<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<link rel="stylesheet" href="${pageContext.request.contextPath}/common/css/sprites.css?${applicationScope.BUILD_TS}" />
<link rel="shortcut icon" href="${pageContext.request.contextPath}/${applicationScope.OEM_PATH}/favicon.png" />
<link rel="stylesheet" href="${pageContext.request.contextPath}/billing/billing.css?${applicationScope.BUILD_TS}" />

<fmt:bundle basename="localization.SurveyMessages">
<jsp:include page="../common/jquery.jsp" />
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular/angular.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billing.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingUtilService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingAppConfig.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" >
	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>


<html>
<head>
<jsp:include page="/common/search-engine.jsp" />
<title><fmt:message key="Royalty_Report"/></title>
</head>
<body>

<div  id="wrapper-div" data-ng-app="billingApp"   data-ng-controller="billingController">
	<div id="header" data-ng-class="{hiddenSection:!isPartner()}">
		<div id="logo" class="pg-logo-class" style="background-image: url(/webconsole/OEM/1/images/Company_logo.png)" alt="Company Logo"></div>
		<div id='customerInfo'>
			<div class='customerInfoRow'>
				<div class='labelCol'><label><fmt:message key="Partner"/>:</label> </div>
				<div class='valueCol'><label >{{partnerName}}</label> </div>
				<div class='clearFloat'></div>
			</div>
			<div class='customerInfoRow'>
				<div class='labelCol'><label> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label></div>
				<div class="valueCol"><label >{{billingCycle}}</label></div>
				<div class='clearFloat'></div>
			</div>
			<div class='customerInfoRow'>
				<div class='labelCol'><label> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label></div>
				<div class="valueCol"><label >{{partnerBillCycle}}</label></div>
				<div class='clearFloat'></div>
			</div>
			<div class='customerInfoRow'>
				<div class='labelCol'><label> <fmt:message key="Billing_Currency"/><fmt:message key="Colon_Symbol"/></label></div>
				<div class="valueCol"><label >{{currencyCode}}</label></div>
				<div class='clearFloat'></div>
			</div>
			<div class='customerInfoRow'>
				<div class='labelCol'><label> <fmt:message key="Amount"/><fmt:message key="Colon_Symbol"/></label></div>
				<div class="valueCol"><label>{{partnerAmountDue}}</label></div>
				<div class='clearFloat'></div>
			</div>
			<div class='clearFloat'></div>
		</div>
		<div class='clearFloat'></div>
	</div>
	<div id="summary-wrapper" data-ng-class="{hiddenSection:!isPartner()}">
		<div id="partnerAccountSummaryDiv" data-ng-class="{accountSummaryDiv:!hideSummarySection(), accountSummaryDivQuarter:hideSummarySection()}">
			<h2 id="accountSummaryTitle"><fmt:message key="Partner"/> <fmt:message key="Summary"/> <fmt:message key="by"/> <fmt:message key="Service_Provider"/></h2>
			<table id="paymentTable">
				<tr>
					<td><fmt:message key="Billing_Period"/></td>
					<td>{{partnerBillCycle}}</td>
				</tr>
				<tr><td colspan="2"></td></tr>
				<tr>
					<td><b><fmt:message key="Payment"/> <fmt:message key="For"/><fmt:message key="Colon_Symbol"/></b></td>
					<td>&nbsp;</td>
				</tr>
				<tr data-ng-repeat="aggregatorData in aggregatorResponse">
					<td class="tdSpacing">{{aggregatorData.data.aggregatorName}}</td>
					<td data-ng-class="{lastCol:true}">{{aggregatorData.data.aggregatorAmountDue}}</td>
				</tr>
				<tr><td colspan="2"></td></tr>
				<tr data-ng-class="{hiddenSection:!hideVolumeDiscount(partnerVolumeDiscountApplicable)}">
					<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
					<td>{{partnerTotalCost}}</td>
				</tr>
				<tr data-ng-class="{hiddenSection:hideVolumeDiscount(partnerVolumeDiscountApplicable)}">
					<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
					<td>{{unadjustedAmount}}</td>
				</tr>
				<tr data-ng-class="{hiddenSection:hideVolumeDiscount(partnerVolumeDiscountApplicable)}">
					<td><fmt:message key="Discount_Level"/></td>
					<td>{{discountPercentage}}</td>
				</tr>
				<tr data-ng-class="{hiddenSection:hideVolumeDiscount(partnerVolumeDiscountApplicable)}">
					<td><fmt:message key="Discounted_Amount"/></td>
					<td>{{discountedAmount}}</td>
				</tr>
				<tr data-ng-class="{hiddenSection:hideVolumeDiscount(partnerVolumeDiscountApplicable)}">
					<td><fmt:message key="Adjusted_Total"/></td>
					<td>{{adjustedAmount}}</td>
				</tr>
			</table>
			<h4><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{partnerAmountDue}}</span></h4>
		</div>
		<div id="partnerSummaryDiv" class="totalTable partnerSummaryDiv" data-ng-class="{hiddenSection:hideSummarySection(), partnerSummaryDisplay:!hideSummarySection()}">
			<h2><fmt:message key="Partner"/> <fmt:message key="chart.title.Usage"/> <fmt:message key="Summary"/></h2>
			<div>
				<h4>{{partnerCapacityTable.title}}</h4>
				<table>
					<tr>
						 <th data-ng-repeat="headerCol in partnerCapacityTable.tableHeaders.cellValue" >{{headerCol.value}}</th>
					</tr>
					<tr data-ng-repeat="row in partnerCapacityTable.tableData">
						<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
					</tr>
				</table>
			</div>
			<div>
				<h4>{{partnerClientTable.title}}</h4>
				<table>
					<tr>
						 <th data-ng-repeat="headerCol in partnerClientTable.tableHeaders.cellValue" >{{headerCol.value}}</th>
					</tr>
					<tr data-ng-repeat="row in partnerClientTable.tableData">
						<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
					</tr>
				</table>
			</div>
		</div>
	</div>
	<div  data-ng-repeat="aggregatorData in aggregatorResponse">
		<div id="partnerTitle" data-ng-class="{hiddenSection:!isPartner()}">
			<fmt:message key="Royalty_Report"/> <fmt:message key="For"/> <fmt:message key="Service_Provider"/>: {{aggregatorData.data.aggregatorName}}
		</div>
		<div id="header" data-ng-class="{hiddenSection:!isAggregator()}">
			<div id="logo" class="pg-logo-class" style="background-image: url(/webconsole/OEM/1/images/Company_logo.png)" alt="Company Logo"></div>
			<div id='customerInfo'>
				<div class='customerInfoRow'>
					<div class='labelCol'><label><fmt:message key="Service_Provider"/>:</label> </div>
					<div class='valueCol'><label >{{aggregatorData.data.aggregatorName}}</label> </div>
					<div class='clearFloat'></div>
				</div>
				<div class='customerInfoRow'>
					<div class='labelCol'><label> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label></div>
					<div class="valueCol"><label >{{billingCycle}}</label></div>
					<div class='clearFloat'></div>
				</div>
				<div class='customerInfoRow'>
					<div class='labelCol'><label> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label></div>
					<div class="valueCol"><label >{{aggregatorData.data.aggregatorBillCycle}}</label></div>
					<div class='clearFloat'></div>
				</div>
				<div class='customerInfoRow'>
					<div class='labelCol'><label> <fmt:message key="Billing_Currency"/><fmt:message key="Colon_Symbol"/></label></div>
					<div class="valueCol"><label >{{currencyCode}}</label></div>
					<div class='clearFloat'></div>
				</div>
				<div class='customerInfoRow'>
					<div class='labelCol'><label> <fmt:message key="Amount"/><fmt:message key="Colon_Symbol"/></label></div>
					<div class="valueCol"><label>{{aggregatorData.data.aggregatorAmountDue}}</label></div>
					<div class='clearFloat'></div>
				</div>
				<div class='clearFloat'></div>
			</div>
			<div class='clearFloat'></div>
		</div>
		<div id="summary-wrapper" data-ng-class="{hiddenSection:isBillingGroup()}">
			<div id="accountSummaryDiv">
				<h2 id="accountSummaryTitle"><fmt:message key="Service_Provider"/> <fmt:message key="Summary"/> <fmt:message key="by"/> <fmt:message key="Billing_Group"/></h2>
				<table id="paymentTable" data-ng-class="{hiddenSection:isQuarterly()}">
					<tr>
						<td><fmt:message key="Billing_Period"/></td>
						<td>{{aggregatorData.data.aggregatorBillCycle}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
					<tr>
						<td><b><fmt:message key="Payment"/> <fmt:message key="For"/><fmt:message key="Colon_Symbol"/></b></td>
						<td>&nbsp;</td>
					</tr>
					<tr data-ng-repeat="billData in aggregatorData.listData">
						<td class="tdSpacing">{{billData.header.custNameValue}}</td>
						<td data-ng-class="{hiddenSection:isQuarterly(),lastCol:true}">{{billData.header.amountDue}}</td>
						<td data-ng-class="{hiddenSection:!isQuarterly(),lastCol:true}">{{billData.quarterAmountDue}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
					<tr data-ng-class="{hiddenSection:!hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.aggregatorTotalCost}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.unadjustedAmount}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td><fmt:message key="Discount_Level"/></td>
						<td>{{aggregatorData.data.discountPercentage}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td><fmt:message key="Discounted_Amount"/></td>
						<td>{{aggregatorData.data.discountedAmount}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td><fmt:message key="Adjusted_Total"/></td>
						<td>{{aggregatorData.data.adjustedAmount}}</td>
					</tr>
					<tr>
						<td><fmt:message key="Required_Minimum"/> <fmt:message key="Payment"/></td>
						<td>{{aggregatorData.data.aggregatorMinFee}}</td>
					</tr>
				</table>
				<h4 data-ng-class="{hiddenSection:isQuarterly()}"><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{aggregatorData.data.aggregatorAmountDue}}</span></h4>
				<table id="paymentTable" data-ng-class="{hiddenSection:!isQuarterly()}">
					<tr>
						<td><fmt:message key="Billing_Period"/></td>
						<td>{{aggregatorData.data.aggregatorBillCycle}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
					<tr>
						<td><b><fmt:message key="Payment"/> <fmt:message key="For_month"/><fmt:message key="Colon_Symbol"/></b></td>
						<td class="tdSpacing"><b>{{quarterMonth3}}</b></td>
					</tr>
					<tr>
						<td class='tdSpacing'><b><fmt:message key="Payment"/> <fmt:message key="For"/><fmt:message key="Colon_Symbol"/></b></td>
						<td>&nbsp;</td>
					</tr>
					<tr data-ng-repeat="billData in aggregatorData.listData">
						<td class="tdDoubleSpacing">{{billData.header3.custNameValue}}</td>
						<td>{{billData.header3.amountDue}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:!hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.aggregatorMonth3Total}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.unadjustedAmount3}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discount_Level"/></td>
						<td>{{aggregatorData.data.discountPercentage3}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discounted_Amount"/></td>
						<td>{{aggregatorData.data.discountedAmount3}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Adjusted_Total"/></td>
						<td>{{aggregatorData.data.adjustedAmount3}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Required_Minimum"/> <fmt:message key="Payment"/></td>
						<td>{{aggregatorData.data.aggregatorMinFee}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Amount"/></td>
						<td>{{aggregatorData.data.aggregatorMonth3Due}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
					<tr>
						<td><b><fmt:message key="Payment"/> <fmt:message key="For_month"/><fmt:message key="Colon_Symbol"/></b></td>
						<td class="tdSpacing"><b>{{quarterMonth2}}</b></td>
					</tr>
					<tr>
						<td class='tdSpacing'><b><fmt:message key="Payment"/> <fmt:message key="For"/><fmt:message key="Colon_Symbol"/></b></td>
						<td>&nbsp;</td>
					</tr>
					<tr data-ng-repeat="billData in aggregatorData.listData">
						<td class="tdDoubleSpacing">{{billData.header2.custNameValue}}</td>
						<td>{{billData.header2.amountDue}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:!hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.aggregatorMonth2Total}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.unadjustedAmount2}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discount_Level"/></td>
						<td>{{aggregatorData.data.discountPercentage2}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discounted_Amount"/></td>
						<td>{{aggregatorData.data.discountedAmount2}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Adjusted_Total"/></td>
						<td>{{aggregatorData.data.adjustedAmount2}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Required_Minimum"/> <fmt:message key="Payment"/></td>
						<td>{{aggregatorData.data.aggregatorMinFee}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Amount"/></td>
						<td>{{aggregatorData.data.aggregatorMonth2Due}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
					<tr>
						<td><b><fmt:message key="Payment"/> <fmt:message key="For_month"/><fmt:message key="Colon_Symbol"/></b></td>
						<td class="tdSpacing"><b>{{quarterMonth}}</b></td>
					</tr>
					<tr>
						<td class='tdSpacing'><b><fmt:message key="Payment"/> <fmt:message key="For"/><fmt:message key="Colon_Symbol"/></b></td>
						<td>&nbsp;</td>
					</tr>
					<tr data-ng-repeat="billData in aggregatorData.listData">
						<td class="tdDoubleSpacing">{{billData.header.custNameValue}}</td>
						<td>{{billData.header.amountDue}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:!hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.aggregatorMonthTotal}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
						<td>{{aggregatorData.data.unadjustedAmount}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discount_Level"/></td>
						<td>{{aggregatorData.data.discountPercentage}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Discounted_Amount"/></td>
						<td>{{aggregatorData.data.discountedAmount}}</td>
					</tr>
					<tr data-ng-class="{hiddenSection:hideVolumeDiscount(aggregatorData.data.aggregatorVolumeDiscountApplicable)}">
						<td class='tdSpacing'><fmt:message key="Adjusted_Total"/></td>
						<td>{{aggregatorData.data.adjustedAmount}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Required_Minimum"/> <fmt:message key="Payment"/></td>
						<td>{{aggregatorData.data.aggregatorMinFee}}</td>
					</tr>
					<tr>
						<td class='tdSpacing'><fmt:message key="Total"/> <fmt:message key="Amount"/></td>
						<td>{{aggregatorData.data.aggregatorMonthDue}}</td>
					</tr>
					<tr><td colspan="2"></td></tr>
				</table>
				<h4 data-ng-class="{hiddenSection:!isQuarterly()}"><fmt:message key="Total"/> <fmt:message key="Quarterly"/> <fmt:message key="Amount"/><span>{{aggregatorData.data.aggregatorAmountDue}}</span></h4>
			</div>
			<div id="summaryDiv" class="totalTable">
				<h2><fmt:message key="Service_Provider"/> <fmt:message key="chart.title.Usage"/> <fmt:message key="Summary"/></h2>
				<div>
					<h4>{{aggregatorData.data.aggregatorCapacityTable.title}}</h4>
					<table>
						<tr>
							 <th data-ng-repeat="headerCol in aggregatorData.data.aggregatorCapacityTable.tableHeaders.cellValue" >{{headerCol.value}}</th>
						</tr>
						<tr data-ng-repeat="row in aggregatorData.data.aggregatorCapacityTable.tableData">
							<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
						</tr>
					</table>
				</div>
				<div>
					<h4>{{aggregatorData.data.aggregatorClientTable.title}}</h4>
					<table>
						<tr>
							 <th data-ng-repeat="headerCol in aggregatorData.data.aggregatorClientTable.tableHeaders.cellValue" >{{headerCol.value}}</th>
						</tr>
						<tr data-ng-repeat="row in aggregatorData.data.aggregatorClientTable.tableData">
							<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
						</tr>
					</table>
				</div>
			</div>
		</div>
		<div  data-ng-repeat="billData in aggregatorData.listData">
			<div id="header" data-ng-class="{hiddenSection:!isBillingGroup()}">
				<div id="logo" class="pg-logo-class" style="background-image: url(/webconsole/OEM/1/images/Company_logo.png)" alt="Company Logo"></div>
				<div id='customerInfo'>
					<div class='customerInfoRow'>
						<div class='labelCol'><label><fmt:message key="Billing_Group"/>:</label> </div>
						<div class='valueCol'><label >{{billData.header.custNameValue}} </label> </div>
						<div class='clearFloat'></div>
					</div>
					<div class='customerInfoRow'>
						<div class='labelCol'><label> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label> </div>
						<div class='valueCol'><label >{{billingCycle}} </label> </div>
						<div class='clearFloat'></div>
					</div>
					<div class='customerInfoRow'>
						<div class='labelCol'><label> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label></div>
						<div data-ng-class="{hiddenSection:isQuarterly(),valueCol:!isQuarterly()}"><label > {{billData.header.billCycle}}</label></div>
						<div data-ng-class="{hiddenSection:!isQuarterly(),valueCol:isQuarterly()}"><label > {{billData.quarterBillCycle}}</label></div>
						<div class='clearFloat'></div>
					</div>
					<div class='customerInfoRow'>
						<div class='labelCol'><label> <fmt:message key="Billing_Currency"/><fmt:message key="Colon_Symbol"/></label> </div>
						<div class='valueCol'><label >{{currencyCode}} </label> </div>
						<div class='clearFloat'></div>
					</div>
					<div class='customerInfoRow'>
						<div class='labelCol'><label> <fmt:message key="Amount"/><fmt:message key="Colon_Symbol"/></label></div>
						<div data-ng-class="{hiddenSection:isQuarterly(),valueCol:!isQuarterly()}"><label>{{billData.header.amountDue}}</label></div>
						<div data-ng-class="{hiddenSection:!isQuarterly(),valueCol:isQuarterly()}"><label > {{billData.quarterAmountDue}}</label></div>
						<div class='clearFloat'></div>
					</div>
					<div class='clearFloat'></div>
				</div>
				<div class='clearFloat'></div>
			</div>
			<div id="aggregatorTitle" data-ng-class="{hiddenSection:isBillingGroup()}">
				<fmt:message key="Royalty_Report"/> <fmt:message key="For"/> <fmt:message key="Billing_Group"/>: {{billData.header.custNameValue}}
			</div>
			<div id="summary-wrapper" data-ng-class="{hiddenSection:!isQuarterly()}">
				<div id="accountSummaryDivQuarter">
					<h2 id="accountSummaryTitle"><fmt:message key="Royalty_Report"/> <fmt:message key="Quarterly"/> <fmt:message key="Summary"/></h2>
					<table>
						<tr>
							<td><fmt:message key="Billing_Period"/></td>
							<td>{{billData.quarterBillCycle}}</td>
						</tr>
						<tr><td colspan="2"></td></tr>
						<tr>
							<td><b><fmt:message key="Payment"/> <fmt:message key="For_month"/><fmt:message key="Colon_Symbol"/></b></td>
							<td/>
						</tr>
						<tr>
							<td class="tdSpacing">{{billData.header3.month}}</td>
							<td>{{billData.header3.amountDue}}</td>
						</tr>
						<tr>
							<td class="tdSpacing">{{billData.header2.month}}</td>
							<td>{{billData.header2.amountDue}}</td>
						</tr>
						<tr>
							<td class="tdSpacing">{{billData.header.month}}</td>
							<td>{{billData.header.amountDue}}</td>
						</tr>
					</table>
					<h4><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{billData.quarterAmountDue}}</span></h4>
				</div>
			</div>
			<div id="summary-wrapper" data-ng-class="{hiddenSection:!isQuarterly()}">
				<h1 class="quarterHeading"><fmt:message key="Details"/> <fmt:message key="For_month"/> {{billData.header3.month}}</h1>
				<div id="accountSummaryDiv">
					<h2 id="accountSummaryTitle"><fmt:message key="Royalty_Report"/> <fmt:message key="Summary"/></h2>
					<table>
						<tr>
							<td><fmt:message key="Billing_Period"/></td>
							<td>{{billData.header3.billCycle}}</td>
						</tr>
						<tr>
							<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
							<td>{{billData.header3.totalCost}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header3.hasVolumeDiscount)}">
							<td><fmt:message key="Discount_Level"/></td>
							<td>{{billData.header3.discountPercentage}}%</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header3.hasVolumeDiscount)}">
							<td><fmt:message key="Discounted_Amount"/></td>
							<td>{{billData.header3.discountedAmount}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header3.hasVolumeDiscount)}">
							<td><fmt:message key="Adjusted_Total"/></td>
							<td>{{billData.header3.adjustedAmount}}</td>
						</tr>
					</table>
					<h4><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{billData.header3.amountDue}}</span></h4>
				</div>
				<div id="summaryDiv" class="totalTable">
					<h2><fmt:message key="chart.title.Usage"/> <fmt:message key="Summary"/></h2>
					<p data-ng-show="isMessageApplicable(billData.summaryTables3)">{{summaryMsg}}</p>
					<div  data-ng-repeat="table in billData.summaryTables3" data-ng-class="{hiddenTable:isEmptyTable(table)}">
						<h4>{{table.title}}</h4>
						<table>
							<tr>
						 		<th data-ng-repeat="headerCol in table.tableHeaders.cellValue" >{{headerCol.value}}</th>
							</tr>
							<tr data-ng-repeat="row in table.tableData">
								<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
							</tr>
						</table>
					</div>
					<div data-ng-class="{notes:true,notesError:isErrorMsg(billData.header3.comment),notesInfo:!isErrorMsg(billData.header3.comment)}">{{billData.header3.comment}}</div>
				</div>
			</div>
			<div class='sectionSeparator' data-ng-class="{hiddenSection:!isQuarterly()}"></div>
			<div data-ng-repeat="section in billData.billSections3" data-ng-class="{detailsDiv:true,hiddenSection:isEmptySection(section,billData.billSections3[2])}">
				<h2>{{section.sectionTitle}}</h2>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<h4>{{detailTable.title}}</h4>
					<table>
						<tr>
						 	<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
						</tr>
						<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow),firstRow:isFirstColumn(dRow.cellValue[0])}">
							<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol),firstColumn:isFirstColumn(dCol)}">{{dCol.value}} </td>
						</tr>
					</table>
				</div>
				<div class='sectionSeparator'></div>
			</div>
			<div id="summary-wrapper" data-ng-class="{hiddenSection:!isQuarterly()}">
				<h1 class="quarterHeading"><fmt:message key="Details"/> <fmt:message key="For_month"/> {{billData.header2.month}}</h1>
				<div id="accountSummaryDiv">
					<h2 id="accountSummaryTitle"><fmt:message key="Royalty_Report"/> <fmt:message key="Summary"/></h2>
					<table>
						<tr>
							<td><fmt:message key="Billing_Period"/></td>
							<td>{{billData.header2.billCycle}}</td>
						</tr>
						<tr>
							<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
							<td>{{billData.header2.totalCost}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header2.hasVolumeDiscount)}">
							<td><fmt:message key="Discount_Level"/></td>
							<td>{{billData.header2.discountPercentage}}%</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header2.hasVolumeDiscount)}">
							<td><fmt:message key="Discounted_Amount"/></td>
							<td>{{billData.header2.discountedAmount}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header2.hasVolumeDiscount)}">
							<td><fmt:message key="Adjusted_Total"/></td>
							<td>{{billData.header2.adjustedAmount}}</td>
						</tr>
					</table>
					<h4><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{billData.header2.amountDue}}</span></h4>
				</div>
				<div id="summaryDiv" class="totalTable">
					<h2><fmt:message key="chart.title.Usage"/> <fmt:message key="Summary"/></h2>
					<p data-ng-show="isMessageApplicable(billData.summaryTables2)">{{summaryMsg}}</p>
					<div  data-ng-repeat="table in billData.summaryTables2" data-ng-class="{hiddenTable:isEmptyTable(table)}">
						<h4>{{table.title}}</h4>
						<table>
							<tr>
						 		<th data-ng-repeat="headerCol in table.tableHeaders.cellValue" >{{headerCol.value}}</th>
							</tr>
							<tr data-ng-repeat="row in table.tableData">
								<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
							</tr>
						</table>
					</div>
					<div data-ng-class="{notes:true,notesError:isErrorMsg(billData.header2.comment),notesInfo:!isErrorMsg(billData.header2.comment)}">{{billData.header2.comment}}</div>
				</div>
			</div>
			<div class='sectionSeparator' data-ng-class="{hiddenSection:!isQuarterly()}"></div>
			<div data-ng-repeat="section in billData.billSections2" data-ng-class="{detailsDiv:true,hiddenSection:isEmptySection(section,billData.billSections2[2])}">
				<h2>{{section.sectionTitle}}</h2>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<h4>{{detailTable.title}}</h4>
					<table>
						<tr>
							<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
						</tr>
						<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow),firstRow:isFirstColumn(dRow.cellValue[0])}">
							<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol),firstColumn:isFirstColumn(dCol)}">{{dCol.value}} </td>
						</tr>
					</table>
				</div>
				<div class='sectionSeparator'></div>
			</div>
			<div id="summary-wrapper">
				<h1 class="quarterHeading" data-ng-class="{hiddenSection:!isQuarterly()}"><fmt:message key="Details"/> <fmt:message key="For_month"/> {{billData.header.month}}</h1>
				<div id="accountSummaryDiv">
					<h2 id="accountSummaryTitle"><fmt:message key="Royalty_Report"/> <fmt:message key="Summary"/></h2>
					<table>
						<tr>
							<td><fmt:message key="Billing_Period"/></td>
							<td>{{billData.header.billCycle}}</td>
						</tr>
						<tr>
							<td><fmt:message key="Total"/> <fmt:message key="Current_Charges"/></td>
							<td>{{billData.header.totalCost}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header.hasVolumeDiscount)}">
							<td><fmt:message key="Discount_Level"/></td>
							<td>{{billData.header.discountPercentage}}%</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header.hasVolumeDiscount)}">
							<td><fmt:message key="Discounted_Amount"/></td>
							<td>{{billData.header.discountedAmount}}</td>
						</tr>
						<tr data-ng-class="{hiddenSection:hideVolumeDiscount(billData.header.hasVolumeDiscount)}">
							<td><fmt:message key="Adjusted_Total"/></td>
							<td>{{billData.header.adjustedAmount}}</td>
						</tr>
					</table>
					<h4><fmt:message key="Total"/> <fmt:message key="Amount"/><span>{{billData.header.amountDue}}</span></h4>
				</div>
				<div id="summaryDiv" class="totalTable">
					<h2><fmt:message key="chart.title.Usage"/> <fmt:message key="Summary"/></h2>
					<p data-ng-show="isMessageApplicable(billData.summaryTables)">{{summaryMsg}}</p>
					<div  data-ng-repeat="table in billData.summaryTables" data-ng-class="{hiddenTable:isEmptyTable(table)}">
						<h4>{{table.title}}</h4>
						<table>
							<tr>
								<th data-ng-repeat="headerCol in table.tableHeaders.cellValue" >{{headerCol.value}}</th>
							</tr>
							<tr data-ng-repeat="row in table.tableData">
								<td data-ng-repeat="col in row.cellValue">{{col.value}} </td>
							</tr>
						</table>
					</div>
					<div data-ng-class="{notes:true,notesError:isErrorMsg(billData.header.comment),notesInfo:!isErrorMsg(billData.header.comment)}">{{billData.header.comment}}</div>
				</div>
			</div>
			<div class='sectionSeparator'></div>
			<div data-ng-repeat="section in billData.billSections" data-ng-class="{detailsDiv:true,hiddenSection:isEmptySection(section,billData.billSections[2])}">
				<h2>{{section.sectionTitle}}</h2>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<h4>{{detailTable.title}}</h4>
					<table>
						<tr>
				        	<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
						</tr>
						<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow),firstRow:isFirstColumn(dRow.cellValue[0])}">
							<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol),firstColumn:isFirstColumn(dCol)}">{{dCol.value}} </td>
						</tr>
					</table>
				</div>
			</div>
		</div>
	</div>
	<div data-ng-class="{hiddenSection:isBillingGroup()}">
		<p class="pagebreak"></p>
		<div id="legal">
			<div class='sectionSeparator'></div>
			{{legalText}}
		</div>
		<div style="margin-bottom:50px;">
			<table id="signatureSection">
				<tr><td colspan="2" data-ng-class="{hiddenSection:isPurchaseOrder()}">{{signatureText}}</td></tr>
				<tr><td colspan="2" data-ng-class="{hiddenSection:!isPurchaseOrder()}"><fmt:message key="Signature_Blob_Line2"/></td></tr>
				<tr class="signatureRow"><td data-ng-class="{hiddenSection:!isPurchaseOrder()}"><fmt:message key="Signature_Blob_Line3"/> </td><td data-ng-class="{hiddenSection:!isPurchaseOrder()}"><div>______________________</div></td></tr>
				<tr><td colspan="2"><fmt:message key="Reference"/>{{customerName}} <fmt:message key="Agreement"/></td></tr>
			</table>
			<table>
				<tr>
					<td><br/></td><td></td>
				</tr>
				<tr>
			 		<td data-ng-class="{hiddenSection:!isSendReport(),docusignTabs:true}">DSCustomerSign</td><td data-ng-class="{hiddenSection:!isSendReport(),docusignTabs:true}">DSCustomerDate</td>
			 		<td data-ng-class="{hiddenSection:isSendReport()}"><br/></td><td data-ng-class="{hiddenSection:isSendReport()}"></td>
				</tr>
				<tr>
			 		<td class="signatureColumn">____________________________________________________________</td><td>____________________________________________</td>
				</tr>
				<tr>
			 		<td class="signatureColumn">{{customerName}} <fmt:message key="Authorized_Signature"/></td><td><fmt:message key="Date"/></td>
				</tr>
				<tr>
					<td><br/></td><td></td>
				</tr>
				<tr>
		 			<td data-ng-class="{hiddenSection:!isSendReport(),docusignTabs:true}">DSCommvaultSign</td><td data-ng-class="{hiddenSection:!isSendReport(),docusignTabs:true}">DSCommvaultDate</td>
		 			<td data-ng-class="{hiddenSection:isSendReport()}"><br/></td><td data-ng-class="{hiddenSection:isSendReport()}"></td>
				</tr>
				<tr>
		 			<td class="signatureColumn">____________________________________________________________</td><td>____________________________________________</td>
				</tr>
				<tr>
		 			<td class="signatureColumn"><fmt:message key="contact.commvault"/> <fmt:message key="Authorized_Signature"/></td><td><fmt:message key="Date"/></td>
				</tr>
			</table>
		</div>
	</div>
</div>
<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	$(document).ready(function() {
		window.allOnReadiesExecuted=true; //while exporting we need to know when the page has completed its execution
	});
</script>
</fmt:bundle>
</body>
</html>


