(function() {
	"use strict";

	var app = angular.module("billingApp");  
	
	
	app.run(["$http","billingService", function(http,billingService) {
        http.defaults.headers.common["X-Requested-With"] = "XMLHttpRequest"
    }]);
	
	app.config(['$httpProvider','$sceProvider','$provide', function($httpProvider,$sceProvider,$provide){
		$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
		$sceProvider.enabled(false);   
		// this is a workaround for the issue where we get into infinite digest loops when using history api with angular.js
		$provide.decorator('$location', ['$delegate', '$browser', function($delegate, $browser){
		      $delegate.absUrl = function(){return $browser.url();};
		      return $delegate;
		 }]);
		// Override $http service's default transformRequest
		
		$httpProvider.defaults.transformRequest = [ function(data) {
			/**
			 * The workhorse; converts an object to x-www-form-urlencoded serialization.
			 * 
			 * @param {Object}
			 *            obj
			 * @return {String}
			 */		
			
			var param = function(obj) {
				var query = '';
				var name, value, fullSubName, subName, subValue, innerObj, i;
				for (name in obj) {
					value = obj[name];
					if (value instanceof Array) {
						for (i = 0; i < value.length; ++i) {
							subValue = value[i];
							fullSubName = name + '[' + i + ']';
							innerObj = {};
							innerObj[fullSubName] = subValue;
							query += param(innerObj) + '&';
						}
					} else if (value instanceof Object) {
						for (subName in value) {
							subValue = value[subName];
							fullSubName = name + '[' + subName + ']';
							innerObj = {};
							innerObj[fullSubName] = subValue;
							query += param(innerObj) + '&';
						}
					} else if (value !== undefined && value !== null) {
						query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
					}
				}
				return query.length ? query.substr(0, query.length - 1) : query;
			};
			return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
		} ]; 
		
		$httpProvider.interceptors.push([
		                                  '$q',	'billingUtilService',	                                  
		                                  function($q,billingUtilService) {		                                      
		                                      return {
		                                          'response' : function(response) {
		                                              return response;
		                                          },		                                         
		                                          request : function(config) {		                                             
		                                              var csrfParam = billingUtilService.readCookie('csrf');
													  config.headers['X-CSRF-Token'] = csrfParam;
		                                              config.headers['csrf'] = csrfParam;
		                                              config.headers['timeZoneInfo'] = new Date().toString().match(/([-\+][0-9]+)\s/)[1];
		                                              return config;
		                                          }
		                                      };
		                                  } ]);
	}]);
})();