<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<link rel="stylesheet" href="${pageContext.request.contextPath}/common/css/sprites.css?${applicationScope.BUILD_TS}" />
<link rel="shortcut icon" href="${pageContext.request.contextPath}/${applicationScope.OEM_PATH}/favicon.png" />
<link rel="stylesheet" href="${pageContext.request.contextPath}/billing/billing.css?${applicationScope.BUILD_TS}" />

<fmt:bundle basename="localization.SurveyMessages">
<jsp:include page="../common/jquery.jsp" />
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular/angular.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billing.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingUtilService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/billing/billingAppConfig.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" >
	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>


<html>
<head><title><fmt:message key="Royalty_Report"/> <fmt:message key="Details"/></title></head>
<body>

<div  id="wrapper-div" data-ng-app="billingApp"   data-ng-controller="billingController">
	<div id="header" data-ng-class="{hiddenSection:!isPartner()}">
        <table>
        	<tbody>
	        	<tr>
	        		<td>&nbsp;</td>
	        		<td rowspan='4'><div id='logoDetails'> <img src='${pageContext.request.contextPath}/${applicationScope.OEM_PATH}/Company_logo.png'></div></td>
	        	</tr>
	        	<tr>
	        		<td><label class='labelColDetails'><fmt:message key="Partner"/>:</label><label class='valueCol1'> {{partnerName}}</label></td>
	        	</tr>
	        	<tr>
	        		<td><label class='labelColDetails'> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label><label class='valueCol2'> {{billingCycle}}</label></td>
	        	</tr>
	        	<tr>
	        		<td class='tdLastHdr'><label class='labelColDetails'> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label><label data-ng-class='{valueCol3:!isQuarterly(),valueCol5:isQuarterly()}'> {{partnerBillCycle}}</label></td>
	        	</tr>
        	</tbody>
        </table>
        <div class='clearFloat'></div>
    </div>
    <table class='sectionSeparatorTbl'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
	<div  data-ng-repeat="aggregatorData in aggregatorResponse">
		<table data-ng-class='{hiddenSection:!isPartner()}'><tbody><tr><td><div id="partnerTitle" data-ng-class="{hiddenSection:!isPartner()}"><fmt:message key="Details"/> <fmt:message key="For"/> <fmt:message key="Service_Provider"/>: {{aggregatorData.data.aggregatorName}}</div></td></tr></tbody></table>
        <div id="header" data-ng-class="{hiddenSection:!isAggregator()}">
	        <table>
	        	<tbody>
		        	<tr>
	        			<td>&nbsp;</td>
	        			<td rowspan='4'><div id='logoDetails'> <img src='${pageContext.request.contextPath}/${applicationScope.OEM_PATH}/Company_logo.png'></div></td>
	        		</tr>
		        	<tr>
		        		<td><label class='labelColDetails'><fmt:message key="Service_Provider"/>:</label><label class='valueCol4'> {{aggregatorData.data.aggregatorName}}</label></td>
		        	</tr>
		        	<tr>
		        		<td><label class='labelColDetails'> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label><label class='valueCol2'> {{billingCycle}}</label></td>
		        	</tr>
		        	<tr>
		        		<td class='tdLastHdr'><label class='labelColDetails'> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label><label data-ng-class='{valueCol3:!isQuarterly(),valueCol5:isQuarterly()}'> {{aggregatorData.data.aggregatorBillCycle}}</label></td>
		        	</tr>
	        	</tbody>
	        </table>
            <div class='clearFloat'></div>
        </div>
        <table class='sectionSeparatorTbl'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
		<div  data-ng-repeat="billData in aggregatorData.listData">
            <div id="header" data-ng-class="{hiddenSection:!isBillingGroup()}">
	            <table>
	            	<tbody>
		            	<tr>
	        				<td>&nbsp;</td>
	        				<td rowspan='4'><div id='logoDetails'> <img src='${pageContext.request.contextPath}/${applicationScope.OEM_PATH}/Company_logo.png'></div></td>
	        			</tr>
			        	<tr>
			        		<td><label class='labelColDetails'><fmt:message key="Billing_Group"/>:</label><label class='valueCol5'> {{billData.header.custNameValue}}</label></td>
			        	</tr>
			        	<tr>
			        		<td><label class='labelColDetails'> <fmt:message key="Billing_Cycle"/><fmt:message key="Colon_Symbol"/></label><label class='valueCol2'> {{billingCycle}}</label></td>
			        	</tr>
			        	<tr>
			        		<td class='tdLastHdr'><label class='labelColDetails'> <fmt:message key="Billing_Period"/><fmt:message key="Colon_Symbol"/></label><label data-ng-class='{hiddenSection:isQuarterly(),valueCol3:!isQuarterly()}'> {{billData.header.billCycle}}</label><label data-ng-class='{hiddenSection:!isQuarterly(),valueCol5:isQuarterly()}'> {{billData.quarterBillCycle}}</label></td>
			        	</tr>
		        	</tbody>
		        </table>
                <div class='clearFloat'></div>
            </div>
            <table class='sectionSeparatorTbl'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
            <table data-ng-class='{hiddenSection:isBillingGroup()}'><tbody><tr><td><div id="aggregatorTitle" data-ng-class="{hiddenSection:isBillingGroup()}"><fmt:message key="chart.title.Usage"/> <fmt:message key="Details"/> <fmt:message key="For"/> <fmt:message key="Billing_Group"/>: {{billData.header.custNameValue}}</div></td></tr></tbody></table>
			<div data-ng-repeat="section in billData.billSections3" data-ng-class="{detailsDiv:true,hiddenSection:!isAdditionalSection(section)}">
				<table data-ng-class="{hiddenSection:isEmptySection(section),hiddenSection:!isAdditionalSection(section),noBorder:true}"><tbody><tr><td><h1 class="quarterHeading"><fmt:message key="Peak"/> <fmt:message key="chart.title.Usage"/> <fmt:message key="For_month"/> {{billData.header3.month}}</h1></td></tr></tbody></table>
				<table data-ng-show="isMessageApplicable(section.detailTables)" class="noBorder"><tbody><tr><td><p class="quarterHeading">{{summaryMsg}}</p></td></tr></tbody></table>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<table class="additionalInfoTable">
						<thead>
							<tr>
						 		<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
							</tr>
						</thead>
						<tbody>
							<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow)}">
								<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol)}">{{dCol.value}} </td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
			<table data-ng-class='{hiddenSection:!isQuarterly()}'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
			<div data-ng-repeat="section in billData.billSections2" data-ng-class="{detailsDiv:true,hiddenSection:!isAdditionalSection(section)}">
				<table data-ng-class="{hiddenSection:isEmptySection(section),hiddenSection:!isAdditionalSection(section),noBorder:true}"><tbody><tr><td><h1 class="quarterHeading"><fmt:message key="Peak"/> <fmt:message key="chart.title.Usage"/> <fmt:message key="For_month"/> {{billData.header2.month}}</h1></td></tr></tbody></table>
				<table data-ng-show="isMessageApplicable(section.detailTables)" class="noBorder"><tbody><tr><td><p class="quarterHeading">{{summaryMsg}}</p></td></tr></tbody></table>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<table class="additionalInfoTable">
						<thead>
							<tr>
						 		<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
							</tr>
						</thead>
						<tbody>
							<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow)}">
								<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol)}">{{dCol.value}} </td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
			<table data-ng-class='{hiddenSection:!isQuarterly()}'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
			<div data-ng-repeat="section in billData.billSections" data-ng-class="{detailsDiv:true,hiddenSection:!isAdditionalSection(section)}">
				<table data-ng-class="{hiddenSection:isEmptySection(section),hiddenSection:!isAdditionalSection(section),noBorder:true}"><tbody><tr><td><h1 class="quarterHeading"><fmt:message key="Peak"/> <fmt:message key="chart.title.Usage"/> <fmt:message key="For_month"/> {{billData.header.month}}</h1></td></tr></tbody></table>
				<table data-ng-show="isMessageApplicable(section.detailTables)" class="noBorder"><tbody><tr><td><p class="quarterHeading">{{summaryMsg}}</p></td></tr></tbody></table>
				<div  data-ng-repeat="detailTable in section.detailTables" data-ng-class="{hiddenTable:isEmptyTable(detailTable)}" >
					<table class="additionalInfoTable">
						<thead>
							<tr>
						 		<th data-ng-repeat="detailHeaderCol in detailTable.tableHeaders.cellValue" data-ng-class="{stringColumn:isStringColumn(detailHeaderCol)}" >{{detailHeaderCol.value}}</th>
							</tr>
						</thead>
						<tbody>
							<tr data-ng-repeat="dRow in detailTable.tableData" data-ng-class="{totalRow:isTotalRow(dRow)}">
								<td data-ng-repeat="dCol in dRow.cellValue" data-ng-class="{stringColumn:isStringColumn(dCol)}">{{dCol.value}} </td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>
			<table data-ng-class='{hiddenSection:isBillingGroup()}'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
		</div>
		<table class='sectionSeparatorTbl'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
	</div>
	<table class='sectionSeparatorTbl'><tbody><tr><td>&nbsp;</td></tr></tbody></table>
</div>
<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	$(document).ready(function() {
		window.allOnReadiesExecuted=true; //while exporting we need to know when the page has completed its execution
	});
</script>
</fmt:bundle>
</body>
</html>


