<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="Royalty_Report" var="Royalty_Report" />
<fmt:message key="Service_Provider" var="Service_Provider" />
<jsp:include page="../../common/header.jsp">
	<jsp:param value="${Service_Provider} ${Royalty_Report}" name="titleLocalized" />
	<jsp:param value="${Service_Provider} ${Royalty_Report}" name="headerTitleLocalized" />
	<jsp:param value="true" name="classicReport"/>
	<jsp:param value="${Service_Provider} ${Royalty_Report}" name="headerTitle" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
 	<jsp:param value="reports/reportsBase.jsp" name="jsp"/>

 	<jsp:param value="true" name="includeHistory"/>
 	<jsp:param value="true" name="includeJqueryUI"/>
 	<jsp:param value="true" name="includeTableSupport"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractManagement.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractCommon.css" name="css"/>
</jsp:include>

<jsp:include page="contractCommon.jsp" />
<jsp:include page="../../survey/exportForm.jsp" flush="true" />

<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	var securityPermission = '${requestScope.securityPermission}';
	window.urlInitializationNotRequired=true;

	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>

<div class ="sechead">
	<span id="sectionTitle" class="sectiontitle"><fmt:message key="Royalty_Report"/></span>
</div>

<div id="associationContent" >
    <h1><fmt:message key="Service_Providers"/></h1>
    <div id="manageAggregatorButton" class="tableActionButton pageRedirect">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Service_Providers"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Service_Providers"/></span>
	</div>
    <div id="ccGroupRedirectButton" class="tableActionButton pageRedirect">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/></span>
	</div>
	<div id="partnerRedirectButton" class="tableActionButton pageRedirect">
		<span class="sprite icon-reports" title='<fmt:message key="Partner"/> <fmt:message key="Royalty"/> <fmt:message key="Reports"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Partner"/> <fmt:message key="Royalty"/> <fmt:message key="Reports"/></span>
	</div>
    <div id="associationContentSeparator"></div>
    <div id="assocActionDiv">
	    <div id="assocText">
	    <label >
			 <fmt:message key="Associate_Aggregators"/>
		</label>
		</div>
		<div>
			<label><fmt:message key="Service_Provider"/> </label>
			<select id='aggregatorList' class="assocItems"> </select>
			<label style="display:none;"><fmt:message key="Contract"/> </label>
			<select style="display:none;" id='contractList' class="assocItems"> </select>
			<label id='minFeeLabel'><fmt:message key="Minimum_Fee"/> </label>
			<input type="text" id="minFee" class='decimalInput assocItems' value="0">
			<label id='billingTypeLabel'><fmt:message key="Billing_Cycle"/> </label>
			<select id='billingTypeList' class="assocItems">
				<option value='0'><fmt:message key="Monthly"/></option>
				<option value='1'><fmt:message key="Quarterly"/></option>
			</select>
			<label id='useAsPOLabel'><fmt:message key="Use_As_PO"/> </label>
			<label><input type="radio" name="useAsPOType" value="0" checked><fmt:message key="Yes"/></label>
  			<label><input type="radio" name="useAsPOType" value="1"> <fmt:message key="No"/> </label>
			<input type='button' id ='associateAggregatorButton' value='<fmt:message key="Associate"/>'/>
			<div class="clearFloat"></div>
		</div>
	</div>

	<div id='aggregatorTableWrapper'>
		<div id="aggregatorTable"> </div>
	</div>
</div>
<jsp:include page="reportCommon.jsp" />
</fmt:bundle>

<form id="exportBillToPDFForm"  class="hideOnExportFriendly"  method="post" action="${pageContext.request.contextPath}/cloud/contractmanagement/exportBillToPDF.do"  >
		<input id= "isExportBill" type="hidden" name="isExport" />
		<input id= "customerId" type="hidden" name="customerId" />
		<input id= "month" type="hidden" name="month" />
		<input id= "quarter" type="hidden" name="quarter" />
		<input id= "year" type="hidden" name="year" />
		<input id= "type" type="hidden" name="type" />
</form>

<jsp:include page="../../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/qtip/jquery.qtip.min.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractManagement.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractCommon.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractAssociation.js" name="js" />

</jsp:include>