(function(commonExports) {
	'use strict';
	var columns = {
		LICENSE_ID : "License ID <DONOTSHOW>",
		LICENSE_NAME : "License Name",
		LICENSE_TYPE : "License Type", //Capacity or CAL
		LICENSE_TYPE_ID : "License Type ID <DONOTSHOW>",
		UNIT_PRICE : "Unit Price",
		BASELINE : "Baseline",
		LOWER_LIMIT : "Lower Limit",
		UPPER_LIMIT : "Upper Limit",
		COUNTING_TYPE : "Counting Type",
		COUNTING_TYPE_ID : "Counting Type ID <DONOTSHOW>",
		CONTRACT_ID : "Billing Group ID <DONOTSHOW>",
		UNIQUE_ID : "Unique ID <DONOTSHOW>",
		CONTRACT_NAME : "Billing Group Name",
		CONTRACT_NAME_HIDDEN : "Billing Group Name <DONOTSHOW>",
		CUSTOMER_NAME : "CommCell Group",
		GROUP_ID : "Group ID <DONOTSHOW>",
		BILLING_GROUP : "SKU",
		BILLING_GROUP_ID : "SKU ID <DONOTSHOW>",
		SKU_TYPE : "SKU Type",
		DESCRIPTION : "Description",
		ENTITY_TYPE : "Entity Type",
		ENTITY_TYPE_ID : "Entity Type ID <DONOTSHOW>",
		CONTRACT : "Billing Group",
		CONTRACT_DESCRIPTION : "Description",
		APPROVED : "Approved",
		APPROVED_ORIG : "APPROVED_ORIG",
		ACTIONS : "Actions",
		BILLING_TYPE : "Billing Cycle",
		CURRENCY : "Currency",
		MINIMUM_FEE : "Minimum Fee",
		DISCOUNT_PERCENTAGE : "Discount Percentage",
		USE_AS_PO : "Use As Purchase Order",
		AGG_ID : "SPID <DONOTSHOW>",
		AGGREGATOR_ID : "Service Provider ID <DONOTSHOW>",
		AGGREGATOR_NAME : "Service Provider",
		AGGREGATOR_ID_HIDDEN : "Service Provider ID <HIDDEN>",
		COMMCELL_GROUP_ID : "CommCell Group ID <HIDDEN>",
		COMMCELL_GROUP_NAME : "CommCell Group",
		PART_ID : "PartID <DONOTSHOW>",
		PARTNER_ID : "Partner ID <DONOTSHOW>",
		PARTNER_NAME : "Partner",
		TENANT_ID : "Tenant ID <DONOTSHOW>",
		TENANT : "Tenant",
		CONTRACT_TYPE : "Billing Group Type",
		PLAN : "Plan",
		BASE_PLAN : "Base Plan",
		LOWER_THRESHOLD : "Lower Threshold",
		UPPER_THRESHOLD : "Upper Threshold",
		INCLUDE_IN_VOLUME_DISCOUNT : "Include SKU in Volume Discount",
	};

	var labels = {
		BASELINE : "Baseline",
		LOWER_LIMIT : "Lower Limit",
		UPPER_LIMIT : "Upper Limit",
		BASELINE_TB : "Baseline (TB)",
		LOWER_LIMIT_TB : "Lower Limit (TB)",
		UPPER_LIMIT_TB : "Upper Limit (TB)",
	};

	var permissions = {
		ADMIN : "admin",
		MANAGE : "manage",
		VIEW : "view"
	};

	var global = {
		ROW_INDEX : "ROW_INDEX",
		CAL_ONLY_LIST : [
				"100011",
				"100013",
				"100017",
				"100018",
				"100024",
				"100025",
				"100026",
				"100028",
				"200010",
				"200011",
				"200012",
				"200013",
				"200014",
				"200015",
				"200016",
				"200018",
				"200019",
				"300001",
				"300002",
				"300003",
				"1147",
				"1131",
				"1138",
				"1146",
				"1152",
				"1153",
				"1154" ],
		BILLING_GROUPS : "SKUs",
		CONTRACTS : "Billing Groups",
		DEFAULT_CURRENCY : "USD",
		AGGREGATORS : "Service Providers",
		PARTNERS : "Partners",
		LEGACY_CONTRACT_NAME : "Legacy Partner Contract",
		DEFAULT_CONTRACT_TYPE : "CommCell based",
		TENANT_CONTRACT_TYPE : "Tenant based"
	};

	function addRenderers(data, isDetailDialog) {
		if (isDetailDialog) {
			$.each(data.aoColumns, function(i, col) {
				if (col.mDataProp === columns.BASELINE || col.mDataProp === columns.LOWER_LIMIT) {
					col.rendererType = "contractCapacityRenderer";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.UPPER_LIMIT) {
					col.rendererType = "contractPriceUnlimitedRenderer";
					col.bUseRendered = false;
				}
			});
		} else {
			$.each(data.aoColumns, function(i, col) {
				if (col.mDataProp === columns.BASELINE) {
					col.rendererType = "contractCapacityRenderer";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.LOWER_LIMIT) {
					col.rendererType = "contractMultiLineRendererWithUnit";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.UNIT_PRICE) {
					col.rendererType = "contractMultiLineRenderer";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.UPPER_LIMIT) {
					col.rendererType = "contractMultiLineRendererUnlimited";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.APPROVED) {
					col.rendererType = "checkBoxRenderer";
				} else if (col.mDataProp === columns.UPPER_THRESHOLD) {
					col.rendererType = "discountUnlimitedRenderer";
					col.bUseRendered = false;
				} else if (col.mDataProp === columns.DISCOUNT_PERCENTAGE) {
					col.rendererType = "discountPercentageRenderer";
					col.bUseRendered = false;
				}

			});

		}

	}

	function handleTenantColumn(data, contractType) {
		$.each(data.aoColumns, function(i, col) {
			if (col.mDataProp === columns.TENANT) {
				if (contractType === 0) {
					col.doNotShow = true;
					col.bVisible = false;
					col.bHidden = true;
				} else {
					col.doNotShow = false;
					col.bVisible = true;
					col.bHidden = false;
				}
			}
		});
		$("#initialQuantity").val("");
		if (contractType === 0) {
			$("#ccGroupRow").hide();
			$("#tenantRow").hide();
			$("#initialQuantity").addClass("integerInput");
			$("#initialQuantity").removeClass("decimalInput");
		} else {
			$("#ccGroupRow").show();
			$("#tenantRow").show();
			$("#initialQuantity").addClass("decimalInput");
			$("#initialQuantity").removeClass("integerInput");
		}
	}

	function disbleSorting(columnDefs) {
		$.each(columnDefs, function(i, col) {
			col.bSortable = false;
		});
	}

	function addActionButtonToTableRows(data, isAssociationTable) {
		var col;
		var colExists = true;

		if ($.isEmptyObject(data.aaData) === true) {
			colExists = false;
		} else {
			$.each(data.aaData, function(i, row) {
				if (typeof row["ACTION_COL"] === 'undefined') {
					row["ACTION_COL"] = "";
					colExists = false;
				}
			});
		}

		if (colExists === false) {

			col = {
				bFilterRendered : false,
				bHidden : false,
				bHiddenColumnSort : false,
				bMandatoryCol : true,
				bSortable : false,
				bUseRendered : false,
				bVisible : true,
				doNotShow : false,
				mDataProp : "ACTION_COL",
				originalColName : "ACTION_COL",
				sName : "Actions",
				sTitle : "Actions",
				sqlType : "String",
				sWidth : "45px",
				rendererType : "actionButtonRenderer"
			};

			data.aoColumns.push(col);
		}

	}

	function openDeleteEntityConfirmDialog(rowData, message, entityName, callback) {
		$("#deleteMessage").text(message);
		$("#entityName").text(entityName);
		$("#entity-delete-dialog-form").dialog({
			title : cvUtil.cvLocalize("Title_Confirm_Delete"),
			height : 180,
			width : 500,
			modal : true,
			resizable : false,
			buttons : [ {
				text : cvUtil.cvLocalize("No"),
				click : function() {
					$(this).dialog("close");
					$(this).dialog("destroy");
				}
			}, {
				text : cvUtil.cvLocalize("Yes"),
				class : "defaultDialogButton",
				click : function() {
					$(this).dialog("close");
					$(this).dialog("destroy");
					callback(rowData);

				}
			} ]
		});
	}

	function exportToExcel(dataTable, title) {

		var contents = "";
		var oSettings = dataTable.fnSettings();

		//Populating table headers
		var visibleColumns = [];
		for (var j = 0; j < oSettings.aoColumns.length; j++) {
			if (oSettings.aoColumns[j].bVisible) {
				var colName = oSettings.aoColumns[j].sTitle;
				if (colName !== columns.ACTIONS) {//action button column need not be exported to excel
					visibleColumns.push(oSettings.aoColumns[j].mDataProp);
					if (colName.indexOf("\"") !== -1) {
						colName = colName.replace(/\"/gi, "\"\"");
					}
					colName = "\"" + colName + "\"";

					contents = contents + colName + ",";//"\t";
				}
			}
		}

		//Populating the main rows (the sub rows will not be taken when, the main row has multiple sub rows within it)
		contents = contents + "\n";
		var filteredData = Reports.fnGetFilteredData(oSettings);
		$.each(filteredData, function(index, value) {
			var lowerLimit = [], upperLimit = [], unitPrice = [], approved = -1, license = [];
			if (title === contractUtils.global.CONTRACTS) {
				lowerLimit = value[columns.LOWER_LIMIT].split(",");
				upperLimit = value[columns.UPPER_LIMIT].split(",");
				unitPrice = value[columns.UNIT_PRICE].split(",");
				approved = value[columns.APPROVED_ORIG];
			} else if (title === contractUtils.global.BILLING_GROUPS) {
				license = value[columns.LICENSE_NAME].split(",");
			}

			var colVal = "", val = "";
			for (var j = 0; j < visibleColumns.length; j++) {
				val = "";
				$.each(value, function(columnTitle, columnValue) {
					if (visibleColumns[j] === columnTitle) {
						if (columnTitle === columns.LOWER_LIMIT) {
							val = val + "\"" + lowerLimit[0] + "\"";
						} else if (columnTitle === columns.UPPER_LIMIT) {
							if (upperLimit[0] === "-1") {//Replacing -1 to Unlimited for UpperLimit column
								val = val + "\"Unlimited\"";
							} else {
								val = val + "\"" + upperLimit[0] + "\"";
							}
						} else if (columnTitle === columns.UNIT_PRICE) {
							val = val + "\"" + unitPrice[0] + "\"";
						} else if (columnTitle === columns.APPROVED) {
							if (approved !== -1) {//Approved column should be shown only for main rows
								if (columnValue.indexOf("data-state=\"checked\"") > -1 ||
										columnValue.indexOf("data-state='checked'") > -1) {
									val = val + "\"Yes\"";
								} else {
									val = val + "\"No\"";
								}
							} else {
								val = val + "\" \"";
							}
						} else if (columnTitle === columns.LICENSE_NAME) {
							val = val + "\"" + license[0] + "\"";
						} else {
							val = val + "\"" + columnValue + "\"";
						}
						val = val + ",";
					}
				});
				colVal = colVal + val;
			}
			if (colVal.replace(/\"/gi, "").replace(/,/gi, "").trim().length > 0) {//add the column value to export contents, only if it is not empty
				contents = contents + colVal + "\n";
			}

			//Populating the sub rows when, the main row has multiple rows within it
			colVal = "";
			if (lowerLimit.length > 1) {
				for (var i = 1; i < lowerLimit.length; i++) {
					for (j = 0; j < visibleColumns.length; j++) {
						val = "";
						$.each(value, function(columnTitle) {
							if (visibleColumns[j] === columnTitle) {
								if (columnTitle === columns.LOWER_LIMIT) {
									val = val + "\"" + lowerLimit[i] + "\"";
								} else if (columnTitle === columns.UPPER_LIMIT) {
									if (upperLimit[i] === "-1") {
										val = val + "\"Unlimited\"";
									} else {
										val = val + "\"" + upperLimit[i] + "\"";
									}
								} else if (columnTitle === columns.UNIT_PRICE) {
									val = val + "\"" + unitPrice[i] + "\"";
								} else {
									val = val + "\" \"";
								}
								val = val + ",";
							}
						});
						colVal = colVal + val;
					}
					if (colVal.replace(/\"/gi, "").replace(/,/gi, "").trim().length > 0) {//add the column value to export contents, only if it is not empty
						colVal = colVal + "\n";
					} else {
						colVal = "";
					}
				}
			} else {
				if (license.length > 1) {
					for (var i = 1; i < license.length; i++) {
						for (j = 0; j < visibleColumns.length; j++) {
							val = "";
							$.each(value, function(columnTitle) {
								if (visibleColumns[j] === columnTitle) {
									if (columnTitle === columns.LICENSE_NAME) {
										val = val + "\"" + license[i] + "\"";
									} else {
										val = val + "\" \"";
									}
									val = val + ",";
								}
							});
							colVal = colVal + val;
						}
						if (colVal.replace(/\"/gi, "").replace(/,/gi, "").trim().length > 0) {//add the column value to export contents, only if it is not empty
							colVal = colVal + "\n";
						} else {
							colVal = "";
						}
					}
				}
			}
			contents = contents + colVal;
		});

		document.exportform.csvBuffer.value = contents;
		var now = new Date();
		document.exportform.fileName.value = title + "_" + now.getDate() + "_" + (now.getMonth() + 1) + "_" +
				now.getFullYear() + "_" + now.getHours() + "" + now.getMinutes() + "" + now.getSeconds();
		document.exportform.reportName.value = report.getExportFilePrefix();
		$("form[name='exportform']").submit();
	}

	commonExports.contractUtils = {
		addActionButtonToTableRows : addActionButtonToTableRows,
		addRenderers : addRenderers,
		handleTenantColumn : handleTenantColumn,
		columns : columns,
		labels : labels,
		openDeleteConfirmDialog : openDeleteEntityConfirmDialog,
		disbleSorting : disbleSorting,
		permissions : permissions,
		global : global,
		exportToExcel : exportToExcel
	};

	Reports.Renderers.actionButtonRenderer = function(o, val) {
		var actionDiv = $("<div></div>", {
			class : "rowActionDiv",
			"data-row" : JSON.stringify(o.aData)
		});

		var editAction = $("<span></span>", {
			title : "Edit",
			id : "editItemButton",
			class : "sprite icon-edit rowActionButton"
		});

		var deleteAction = $("<span></span>", {
			title : "Delete",
			id : "deleteItemButton",
			class : "sprite icon-edit rowActionButton"
		});

		actionDiv.append(editAction);
		actionDiv.append(deleteAction);

		var name = "";
		//name of the billing group
		if (typeof o.aData[columns.CUSTOMER_NAME] !== "undefined" && typeof o.aData[columns.CONTRACT] !== "undefined") {
			name = o.aData[columns.CUSTOMER_NAME];
		}
		//name of the aggregator
		if (typeof o.aData[columns.AGGREGATOR_NAME] !== "undefined" &&
				typeof o.aData[columns.MINIMUM_FEE] !== "undefined") {
			name = o.aData[columns.AGGREGATOR_NAME];
		}
		//name of the partner
		if (typeof o.aData[columns.PARTNER_NAME] !== "undefined" &&
				typeof o.aData[columns.DISCOUNT_PERCENTAGE] !== "undefined") {
			name = o.aData[columns.PARTNER_NAME];
		}
		//name of billing group in "new" contract dialog box
		if (typeof o.aData[columns.CONTRACT] !== "undefined" && typeof o.aData[columns.BILLING_GROUP] !== "undefined" &&
				typeof o.aData[columns.APPROVED_ORIG] === "undefined") {
			name = o.aData[columns.BILLING_GROUP];
		}

		var status = "", visibility = "", contractPage = false;
		if (typeof o.aData[columns.APPROVED_ORIG] !== "undefined") {
			if (o.aData[columns.APPROVED_ORIG] === 1) {
				status = "disabled";
			}
			//show action buttons, only for the first item within the same contract group(in contracts table)
			if (o.aData[columns.APPROVED_ORIG] === -1) {
				visibility = "hidden";
			}

			//name of the contract
			name = o.aData[columns.CONTRACT];
			contractPage = true;
		}
		if (typeof o.aData[columns.AGG_ID] !== "undefined") {
			//show action buttons, only for the first item within the same aggregator group(in aggregators table)
			if (o.aData[columns.AGG_ID] === "-1") {
				visibility = "hidden";
			}

			//name of the aggregator
			name = o.aData[columns.AGGREGATOR_NAME];
		}
		if (typeof o.aData[columns.PART_ID] !== "undefined") {
			//show action buttons, only for the first item within the same partner group(in partners table)
			if (o.aData[columns.PART_ID] === "-1") {
				visibility = "hidden";
			}

			//name of the partner
			name = o.aData[columns.PARTNER_NAME];
		}

		var associationPage = false;
		//do not show email button in Billing Group Association page
		if (cvUtil.getTopWindow().document.URL.indexOf("contractManagement.jsp") > 0) {
			associationPage = true;
		}

		//show action buttons, only for the first item within the same billingGroup group(in billing group table)
		if (typeof o.aData[columns.CONTRACT] === "undefined" && typeof o.aData[columns.AGG_ID] === "undefined" &&
				typeof o.aData[columns.PART_ID] === "undefined") {//this check is to ensure the below if condition is executed only for Manage Billing Group page
			//If below condition is checked for Contracts page then, ACTION columns will not be shown for contracts having no billing group
			//Contracts with no Billing Groups can be created by,
			// 1. create contract and associate it to a billing group
			// 2. Now delete those billing groups in Manage Billing Group page
			// 3. contract created in step 1 will now exist without any billing group associations
			//2nd part of if condition above makes sure the call is not from aggregator page
			if (typeof o.aData[columns.BILLING_GROUP] !== "undefined") {
				if (o.aData[columns.BILLING_GROUP].trim() === "") {
					visibility = "hidden";
				}
				//name of the billing group
				name = o.aData[columns.BILLING_GROUP];
			}
		}

		var returnString = "";
		if (contractPage === true) {
			returnString = "<div class='rowActionDiv'> <span id='deleteItemButton'  title='" +
					cvUtil.cvLocalize("Delete") + " " + name + "' class='sprite icon-trash rowActionButton " + status +
					" " + visibility + "'></span>" + " <span id='editItemButton'  title='" +
					cvUtil.cvLocalize("contact.edit") + " " + name + "' class='sprite icon-edit rowActionButton " +
					status + " " + visibility + "'></span></div>";
		} else if (associationPage === true) {
			returnString = "<div class='rowActionDiv'> <span id='deleteItemButton'  title='" +
					cvUtil.cvLocalize("Delete") + " " + name + "' class='sprite icon-trash rowActionButton " + status +
					" " + visibility + "'></span>" + " <span id='editItemButton'  title='" +
					cvUtil.cvLocalize("contact.edit") + " " + name + "' class='sprite icon-edit rowActionButton " +
					status + " " + visibility + "'></span>" + " <span id='generateBillButton'  title='" +
					cvUtil.cvLocalize("Generate") + " " + cvUtil.cvLocalize("Royalty_Report") + " " +
					cvUtil.cvLocalize("For") + " " + name + "' class='sprite icon-billing rowActionButton " + status +
					" " + visibility + "'></span></div>";
		} else {
			returnString = "<div class='rowActionDiv'> <span id='deleteItemButton'  title='" +
					cvUtil.cvLocalize("Delete") + " " + name + "' class='sprite icon-trash rowActionButton " + status +
					" " + visibility + "'></span>" + " <span id='editItemButton'  title='" +
					cvUtil.cvLocalize("contact.edit") + " " + name + "' class='sprite icon-edit rowActionButton " +
					status + " " + visibility + "'></span>" + " <span id='emailBillButton'  title='" +
					cvUtil.cvLocalize("Send") + " " + cvUtil.cvLocalize("Royalty_Report") + " " +
					cvUtil.cvLocalize("For") + " " + name + "' class='sprite icon-send rowActionButton " + status +
					" " + visibility + "'></span>" + " <span id='generateBillButton'  title='" +
					cvUtil.cvLocalize("Generate") + " " + cvUtil.cvLocalize("Royalty_Report") + " " +
					cvUtil.cvLocalize("For") + " " + name + "' class='sprite icon-billing rowActionButton " + status +
					" " + visibility + "'></span></div>";
		}
		return returnString;
	};

	Reports.Renderers.checkBoxRenderer = function(o, val) {
		var checkStatus = "unchecked";
		if (val === 1) {
			checkStatus = "checked";
		}

		var visibility = "";
		if (val === -1) {
			visibility = "hidden";
		}

		o.aData[columns.APPROVED_ORIG] = val;
		return '<div class="chkApprove selectCB custom-cb ' + checkStatus + ' ' + visibility + ' ' + 'approveBox_' +
				o.aData[columns.CONTRACT_ID] + '" data-state="' + checkStatus + '" data-contractid="' +
				o.aData[columns.CONTRACT_ID] + '" data-groupid="' + o.aData[columns.BILLING_GROUP_ID] + '"></div>';

	};

})(window);