(function() {
	'use strict';
	var entities = {};

	$(document).ready(function() {
		addEvents();
		initTable();
		loadBillingGroups();
		$("#tabs").tabs();
		$("#ccGroupRow").hide();
		$("#planRow").hide();
		$("#basePlanRow").hide();
		$("#txtPlanRow").hide();
		//initCommcellGroupList();
		//initPlanList("0");
		//initBasePlanList("0")
	});

	function initCommcellGroupList() {
		cvUtil.loadPage("getCommCellGroupList.do", {
			iAggregator : 3
		}, function(data) {
			var ccGroupList = $("#ccGroupList");
			ccGroupList.empty();
			$.each(data.aaData, function(index, ccGroup) {
				ccGroupList.append("<option value='" + ccGroup[contractUtils.columns.COMMCELL_GROUP_ID] + "'>" +
						ccGroup[contractUtils.columns.COMMCELL_GROUP_NAME] + "</option>");
			});
		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Billing_Group_Details"));
		}, {
			"async" : false
		});
	}

	function initPlanList(groupId) {
		cvUtil.loadPage("getPlans.do", {
			ccGrpId : groupId
		}, function(data) {
			var planList = $("#planList");
			planList.empty();
			$.each(data.aaData, function(index, plan) {
				planList.append("<option value='" + plan[contractUtils.columns.PLAN] + "'>" +
						plan[contractUtils.columns.PLAN] + "</option>");
			});
		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Plan_List"));
		}, {
			"async" : false
		});
	}

	function initBasePlanList(groupId) {
		cvUtil.loadPage("getBasePlans.do", {
			ccGrpId : groupId
		}, function(data) {
			var basePlanList = $("#basePlanList");
			basePlanList.empty();
			$.each(data.aaData, function(index, basePlan) {
				basePlanList.append("<option value='" + basePlan[contractUtils.columns.BASE_PLAN] + "'>" +
						basePlan[contractUtils.columns.BASE_PLAN] + "</option>");
			});
		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Base_Plan_List"));
		}, {
			"async" : false
		});
	}

	function loadBillingGroups() {
		$("#content").mask(cvUtil.cvLocalize("Loading"));

		cvUtil.loadPage("getBillingGroups.do", {
			option : 4
		}, function(data) {
			$("#billingGroupTable td").remove();
			if (data && data.iTotalRecords > 0) {
				$("#noBillingGroupFound").hide();
				$("#tableContent").show();
				contractUtils.addActionButtonToTableRows(data);
				contractUtils.disbleSorting(data.aoColumns);
				$.each(data.aoColumns, function(i, col) {
					if (col.mDataProp === contractUtils.columns.LICENSE_NAME) {
						col.rendererType = "licenseNameRenderer";
						col.bUseRendered = false;
					}
				});

				Reports.configureClientSideTable("billingGroupTable", '', data);
				$("#billingTableWrapper .icon-billing").hide();
				$("#billingTableWrapper .icon-send").hide();
			} else {
				$("#noBillingGroupFound").show();
				$("#tableContent").hide();
			}
			$("#content").unmask();

		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Billing_Group"));
			$("#content").unmask();

		});
	}

	function createTable(data) {
		$("#billingGroupTable td").remove();
		var curGroupId = 0;
		var groups = [], group = {};

		$.each(data, function(i, rowData) {
			var groupId = rowData[contractUtils.columns.BILLING_GROUP_ID], license = {};

			if (groupId !== curGroupId) {
				curGroupId = groupId;
				group = {
					data : rowData,
					licenses : []
				};
				groups.push(group);
			}

			license.licenseName = rowData[contractUtils.columns.LICENSE_NAME];
			license.uniqueId = rowData[contractUtils.columns.UNIQUE_ID];
			group.licenses.push(license);
		});

		$.each(groups, function(i, group) {
			var rowData = group.data;
			var row = $("<tr></tr>", {
				"data-groupname" : rowData[contractUtils.columns.BILLING_GROUP],
				"data-groupid" : rowData[contractUtils.columns.BILLING_GROUP_ID]

			}), groupName = $("<td></td>", {
				text : rowData[contractUtils.columns.BILLING_GROUP],
				rowspan : group.licenses.length || 0
			}), description = $("<td></td>", {
				text : rowData[contractUtils.columns.DESCRIPTION],
				rowspan : group.licenses.length || 0
			}), countType = $("<td></td>", {
				text : rowData[contractUtils.columns.BILLING_TYPE],
				rowspan : group.licenses.length || 0
			});

			row.append(groupName);
			row.append(description);
			row.append(countType);

			$.each(group.licenses, function(i, lic) {
				var licenseName = $("<td></td>", {
					text : lic.licenseName,
					"data-licName" : lic.licenseName,
					"data-licUniqueId" : lic.uniqueId
				});

				if (i !== 0) {
					row = $("<tr></tr>");
				}
				row.append(licenseName);

				if (i < group.licenses.length - 1) {
					row.attr("class", "noBorderRow");
				}

				$("#billingGroupTable tbody").append(row);
			});

		});

		$.each(data, function(i, rowData) {
			var groupName = $("<td></td>", {
				text : rowData[contractUtils.columns.BILLING_GROUP]
			}), description = $("<td></td>", {
				text : rowData[contractUtils.columns.DESCRIPTION]
			}), countType = $("<td></td>", {
				text : rowData[contractUtils.columns.BILLING_TYPE]
			}), licenseName = $("<td></td>", {
				text : rowData[contractUtils.columns.LICENSE_NAME]
			}), row = $("<tr></tr>", {
				"data-groupname" : rowData[contractUtils.columns.BILLING_GROUP],
				"data-groupid" : rowData[contractUtils.columns.BILLING_GROUP_ID]
			}), groupId = contractUtils.columns.BILLING_GROUP_ID;

			$("#billingGroupTable tbody").append(row);
			row.append(groupName);
			row.append(description);
			row.append(countType);
			row.append(licenseName);

		});
	}

	function initTable() {
		var view = {};
		view.title = '';
		view.filters = false;
		view.collapsible = false;
		view.alarm = false;
		view.exportExcel = true;
		view.colChooser = true;
		$('#contractTableWrapper').append(SurveyTemplates.makeReportTable('billingGroupTable', view));

	}

	function openGroupDetailDialog(rowData) {
		var title = "";
		if (rowData) {
			title = cvUtil.cvLocalize("contact.edit") + " " + cvUtil.cvLocalize("Subscription_Sku");
		} else {
			title = cvUtil.cvLocalize("New") + " " + cvUtil.cvLocalize("Subscription_Sku");
		}
		initDialog(rowData);
		$("#billing-dialog-form").dialog({
			title : title,
			height : 820,
			width : 700,
			modal : true,
			resizable : false,
			buttons : [ {
				text : cvUtil.cvLocalize("Close"),
				click : function() {
					$(this).dialog("close");
					$(this).dialog("destroy");
				}
			}, {
				text : cvUtil.cvLocalize("Save"),
				class : "defaultDialogButton",
				click : function() {
					if (isValidInput()) {
						saveBillingGroup(rowData);
					}
				}
			} ]
		});
	}

	function initDialog(rowData) {
		$('#tabs').tabs('select', 0);
		$("#messageLabel").text("");
		$("#ccGroupList").val("-1");
		$("#txtPlan").val("");
		if (rowData) {
			$("#billing-dialog-form").mask(cvUtil.cvLocalize("Loading"));
			cvUtil.loadPage("getBillingGroupDetail.do", {
				groupId : rowData[contractUtils.columns.BILLING_GROUP_ID]
			}, function(data) {
				$("#billing-dialog-form").unmask();
				if (data && data.aaData && data.aaData.length > 0) {
					var groupData = data.aaData[0];
					$("#billingGroupName").val(groupData[contractUtils.columns.BILLING_GROUP]);
					$("#billingGroupDesc").val(groupData[contractUtils.columns.DESCRIPTION]);
					$("#countingType").val(groupData[contractUtils.columns.COUNTING_TYPE_ID]);
					$("#skuType").val(String(groupData[contractUtils.columns.SKU_TYPE]));
					$("#txtPlan").val("");
					if(groupData[contractUtils.columns.SKU_TYPE]===0) {
						$("#ccGroupRow").hide();
						$("#planRow").hide();
						$("#basePlanRow").hide();
						$("#txtPlanRow").hide();
						$("#tabs ul #agentsTabLi").show();
					}else{
						initCommcellGroupList();
						$("#ccGroupRow").show();
						$("#ccGroupList").val("-1");
						$("#tabs ul #agentsTabLi").hide();
						if(groupData[contractUtils.columns.SKU_TYPE]===1) {
							initPlanList("0");
							$("#planList").val(groupData[contractUtils.columns.PLAN]);
							$("#planRow").show();
							$("#basePlanRow").hide();
							$("#txtPlanRow").show();
							if($("#planList option:selected").text().trim()!==groupData[contractUtils.columns.PLAN].trim()){
								$("#txtPlan").val(groupData[contractUtils.columns.PLAN]);
							}
						} else if(groupData[contractUtils.columns.SKU_TYPE]===2) {
							initBasePlanList("0");
							$("#basePlanList").val(groupData[contractUtils.columns.PLAN]);
							$("#planRow").hide();
							$("#basePlanRow").show();
							$("#txtPlanRow").show();
							if($("#basePlanList option:selected").text().trim()!==groupData[contractUtils.columns.PLAN].trim()){
								$("#txtPlan").val(groupData[contractUtils.columns.PLAN]);
							}
						}
					}
					$.when(populateAgentTypeList()).then(function() {
						initLicenseDetailPanel(data.aaData);
					});

					$.when(populateLicenseTypeList()).then(function() {
						initLicenseDetailPanel(data.aaData);
					});

				} else {
					cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Billing_Group_Details"));
				}
			}, function(xhr, ajaxOptions, thrownError) {
				$("#billing-dialog-form").unmask();
				cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Billing_Group_Details"));

			});

		} else {
			$("#billingGroupName").val("");
			$("#billingGroupDesc").val("");
			$("#countingType").val(1);
			populateAgentTypeList();
			populateLicenseTypeList();
		}
	}

	function hideInvalidLicenses() {
		var calOnlyLicense = contractUtils.global.CAL_ONLY_LIST;
		if ($("#countingType option:selected").val() === "1") {
			calOnlyLicense.forEach(function(item) {
				$(".availableList li[data-id=" + item + "]").addClass("hidden");
			});
		} else {
			calOnlyLicense.forEach(function(item) {
				$(".availableList li[data-id=" + item + "]").removeClass("hidden");
			});
		}
	}

	function removeInvalidLicensesSelected() {
		var calOnlyLicense = contractUtils.global.CAL_ONLY_LIST;
		if ($("#countingType option:selected").val() === "1") {
			//remove invalid licenses from License Types tab
			var selectedLicenses = $("#licenseTypesTab .selectedList li");
			selectedLicenses.each(function(index, li) {
				calOnlyLicense.forEach(function(item) {
					if ($(li).attr("data-id") === item) {
						$(li).appendTo($("#licenseTypesTab .availableList"));
						$("#licenseTypesTab .selectedList li[data-id=" + item + "]").remove();
					}
				});
			});
			sortList($("#licenseTypesTab .availableList"));
			//remove invalid agents from Agents tab
			var selectedAgents = $("#agentsTab .selectedList li");
			selectedAgents.each(function(index, li) {
				calOnlyLicense.forEach(function(item) {
					if ($(li).attr("data-id") === item) {
						$(li).appendTo($("#agentsTab .availableList"));
						$("#agentsTab .selectedList li[data-id=" + item + "]").remove();
					}
				});
			});
			sortList($("#agentsTab .availableList"));
		}
	}

	function sortList($list) {
		$list.children().detach().sort(function(a, b) {
			return $(a).text().localeCompare($(b).text());
		}).appendTo($list);
	}

	function isValidInput() {
		var calOnlyLicense = contractUtils.global.CAL_ONLY_LIST, notValidSelection = [], list = {}, invalid = false;

		if ($("#billingGroupName").val().trim() === "") {
			$("#messageLabel").text(cvUtil.cvLocalize("Enter_Billing_Group_Name"));
			$("#billingGroupName").focus();
			return false;
		}

		if ($("#skuType").val() !== "0") {
			if($("#txtPlan").val().trim()==="") {
				if(($("#skuType").val() === "1" && $("#planList option:selected").text().trim()==="") || ($("#skuType").val() === "2" && $("#basePlanList option:selected").text().trim()==="")) {
					$("#messageLabel").text(cvUtil.cvLocalize("Enter_Plan_Name"));
					$("#txtPlan").focus();
					return false;
				}
			}
		}

		if ($(".selectedList li").length === 0) {
			$("#messageLabel").text(cvUtil.cvLocalize("Add_License"));
			return false;
		}

		//	 	 License Name						License  ID		Agent  ID
		//		 Virtual Machines					100011			1147
		//		 Archived Mailboxes					100013			1131
		//		 Content Indexed Object				100017			1138
		//		 CPU Sockets on Hypervisor Hosts	100018			1146
		//		 End point users					100024			1152
		//		 End point sharing users			100025			1153
		//		 End point E-discovery users		100026			1154

		if ($("#countingType option:selected").val() === 1) {
			$(".selectedList li").each(function() {
				var lic = $(this).attr("data-id");
				if ($.inArray(lic, calOnlyLicense) !== -1) {
					invalid = true;
				}
			});

			if (invalid) {
				$("#messageLabel").text(cvUtil.cvLocalize("Invalid_License"));
				return false;
			}
		}

		return true;

	}

	function saveBillingGroup(rowData) {
		var group = {}, option = 1, isEdit = false;
		if (rowData) {
			isEdit = true;
			option = 2;
		}

		group.billingGroupName = $("#billingGroupName").val();
		group.description = $("#billingGroupDesc").val() || "";
		group.countingType = $("#countingType option:selected").val();
		group.licenseList = [];
		var skuType=$("#skuType option:selected").val();
		group.billingGroupType = skuType;
		if(skuType==="1") {
			if($("#txtPlan").val() !== ""){
				group.planName = $("#txtPlan").val().trim();
			} else {
				group.planName = $("#planList option:selected").val();
			}
		} else if(skuType==="2") {
			if($("#txtPlan").val() !== ""){
				group.planName = $("#txtPlan").val().trim();
			} else {
				group.planName = $("#basePlanList option:selected").val();
			}
		} else {
			group.planName = "";
		}

		$(".selectedList li").each(function() {
			var license = {};
			license.licenseId = $(this).attr("data-id");
			license.licenseName = $(this).attr("data-name");
			license.uniqueId = 0;
			license.licenseType = $(this).attr("data-type");
			group.licenseList.push(license);
		});

		if (isEdit) {
			group.billingGroupId = rowData[contractUtils.columns.BILLING_GROUP_ID];
		}

		cvUtil.loadPageWithPOST("saveBillingGroup.do", {
			billingGroup : JSON.stringify(group),
			option : option
		}, function(data) {
			if (data && data.errorCode === 0) {
				cvUtil.toast(data.message);
				$("#billing-dialog-form").dialog("close");
				$("#billing-dialog-form").dialog("destroy");
				loadBillingGroups();
			} else {
				cvUtil.errorToast(data.message);
			}
		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Save_Billing_Group_Failure"));
		});
	}

	var deleteBillingGroup = function(rowData) {
		cvUtil.loadPage("deleteBillingGroupEntity.do", {
			groupId : rowData[contractUtils.columns.BILLING_GROUP_ID]
		}, function(data) {
			if (data && data.errorCode === 0) {
				cvUtil.toast(cvUtil.cvLocalize("Delete_Billing_Group_Success"));
				loadBillingGroups();
			} else {
				cvUtil.errorToast(cvUtil.cvLocalize("Delete_Billing_Group_Failure"));
			}

		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast(cvUtil.cvLocalize("Delete_Billing_Group_Failure"));

		});
	};

	function initLicenseDetailPanel(licenses) {
		var licenseAvailableList = "#licenseTypesTab .availableList", agentAvailableList = "#agentsTab .availableList", licenseSelectedList = "#licenseTypesTab .selectedList", agentSelectedList = "#agentsTab .selectedList", licEle;

		$.each(licenses, function(i, lic) {
			if (lic[contractUtils.columns.ENTITY_TYPE_ID] === 1) {
				licEle = $(licenseAvailableList + " li[data-id=" + lic[contractUtils.columns.LICENSE_ID] + "]");
				licEle.appendTo(licenseSelectedList);
			} else {
				licEle = $(agentAvailableList + " li[data-id=" + lic[contractUtils.columns.LICENSE_ID] + "]");
				licEle.appendTo(agentSelectedList);
			}
		});

		//sort all the lists
		sortList($(licenseAvailableList));
		sortList($(agentAvailableList));
		sortList($(licenseSelectedList));
		sortList($(agentSelectedList));
	}

	function populateAgentTypeList() {
		var deferred = jQuery.Deferred();

		if (entities.agentTypes === undefined) {
			cvUtil.loadPage("getAgentTypes.do", '', function(data) {
				entities.agentTypes = data.aaData;
				doPopulate(entities.agentTypes, 'agentType');
				deferred.resolve("true");

			}, function(xhr, ajaxOptions, thrownError) {
				cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Agents"));
				deferred.resolve("true");

			});
		} else {
			doPopulate(entities.agentTypes, 'agentType');
			deferred.resolve("true");
		}

		return deferred.promise();
	}

	function populateLicenseTypeList() {
		var deferred = jQuery.Deferred();

		if (entities.liceseTypes === undefined) {
			cvUtil.loadPage("getLicenseTypes.do", '', function(data) {
				entities.liceseTypes = data.aaData;
				doPopulate(entities.liceseTypes, 'licenseType');
				deferred.resolve("true");

			}, function(xhr, ajaxOptions, thrownError) {
				cvUtil.errorToast(cvUtil.cvLocalize("Error_Loading_Licenses"));
				deferred.resolve("true");

			});
		} else {
			doPopulate(entities.liceseTypes, 'licenseType');
			deferred.resolve("true");
		}
		return deferred.promise();
	}

	function getTabId(type) {
		if (type === 'agentType') {
			return 'agentsTab';
		} else {
			return 'licenseTypesTab';
		}
	}

	function doPopulate(data, type) {
		var tabId = getTabId(type), availableList = $("#" + tabId + " .availableList"), selectedList = $("#" + tabId +
				" .selectedList"), licType = type === 'agentType' ? 0 : 1;

		availableList.empty();
		selectedList.empty();
		$.each(data, function(i, lic) {
			var sourceLi = $("<li></li>", {
				text : lic.name,
				class : "selectableItem",
				"data-id" : lic.id,
				"data-name" : lic.name,
				"data-type" : licType
			});
			availableList.append(sourceLi);
		});
		hideInvalidLicenses();
	}

	function addItemsToList(tabid) {
		$("#" + tabid + " .availableList .selectedItem").each(function() {
			$(this).removeClass("selectedItem");
			$(this).appendTo("#" + tabid + " .selectedList");
			$("#" + tabid + " .searchItem").val("");
		});
		//sort the lists
		sortList($("#" + tabid + " .availableList"));
		sortList($("#" + tabid + " .selectedList"));
	}

	function removeItemsFromList(tabid) {
		$("#" + tabid + " .selectedList .selectedItem").each(function() {
			$(this).removeClass("selectedItem");
			$(this).appendTo("#" + tabid + " .availableList");
		});
		//sort the lists
		sortList($("#" + tabid + " .availableList"));
		sortList($("#" + tabid + " .selectedList"));
	}

	function addEvents() {
		$("#addBillingGroupButton").click(function() {
			openGroupDetailDialog();
		});

		$(".addNewGroup").click(function() {
			openGroupDetailDialog();
		});

		$("#licenseTypesTab").on("click", ".selectableItem", function() {
			if ($(this).hasClass('selectedItem')) {
				$(this).removeClass('selectedItem');
			} else {
				$(this).addClass('selectedItem');
			}
		});

		$("#agentsTab").on("click", ".selectableItem", function() {
			if ($(this).hasClass('selectedItem')) {
				$(this).removeClass('selectedItem');
			} else {
				$(this).addClass('selectedItem');
			}
		});

		$(".addItemButton").click(function() {
			var tabid = $(this).attr('data-tabid');
			$("#messageLabel").text("");
			addItemsToList(tabid);
		});

		$(".removeItemButton").click(function() {
			var tabid = $(this).attr('data-tabid');
			removeItemsFromList(tabid);
		});

		$("#billingGroupName").keypress(function() {
			$("#messageLabel").text("");
		});

		$("#billingGroupDesc").keypress(function() {
			$("#messageLabel").text("");
		});

		$("#countingType").change(function() {
			$("#messageLabel").text("");
			removeInvalidLicensesSelected();
			hideInvalidLicenses();
		});

		$("#skuType").change(function() {
			if($("#skuType option:selected").val() === "0") {
				$("#ccGroupRow").hide();
				$("#planRow").hide();
				$("#basePlanRow").hide();
				$("#txtPlanRow").hide();
				$("#tabs ul #agentsTabLi").show();
			}else{
				initCommcellGroupList();
				$("#ccGroupRow").show();
				$("#ccGroupList").val("-1");
				$("#tabs ul #agentsTabLi").hide();
				var groupId = $("#ccGroupList option:selected").val();
				if ($("#skuType option:selected").val() === "1") {
					initPlanList(groupId);
					$("#planRow").show();
					$("#basePlanRow").hide();
					$("#txtPlanRow").show();
				} else if ($("#skuType option:selected").val() === "2") {
					initBasePlanList(groupId);
					$("#planRow").hide();
					$("#basePlanRow").show();
					$("#txtPlanRow").show();
				}
			}
		});
		$("#ccGroupList").change(function() {
			var groupId = $("#ccGroupList option:selected").val();
			if ($("#skuType option:selected").val() === "1") {
				initPlanList(groupId);
			} else if ($("#skuType option:selected").val() === "2") {
				initBasePlanList(groupId);
			}
		});


		$("#billingTableWrapper").on("click",
				'#editItemButton',
				function() {
					var rowIndex = $("#billingGroupTable_table").dataTable().fnGetPosition($(this).closest('tr')
							.find('td')[0])[0];
					var rowData = $("#billingGroupTable_table").dataTable().fnGetData()[rowIndex];
					openGroupDetailDialog(rowData);
				});

		$("#billingTableWrapper").on("click",
				'#deleteItemButton',
				function() {
					var rowIndex = $("#billingGroupTable_table").dataTable().fnGetPosition($(this).closest('tr')
							.find('td')[0])[0];
					var rowData = $("#billingGroupTable_table").dataTable().fnGetData()[rowIndex];
					contractUtils.openDeleteConfirmDialog(rowData,
							cvUtil.cvLocalize("Confirm_Billing_Group_Deletion"),
							rowData[contractUtils.columns.BILLING_GROUP],
							deleteBillingGroup);
				});

		$("#billingTableWrapper").on("click", '.tableExportExcel', function() {
			var dataTable = $("#billingGroupTable_table").dataTable();
			contractUtils.exportToExcel(dataTable, contractUtils.global.BILLING_GROUPS);
		});

		$("#manageContractButton").click(function() {
			cvUtil.getTopWindow().location.assign(cvUtil.getContextPath() + "/cloud/contract/manageContract.jsp");
		});
		$("#aggregatorRedirectButton")
				.click(function() {
					cvUtil.getTopWindow().location.assign(cvUtil.getContextPath() +
							"/cloud/contract/aggregatorManagement.jsp");
				});
		$("#ccGroupRedirectButton").click(function() {
			cvUtil.getTopWindow().location.assign(cvUtil.getContextPath() + "/cloud/contract/contractManagement.jsp");
		});
	}

	Reports.Renderers.licenseNameRenderer = function(o, val) {
		var licenses = val.split(","), newVal = "";

		if (licenses.length === 1) {
			return val;
		}

		$.each(licenses, function(i, lic) {
			if (i !== 0) {
				newVal = newVal + "<br>";
			}

			newVal = newVal + lic;

		});
		return newVal;
	};

})(this);
