<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="Service_Provider" var="Service_Provider" />
<fmt:message key="Service_Providers" var="Service_Providers" />
<fmt:message key="Royalty_Report" var="Royalty_Report" />
<fmt:message key="Manage" var="Manage" />
<jsp:include page="../../common/header.jsp">
	<jsp:param value="${Service_Providers}" name="titleLocalized" />
	<jsp:param value="${Manage} ${Service_Providers}" name="headerTitleLocalized" />
	<jsp:param value="true" name="classicReport"/>
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
 	<jsp:param value="reports/reportsBase.jsp" name="jsp"/>

 	<jsp:param value="true" name="includeHistory"/>
 	<jsp:param value="true" name="includeJqueryUI"/>
 	<jsp:param value="true" name="includeTableSupport"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/manageBillingGroup.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractCommon.css" name="css"/>
</jsp:include>

<jsp:include page="contractCommon.jsp" />
<jsp:include page="../../survey/exportForm.jsp" flush="true" />

<script nonce="${sessionScope.cspNonce}" >
	var securityPermission = '${requestScope.securityPermission}';
	window.urlInitializationNotRequired=true;

	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>

<div class ="sechead">
	<span id="sectionTitle" class="sectiontitle"><fmt:message key="Manage"/> <fmt:message key="Service_Providers"/> </span>
</div>
<div id="noPermission" class="hidden"><fmt:message key="error.msg.no_permissions"/></div>
<div id='tableHeader'>
	<h1><fmt:message key="Service_Providers"/></h1>
	<div id='addAggregatorButton' class='tableActionButton'>
		<span   title='<fmt:message key="contact.add"/> <fmt:message key="Contract"/>' class='sprite icon-plus '  > </span>
		<span class='tableButtonText '><fmt:message key="contact.add"/> <fmt:message key="Service_Provider"/></span>
	</div>
	<div id="manageContractButton" class="tableActionButton pageRedirect" style="display:none">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Billing_Groups"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Billing_Groups"/></span>
	</div>
	<div id="aggregatorRedirectButton" class="tableActionButton pageRedirect">
		<span class="sprite icon-reports" title='<fmt:message key="Service_Provider"/> <fmt:message key="Royalty"/> <fmt:message key="Reports"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Service_Provider"/> <fmt:message key="Royalty"/> <fmt:message key="Reports"/></span>
	</div>
	<div class='clearfloat'></div>
</div>
<div id='aggregatorTableWrapper'>
	<div id="aggregatorTable" > </div>
</div>

 <div id="aggregator-dialog-form"   class="hidden">
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="Service_Provider"/> <fmt:message key="Name"/></div>
 		<input  id='aggregatorName'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="task.description"/></div>
 		<input  id='aggregatorDesc'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div id='entitiesLabel' class='cgLabel'> <fmt:message key="CommCell_Groups"/> </div>
   	<div id='licensesDiv'>
	  <div id="ccGrpsTab">
		  <div class="selectionList">
			<div class="licenseListPanel" id="availableLicensePanel">
				<h2><fmt:message key="Available"/> <fmt:message key="CommCell_Groups"/></h2>
				<ul   class="connectedSortable availableList "></ul>
			</div>
			<ul id="moveButtons">
				<li><button class="addItemButton" data-tabid="ccGrpsTab">&gt;</button></li>
				<li><button class="removeItemButton" data-tabid="ccGrpsTab">&lt;</button></li>
			</ul>
			<div class="licenseListPanel" id="selectedLicensePanel">
				<h2><fmt:message key="Selected"/> <fmt:message key="CommCell_Groups"/></h2>
				<ul   class="connectedSortable selectedList"></ul>
			</div>
			<div class="clearFloat"></div>
		 </div>
 	  </div>
   	</div>
   	<div class="ncRow">
 		<label id="messageLabel" class="invalidInput"></label>
	</div>
 </div>

</fmt:bundle>
<jsp:include page="../../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/qtip/jquery.qtip.min.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/manageAggregator.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractCommon.js" name="js" />
</jsp:include>