<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="Royalty_Report" var="Royalty_Report" />
<fmt:message key="Subscription_Skus" var="Subscription_Skus" />
<fmt:message key="Manage" var="Manage" />
<jsp:include page="../../common/header.jsp">
	<jsp:param value="${Subscription_Skus}" name="titleLocalized" />
	<jsp:param value="${Manage} ${Subscription_Skus}" name="headerTitleLocalized" />
	<jsp:param value="true" name="classicReport"/>
	<jsp:param value="${Royalty_Report}" name="headerTitle" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
 	<jsp:param value="reports/reportsBase.jsp" name="jsp"/>

 	<jsp:param value="true" name="includeHistory"/>
 	<jsp:param value="true" name="includeJqueryUI"/>
 	<jsp:param value="true" name="includeTableSupport"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/> 
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/manageBillingGroup.css" name="css"/> 
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractCommon.css" name="css"/> 
</jsp:include>

<jsp:include page="contractCommon.jsp" />	
<jsp:include page="../../survey/exportForm.jsp" flush="true" />

<script nonce="${sessionScope.cspNonce}" >
	window.urlInitializationNotRequired=true;

	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>

<div class ="sechead">
	<span id="sectionTitle" class="sectiontitle"><fmt:message key="Manage"/> <fmt:message key="Subscription_Skus"/> </span>
</div>
<div id='billingGroupContent'>
	<div id="noBillingGroupFound" class="hidden">
		<label><fmt:message key="No_Billing_Group_Found"/> <span id='addNewGroupLink' class='addNewGroup'><fmt:message key="Click_Here"/></span> <fmt:message key="To_Add"/> <fmt:message key="Subscription_Sku"/></label>
	</div>
	
	<div id='tableContent'> 	
		<div id='tableHeader'>
			<h1><fmt:message key="Subscription_Skus"/></h1>
			<div id='addBillingGroupButton' class='tableActionButton'>
				<span   title='<fmt:message key="New"/> <fmt:message key="Subscription_Sku"/>' class='sprite icon-newbillinggroup'  > </span><span class='tableButtonText'><fmt:message key="contact.add"/> <fmt:message key="Subscription_Sku"/></span>
			</div>
			<div id="manageContractButton" class="tableActionButton pageRedirect">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Billing_Groups"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Billing_Groups"/></span>
	</div>
	<div id="ccGroupRedirectButton" class="tableActionButton">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/></span>
	</div>
			<div class='clearfloat'></div>
		</div>
	
		<div id='billingTableWrapper'>
			<div id="billingGroupTable">
			</div>
		</div>
	</div>
</div>

 <div id="billing-dialog-form"   class="hidden">
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="Subscription_Sku"/> <fmt:message key="Name"/></div>
 		<input  id='billingGroupName'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="task.description"/></div>
 		<input  id='billingGroupDesc'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	
 	<div class='ncRow'>
 		<label class='labelCol'><fmt:message key="Counting_Type"/><fmt:message key="Footnote_Symbol"/></label>
 		<select id='countingType' class='valueCol'>
 			<option value=1><fmt:message key="Capacity"/></option>
 			<option value=0><fmt:message key="Client_Access"/></option>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<label class='labelCol'><fmt:message key="Sku_Type"/></label>
 		<select id='skuType' class='valueCol'>
 			<option value=0><fmt:message key="Regular"/></option>
 			<option value=1><fmt:message key="Plan_Associated"/></option>
 			<option value=2><fmt:message key="Base_Plan_Associated"/></option>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow' id='ccGroupRow'>
 		<div id='ccGrouplabel' class='labelCol'><fmt:message key="CommCell_Group"/></div>
 		<select id='ccGroupList' class='valueCol'>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
	<div class='ncRow' id='planRow'>
		<label  id='planLabel' class='labelCol'><fmt:message key="Plan"/></label>
	 	<select id='planList' class='valueCol'>
	 	</select>
	 	<div class="clearFloat"></div>
	</div>
	<div class='ncRow' id='basePlanRow'>
		<label  id='basePlanLabel' class='labelCol'><fmt:message key="Base_Plan"/></label>
	 	<select id='basePlanList' class='valueCol'>
	 	</select>
	 	<div class="clearFloat"></div>
	</div>
	<div class='ncRow' id='txtPlanRow'>
		<label  id='txtPlanLabel' class='labelCol' style='color:white;'>.</label>
 		<input  id='txtPlan'  class='valueCol' type='text' placeholder='<fmt:message key="Type_Plan_Name"/>'>
 		<div class="clearFloat"></div>
 	</div>

 	<div id='entitiesLabel'> <fmt:message key="Licenses"/> </div>
   	<div id='licensesDiv'>
   	<div id="tabs">
	  <ul>
	    <li><a href="#licenseTypesTab"><fmt:message key="License"/> <fmt:message key="Types"/></a></li>
	    <li id="agentsTabLi"><a href="#agentsTab"><fmt:message key="Agents"/></a></li>
 	 </ul>
 	 
	  <div id="licenseTypesTab">
		  <div class="selectionList">
			<div class="licenseListPanel" id="availableLicensePanel">
				<h2><fmt:message key="Available"/> <fmt:message key="License"/> <fmt:message key="Types"/></h2>
				<ul   class="connectedSortable availableList "></ul>
			</div>	
			<ul id="moveButtons">
				<li><button class="addItemButton" data-tabid="licenseTypesTab">&gt;</button></li>
				<li><button class="removeItemButton" data-tabid="licenseTypesTab">&lt;</button></li>
			</ul>	
			<div class="licenseListPanel" id="selectedLicensePanel">
				<h2><fmt:message key="Selected"/> <fmt:message key="License"/> <fmt:message key="Types"/></h2>
				<ul   class="connectedSortable selectedList"></ul>
			</div>
			<div class="clearFloat"></div>
		</div>
 	 </div>
	 <div id="agentsTab">
		  <div class="selectionList">
				<div class="licenseListPanel" id="availableLicensePanel">
					<h2><fmt:message key="Available"/> <fmt:message key="Agents"/></h2>
					<ul   class="connectedSortable availableList"></ul>
				</div>	
				<ul id="moveButtons">
					<li><button class="addItemButton" data-tabid="agentsTab">&gt;</button></li>
					<li><button class="removeItemButton" data-tabid="agentsTab">&lt;</button></li>
				</ul>	
				<div class="licenseListPanel" id="selectedLicensePanel">
					<h2><fmt:message key="Selected"/> <fmt:message key="Agents"/></h2>
					<ul   class="connectedSortable selectedList"></ul>
				</div>
				<div class="clearFloat"></div>
			</div>
	  </div>
</div>

   	</div>
	<div id="notesDiv">
		<h4><fmt:message key="task.notes"/></h4>
		<p><fmt:message key="Footnote_Symbol"/> <fmt:message key="License_Notes_Line1"/></p>
		<p><fmt:message key="Footnote_Symbol"/> <fmt:message key="License_Notes_Line2"/></p>
		<p class="subItems"><fmt:message key="License_Notes_Line3"/></p>
	</div>
 	<label id="messageLabel" class="invalidInput"></label>
 
 </div>
  
</fmt:bundle>
<jsp:include page="../../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/qtip/jquery.qtip.min.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/> 
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/manageBillingGroup.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractCommon.js" name="js" />
</jsp:include>