<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="Billing_Groups" var="Billing_Groups" />
<fmt:message key="Manage" var="Manage" />
<jsp:include page="../../common/header.jsp">
	<jsp:param value="${Billing_Groups}" name="titleLocalized" />
	<jsp:param value="${Manage} ${Billing_Groups}" name="headerTitleLocalized" />
	<jsp:param value="true" name="classicReport"/>
	<jsp:param value="${Royalty_Report}" name="headerTitle" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
 	<jsp:param value="reports/reportsBase.jsp" name="jsp"/>
	<jsp:param value="true" name="includeSecHeader" />
 	<jsp:param value="true" name="includeHistory"/>
 	<jsp:param value="true" name="includeJqueryUI"/>
 	<jsp:param value="true" name="includeTableSupport"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractManagement.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/css/contractCommon.css" name="css"/>
</jsp:include>

<jsp:include page="contractCommon.jsp" />
<jsp:include page="../../survey/exportForm.jsp" flush="true" />

<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	var securityPermission = '${requestScope.securityPermission}';
	window.urlInitializationNotRequired=true;

	var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
</script>

<div id="noPermission" class="hidden"><fmt:message key="error.msg.no_permissions"/></div>
<div id='tableHeader'>
	<h1><fmt:message key="Billing_Groups"/></h1>
	<div id='addContractButton' class='tableActionButton'>
		<span   title='<fmt:message key="contact.add"/> <fmt:message key="Billing_Group"/>' class='sprite icon-plus '  > </span><span class='tableButtonText '><fmt:message key="contact.add"/> <fmt:message key="Billing_Group"/></span>
	</div>
	<div id='billingGroupButton' class='tableActionButton'>
		<span   title='<fmt:message key="Manage"/> <fmt:message key="Subscription_Skus"/>' class='sprite icon-manage-billing-group'  > </span><span class='tableButtonText '><fmt:message key="Manage"/> <fmt:message key="Subscription_Skus"/></span>
	</div>
	<div id="ccGroupRedirectButton" class="tableActionButton">
		<span class="sprite icon-manage-billing-group" title='<fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/>'> </span>
		<span class="tableButtonText "><fmt:message key="Manage"/> <fmt:message key="Billing_Group"/> <fmt:message key="Associations"/></span>
	</div>

	<div class='clearfloat'></div>
</div>
<div id='contractTableWrapper'>
	<div id="contractTable" > </div>
</div>

 <div id="contract-dialog-form"   class="hidden">
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="Billing_Group"/> <fmt:message key="Name"/></div>
 		<input  id='contractName'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="task.description"/></div>
 		<input  id='contractDesc'  class='valueCol' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="Currency"/></div>
 		<select id='contractCurrencyList' class='valueCol'>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<div class='labelCol'><fmt:message key="Billing_Group"/> <fmt:message key="task.task_type"/></div>
 		<select id='contractType' class='valueCol'>
 			<option value="0"><fmt:message key="CommCell_Based"/></option>
  			<option value="1"><fmt:message key="Tenant_Based"/></option>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow' id='ccGroupRow'>
 		<div id='ccGrouplabel' class='labelCol'><fmt:message key="CommCell_Group"/></div>
 		<select id='ccGroupList' class='valueCol'>
 		</select>
 		<div class="clearFloat"></div>
 	</div>
 	<div id='contractDetailTitle'> <fmt:message key="Billing_Group"/> <fmt:message key="Details"/>	</div>

	<div class='ncRow' id='tenantRow'>
		<label  id='tenantLabel' class='labelCol'><fmt:message key="Tenant"/></label>
	 	<select id='tenantList' class='valueCol'>
	 	</select>
	 	<div class="clearFloat"></div>
	</div>
 	<div  class='ncRow'>
 		<label class='labelCol'><fmt:message key="Subscription_Sku"/></label>
 		<select id='billingGroupList' class='valueCol'>
 		</select>
 		<div class="clearFloat"></div>
 	</div>

 	<div class='ncRow'>
 		<label class='labelCol'><fmt:message key="Counting_Type"/></label>
 		<input  id='countingType'  class='valueCol' type='text' disabled>
 		<div class="clearFloat"></div>
 	</div>


 	<div class='ncRow'>
 		<label  id='initialQuantityLabel' class='labelCol'><fmt:message key="Base_Line"/></label>
 		<input id='initialQuantity' class='valueCol integerInput' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<label class='labelCol'><fmt:message key="Unit_Price"/></label>
 		<input  id='price'  class='valueCol decimalInput' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<label  id='lowerLimitLabel' class='labelCol'><fmt:message key="Lower_Limit"/></label>
 		<input id='lowerLimit' class='valueCol integerInput' type='text'>
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<label id='upperLimitLabel' class='labelCol'><fmt:message key="Upper_Limit"/></label>
 		<input id='upperLimit' class='valueCol integerInput' type='text' placeholder="<fmt:message key="Placeholder_For_Upper_Limit"/>">
 		<div class="clearFloat"></div>
 	</div>
 	<div class='ncRow'>
 		<label id='IncludeInVDLabel' class='labelCol'><fmt:message key="Include_In_Volume_Discount"/></label>
 		<select id='IncludeInVDList' class='valueCol'>
 			<option value="No"><fmt:message key="No"/></option>
  			<option value="Yes"><fmt:message key="Yes"/></option>
 		</select>
 		<div class="clearFloat"></div>
 	</div>

 	<div id='addContractBtnDiv'>
 		<input id='addContractDetailBtn' type='button' value='<fmt:message key="contact.add"/> <fmt:message key="Subscription_Sku"/> <fmt:message key="Price"/>'/>
 		<input id='clearContractDetailBtn' type='button' value='Clear'/>
		<p id='errorMessage'> </p>
 	</div>
 	<div id='contractDetailTableWrapper'>
		<div id="contractDetailTable" > </div>

	</div>
 </div>

  <div id="delete-contract-entity-dialog-form"   class="hidden">
  	<p> <fmt:message key="Confirm_Contract_Deletion"/></p>
  	<table>
  		<tbody>
  			<tr>
  				<td> <fmt:message key="Contract"/> <fmt:message key="Name"/> </td>
  				<td><label id="entityContractName"></label></td>
  			</tr>
  			<tr>
  				<td> <fmt:message key="Subscription_Sku"/> </td>
  				<td><label id="groupName"></label></td>
  			</tr>
			<tr>
  				<td><fmt:message key="Counting_Type"/> </td>
  				<td><label id="countingType"></label></td>
  			</tr>
			<tr>
  				<td><fmt:message key="Entity_Type"/> </td>
  				<td><label id="entityType"></label></td>
  			</tr>
  			<tr>
  				<td><fmt:message key="Unit_Price"/> </td>
  				<td><label id="entityPrice"></label></td>
  			</tr>
  			<tr>
  				<td><fmt:message key="Base_Line"/> </td>
  				<td><label id="entityBaseline"></label></td>
  			</tr>
  			<tr>
  				<td><fmt:message key="Lower_Limit"/> </td>
  				<td><label id="entityLowerLimit"></label></td>
  			</tr>
  			<tr>
  				<td><fmt:message key="Upper_Limit"/> </td>
  				<td><label id="entityUpperLimit"></label></td>
  			</tr>

  		</tbody>
  	</table>
  </div>
  <div id="save-and-delete-dialog-form"   class="hidden">
   		<p><fmt:message key="Confirm_Save_And_Delete"/></p>
   </div>
</fmt:bundle>
<jsp:include page="../../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/common/qtip/jquery.qtip.min.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js" />
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/manageContract.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractDetail.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractCommon.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/cloud/contract/js/contractAssociation.js" name="js" />

</jsp:include>