(function(exports) {
	'use strict';

	var chartData = null,
	selectedGroup = "records";


	$(document).ready(function() {
		setUIStateFromURL();

		$("#applyButton").on("click", function() {
			generateChart(true);
		});

		$(".plotEntity").on("click", function() {
			setTimeout(function() { //asynchronously call generateChart so that the checkbox status is set properly
				generateChart(false);
			},0);

		});

		$("#ddbListBox").on("change", function() {
			generateChart(false);
		});


		$("#lastNDays").keypress(function(e) {
			  if (e.which != 8 && e.which != 0 && (e.which < 48 || e.which > 57)) {
				  return false;
			  }
		});

		$("#trendFrequency").on("change", function() {
			$("#nDaysText").text($("#trendFrequency option:selected").attr("data-sublabel"));
			if ($("#trendFrequency option:selected").val() !=1) {
				$("#lastNDays").prop("max", 12);
				if ($("#lastNDays").val() > 12)
					$("#lastNDays").val(12);
			} else {
				$("#lastNDays").prop("max", 30);
			}

		});


		$(".optionsDiv").on("click", function(event) {
			if ($(this).hasClass("selected"))
				return;
			event.stopPropagation();

			$(".optionsDiv.selected").removeClass("selected");
			$(".plotEntity").addClass("disabled");
			$(this).addClass("selected");
			$(".plotEntity", $(this) ).removeClass("disabled");
			report.requestString.group=$(this).attr("id");
			generateChart(false);
		});


		$("#trendingDiv").on("click",".arrowPlaceholder",function () {
			if ($(this).hasClass("expand")) {
				$("#trendingWrapper").hide();
				$(this).removeClass("expand");
				$(this).addClass("collapse");
				report.requestString.trending="collapse";
			}
			else {
				$("#trendingWrapper").show();
				$(this).removeClass("collapse");
				$(this).addClass("expand");
				report.requestString.trending="expand";
				generateChart(true);
			}
		});

		if (cvUtil.getParameterByName("trending") ==="expand") {
			generateChart(true);
		}
	});


	function setUIStateFromURL() {
		var selections = cvUtil.getParameterByName("selections"),
		trending = cvUtil.getParameterByName("trending"),
		group =  cvUtil.getParameterByName("group"),
		frequency =  cvUtil.getParameterByName("freq"),
		interval=  cvUtil.getParameterByName("interval"),
		ddb= cvUtil.getParameterByName("ddb"),
		entities,
		displaySel = [];



		$(".optionsDiv.selected").removeClass("selected");
		$(".plotEntity").addClass("disabled");



		if (selections !="") {
			entities = selections.split(",");

			 $.each($("#plotOptions .checked"), function (i, cb) {
				 unCheckCb($("#" + cb.id))
			});

			 $.each(entities, function (i, entity) {
				 checkCb($("#" + entity));
				 displaySel.push($("#" + entity).siblings().text());
			 });
		}


		if (group == "")
			group = "records";

		$("#" + group).addClass("selected");
		$(".plotEntity", $("#" + group)).removeClass("disabled");

		if (frequency !="") {
			$("#trendFrequency").val(frequency);
			$("#nDaysText").text($("#trendFrequency option:selected").attr("data-sublabel"));
			if ($("#trendFrequency option:selected").val() !=1) {
				$("#lastNDays").prop("max", 12);
			} else {
				$("#lastNDays").prop("max", 30);
			}
		}

		if (interval != "") {
			$("#lastNDays").val(interval);
		}

		if (trending ==="expand") {
			$("#trendingWrapper ").show();
			$("#trendingDiv .arrowPlaceholder").removeClass("collapse");
			$("#trendingDiv .arrowPlaceholder").addClass("expand");
		}

		if (exportType) {
			$("#freqVal").html($("#trendFrequency option:selected").text());
			$("#forLastVal").html(interval +" " +  $("#trendFrequency option:selected").attr("data-sublabel"));
			$("#ddbVal").html(ddb);
			 $("#entitiesVal").html(displaySel.join(", "));
		}
	}

	function generateChart(fetchData) {
		console.log("generate chart");
		cvUtil.mask("#chartDisplayArea");

		 var aggregate = 1;
		 var ccid = cvUtil.getParameter('commUniId', "0");
//		 fetchData= true;
		 if (fetchData) {
			 cvUtil.loadPageWithPOST("survey.do?action=GetSurveyDetails&isChart=true&surveyId=65&ccId=" + ccid + "&bAggregate=" + $("#trendFrequency option:selected").val() + "&latest=" + $("#lastNDays").val() ,null, function(cData) {
		            if(!cData.data){
		            	return handleError("No chartable data available.");
		            }

		            if (cData.errorMessage)
		            	return handleError(cData.errorMessage);

		            chartData = cData;
		            fillDDBList(cData.data.DDBList);
		        	drawChart(cData.data);
		        },function(xhr, ajaxOptions, thrownError){
		        	handleError(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		    });
		 } else {
			 drawChart(chartData.data);
		 }

	}


	function fillDDBList(data) {
		var selectEle = $("#ddbListBox"),
		ddb= cvUtil.getParameterByName("ddb");

		selectEle.empty();
		$.each(data, function(i, ddb) {
			var item = $("<option>", {
						value: ddb,
						text:ddb
				});
			selectEle.append(item);
		});

		if (ddb !== "") {
			$("#ddbListBox").val(ddb);
		}
	}

	function drawChart(data) {
		var cw = 800, ch=250,
	    r,
	    cData = data[$("#ddbListBox option:selected").text()],
//	    numPoints = cData.seriesList[0].points.length,
	    selections = [],
	    i=0,
	    series;
//	    maxSteps=14;

		$("#ddbTrendChartArea").empty();
		r =  Raphael("ddbTrendChartArea");

		if (report.requestString.group === undefined){
			report.requestString.group="records";
		}

		$.each($("#" + report.requestString.group + " .checked"), function () {
				selections.push($(this).attr("id"));
		});

		report.requestString.selections = selections.toString();
		report.requestString.ddb= $("#ddbListBox option:selected").text();
		report.requestString.freq= $("#trendFrequency").val();
		report.requestString.interval=$("#lastNDays").val();
		report.updateHash(true);

		if (selections.length == 0) {
			handleError(cvUtil.cvLocalize("ddb.Entity_selection_check"));
			return;
		}

		var tempData = {};
		$.extend(true, tempData, cData);

		for (i=0; i<tempData.seriesList.length; i++) {
			series = tempData.seriesList[i];
			if ($.inArray(getIdOfSeries(series.seriesName), selections) === -1) {
				tempData.seriesList.splice(i,1);
				i--;
			}

		}


		$("#ddbTrendChartArea").show();
		$("#messageLabel").hide();
		cvUtil.unmask("#chartDisplayArea");


		tempData.yAxisTitle = getYAxisTitle(report.requestString.group);
	    cvcharts.createRaphaelLinechartNew(r, tempData, {axis:"0 1 1 1",chartWidth:cw,chartHeight:ch,leftMargin:75,topMargin:20,shade:false,radius:2,showPartialLine:true,showLegend:false,legendAnchor:'bottom',
	    	showLegendMultiLines:true, legend:1,legendX:cw +20,legendY:35, maxSteps:14,maxLegendLen:300,colors:cvcharts.colors[5],smooth:false,
	    	thresholdLabel:tempData.yAxis.thresholdLabel,
	    	thresholdProperties:{thresholdStroke:{"stroke": "#008000","stroke-width": 1.5 }},recalculateYMax:true,isDataSize:report.requestString.group ==='dataSize'
	    	});

	}

	function handleError(message) {
		$("#messageLabel").html(message);
		$("#messageLabel").show();
		cvUtil.unmask("#chartDisplayArea");
	}

	function getYAxisTitle(group) {
		if (group=== "records")
			return localMsg.records;
		else if (group=== "dataSize")
			return localMsg.dataSize;
		else if (group==="QITime")
			return localMsg.qiTime;
		else
			return localMsg.records;
	}

	function getIdOfSeries(name) {
		if (name === 'Primary Records')
			return "PRIMARY_RECORDS";
		else if (name==='Secondary Records')
			return 'SECONDARY_RECORDS';
		else if (name=== 'Prunable Records')
			return 'PRUNABLE_RECORDS';
		else if (name ==='Total Data')
			return 'TOTAL_DATA';
		else if (name==='Deduped Data')
			return 'DEDUPED_DATA';
		else if (name ==='Frontend Backup')
			return 'FRONTEND_BACKUP';
		else if (name==='Frontend Archive')
			return 'FRONTEND_ARCHIVE';
		else if (name==='Size of DDB')
			return 'DDB_SIZE';
		else if(name==='Average Q&I Time')
			return 'QI_TIME';
		else if(name==='Total Data')
			return 'TOTAL_DATA';
		else
			return "";
	}


	exports.ddbPerformance = {
			generateChart : generateChart
	}

})(this);