var Alarms = {
		TYPE_HEALTH : 0,
		TYPE_GENERAL : 1,
		VERSION: 1,
		getHealthParams : function(obj, criteriaId) {
			if (obj.isTiledHealth) {
				if (obj.fromManage && !obj.editCriteriaSet) {
					var alertData = {};
					alertData.DescriptionText = obj.description;
					return alertData;
				} else {
					if (criteriaId) {
						if (obj.alertCriteria && obj.alertCriteria.criteria) {
							for (var idx =0; idx < obj.alertCriteria.criteria.length; idx++) {
								if (obj.alertCriteria.criteria[idx].criteriaId == criteriaId) {
									return obj.alertCriteria.criteria[idx];
								}
							}
						}
						return {};
					}else {
						return obj.alertCriteria;
					}
				}
			} else {
				var paramsTable = obj.paramsTable;
				var paramName = obj.paramName;

				var i = 0;
				for(i = 0; !!paramsTable.aaData && i<paramsTable.aaData.length; i++) {
					var row = paramsTable.aaData[i];
					if(row.Parameter == paramName) {
						return row;
					}
				}
				return {};
			}

		},
		isCustomReport : false,
		DEFAULT_SCHEDULE_TIME : 28800, // default time is set to 8:00 AM
		DEFAULT_SCHEDULE_END_TIME : 86100, // default time is set to 11:55 PM
		dateRenderer : ["dateTimeRenderer", "MMMYYYY", "MMMDDYYYY","DWDDMMM","MMMDDYYYYHrMinAM","HHMMSS","MMMDDYYYYNEVER"],
		stringSqlType : [ "varchar", "nvarchar", "text", "ntext", "char","nchar", "String"]

};


function manageAlarms(allCommCellsData) {
	var commUniId = cvUtil.getParameter('commUniId', 0);
	var commCellName = "";
	if (commUniId != 0 && !getValueForUniqId(commUniId, "guid")) {
		loadAlarms = false;
		cvUtil.errorToast('Could not load details for CommCell Unique id '+ commUniId);
		window.location.href='../survey/reports/monitoringform.jsp';
	}

	this.report = new Reports.initReport({
		type: "survey",
		directPrint : true
	});

	this.requestString = report.requestString;
	report.idtomask = "alarmsSettings";
	report.mask = function(id,message){
		if(message && message!=null) {
			loading=message;
		} else {
			message = "";
		}
		if(id && id!=null){$("#"+id).mask(message);} else {$("#content").mask(message);}
	};

	report.initializeDefaults = function() {
		if(commUniId) {
			report.requestString.commUniId = commUniId;
			commCellName = getValueForUniqId(commUniId, "name");
		}
		report.type = "survey";
	};
	alarmsOperations();

	report.initComponents = function() {
		$(document).on('click', ".alarmNameLink", function(){
			var obj = {};
			var reportName = $(this).data("report");
			var alarmURL = $(this).data("alarmurl");
			var reportURL = $(this).data("reporturl");
			var reportEnum = $(this).data("reportenum");
			var reportUniqId = $(this).data("reportuniqid");
			var aid = $(this).data("aid");
			var name = $(this).data("name");
			var email = $(this).data("email");
			var emailCc = $(this).data("emailcc");
			var emailBcc = $(this).data("emailbcc");
			var description = $(this).data("description");
			var notificationTypes = $(this).data("notificationtypes");
			var type = $(this).data("type");
			var alertSeverity = $(this).data("alertseverity");
			var alertstatus  = $(this).data("alertstatus");
			var headerTemplate  = $(this).data("headertemplate");
			obj.alarmURL = alarmURL;
			obj.reportURL= reportURL;
			obj.reportName = reportName;
			obj.name = name;
			obj.email = email;
			obj.emailCc = emailCc;
			obj.emailBcc = emailBcc;
			obj.aid = aid;
			obj.description = description;
			obj.notificationTypes = notificationTypes;
			obj.type = type;
			obj.fromManage = true;
			obj.SNMPDescription =  $(this).data("snmpdescription");
			obj.alertSeverity  = alertSeverity;
			obj.reportEnum = reportEnum;
			obj.reportUniqId = reportUniqId;
			obj.alertstatus = alertstatus;
			obj.headerTemplate = headerTemplate;
			obj.isTiledHealth = $(this).data("tileAlert");
			obj.tileID = $(this).data("tileId");
			obj.paramValue = $(this).data("paramValue");
			obj.alertCriteriaIdForTile = $(this).data("alertCriteriaId");
			obj.operator = $(this).data("operator");
			obj.commUniId = $(this).data("commUniId");
			obj.templateId=$(this).data("templateId");
			obj.ccGroupId=$(this).data("ccGroupId");
			obj.companyId=$(this).data("companyId");
			Reports.configureAlarm(obj);
		});

	};

	$(document).on("checkedState", ".selectCB", function(){
		$(".actnBtnsDiv.alarmsSettings").removeClass("disabled");
		var tbl = $(this).closest("table");
		var cbs = tbl.find(".selectCB");

		if(cbs.length == cbs.filter(".checked").length) {
			checkCb(tbl.find(".selectAllReport"));
		}

	}).on("unCheckedState", ".selectCB", function(){
		if($(".selectCB.checked").length <= 0) {
			$(".actnBtnsDiv.alarmsSettings").addClass("disabled");
		}
		unCheckCb($(this).closest("table").find(".selectAllReport"));
	});

	$(document).on("checkedState", ".selectAllReport", function(){
		$(this).closest("table").find(".selectCB").each(function(){
			checkCb($(this));
		});
		$(".actnBtnsDiv.alarmsSettings").removeClass("disabled");
	}).on("unCheckedState", ".selectAllReport", function(){
		$(this).closest("table").find(".selectCB").each(function(){
			unCheckCb($(this));
		});
		if($(".selectCB.checked").length <= 0) {
			$(".actnBtnsDiv.alarmsSettings").addClass("disabled");
		}
	});


	report.initComponentState = function(){


	};

	report.beforeLoadReport = function() {
		$("#tableWrapper").empty();
	};

	report.getRequestUrl = function() {
		var commUniId = cvUtil.getParameter('commUniId', 0);
		if(commUniId) {
			return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=alarms&action=GET_LIST&commUniId=' + commUniId;
		}
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=alarms&action=GET_LIST';
	};

	report.onLoadReport = function(data) {
		if(data && typeof data ===  'object' && !data.errorMsg) {
			window.alarmsLoaded = true;
			if($.isEmptyObject(data)) {
				$("#tableWrapper").empty();
				$(".alertsToolbar").hide();
				$("#noDataNotificationPanel").html("No Alerts Are Available.");
				$("#noDataNotificationPanel").show();
			} else {
				$.each(data, function(key, value) {
					if(key.indexOf('alarmTable') == 0) {
						var view = {};
						view.title = commCellName == "" ?"":commCellName+ " - "+cvUtil.cvLocalize("Alerts") ;
						view.filters = true;
						view.collapsible = true;
						view.colChooser = true;
						view.alarm = false;
						view.exportExcel = false;
						var option ={};
						option.alarmTable=true;
						option.oColReorder = {"iFixedColumns": 1};
						var elem = $('#'+key);
						if(elem.length == 0) {
							$('#tableWrapper').append(SurveyTemplates.makeReportTable(key, view));
						}

						if(value.iTotalDisplayRecords > 50) {
							value.iDisplayLength = 50;
							$("#" + key +"_table_length").remove();
							Reports.configureClientSideTableWithPaging(key, view.title, value,"",option);
							$("#" + key + " .rptTblBtnEncDiv").append($("#" + key +"_table_length"));
						} else {
							Reports.configureClientSideTable(key, view.title, value,"",option);
						}
					}
				});
				$(".alertsToolbar").show();
				$("#searchBox").show();
				$(".actnBtnsDiv.alarmsSettings").addClass("disabled");
				report.afterLoadReport();
			}
		}
		else {
			alert(data.errorMsg);
		}
	};

	if(window.loadAlarms || window.loadAlarmsFromSettings) {
		report.init();
	}


	// ------------ Private Supporting functions --------------------

}

function alarmsOperations() {

	//==================================================Reports Manager page =============================================================//

	//==================================================Report Manage Page Events=========================================================//
	$(".alarmsSettings .actionBtns").click(function(e){
		var action = $(this).data("action");
		if(action == "ENABLE") {
			enableAlarms(getSelection());
		} else if(action == "DISABLE") {
			disableAlarms(getSelection());
		} else if(action == "DELETE") {
			deleteAlarms(getSelection());
		}if(action == "TRIGGER") {
			triggerAlarms(getSelection());
		}
		e.stopPropagation();
	});

	$(".selectBtns").click(function(){
		var action = $(this).data("action");
		if (action == "SELECT_ALL") {
			selectAllAlarms();
		} else if (action == "SELECT_NONE") {
			deselectAllAlarms();
		}
	});
	//================================================Report Manage Page Events End=========================================//

	//================================================Report Manage Page Functions=========================================//
	function selectAllAlarms() {
		$(".selectCB").each(function(){
			checkCb($(this));
		});

		$(".selectAllReport").each(function(){
			checkCb($(this));
		});

		$(".actnBtnsDiv.alarmsSettings").removeClass("disabled");
	}

	function deselectAllAlarms() {
		$(".selectCB").each(function(){
			unCheckCb($(this));
		});

		$(".selectAllReport").each(function(){
			unCheckCb($(this));
		});


		$(".actnBtnsDiv.alarmsSettings").addClass("disabled");
	}

	function getSelection() {
		var retval = $(".selectCB.checked").map(function(){
			return $(this).data("alarmid");
		}).get();

		return retval;
	}

	function deleteAlarms(alarmIdList) {
		alarmsUtil.alarmActions(alarmIdList,
								"DELETE",
								localMsg.Delete_Alerts_Confirmation_text,
								"Failed to delete, ",
								function () { report.loadReport()});
	}
	function disableAlarms(alarmIdList) {
		alarmsUtil.alarmActions(alarmIdList,
								"DISABLE",
								localMsg.Disable_Alerts_Confirmation_text,
								"Failed to delete, ",
								function () { report.loadReport()});
	}
	function enableAlarms(alarmIdList) {
		alarmsUtil.alarmActions(alarmIdList,
								"ENABLE",
								localMsg.Enable_Alerts_Confirmation_text,
								"Failed to delete, ",
								function () { report.loadReport()});
	}
	function triggerAlarms(alarmIdList) {
		alarmsUtil.alarmActions(alarmIdList,
								"TRIGGER_ALERT",
								localMsg.Trigger_Alerts_Confirmation_text,
								"Failed to delete, ",
								function (data) { cvUtil.toast(data.success)});
	}
	//================================================Report Manage Page Function End =========================================//

	//==================================================Alarm Dialog Box =============================================================//

	Reports.configureAlarm = function(obj) {
		// build dialog and display it..

		if (typeof emailSuggestion == "undefined") {
				setTimeout(function() {
					cvUtil.loadPageWithGET(cvUtil.getContextPath() + "/reports/js/emailSuggestion.js", null);
				}, 1000);
		}

		var buttonsObj = [];
		var saveButton ={
				id:"dialogbutton-save",
				text:"Save",
		        click: function() {
		        	// code for save...
		        	buildParamsAndSave(obj,  $("input[name=configureBy]:checked").attr("data-criteria-id"));
		        	}
				};
		var cancelButton={
		        id:"dialogbutton-cancel",
		        text:"Cancel",
		        click: function() {
		          $(this).dialog("close");
		        }
		      };

		buttonsObj.push(cancelButton);
		buttonsObj.push(saveButton);

		if(obj.isCustomReport) {
			Alarms.isCustomReport = true;
		}

		if(obj.editCriteriaSet){
			var urlParameters = window.location.search;
			urlParameters = urlParameters.replace("&alarmId=" + obj.aid, "").replace("alarmId=" + obj.aid, "");
			history.replaceState(null, document.title, urlParameters);
		}
		resetAll(obj);
		if(obj.fromManage) {
			obj.action = "EDIT";
			var notes = obj.notificationTypes.split(",");
			var notificationsId = ".notesCB";
			$("#alarmName").val(obj.name);
			$("#alertSeveritySelect").val(obj.alertSeverity);
			if(!obj.editCriteriaSet || $("#gen-alarmOpts").find("#paramsDiv .gen-columnSelect option").length == 0){
				$("#gen-alarmOpts").html(obj.description);
				$(".addNewCondition").hide();
				$("#allOrAnyDiv").hide();
				$(".gen-alarm-row").each(function(index,element){
					$(element).attr('title', $(element).text());
				});

			}else{
				//prepare existing conditions from the description place.
				var existingCriteria = $.parseHTML(obj.description);
				if(existingCriteria){
					$(".addNewCondition").show();
					$("#allOrAnyDiv").show();
					var isOrValue;
					existingCriteria.forEach(function(idx, li) {
					    var columnName;
					    var conditionOperator;
					    var value;
					    if(idx.childElementCount >= 4 ){
					    	columnName = idx.childNodes[0].textContent.trim();
				    		conditionOperator = idx.childNodes[2].textContent.trim();
				    		value = idx.childNodes[3].textContent.trim();
				    		if(li > 0){
									addConditionRow(obj);
							 }
				    		if(!isOrValue && idx.childNodes.length >=5){
				    			isOrValue = idx.childNodes[4].textContent.trim();
				    		}
				    		 //selecting columnname, operations and setting value.
				    		 var selectedList = $('#gen-alarmOpts .editable-alarm,gen-alarm-row li');
							 var selectedRow = selectedList.last();
							 selectedRow.find('.gen-columnSelect option[data-title="'+columnName+'"]').prop('selected','selected');
							 selected = selectedRow.find( ".gen-columnSelect option:selected" );
							 alarmsUtil.showHideOperators(selected, selectedRow,$("#alarmDialogOperators #alarmOpSelect"));
							 var optionSelected = selectedRow.find('#gen-opSelect option').filter(
									 function () {
										 return $(this).text().toLowerCase() == conditionOperator.toLowerCase();
							 }).attr('selected','selected');

							 //making usre the input fields are disabled/emabled based on the selected option.
							 inputFieldContextSensitivity(optionSelected);

							 if(!selectedRow.find('.gen-thresholdValue').is(':disabled')){
								 selectedRow.find('.gen-thresholdValue').val(value);
							 }

				    	}
					});
					if(isOrValue && isOrValue == "and"){
						obj.isOr = false;
					}else if(isOrValue && isOrValue == "or"){
						obj.isOr = true;
					}
					$("#allOrAnyDiv #allOrAnySelect option[value='"+obj.isOr+"']").prop('selected','selected');

				}else{
					$("#gen-alarmOpts").html(obj.description);
					$(".addNewCondition").hide();
					$("#allOrAnyDiv").hide();
					$(".gen-alarm-row").each(function(index,element){
						$(element).attr('title', $(element).text());
					});
				}
			}
			$("#alarmSchedule").hide();
			$("#noScheduleAvailable").hide();
			$("#loadingSchedule").show();
			if(($.inArray('SNMP', notes) > -1 || $.inArray('APPLOG', notes) > -1 || $.inArray('SCOM', notes) > -1) && ( obj.SNMPDescription!= undefined && obj.SNMPDescription !="" )){
				$("#customiseSNMPTrap").find("#customSNMPTrap").val(obj.SNMPDescription);
				$("#customiseSNMPTrap").show();
			}
			$("#customiseEmail").find("#emailBody").val(obj.headerTemplate !== "undefined"?obj.headerTemplate:cvUtil.cvLocalize('Custom_Email_Header_Text'));

			if(($.inArray('EMAIL', notes) > -1)){
				$("#emailDetails").show();
				$("#emailTo").val(obj.email);
				$("#emailCc").val(obj.emailCc);
				$("#emailBcc").val(obj.emailBcc);

			}
			if(($.inArray('EMAIL', notes) > -1) || $.inArray('LIVEFEEDS', notes) > -1){
				$("#customiseEmail").show();
			}
			$(notificationsId).each(function(){
				var val = $(this).data("value");
				if($.inArray(val, notes) > -1) {
					checkCb($(this));
				}
			});
			getTime(obj.aid);
		} else {
			var repName = obj.reportName;
			$("#gen-paramName").text(repName);
			var commUniId = cvUtil.getParameter('commUniId', 0);
			if(!isNaN(commUniId) && parseInt(commUniId)) {
				var ccId = getValueForUniqId(commUniId, "ccId");
				var ccName = getValueForUniqId(commUniId, "name");
			}
			setTime();
			if(obj.type == Alarms.TYPE_GENERAL) {
				$("#removeCondition").addClass("disabled");
				if(repName) {
					if((!isNaN(commUniId)) && parseInt(commUniId)) {
						$("#alarmName").val(cvUtil.cvLocalize("General_Alert_Default_Name",ccName,decimalToHex(ccId), repName));
					} else {
						$("#alarmName").val("Alert for worldwide " + repName);
					}
				} else {
					$("#gen-paramName").text("Uncategorized");
				}
			} else {
				if(!isNaN(commUniId) && parseInt(commUniId)) {
					if (obj.paramId == -1) {
						$("#alarmName").val("Alert for " + obj.paramName);
					} else {
						$("#alarmName").val(cvUtil.cvLocalize("Health_Alert_Default_Name",obj.paramName,ccName,decimalToHex(ccId)))
					}
				} else {
					$("#alarmName").val("Alert for " + obj.paramName);
				}
			}

			$("#emailAlertCB").click(); //Showing Email as default option while adding
			$("#emailDetails").show();
			$("#customiseEmail").show();
			//Setting Default Email as logged in user email
			var userEmail = window.sessionStorage.getItem('userEmail');
			if (userEmail ) {
					$( "#alarmsDialog" ).find("#emailTo").val(userEmail+",");
			}

		}
		var alarmDialog = $("#alarmsDialog");
		alarmDialog.dialog({
		      autoOpen: false,
		      width: 600,
		      title:"Configure Alert - " + (obj.type===Alarms.TYPE_HEALTH ? cvUtil.cvLocalize("HealthAlert") : $("#gen-paramName").text()),
		      resizable: false,
		      modal: true,
		      dialogClass: "alarmDialog",
		      buttons: buttonsObj,
		      close: function() {
		      },
		      drag: function(event, ui){
		    	  $("#timeElement .ui-autocomplete").hide();
		    	  $("#timeElementUntil .ui-autocomplete").hide();

		      }
		 });

		alarmDialog.dialog( "open" );
		if(obj.fromManage) {
			$(".ui-dialog-title").text("View Alert - " + obj.name);
			$(".ui-dialog-title").attr("title","View Alert - " + obj.name);
			$("#dialogbutton-save").attr("disabled", true);
			$("#dialogbutton-save").addClass("disabled");

			//set edit criteria option on the dialog panel if the alert opened from manager page
			if(!obj.editCriteriaSet && obj.type == Alarms.TYPE_GENERAL){
				var reportUrlWithAlarmId = obj.reportURL;

				if (reportUrlWithAlarmId.indexOf('/adminconsole/#/reportDetails') > -1) {
					reportUrlWithAlarmId = reportUrlWithAlarmId.replace('/adminconsole/#/reportDetails', '/webconsole/reportsplus/reportViewer.jsp');
					reportUrlWithAlarmId = reportUrlWithAlarmId.replace('app=ADMIN_CONSOLE', '');
				}

				var reportUrlParams = reportUrlWithAlarmId.split("?");
				if(reportUrlParams.length > 1){
					var urlParams = alarmsUtil.getUrlParams("?"+reportUrlParams[1]);
					if(Object.keys(urlParams).length > 0){
						reportUrlWithAlarmId +="&"
					}
				}else{
					reportUrlWithAlarmId +="?";
				}

				reportUrlWithAlarmId +="alarmId="+obj.aid;

				if (reportUrlWithAlarmId.indexOf('/webconsole/') > -1) {
					reportUrlWithAlarmId = reportUrlWithAlarmId.substring(reportUrlWithAlarmId.indexOf('/webconsole/'));
				}
				
				$("#editCriteria").attr("data-redirecturl",reportUrlWithAlarmId);
				$("#editCriteria").show();
			}else{
				$("#editCriteria").hide();
			}

		}else{
			applyContextSensitivity();
			var url = cvUtil.getContextPath() + "/reports/reports.jsp";
			var uId = cvUtil.getParameter("commUniId", 0);
			if(uId) {
				url = url + "?commUniId=" + uId + "&report=alarmsSettings";
			} else {
				url= url + "?report=alarmsSettings";
			}
			$(".ui-dialog-buttonpane.ui-widget-content.ui-helper-clearfix").append('<div style="float:left;margin: 10px 10px 0;"><a href="' + url + '" class="manageLink">Manage Alerts</a></div>');
		}

		function testCriteria(obj1, criteriaId){
			var alarmURL ="";
			var gridId = "";
			var reportName = "";
			var testCriteriaConditionString=[];
			if(obj1.action !== "EDIT"  || obj1.editCriteriaSet){
				var paramsObj ={};
				var errorsExist= "";
				var testCriteriaCondition="";
				gridId =  obj1.gridId;
				reportName = obj1.reportName;
				paramsObj.type = obj1.type;
				paramsObj.gridId = obj1.gridId;
				paramsObj.paramId = obj1.paramId;
				if (obj1.type == Alarms.TYPE_HEALTH) {
					obj1.errorsExist = false;
					var healthParamObj = getHealthAlarmParms(obj1, criteriaId);
					if(healthParamObj.errorsExist){
						return;
					}
					delete obj1.errorsExist;
					delete healthParamObj.errorsExist;
					$.each(healthParamObj, function(index, value){
						paramsObj[index] = value;
					});
					paramsObj.paramsTable = obj1.paramsTable;
					reportName = getValueForUniqId(commUniId, "name")+" - " +  cvUtil.cvLocalize("HealthAlert");
					alarmURL = alarmsUtil.makeAlarmURL(paramsObj);
					paramsObj.fromManage = true;
					paramsObj.alarmURL = alarmURL;
					gridId = "table_0";
					paramsObj.gridId = gridId;
					testCriteriaCondition=cvUtil.parseJSON(SurveyTemplates.makeAlarmConditionRow(paramsObj));
					var healthAlertCriteria = testCriteriaCondition[0];
					if(healthAlertCriteria.oper&&healthAlertCriteria.paramName){
						testCriteriaConditionString.push(
								healthAlertCriteria.paramName+ " value " + healthAlertCriteria.oper + healthAlertCriteria.paramStatus);
					}else if(healthAlertCriteria.oper && healthAlertCriteria.paramValue){
						testCriteriaConditionString.push(encodeURIComponent(
								healthAlertCriteria.template.replace('##val##',healthAlertCriteria.paramValue).replace('##op##',healthAlertCriteria.oper)));
					}else if(healthAlertCriteria.oper&&healthAlertCriteria.oper === ''){
						testCriteriaConditionString.push(encodeURIComponent(
								healthAlertCriteria.template+  healthAlertCriteria.oper + healthAlertCriteria.paramValue));
					}else{
						testCriteriaConditionString.push(encodeURIComponent(healthAlertCriteria.template.replace('##val##',healthAlertCriteria.paramValue)));
					}
				} else {
					var genParamObj = getGeneralAlarmPrams(obj1, errorsExist);
					if(genParamObj.errorsExist === true|| genParamObj.errorsExist === "true") {
						return;
					}
					$.each(genParamObj, function(index, value){
						paramsObj[index] = value;
					});
					alarmURL = alarmsUtil.makeAlarmURL(paramsObj);
					var editCriteriaSet =  obj1.editCriteriaSet;
					obj1.editCriteriaSet = false;
					obj1.fromManage = true;
					obj1.alarmURL = alarmURL;
					var dataTable = $('#' + gridId + CVTable.table).dataTable();
					var oSettings = dataTable.fnSettings();
					testCriteriaCondition = cvUtil.parseJSON(SurveyTemplates.makeAlarmConditionRow(obj1 , {"forDescription" : true, "oSettings" : oSettings}));
					var join = "";
					$.each(testCriteriaCondition,function(index, value){
						if(testCriteriaCondition.length>1 && ((testCriteriaCondition.length-1)!=index)){
							join = " "+value.join;
						}else{
							join= "";
						}
						testCriteriaConditionString.push(encodeURIComponent(value.filteredColumn)+ " value " + value.oper + encodeURIComponent(value.search)+ join);
					});
					obj1.editCriteriaSet = editCriteriaSet;
					if(!editCriteriaSet){
						obj1.fromManage = false;
					}
				}
			}else{
				alarmURL =obj1.alarmURL;
				reportName = obj1.reportName;
				gridId= cvUtil.getParameterByName("filteredTable-0",alarmURL,"table_0");
				var testCriteriaList = $('<div></div>').append(obj1.description).find('li');
				$.each(testCriteriaList,function(index, value){
						testCriteriaConditionString.push(encodeURIComponent($(value).text()));
				});
			}

			if (!window.location.origin) {
				window.location.origin = window.location.protocol + "//" + window.location.host;
			}
			var critStr = escape(JSON.stringify(testCriteriaConditionString));
			$('form[name="testAlertCriteria"] [name="testCriteria"]').val(critStr);
			$('form[name="testAlertCriteria"] [name="reportName"]').val(reportName);
			if(alarmURL.indexOf('reportsplus') !== -1){
				alarmURL = alarmURL.replace("reportViewer.jsp", "reportInclude.jsp");
				gridId = cvUtil.getParameterByName('componentName',alarmURL,'');
				alarmURL = alarmURL.replace('&exportType=csv&isAlarm=true','');
				alarmURL =  alarmURL+"&showComponents="+gridId+"&avoidClientScripts=true";
			}
			if(obj.type == Alarms.TYPE_HEALTH) {
				alarmURL += "&testCriteria=true";
			}

			$('form[name="testAlertCriteria"] [name="testurl"]').val(alarmURL);
			$('form[name="testAlertCriteria"] [name="gridId"]').val(gridId);
			$('form[name="testAlertCriteria"]').submit();
		}

		function addConditionRow(obj1, button){
			var html = SurveyTemplates.makeAlarmConditionRow(obj1);
			var addNewConditionRow = true;
			errorDiv = $("#alarmErr");
			errorDiv.hide();
			if(!obj1.editCriteriaSet)
			{
				addNewConditionRow = alarmsUtil.checkRowConditionsHasValidValue();
				if(!addNewConditionRow){
					return;
				}
			}

			$("#allOrAnySelect").prop('disabled', false);
			$("#allOrAnyDiv").removeClass('alarmAllOrAnyDivOpacity');

			if(!!button || obj1.editCriteriaSet) {
				$("#gen-alarmOpts").append(html);
				if(!obj1.editCriteriaSet){
					button.prev().show();
				}
				$("#gen-alarmOpts li").find("#removeCondition").removeClass("disabled");
				applyContextSensitivity($("#gen-alarmOpts .gen-alarm-row").last());
			} else {
				$("#gen-alarmOpts").empty().append(html);
			}
		}

		//==================================================Alarm Dialog Window Events=========================================================//
		$(document).off('click', ".addNewCondition");
		$(document).off('click', ".testCriteria");
		$(document).off('click', ".editCriteria");
		$(document).off('click', "#removeCondition");
		$(document).on('click', ".addNewCondition", function(){
			addConditionRow(obj, $(this));
		});
		$(document).on('click', ".testCriteria", function(){
			testCriteria(obj, $("input[name=configureBy]:checked").attr("data-criteria-id"));
		});

		$(document).on('click', ".editCriteria", function(){
			$("#alarmsDialog").dialog("close");
		});


		$('div[id=snmpCB],div[id=eventViewerCB],div[id=scomCB]').on("checkedState", function() {
			$(this).closest(".notificationType").find("#customiseSNMPTrap").show();
		}).on("unCheckedState", function() {
			var unChecked= true;
			$.each($('div[id=snmpCB],div[id=eventViewerCB],div[id=scomCB]'),function(index,value){
				if($(value).attr("data-state")=="checked"){
					unChecked =false;
				}
			});
			if(unChecked){
				$(this).closest(".notificationType").find("#customiseSNMPTrap").hide();
			}
		});


		$('div[id=emailAlertCB]').on("checkedState", function() {
			var notificationType = $(this).closest(".notificationType");
			$(notificationType).find("#emailDetails").show();
			$(notificationType).find("#customiseEmail").show();
		}).on("unCheckedState", function() {
			$(this).closest(".notificationType").find("#emailDetails").hide();
			var unChecked= true;
			$.each($('div[id=emailAlertCB],div[id=consoleAlertCB]'),function(index,value){
				if($(value).attr("data-state")=="checked"){
					unChecked =false;
				}
			});
			if(unChecked){
				$(this).closest(".notificationType").find("#customiseEmail").hide();
			}

		});

		$('div[id=consoleAlertCB]').on("checkedState", function() {
			$(this).closest(".notificationType").find("#customiseEmail").show();
		}).on("unCheckedState", function() {
			var unChecked= true;
			$.each($('div[id=emailAlertCB],div[id=consoleAlertCB]'),function(index,value){
				if($(value).attr("data-state")=="checked"){
					unChecked =false;
				}
			});
			if(unChecked){
				$(this).closest(".notificationType").find("#customiseEmail").hide();
			}
		});

		$("input[name=monthSelection]").click(function() {
			var monthSelection=$("input[name=monthSelection]:checked").val();
			$("#daySelectorInput select").prop('disabled', monthSelection=='dateSelector');
			$("#dateSpinner").prop("disabled", monthSelection!='dateSelector');
		});

		$("select#alarmFreqOptionSelect").on('change', '', function (e) {
			setFreqFieldVisibility();
		});

		$(document).on('click', "#removeCondition", function(){
			if($("#gen-alarmOpts li").length > 1) {
				$(this).closest("li").remove();
				if($("#gen-alarmOpts li").length == 1) {
					$("#removeCondition").addClass("disabled");
					$("#allOrAnyDiv").addClass('alarmAllOrAnyDivOpacity');
					$("#allOrAnySelect").prop('disabled', 'disabled');
				}
				$(".addNewCondition").show();
			}
		});

		$(document).on('click', "#noScheduleAvailable > span", function(){
			$("#noScheduleAvailable").hide();
			$("#alarmSchedule").show();
		});


		$(document).on("change", ".gen-columnSelect", function() {
			applyContextSensitivity($(this));
		});

		$(document).on("change", ".gen-opSelect", function() {
			inputFieldContextSensitivity($(this));
		});

		$(document).on("change", "input:radio[name=configureBy]",function(){
			var id = $(this).attr("id");
			if(id == "byStatus") {
				$("#opSelect").attr("disabled", "true");
				$("#thresholdValue").attr("disabled", "true");
				$("#thresholdValue").val("");
				$("#statusSelect").removeAttr("disabled");
			} else {
				$("#statusSelect").attr("disabled", "true");
				$("#opSelect").removeAttr("disabled");
				$("#thresholdValue").removeAttr("disabled");
			}
        	}
		);

		$( "#dateSpinner" ).bind('keyup input', function(event) {
			var freqOption = 	$("select#alarmFreqOptionSelect").val();
			alarmsUtil.validateField(alarmsUtil.getTimeFieldID(freqOption),freqOption,alarmsUtil.validateFreq);
		});

		$( "#dateSpinner" ).bind('keydown', function(evt) {
			var arrayExceptions = [8, 13, 16, 17, 18, 20, 27, 35, 36, 37,
			                       38, 39, 40, 45, 46, 144];
			if ((evt.which < 48 || evt.which > 57) &&
					(evt.which < 96 || evt.which > 106) && // NUMPAD
					$.inArray(evt.which, arrayExceptions) === -1) {
				return false;
			}
		});

		//==================================================Alarm Dialog Window Events END=========================================================//
	};


	//initAlarmDialog - create obj for editing alerts and caching the column details before opening up the dialog.
	Reports.initAlarmDialog = function(alarmDetails){
		if(alarmDetails.error){
			console.error("Unable to find alert details for alarmId ["+alarmDetails.alarmId+"], Error Message :" + alarmDetails.error);
			cvUtil.errorToast(alarmDetails.error);

		}else{
			var obj = {};
			obj.alarmURL =  decodeURIComponent(alarmDetails.alarmURL);
			obj.reportURL= alarmDetails.reportURL;
			obj.reportName = alarmDetails.report;
			obj.name = alarmDetails.name;
			obj.email = alarmDetails.email;
			obj.emailCc = alarmDetails.emailCc;
			obj.emailBcc = alarmDetails.emailBcc;
			obj.aid = alarmDetails.alarmId;
			obj.description = alarmDetails.description;
			obj.notificationTypes = alarmDetails.notificationTypes;
			obj.type = alarmDetails.type;
			obj.fromManage = true;
			obj.editCriteriaSet = true;
			obj.SNMPDescription =  alarmDetails.SNMPDescription;
			obj.alertSeverity  = alarmDetails.alertSeverity;
			obj.reportEnum = alarmDetails.reportEnum;
			obj.reportUniqId = alarmDetails.reportUniqId;
			obj.alertstatus = alarmDetails.status;
			obj.headerTemplate = alarmDetails.headerTemplate;
			obj.isTiledHealth = alarmDetails.isTileAlert;
			obj.tileID = alarmDetails.tileID;
			obj.paramValue = alarmDetails.paramValue;
			obj.alertCriteriaIdForTile = alarmDetails.alertCriteriaIdForTile;
			obj.operator = alarmDetails.operator;
			obj.manageLink = false;
			obj.gridId= cvUtil.getParameterByName("filteredTable-0",obj.alarmURL);
			obj.isOr = alarmDetails.isOr;
			$(document).one("ajaxStop",function() {
				var callConfigureAlarm = true;
				if(obj.type == Alarms.TYPE_GENERAL){
					var urlParams = cvUtil.getUrlParams();
					//Few reports has multi table and it might not be initialized on load, so before collecting the columnDetails, initializing once.
					if (urlParams.surveyId && $.isNumeric(urlParams.surveyId) && (urlParams.surveyId  == 1)) {
						var tableId = $('table#'+obj.gridId+CVTable.table);
						var tableHead = $('table#'+obj.gridId+CVTable.table+" thead");

						if(tableId.length == 0 || tableHead.length == 0){
							$("#"+ obj.gridId +" #"+obj.gridId+"_title_holder .arrowPlaceholder ").trigger('click');
							$(document).one("ajaxStop",function(){
								Reports.configureAlarm(obj);
							});
							callConfigureAlarm = false;
						}

					}else{
						var dataTable = $('#'+obj.gridId+CVTable.table).dataTable();
						var oSettings = dataTable.fnSettings();
						if(!oSettings || !oSettings.originalColumns){
							obj.editCriteriaSet = false;
						}
					}
					if(callConfigureAlarm){
						Reports.configureAlarm(obj);
					}
				}

	        });


		}
	}

	Reports.getAlarmDetails = function(param, callback){
		cvUtil.loadPageWithGET(cvUtil.getContextPath() + "/server/getAlarmDetails.do", param, function(data) {
			var alarmDetails = data[0];
			callback(alarmDetails);
		});
	}

	window.tpicker = $("#timeElement").cvTimepicker({change: function( event, data ) {
    	alarmsUtil.validateTime("#timeElement");
    }});
	window.tEUntilpicker = $("#timeElementUntil").cvTimepicker({change: function( event, data ) {
    	alarmsUtil.validateTime("#timeElementUntil");
    }});
	//==========================hide minute dropdown on scroll===========================================================//
	$(window ).scroll(function() {
		  $("#timeElement .ui-autocomplete").hide();
    	  $("#timeElementUntil .ui-autocomplete").hide();

	});
	//=========================End of hide event on minute dropdown on scroll===========================================================//
	$("#timeElement  .ui-autocomplete").addClass("alarm-minute-dropdown-position");
	$("#timeElementUntil  .ui-autocomplete").addClass("alarm-minute-dropdown-position");

	function inputFieldContextSensitivity(optionSelected){
		var selectedRow = optionSelected.closest(".gen-alarm-row");;
		if($(optionSelected).val()== 9 || $(optionSelected).val() == 10){
			selectedRow.find('input.gen-thresholdValue').val(' Not Applicable');
			selectedRow.find('input.gen-thresholdValue').prop('disabled', true);
		}else{
			selectedRow.find('input.gen-thresholdValue').val('');
			selectedRow.find('input.gen-thresholdValue').prop('disabled', false);
		}
	}
	function applyContextSensitivity(src) {
		var selected = "";
		var selectedRow = "";
		if(src) {
			selectedRow = src.closest(".gen-alarm-row");
			selected = selectedRow.find( ".gen-columnSelect option:selected" );
		} else {
			selectedRow = $(".gen-alarm-row");
			selected = $( ".gen-columnSelect option:selected" );
		}
		selectedRow.find(".gen-thresholdValue").removeClass("errorField");
		alarmsUtil.showHideOperators(selected, selectedRow,$("#alarmDialogOperators #alarmOpSelect"));
		inputFieldContextSensitivity(selectedRow.find( ".gen-opSelect option").filter(':visible:first'));
		alarmsUtil.showInputHints(selected, selectedRow);
	}
	//=============reset all the fields and populate with default value ========================
	function resetAll(obj) {
		var notificationsId = ".notesCB";
		var emailField = "#emailTo";
		var emailCcField = "#emailCc";
		var emailBccField = "#emailBcc";
		$("#alarmErr").hide();
		alarmsUtil.clearHighlight($("input[type=text]"));
		alarmsUtil.clearHighlight($("#noScheduleAvailable >span"));
		alarmsUtil.clearHighlight($("#repeatNHoursElements"));

		$("#timeElement .ui-autocomplete").hide();
		$("#timeElementUntil .ui-autocomplete").hide();

		var colList = [];
		if(obj.type == Alarms.TYPE_HEALTH) {
			var healthParam = Alarms.getHealthParams(obj);
			if(!obj.fromManage || obj.editCriteriaSet){
				var paramName = obj.paramName;
				$("#paramName").html(paramName);
				var thresholdName = healthParam.Threshold;
				if($.trim(thresholdName).length != 0) {
					if(thresholdName != "Information" && thresholdName != "Warning") {
						if(thresholdName.toString().indexOf("SLA") == 0) {
							thresholdName = thresholdName.substr(0, thresholdName.indexOf('-') - 1);
						}
						$("#thresholdName").html(thresholdName + "'s");
					}
				} else {
					$("#thresholdName").html("");
				}
				var valueEditable = healthParam.Editable == "Yes" ? true : false;
				if(!valueEditable) {
					$("#byValLi").hide();
					$("#byStatus").hide();
				} else {
					$("#byValLi").show();
					$("#byStatus").show();
				}

				// disable the value input fields on startup.
				$("#opSelect").attr("disabled", "true");
				$("#thresholdValue").attr("disabled", "true");
				$("#thresholdValue").val("");
				$("#alarmName").val("");

				// enable status by default.
				$("#byStatus").attr("checked", true);
				$("#statusSelect").removeAttr("disabled");

				if (obj.isTiledHealth) {
					$(".testCriteria").hide();
				}
			}
//		var html = SurveyTemplates.makeAlarmConditionRow(obj);
	        var html = "";
			//construct the criteria radio buttons
			if (obj.isTiledHealth && !obj.fromManage) {
				if (healthParam.criteria && healthParam.criteria.length > 0) {
					html = SurveyTemplates.constructConditionHTML(healthParam.criteria[0].criteriaValue, healthParam.criteria[0].criteriaId);
					$("#byValLi .opts-radios").html(html);

					for (var idx=1; idx < healthParam.criteria.length; idx++) {

						var liID = "alertOptLI_" + idx;
						var li = $("<li class='alertOptLI' id='" + liID + "'><div class='opts-radios' ></div></li>");
						html = SurveyTemplates.constructConditionHTML(healthParam.criteria[idx].criteriaValue, healthParam.criteria[idx].criteriaId);
						$("#" + liID + "  .opts-radios").html(html);
						$("#alarmOpts").append(li);
//						var input = $("<input type='radio' id='byBalue_" + idx + "'>");
//						var label = $("<label>" +  >");

//						$(liId + " div").append(input);

					}
				}

				if (obj.paramId == -1) {  //report level
					$("#sendNotifSelection").hide();
					$(".testCriteria").hide();
					$("#byValLi").hide();
				}
			} else {
				html = SurveyTemplates.constructConditionHTML(healthParam.DescriptionText);
				$("#byValLi .opts-radios").html(html);
//				return SurveyTemplates.constructConditionHTML(healthParamObj.DescriptionText);
			}

		}else if(obj.type == Alarms.TYPE_GENERAL){
			if(obj.fromManage && !obj.editCriteriaSet){
				var alarmURL = obj.alarmURL;
				var tableName = cvUtil.getParameterByName("filteredTable-0", alarmURL);
				var count = 0;
				while(true){
					var colName = cvUtil.getParameterByName(tableName+"-tableColumns-"+count++ , alarmURL,null);
					if(colName ==null || $.isEmptyObject(colName)){
						break;
					}
					 colList.push(colName);
				}
			}else{
				var gridId = obj.gridId;
				// get columns list
				var dataTable = $('#'+gridId+CVTable.table).dataTable();
				var oSettings = dataTable.fnSettings();
				if(!oSettings.originalColumns) {
					oSettings.originalColumns = oSettings.aoColumns;
				}
				obj.originalColumns = oSettings.originalColumns;
				var html = SurveyTemplates.makeAlarmConditionRow(obj);
				$("#gen-alarmOpts").empty().append(html);
				$.each($("#gen-alarmOpts").find("#paramsDiv .gen-columnSelect option"), function(index,value){
					colList.push(value.text);
				});
				$("#allOrAnyDiv").addClass("alarmAllOrAnyDivOpacity");
			}
		}
		var defaultSNMPText = alarmsUtil.getDefaultSNMPText(obj.type, colList);
		$("#customiseEmail").find("#emailBody").val(cvUtil.cvLocalize('Custom_Email_Header_Text'));
		$("#customiseEmail").hide();
		$("#customiseSNMPTrap").find("#customSNMPTrap").val(defaultSNMPText);
		$("div #customiseSNMPTrap").hide();
		$("div .notificationType #emailDetails").hide();
		if(reportsUtil.validateEmail($(emailField).val()).error) {
			$(emailField).val("");
		}

		if(reportsUtil.validateEmail($(emailCcField).val()).error) {
			$(emailCcField).val("");
		}

		if(reportsUtil.validateEmail($(emailBccField).val()).error) {
			$(emailBccField).val("");
		}
		$(notificationsId).each(function(){
			unCheckCb($(this));
		});
		resetSchedule();
	}
	//===============================reset function ends here============================================

	//===============================reset function For Schedules============================================
	function resetSchedule(){
		setTime("#timeValue",Alarms.DEFAULT_SCHEDULE_TIME);// Convert to seconds-from-midnight:
		$("#alarmFreqOptionSelect").val("DAILY");
		setFreqFieldVisibility("DAILY");
		repeatEverySelection();
		$("#timezone option[value='" + defaultTimeZoneId + "']").prop('selected', 'selected');
		reportsUtil.enableDisableRepeatEveryElements("#freqDetails");
		var weekDays=$("#daysToRunList div.dayToRun");
		$("#daysToRunList div.dayToRun").each(function( key, value ) {
			   unCheckCb($(value));
		});
		$("input[name=monthSelection][value=dateSelector]").attr('checked', false);
		$("#dateSpinner").val("");
		$("#dateSpinner").prop("disabled", true);
		$("input[name=monthSelection][value=daySelector]").attr('checked', 'checked');
		$("#daySelectorInput [name=weekOfMonth]").val("First");
		$("#daySelectorInput [name=dayOfWeek]").val("Weekday");
	}

	//===============================reset function ends here============================================

	//================================build request params from DOM elemets================================
	function buildParamsAndSave(obj, criteriaId) {
		var paramsObj = {};
		paramsObj.gridId = obj.gridId;
		paramsObj.type = obj.type;
		paramsObj.severity = $("#alertSeveritySelect option:selected").val();
		paramsObj.action = obj.action? obj.action:"CREATE";
		paramsObj.type = obj.type ;
		paramsObj.paramId = obj.paramId;
		paramsObj.activeStartTime = getTime(0,"#timeValue");

		paramsObj.freqType = $("select#alarmFreqOptionSelect").val();
		paramsObj.timezone = $("#timezone").val();
		paramsObj = populateBuildParamFreqField(paramsObj);
		paramsObj.alertStatus = obj.alertstatus;
		paramsObj.alarmName = encodeURIComponent($("#alarmName").val());
		paramsObj.isOr =  obj.isOr;

		var notificationsSelected = [];
		var errorsExist = false;
		var email="";
		var emailCc="";
		var emailBcc="";
		var emailHeader="";
		var isEmailRecipientsError = false;
		var isEmailCcRecipientsError = false;
		var isEmailBccRecipientsError = false;

		if($(".notesCB").length>0){
			$(".notesCB").each(function() {
				var isChecked = $(this).attr("data-state") == "checked";
				if (isChecked) {
					notificationsSelected.push($(this).data("value"));
				}
			});
			if($.inArray("EMAIL", notificationsSelected) > -1) {
				email = $.trim($("#emailTo").val());
				emailCc = $.trim($("#emailCc").val());
				emailBcc = $.trim($("#emailBcc").val());
			}
			paramsObj.email = email;
			paramsObj.emailCc = emailCc;
			paramsObj.emailBcc = emailBcc;

		}else{
			email = $.trim($("#emailTo").val());
			emailCc = $.trim($("#emailCc").val());
			emailBcc = $.trim($("#emailBcc").val())

			if ($.trim(email).length > 0) {
				notificationsSelected.push("EMAIL");
			}

		}
		paramsObj.notificationsSelected = notificationsSelected;
		if(($.inArray('EMAIL', paramsObj.notificationsSelected) > -1) || ($.inArray('LIVEFEEDS', paramsObj.notificationsSelected) > -1)){
			emailHeader=$("#customiseEmail").find("#emailBody").val();
			paramsObj.emailHeader = emailHeader;
		}

		if(notificationsSelected.length > 0) {
			var errorMessage = '';
			if($.inArray("EMAIL", notificationsSelected) > -1) {
				var retval = reportsUtil.validateEmail(email);
				if(retval.error) {
					errorMessage = retval.errorMsg;
					isEmailRecipientsError = true;
				}
				if(emailCc){
					var retvalCc = reportsUtil.validateEmail(emailCc);
					if(retvalCc.error) {
						errorMessage = retvalCc.errorMsg;
						isEmailCcRecipientsError = true;
					}
				}
				if(emailBcc){
					var retvalBcc = reportsUtil.validateEmail(emailBcc);
					if(retvalBcc.error) {
						errorMessage = retvalBcc.errorMsg;
						isEmailBccRecipientsError = true;
					}
				}

			}
			paramsObj.email = email;
			paramsObj.emailCc = emailCc;
			paramsObj.emailBcc = emailBcc;
			$.each(notificationsSelected,function(index, value){
				if(value == "SNMP" || value == "APPLOG" || value == "SCOM")
				{
					paramsObj.templateDescriptionSNMP = $('textarea#customSNMPTrap').filter(":visible").val().replace(/</gi, "##lt;").replace(/>/gi,"##gt;");
				}
		});
		}else {
			//when none of the notification option is selected, by default emailRecipientsError should be set to true.
			isEmailRecipientsError = true;

			if($(".notificationType").is(":visible")) {
				errorMessage = cvUtil.cvLocalize("alert.check.Email_ID_check");
			} else {
				errorMessage = cvUtil.cvLocalize("alert.check.Email_ID_empty");
			}

		}

		if(!errorsExist && !alarmsUtil.validateField("#alarmName", paramsObj.alarmName, alarmsUtil.validateAlertName)) {
			errorsExist = true;
		}

		//verify row conditions is not empty.
		if(!errorsExist && !alarmsUtil.checkRowConditionsHasValidValue()){
			errorsExist = true;
		}


		if(obj.action == "EDIT"){
			paramsObj.reportName = $.isEmptyObject(obj.reportName)?  cvUtil.cvLocalize("HealthAlert") : obj.reportName;
			//paramsObj.description = obj.description;
			paramsObj.reportURL = encodeURI(obj.reportURL);
			paramsObj.alarmURL = encodeURIComponent(obj.alarmURL);
			paramsObj.reportEnum = obj.reportEnum;
			paramsObj.reportUniqId = obj.reportUniqId;
			paramsObj.commUniId = obj.commUniId;
			paramsObj.templateId = obj.templateId;
			paramsObj.ccGroupId = obj.ccGroupId;
			paramsObj.companyId = obj.companyId;
			paramsObj.alarmId = obj.aid;
			paramsObj.scheduleTaskID = $("#alarmSchedule").data("scheduletaskid");
			if (obj.isTiledHealth) {
				paramsObj.isTileAlert = true;
				paramsObj.paramValue = obj.paramValue;
				paramsObj.alertCriteriaIdForTile =  obj.alertCriteriaIdForTile;
				paramsObj.tileID = obj.tileID;
				paramsObj.operator = obj.operator;
			}
		}
		if(obj.action != "EDIT" || obj.editCriteriaSet){
			paramsObj.editCriteriaSet = obj.editCriteriaSet;
			if (obj.type == Alarms.TYPE_HEALTH) {
				var healthParamObj = getHealthAlarmParms(obj, criteriaId);
				errorsExist = healthParamObj.errorsExist;
				delete obj.errorsExist;
				delete healthParamObj.errorsExist;
				$.each(healthParamObj, function(index, value){
					paramsObj[index] = value;
				});

				if (healthParamObj.tileID === -1) { //health report level alarm
					if (healthParamObj.status == "critical") {
						paramsObj.severity = "CRITICAL";
					} else if (healthParamObj.status == "warning") {
						paramsObj.severity = "WARNING";
					} if (healthParamObj.status == "good") {
						paramsObj.severity = "INFORMATION";
					}
				}

			} else {
				var genParamObj = getGeneralAlarmPrams(obj, errorsExist);
				//if errors from AlarmParams
				if(genParamObj.errorsExist === true|| genParamObj.errorsExist === "true") {
					return;
				}
				$.each(genParamObj, function(index, value){
					paramsObj[index] = value;
				});
			}
		}

		if(!errorsExist && isEmailRecipientsError && !alarmsUtil.markField("#emailTo", errorMessage)) {
			errorsExist = true;
		}else if(!isEmailRecipientsError){
			alarmsUtil.markField("#emailTo", '');
			if(!errorsExist && isEmailCcRecipientsError && !alarmsUtil.markField("#emailCc", errorMessage)) {
				errorsExist = true;
			}else if(!isEmailCcRecipientsError){
				alarmsUtil.markField("#emailCc", '');
				if(!errorsExist && isEmailBccRecipientsError && !alarmsUtil.markField("#emailBcc", errorMessage)) {
					errorsExist = true;
				}

			}
		}

		if(!errorsExist &&  !$("#alarmSchedule").is(":visible")){
			alarmsUtil.markField("#noScheduleAvailable >span", cvUtil.cvLocalize("add_Schedule_Error_Message"));
			errorsExist = true;
		}
		var freqOption = 	$("select#alarmFreqOptionSelect").val();
		if(!errorsExist && !(alarmsUtil.validateTime("#timeElement")
							   && alarmsUtil.validateField(alarmsUtil.getTimeFieldID(freqOption),freqOption,alarmsUtil.validateFreq) && alarmsUtil.validateTime("#timeElementUntil") && reportsUtil.validateRepeatNHours("select#alarmFreqOptionSelect", true))) {
			errorsExist = true;
		}

		if(errorsExist) {
			return;
		}
		$("#alarmsDialog").dialog("close");

		if(paramsObj.type != Alarms.TYPE_HEALTH && paramsObj.type != Alarms.TYPE_GENERAL){
			cvUtil.errorToast("Invalid Alert Save Request");
		}
		var urlParamsObj = alarmsUtil.makeAlarmRequest(paramsObj);

		if(obj.editCriteriaSet){
			var urlParameters = window.location.search;
			urlParameters = urlParameters.replace("&alarmId=" + obj.aid, "").replace("alarmId=" + obj.aid, "");
			history.replaceState(null, document.title, urlParameters);
		}


		alarmsUtil.submitRequest(urlParamsObj,  alarmsUtil.alarmCreationSuccFn, alarmsUtil.alarmCreationErrFn);
	}
	function getHealthAlarmParms(obj, criteriaId){
		var healthParamObj = {};
		var errorsExist =obj.errorsExist;
		var byStatus = $("input:radio[name=configureBy]:checked").val() == 'byStatus' ? true : false;
		healthParamObj.paramName = obj.paramName;
		healthParamObj.byStatus = byStatus;
		healthParamObj.reportName =  cvUtil.cvLocalize("HealthAlert");
		if (byStatus) {
			var status = $("#statusSelect option:selected").val();
			healthParamObj.status = status;
			if (obj.isTiledHealth) {
				healthParamObj.paramValue = status;
				healthParamObj.operator = 2;
			}
		} else {
			var operator = $("#opSelect option:selected").val();
			var paramValue = $("#thresholdValue").val();
			healthParamObj.value = paramValue;
			healthParamObj.inputVal = paramValue;
			healthParamObj.operator = operator;
			var healthParam = Alarms.getHealthParams(obj, criteriaId);
			healthParamObj.description = healthParam.DescriptionText;
			if (obj.isTiledHealth) {
				healthParamObj.paramValue = paramValue;
				healthParamObj.alertCriteriaIdForTile = healthParam.criteriaId;
			}

			// should validate if the paramValue is non-empty and numeric value.
			// this is the only validation for health reports.

			if(!errorsExist && !alarmsUtil.validateField("#thresholdValue", paramValue, alarmsUtil.isNumeric)) {
				errorsExist = true;
			}
		}

		if (obj.isTiledHealth) {
			healthParamObj.isTileAlert = true;
			healthParamObj.tileID = obj.paramId;
		}

		healthParamObj.errorsExist = errorsExist;
		return healthParamObj;
	}
	function getGeneralAlarmPrams(obj, errorsExist){
		var genParamObj = {};
		var isOr = $("#allOrAnySelect option:selected").val();
		obj.isOr = isOr;
		genParamObj.reportName = obj.reportName;
		var conditionObj = {};
		conditionObj.columnList = [];
		conditionObj.isOr = isOr;

		$(".gen-alarm-row").each(function(index, value) {
			var colObj = {};
			var operator = $(this).find("#gen-opSelect option:selected").val();
			var field = $(this).find(".gen-thresholdValue");
			var paramValue = field.val();
			var selectedCol = $(this).find(".gen-columnSelect option:selected");
			var renderer = selectedCol.data("renderer");
			paramValue = $.trim(paramValue);
			colObj.inputVal = paramValue;
			if (!!renderer && !!paramValue) {
				paramValue = alarmsUtil.getRawValueForRenderer(colObj.inputVal, renderer);
				if(!!renderer && $.inArray(renderer,Alarms.dateRenderer) != -1){
					if (Reports.unformatRelativeDate(colObj.inputVal) != null) {
						colObj.rel = 1;
					}
				}
			}
			var name = selectedCol.val();
			colObj.index = selectedCol.data("index");
			colObj.type = selectedCol.data("sqltype");
			colObj.dataType = selectedCol.data("sqltype");
			colObj.title = name;
			colObj.name = name;
			colObj.mDataProp = $.grep(obj.originalColumns, function(ele, i) {
				if(name == $("<div>").html($.trim(ele.sTitle)).text()) {
					return ele.mDataProp;
				}
			})[0].mDataProp;
			colObj.value = paramValue;
			colObj.operator = operator;
			colObj.renderer = renderer;
			colObj.visible = "true";

			if(!errorsExist && !alarmsUtil.validateField(field, colObj, alarmsUtil.validateVal)) {
				errorsExist = true;
			}

			conditionObj.columnList.push(colObj);
		});

		var i = 0,
		j = 0;
		for (i = 0; i < obj.originalColumns.length; i++) {
			var origCol = obj.originalColumns[i];
			var included = false;
			for (j = 0; j < conditionObj.columnList.length; j++) {
				var sCol = conditionObj.columnList[j];
				if (i == sCol.index) {
					included = true;
					break;
				}
			}
			if (!included) {
				var colObj = {};
				colObj.index = i;
				colObj.name = origCol.sTitle;
				colObj.mDataProp = origCol.mDataProp;
				colObj.value = null;
				colObj.operator = null;
				colObj.visible = origCol.bVisible;
				colObj.renderer = origCol.rendererType;
				colObj.type = origCol.sqlType;
				colObj.dataType = origCol.sqlType;
				colObj.title = origCol.sTitle;;
				conditionObj.columnList.push(colObj);
			}
		}
		genParamObj.condition = conditionObj;
		genParamObj.errorsExist = errorsExist;
		return genParamObj;

	}
	function setTime(fieldId, time){
		if(!fieldId) {
			return;
		}
		var ast = 0;
		if(!time && time !=0){
			ast = $(fieldId).val();// internal numeric value
		}else{
			ast = time;
			$(fieldId).val(""+ast);
		}

		if(fieldId == "#timeValue"){
			window.tpicker.cvTimepicker('setTime', Math.floor(ast / 3600), ((ast / 60) % 60));
		}else if(fieldId == "#activeEndTime"){
			window.tEUntilpicker.cvTimepicker('setTime', Math.floor(ast / 3600), ((ast / 60) % 60));
		}

	}

	function getTime(alarmId, fieldId){
		if(!alarmId && fieldId){
			var object;
			if(fieldId == "#timeValue"){
				object = window.tpicker;
			}else if(fieldId == "#activeEndTime"){
				object = window.tEUntilpicker;
			}
			if(object){
				var hour = object.cvTimepicker('getHour');
				var min = object.cvTimepicker('getMinute');
				console.debug("Parsed time: hours=" + hour + ", minutes=" + min);
				var activeTime = hour * 3600 + min * 60;
				$(fieldId).val("" + activeTime); // Convert to seconds-from-midnight:
				return activeTime;
			}
		}else{
			var param = {};
			param.alarmId = alarmId;
			alarmsUtil.submitGetScheduleRequest(param, populateAlarmDialogFreqField);
		}
	}
	function setFreqFieldVisibility(freq) {
		if(!freq){
			freq = $("#alarmFreqOptionSelect").val();
		}
		$("#repeatNHoursElements").hide();
		$("#monthlyElements").hide();
		$("#weeklyElements").hide();
		if (freq.toUpperCase()  === "WEEKLY") {
			$("#weeklyElements").show();
		}else if (freq.toUpperCase()  === "MONTHLY") {
			var monthSelection=$("input[name=monthSelection]:checked").val();
			$("#monthlyElements").show();
		}else if (freq === "DAILY") {
			$("#repeatNHoursElements").show();
		}
		console.debug("Frequency value: " + freq);

		$("#daySelectorInput select").prop('disabled', monthSelection!='daySelector');
		$("#dateSpinner").prop("disabled", monthSelection!='dateSelector');
	}

	function populateBuildParamFreqField(paramsObj){
		var freq = paramsObj.freqType;
		if(freq.toUpperCase() == 'DAILY'){
			if(isChecked($("div[name=repeatEveryNHours]"))){
				paramsObj.activeEndTime = getTime(0,"#activeEndTime");
				paramsObj.everyNHoursSpinner = $("#everyNHoursSpinner").val();
				paramsObj.everyNMinsSpinner = $("#everyNMinsSpinner").val();
			}
		}else if(freq.toUpperCase() == 'WEEKLY'){
			var weekDays=[];
			$("#daysToRunList .dayToRun").each(function() {
				var isChecked = $(this).attr("data-state") == "checked";
				if (isChecked){
					weekDays.push($(this).attr('name'));
				}
			});
			paramsObj.weekDays = weekDays;
		}else if(freq.toUpperCase() == 'MONTHLY'){
			var monthSelection=$("input[name=monthSelection]:checked").val();
			if(monthSelection=='dateSelector'){
				var dayOfMonth = $('#monthlyElements #dateSpinner').val();
				paramsObj.dayOfMonth = dayOfMonth;
			}else{
				 var weekOfMonth = $('#monthlyElements #weekOfMonth').val();
				 var dayOfWeek = $('#monthlyElements #dayOfWeek').val();
				 paramsObj.weekOfMonth = weekOfMonth;
				 paramsObj.dayOfWeek = dayOfWeek;
			}
		}
		return paramsObj
	}

	function populateAlarmDialogFreqField(scheduleData){
		$("#loadingSchedule").hide();
		$("#dialogbutton-save").attr("disabled", false);
		$("#dialogbutton-save").removeClass("disabled");
		if(scheduleData == undefined || scheduleData == null) {
			$("#noScheduleAvailable").show();
		}else{
			var freq = scheduleData.freqType;
			$("#alarmSchedule").show();
			$("#alarmFreqOptionSelect").val(freq);
			$("#alarmSchedule").data("scheduletaskid",scheduleData.taskId);
			setTime("#timeValue",scheduleData.activeStartTime);
			if (scheduleData.timezone) {
				        $("#timezone option[value='" + scheduleData.timezone + "']").prop('selected', 'selected');
			} else {
				        $("#timezone option[value='" + defaulttimezone + "']").prop('selected', 'selected');
			}

			if(freq.toUpperCase() == 'DAILY'){
				repeatEverySelection(scheduleData);

			}else if(freq.toUpperCase() == 'WEEKLY'){
				var weekDays=$("#daysToRunList div.dayToRun");
				$.each( scheduleData.daysToRun, function( key, value ) {
					if (value){
						//$(weekDays[key]).attr("data-state","checked");
						//$(weekDays[key]).addClass("checked");
						checkCb($(weekDays[key]));
					}
				});

			}else if(freq.toUpperCase() == 'MONTHLY'){
				var weekOfMonth = scheduleData.weekOfMonth;
				var dayOfWeek = scheduleData.dayOfWeek;
				var dateOfMonth = scheduleData.dateOfMonth;
				$("input[name=monthSelection]").prop("checked",false);
				$('#monthlyElements #dateSpinner').val("");
				$('#monthlyElements #weekOfMonth').val("First");
				$('#monthlyElements #dayOfWeek').val("Weekday");
				if(dateOfMonth){
					$("input[name=monthSelection][value=dateSelector]").attr('checked', 'checked');
					$('#monthlyElements #dateSpinner').val(dateOfMonth);
				}else if(dayOfWeek){
					$("input[name=monthSelection][value=daySelector]").attr('checked', 'checked');
					$('#monthlyElements #weekOfMonth').val(weekOfMonth);
					$('#monthlyElements #dayOfWeek').val(dayOfWeek);
				}
			}
		}
		setFreqFieldVisibility(freq);
		reportsUtil.enableDisableRepeatEveryElements("#freqDetails");
		return
	}

	function repeatEverySelection (scheduleData){
			var form = $("#freqDetails");

			var enableRepeatEverySection = false;
			if(!scheduleData){
				scheduleData = {};
			}
			if (scheduleData.activeEndTimeNHours && scheduleData.activeEndTimeNHours > 0) {
				setTime("#activeEndTime",scheduleData.activeEndTimeNHours);
				enableRepeatEverySection = true;
			} else if(scheduleData.activeEndTime && scheduleData.activeEndTime > 0){
				setTime("#activeEndTime",scheduleData.activeEndTime);
			} else {
				setTime("#activeEndTime",Alarms.DEFAULT_SCHEDULE_END_TIME);// Convert to seconds-from-midnight:

			}

			if (scheduleData.repeatNHoursInterval && scheduleData.repeatNHoursInterval > 0) {
				$("#everyNHoursSpinner").val(Math.floor(scheduleData.repeatNHoursInterval / 3600));
				$("#everyNMinsSpinner").val((scheduleData.repeatNHoursInterval / 60) % 60);
			} else {
				enableRepeatEverySection = false;
				$("#everyNHoursSpinner").val(8);//default value as 8 hours
				$("#everyNMinsSpinner").val(0);///default value as 0 mins
			}
			if (enableRepeatEverySection) {
				form.find("div[name=repeatEveryNHours]").removeClass('unchecked').addClass('checked').attr("data-state",
						"checked");
			} else {
				form.find("div[name=repeatEveryNHours]").removeClass('checked').addClass('unchecked').attr("data-state",
						"unchecked");

			}
	}


	$("#everyNHoursSpinner, #everyNMinsSpinner").bind('keyup input', function(event) {
		reportsUtil.validateRepeatNHours("select#alarmFreqOptionSelect");
	});

	$(".repeatEveryNHours").bind('checkedState unCheckedState', function() {
		reportsUtil.enableDisableRepeatEveryElements("#freqDetails");
	});
//========================================AlarmsUtil Functions===============================================================//
	//==========================================================================================================//
	var alarmsUtil = {};
	alarmsUtil.getDefaultSNMPText = function(alarmtype, columnNameList) {
		if(alarmtype  == Alarms.TYPE_GENERAL){
			var defaultSNMPText = cvUtil.cvLocalize('General_Alarms_SNMP_DefaultText');
			$.each(columnNameList, function(index,value){
					defaultSNMPText+= ", " + value +" : $" + value+"$ ";
			});

			return defaultSNMPText;
		}else if(alarmtype  == Alarms.TYPE_HEALTH){
			return 	cvUtil.cvLocalize('Health_Alarms_SNMP_DefaultText');
		}

	};

	alarmsUtil.getRawValueForRenderer =  function(val, renderer) {
		val = $.trim(val).toLowerCase();
		var fn = undefined;
		if(!!Reports.Renderers[renderer] && Reports.Renderers[renderer].length == 4) {
			fn = Reports.Renderers[renderer](null, null, null, {unformat: true});
		}
		if(!!fn) {
			return fn.call(this, val);
		} else {
			return val;
		}

		return val;
	}
	alarmsUtil.showInputHints = function(selected, selectedRow) {
		var renderer = $(selected).data("renderer");

		if(!!Reports.Renderers[renderer]
			&& Reports.Renderers[renderer].length == 4
			&& $.isFunction(Reports.Renderers[renderer](null, null, null, {validateVals : true}))) {
			var validateVals = Reports.Renderers[renderer](null, null, null, {validateVals : true}).call(this);
			var hint = validateVals.hint;
			if(selectedRow){
				var thrValElem = selectedRow.find(".gen-thresholdValue");
				thrValElem.attr("placeholder", hint);
				thrValElem.attr("title", hint);
			}
		} else {
			if(selectedRow){
				var thrValElem = selectedRow.find(".gen-thresholdValue");
				thrValElem.removeAttr("placeholder");
				thrValElem.removeAttr("title");
			}
		}
	}
	alarmsUtil.showHideOperators  = function(selected, selectedRow, operators) {
		var lessThanOpt = $(operators).find(".lessThan").clone();
		var moreThanOpt = $(operators).find(".moreThan").clone();
		var equalOpt 	= $(operators).find(".equals").clone();
		var containsOpt = $(operators).find(".contains").clone();
		var inLast 		= $(operators).find(".inLast").clone();
		var beyondLast  = $(operators).find(".beyondLast").clone();
		var inNext 		= $(operators).find(".inNext").clone();
		var beyondNext  = $(operators).find(".beyondNext").clone();
		var notequalto 	= $(operators).find(".notequals").clone();
		var isEmpty 	= $(operators).find(".isEmpty").clone();
		var notEmpty 	= $(operators).find(".notEmpty").clone();
		var notContainsOpt = $(operators).find(".notContains").clone();

		var optSelect = $("#gen-opSelect", selectedRow);
		optSelect.empty();
		var sqltype = $(selected).data("sqltype");
		var sType = $(selected).data("stype");
		var renderer = $(selected).data("renderer");
		if(!!renderer && $.inArray(renderer,Alarms.dateRenderer) != -1) {
			optSelect.append(inLast);
			optSelect.append(beyondLast);
			optSelect.append(inNext);
			optSelect.append(beyondNext);
		} else if(renderer == "HEALTH_STATUS" || renderer == "statusRenderer" ) {
			optSelect.append(equalOpt);
			optSelect.append(notequalto);
		} else {
			if(Alarms.isCustomReport) {
				optSelect.append(equalOpt);
				optSelect.append(notequalto);
				if(sType == "numeric") {
					optSelect.append(lessThanOpt);
					optSelect.append(moreThanOpt);
				} else {
					optSelect.append(containsOpt);
					optSelect.append(notContainsOpt);
					optSelect.append(isEmpty);
					optSelect.append(notEmpty);
				}
			} else {
				optSelect.append(equalOpt);
				optSelect.append(notequalto);
				if($.inArray(sqltype,Alarms.stringSqlType) != -1) {
					optSelect.append(containsOpt);
					optSelect.append(notContainsOpt);
					optSelect.append(isEmpty);
					optSelect.append(notEmpty);
				} else {
					optSelect.append(lessThanOpt);
					optSelect.append(moreThanOpt);
				}
			}
		}
		selectedRow.find( ".gen-opSelect option").filter(':visible:first').attr("selected","selected");
	}

	alarmsUtil.fnGetSearchString = function(columnList, isOr)
	{
		var searchString = "";
		var conditions = {};
		for ( var iColumn=0;  iColumn < columnList.length  ; iColumn++ )
		{
			var oCol = columnList[iColumn];
			if(oCol.visible) {
				var operator = '';
				if(typeof oCol.operator != 'undefined' && oCol.operator != null) {
					if(oCol.operator == 0) {
						operator = '<';
					} else if(oCol.operator == 1) {
						operator = '>';
					} else if(oCol.operator == 2) {
						operator = '=';
					} else if(oCol.operator == 3) {
						operator = ''; 		//contains
					} else if(oCol.operator == 4) {
						operator = 'inLast';
					} else if(oCol.operator == 5) {
						operator = 'beyondLast';
					} else if(oCol.operator == 6) {
						operator = 'inNext';
					} else if(oCol.operator == 7) {
						operator = 'beyondNext';
					}else if(oCol.operator == 8) {
						operator = '<>';
					}else if(oCol.operator == 9) {
						operator = 'isempty';
					}else if(oCol.operator == 10) {
						operator = 'notempty';
					}else if(oCol.operator == 11) {
						operator = 'notlike';
					}
				}

				if(typeof oCol.inputVal != 'undefined' && oCol.inputVal != null) {
					var search = oCol.inputVal;

					if(oCol.type == "int" || oCol.type == "decimal") {
					}
					if(typeof conditions[oCol.mDataProp] == 'undefined') {
						conditions[oCol.mDataProp] = operator + search;
					} else {
						var token = "AND";
						if(Alarms.isCustomReport) {
							token = "&&";
						}
						if(isOr == "true" || isOr == true) {
							if(Alarms.isCustomReport) {
								token = "||";
							} else {
								token = "OR";
							}
						}
						conditions[oCol.mDataProp] = conditions[oCol.mDataProp] + (" " + token + " ") + operator + search;
					}

				} else {
					conditions[oCol.mDataProp] = "";
				}

			}
		}
		$.each(conditions, function(k, v) {
			if(Alarms.isCustomReport) {
				searchString = searchString + k + '-LIKE-' + v + ';';
				//searchString = searchString + k + '[{,}]' + v + ';';
			} else {
				searchString = searchString + k + '-LIKE-' + v + ';';
			}
		});
		return searchString;
	}

	alarmsUtil.validateAlertName =  function(name) {
		var errorMessage = '';
		name = $.trim(name);
		if(!name.length) {
			errorMessage = cvUtil.cvLocalize("Alert_Name_Is_Empty");//"Name cannot be empty"
		}
		return errorMessage;
	}

	alarmsUtil.validateVal =  function(col) {
		var errorMessage = '';
		var inputVal = $.trim(col.inputVal);
		if($("<p>").html(inputVal).text() != inputVal) {
			errorMessage = cvUtil.cvLocalize("HTML_Tags_ErrorMessage");// 'Value should not contain HTML tags';
		} else {
			var validationObj = undefined;
			if(typeof col.renderer != 'undefined' && col.renderer != "") {
				if(!!Reports.Renderers[col.renderer] && Reports.Renderers[col.renderer].length==4) {
					if($.isFunction(Reports.Renderers[col.renderer](null, null, null, {validateVals : true}))) {
						validationObj = Reports.Renderers[col.renderer](null, null, null, {validateVals : true}).call(this);
					}
				} else {
					if(col.dataType.toLowerCase()=="decimal" || col.dataType.toLowerCase()=="long" || col.dataType.toLowerCase()=="integer"){
						validationObj = { pattern : /^-?(\d*.\d*)/, desc: "integer"};
					}else{
						validationObj = { pattern : /[^\s]+/, desc: "text"};
					}
				}
			}
			var validationResult = Reports.validateValue(inputVal, validationObj, col.type);
			if(!validationResult.status) {
				errorMessage = cvUtil.cvLocalize("Field_Validation_ErrorMessage",validationResult.desc);// 'Please enter ' + validationResult.desc +  ' value';
			}
		}
		return errorMessage;
	}

	alarmsUtil.validateTime =  function (fieldId){
		//var fieldId="#timeElement";
		var object;
		if(fieldId == "#timeElement"){
			object = window.tpicker;
		}else if(fieldId == "#timeElementUntil"){
			object = window.tEUntilpicker;
		}
		if(!object){
			return true;
		}
		var isValid = object.cvTimepicker('isValid');
		if(!isValid){
			$(fieldId).find(".minuteDD").addClass("errorField");
			$(fieldId+" select").addClass("errorField")
			 alarmsUtil.markField(fieldId, "Invalid Time");
			 $(fieldId).find(".minuteDD").focus();
			 return false;
		}
		$(fieldId).find(".minuteDD").removeClass("errorField");
		$(fieldId+" select").removeClass("errorField")
		$("#alarmErr").text("").hide();
		return markField(fieldId, "");
	}
	alarmsUtil.validateFreq = function (freqOption){
		var errorMsg="";
		if(freqOption === 'MONTHLY'){
			errorMsg = alarmsUtil.validateDateSpinner();
		}else if(freqOption ==='WEEKLY'){
			errorMsg = alarmsUtil.validateWeek();
		}
		return errorMsg;
	}

	alarmsUtil.validateDateSpinner =  function (){
	    var monthSelection=$("input[name=monthSelection]:checked").val();
	    if(monthSelection!='dateSelector') {
			return "";
		}
	    var dayOfMonth = $("#dateSpinner").val();
	    if(dayOfMonth== undefined || dayOfMonth.trim().length == 0){
	            return  cvUtil.cvLocalize("Day_Of_Month_Required"); //"Day of month is required";
	    }
	    if(isNaN(dayOfMonth) || dayOfMonth>31 || dayOfMonth<1) {
			return cvUtil.cvLocalize("Invalid_DATE");
		}
	    return "";
	}
	alarmsUtil.validateWeek =  function (){
		var errorMsg = cvUtil.cvLocalize("Please_Select_At_Least_One_Day");  //"Please select at least one day";
	    $("#daysToRunList .dayToRun").each(function() {
			if($(this).attr("data-state") == "checked"){errorMsg="";}
		});
	    return errorMsg;
	}
	alarmsUtil.getTimeFieldID = function(freqOption){
		var fieldId="";
		if(freqOption === 'MONTHLY'){
			fieldId ="#dateSpinner";
		}else if(freqOption!='WEEKLY'){
			fieldId ="#";
		}
		return fieldId;
	}

	alarmsUtil.validateField =  function(fieldSelector, value, validatingFn) {
		// the value is also sent as an arg and not read in this func.
		// the selector is only used to highlight or clear.
		return alarmsUtil.markField(fieldSelector, validatingFn(value));
	}

	alarmsUtil.markField =  function(fieldId, errorMessage)
	{
		alarmsUtil.clearErrorMessages();
		if(!errorMessage || errorMessage=='')
		{
			alarmsUtil.clearHighlight(fieldId);
			return true;
		}
		alarmsUtil.highlightField(fieldId, errorMessage);
		return false;
	}

	alarmsUtil.clearErrorMessages = function() {
		$('#alarmErr').text('').hide();
		$('.accordion-error').text('').hide();
	}

	alarmsUtil.clearHighlight = function(fieldId)
	{
		$(fieldId).removeClass("errorField");
		$(fieldId).attr('title', '');
		$("#alarmErr").val("").hide();

	}

	alarmsUtil.highlightField = function(fieldSelector, errorMessage)
	{
		var errorText = '';
		if (errorMessage!=undefined && errorMessage.trim().length>0) {
			errorText = errorMessage;
		} else {
			errorText = cvUtil.cvLocalize('ValidationText');
		}

		var isAccordionError = false;
		$('.alarm-accordion').each(function() {
			if ( $(this).find(fieldSelector).length > 0 ) {
				if ($(this).find('.accordion-error').length != 0) {
					isAccordionError = true;
					$(this).find('.accordion-error').text(errorText).show();
				}
				$(this).addClass('active'); // open accordion
			}
		});

		if (!isAccordionError) {
			$("#alarmErr").text(errorText).show();
		}

		$(fieldSelector).addClass("errorField");
		$(fieldSelector).attr('title', errorMessage);
		if(!$(fieldSelector).is(":focus")){$(fieldSelector).focus();}
	}

	alarmsUtil.isNumeric = function(value) {
		var errorMessage = '';
		if(!$.isNumeric(value)) {
			errorMessage =  cvUtil.cvLocalize("Numeric_Value_Required");//'Please enter a numeric value';
		}
		return errorMessage;
	}

	alarmsUtil.isPositiveNumeric = function(value) {
		var errorMessage = '';
		var validationObj = { pattern : /^[0-9.]+$/, desc: "integer"};
		var validationResult = Reports.validateValue(value, validationObj, "integer");
		if(!validationResult.status) {
			errorMessage =  cvUtil.cvLocalize("Positive_Numeric_Value_Required");//'Please enter a numeric value';
		}
		return errorMessage;
	}


	alarmsUtil.makeAlarmURL = function(alarmObj){
		var alarmURL = "";
		var reqObj = {};
		reqObj.exportType ="CSV";
		var relativeUrl = window.location.pathname.replace(cvUtil.getContextPath(), "");
		var reqToUrl="";
		if(alarmObj.type == Alarms.TYPE_HEALTH) {
			var reportURL  = window.location.href;
			reqObj.commUniId = cvUtil.getParameter("commUniId", 0);
			reqObj.paramId = alarmObj.paramId;
			reqObj.paramValue = alarmObj.value;
			reqObj.paramStatus = alarmObj.status;
			reqObj.paramName = alarmObj.paramName;
			reqObj.op = alarmObj.operator;
			reqObj.filePrefix = "Alert";
			reqObj.isAlarm = true; // to say that it's an alert
			reqToUrl = requestToUrl(reqObj);
			alarmURL = relativeUrl + (reqToUrl.length > 0 ? "?" + reqToUrl : "");
		}else if(alarmObj.type == Alarms.TYPE_GENERAL) {
			var columnArray = Reports.getTableCols(alarmObj.gridId);
			var colJson = alarmObj.condition.columnList;
			urlToRequest(window.location.search, reqObj);

			if(reqObj.alarmId){
				delete reqObj.alarmId;
			}
            for (x in reqObj)
            	if (typeof reqObj[x] == 'object' && reqObj[x] instanceof Object){delete reqObj[x];}
			reqObj.isOr = alarmObj.condition.isOr;
			reqObj.filePrefix = "Alert";
			reqObj.isAlarm = true; // to say that it's an alert
			reqObj[alarmObj.gridId]={};
			reqObj[alarmObj.gridId]["tableColumns"]=columnArray;
			reqToUrl = requestToUrl(reqObj);
			alarmURL = relativeUrl + (reqToUrl.length > 0 ? "?" + reqToUrl : "");
			alarmURL = alarmURL.indexOf("?")>-1? (alarmURL+ "&") : (alarmURL+ "?");
			var searchString = alarmsUtil.fnGetSearchString(alarmObj.condition.columnList, alarmObj.condition.isOr);
			alarmURL = alarmURL + (alarmObj.gridId + "-filterClause=" + encodeURIComponent(searchString)) + "&filteredTable-0=" + alarmObj.gridId;
		}
		return alarmURL;
	}

	alarmsUtil.makeAlarmRequest = function(paramsObj) {
		var retval = {};
		retval.action = paramsObj.action;
		retval.alarmName = paramsObj.alarmName;
		retval.reportName = paramsObj.reportName.length > 0 ? paramsObj.reportName : "Uncategorized";
		retval.alertStatus = paramsObj.alertStatus;
		retval.email = paramsObj.email;
		retval.emailCc = paramsObj.emailCc;
		retval.emailBcc = paramsObj.emailBcc;
		retval.reportType = paramsObj.type;
		retval.reportEnum = window.reportEnum;
		retval.reportUniqId = window.reportUniqId;
		retval.exportType = "CSV";
		retval.filePrefix = "Alert";
		retval.severity= paramsObj.severity;
		retval.activeStartTime= paramsObj.activeStartTime;
		retval.timezone = paramsObj.timezone;
		retval.freqType= paramsObj.freqType;
		retval.commUniId = cvUtil.getParameter("commUniId", 0);
		retval["alarmType"] = paramsObj.type== 0?"HEALTH" : "GENERAL";
		retval.version = Alarms.VERSION;
		retval.isTileAlert = paramsObj.isTileAlert;
		retval.paramValue = paramsObj.paramValue;
		retval.alertCriteriaIdForTile = paramsObj.alertCriteriaIdForTile;
		retval.tileID = paramsObj.tileID;
		retval.operator = paramsObj.operator;
		retval.isOr = paramsObj.isOr;
		var currentUrl = "";
		var reqObj = {};
		var reportUrl = "";
		var reqToUrl = "";
		if (!window.location.origin) {
			  window.location.origin = window.location.protocol + "//" + window.location.host;
		}
		if(paramsObj.emailHeader && (($.inArray('EMAIL', paramsObj.notificationsSelected) > -1) || ($.inArray('LIVEFEEDS', paramsObj.notificationsSelected) > -1))){
			retval.emailHeader = paramsObj.emailHeader?paramsObj.emailHeader:"";
		}
		var relativeUrl = window.location.pathname.replace(cvUtil.getContextPath(), "");
		var manageUrl = window.location.origin + cvUtil.getContextPath() + "/reports/reports.jsp?report=alarmsSettings";

		if(paramsObj.freqType.toUpperCase()== "WEEKLY"){
			$.each(paramsObj.weekDays , function(index,value) {
				retval[value]=true;
			});
		}else if(paramsObj.freqType.toUpperCase() == "MONTHLY"){
			if(paramsObj.dayOfMonth!=undefined){
				retval.dayOfMonth =paramsObj.dayOfMonth;
			}else if(paramsObj.weekOfMonth != undefined){
				retval.weekOfMonth= paramsObj.weekOfMonth;
				retval.dayOfWeek= paramsObj.dayOfWeek ;
			}
		}else if(paramsObj.freqType.toUpperCase() == "DAILY"){
			if(paramsObj.activeEndTime!=undefined && paramsObj.everyNHoursSpinner!=undefined &&paramsObj.everyNMinsSpinner !=undefined ){
				retval.activeEndTime = paramsObj.activeEndTime ;
				retval.everyNHoursSpinner = paramsObj.everyNHoursSpinner;
				retval.everyNMinsSpinner = paramsObj.everyNMinsSpinner;
			}

		}

		if(retval.action == "EDIT"){
			retval["reportURL"] = paramsObj.reportURL;
			retval["columnJson"]=window.encodeURIComponent(JSON.stringify({}));
			retval["alarmURL"] = paramsObj.alarmURL;
			retval.reportEnum = paramsObj.reportEnum;
			retval.reportUniqId = paramsObj.reportUniqId;
			retval.alarmId = paramsObj.alarmId;
			retval.commUniId = paramsObj.commUniId;
			retval.templateId=paramsObj.templateId;
			retval.ccGroupId=paramsObj.ccGroupId;
			retval.companyId=paramsObj.companyId;
			retval.scheduleTaskID = paramsObj.scheduleTaskID;
		}
		if(retval.action != "EDIT" || paramsObj.editCriteriaSet){
			if(paramsObj.type == Alarms.TYPE_HEALTH) {
				currentUrl = alarmsUtil.makeAlarmURL(paramsObj);
			} else if(paramsObj.type == Alarms.TYPE_GENERAL) {
				var columnArray = Reports.getTableCols(paramsObj.gridId);
				var colJson = paramsObj.condition.columnList;
				retval["columnJson"] = window.encodeURIComponent(JSON.stringify(colJson));
				currentUrl = alarmsUtil.makeAlarmURL(paramsObj);
			}
			if(!paramsObj.editCriteriaSet){
				retval["reportURL"] = window.location.href;
			}
			if(cvUtil.getTopWindow().convertToExportUrl){
				var exportType="csv";
				currentUrl = cvUtil.getTopWindow().convertToExportUrl(currentUrl, exportType, -1); //currenturl is initialized in jsp
			}

			retval["alarmURL"] = window.encodeURIComponent(currentUrl);

			var editCriteriaSet = paramsObj.editCriteriaSet;
			paramsObj.editCriteriaSet = false;
			if(paramsObj.type == Alarms.TYPE_GENERAL) {
				paramsObj.fromManage = true;
				paramsObj.alarmURL = currentUrl;
				var dataTable = $('#' + paramsObj.gridId + CVTable.table).dataTable();
				var oSettings = dataTable.fnSettings();
				retval["description"] = SurveyTemplates.makeAlarmConditionRow(paramsObj , {"forDescription" : true, "oSettings" : oSettings});
			} else if(paramsObj.type == Alarms.TYPE_HEALTH) {
				// need a description for event logs.
				paramsObj.fromManage = true;
				paramsObj.alarmURL = currentUrl;
				retval["description"] = SurveyTemplates.makeAlarmConditionRow(paramsObj);
				if(!editCriteriaSet){
					paramsObj.fromManage = false;
				}
			}
			paramsObj.editCriteriaSet = editCriteriaSet;

		}
		if(retval.commUniId) {
			manageUrl = manageUrl + "&commUniId=" + retval.commUniId;
		}
		retval["manageURL"] = manageUrl;
		retval["notificationsSelected"] = paramsObj.notificationsSelected.join(",");
		if(paramsObj.templateDescriptionSNMP != undefined){
			retval.templateDescriptionSNMP = paramsObj.templateDescriptionSNMP;
		}
		console.debug("Adding alert: " + retval["alarmURL"]);
		return retval;
	}

	alarmsUtil.alarmCreationSuccFn = function(data, action) {
		var errorMessage ="";
		var sucessMessage = "";
		if(action == "EDIT"){
			errorMessage = cvUtil.cvLocalize("Alert_Modification_Failed");
			sucessMessage = cvUtil.cvLocalize("Alert_Modification_Success");
		}else{
			errorMessage = cvUtil.cvLocalize("Alert_Creation_Failed");
			sucessMessage = cvUtil.cvLocalize("Alert_Creation_Success");
		}
		if (typeof data == 'object') {
			if (!!data.errorMsg) {
				cvUtil.errorToast(errorMessage+" "+ data.errorMsg);
			} else {
				cvUtil.toast(sucessMessage);
			}
		} else {
			cvUtil.errorToast(errorMessage+" "+ data);
		}
		if(action == "EDIT"){
			report.loadReport()
		}
	};
	alarmsUtil.alarmCreationErrFn = function(xhr, ajaxOptions, thrownError) {
		if (xhr.status == 0 && xhr.statusText != "userAborted") {
			cvUtil.errorToast( cvUtil.cvLocalize("Validate_Tomcat_services"), "");
		} else {cvUtil.errorToast(cvUtil.cvLocalize("Alert_Creation_Failed")+ " " + thrownError);}
	};
	alarmsUtil.alarmActions = function(alarmIdList, action, confirmationTextMessage,errorMessage , sucessFunc){
		if(alarmIdList && alarmIdList.length > 0) {
			if (window.confirm(confirmationTextMessage)) {
				var urlParamsObj = {};
				urlParamsObj.action = action;
				urlParamsObj.alarmIdList = alarmIdList.join(",");

				alarmsUtil.submitRequest(urlParamsObj, function(data){
					if(data.errorMsg) {
						cvUtil.errorToast(errorMessage + data.errorMsg);
					} else {
						// success
						// temporary way to see the latest...
						sucessFunc(data);
					}
				});
			}
		} else {

		}
	}
	alarmsUtil.submitRequest = function(urlParamsObj, callback) {
		var url = cvUtil.getContextPath() + '/server/cloudsurvey.do?type=alarms';
		var action = urlParamsObj.action;
		var reportName = urlParamsObj.reportName;
		var loglevel = "";
		var alertDetails ="";
		if(window.location.href.indexOf("reportSettings.jsp") != -1){
			reportName = "Reports Settings";
			loglevel = "INFO";
			if(urlParamsObj.alarmIdList){
				alertDetails = "AlertId=["+urlParamsObj.alarmIdList+"]";
			}else{
				alertDetails = "AlertId=["+urlParamsObj.alarmId+"]";
			}
		}
		var exportType ="Alert";
		cvUtil.loadPageWithSessionCheck(url, urlParamsObj, function(data1) {
			cvUtil.logUserAction(reportName,action,exportType,"Message=[Action Successful] "+alertDetails,loglevel);
			if(!!callback && typeof callback == 'function') {
				callback(data1,action);
			}
		},
		function(xhr, ajaxOptions, thrownError){
			cvUtil.logUserAction(reportName,action,exportType,"Message=[Failed] "+alertDetails,loglevel);
			if(!!callback && typeof callback == 'function') {
				callback({"error" : true, "errorMsg" : cvUtil.cvLocalize("Alert_Request_Failed") });//"Failed to complete the request."
			}
		});
	}

	alarmsUtil.submitGetScheduleRequest = function(param, callback){
		cvUtil.loadPageWithPOST(cvUtil.getContextPath() + "/server/reportAlarmSchedules.do", param, function(data) {
			var scheduleData = data.aaData[0];
			callback(scheduleData);
		});
	}

	alarmsUtil.checkRowConditionsHasValidValue = function(){
		var isRowConditionHasValue = true;
		$.each($("#gen-alarmOpts li").find("input.gen-thresholdValue"),function(index , element){
			if(element.value=="" || element.value == null ){
				isRowConditionHasValue = false;
				alarmsUtil.markField(element, cvUtil.cvLocalize("alert.check.Enter_value"));
				return isRowConditionHasValue;
			}else{
				alarmsUtil.markField(element,"" );
			}
		});

		return isRowConditionHasValue;

	}

	/**
	 * Use this function to get query string parameters as an associative array
	 */
	alarmsUtil.getUrlParams = function(url) {
		var urlParams = {};
		if(!url){
			return urlParams;
		}
		var e, a = /\+/g, // Regex for replacing addition symbol with a space
		r = /([^&=]+)=?([^&]*)/g, d = function(s) {
			return decodeURIComponent(s.replace(a, " "));
		}, q = url.substring(1);

		while (e = r.exec(q)) {
			urlParams[d(e[1])] = d(e[2]);
		}

		return urlParams;
	};


	//============================================Alarms Util functions end here==========================================//
}

function loadCommCellsAndCallback(callback) {
	var url = "survey.do?action=CommCellsForSearch";
	if(typeof isMetricsOk != "undefined" && !!isMetricsOk) {
		cvUtil.loadPageWithPOST(url, null, function(data1) {
			var parsedData = data1; //cvUtil.parseJSON(data1);
			if(!parsedData)
			{
				manageAlarms([]);
			} else {
				window.commcellSearchData = parsedData;
				if(!!callback && typeof callback == 'function') {
					callback(window.commcellSearchData);
				} else {
					manageAlarms(window.commcellSearchData);
				}
			}
		}, function(xhr, ajaxOptions, thrownError) {
			console.log(thrownError);
			manageAlarms([]);
		});
	} else {
		manageAlarms([]);
	}
}
function getValueForUniqId(uid, token) {
	if(uid > 0 && Alarms.commcellDetails){
		if (token === 'guid') {
			return Alarms.commcellDetails.CommServeGUID;
		} else if (token === 'name') {
			return Alarms.commcellDetails.Customer;
		} else if (token === 'ccId') {
			return Alarms.commcellDetails.CommCellID;
		}
	}
	return null;
}


$(document).ready(function() {
	var commUniId = cvUtil.getParameter('commUniId', 0);
	if(commUniId > 0){
		var URL="survey.do?action=CommCellDetailsUid&commUniId="+commUniId;
		cvUtil.loadPageWithPOST(URL, null, function(data) {
			if(data){
				Alarms.commcellDetails = data;
			}
		});
	}

	if(window.loadAlarmsFromSettings) {
	} else {
		if(window.waitress) {
			window.waitress.when(["commcellsearch"], function(){
				$(".reports_Alarm").removeClass("disabled");
				if(window.loadAlarms) {
					manageAlarms(window.commcellSearchData);
				} else {
					alarmsOperations();
				}
				return;
			});
		}
		alarmsOperations();

		/*
		 * Fetching urlParams to verify if any alarmId being passed in the urland initiates getAlarmDetails
		 * call.
		 */
		var urlParams = cvUtil.getUrlParams();
		//while loading health.jsp it includes alarms.js, to avoid un-necesary calls, adding location.pathname check
		if (location.pathname.indexOf("/health/health.jsp") == -1 && urlParams.alarmId && $.isNumeric(urlParams.alarmId) && urlParams.alarmId > 0) {
			var param = {};
			param.alarmId = urlParams.alarmId;
			Reports.getAlarmDetails(param, Reports.initAlarmDialog);
		}

	}

	$("#editCriteria").click(function(){
		var redirectUrl = $(this).attr("data-redirecturl");
		if(redirectUrl){
			window.open(redirectUrl,"_blank");
		}else{
			cvUtil.errorToast( cvUtil.cvLocalize('Something_went_wrong_please_try_again'));
		}
	});

	$('.alarm-accordion-title').click(function(){
		$(this).closest('.alarm-accordion').toggleClass('active');
	});

});

