(function() {
	'use strict';

	$(document).ready(function() {
		var view = {}, params = {}, commUniId, groupId, startDate, breadcrumbParams = "", gType;
		view.filters = true;
		view.collapsible = true;
		view.alarm = true;
		view.exportExcel = true;
		view.colChooser = true;
		commUniId = parseInt(cvUtil.getParameter("commUniId", 0));
		groupId = parseInt(cvUtil.getParameter("ccGroupId", -1));
		startDate = cvUtil.getParameter("startDate", 0);
		gType = cvUtil.getParameter("gType", "backup");

		view.title = getTableTitle(gType) + " - " + cvUtil.cvLocalize("Usage_For", getStartDate(startDate));

		surveyCommon.initComponents(cvUtil.cvLocalize("Peak_Capacity_Usage_Growth_Detail"), commUniId, groupId);

		if (commUniId !== 0) {
			breadcrumbParams += "commUniId=" + commUniId;
		}

		if (groupId !== -1) {
			if (breadcrumbParams) {
				breadcrumbParams += "&";
			}
			breadcrumbParams += "ccGroupId=" + groupId;
		}

		var a = '<a class="smartLinkMain growthDashboardLink" href="capacitygrowth.jsp?' + breadcrumbParams + '">' +
				cvUtil.cvLocalize("Peak_Capacity_Usage_Growth") + '</a>';
		$('#breadcrumbMain').append('<li class="secTitleClickable smartlinkMain withSeparatorMain">' + a + '</li>');

		$("#search").hide();
		$("#advCCSearch").hide();

		params.commUniId = commUniId;
		params.ccGroupId = groupId;
		params.startDate = startDate;
		params.aggregate = getAggregate(gType);

		$("#capacityGrowthDetail").empty();
		$('#tableWrapper').append(SurveyTemplates.makeReportTable('capacityGrowthDetail', view));
		cvUtil.loadPageWithPOST(cvUtil.getContextPath() + '/server/capacityGrowthDetail.do', params, function(data) {
			createTable(data, 'capacityGrowthDetail');
		});

	});

	function getAggregate(gType) {
		var aggregate = 1;
		if (gType === 'protectionEnterprise') {
			aggregate = 1;
		} else if (gType === 'archiveEnterprise') {
			aggregate = 2;
		} else if (gType === 'snapshot') {
			aggregate = 3;
		} else if (gType === 'replication') {
			aggregate = 4;
		}

		return aggregate;
	}

	function getStartDate(startDate) {
		var date = moment(startDate);
		return date.format("MMMM") + " " + date.format("YYYY");
	}

	function getTableTitle(gType, startDate) {
		var title = cvUtil.cvLocalize("Backup");
		if (gType === 'protectionEnterprise') {
			title = cvUtil.cvLocalize("Backup");
		} else if (gType === 'archiveEnterprise') {
			title = cvUtil.cvLocalize("Archive");
		} else if (gType === 'snapshot') {
			title = cvUtil.cvLocalize("Snapshot");
		} else if (gType === 'replication') {
			title = cvUtil.cvLocalize("Replication");
		}

		return title;
	}

	function createTable(data, tableDiv) {
		var dateIndex = 4, ctr = 0, total = 5;
		data.iDisplayLength = 100;
		var opt = {};

		if (exportRequest) {
			data.iDisplayLength = -1;
		}

		$.each(data.aoColumns, function(columnCount, columnValue) {
			columnValue.bUseRendered = false;
		});

		Reports.configureClientSideTableWithPaging(tableDiv, '', data, undefined, opt);
		var oTable = $("#" + tableDiv + CVTable.table).dataTable();
		var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
		pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
	}

}());