// ============================================================================
//  Copyright (c) CommVault Systems,
//  All Rights Reserved
//
//  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF CommVault Systems
//  The copyright notice above does not evidence any
//  actual or intended publication of such source code.
//
//  Author: Siva Ram
// ============================================================================

var commUniId = 0;
var ccGroupId = -1;
var companyId = 0;
var exportRequestType = "";
var monthsOfTrend = 12;
var sizeUnit = "TB";
function GrowthReport() {
	exportRequestType = cvUtil.getParameter('exportType', "");
	monthsOfTrend = cvUtil.getParameter('monthsOfTrend', 12);
	sizeUnit = cvUtil.getParameter('sizeUnit', "TB");

	this.report = new Reports.initReport({
		type : 'commcellgrowth_survey',
		generateButtonId : 'btngenerate',
		idtomask : 'GrowthContentWrapper',
		chartIds : [
				'protectionEnterprise_Chart',
				'protectionCore_Chart',
				'archiveEnterprise_Chart',
				'archiveCore_Chart' ],
		directPrint : true
	});
	report.requestString["monthsOfTrend"] = monthsOfTrend;
	report.requestString["sizeUnit"] = sizeUnit;
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			/// If current report is for a specific CommCell, persist its ID in
			/// the URL
			requestString["commUniId"] = commUniId;
		}

		if (ccGroupId > 0) {
			/// If current report is for a CommCell group, persist its ID in
			/// the URL
			requestString["ccGroupId"] = ccGroupId;
		}
		if (companyId > 0) {
			requestString["companyId"] = companyId;
		}

		if (monthsOfTrend != 12) {
			checkCb($("#show24Months"));
		}
		
		if (sizeUnit == "TB") {
			$("#sizeTB").addClass("selected");
		} else {
			$("#sizeGB").addClass("selected");
		}
		
	};

	report.initComponents = function() {
		$("#exportcsv").hide();
	};

	report.initComponentState = function() {
	};
	report.beforeLoadReport = function() {
		/*
		 * if(commUniId > 0) { $("#diagUrl").attr("href", "commcellmonitoring.jsp?commUniId=" + commUniId); }
		 */

		beforeLoadReportBase();
		report.mask("");
		//getCurrentCapacityUsage();

		if (commUniId <= 0) {
			/// If at Worldwide/Group level, no CommCell details are available
			var $metaTotalCCs = $("#metaTotalCCs"), url = "survey.do?action=GetTotalCommCells";

			/// Hide all CommCell-level details and "Worldwide" link
			$("#meta").find(".mItem").hide();

			/// Include group ID in request if applicable
			if (ccGroupId > 0) {
				url += "&ccGroupId=" + ccGroupId;
			}
			if (companyId > 0) {
				url += "&companyId=" + companyId;
			}
			/// Fetch the total number of participating CommCells and display in
			/// the header
			cvUtil.loadPageWithPOST(url, {}, function(total) {
				$metaTotalCCs.show().empty().append(cvUtil.cvLocalize("Participating_CommCells") + ' <span class="commcell">' +
						total + '</span>')
			});
		}

		reportsUtil.setWorldwideLink(!isPublicMetrics);
	};

	report.getRequestUrl = function() {
		var url;

		if (exportRequestType == "csv") {
			url = cvUtil.getContextPath() + '/server/survey.do?action=CommCellGrowth&commUniId=' + commUniId +
					'&monthsOfTrend=' + monthsOfTrend + '&sizeUnit=' + sizeUnit + '&isChart=false&exportType=CSV&json=' +
					window.encodeURIComponent(JSON.stringify(this.requestString));
		} else {
			url = cvUtil.getContextPath() + '/server/survey.do?action=CommCellGrowth&commUniId=' + commUniId +
					'&monthsOfTrend=' + monthsOfTrend + '&sizeUnit=' + sizeUnit + '&json=' +
					window.encodeURIComponent(JSON.stringify(this.requestString));
		}

		///  Include CommCell group ID if relevant
		if (ccGroupId !== -1) {
			url += "&ccGroupId=" + ccGroupId;
		}
		if (companyId > 0) {
			url += "&companyId=" + companyId;
		}

		return url;
	};

	report.onLoadReport = function(data) {
		if (exportRequestType == "csv") {
			var data1 = data; //jQuery.parseJSON(data);
			//Get peak capacity usage per month table
			genearateTableFromResult(data1,
					"",
					"CommCellGrowth",
					"GrowthTableDetails",
					"GrowthTableDetailsPager",
					"Capacity Growth Details",
					commUniId,
					"Details",
					false);
			//Get prediction data based on peak capacity usage per month
			generateTable("",
					'CommCellGrowth',
					false,
					true,
					'reportTaskSummaryDiv',
					'reportTaskSummaryPager',
					"Capacity Growth Prediction",
					commUniId,
					'Summary',
					false,
					false,
					true,
					"getChartData=true&exportType=CSV&commUniId=" + commUniId + "&monthsOfTrend=" + monthsOfTrend + '&sizeUnit=' + sizeUnit);
		} else {
			onLoadReportBase(data, true);
		}
	};

	report.getExportFilePrefix = function() {
		var filePre = "PeakCapacityUsageGrowth";
		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}
		return filePre;
	};

	report.showErrorMessage = function() {
		$("#GrowthContent_NoData").append('<div class="reportNoData">' +
				cvUtil.cvLocalize("error.msg.Capacity_License_may_not_be_used") + '</div>');
	};

	report.showDetailsLink = function(gType) {
		var link;

		if (commUniId > 0) {
			link = "indcommcellsurvey.jsp";
		} else {
			link = "CommCellSurvey.jsp";
		}
		link += "?surveyId=1";

		/// If at Worldwide level, CommCell ID of zero is not required
		if (commUniId !== 0) {
			link += "&commUniId=" + commUniId;
		}
		/// Group ID must be included
		if (ccGroupId > 0) {
			link += "&ccGroupId=" + ccGroupId;
		}
		if (companyId > 0) {
			link += "&companyId=" + companyId;
		}

		$("#" + gType + "_detailsLink").attr("href", link);
		$("#" + gType + "_detailsSpan").show();
	};

	report.init();
	report.customizeTable = function(dataTable) {
	};

}

/*
 * function getCurrentCapacityUsage(){ this.requestString.dashboard = true; var commCellUID =
 * this.requestString.commUniId; this.requestString.commUniId = cvUtil.getParameter("commUniId", 0);
 * this.requestString.dToken = 2; var URL = cvUtil.getContextPath() +
 * '/server/cloudsurvey.do?type=operations&json='+window.encodeURIComponent(JSON.stringify(this.requestString));
 * cvUtil.loadPageWithPOST(URL, "", function(output) { if(output.summary2 != undefined){
 * 
 * var nameMap = {'Data Protection':'protectionEnterprise','DP Enterprise':'protectionEnterprise','DP
 * Core':'protectionCore','Archive Enterprise':'archiveEnterprise','Archive
 * Core':'archiveCore','Archive':'archiveEnterprise','Replication':'replication', 'Snapshot':'snapshot'};
 * 
 * for(var j=0;j<output.summary2.value.members.iTotalDisplayRecords;j++){ var key =
 * nameMap[output.summary2.value.members.aaData[j].Name]; $("#" + key +
 * "_currentUsage").html(autoConvertFromMB(output.summary2.value.members.aaData[j].Used * 1024 * 1024)); }
 * $('.currentCapacity').show(); } });
 *  }
 */

$(document).ready(function() {
	/// Cast URL parameters to numbers
	commUniId = Number(cvUtil.getParameter('commUniId', 0));
	ccGroupId = Number(cvUtil.getParameter('ccGroupId', -1));
	companyId = Number(cvUtil.getParameter('companyId', 0));
	if (commUniId <= 0 && ccGroupId <= 0 && companyId <= 0 && isPublicMetrics) {
		window.location.href = "../../reports";
	}

	$("#CapacityGrowthContentWrapper #show24Months").click(function() {
		requestString["monthsOfTrend"] = $('#show24Months').attr('data-state') == "checked" ? 12 : 24;
		monthsOfTrend = requestString["monthsOfTrend"];
		report.updateHash(true);
		report.loadReport();
	});


	$("#CapacityGrowthContentWrapper .sizeOptions").click(function() {
		requestString["sizeUnit"] = $(this).attr("data-sizeUnit");
		sizeUnit = requestString["sizeUnit"];
		report.updateHash(true);
		report.loadReport();
		$(".sizeOptions").removeClass("selected");
		$(this).addClass("selected");
	});

	surveyListAndMeta(function(data1) {
		var output = data1;//cvUtil.parseJSON(data1);

		if (output !== null && typeof output === 'object') {
			if (output.error) {
				hideAllComponents();
				$("#noDataNotificationPanel").html(output.error);
				$("#noDataNotificationPanel").show();
			} else {
				var selectedSurvey = output.surveys.selectedSurvey;
				var surveyGroupList = output.surveys.surveyGroupList;
				var enableDropDown = output.surveys.enableDropDown;
				enableDropDown = false;
				var customer = output.customer;

				$("#surveyName").html(selectedSurvey);
				if (enableDropDown) {
					$("#surveyList").html(SurveyTemplates.makeSurveyList("surveyList", surveyGroupList));
					$("#cust-survey-div").addClass("cust-survey-div");
					$("#surveyName").append("<span class='downarrow'></span>");
					SurveyGlobals.addDropDownEvents();
				}
				$("#survey-list-holder").show();

				$("#chartTitle").html(selectedSurvey);

				$(document).attr("title", selectedSurvey);
				if (customer) {
					customer = $.trim(customer);
					if (customer.length != 0) {
						$("#custName").html(customer + " -&nbsp;");
						//$("#surveyListHolder").width($("#uniform-surveyList span").width() + $("#custName").width() + 10 );
						$(document).attr("title", customer + " - " + selectedSurvey);
						$('.reportsLink').text(customer + ' (' + cvUtil.cvLocalize("Reports") + ')');
						cvUtil.GUIAuditReportLog(selectedSurvey, customer);
					}
				}
				if (output.CommServeGUID) {
					output.CommServeGUID = registrationCode(output.CommServeGUID);
					$("#GUID").html(cvUtil.cvLocalize("commcell.info.label.Registration_Code") + ": <span>" +
							output.CommServeGUID + "</span>");
				}
				if (output.GroupName != null) {
					$('.commcellsLink').text(output.GroupName + ' (' + cvUtil.cvLocalize("CommCells") + ')');
				}
			}
		} else {
			//Error
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		}
	});

	/// Populate the title and reports link with appropriate group name
	if (ccGroupId > 0) {
		getCommCellDetailsOfUid(commUniId, null, function(data) {
			if (data.error) {
				$(".cvApps").hide();
				$("#noDataNotificationPanel").html(data.error);
				$("#noDataNotificationPanel").show();
			} else {
				$('#custName').html(data.GroupName + " - ");
				$('.reportsLink').text(data.GroupName + ' (' + cvUtil.cvLocalize("Reports") + ')');
				$(document).attr("title", data.GroupName + " - " + $(document).attr("title"));
			}
		});
	}

	/*
	 * populateSurveyList(function() { $("#surveyList").uniform(); $("#uniform-surveyList span").append("<span
	 * class='downarrow'></span>"); $("#surveyList").width($("#uniform-surveyList span").width());
	 * $("#chartTitle").append(selectedSurvey); }, 'none');
	 */

	GrowthReport();
});