(function(diffExport) {
	'use restrict';

	var chargebackDiff = {};
	chargebackDiff.defaultGrowthType = 0;
	chargebackDiff.defaultAggregateType = 2;
	chargebackDiff.entityMap = {
		'commcell' : 'CommCell',
		'client' : 'Client',
		'agenttype' : 'Agent Type',
		'subclient' : 'SubClient',
		'storagepolicy' : 'Storage Policy',
		'storagepolicycopy' : 'Storage Policy Copy',
		'tenant' : 'Tenant'
	};
	chargebackDiff.titleMap = {
		'commcell' : 'CommCell',
		'client' : 'Client',
		'agenttype' : 'Agent',
		'subclient' : 'SubClient',
		'storagepolicy' : 'Storage Policy',
		'storagepolicycopy' : 'Storage Policy Copy',
		'tenant' : 'Tenant'
	};
	chargebackDiff.apiMap = {
		'commcell' : 'commcellChargebackTrends.do',
		'client' : 'clientChargebackTrends.do',
		'agenttype' : 'agentChargebackTrends.do',
		'subclient' : 'subclientChargebackTrends.do',
		'storagepolicy' : 'storagePolicyChargebackTrends.do',
		'storagepolicycopy' : 'storagePolicyCopyChargebackTrends.do',
		'tenant' : 'tenantsChargebackTrends.do'
	};
	function init() {
		chargebackDiff.request = {};
		var entityType = window.entityType;
		var groupBy = cvUtil.getParameter('groupBy');
		groupBy = groupBy.toLowerCase();
		chargebackDiff.request.groupBy = groupBy;
		chargebackDiff.request.ccGroupId = cvUtil.getParameter('ccGroupId', "-1");
		chargebackDiff.request.companyId = cvUtil.getParameter('companyId', "0");
		chargebackDiff.request.ccId = cvUtil.getParameter('commUniId', 0);
		chargebackDiff.request.commcell = cvUtil.getParameter('commcell', 0);
		chargebackDiff.request.application = cvUtil.getParameter('application');
		chargebackDiff.request.agent = cvUtil.getParameter('agent');
		chargebackDiff.request.growthType = cvUtil.getParameter('growthType', null);
		chargebackDiff.request.entityId = cvUtil.getParameter('entityId', 0);
		chargebackDiff.request.entityName = cvUtil.getParameter('entityName');
		chargebackDiff.request.intervalType = cvUtil.getParameter('intervalType', "3");
		chargebackDiff.request.startDate = cvUtil.getParameter('startDate', 0);
		chargebackDiff.request.endDate = cvUtil.getParameter('endDate');
		chargebackDiff.request.date1 = cvUtil.getParameter('date1');
		chargebackDiff.request.date2 = cvUtil.getParameter('date2');
		chargebackDiff.request.entityType = chargebackDiff.entityMap[entityType.toLowerCase()];
		chargebackDiff.request.excludeDeSCs = cvUtil.getParameter('excludeDeSCs', 0);
		chargebackDiff.request.includeDRSubclients = cvUtil.getParameter('includeDRSubclients', 0);
		chargebackDiff.request.primaryCopyOnly = cvUtil.getParameter('primaryCopyOnly', 0);
		chargebackDiff.request.drilldownto = cvUtil.getParameter('drilldownto', "");
		var exportRequest = cvUtil.getParameter('exportType', '');
		chargebackDiff.exportRequest = exportRequest;
		if (entityType === 'AgentType' && chargebackDiff.request.entityId == 106) {
			$('#drilldownTo option[value="subclient"]').remove();//SubClient is not applicable for Virtual Server agent
		}
		chargebackDiff.request.entityDisplayType = chargebackDiff.titleMap[groupBy];
		if (groupBy === 'storagepolicycopy') {
			chargebackDiff.request.growthType = chargebackDiff.request.growthType != null ? chargebackDiff.request.growthType
					: chargebackDiff.defaultGrowthType;
		}
		var timeTitle = '';
		if (chargebackDiff.request.intervalType === '1') {
			timeTitle = 'Daily ';
		} else if (chargebackDiff.request.intervalType === '2') {
			timeTitle = 'Weekly ';
		} else {
			timeTitle = 'Monthly ';
		}
		var dispTitle = timeTitle + " Chargeback Difference -";
		if (chargebackDiff.request.entityName) {
			dispTitle += ' For ' + chargebackDiff.request.entityName;
		} else {

		}
		dispTitle += ' By ' + chargebackDiff.request.entityDisplayType;

		chargebackDiff.request.entityDisplayType = dispTitle;
		initComponents();
		drawTable();
	}

	function initComponents() {
		var trends_params = '?intervalType=' + chargebackDiff.request.intervalType;
		var cb_params = '?';
		if (chargebackDiff.request.intervalType == 1) {
			cb_params += "repType=4";
		} else if (chargebackDiff.request.intervalType == 2) {
			cb_params += "repType=2";
		} else {
			cb_params += "repType=1";
		}
		if (chargebackDiff.request.endDate) {
			cb_params += "&startDate=" + chargebackDiff.request.endDate + " 00:00:00";
			trends_params += "&endDate=" + chargebackDiff.request.endDate;
		}

		var params = '';
		if (parseInt(chargebackDiff.request.ccId) > 0) {
			params += "&commUniId=" + chargebackDiff.request.ccId;
		}
		if (parseInt(chargebackDiff.request.ccGroupId) > 0) {
			params += "&ccGroupId=" + chargebackDiff.request.ccGroupId;
		}
		if (parseInt(chargebackDiff.request.companyId) > 0) {
			params += "&companyId=" + chargebackDiff.request.companyId;
		}
		trends_params += params;
		cb_params += params;
		cb_params += "&excludeDeSCs=" + chargebackDiff.request.excludeDeSCs;
		trends_params += "&excludeDeSCs=" + chargebackDiff.request.excludeDeSCs;

		cb_params += "&includeDRSubclients=" + chargebackDiff.request.includeDRSubclients;
		trends_params += "&includeDRSubclients=" + chargebackDiff.request.includeDRSubclients;

		cb_params += "&primaryCopyOnly=" + chargebackDiff.request.primaryCopyOnly;
		trends_params += "&primaryCopyOnly=" + chargebackDiff.request.primaryCopyOnly;

		var cb = '<a class="smartLinkMain trendsLink" href="chargebackmonthly.jsp' + cb_params + '">' +
				cvUtil.cvLocalize("Chargeback") + '</a>';
		$('#breadcrumbMain').append('<li class="secTitleClickable smartlinkMain withSeparatorMain">' + cb + '</li>');

		var a = '<a class="smartLinkMain trendsLink" href="chargebackTrends.jsp' + trends_params + '">' +
				cvUtil.cvLocalize("chargeback.Trends_Report") + '</a>';
		$('#breadcrumbMain').append('<li class="secTitleClickable smartlinkMain withSeparatorMain">' + a + '</li>');

		var details_href = getChargebackTrendDetailsURL();
		var a = '<a class="smartLinkMain trendsLink" href="' + details_href + '">' +
				cvUtil.cvLocalize("chargeback.trends.details.title") + '</a>';
		$('#breadcrumbMain').append('<li class="secTitleClickable smartlinkMain withSeparatorMain">' + a + '</li>');

		surveyCommon.initComponents(chargebackDiff.request.entityDisplayType,
				chargebackDiff.request.ccId || chargebackDiff.request.commcell,
				chargebackDiff.request.ccGroupId,
				chargebackDiff.request.companyId,
				true);
		//reportsUtil.setWorldwideLink(!isPublicMetrics);

		if (chargebackDiff.request.application) {
			$('#custName').text(chargebackDiff.request.application + ' - ');
		}

		var startDate = parseInt(chargebackDiff.request.startDate);
		var dates = [];
		for (var i = 0; i < 12; i++) {
			var temp = startDate;
			if (chargebackDiff.request.intervalType == 1) {
				temp = moment(startDate).add("days", i);
			} else if (chargebackDiff.request.intervalType == 2) {
				temp = moment(startDate).add("weeks", i);
			} else {
				temp = moment(startDate).add("months", i);
			}
			dates[i] = temp;
		}

		var options = '';
		var dateFormat = 'MMM YYYY';
		if (chargebackDiff.request.intervalType === '1') {//Daily
			dateFormat = 'MMM DD, YYYY';
		} else if (chargebackDiff.request.intervalType === '2') {//Weekly
			dateFormat = 'MMM DD, YYYY';
		}

		$.each(dates, function(i, dt) {
			var displayVal = moment(dt).format(dateFormat);
			if (chargebackDiff.request.intervalType === '2') {//Weekly
				displayVal = moment(dt).format(dateFormat) + " - " + moment(dt).add("days", 6).format(dateFormat);
			}
			dt = moment(dt).format('YYYY-MM-DD') + ' 00:00:00';
			options += '<option value=\'' + dt + '\'>' + displayVal + '</option>';
		});
		$('#diff-first').append(options);
		$('#diff-second').append(options);
		$("#diff-second option:last").prop("selected", "selected");

		$("#diff-first").find("option[value='" + chargebackDiff.request.date1 + "']").attr("selected", "selected");
		$("#diff-second").find("option[value='" + chargebackDiff.request.date2 + "']").attr("selected", "selected");

		$('.diff-generate-button').click(function() {
			var drillDownType = $('#drilldownTo').val().toLowerCase();
			updateReport(drillDownType);
		});
		$("#drilldownTo").find("option[value='" + chargebackDiff.request.groupBy + "']").attr("selected", "selected");

		if (chargebackDiff.exportRequest != '') {
			var summaryStr = cvUtil.cvLocalize("chargeback.diff.diff_between_export", $('#diff-first option:selected')
					.text(), $('#diff-second option:selected').text(), $('#drilldownTo option:selected').text());
			var summary = "<table id=\"reportSummary\"><tr><td>" + summaryStr + "</td></tr></table>";
			$(".diff-export-summary").html(summary).show();
		}

	}

	function getChargebackTrendDetailsURL() {
		var detailsParams = cvUtil.getUrlParams();
		var detailsURL = chargebackDiff.apiMap[chargebackDiff.request.groupBy];
		updateURLParamToUrl(detailsParams, 'groupBy', null, true);
		updateURLParamToUrl(detailsParams, 'date1', null, true);
		updateURLParamToUrl(detailsParams, 'date2', null, true);
		updateURLParamToUrl(detailsParams, 'startDate', null, true);
		detailsURL = detailsURL + "?" + cvUtil.requestToUrl(detailsParams);
		console.log(detailsURL);
		return detailsURL;
	}

	function drawTable() {
		var view = {};
		view.title = '';
		view.filters = true;
		view.collapsible = true;
		view.alarm = true;
		view.exportExcel = true;
		view.colChooser = true;
		$("#chargebackDiffTable").empty();
		$('#tableWrapper').append(SurveyTemplates.makeReportTable('chargebackDiffTable', view));
		//cvUtil.mask("#tableWrapper");
		cvUtil.loadPageWithPOST(cvUtil.getContextPath() + '/server/chargebackDiffTableData.do',
				chargebackDiff.request,
				function(data) {
					createTable(data.data.cData, 'chargebackDiffTable');
					//cvUtil.unmask("#tableWrapper");
				});
	}

	function updateReport(groupBy) {
		var date1 = $('#diff-first').val();
		var date2 = $('#diff-second').val();
		var params = cvUtil.getUrlParams();
		updateURLParamToUrl(params, 'groupBy', groupBy, true);
		updateURLParamToUrl(params, 'date1', date1, true);
		updateURLParamToUrl(params, 'date2', date2, true);
		var href = "?" + cvUtil.requestToUrl(params);
		href = 'chargebackDiff.do' + href;
		if (href) {
			window.location.href = href;
		}
	}
	function updateURLParamToUrl(params, name, value, isReplace) {
		if (value == null) {
			if (params[name]) {
				delete params[name];
			}
		} else {
			if (params[name] == value) {
				return;
			}
			params[name] = value;
		}
	}
	function createTable(data, tableDiv) {
		if (data === undefined) {
			return;
		}
		data.iDisplayLength = 100;
		if (exportRequest) {
			data.iDisplayLength = -1;
		}
		$.each(data.aoColumns, function(columnCount, columnValue) {
			columnValue.bUseRendered = false;
		});
		$(document).off("keyup", "#" + tableDiv + " .inLineFilter");
		Reports.configureClientSideTableWithPaging(tableDiv, '', data);
		var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
		pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));

		$('input#chargebackDiffTable_filterText-0').remove();
		report.idtomask = 'chargebackDiffTable';

	}

	init();

	diffExport.diff = {

	};

})(window);
