var chargebackTrends = chargebackTrends || {};
chargebackTrends.chartData = {};
chargebackTrends.cachedCommcells = {};

$(document).ready(function() {

	$('#chartTitle').text(chargebackTrends.request.entityDisplayType);
	chargebackTrends.chartType = 'line';
	$('.linechartMini').click(function(e) {
		chargebackTrends.changeChartType('line');
		e.preventDefault();
		chargebackTrends.updateHash();
	});
	$('.vbarchartMini').click(function(e) {
		chargebackTrends.changeChartType('bar');
		e.preventDefault();
		chargebackTrends.updateHash();
	});
	$('#yAxisSelection').on('click', 'li', function() {
		$('#yAxisSelection li.on').removeClass('on');
		$(this).addClass('on');
		chargebackTrends.request.growthType = $(this).attr('id').substring(0, 1);
		chargebackTrends.drawGrowthChart();
		chargebackTrends.drawTable();
		chargebackTrends.updateHash();
	});
	$('#aggregateSelection').on('click', 'li', function(e) {
		$('#aggregateSelection li.on').removeClass('on');
		$(this).addClass('on');
		var agid = $(this).attr('id');
		var aggregate = agid.substring(0, agid.indexOf('_'));
		chargebackTrends.toggleChartMode(aggregate);
		chargebackTrends.updateHash();
		e.preventDefault();
		e.stopPropagation();
	});
});
chargebackTrends.initChartComponentsFromUrl = function() {
	if (chargebackTrends.request.aggregate || chargebackTrends.request.aggregate == 0) {
		$('#aggregateSelection li.on').removeClass('on');
		$('#aggregateSelection li#' + chargebackTrends.request.aggregate + '_aggregate').addClass('on');
	}
	$('#yAxisSelection li.on').removeClass('on');
	$('#yAxisSelection li#' + chargebackTrends.request.growthType + '_growthType').addClass('on');
	$('.entitySelection').toggleClass('disabledActions', chargebackTrends.request.aggregate != 0);
	$("#drilldownTo").val(chargebackTrends.request.drilldownto);
	if (chargebackTrends.request.aggregate != 0) {
		$('.entitySelection').attr('title', cvUtil.cvLocalize("chargeback.trends.entity.title"));
	} else {
		$('.entitySelection').attr('title', '');
	}
};
chargebackTrends.changeChartType = function(chartType) { //line or bar
	var ele = '#chartContainer';
	if (chartType) {
		chargebackTrends.chartType = chartType;
	}
	var viewBox = $(ele).closest('.viewBox');
	if (viewBox.hasClass('errorBox') || viewBox.hasClass('nodata')) {
		return;
	}
	viewBox.find('.boxedChart').empty();
	chargebackTrends.rePaint();
};
chargebackTrends.drawChartInSelectedMode = function(entities) {
	chargebackTrends.request.entities = entities;
	chargebackTrends.toggleChartMode(0);
};
chargebackTrends.drawChartInAggregateMode = function() {
	chargebackTrends.toggleChartMode(1);
};
chargebackTrends.toggleChartMode = function(aggregate) {
	chargebackTrends.request.aggregate = aggregate;
	delete chargebackTrends.chartData;
	$('.entitySelection').toggleClass('disabledActions', chargebackTrends.request.aggregate != 0);

	if (aggregate == 0 && (!chargebackTrends.selectedEntities || chargebackTrends.selectedEntities.length == 0)) {
		chargebackTrends.handleNoChartableData('#chartContainer', cvUtil
				.cvLocalize("Growth_Trend_Entity_Selection_Msg"));
	} else {
		if (aggregate == 0) {
			chargebackTrends.request.entities = chargebackTrends.selectedEntities;
		} else {
			delete chargebackTrends.request.entities;
		}
		chargebackTrends.drawGrowthChart();
	}
	if (chargebackTrends.request.aggregate != 0) {
		$('.entitySelection').attr('title', cvUtil.cvLocalize("chargeback.trends.entity.title"));
	} else {
		$('.entitySelection').attr('title', '');
	}
};
chargebackTrends.addEntityToChart = function(entityName, selectedEntities) {
	chargebackTrends.request.entities = selectedEntities;
	chargebackTrends.drawGrowthChart();
};
chargebackTrends.removeEntityFromChart = function(entityName) {
	var entityList = chargebackTrends.selectedEntities;
	var newEntityList = [];
	for (var i = 0; i < entityList.length; i++) {
		if (entityList[i] != entityName) {
			newEntityList.push(entityList[i]);
		}
	}

	chargebackTrends.request.entities = newEntityList;
	chargebackTrends.selectedEntities = newEntityList;
	if (newEntityList.length == 0) {
		chargebackTrends.handleNoChartableData('#chartContainer', cvUtil
				.cvLocalize('Growth_Trend_Entity_Selection_Msg'));
		return;
	}
	chargebackTrends.drawGrowthChart();
};

chargebackTrends.drawGrowthChart = function(append) {
	var boxSelector = '#chartContainer';
	cvUtil.mask(boxSelector);
	$('.entitySelection').addClass('disabledActions');
	cvUtil.loadPageWithPOST('entityChargebackTrendsChart.do', chargebackTrends.request, function(resp) {
		cvUtil.unmask(boxSelector);
		$('.entitySelection').toggleClass('disabledActions', chargebackTrends.request.aggregate != 0);
		if (!append || !chargebackTrends.chartData || !chargebackTrends.chartData.seriesList) {
			if (!resp || !resp.data) {
				return handleError(boxSelector);
			}
			if (resp.data.isError) {
				return handleError(boxSelector, resp.data.errorMessage);
			}
			var cData = resp.data.cData;
			if (!cData) {
				return chargebackTrends.handleNoChartableData(boxSelector);
			}
			if (cData.seriesList.length <= 0) {
				return chargebackTrends.handleNoData(boxSelector);
			}
		} else {
			if (!resp || !resp.data) {
				return alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
			}
			if (resp.data.isError) {
				return alert(resp.data.errorMessage);
			}
			var cData = resp.data.cData;
			if (!cData) {
				return alert(cvUtil.cvLocalize("chargeback.trends.No_chartable_data_selected_entity"));
			}
			if (cData.seriesList.length <= 0) {
				return alert(cvUtil.cvLocalize("chargeback.trends.No_chartable_data_selected_entity"));
			}
		}
		var cData = resp.data.cData;
		if (chargebackTrends.request.application) {
			for (var i = 0; i < cData.seriesList.length; i++) {
				cData.seriesList[i].seriesName = chargebackTrends
						.getCommcellNameFromUniqId(cData.seriesList[i].seriesName);
			}
		}
		if (append && chargebackTrends.chartData && chargebackTrends.chartData.seriesList) {
			chargebackTrends.chartData.seriesList.push(cData.seriesList[0]);
		} else {
			chargebackTrends.chartData = cData;
		}
		chargebackTrends.rePaint();
	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.unmask(boxSelector);
		chargebackTrends.handleError(boxSelector, cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
	});
};
chargebackTrends.getCommcellNameFromUniqId = function(id) {
	if (!chargebackTrends.cachedCommcells || !chargebackTrends.cachedCommcells[id]) {
		return id;
	}
	return chargebackTrends.cachedCommcells[id];
};
chargebackTrends.rePaint = function() {
	$('#chart').empty();
	$('#chartContainer').removeClass('nodata');
	if (chargebackTrends.chartType == 'bar') {
		chargebackTrends.drawBarGrowthChart('chart', chargebackTrends.chartData);
	} else if (chargebackTrends.chartType == 'line') {
		chargebackTrends.drawLineGrowthChart('chart', chargebackTrends.chartData);
	}
	if ($('.chargeback-diff').length > 0) {
		if (typeof chargebackTrends.initDiffInputs === 'function') {
			if (chargebackTrends.chartData.userData) {
				chargebackTrends.initDiffInputs(chargebackTrends.chartData.userData.startDate);
			}
		}

	}
};
chargebackTrends.drawLineGrowthChart = function(chartDiv, cData) {
	if (!cData) {
		console.log('drawLineGrowthChart - cData is null...returning without doing anything.');
		return;
	}
	var cw = 835, ch = 280;
	var r = Raphael(chartDiv);
	var numPoints = cData.seriesList[0].points.length;
	cData.yAxis.minValue = 0;
	cvcharts.createRaphaelLinechartNew(r, cData, {
		axis : "0 1 1 1",
		chartWidth : cw,
		chartHeight : ch,
		leftMargin : 53,
		topMargin : 30,
		shade : false,
		showLegend : false,
		showPartialLine : true,
		radius : 2,
		legend : 1,
		legendX : cw + 15,
		legendY : 35,
		maxSteps : numPoints,
		maxLegendLen : 50,
		thresholdLabel : cData["yAxis"]['thresholdLabel'],
		thresholdProperties : {
			thresholdStroke : {
				"stroke" : "#008000",
				"stroke-width" : 1.5
			}
		},
		colors : cvcharts.colors[5]
	});
};

chargebackTrends.drawBarGrowthChart = function(frameid, chartData) {
	if (!chartData) {
		console.log('drawBarGrowthChart - chartdata is null...returning without doing anything.');
		return;
	}
	chartData.isStack = true;
	chartData.isShowLegend = true;

	var r = Raphael(frameid);
	var minYAxisValue = chartData["yAxis"]["minValue"];
	var smooth = true;
	var temp = [];
	var temp2 = [];
	var popupLabels = [];
	var pointData = [];
	var seriesLabels = [];
	var colors = [];

	var myColor = cvcharts.colors[5];

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var ctr = 0;
		for (var i = 0; i < chartData.seriesList.length; i++) {
			var s = chartData.seriesList[i];
			if (chartData.isStack == true) {
				if (chartData.colorSet != null && chartData.colorSet != undefined) {
					if (chartData.colorSet[s["seriesName"]] != null && chartData.colorSet[s["seriesName"]] != undefined) {
						s.color = chartData.colorSet[s["seriesName"]];
					} else {
						s.color = myColor[ctr++];
					}
				} else {
					s.color = myColor[i];
				}
			} else {
				s.color = myColor[0];
			}
		}
	}

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[chartData.seriesList.length - i - 1];
		var points = s.points;
		temp[i] = [];
		temp2[i] = [];
		popupLabels[i] = [];
		pointData[i] = [];
		xLabels = [];
		colors[i] = s["color"];
		for (var j = 0; j < points.length; j++) {
			temp[i][j] = points[j]["x"];
			xLabels[j] = points[j]["name"];
			temp2[i][j] = (parseInt(points[j]["y"]) >= 0) ? points[j]["y"] : 0;
			if (points[j]["y"] <= minYAxisValue && j + 1 < points.length) {
				if (points[j + 1]["y"] <= minYAxisValue) {
					smooth = false; //don't smooth if more than 1 cnsecutive values are 0 in which case it will go below the axis line
				}
			}
			popupLabels[i][j] = points[j]["popupLabel"];
			pointData[i][j] = s["pointData"];
		}
		seriesLabels[i] = s["seriesName"];
	}

	var xAxisLabels = chartData["xAxis"]["labels"];
	if (typeof xAxisLabels == 'undefined' || !xAxisLabels.length || xAxisLabels.length < 1) {
		xAxisLabels = xLabels;
	}
	xAxisLabels = modifyLabels(xAxisLabels);

	var totalPoints = xAxisLabels.length;
	var width = 800;
	var chart;

	var height = 300;
	chart = r.barchart(20, 20, width, height, temp2, {
		stacked : true,
		nostroke : false,
		axis : "0 0 1 1",
		symbol : "circle",
		smooth : true,
		actualMaxY : chartData["stackedYAxis"]["maxValue"],
		axisxstep : totalPoints,
		serieslabels : seriesLabels,
		colors : colors,
		maxLegendLen : 50,
		labelypos : 50,
		showlegend : chartData["isShowLegend"],
		xAxisTitle : chartData["xAxisTitle"],
		yAxisTitle : chartData["yAxisTitle"],
		pointlabels : xAxisLabels,
		showpopup : true,
		showGrid : true,
		barGap : 24,
		barActualWidth : 18,
		threshold : {
			value : chartData["yAxis"]['thresholdValue'],
			color : '#008000',
			label : chartData["yAxis"]['thresholdLabel']
		}
	}, popupLabels);
	chart.heightAdjustment(frameid);

	chart.label(xAxisLabels, true);
};

chargebackTrends.handleNoData = function(viewBoxId) {
	$(viewBoxId).addClass('nodata');
};
chargebackTrends.handleNoChartableData = function(viewBoxId, msg) {
	$(viewBoxId).addClass('nodata');
	$(viewBoxId).find('.noDataSpan').text(msg || cvUtil.cvLocalize("No_chartable_data_available"));
};
chargebackTrends.handleError = function(viewBoxId, errorText) {
	$(viewBoxId).addClass('errorBox');
	var msg = errorText || 'Something went wrong';
	$(viewBoxId).find('.errorSpan').text(msg);
};
cvcharts.formatChartLabels = function(seriesLabels) {
	return seriesLabels;
};