function MonthlyChargebackReport() {
	var commUniId = cvUtil.getParameter('commUniId', 0);
	var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
	var companyId = cvUtil.getParameterByName("companyId", 0);
	var startDate = cvUtil.getParameter('startDate', 1);
	var sizeUnit = cvUtil.getParameter('sizeUnit', 'TB');
	var groupBy = cvUtil.getParameter('groupBy', 'ClientGroup');
	var drillFrom = cvUtil.getParameter('drillFrom');
	var drillEntity = cvUtil.getParameter('drillEntity');
	var exportRequest = cvUtil.getParameter('exportType', '');
	var isReportMetadataCall = cvUtil.getParameter('isReportMetadataCall', null);
	var repType = cvUtil.getParameter('repType', 1);
	var excludeDeconfigSubclients = cvUtil.getParameter('excludeDeSCs', 0);
	var showFETforVSAnIda = cvUtil.getParameter('showFET', 0);
	var showTotals = cvUtil.getParameter('showTotals', 0);
	var includeDRSubclients = cvUtil.getParameter('includeDRSubclients', 0);
	var primaryCopyOnly = cvUtil.getParameter('primaryCopyOnly', 0);

	var loadTable = [];
	var customerName = "";
	var costDetails = {};
	var dataAvailable;
	var exportLatestDate;

	this.report = new Reports.initReport({
		type : 'chargebackmonthly',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			requestString["commUniId"] = commUniId;
		}
		requestString["repType"] = repType;
		if (ccGroupId > 0) {
			requestString["ccGroupId"] = ccGroupId;
		}
		if (companyId > 0) {
			requestString["companyId"] = companyId;
		}
		requestString["startDate"] = startDate;
		requestString["sizeUnit"] = sizeUnit;
		requestString["groupBy"] = groupBy;
		if (drillFrom) {
			requestString["drillFrom"] = drillFrom;
			requestString["drillEntity"] = drillEntity;
		}
	};

	report.initComponents = function() {
		$("#exportcsv").hide();

		var arrowAction = function(arrow, event) {
			arrow.parent().siblings().slideToggle("fast");
			if (arrow.hasClass("expand")) {
				arrow.removeClass("expand").addClass("collapse");
			} else {
				arrow.removeClass("collapse").addClass("expand");
			}
			event.stopPropagation();
			event.preventDefault();
		};
		$(".repHolder").find(".arrowPlaceholder").click(function(event) {
			arrowAction($(this), event);
		});

		$("#surveyName").html('Chargeback');

		$("#discount").click(function(event) {
			updateDiscountComponent();
		});

		var billingLinks = "<li class='rightMenu  hideOnExportFriendly globalPrice hide'><a id='global_price' http=''>" +
				cvUtil.cvLocalize("chargeback.global.title.Global_Price") + "</a></li>";

		billingLinks += "<li class='rightMenu hideOnExportFriendly billingTags nobar hide'>";
		var billingUrl = "manageBilling.jsp";
		if (commUniId > 0) {
			billingUrl += "?commUniId=" + commUniId;
		}
		billingLinks += "<a id='tagsSettings' href='" + billingUrl + "'>" + cvUtil.cvLocalize("BillingTags") +
				"</a></li>";

		$("#headerLinks ul").append(billingLinks);
	};

	report.initComponentState = function() {
		$("#groupBy option[value='" + report.requestString.groupBy + "']").prop('selected', 'selected');

		updateFilters();

		addGlobalPriceButton();
	};
	report.beforeLoadReport = function() {
		reportsUtil.setWorldwideLink();
		report.mask("");
	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=chargebackmonthly&action=chargeback&commUniId=' +
				commUniId + '&json=' + window.encodeURIComponent(JSON.stringify(this.requestString));
	};
	report.getExportFilePrefix = function() {
		var filePre = "Chargeback";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		} else {
			filePre = 'Worldwide - ' + filePre;
		}

		return filePre;
	};
	report.onLoadReport = function(data) {
		processResponse(data, true);
		report.attachTableActions();
		report.afterLoadReport();
		report.logReportLoadEvent();
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(data, initialLoad) {
		if (data == undefined || data == null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else if (data && typeof data === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel1").html(data);
			$("#noDataNotificationPanel1").show();
		} else {
			if (data && typeof data === 'object') {
				$("#filterDiv").show();
				$.each(data, function(key, value) {
					if (typeof value == 'object') {
						if (value.viewType == 'clientTableWithPaging' || value.viewType == 'clientTable') {
							var tableDiv = 'entityTable';
							if (initialLoad) {
								var wrapperId = 'ContentWrapper';
								$('#' + wrapperId).append(SurveyTemplates.makeReportTable(tableDiv, value));
							} else {
								$("input[id*='_FilterSelected']").val('');
							}
							var tdata = value.value;
							setFilterRendered(tdata.aoColumns);
							var configTable = true;
							if ((!tdata.aoColumns || tdata.aoColumns.length == 0) &&
									(!tdata.aoColumnDefs || tdata.aoColumnDefs.length == 0)) {
								configTable = false;
							}
							if (configTable) {
								if (value.viewType == 'clientTable') {
									Reports.configureClientSideTable(tableDiv, value.title, tdata);
								} else {
									Reports.configureClientSideTableWithPaging(tableDiv, value.title, tdata);
								}
							}
							$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
							var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
							pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
							$("#" + tableDiv + "_title").html(value.title);

							/*
							 * if(value.totalRows > value.maxRows){ var title = 'This table is showing only
							 * '+value.maxRows+' of ' + value.totalRows + ' entries. Filters and Sorting will
							 * work on loaded data only. To view full data, please use CSV export.'; var note = "<span
							 * id='"+tableDiv+"_rows_note' class='tableRowsNote' title='"+title+"'>This table
							 * is showing partial data.</span>"; $("#"+tableDiv+"
							 * .rptTblBtnEncDiv").append(note); $("#"+tableDiv).attr('sqlid',
							 * value.sqlExportKey); }
							 */
						} else if (value.viewType == 'literal') {
							if (key == 'noDataNotificationPanel') {
								$("#ContentWrapper").hide();
								$("#meta").hide();
								$("#filterDiv").hide();
								$("#noDataNotificationPanel1").html(value.value);
								$("#noDataNotificationPanel1").show();
							} else if (key == 'surveyList') {
								$("#surveyName").html(value.value.selectedSurvey);
							}
						} else if (value.viewType == 'custom') {
							customRender(key, value);
						}

						$("#" + key + "_nodata").hide();
						$("#" + key).show();
					} else if (key == 'dataAvailable') {
						dataAvailable = value;
						if (!dataAvailable) {
							$("#ContentWrapper").hide();
							$("#noDataNotificationPanel1").html(data.errorMsg.value);
							$("#noDataNotificationPanel1").show();

							$("#filters").hide();

						}
					} else if (key == 'hasSurveyCapability') {
						var hasSurveyCapability = value;
						if (!hasSurveyCapability) {
							$("#content").addClass('noSurveyCapability');
						} else {
							$("#content").removeClass('noSurveyCapability');
						}
					} else if (key == 'isChargebackOnPublic') {
						reportsUtil.setWorldwideLink(!value);
					} /*
						 * else if (key === 'showChargebackTrends'){ if(value == true){
						 * $('.chargebackTrends').show(); } }
						 */
				});
				/*
				 * if($("#global_price").length <= 0){ addGlobalPriceButton(); }
				 */

				if (data.isChargebackOnPublic == true) {
					$("#commcellUrl").addClass("disabled");
				}
			} else if (typeof data === 'string') {
				//$("#filterDiv").hide();
				$("#global_price").hide();
				$("#noDataNotificationPanel").html(data);
				$("#noDataNotificationPanel").show();
			}
		}
	}

	function addSummarySection(tableDiv) {
		if (isReportMetadataCall !== null) {
			return;
		}

		var summary = "<table id=\"reportSummary\">";

		var sDate = (startDate == 1) ? exportLatestDate : startDate,
		// Abstract out the interval details
		interval = {};

		if (repType == 1) {
			// Handle monthly intervals
			interval = {
				label : "Month",
				dateStr : moment(sDate).format("MMM YYYY")
			};
		} else if (repType == 2) {
			// Handle weekly intervals
			interval = {
				label : "Week",
				dateStr : moment(sDate).format("MMM DD, YYYY") + " - " +
						moment(sDate).add('days', 6).format("MMM DD, YYYY")
			};
		} else {
			// Handle daily intervals
			interval = {
				label : "Day",
				dateStr : moment(sDate).format("MMM DD, YYYY")
			};
		}

		if (exportRequest) {
			summary += "<tr><td><u>" + cvUtil.cvLocalize("Summary") + "</u></td><td></td></tr>";
		}

		if (exportRequest) {
			var groupStr = groupBy;
			if (groupBy === 'CommCell') {
				groupStr = cvUtil.cvLocalize("CommCells");
			} else if (groupBy === 'ClientGroup') {
				groupStr = cvUtil.cvLocalize("ClientGroups");
			} else if (groupBy === 'Client') {
				groupStr = cvUtil.cvLocalize("Clients");
			} else if (groupBy === 'SubClient') {
				groupStr = cvUtil.cvLocalize("SubClients");
			} else if (groupBy === 'SubClientPerCopy') {
				groupStr = cvUtil.cvLocalize("SubClientPerCopy");
			} else if (groupBy === 'BillingTag') {
				groupStr = cvUtil.cvLocalize("BillingTags");
			} else if (groupBy === 'Tenant') {
				groupStr = cvUtil.cvLocalize("Tenants");
			}
			summary += "<tr><td>" + cvUtil.cvLocalize("GroupBy") + ":</td><td> " + groupStr + "</td></tr>";

			summary += "<tr>" + "<td>" + interval.label + ":</td>" + "<td> " + interval.dateStr + "</td>" + "</tr>";

			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.SizeUnit") + ":</td><td> " + sizeUnit + "</td></tr>";
			var excludeSC = isChecked($("#excludeDeSCs")) ? 'Yes' : 'No';
			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.Exclude_Deconfigured_Subclients") + ":</td><td> " +
					excludeSC + "</td></tr>";
			var showFET = isChecked($("#showFET")) ? 'Yes' : 'No';
			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.show_fet_vsa_ida") + ":</td><td> " + showFET +
					"</td></tr>";
			var includeSubclients = isChecked($("#includeDRSubclients")) ? 'Yes' : 'No';
			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.include_subclients") + ":</td><td> " +
					includeSubclients + "</td></tr>";
			var primaryCopy = isChecked($("#primaryCopyOnly")) ? 'Yes' : 'No';
			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.primary_copy_only") + ":</td><td> " + primaryCopy +
					"</td></tr>";
			var totals = isChecked($("#showTotals")) ? 'Yes' : 'No';
			summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.show_totals") + ":</td><td> " + totals + "</td></tr>";
		} else {
			summary += "<tr>" + "<td>" + cvUtil.cvLocalize("Timeframe") + ":</td> " + "<td>" + interval.dateStr +
					"</td>" + "</tr>";
		}

		if ((exportRequest && requestString["drillFrom"]) || requestString["drillFrom"] == 'BillingTag' ||
				requestString["drillFrom"] == 'Tenant') {
			var totalCost = cvUtil.getParameter('totalCost');
			var drillFrom = requestString["drillFrom"];
			var drillData = '';
			var totalCostStr = '';
			if (drillFrom == 'ClientGroup') {
				summary += "<tr><td>" + cvUtil.cvLocalize("audit.label.Client_Group") + ":</td><td> " + drillEntity +
						"</td></tr>";
				drillData += "<span>" + cvUtil.cvLocalize("audit.label.Client_Group") + ": " + drillEntity + "</span>";
				totalCostStr = cvUtil.cvLocalize("chargeback.summary.label.Total_Cost_Client_Group");
			} else if (drillFrom == 'Client') {
				var list = drillEntity.split(';');
				summary += "<tr><td>" + cvUtil.cvLocalize("CommCell") + ":</td><td> " + list[1] + "</td></tr>";
				summary += "<tr><td>" + cvUtil.cvLocalize("Client") + ":</td><td> " + list[0] + "</td></tr>";

				drillData += "<span>" + cvUtil.cvLocalize("CommCell") + ": " + list[1] + "</span>";
				drillData += "<span>" + cvUtil.cvLocalize("Client") + ": " + list[0] + "</span>";
				totalCostStr = cvUtil.cvLocalize("chargeback.summary.label.Total_Cost_Client");
			} else {
				summary += "<tr><td>" + drillFrom + ":</td><td> " + drillEntity + "</td></tr>";
				drillData += "<span>" + drillFrom + ": " + drillEntity + "</span>";
				totalCostStr = cvUtil.cvLocalize("chargeback.summary.label.Total_Cost_at", drillFrom);
			}
			totalCostStr += ':';
			summary += "<tr><td>" + totalCostStr + "</td><td> " + totalCost + "</td></tr>";
			drillData += "<span>" + totalCostStr + " " + totalCost + "</span>";
		}

		summary += "</table>";

		$("#chargebackSummaryDiv").html(summary).show();
	}

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}

	function addGlobalPriceButton() {
		if ((isPublicMetricsCloud && isCommvaultUser && commUniId <= 0) ||
				(!isPublicMetricsCloud && (commUniId <= 0 || surveySingleCommcellUser))) {
			$(".globalPrice").removeClass('hide');
			$(".globalPrice").click(function(event) {
				$("#DialogWrapper").removeClass('hide');
				$("#err_msg").hide();
				$("#globalparam-dialog").dialog({
					width : 380,
					//height : 540,
					modal : true,
					buttons : [
							{
								text : cvUtil.cvLocalize('chargeback.global.save.btn.label'),
								'class' : 'global-price-save-btn',
								click : function(event) {
									if (!validCost('fet', cvUtil.cvLocalize("chargeback.global.check.fet"))) {
										return;
									}
									if (!validCost('fetarchive', cvUtil
											.cvLocalize("chargeback.global.check.fetarchive"))) {
										return;
									}
									if (!validCost('primaryapp', cvUtil
											.cvLocalize("chargeback.global.check.primaryapp"))) {
										return;
									}
									if (!validCost('datawritten', cvUtil
											.cvLocalize("chargeback.global.check.datawritten"))) {
										return;
									}
									if (!validCost('dataprotected', cvUtil
											.cvLocalize("chargeback.global.check.dataprotected"))) {
										return;
									}
									if (!validCost('totaldataprotected', cvUtil
											.cvLocalize("chargeback.global.check.totaldataprotected"))) {
										return;
									}
									if (!validCost('totaldatawritten', cvUtil
											.cvLocalize("chargeback.global.check.totaldatawritten"))) {
										return;
									}
									if (!validCost('adminclient', cvUtil
											.cvLocalize("chargeback.global.check.adminclient"))) {
										return;
									}
									if (!validCost('adminsubclient', cvUtil
											.cvLocalize("chargeback.global.check.adminsubclient"))) {
										return;
									}
									if (isDiscountSelected()) {
										if (!validateDiscount('discountpercent', cvUtil
												.cvLocalize("chargeback.global.check.discountpercent"), true)) {
											return;
										}
										if (!validateDiscount('discountsize', cvUtil
												.cvLocalize("chargeback.global.check.discountsize"), false)) {
											return;
										}
									}
									setGlobalParam();
									$(this).dialog("close");
								}
							},
							{
								text : cvUtil.cvLocalize('Close'),
								click : function() {
									setCostDetailsToUI();
									$(this).dialog("close");
								}
							} ]
				});
			});
		}
	}

	/* This method will be used in the formatter to return the hex value of a commcell id. */
	function decimalToHex(d, padding) {
		var hex = Number(d).toString(16);
		padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;
		while (hex.length < padding) {
			hex = "0" + hex;
		}
		return hex.toUpperCase();
	}

	function setGlobalParam() {
		report.requestString["globalparam"] = true;
		report.requestString["fet"] = $("#fet").val() || 0;
		report.requestString["datawritten"] = $("#datawritten").val() || 0;
		report.requestString["adminclient"] = $("#adminclient").val() || 0;
		report.requestString["adminsubclient"] = $("#adminsubclient").val() || 0;
		report.requestString["dataprotected"] = $("#dataprotected").val() || 0;
		report.requestString["totaldataprotected"] = $("#totaldataprotected").val() || 0;
		report.requestString["totaldatawritten"] = $("#totaldatawritten").val() || 0;
		report.requestString["fetarchive"] = $("#fetarchive").val() || 0;
		report.requestString["primaryapp"] = $("#primaryapp").val() || 0;
		if (isDiscountSelected()) {
			report.requestString["discountlevel"] = $("#discountlevel").val() || -1;
			report.requestString["discountpercent"] = $("#discountpercent").val() || 0;
			report.requestString["discountsize"] = $("#discountsize").val() || 0;
		} else {
			report.requestString["discountlevel"] = -1;
			report.requestString["discountpercent"] = 0;
			report.requestString["discountsize"] = 0;
		}

		var configURL = report.getRequestUrl();

		report.mask("");
		cvUtil.loadPageWithPOST(configURL, "", function(data) {
			window.location.reload();
		});
	}

	function customRender(key, model) {
		if (key == 'customerInfo') {
			customerName = model.value.Customer;
			collectiontime = model.value.time;
			GUID = model.value.CommServeGUID;

			if (customerName != null && customerName != " " && $.trim(customerName).length != 0) {
				$('#custName').html(customerName + ' -&nbsp;');
				$('.reportsLink').text(customerName + ' (Reports)');
				$(document).attr("title", customerName + " - " + $(document).attr("title"));
				cvUtil.GUIAuditReportLog($("#surveyName").text().trim(), customerName);
			}

			if (commUniId > 0 && (collectiontime != '') && GUID != undefined) {
				GUID = registrationCode(GUID);
				$("#timeZone").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Time_zone") + ': ' +
						model.value.TimeZone + '</span>');
				/*
				 * $("#metaAsOf").html('<span>' + cvUtil.cvLocalize("commcell.info.label.As_of") + ': ' +
				 * collectiontime + '</span>');
				 */
				$("#metaCCId").html('<span>' + cvUtil.cvLocalize("commcell.info.label.CommCell_ID") + ': ' +
						model.value.CommCellHexID + '</span>');
				$("#GUID").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Registration_Code") + ': ' + GUID +
						'</span>');
				if (model.value.GroupName) {
					$('.commcellsLink').text(model.value.GroupName + ' (' + cvUtil.cvLocalize("CommCells") + ')');
				}
			}
		} else if (key == 'globalParamInfo') {
			costDetails.fet = model.value.fet;
			costDetails.datawritten = model.value.datawritten;
			costDetails.adminclient = model.value.adminclient;
			costDetails.adminsubclient = model.value.adminsubclient;
			costDetails.dataprotected = model.value.dataprotected;
			costDetails.totaldataprotected = model.value.totaldataprotected;
			costDetails.totaldatawritten = model.value.totaldatawritten;
			costDetails.fetarchive = model.value.fetarchive;
			costDetails.primaryapp = model.value.primaryapp;
			costDetails.discountlevel = model.value.discountlevel;
			costDetails.discountpercent = model.value.discountpercent;
			costDetails.discountsize = model.value.discountsize;
			setCostDetailsToUI();
		} else if (key == "monthsView") {
			// Build markup for interval selection
			var datesOptionHtml = "",

			// Function to create a datepicker for the daily interval
			createDatePicker = function(repType) {
				return function() {
					var interval = intervals[typeIdx[repType]], pickerHtml = " <select id='" + interval.id +
							"_dropdown' class='chargebackInputsOptions chargebackDateSelect " +
							interval.label.toLowerCase() + "' data-repType='" + interval.index + "'>" +
							"<option value='latest'>" + cvUtil.cvLocalize("Latest") + "</option>" +
							"<option value='custom'>" + cvUtil.cvLocalize("Custom") + "</option>" +
							"</select><input readonly type='text' size='15' id='" + interval.id + "' data-repType='" +
							interval.index + "' class='chargebackInputsOptions chargebackDateSelect datepicker'>";

					return pickerHtml;
				};
			},

			// Function to set the value of a datepicker for the daily
			// interval
			setDatePickerVal = function(repType) {
				return function(value) {
					var interval = intervals[typeIdx[repType]];
					$("#" + interval.id).datepicker("setDate", moment(value)._d);
				};
			},

			// Function to get the value from a an datepicker for the daily
			// interval
			getIntervalDatePickerVal = function(repType) {
				return function() {
					var interval = intervals[typeIdx[repType]], $dropdown = $("#" + interval.id + "_dropdown");

					if ($dropdown.val() === "custom") {
						return $("#" + interval.id).val();
					} else {
						return 1;
					}
				};
			},

			// Function to create a select dropdown for the weekly and
			// monthly intervals
			createIntervalSelect = function(repType) {
				return function() {
					var interval = intervals[typeIdx[repType]], selectHtml = " <select id='" + interval.id +
							"' class='chargebackInputsOptions chargebackDateSelect " + interval.label.toLowerCase() +
							"' data-repType='" + interval.index + "'><option value='1'>" + cvUtil.cvLocalize("Latest") +
							"</option>", j;

					// Create options in the dropdown for each value
					for (j = 0; j < interval.values.length; ++j) {
						var date = interval.values[j];

						selectHtml += "<option value='" + date + "'>" + interval.getDateString(date) + "</option>";
					}

					selectHtml += "</select>";

					return selectHtml;
				};
			},

			// Function to set the value of a select dropdown for an
			// interval
			setIntervalSelectVal = function(repType) {
				return function(value) {
					var interval = intervals[typeIdx[repType]];
					$("#" + interval.id).find("option[value='" + value + "']").attr("selected", "selected");
				};
			},

			// Function to get the value from a an input for an
			// interval
			getIntervalSelectVal = function(repType) {
				return function() {
					var interval = intervals[typeIdx[repType]];
					return $("#" + interval.id).val();
				};
			},

			// Map from report type to interval index
			typeIdx = {
				"1" : 0,
				"2" : 1,
				"4" : 2
			},

			// List of interval types and info
			intervals = [
					{
						label : "Monthly",
						id : "months_list",
						values : model.value[1],
						index : 1,
						createPicker : createIntervalSelect(1),
						getStartDate : getIntervalSelectVal(1),
						setStartDate : setIntervalSelectVal(1),
						getDateString : function(date) {
							return moment(date).format("MMM YYYY");
						}
					},
					{
						label : "Weekly",
						id : "weeks_list",
						values : model.value[2],
						index : 2,
						createPicker : createIntervalSelect(2),
						getStartDate : getIntervalSelectVal(2),
						setStartDate : setIntervalSelectVal(2),
						getDateString : function(date) {
							return moment(date).format("MMM DD, YYYY") + " - " +
									moment(date).add("days", 6).format("MMM DD, YYYY");
						}
					},
					{
						label : "Daily",
						id : "days_list",
						values : model.value[4],
						index : 4,
						createPicker : createDatePicker(4),
						getStartDate : getIntervalDatePickerVal(4),
						setStartDate : setDatePickerVal(4),
						getDateString : function(date) {
							return moment(date).format("MMM DD, YYYY");
						}
					} ],

			// Whether or not multiple interval sizes are available
			multipleTypes = false,

			// Update the report type based on available results
			updateRepType = function() {
				repType = Number($("input[name='repType']:checked").val());

				// If there is no data for the requested interval type, try
				// alternatives
				if (isNaN(repType) || !intervals[typeIdx[repType]].values) {
					// Try URL
					repType = Number(cvUtil.getParameter("repType", NaN));
				}
				if (isNaN(repType) || !intervals[typeIdx[repType]].values) {
					// Handle monthly intervals
					repType = 1;
				}
				if (!intervals[typeIdx[repType]].values) {
					// Handle weekly intervals
					repType = 2;
				}
				if (!intervals[typeIdx[repType]].values) {
					// Handle daily intervals
					repType = 4;
				}
			},

			// Display the dropdown for the current report type
			showDropdown = function(repType) {
				$(".chargebackDateSelect").hide() // Hide all dropdowns
				.filter("[data-repType=" + repType + "]").not(".hidden").show(); // Show the selected one
			},

			// Counters and utility variables for loops
			i, interval, count;

			// Identify if there is more than one possible type
			count = 0;
			for (i = 0; i < intervals.length; ++i) {
				if (intervals[i].values) {
					count++;
				}
			}
			multipleTypes = count > 1;

			if (multipleTypes) {
				// If there are multiple types, generate radio buttons to
				// choose between them
				for (i = 0; i < intervals.length; ++i) {
					interval = intervals[i];

					if (interval.values) {
						datesOptionHtml += "<input type='radio' name='repType' value='" + interval.index + "'>" +
								interval.label;
					}
				}
			} else {
				// Otherwise, find the single type which has values associated
				// to it and just display its label
				for (i = 0; i < intervals.length; ++i) {
					interval = intervals[i];

					if (interval.values) {
						datesOptionHtml = interval.label;
						break;
					}
				}
			}

			// Create a picker for each possible interval type
			for (i = 0; i < intervals.length; ++i) {
				interval = intervals[i];

				if (interval.values) {
					datesOptionHtml += interval.createPicker();
				}
			}

			// By default, set the start date to the most recent date in the
			// selected interval dropdown
			if (startDate == 1) {
				updateRepType();
				exportLatestDate = intervals[typeIdx[repType]].values[0];
			}

			// Inject the built markup and initialize the datepicker if relevant
			$(".chargeback-time-frame")
					.append(datesOptionHtml)
					.find("#" + intervals[2].id + ".datepicker")
					.each(function() {
						var dates = intervals[2].values, minDate = maxDate = dates[0], dateLookup = {}, $datepicker = $(this);
						$dropdown = $("#" + intervals[2].id + "_dropdown"), i;

						// Compute the range of valid dates
						for (i = 0; i < dates.length; ++i) {
							if (dates[i] > maxDate) {
								maxDate = dates[i];
							}
							if (dates[i] < minDate) {
								minDate = dates[i];
							}

							dateLookup[moment(dates[i]).format("YYYY-MM-DD")] = true;
						}

						// Only show the datepicker input if the custom date option is
						// selected
						$dropdown.change(function() {
							$datepicker.toggleClass("hidden", $(this).val() === "latest")
									.toggle($(this).val() === "custom");
						}).trigger("change");

						$datepicker.datepicker({
							minDate : moment(minDate)._d,
							maxDate : moment(maxDate).add("days", 1)._d,
							showAnim : "slideDown",
							dateFormat : "M dd, yy",
							hideIfNoPrevNext : true,
							beforeShowDay : function(date) {
								// Note: The '!!' casts undefined to false. Normally
								// not recommended since undefined is a false value
								// anyway, but since it is going to jQuery UI's
								// internals and not our own, better to be safe.
								return [ !!dateLookup[moment(date).format("YYYY-MM-DD")], "" ];
							}
						});

						intervals[2].setStartDate(moment(maxDate));
					});

			// Show the appropriate dropdown when the interval type changes
			$("input[name=repType]:radio").change(function() {
				showDropdown($("input[name='repType']:checked").val());
			});

			// Select initial interval type
			$("input[name='repType'][value='" + repType + "']").prop("checked", true);

			// Show dropdown for initial interval type
			showDropdown(repType);

			$("#advfilterDiv").show();
			setChecked($('#excludeDeSCs'), (parseInt(excludeDeconfigSubclients) === 1));
			setChecked($('#showFET'), (parseInt(showFETforVSAnIda) === 1));
			setChecked($('#showTotals'), (parseInt(showTotals) === 1));
			setChecked($('#includeDRSubclients'), (parseInt(includeDRSubclients) === 1));
			setChecked($('#primaryCopyOnly'), (parseInt(primaryCopyOnly) === 1));

			if (!dataAvailable) {
				$(".chargebackGenerate").hide();
			}

			if (model.filters) {
				$(".billingTags").removeClass('hide');
			}
			$('.chargebackTrends').click(function(e) {
				var trendsHref = "chargebackTrends.jsp";
				if (commUniId > 0) {
					trendsHref += "?commUniId=" + commUniId;
				}

				if (ccGroupId > 0) {
					trendsHref += (trendsHref.indexOf('?') < 0) ? '?' : '&';
					trendsHref += "ccGroupId=" + ccGroupId;
				}
				if (companyId > 0) {
					trendsHref += (trendsHref.indexOf('?') < 0) ? '?' : '&';
					trendsHref += "companyId=" + companyId;
				}
				trendsHref += (trendsHref.indexOf('?') < 0) ? '?' : '&';
				var interval = repType;
				if ($("input[name='repType']").length > 0) {
					interval = $("input[name='repType']:checked").val();
				}
				if (interval == 4) {
					trendsHref += "intervalType=1";
				} else if (interval == 2) {
					trendsHref += "intervalType=2";
				} else {
					trendsHref += "intervalType=3";
				}
				trendsHref += "&excludeDeSCs=" + (isChecked($("#excludeDeSCs")) ? 1 : 0);
				trendsHref += "&includeDRSubclients=" + (isChecked($("#includeDRSubclients")) ? 1 : 0);
				trendsHref += "&primaryCopyOnly=" + (isChecked($("#primaryCopyOnly")) ? 1 : 0);

				var startDate = intervals[typeIdx[interval]].getStartDate();
				if (parseInt(startDate) === 1) {
					window.location.href = trendsHref;
				} else {
					startDate = moment(startDate).format("YYYY-MM-DD");
					window.location.href = trendsHref + "&endDate=" + startDate;
				}

			});
			$(".chargebackGenerate").click(function(el) {
				report.mask("");
				var groupBy = $("#groupBy").val();
				var size = $("#sizeunit_list").val();

				// Update relevant metadata from input values
				updateRepType();
				exportLatestDate = intervals[typeIdx[repType]].values[0];
				startDate = intervals[typeIdx[repType]].getStartDate();

				report.requestString["groupBy"] = groupBy;
				report.requestString["startDate"] = startDate;
				report.requestString["sizeUnit"] = size;
				report.requestString["repType"] = repType;
				report.requestString["excludeDeSCs"] = isChecked($("#excludeDeSCs")) ? 1 : 0;
				report.requestString["includeDRSubclients"] = isChecked($("#includeDRSubclients")) ? 1 : 0;
				report.requestString["primaryCopyOnly"] = isChecked($("#primaryCopyOnly")) ? 1 : 0;
				report.requestString["showFET"] = isChecked($("#showFET")) ? 1 : 0;
				report.requestString["showTotals"] = isChecked($("#showTotals")) ? 1 : 0;
				updateTableData();
				addSummarySection();
			});

			// Set the initial start date
			intervals[typeIdx[repType]].setStartDate(report.requestString.startDate);

			$("#sizeunit_list option[value='" + report.requestString.sizeUnit + "']").attr("selected", "selected");
			addSummarySection("entityTable");
		}

		function updateTableData() {
			delete requestString["drillFrom"];
			delete requestString["drillEntity"];
			delete requestString["totalCost"];
			Reports.clearTableParams();
			var configURL = cvUtil.getContextPath() +
					'/server/cloudsurvey.do?type=chargebackmonthly&action=entitytable&commUniId=' + commUniId +
					'&json=' + window.encodeURIComponent(JSON.stringify(report.requestString));
			report.mask("");
			cvUtil.loadPageWithPOST(configURL, "", function(data) {
				processResponse(data, false);
				report.afterLoadReport();
				var filterOn = $("#entityTable_FilterButton").hasClass("filterOn");
				if (filterOn) {
					//$("#entityTable_FilterButton").click();
					$("#entityTable_FilterButton").toggleClass("filterOn");
				}

				addSummarySection('entityTable');
				report.unmask();
			});
		}
	}

	function setCostDetailsToUI() {
		$("#fet").val(costDetails.fet);
		$("#datawritten").val(costDetails.datawritten);
		$("#adminclient").val(costDetails.adminclient);
		$("#adminsubclient").val(costDetails.adminsubclient);
		$("#dataprotected").val(costDetails.dataprotected);
		$("#totaldataprotected").val(costDetails.totaldataprotected);
		$("#totaldatawritten").val(costDetails.totaldatawritten);
		$("#fetarchive").val(costDetails.fetarchive);
		$("#primaryapp").val(costDetails.primaryapp);
		selectDiscount(costDetails.discountlevel != -1);
		/*
		 * if(costDetails.discountlevel != -1 ){ selectDiscount(true); }else{ selectDiscount(false); }
		 */
		setDiscountLevel(costDetails.discountlevel);
		$("#discountpercent").val(costDetails.discountpercent);
		$("#discountsize").val(costDetails.discountsize);

		updateDiscountComponent();
	}

	function setCostDetailsToObj() {
		costDetails.fet = $("#fet").val();
		costDetails.datawritten = $("#datawritten").val();
		costDetails.adminclient = $("#adminclient").val();
		costDetails.adminsubclient = $("#adminsubclient").val();
		costDetails.dataprotected = $("#dataprotected").val();
		costDetails.totaldataprotected = $("#totaldataprotected").val();
		costDetails.totaldatawritten = $("#totaldatawritten").val();
		costDetails.fetarchive = $("#fetarchive").val();
		costDetails.primaryapp = $("#primaryapp").val();
		if (isDiscountSelected()) {
			costDetails.discountlevel = parseInt($("#discountlevel").val());
			costDetails.discountpercent = $("#discountpercent").val();
			costDetails.discountsize = $("#discountsize").val();
		} else {
			costDetails.discountlevel = -1;
		}

	}

	function isDiscountSelected() {
		var res = $('#discount').is(':checked');
		return res;
	}

	function selectDiscount(select) {
		$('#discount').prop('checked', select);
	}

	function setDiscountLevel(id) {
		$("#discountlevel option[value='" + id + "']").prop('selected', 'selected');
	}

	function updateDiscountComponent() {
		$('.discountLi').children().prop('disabled', !isDiscountSelected());
	}

	function validateDiscount(id, msg, percent) {
		var val = $("#" + id).val();
		if ($("#" + id).hasClass('costError')) {
			$("#" + id).removeClass('costError');
		}
		if (parseFloat(val) < 0 || isNaN(val)) {
			$('#err_msg').html(msg);
			$("#err_msg").show();
			$("#" + id).focus();
			$("#" + id).addClass('costError');
			return false;
		}
		var showError = false;
		if (percent) {
			if (parseFloat(val) > 100) {
				msg = cvUtil.cvLocalize("chargeback.global.check.Percentage_cannot_exceed_100");
				showError = true;
			}
		} else {
			if (parseFloat(val) > 99999) {
				msg = cvUtil.cvLocalize("chargeback.global.check.Volume_cannot_exceed_99999");
				showError = true;
			}
		}
		if (showError) {
			$('#err_msg').html(msg);
			$("#err_msg").show();
			$("#" + id).focus();
			$("#" + id).addClass('costError');
			return false;
		}
		return true;
	}

	function validCost(id, msg) {
		var cost = $("#" + id).val();
		if ($("#" + id).hasClass('costError')) {
			$("#" + id).removeClass('costError');
		}
		if (parseFloat(cost) < 0 || isNaN(cost)) {
			$('#err_msg').html(msg);
			$("#err_msg").show();
			$("#" + id).focus();
			$("#" + id).addClass('costError');
			return false;
		}
		var showError = false;
		var values = cost.split('.');

		if (values[1] != undefined && values[1].length > 3) {
			msg = cvUtil.cvLocalize("chargeback.global.check.Cost_can_only_have_3_decimal_places");
			showError = true;
		} else if (parseFloat(cost) > 99999.999) {
			msg = cvUtil.cvLocalize("chargeback.global.check.Cost_cannot_exceed_99999_999");
			showError = true;
		}
		if (showError) {
			$('#err_msg').html(msg);
			$("#err_msg").show();
			$("#" + id).focus();
			$("#" + id).addClass('costError');
			return false;
		}
		return true;
	}

}

function isValideNumber(evt) {
	var keyCode = (evt.which) ? evt.which : evt.keyCode;
	key = String.fromCharCode(keyCode);
	//console.log(keyCode+" : "+key);
	var regex = /[0-9]|\./;
	if (!regex.test(key) &&
	// Backspace and Del
	!(keyCode == 8 || keyCode == 46
	//left and right
	|| keyCode == 37 || keyCode == 39
	//Home and End
	|| keyCode == 35 || keyCode == 36
	//Tab and Shift+Tab
	|| keyCode == 9 || (evt.shiftKey && keyCode == 9))) {
		evt.returnValue = false;
		if (evt.preventDefault) {
			evt.preventDefault();
		}
	}
}

function setFilterRendered(aoColumns) {
	var renderersResultingURLs = [
			"CustomerName",
			"CommCellName",
			"commcellName",
			"commceServ",
			"chargebackCommCellName",
			"chargebackClient",
			"chargebackClientGroup" ];
	for (var i = 0; i < aoColumns.length; i++) {
		var renderer = aoColumns[i].rendererType;
		if (typeof renderer != 'undefined') {
			if ($.inArray(renderer, renderersResultingURLs) > -1) {
				aoColumns[i].bFilterRendered = false;
			}
		}
	}
}

$(document).ready(function() {
	MonthlyChargebackReport();
	report.scaleReport = true;
});

function arrowAction(arrow, event) {
	arrow.parent().siblings().slideToggle("fast");
	if (arrow.hasClass("expand")) {
		arrow.removeClass("expand").addClass("collapse");
	} else {
		arrow.removeClass("collapse").addClass("expand");
	}
	event.stopPropagation();
	event.preventDefault();
};