// ============================================================================
//  Copyright (c) CommVault Systems,
//  All Rights Reserved
//
//  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF CommVault Systems
//  The copyright notice above does not evidence any
//  actual or intended publication of such source code.
//
//  File name: operationsReport.js
//  Author: Hari Ravula
// ============================================================================
function CloudSurvey() {
	var customename = '';
	var collectiontime = '';

	var count = '';
	var chartTypes = ["pieChart", "vBarChart", "hBarChart", "stackedBarChart", "lineChart"];
	var tableTypes = ["clientTable", "clientTableWithPaging", "serverTable"];

	var sid= cvUtil.getParameter('surveyId', 0);
	var surveyId = cvUtil.getParameter('surveyId');
	var ccId = cvUtil.getParameter('commUniId');
	var ccGroupId = cvUtil.getParameter('ccGroupId');
	var companyId = cvUtil.getParameter("companyId", 0);
	var errorCode = cvUtil.getParameter('errorCode', "");
	var exportRequest =cvUtil.getParameter('exportType', "");
	var dashboardData = cvUtil.getParameter('dashboardData', "");
	var mergeWeekend = cvUtil.getParameter("mergeWeekend")=="true"? true:false;
	var skippedJobs = cvUtil.getParameter("skippedJobs")=="true"? true:false;
	var tenant = cvUtil.getParameter('tenant', ''); //Tenant param default : ''
	var strikeAgents = cvUtil.getParameter("strikeAgents", 0);
	var Agents = {FILE_SYSTEM:1, DATABASE:2, EXCHANGE:4, LOTUS_NOTES:8, SHAREPOINT:16, VSA:32};//0-All
	var flag = true;
	var colorCodeFlags = [false, false, false, false, false, false];

	if(!surveyId) {
		surveyId = $('#defaultSurvey').val();
		if(!surveyId) {
			surveyId = 0;
		}
	}

	this.report = new Reports.initReport({
		type: '',
		idtomask: "content",
		directPrint : true

	});

	this.requestString = report.requestString;
	this.requestString.dashboardData = dashboardData;

	report.initializeDefaults= function(){
		if(surveyId != 0) {
			report.requestString.surveyId = surveyId;
		}
		if(ccId) {
			report.requestString.commUniId = ccId;
		}
		if(errorCode) {
			report.requestString.errorCode = errorCode;
		}

		var jobStatus = cvUtil.getParameter('jobStatus');
		if(jobStatus){
			var startDate = cvUtil.getParameter('startDate');
			var endDate = cvUtil.getParameter('endDate');
			report.requestString.jobHistory = true;
			report.requestString.jobStatus = jobStatus;
			report.requestString.startDate = startDate;
			report.requestString.endDate = endDate;
		}
		if(strikeAgents > 0){
			report.requestString.strikeAgents = strikeAgents;
		}
		var type = $('#apptype').val();
		if(!type) {
			type = 'general';
		}
		var dd = cvUtil.getParameter("dd");
		if(dd) {
			this.requestString.dd = dd;
		}
		report.type = type;
	};

	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type='+report.type+'&json='+window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	report.initComponents= function(){
		/*
		if(surveyId==25){
			defaultIDisplayLength=10;
			if(ccId)
			{
				generateTable(surveyId,'GetSurveyDetails',false,true,'FullStrikeTable','indCommCellDetailsPager','Client Strike Details',ccId,'IndCommCell',false, false, true, {});
//				generateTable(surveyId,'GetSurveyDetails',false,true,'IncrementalStrikeTable','indCommCellDetailsPager2','Incremental/Differential Backup Job Strike Details',ccId,'IndCommCell',false, false, true, {"strikeType":"Incremental"});
			}
			else{
				generateTableOnDemand(surveyId,-2,'Client Strike Details', 'FullStrikeTable','indCommCellDetailsPager1',{"strikeType":"Full"});
//				generateTableOnDemand(surveyId,-2,'Incremental/Differential Backup Job Strike Details', 'IncrementalStrikeTable','indCommCellDetailsPager2',{"strikeType":"Incremental"});
			}
			$(document).ajaxStop(function() {
				 // If the ajax completes but tables are not rendered attacheTableActions may fail.
				 // This is not observed but just be sure, waiting for 100ms.
				 setTimeout(function() {
					 report.unmask();
				 }, 100);
				 report.unmask();
			 });
		}
		*/
	};

	report.initComponentState = function(){
		if(surveyId == 25){
			$("#strikeAgents").multiselect({
				includeSelectAllOption : true,
				selectAllValue : 0,
				onChange: function(option, checked, select) {
					toggleApplyBtn();
		        },
		        onSelectAll: function() {
		            toggleApplyBtn();
		        },
		        onDeselectAll: function() {
		        	//Hide Apply button on de-selecting all options
		        	$('#apply-btn').addClass('hide');
	            },
				selectedClass: 'multiselect-selected'
			});
			var agentNamesList = [];
			strikeAgents = parseInt(strikeAgents);
			if(strikeAgents > 0){
				var selected = [];
				if((strikeAgents & Agents.FILE_SYSTEM) == Agents.FILE_SYSTEM){
					selected.push(Agents.FILE_SYSTEM);
					agentNamesList.push(cvUtil.cvLocalize('agent_filesystem'));
				}
				if((strikeAgents & Agents.DATABASE) == Agents.DATABASE){
					selected.push(Agents.DATABASE);
					agentNamesList.push(cvUtil.cvLocalize('agent_database'));
				}
				if((strikeAgents & Agents.EXCHANGE) == Agents.EXCHANGE){
					selected.push(Agents.EXCHANGE);
					agentNamesList.push(cvUtil.cvLocalize('agent_exchange'));
				}
				if((strikeAgents & Agents.LOTUS_NOTES) == Agents.LOTUS_NOTES){
					selected.push(Agents.LOTUS_NOTES);
					agentNamesList.push(cvUtil.cvLocalize('agent_lotusnotes'));
				}
				if((strikeAgents & Agents.SHAREPOINT) == Agents.SHAREPOINT){
					selected.push(Agents.SHAREPOINT);
					agentNamesList.push(cvUtil.cvLocalize('agent_sharepoint'));
				}
				if((strikeAgents & Agents.VSA) == Agents.VSA){
					selected.push(Agents.VSA);
					agentNamesList.push(cvUtil.cvLocalize('agent_vsa'));
				}
				$("#strikeAgents").multiselect('select', selected);
			}else{
				$("#strikeAgents").multiselect('selectAll', false);
				$('#strikeAgents').multiselect('updateButtonText');
				agentNamesList.push(cvUtil.cvLocalize('all'));
			}
			if(exportType && exportType != 'csv'){
				$('#strikeAgentsListVal').text(agentNamesList.toString());
				$('.export-summary').removeClass('hide');
			}

			$('#reportFilters').removeClass('hide');
			$("#apply-btn").click(function(){
				if(surveyId == 25){
					var selectedAgents = 0;
					var selectedList = $("#strikeAgents").val();
					if(selectedList.length < Object.keys(Agents).length){
						selectedList.forEach(function(val){
							val = parseInt(val);
							selectedAgents = selectedAgents | val;
						});
					}
					strikeAgents = getSelectedAgents();
					report.requestString["strikeAgents"]=strikeAgents;
					report.updateHash(true);
					if(ccId > 0){
						$('#summary25').empty();
						$('#FullStrikeTable').empty();
					}else{
						$('#details25').empty();
					}
				}
				$('#apply-btn').addClass('hide');
				report.loadReport();

			});
			function toggleApplyBtn(){
				var selected = getSelectedAgents();
				if(selected == -1 || strikeAgents == selected){
					$('#apply-btn').addClass('hide');
				}else{
					$('#apply-btn').removeClass('hide');
				}
			}
			function getSelectedAgents(){
				var selectedAgents = -1;
				var selectedList = $("#strikeAgents").val();
				if(selectedList){
					selectedAgents = 0;
					if(selectedList.length < Object.keys(Agents).length){
						selectedList.forEach(function(val){
							val = parseInt(val);
							selectedAgents = selectedAgents | val;
						});
					}
				}
				return selectedAgents;
			}
		}
	};

	report.getExportFilePrefix = function(){
		var filePre = $("#surveyName").text() || "Activity";
		var unicID = cvUtil.getParameter('commUniId', 0);
		if(unicID <= 0 && !customename) {
			filePre = 'Worldwide' + ' ' + filePre;
		}
		if(customename != '') {
			filePre = customename + ' - ' + filePre;
		}
		return filePre;
	};

	report.beforeLoadReport = function() {
		// you are in commcell level

		var wwLinkParams = [];

		if(ccId > 0) {
			if(!surveyId) {
				if(errorCode) {
					$("#surveyName").html(cvUtil.cvLocalize("report.title.Jobs_Affected_with_Error_Codes"));
				}
			} else if(errorCode!='') {
				$("#headerSearchCC").css("visibility", "hidden");
			} else {
				wwLinkParams.push("surveyId=" + surveyId);
			}
		} else { // you are in worldwide level
			if(ccGroupId >0 && surveyId){
				wwLinkParams.push("surveyId=" + surveyId);
			}
			if(surveyId == 51 || errorCode!='') {
				$("#headerSearchCC").css("visibility", "hidden");
				if(errorCode) {
					$("#headerSearchCC").css("visibility", "hidden");
					$("#surveyName").html(cvUtil.cvLocalize("report.title.Jobs_Affected_with_Error_Codes"));
				}
			}
			$(document).attr("title", cvUtil.cvLocalize("Worldwide")+" " + $(document).attr("title"));
		}
		if(cvUtil.getParameter('tenant', '') != ''){
			wwLinkParams.push("tenant=" + encodeURIComponent(cvUtil.getParameter('tenant')));
		}
		var showWW = true;
		if (typeof metricsInstalled != "undefined" && metricsInstalled == false) {
			showWW = false;
		}

		reportsUtil.setWorldwideLink(showWW, wwLinkParams);
		report.mask("");
		buildRequestObject();
	};

	report.afterLoadReport = function(){
		report.attachTableActions();
		var reportNamePrefix  = ( $('#custName').text() ? $('#custName').text() + "_" : "")
								+ $.trim($('#surveyList option:selected').text()) || $("#surveyName").text();
		var customerName = $("#custName").text().trim();
		var surveyName = $("#surveyName").text().trim();
		if(customerName){
			cvUtil.GUIAuditReportLog(surveyName ,customerName.replace(/\s-\s*/g, "").replace(/\s-&nbsp;*/g, ""));
		}else{
			cvUtil.GUIAuditReportLog(surveyName ,"WorldWide");
		}
		Reports.exportToExcelPrefix = reportNamePrefix.replace(/\s-\s/g, "").replace(/\s-&nbsp;/g, "").replace(/\s/g, "_");

		if(!cvUtil.getParameter('exportType')||Reports.isFilteredTable()) {
			$('.tableFilter').each(function(idx, elem){
				Reports.filterClick($(elem).closest('.reportTable').attr('id'), 'expand');
			});
		}
	};

	report.defaultSortColumn=function(gridid, aoColumns){
		if(gridid=='summary' || gridid=='summary25')
			return aoColumns[0].mDataProp;
	};
	report.defaultSortOrder=function(gridid, aoColumns){
		return 'desc';
	};
	report.onLoadReport = function (data) {
		if(data == undefined || data == null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		}
		else {
			if(data && typeof data === 'object') {
				$.each(data, function(key, value){
					if(typeof value == 'object') {
						if(value.viewType == 'literal') {
							if(key == "participient_count"){
								count = value.value;
								if(ccId <=0){
									$('#metaTotalCCs').empty();
									$('#metaTotalCCs').append(cvUtil.cvLocalize("Participating_CommCells")+' <span class="commcell">' + count + '</span>');
								}
								var sid = cvUtil.getParameter('surveyId', 0);
								if(count == '0' && sid <=0){
									$('#ContentWrapper').append('<div id="nodata">'+cvUtil.cvLocalize("No_Data_Available")+'</div>');
								}

							} else {
								$("#"+key).html(value.value);
								if(key == 'noDataNotificationPanel') {
									$("#ContentWrapper").hide();
								}
							}
						}



						if(value.viewType=='clientTable'){
							if ((surveyId === 25 && key === 'summary25') ||
								(surveyId === 44 && key === 'summary44')) {
								$('#ContentWrapper').addClass('horizontal-line-top');
							}
							if(cvUtil.getParameter('isAlarm', '') == "true"){
								value.filters = true;
							}
							$('#ContentWrapper').append(SurveyTemplates.makeReportTable(key, value));
							setFilterRendered(value.value);
							value.value.dataURL = value.dataURL;
							Reports.configureClientSideTable(key, value.title, value.value);
							$("#"+key+" .rptTblBtnEncDiv").append($("#"+key+"_table_length"));
						}
						if(value.viewType == 'clientTableWithPaging') {
							$('#ContentWrapper').append(SurveyTemplates.makeReportTable(key, value));
							if(exportRequest){
								value.value.iDisplayLength = -1;
							}
							setFilterRendered(value.value);
							value.value.dataURL = value.dataURL;
							Reports.configureClientSideTableWithPaging(key, value.title, value.value);
							var details25Div = "details25";
							if(surveyId == 25 && ccId <= 0 && key == details25Div){
								if(exportRequest != 'csv' && exportRequest != 'mhtml'){
									updateClientStrikesTableHeader(details25Div);
								}
							}
							$("#"+key+" .rptTblBtnEncDiv").append($("#"+key+"_table_length"));
							/*if(value.totalRows > value.maxRows){
								var title = 'This table is showing only '+value.maxRows+' of ' + value.totalRows + ' entries. Filters and Sorting will work on loaded data only. To view full data, please use CSV export.';
								var note = "<span id='"+key+"_rows_note' class='tableRowsNote' title='"+title+"'>This table is showing partial data.</span>";
								$("#"+key+" .rptTblBtnEncDiv").append(note);
							}*/

						}
						if(value.viewType=='serverTable'){
							$('#ContentWrapper').append(SurveyTemplates.makeReportTable(key, value));
							Reports.configureTable(key, value.title, value.value, report.requestString, report.getRequestUrl);
							$("#"+key+" .rptTblBtnEncDiv").append($("#"+key+"_table_length"));
						}
						if(value.viewType == 'pieChart') {
							$('#ContentWrapper').append(SurveyTemplates.makeChart(key, value));
							if(key == 'summary23chart'){
								drawSimplePieChart(key+"_container", value.value);
							}else{
							    if(value.value.data.values[0].cell[0]!= null){
							    	createRaphaelPieChart(key+"_container", value.value.data);
							    	$('#summary51Chart_container').append("<div id='successTitle'/>");
							    	var success = value.value.data.labels[0]  +": "+ value.value.data.values[0].cell[0] + '%';
							    	$("#successTitle").html(success);
							    }else{
							    	$('#ContentWrapper').append('<div id="nodata">'+cvUtil.cvLocalize("No_data_available_to_display_chart_or_table")+'</div>');
							    }
								if(value.value.data.values[0].cell[0] <95){
									$("#successTitle").css('color','#d43a52');
								}else{
									$("#successTitle").css('color','#48a451');
								}
							}
						}

						if(value.viewType == 'complex') {

							if(value.value != undefined && $.isEmptyObject(value.value)){
								$('#ContentWrapper').append('<div style="font-weight: bold;padding:4px;clear:both;">'+value.title+'</div>');
								$('#ContentWrapper').append('<div id="nodata">'+cvUtil.cvLocalize("No_data_available_to_display_chart_or_table")+'</div>');
							}else{
								$('#ContentWrapper').append(SurveyTemplates.makeComplexView(key, value));
								if(window.isActivity && $("#ContentWrapper").children("#options").children("#mergeWeekendDiv").length==0){
									$("#ContentWrapper").children("#options").append($("#mergeWeekend").html());
									$("#ContentWrapper").children("#options").children("#mergeWeekendDiv").show();
									var mergeWeekendPropValue = mergeWeekend?"checked":'unchecked';
									$('#mergeWeekendData').attr('data-state', mergeWeekendPropValue );
									$('#mergeWeekendData').addClass(mergeWeekendPropValue);

										$("#ContentWrapper #options #mergeWeekendData").click(function() {
											report.requestString["mergeWeekend"]=$('#mergeWeekendData').attr('data-state')=="checked"?false:true;
											report.updateHash(true);
											mergeWeekend = cvUtil.getParameter("mergeWeekend")=="true"? true:false;
											showHideData();
										});
								}
								if(window.isActivity && $("#ContentWrapper").children("#options").children("#skippedJobsDiv").length==0){
									$("#ContentWrapper").children("#options").append($("#skippedJobs").html());
									$("#ContentWrapper").children("#options").children("#skippedJobsDiv").show();
									var skippedJobsPropValue = skippedJobs?"checked":'unchecked';
									$('#skippedJobsData').attr('data-state', skippedJobsPropValue );
									$('#skippedJobsData').addClass(skippedJobsPropValue);

										$("#ContentWrapper #options #skippedJobsData").click(function() {
											report.requestString["skippedJobs"]=$('#skippedJobsData').attr('data-state')=="checked"?false:true;
											report.updateHash(true);
											skippedJobs = cvUtil.getParameter("skippedJobs")=="true"? true:false;
											showHideData();
										});
								}

									$.each(value.value, function(iKey, iView){
											if(typeof iView == 'object') {
												if($.inArray(iView.viewType, chartTypes) !== -1 ) {
													$('#'+key).append(SurveyTemplates.makeChart(iKey, iView));
													drawBarChart( iView.value, iView.title, iKey+"_container", value.enableDrilldown, value.datePattern);
												} else if($.inArray(iView.viewType, tableTypes) !== -1 ) {
													var titlePresent = $.trim(iView.title).length?true:false;
													if(titlePresent){
														$('#'+key).append(SurveyTemplates.makeReportTable(iKey, iView));
													}else{
														iView.title = value.title;
														$('#'+key).append(SurveyTemplates.makeReportTable(iKey, iView));
														$("#"+iKey+"_title").hide();
														$("#"+iKey).addClass("disableBorder");
													}
													iView.value.dataURL = iView.dataURL;
													if(iView.viewType == 'clientTableWithPaging') {
														Reports.configureClientSideTableWithPaging(iKey, iView.title, iView.value);
													}else if(iView.viewType == 'clientTable'){
														Reports.configureClientSideTable(iKey, iView.title, iView.value);
													}
												}
											} else {
												// should not come here..
												console.log('Unknown value... '+iview);
											}
										});
									showHideData();

							}
						}
						if(value.viewType == 'vBarChart') {
							$('#ContentWrapper').append(SurveyTemplates.makeChart(key, value));
						drawBarChart(value.value, value.title, key+"_container");

						}
						if(value.viewType == 'hBarChart') {
							$('#ContentWrapper').append(SurveyTemplates.makeChart(key, value));
							drawhorizantalBarChart(key+"_container",value.value );
						}
						if(value.viewType == 'stackedBarChart') {

						}
						if(value.viewType == 'lineChart') {
							createRaphaelLinechart(value.value, key);
						}
						if(value.viewType=='custom'){
							if(key === 'surveyList') {
								var enableDropDown = value.value.enableDropDown && (cvUtil.getParameter("dd", "true") === "true" ? true : false);;
								$("#surveyName").html(value.value.selectedSurvey);
//								if(enableDropDown) {
//									$("#surveyList").html(SurveyTemplates.makeSurveyList(key, value.value.surveyGroupList));
//									$("#cust-survey-div").addClass("cust-survey-div");
//									$("#surveyName").append("<span class='downarrow'></span>");
//									SurveyGlobals.addDropDownEvents();
//								}

								$("#survey-list-holder").show();
							} else {
								customRender(key, value);
							}
						}

						$("#"+key+"_nodata").hide();
						$("#"+key).show();
						if(($("#summaryLast7Days51_table")!= undefined && $('#summaryLast7Days51_table')[0] != undefined) && !colorCodeFlags[0]){
							colorCodeFlags[0] = true;
							addColorCodes("summaryLast7Days51");
						}
						if(($("#summaryLast7DaysMergeWeekend51_table")!= undefined && $('#summaryLast7DaysMergeWeekend51_table')[0] != undefined) && !colorCodeFlags[1]){
							colorCodeFlags[1] = true;
							addColorCodes("summaryLast7DaysMergeWeekend51");
						}
						if(($("#summaryLast7DaysSkippedJobs51_table")!= undefined && $('#summaryLast7DaysSkippedJobs51_table')[0] != undefined) && !colorCodeFlags[2]){
							colorCodeFlags[2] = true;
							addColorCodes("summaryLast7DaysSkippedJobs51");
						}
						if(($("#summaryLast7DaysMWSJData51_table")!= undefined && $('#summaryLast7DaysMWSJData51_table')[0] != undefined) && !colorCodeFlags[3]){
							colorCodeFlags[3] = true;
							addColorCodes("summaryLast7DaysMWSJData51");
						}
						if(($("#summaryLast6Months51_table")!= undefined && $('#summaryLast6Months51_table')[0] != undefined) && !colorCodeFlags[4]){
							colorCodeFlags[4] = true;
							addColorCodes("summaryLast6Months51");
						}
						if(($("#summaryLast6MonthsSkippedJobs51_table")!= undefined && $('#summaryLast6MonthsSkippedJobs51_table')[0] != undefined) && !colorCodeFlags[5]){
							colorCodeFlags[5] = true;
							addColorCodes("summaryLast6MonthsSkippedJobs51");
						}
				} else {
					// should not come here..
					console.log('Unknown value... '+value);
				}

			});
		}else if(data && typeof data === 'string') {
				// not expecting string for data, could be error..
				$("#noDataNotificationPanel").html(data);
				$("#ContentWrapper").hide();
				$("#noDataNotificationPanel").show();
			}
			$('#ContentWrapper').append("<div class='clearFloat'/>");

		}
		if(surveyId==25 && ccId > 0 && $("#noDataNotificationPanel").text().trim() == ""){
              defaultIDisplayLength=10;
              var extraParams = {};
              if(strikeAgents > 0){
            	  extraParams.strikeAgents = strikeAgents;
              }

              generateTable(surveyId,'GetSurveyDetails',false,true,'FullStrikeTable','indCommCellDetailsPager','Strike Details',ccId,'IndCommCell',false, false, true,extraParams);
	          $(document).ajaxStop(function() {
                  // If the ajax completes but tables are not rendered attacheTableActions may fail.
                  // This is not observed but just be sure, waiting for 100ms.
                  setTimeout(function() {
                        report.unmask();
                  }, 100);
                  report.unmask();
            });
      }

		report.attachTableActions();
		report.afterLoadReport();
		report.logReportLoadEvent();
	};


	report.updateRequestString= function(){
		updateReportOptions();
	};

	report.init();

	//============================== Add Functions below ================================

	function updateReportOptions(){

	}

	function createRaphaelPieChart(divId, data)
	{
		$("#"+divId).empty();
		var values = data["values"][0].cell;
		values=values.splice(2,values.length);
		var labels = data["labels"];
		labels=labels.splice(2,labels.length);
		labels = $.map(labels, function(val, indx) {
			return val + " - (" + values[indx] + ")";
		});
		var colors=[COLORCODES["SUCCESS"], COLORCODES["PARTIALSUCCESS"], COLORCODES["FAILURE"], '#87CEFA'];
		var arr = SurveyUtil.restrictToMax(labels,values, "");
		Raphael(divId, 600, 350).pieChart(250, 170, 140, arr[1], arr[0],420,30, "#fff",null,colors,false);

	}

	function createHeaders(chart, vals, r){
		for(var i=0;i < vals.length;i++)
		{
			var name = convert(chart.bars[i].value);
			var y = chart.bars[i].y || 280;
			r.text(chart.bars[i].x-10, y - 10,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
		}
	}

	function customRender(key, model){
		if(key == 'customerInfo'){
			var data = model.value.data;
			if((ccId > 0 || ccGroupId > 0 || companyId > 0) && data){
				customename = data.Customer;
				if(customename != ''){
					//$(".smartLinkMain").text($(".smartLinkMain").text());
					$('#custName').html(customename + ' -&nbsp;');
					$('.reportsLink').text(customename+' (Reports)');
					$(document).attr("title", customename + " - " + $(document).attr("title"));
				}
				if(data.CommCellID) {
					$("#metaCCId").html('<span>'+cvUtil.cvLocalize("commcell.info.label.CommCell_ID")+': ' +data.CommCellHexID+'</span>');
				}
				collectiontime = data.time;
				if(collectiontime){
					$("#metaAsOf").html('<span>'+cvUtil.cvLocalize("commcell.info.label.As_of")+': ' + collectiontime + '</span>');
				}
				if(data.TimeZone) {
					$("#timeZone").html('<span>'+cvUtil.cvLocalize("commcell.info.label.Time_zone")+': ' + data.TimeZone + '</span>');
				}
				if(data.CommServeGUID){
					data.CommServeGUID = registrationCode(data.CommServeGUID);
					$("#GUID").html('<span>'+cvUtil.cvLocalize("commcell.info.label.Registration_Code")+': ' + data.CommServeGUID + '</span>');
				}
				if(data.GroupName != null){
					$('.commcellsLink').text(data.GroupName+' ('+cvUtil.cvLocalize("CommCells")+')');
				}
				if(surveyId <=0 && data.MonitoredGroup != null){
					var monitoredGroup = data.MonitoredGroup;
					if (monitoredGroup != undefined && $.trim(monitoredGroup).length != 0 ) {
						$('#metaClientGrp').html('<span>'+cvUtil.cvLocalize("commcell.info.label.Client_Group")+': '+ monitoredGroup +'</span>');
					}
				}
			}

		 }

	}
	function drawhorizantalBarChart(div, data){

		var values = new Array();
		var labels = new Array();
		var colors = new Array();
		var yMax = 0;
		for(var i=0;i<data.data.values.length;i++){
			if(data.data.values[i].cell[0] !=null && data.data.values[i].cell[0] != "<UNDEFINED>"){
				labels .push(data.data.values[i].cell[0]);
				var val = parseInt(data.data.values[i].cell[1]);
				values .push(val);
				colors.push("#0088bb");
			}
		}

		if(values.length) {
			var r = new Raphael(div, 1000, 320);

			var height = 50;
	   		var guitter= 100;

		   for(var i=0;i<labels.length;i++){
			   if(height<300){
				   height = height +50;
			   }
			   if(guitter > 20){
				   guitter= guitter - 10;
			   }

		   }
		   guitter = guitter+'%';


		   var yMax = Math.ceil(Math.max.apply(Math, values));
		   //yMax = getYmax(yMax);

			var chart = r.hbarchart(150, 10, 600, height, values,
					{
						stacked: true,
						axis: "0 0 1 1",
						actualMaxY:yMax,
						xAxisTitle: "AppGroup",
						yAxisTitle: "Clients Count",
						pointlabels: labels,
						showGrid: true,
						showpopup: true,
						colors:colors
					});
			chart.label(labels);
			updatBarChartPopups(chart, labels);
			chart.heightAdjustment(div);
			chart.centerChart(div);
		} else {
			$("#" + div).parent().append('<div class="nodata clearFloat">'+cvUtil.cvLocalize("No_data_available_to_display_chart_or_table")+'</div>');
		}
		$('#ContentWrapper').append("<div class='clearFloat'/>");
	}

	function drawSimplePieChart(divId, data)
	{
		if(data == undefined || data.values == undefined || data.values.length <= 0) {
			dataAvailable(false, divId, divId, cvUtil.cvLocalize("No_Data_Available"));
			return;
		}
		var values = data["values"];
		var labels = data["labels"];
		var total = 0;
		labels = $.map(labels, function(val, indx) {
			total += values[indx];
			return val + " - (" + values[indx] + ")";
		});

		if(total <= 0){
			dataAvailable(false, divId, divId, cvUtil.cvLocalize("No_chartable_data_available"));
			return;
		}

		Raphael(divId, 1000, 380).pieChart(500, 200, 140, values, labels, 720,100, "#fff",null,null,false);
	}


	function drawBarChart(chartData, title, div, enableDrilldown, dPattern){

		var asof=new Array();
		var isMonthly;
		var success=new Array();
		var failure=new Array();
		var killed=new Array();
		var committed=new Array();
		var skipped=new Array();
		var warning=new Array();
		var maxValue=new Array();
		var success_Rate=new Array();
		var datePattern = dPattern || {"pointLabelPattern":"ddd","titlePattern":"MMM D", "popupPattern": "ddd, MMM D"};

		for(var i=0;i<chartData.aaData.length;i++){
			asof.push((chartData.aaData[i]["As Of"]));
			if(chartData.aaData[i]["Completed"] == "-"){
				success.push(parseInt(0));
			}else{
				success.push(parseInt(chartData.aaData[i]["Completed"]));
			}
			if(chartData.aaData[i]["Failed"] == "-"){
				failure.push(parseInt(0));
			}else{
				failure.push(parseInt(chartData.aaData[i]["Failed"]));
			}
			if(chartData.aaData[i]["Killed"] == "-"){
				killed.push(parseInt(0));
			}else{
				killed.push(parseInt(chartData.aaData[i]["Killed"]));
			}
			if(chartData.aaData[i]["Committed"] == "-"){
				committed.push(parseInt(0));
			}else{
				committed.push(parseInt(chartData.aaData[i]["Committed"]));
			}
			// creates the Skipped array only if Skipped data exists. Useful since this function is used for data that both contain and do not contain Skipped Jobs
			if(chartData.aaData[i]["Skipped"] != undefined) {
				if(chartData.aaData[i]["Skipped"] == "-"){
					skipped.push(parseInt(0));
				}else{
					skipped.push(parseInt(chartData.aaData[i]["Skipped"]));
				}
			}
			if(chartData.aaData[i]["Completed with Errors or Warnings"] == "-"){
				warning.push(parseInt(0));
			}else{
				warning.push(parseInt(chartData.aaData[i]["Completed with Errors or Warnings"]));
			}
			if(chartData.aaData[i]["Total"] == "-"){
				maxValue.push(parseInt(0));
			}else{
				maxValue.push(chartData.aaData[i]["Total"]);
			}
			if(chartData.aaData[i]["Success Rate (%)"] == "-"){
				success_Rate.push(parseInt(0));
			}else{
				success_Rate.push(chartData.aaData[i]["Success Rate (%)"]);
			}

	   }
		if(chartData.aaData.length > 0){

			var labels = new Array();
			var popupLabels = new Array();
			var percent = new Array();
			var unit = '';
			for (var i=0,count = 0; i< asof.length; i++,count++) {
				if((div.indexOf("MergeWeekend")>-1 || div.indexOf("MWSJ")>-1) && getDate(asof[i], datePattern.pointLabelPattern).search(/Sat|fri|Sun/i)>-1){
					labels.push(getDate(asof[i], datePattern.pointLabelPattern).replace(/Sat|fri|Sun/i, "Weekend"));
					popupLabels.push(createMergedWeekendBarLabel(asof[i], datePattern.popupPattern, 16 - (count+1)));
					count+=3;
					isMonthly = false;
				}else{
					labels.push(getDate(asof[i], datePattern.pointLabelPattern));
					popupLabels.push(getDate(asof[i], datePattern.popupPattern)+"<div style='font-weight: normal; text-align: center'>"+"Success (%) : " +success_Rate[i]+"</div>");
				}
			}

			var stackLegLabels;
			var stackedValues;
			var showSkippedJobs = (skipped.length > 0);
			if(showSkippedJobs){
				stackLegLabels = [cvUtil.cvLocalize("chart.series.label.Completed"),cvUtil.cvLocalize("chart.series.label.Completed_with_Errors_or_Warnings"),cvUtil.cvLocalize("chart.series.label.Failed"), cvUtil.cvLocalize("chart.series.label.Killed"), cvUtil.cvLocalize("chart.series.label.Skipped"), cvUtil.cvLocalize("chart.series.label.Committed")];
				stackedValues = [success,warning, failure, killed, skipped, committed];
			} else {
				stackLegLabels = [cvUtil.cvLocalize("chart.series.label.Completed"),cvUtil.cvLocalize("chart.series.label.Completed_with_Errors_or_Warnings"),cvUtil.cvLocalize("chart.series.label.Failed"), cvUtil.cvLocalize("chart.series.label.Killed"), cvUtil.cvLocalize("chart.series.label.Committed")];
				stackedValues = [success,warning, failure, killed, committed];
			}

			var yMax = Math.ceil(Math.max.apply(Math, maxValue));
			//yMax = getYmax(y);

			var serLabels =[cvUtil.cvLocalize("chart.series.label.Data_Size_in", unit) ,cvUtil.cvLocalize("chart.series.label.License_Type")];
			var yAxistitle="Job Count";
			var xAxistitle =  getDate(asof[0], datePattern.titlePattern) + " - " +  getDate(asof[asof.length-1], datePattern.titlePattern);
			createBackupStatBarChart(div,stackedValues,stackLegLabels,labels,percent,yMax,serLabels,unit,yAxistitle,xAxistitle, enableDrilldown, asof, popupLabels, isMonthly, showSkippedJobs);
		} else {
			dataAvailable(false, div, div, cvUtil.cvLocalize("No_Data_Available"));
		}

		$('#ContentWrapper').append("<div class='clearFloat'/>");
	}
	function createMergedWeekendBarLabel(date, pattern,count){
		var label = "Weekend ";
		var tempPattern=pattern.replace(/d/g, "");
		var dateMoment  = moment.unix(parseFloat(date)+ getTimezoneOffset(date));
		while(dateMoment.format(pattern).search(/Sat|fri|Sun/i)>-1 && count>0){
			label +=  dateMoment.format(tempPattern);
			dateMoment.add('days', 1);
			count--;
		}
		return label;
	}
	function showJobResults(params){
		sd = getDate(params.startDate, 'YYYY-MM-DD');
		if(params.isMonthly){
			var mm = moment(sd);
			edate = mm.endOf("month").unix();
			ed = moment.unix((parseFloat(edate))).format('YYYY-MM-DD');
		} else {
			ed = sd;
		}
		sd += " 00:00:00";
		ed += " 23:59:59";


		var str = "?";
		var file = 'CommCellSurvey.jsp';
		if(ccId != undefined && ccId){
			file = 'indcommcellsurvey.jsp';
			str += 'commUniId='+ccId+'&';
		}
		var href = window.location.href;
		href = href.replace(window.location.search, "");
		href = href.replace("operations.jsp", file);

		var repType = 'daily';
		var status = '&jobStatus='+params.jobStatus;
		if(params.isMonthly){
			repType = 'monthly';
			status = '&jobStatus=0';
		}
		str += "surveyId=137&startDate="+sd+"&endDate="+ed+"&repType="+repType+status;
		if(cvUtil.getParameter('ccGroupId', -1) > 0){
			str = str + "&ccGroupId=" + cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('tenant', '') != ''){
			str = str + "&tenant=" + encodeURIComponent(cvUtil.getParameter('tenant'));
		}
		if(cvUtil.getParameter('companyId', 0) > 0){
			str = str + "&companyId=" + cvUtil.getParameter('companyId');
		}
		if(skippedJobs)
			str += "&skippedJobs=true";
		href += str;
		window.location.href=href;
	}

	function getHourlyJobResultsURL(params, div){
		if(params.weekend){
			return;
		}
		var sd =getDate(params.startDate, 'YYYY-MM-DD');
		var href = window.location.href;
		href = href.replace(window.location.search, "");
		if(ccId != undefined && ccId){
			href = href.replace("operations.jsp", "indcommcellsurvey.jsp");
		}else{
			href = href.replace("operations.jsp", "CommCellSurvey.jsp");
		}
		var str = "?";
		if(ccId != undefined && ccId) {
			str += "commUniId="+ccId+"&";
		}
		str += "surveyId=51&repType=hourly&startDate="+sd+"&endDate="+sd;
		if(cvUtil.getParameter('ccGroupId', -1) > 0){
			str = str + "&ccGroupId=" + cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('companyId', 0) > 0){
			str = str + "&companyId=" + cvUtil.getParameter('companyId');
		}
		if(cvUtil.getParameter('tenant', '') != ''){
			str = str + "&tenant=" + encodeURIComponent(cvUtil.getParameter('tenant'));
		}
		if(div.match(/skipped/i) || div.match(/sj/i))
			str += "&skippedJobs=true";
		href += str
		return href;
	}

	function getMonthlyJobResultsURL(params, div){
		var sd =getDate(params.startDate, 'YYYY-MM-DD');
		var mm = moment(sd);
		var edate = mm.endOf("month").unix();
		var ed = moment.unix(parseFloat(edate)).format('YYYY-MM-DD');
		sd += " 00:00:00";
		ed += " 23:59:59";

		var href = window.location.href;
		href = href.replace(window.location.search, "");
		if(ccId != undefined && ccId){
			href = href.replace("operations.jsp", "indcommcellsurvey.jsp");
		}else{
			href = href.replace("operations.jsp", "CommCellSurvey.jsp");
		}
		var str = "?";
		if(ccId != undefined && ccId) {
			str += "commUniId="+ccId+"&";
		}
		str += "surveyId=137&repType=monthly&jobStatus=0&startDate="+sd+"&endDate="+ed;
		if(cvUtil.getParameter('ccGroupId', -1) > 0){
			str = str + "&ccGroupId=" + cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('companyId', 0) > 0){
			str = str + "&companyId=" + cvUtil.getParameter('companyId');
		}
		if(cvUtil.getParameter('tenant', '') != ''){
			str = str + "&tenant=" + encodeURIComponent(cvUtil.getParameter('tenant'));
		}
		if(div.match(/skipped/i) || div.match(/sj/i))
			str += "&skippedJobs=true";
		href += str;
		return href;
	}

	function getDates(labels, isMonthly){
		var cdates = [], key="months", format="MMM YYYY";

		var str = labels[labels.length-1];
		if(isMonthly){
			key="months", format="MMM YYYY";
		}else{
			key="days", format="D MMM";
		}
		var mm = moment(str, format);
		if(!isMonthly){
			mm = mm.add("years", new Date().getFullYear());
		}
		mm = mm.subtract(key, labels.length);
		for(var i=0; i<labels.length; i++){
			mm = mm.add(key, 1);
			cdates[i] = mm.unix();
		}

		return cdates;
	}

	function createBackupStatBarChart(div,values,legendLabels,labels,percent,ymax,serLabels,unit, yAxistitle, xAxistitle, enableDrilldown,rawDate, popupLabels,isMonthly, showSkippedJobs)
	{

		var params;
		var drillHandler;
		isMonthly = isMonthly !=undefined? isMonthly: labels.length == 12;
		if(enableDrilldown){
			var JOB_STATUS={
					0: 1,
					1: 3,
					2: 2,
					3: 4,
					4: 6
			};
			if(showSkippedJobs) {
				JOB_STATUS={
						0: 1,
						1: 3,
						2: 2,
						3: 4,
						4: 5,
						5: 6
				};
			}
			params = [];
			for(var stack=0; stack < values.length; stack++){
				var temp = [];
				for(var series=0; series<values[stack].length; series++){
					if((!isMonthly) && div.indexOf("MergeWeekend")>-1 && getDate(rawDate[series], "ddd").search(/Fri|Sat|Sun/i)>-1){
						temp[series] = undefined;
					}else{
						var entity = {};
						entity.startDate = rawDate[series];
						entity.jobStatus = JOB_STATUS[stack];
						entity.isMonthly = isMonthly;
						temp[series] = entity;
					}
				}
				params[stack] = temp;
			}

			drillHandler = function(){
				var entity = this.bar.clickParams;
				showJobResults(entity);
			};
		}
		var colorCodes = [COLORCODES["SUCCESS"],COLORCODES["PARTIALSUCCESS"],COLORCODES["FAILURE"],COLORCODES["KILLED"]];
		if(showSkippedJobs){
			colorCodes.push(COLORCODES["SKIPPED"]);
		}
		colorCodes.push(COLORCODES["COMMITTED"]);

		//--------------------
		var xLabelDrilldownURLs;
		var enable12MonthsXLabelDrilldown = enableDrilldown;
		if((!isMonthly) || enable12MonthsXLabelDrilldown){
			xLabelDrilldownURLs = [];
			for(var series=0; series<values[0].length; series++){
				var entity = {};
				entity.startDate = rawDate[series];
				if(isMonthly){
					xLabelDrilldownURLs[series] = getMonthlyJobResultsURL(entity, div);
				}else{
					if(( div.indexOf("MergeWeekend")>-1 || div.indexOf("MWSJ")>-1) && getDate(entity.startDate, "ddd").search(/Fri|Sat|Sun/i)>-1){
						entity.weekend=true;
					}
					xLabelDrilldownURLs[series] = getHourlyJobResultsURL(entity, div);
				}
			}
		}

		//----------------------
		var r = Raphael(div, 1050,380);
		var valuesArray = jQuery.makeArray(values);
//		var xAxistitle = labels[0]+ " - "+  labels[ labels.length -1];
		var trimLabel=true;
		if(!isMonthly && ( div.indexOf("MergeWeekend")>-1 || div.indexOf("MWSJ")>-1) ){
			trimLabel=false;
		}
		for(var i=0;(i<labels.length)&&trimLabel;i++){
			labels[i] = labels[i].substring(0,3);
		}
		var width =500;
		var x= 200,y=40;
		var xpos = 600;
		if(labels.length <10){
			width = 300;
			x=300;
		}
		xpos = width+x+50;
		var  barsWidth=30;
		r.txtattr = {font:"12px Arial, sans-serif, Fontin-Sans", fill:"#000", "font-weight": "bold"};
		var chart = r.barchart(150,y,width,300,valuesArray,
    		{
			  //nostroke: false,
			  stacked: true,
    		  axis: "0 0 1 1",
    		  actualMaxY:ymax,
    		  serieslabels:legendLabels,
    		  labelxpos:xpos,
    		  labelypos:60,
			  colors: colorCodes,
			  barWidth: barsWidth,
			  axisxstep:2,
			  xAxisTitle:xAxistitle,
			  yAxisTitle:yAxistitle,
    		  //axisystep: yAxisStep,
			  clickParams: params,
			  clickHandler: drillHandler,
			  xLabelDrilldownURLs: xLabelDrilldownURLs,
    		  totalpoints:2,
    		  showGrid:true,
    		  showpopup:true,
    		  isBottom:true
    		}
    	);
		/*if(enableDrilldown && isMonthly){
			for(var k=0;k<chart[1].length;k++){
				chart[1][k][0].setAttribute("style","cursor:pointer");
			}
			chart.click(function(e){
				alert('For jobs details, click on the Last Week Backup Statistics graph above');
			});
		}*/

		chart.label(labels, true);
		if (popupLabels)
			labels = popupLabels;
		updatBarChartPopups(chart, legendLabels, labels);

		//centerChart
		chart.centerChart(div);

	}


	function createRaphaelBarChart(div,values,legendLabels,labels,percent,ymax,serLabels,unit)
	{

		var r = Raphael(div, 1050,380);
		//var yAxisStep = getYStepCount(ymax);//getNoOfTicks(ymax);
		var valuesArray = jQuery.makeArray(values);
		var xAxistitle = labels[0]+ " - "+  labels[ labels.length -2];
		for(var i=0;i<labels.length;i++){
			labels[i] = labels[i].substring(0,3);
		}
		var width =780;
		var x= 80;
		var xpos = 830;
		if(labels.length <10){
			width = 470;
			x=300;
			xpos = width+x;
		}
		//ymax = getYmax(ymax);
			r.txtattr = {font:"15px Fontin-Sans, Arial, sans-serif", fill:"#000", "font-weight": "normal"};
			var chart = r.barchart(x,40,width,300,valuesArray,
	    		{
				  nostroke: false,
				  stacked: true,
	    		  axis: "0 0 1 1",
	    		  symbol: "circle",
	    		  smooth: true,
	    		  maxy:ymax,
	    		  serieslabels:legendLabels,
	    		  type:"soft",
	    		  labelxpos:xpos,
				  gutter:"19%",
	    		  labelypos:60,
				  colors:["#48a451","#d43a52","#CD6839"],
				  barWidth: 55,
				  axisxstep:2,
				  custom:true,
				  xAxisTitle:xAxistitle,
	    		  //axisystep: yAxisStep,
	    		  totalpoints:2,
	    		  isBottom:true
	    		}
	    	);

		//createBarHeaders(chart,labels,percent,r,unit);
		chart.label(labels, true);
		chart.hover(function(i) {
			if(this.bar.value == ymax){
				return;
			}
	        // Create a popup element on top of the bar
	        this.flag = r.popup(this.bar.x, this.bar.y, (this.bar.value || "0")).insertBefore(this);
	    }, function() {
	        // hide the popup element with an animation and remove the popup element at the end
	    	if(typeof this.flag.animate != 'undefined') {
	    		this.flag.animate({opacity: 0}, 300, function () {this.remove();});
	    	} else {
	    		this.flag = {};
	    	}
	    });
	}
	function createBarHeaders(chart,labels,percent,r,unit){
		for(var i=0;i<labels.length-1;i++)
		{
			var name = "S: " +  roundNumber(chart.bars[0][i].value, 2) +" \n" + "F: " + roundNumber(chart.bars[1][i].value, 2)+" \n" + "CE: "  + roundNumber(chart.bars[2][i].value, 2)
			+" \n" + "CW: "  + roundNumber(chart.bars[3][i].value, 2);
			r.text(chart.bars[1][i].x-25,chart.bars[1][i].y-20,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
		}
	}

	function buildRequestObject() {
		surveyId = parseInt(surveyId);
		if(surveyId > 0) {
			report.requestString.surveyId = surveyId;
		}
	}

	function updateClientStrikesTableHeader(details25Div){

		var yellow = "<span class='dot-status dot-strike dot-status-yellow'></span>";
		var orange = "<span class='dot-status dot-strike dot-status-orange'></span>";
		var red = "<span class='dot-status dot-strike dot-status-red'></span>";
		orange = orange+orange;
		red = red+red+red;

		var eleArr = $("#"+details25Div+" th");
		$.each(eleArr, function(index, col){
			var title = $(col).text();
			var dispTitle = title;
			if(title.indexOf(' ') > 0){
				dispTitle = title.substring(title.indexOf(' ')+1);
			}
			if(title.indexOf('Strike1') >= 0){
				$($("th")[index]).html(yellow+' '+dispTitle);
			}else if(title.indexOf('Strike2') >= 0){
				$($("th")[index]).html(orange+' '+dispTitle);
			}else if(title.indexOf('Strike3') >= 0){
				$($("th")[index]).html(red+' '+dispTitle);
			}
		});
		$("#"+details25Div+"_holder").hide();

	}

	// if the source is undefined, hide all the elements and show data from both the 7Days and 12Months tables based on the selected options
	// if the source is the arrow of 7Days, there is no need to hide since the elements have already been hidden during collapse. Hence, show only the required elements from 7Days.
	// if the source is the arrow of 12Months, there is no need to hide since the elements have already been hidden during collapse. Hence, show only the required elements from 12Months.
	function showHideData(source) {
		if(source == undefined) {
			$("#Last7days .reportView").hide();
			$("#Last12months .reportView").hide();
			$(".arrowPlaceholder").removeClass("collapse").addClass("expand");
		}
		if(source == "arrow7" || source == undefined) {
			if(mergeWeekend && skippedJobs) {
				$("#summaryLast7DaysMWSJChartData").show();
				$("#summaryLast7DaysMWSJData51").show();
			} else if (mergeWeekend) {
				$("#summaryLast7DaysMergeWeekendChartData").show();
				$("#summaryLast7DaysMergeWeekend51").show();
			} else if (skippedJobs) {
				$("#summaryLast7DaysSkippedJobs51").show();
				$("#summaryLast7DaysSkippedJobsChartData").show();
			} else {
				$("#summaryLast7DaysChartData").show();
				$("#summaryLast7Days51").show();
			}
		}
		if(source == "arrow12" || source == undefined) {
			if(skippedJobs) {
				$("#summaryLast6MonthsSkippedJobsChartData").show();
				$("#summaryLast6MonthsSkippedJobs51").show();
			} else {
				$("#summaryLast6MonthsChartData51").show();
				$("#summaryLast6Months51").show();
			}
		}
	}

    $("body").on("click","#Last7days.reportCView .arrowPlaceholder, #Last12months.reportCView .arrowPlaceholder",function (event) {
        var arrow = $(this);
        var elements = arrow.parent().siblings();
        mergeWeekend = cvUtil.getParameter("mergeWeekend")=="true"? true:false;
        skippedJobs = cvUtil.getParameter("skippedJobs")=="true"? true:false;
        var source = "arrow7";
        if($(this).parent().parent().hasClass("Last12months_cview"))	// checks the source of the originating arrow click
        	source = "arrow12";

        if(arrow.hasClass("expand")){
            arrow.removeClass("expand").addClass("collapse");
            elements.hide();
        }else{
            arrow.removeClass("collapse").addClass("expand");
           	showHideData(source);
        }
        event.stopImmediatePropagation();
        event.preventDefault();
    });

	function addColorCodes(table) {
		if(($("#"+table+"_table")!= undefined && $('#'+table+'_table')[0] != undefined)){
			if($('#'+table+'_table')[0].children[0]!= undefined && $('#'+table+'_table')[0].children[0].rows.length > 0 &&
					$('#'+table+'_table')[0].children[0].rows[0].children[0]!= undefined && $('#'+table+'_table')[0].children[0].rows[0].children[0].textContent == 'As Of'){
				$('#'+table+'_table')[0].children[0].rows[0].children[0].textContent = "";
				$('#'+table+'_table')[0].children[0].rows[0].children[0].title= "";
			}

			for(var i=1;i<$('#'+table+'_table')[0].rows.length;i++){
				if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Success Rate (%)'){
					for(var j=2;j<$('#'+table+'_table')[0].rows[i].children.length+1;j++){
						$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("font-weight", "bold");
						$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("font-size", 15);
						if($('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')')[0].firstChild.nodeValue >=97 ){
							$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("color", "#008000");

						}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')')[0].firstChild.nodeValue <97
							&& $('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')')[0].firstChild.nodeValue >=90){
							$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("color", "#CD6839");
						}else{
							$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("color", "#FF0000");
						}
					}
				}
				else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Total'){
					for(var j=2;j<$('#'+table+'_table')[0].rows[i].children.length+1;j++){
						$('#'+table+'_table tr:nth-child('+i+') td:nth-child('+j+')').css("font-weight", "bold");
					}
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Completed'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["SUCCESS"]);
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Completed with Errors or Warnings'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["PARTIALSUCCESS"]);
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Failed'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["FAILURE"]);
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Killed'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["KILLED"]);
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Skipped'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["SKIPPED"]);
				}else if($('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)')[0].textContent == 'Committed'){
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", COLORCODES["COMMITTED"]);
				}else {
					$('#'+table+'_table tr:nth-child('+i+') td:nth-child(1)').css("background-color", "");
				}

			}
		}
	}
}

var SurveyUtil = {
	restrictToMax : function(labels,values,unit)
	{
		//labels.sort(this.sortLabelsArray);
		//values.sort(this.int_arr);
		var arr = new Array();
		var labs = new Array();
		var vals = new Array();
		var MAX_SLICE = 9;
		var ex = "Others";
		var exVal = 0;
		var includeOthers = false;

		if ( labels.length > MAX_SLICE + 1 ) {
			includeOthers = true;
		}
		for(var i=0;i<labels.length;i++)
		{
			if(i >= MAX_SLICE && includeOthers )
			{
				exVal = exVal+(parseFloat(values[i]));
			}
			else
			{
				labs[i]=labels[i];
				vals[i]=values[i];
			}
		}
		if(labs.length == 9)
		{
			if(unit != "")
				labs[9]= ex + " - (" + exVal.toFixed(2)+" " + $.trim(labels[0].split("-")[1]).split(" ")[1]+")";
			else
				labs[9]= ex + " - (" + exVal+")";
			vals[9]=exVal.toFixed(2);
		}


		arr.push(labs);

		arr.push(vals);
		return arr;
	},

	int_arr: function (a, b) {
		  return parseInt(b) - parseInt(a);
	},
	sortLabelsArray:function (a, b) {
		  return parseInt(b.substring(b.lastIndexOf("(")+1,b.lastIndexOf(")"))) - parseInt(a.substring(a.lastIndexOf("(")+1,a.lastIndexOf(")")));
	}
};




$(document).ready(function() {
	CloudSurvey();
	var queryId = cvUtil.getParameterByName("surveyId");
	if(queryId == 25){
		report.scaleReport=true;
	}
});





