this.report = new Reports.initReport({
	type : 'reportsHome',
	reportTitle : 'Reports'

});

var commCellGroupHandler = {};
commCellGroupHandler.enableProfile = false;
commCellGroupHandler.name = "";
commCellGroupHandler.groupdescription = "";
commCellGroupHandler.ccGroupId = -1;
commCellGroupHandler.commcellHolder = {};

commCellGroupHandler.checkLength = function(o, min, max, idName) {
	if (o.val().length > max) {
		var msg = "";
		msg = cvUtil.cvLocalize('CommCell_group_length_check_error_message', idName, max);
		$('#validateTips').text(msg);
		o.addClass("ui-state-error");
		setTimeout(function() {
			o.removeClass("ui-state-error", 3500);
		}, 500);
		return false;
	} else if (o.val().length < min) {
		$('#validateTips').text(cvUtil.cvLocalize('Please_Enter_CommCell_group_name'));
		o.addClass("ui-state-error");
		setTimeout(function() {
			o.removeClass("ui-state-error", 3500);
		}, 500);
		return false;
	} else {
		return true;
	}
};

commCellGroupHandler.deleteGroup = function(ccGroupId, groupName) {
	$("#commCellGroupDeletedialog").dialog({
		resizable : false,
		modal : true,
		title : cvUtil.cvLocalize("ccGroups.Confirm_Deletion"),
		width : 400,
		height : 120
	});
	$(".deleteButton").off("click");
	$(".deleteButton").on("click",
			function(e) {
				e.preventDefault();
				this.requestString = report.requestString;
				this.requestString.ccGroupId = parseInt(ccGroupId);
				this.requestString.groupName = groupName;
				this.requestString.operation = 2;//delete operation
				$("#commCellGroupDeletedialog").dialog("close");
				report.mask("");
				var URL = cvUtil.getContextPath() + '/server/commCellGroupOp.do?action=deleteGroup&json=' +
						window.encodeURIComponent(JSON.stringify(this.requestString));
				report.mask();
				cvUtil.loadPageWithPOST(URL, "", function(output) {
					if (output.errorCode == undefined || output.errorCode == 0) {
						cvUtil.logUserAction(groupName,
								"deleteGroup",
								null,
								" Message=[" + output.success + "]",
								"INFO");
						window.location.reload();
					} else {
						report.unmask();
						cvUtil.logUserAction(groupName,
								"deleteGroup",
								null,
								"Message=[" + output.errorMsg + "]",
								"INFO");
						cvUtil.errorToast(output.errorMsg);
					}
				});
			});

	$(".cancel").click(function(e) {
		e.preventDefault();
		$("#commCellGroupDeletedialog").dialog("destroy");
	});
};
commCellGroupHandler.createEditGroup = function(ccGroupId, name, groupdescription, enableProfile) {
	var params = [];
	params.push("ccGroupId=" + ccGroupId);
	params.push("groupdescription=" + window.encodeURIComponent(groupdescription));
	//params.push("enableProfile="+enableProfile);
	params.push("name=" + window.encodeURIComponent(name));
	params.push("createGroup=" + true);
	var target = cvUtil.createUrlWithParams("commCellGroupHandling.jsp", params);
	window.location.href = target;
};
commCellGroupHandler.loadData = function() {
	var ccGroupId = cvUtil.getParameter("ccGroupId");
	var title = cvUtil.cvLocalize('Commcell_group_Create_dialog_title');
	var name = window.decodeURIComponent(cvUtil.getParameter("name"));
	if (ccGroupId > 0) {
		$("#name").val(name);
		title = cvUtil.cvLocalize('Commcell_group_Edit_dialog_title', name);
		$("#description").val(window.decodeURIComponent(cvUtil.getParameter("groupdescription")));
		if ($("#enableProfile").length == 1) {
			var request = {};
			request.ccGroupId = ccGroupId;
			var configURL = cvUtil.getContextPath() + '/reports/getProfileEnabledForGroup.do';
			cvUtil.mask();
			cvUtil.loadPageWithPOST(configURL, request, function(resp) {
				if (resp) {
					$("#enableProfile").prop("checked", resp.enabledProfile);
				}
			});
		}
	}
	$("#welcomeMsg").text(title);

	metricsReporting(function(data1) {
		//data1 = $.parseJSON(data1);
		if (data1) {
			if (!data1.error) {
				genearateTableFromResult(data1,
						0,
						'monitoringform',
						'ccTableWrapper',
						'ccTableWrapperPager',
						'',
						0,
						'CommCell',
						true);
				$("#ccTableWrapper .rptTblBtnEncDiv").append($("#ccTableWrapper_table_length"));

				var ccSelectedIndex = $.inArray('Associate To CommCell Group', data1.colNames);
				var ccIdIndex = $.inArray('CommCell ID', data1.colNames);
				var ccGuidIndex = $.inArray('CommServGUID', data1.colNames);
				var ccDispIndex = $.inArray('Display Name', data1.colNames);
				var ccNameIndex = $.inArray('CommCell Name', data1.colNames);

				$.each(data1.coldata.rows, function(ccIndex, commcell) {
					//Adding existing selected commcells to commcell holder
					if (parseInt(commcell.cell[ccSelectedIndex]) == 1) {
						var commCellInfo = {};
						commCellInfo.CommCellID = parseInt(commcell.cell[ccIdIndex], 16);
						commCellInfo.CommServGUID = commcell.cell[ccGuidIndex];
						commCellInfo.CommCellName = commcell.cell[ccDispIndex];
						commCellInfo.ActualCCName = commcell.cell[ccNameIndex];
						commCellGroupHandler.commcellHolder[commCellInfo.CommServGUID] = commCellInfo;
					}
				});

				$('#ccTableWrapper').on('change', 'input.associatedToGroup:checkbox', function(event) {
					var tr = $(this).closest('tr');
					var data = $("#ccTableWrapper_table").dataTable().fnGetData(tr[0]);
					var commCellInfo = {};
					commCellInfo.CommCellID = parseInt(data['CommCell ID'], 16);
					commCellInfo.CommServGUID = data['CommServGUID'];
					commCellInfo.CommCellName = data['Display Name'];
					commCellInfo.ActualCCName = data['CommCell Name'];
					if ($(this).is(':checked')) {
						//Add selected commcell to holder
						commCellGroupHandler.commcellHolder[commCellInfo.CommServGUID] = commCellInfo;
					} else {
						//Remove un-selected commcell from holder
						delete commCellGroupHandler.commcellHolder[commCellInfo.CommServGUID];
					}
				});
			} else {
				if (data1.error == 'No data to load for : ') {
					$("#noDataNotificationPanel").show();
				} else {
					$("#noDataNotificationPanel").html(data1.error);
					$("#noDataNotificationPanel").show();
				}
			}
		} else {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		}
	});
};