var commUniId = cvUtil.getParameter('commUniId', 0);
var ccGroupId = cvUtil.getParameter('ccGroupId', 0);

function CommCellSKUsDetails() {
	var customerName = "";

	this.report = new Reports.initReport({
		type : 'commcellskus',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			requestString["commUniId"] = commUniId;
		}
	};

	report.initComponents = function() {
		$("#surveyName").html("SKUs");
	};

	report.initComponentState = function() {
		$("#commcellUrl").hide();
		updateFilters();
	};
	report.beforeLoadReport = function() {
		report.mask("");
	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/reports/getCommCellSKUs.do?commcellId=' + commCellId;
	};
	report.getExportFilePrefix = function() {
		var filePre = "CommCellSKUs";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}

		return filePre;
	};
	report.onLoadReport = function(data) {
		processResponse(data);
		report.attachTableActions();
		report.afterLoadReport();
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(resp) {
		if (resp === undefined || resp === null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else if (resp && typeof resp === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel").html(data);
			$("#noDataNotificationPanel").show();
		} else {
			if (resp && typeof resp === 'object') {
				if (resp.data.ccskus) {
					var view = {};
					view.members = resp.data.ccskus;
					view.collapsible = false;
					view.filters = true;
					view.exportExcel = true;
					view.alarm = true;
					//view.title='SKUs';

					var wrapperId = 'ContentWrapper';
					var tableDiv = 'commcellSKUs';
					$('#' + wrapperId).append(SurveyTemplates.makeReportTable(tableDiv, view));

					var tdata = view.members;
					tdata.iDisplayLength = 100;
					var configTable = true;
					if ((!tdata.aoColumns || tdata.aoColumns.length === 0) &&
							(!tdata.aoColumnDefs || tdata.aoColumnDefs.length === 0)) {
						configTable = false;
					}
					if (configTable) {
						Reports.configureClientSideTableWithPaging(tableDiv, view.title, tdata);
					}
					$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
					var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
					pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
				}
			}

		}
	}

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}
}

$(document).ready(function() {
	$("#surveyName").html('SKUs');
	window.reportEnum = "Survey";
	if (commUniId <= 0) {
		alert('Invalid CommCell Id.');
		return;
	}

	getCommCellDetailsOfUid(commUniId, null, function(data) {
		if (data.error) {
			$(".cvApps").hide();
			$("#noDataNotificationPanel").html(data.error);
			$("#noDataNotificationPanel").show();
			return;
		}
		if (commCellId === ' ') {
			commCellId = " N/A";
		}
		if (commUniId !== 0) {
			if (clientName.indexOf("@") !== -1) {
				clientName = clientName.replace(/@/g, "&");
			}

			if (clientName !== null && clientName !== " " && clientName !== " N/A" && $.trim(clientName).length !== 0) {
				var cName = reportsUtil.getTruncatedName(clientName);
				$('.reportsLink').text(clientName + ' (Reports)');
				$('#custName').html(cName);
				$('#custName').attr('title', clientName);
				$("#surveyName").html('SKUs');
				$(document).attr("title", clientName + " - SKUs");
				cvUtil.GUIAuditReportLog("CommCell SKUs", clientName);
			}
			if (data.GroupName) {
				$('.commcellsLink').text(data.GroupName + ' (CommCells)');
			}
		}
		if (exportRequest) {
			$("#custName").text($("#custName").text() + ' - SKUs');
		}
		CommCellSKUsDetails();
	});
});
