if (typeof surveyId === "undefined") {
    var surveyId = -1;
}
var selectedSurvey='';
var surveyCommon={};
var gridSearchResult=null;
var isSearch = false;
var currentSearchGrid = null;
var exportRequest = cvUtil.getParameter('exportType', '');
var isAlarmRequest = cvUtil.getParameter("isAlarm", "false")=== "true";
var defaultIDisplayLength=100;
var countEntities=['VM Sockets', 'Protected VMs', 'Users', 'Sharing Users', 'eDiscovery Users','Archived MailBoxes','CI Objects', 'Servers', 'Laptops', 'VMs', 'Devices', 'Application Class Virtual', 'Mailbox Archive Solution'];
var COLORCODES={
		"SUCCESS":"#03C04A",
		"FAILURE": "#F1453D",
		"PARTIALSUCCESS":"#FF9800",
		"KILLED":"#777777",
		"SKIPPED":"#348ab4",
		"COMMITTED":"#e4c9a3",
		"WITHIN_CAPACITY":"#03C04A",
		"OVER_CAPACITY":"#F1453D",
		"WARNING":"#FF9800",
		"LOANED_CAPACITY":"#b2d4da",
		"LICENSE_NOT_APPLIED":"#868686"//"#EB8787",
};

function convertToMaxSizeLabels(values,unit)
	{
		var convVals = new Array();
		for(var i=0;i<values.length;i++)
		{
			var val = values[i];
			convVals[i] =converTOMaxUnitLabels(val,unit);
		}
		return convVals;
	}

	function convertToMaxSizeValues(values,unit)
	{

		var convVals = new Array();
		for(var i=0;i<values.length;i++)
		{
			var val = values[i];
			convVals[i] =converTOMaxUnitValues(val,unit);
		}
		return convVals;
	}
	/*
	 * This method is used to convert the value to a specific unit and retur the value with the unit. This is
	 * used in the summary Bar Chart for Legends.
	 */
	function converTOMaxUnitLabels(value,unit)
	{
		var bytes = value *1024*1024;
		var kilobyte = 1024;
		var megabyte = kilobyte * 1024;
		var gigabyte = megabyte * 1024;
		var terabyte = gigabyte * 1024;
		var petabyte = terabyte * 1024;
		if(unit == 'KB')
		{
			return (bytes / kilobyte).toFixed(2) + ' KB';
		}else if(unit == 'MB')
		{
			return (bytes / megabyte).toFixed(2) + ' MB';
		}else if(unit == 'GB')
		{
			return (bytes / gigabyte).toFixed(2) + ' GB';

		}else if(unit == 'TB')
		{
			return (bytes / terabyte).toFixed(2) + ' TB';
		}else if(unit == 'PB')
		{
			return (bytes / petabyte).toFixed(2) + ' PB';
		}
	}

	/*
	 * This method is used to convert the value to a specific unit. This is used in the summary Bar Chart for
	 * the survey capacity License Usage.
	 */
	function converTOMaxUnitValues(value,unit)
	{
		var bytes = value*1024*1024;
		var kilobyte = 1024;
		var megabyte = kilobyte * 1024;
		var gigabyte = megabyte * 1024;
		var terabyte = gigabyte * 1024;
		var petabyte = terabyte * 1024;
		if(unit == 'KB')
		{
			return (bytes / kilobyte).toFixed(2);
		}else if(unit == 'MB')
		{
			return (bytes / megabyte).toFixed(2);
		}else if(unit == 'GB')
		{
			return (bytes / gigabyte).toFixed(2);
		}else if(unit == 'TB')
		{
			return (bytes / terabyte).toFixed(2);
		}else if(unit == 'PB')
		{
			return (bytes / petabyte).toFixed(2);
		}
	}

	function convertToBytes(value, unit) {
		var kilobyte = 1024;
		var megabyte = kilobyte * 1024;
		var gigabyte = megabyte * 1024;
		var terabyte = gigabyte * 1024;
		var petabyte = terabyte * 1024;
		var bytes = 0;

		if(unit == 'Bytes') {
			bytes = value;
		}
		else if(unit == 'KB') {
			bytes = value * kilobyte;
		} else if(unit == 'MB') {
			bytes = value * megabyte;
		} else if(unit == 'GB') {
			bytes = value * gigabyte;
		} else if(unit == 'TB') {
			bytes = value * terabyte;
		} else if(unit == 'PB') {
			bytes = value * petabyte;
		}

		return bytes;
	}

	/*
	 * prepares Pie Chart Data for a five data Set based on the column number. This method is use to prepare
	 * the data for the Summary data for all the surveys except the survey Capacity License Usage.
	 */
	function createIndPieChart(data, topId, divId, dataColumn, labelColumn)
	{
		if ( data.error == undefined ) {
			$('#chartTitle').append(selectedSurvey);
			dataAvailable(true, topId, divId);
			var labels = new Array();
			var colmodel = data.values;
			var tempValues = $.map(colmodel, function(node){
				return node["cell"];
			});
			var values = new Array();
			for (var i=0;i<colmodel.length;i++)
			{
				var tempArray = colmodel[i]['cell'];
				values[i]= tempArray[dataColumn];
				labels[i]=tempArray[labelColumn] + " - (" + values[i] + ")";
			}
			var arr = restrictToMax(labels,values,"");
			createRaphaelPieChart(divId,arr[0],arr[1]);
		} else {
			dataAvailable(false, topId, divId, cvUtil.cvLocalize("No_Data_Available"));
		}
	}

	/*
	 * prepares Pie Chart Data for a five data Set based on the column number. This method is use to prepare
	 * the data for the Summary data for all the surveys except the survey Capacity License Usage.
	 */
	function createPieChart(currentData,divId,dataColumn,labelColumn,surveyId)
	{
			$("#"+divId).empty();
			var labels = new Array();
			var values = new Array();
			var arr = jQuery.makeArray(currentData.coldata.rows);

			for (var i=0; i< arr.length ; i++)
			{
					var dataObj = arr[i];
					var vals = dataObj['cell'];
					values[i] = vals[dataColumn];
					labels[i] = vals[labelColumn] + " - (" + vals[dataColumn] +")";
			}

			if(surveyId == 5)
			{
				var english_index = 0;
				$.each(labels,function(i,val){
					if(val.indexOf("English-UnitedStates") != -1){english_index=i;}
				});
				labels.splice(english_index,1);
				values.splice(english_index,1);
			}

			var arr = restrictToMax(labels,values,"");
			if(arr[0].length && arr[1].length) {
			createRaphaelPieChart(divId,arr[0],arr[1]);
			} else {
				if(surveyId == 5) {
					dataAvailable(false, "pieTop", divId, cvUtil.cvLocalize("error.msg.GUI_Login_Languages"));
				} else {
					dataAvailable(false, divId, divId, cvUtil.cvLocalize("No_Data_Available"));
				}
			}
			//createRaphaelPieChart(divId,labels,values);
	}

	// retunrns the nearest unit for a specific value.
	function getUnitFor(maxValue)
	{
		var unit='';
		if(maxValue <= 1024) {
			unit = 'MB';
		}
		else if (maxValue <= 1048576)
		{
			unit = 'GB';
		}
		else if (maxValue <= 1073741824)
		{
			unit = 'TB';
		}
		else if (maxValue <= 1099511627776)
		{
			unit = 'PB';
		}
		else
		{
			unit = 'PB';
		}
		/*
		 * if (maxValue <= 1024) { unit = 'Bytes'; } else if (maxValue <= 1048576) { unit = 'KB'; } else if
		 * (maxValue <= 1073741824) { unit = 'MB'; } else if (maxValue <= 1099511627776) { unit = 'GB'; } else
		 * if(maxValue <= 1125899906842624) { unit = 'TB'; } else { unit = 'PB'; }
		 */
		return unit;
	}

	function getXaxisWidth(noOfBars, barWidth){
		var width = noOfBars * (barWidth + 15) + 25;
		if(width < 150){
			width = 150;
		}
		return width;
	}


	function createBarHeaders(chart,labels,percent,r,unit){
		for(var i=0;i<labels.length-1;i++)
		{
            var total = roundNumber(chart.bars[1][i].value + chart.bars[0][i].value, 2);
            var used= roundNumber(chart.bars[0][i].value, 2) ;
            var name = "T: " + total  + " "+ unit +" \n" + "U: " + used + " " + unit + " \nP: "+percent[i] + "%";
            if(total > used){
			r.text(chart.bars[1][i].x-25,chart.bars[1][i].y-20,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
            }else{
                  r.text(chart.bars[0][i].x-25,chart.bars[0][i].y-20,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
            }
		}
	}

	/* This method will be used in the formatter to return the hex value of a commcell id. */
	function decimalToHex(d, padding) {
			var hex = Number(d).toString(16);
			if(hex == -1) {
				return "FFFFFFFF";
			}
			padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;
			while (hex.length < padding) {
				hex = "0" + hex;
			}
			return hex.toUpperCase();
	}
	/* This method will retrieve the desc of a survey. */
	function getSurveyDesc(survey)
	{
		var URL="survey.do?action=GetSurveyDescription&surveyId="+survey;
		cvUtil.loadPageWithPOST(URL, null, function(data) {
			$('#surveyDesc').append(data);
			$("#surveyDesc").css('color','#333333');
		});
	}

/*
 * this is a generic method that can be used to generate the chart and the table for all the surveys except
 * the capacity license usage. It takes 1.surveyid - the id of the survey. 2. method name to call for the
 * results 3.isChart - if the chart is to be drawn -- boolean 4.isTable-- if the table has to be drawn --
 * boolean 5.tableDiv -- the id of the table div for the grid has to drawn 6.pagerDiv-- id of the pagerdiv for
 * the jqgrid. 7.tabale caption 8.commcellID -- if it is history table then the commcell id is used for the
 * genrating the history, 9.type wether it is summary table or histroy table.
 */
function generateTable(surveyId,actionTitle,isChart,isTable,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal, latest, async, extraUrlParams,tenant){
	var tableType = surveyId+'_'+tableDiv; // this will be used for fetching the column properties from the column.properties file.
	//var URL="index.php?action="+actionTitle+"&isChart=false&surveyId="+surveyId+"&tableType="+tableType;
	var URL="survey.do?action="+actionTitle+"&isChart=false&surveyId="+surveyId+"&tableType="+tableType;

	if(exportRequest ){
		if (isAlarmRequest) {
			var alarmTablediv = cvUtil.getParameter("filteredTable-0", "");
			if(isTable === false || isTable === "false") {
				return;
			}else if(alarmTablediv !== tableDiv.trim()){
				return;
			}
		}
		URL = URL + "&exportType=" + exportRequest.toLowerCase();
	}

	Reports.reportTableMap[tableDiv]={};
	Reports.reportTableMap[tableDiv].gridid=tableDiv;
	Reports.reportTableMap[tableDiv].queryId=tableDiv;
	Reports.reportTableMap[tableDiv].title=tableHeading;


	if (commcellId != '')
	{
		URL = URL+"&ccId="+commcellId;
	}

	var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
	if(ccGroupId > 0) {
		URL += "&ccGroupId="+ccGroupId;
	}
	var companyId = cvUtil.getParameter('companyId', 0);
	if(companyId > 0) {
		URL += "&companyId="+companyId;
	}
	var tenant = encodeURIComponent(cvUtil.getParameter('tenant', ''));
	if (tenant && tenant != '') {
		URL = URL + '&tenant=' + tenant;
	}

	if (latest) {
		URL = URL + "&latest="+latest;
	}
	if(surveyId == 60 ) {
		var spName = cvUtil.getParameter("spName");
		if(spName) {
			URL = URL + "&spName=" + spName;
		}
	}
	if(surveyId == 4){
		var aggr = 1;
		if(tableDiv === 'summaryDetails2'){
			aggr = 0;
		}
		URL = URL + "&aggr=" + aggr;
	}
	if(surveyId == 67 && cvUtil.getParameter("entity") ) {
		var entity = cvUtil.getParameter("entity");
		if(entity) {
			URL = URL + "&entity=" + entity;
		}
	}
	var repType = cvUtil.getParameter('repType');
	var excludeTranscationLogs = cvUtil.getParameter("excludeTranscationLogs", 0);
	if(surveyId == 137) {
		var jobStatus = cvUtil.getParameter('jobStatus');
		var startDate = cvUtil.getParameter('startDate');
		var endDate = cvUtil.getParameter('endDate');
		var clientId = cvUtil.getParameter('clientId');
		URL += "&jobStatus="+jobStatus+"&startDate="+startDate+"&endDate="+endDate+"&repType="+repType+"&clientId="+clientId+"&excludeTranscationLogs="+excludeTranscationLogs;
	}

	if(surveyId == 51 && repType) {
		var startDate = cvUtil.getParameter('startDate');
		var endDate = cvUtil.getParameter('endDate');
		URL += "&repType="+repType+"&startDate="+startDate+"&endDate="+endDate+"&excludeTranscationLogs="+excludeTranscationLogs;
	}

	if(surveyId == 7) {//Scale report
		var param = cvUtil.getParameter('param');
		if(param != undefined && param.length > 0){
			URL += "&param="+param;
		}
		var  paramId = cvUtil.getParameter('paramId');
		if(paramId != undefined && paramId.length > 0){
			URL += "&paramId="+paramId;
		}
	}

	if(surveyId == 65 && cvUtil.getParameter("storeId") ) {
		var storeId = cvUtil.getParameter("storeId");
		if(storeId) {
			URL = URL + "&storeId=" + storeId;
		}
	}

	var showSLATrend = cvUtil.getParameter("showSLATrend");
	if(showSLATrend != undefined && showSLATrend == 'true'){
		URL +='&showSLATrend='+cvUtil.getParameter('showSLATrend')+"&repType="+repType;
	}
	var fromDashboardSLA = cvUtil.getParameter("fromDashboardSLA");
	if(fromDashboardSLA != undefined && fromDashboardSLA == 'true'){
		URL +='&fromDashboardSLA='+fromDashboardSLA;
	}
	if(surveyId == 27){
		var fromCCDashboardSLA = cvUtil.getParameter("fromCCDashboardSLA");
		if(fromCCDashboardSLA != undefined && fromCCDashboardSLA == 'true'){
			URL +='&fromCCDashboardSLA='+fromCCDashboardSLA;
		}
	}
	if(surveyId == 144 && cvUtil.getParameter("database") ) {
		var database = cvUtil.getParameter("database");
		var indexInterval = cvUtil.getParameter("indexInterval");
		if(database) {
			URL = URL + "&database=" + database+"&indexInterval="+indexInterval;
		}
	}

	var additionalParams = cvUtil.getAdditionalParams();

	if (additionalParams) {
		extraUrlParams = extraUrlParams || {};
		$.each(additionalParams, function (index, param) {
			extraUrlParams[param.key] = param.value;
		});
	}

	async = async || false;
	cvUtil.loadPageWithPOST(URL, extraUrlParams, function(output) {
        	 var newData = output;//jQuery.parseJSON(output);
        	 var error = newData.error;
        	 updateOptions();
        	 if( error == undefined )
        	 {
        		 if(isChart && !isAlarmRequest) {
        			 dataAvailable(true, "pieTop", "piechartcontainer");
        			 if ( surveyId == 5 || surveyId == 34) {
        			 	dataAvailable(true, "barTop", "barchartcontainer");

        			 }
        			 genearateChartFromResult(newData,surveyId,tableDiv,extraUrlParams);
        		 }
        		 if(isTable) {
        			 if(surveyId == 7 || surveyId == 250){
						 genearateScaleReportTables(newData,surveyId,actionTitle,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal);
        			 }else if(surveyId == 27){
        				 if(newData.noDataNotificationPanel){
        					 $('#tableWrapper').hide();
        					 $("#noDataNotificationPanel").html(newData.noDataNotificationPanel.value);
        					 $("#noDataNotificationPanel").show();
        				 }else{
        					 genearateTableFromResult(newData,surveyId,actionTitle,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal);
        					 var fromCCDashboardSLA = cvUtil.getParameter("fromCCDashboardSLA");
        						if(fromCCDashboardSLA === undefined || fromCCDashboardSLA != 'true'){
        							$('html, body').scrollTop(  $("#commCellDetails").offset().top+70 );
        						}
        				 }
        			 }
					else{
        				 genearateTableFromResult(newData,surveyId,actionTitle,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal);
        			 }
					 if(surveyId == 25 || surveyId == 30 || surveyId == 37){$('#errorLink').show();}
        		 }
        	 }
        	 else
        	 {
        		 if ( isChart && !isAlarmRequest) {
        			 if(!$("#pieTop").hasClass("chartError")){
					dataAvailable(false, "pieTop", "piechartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        			 }
					if ( surveyId == 5 ) {
						dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        			}else if(surveyId==55){
        				if(commUniId<=0){
        					$('#summaryBarChartContainerTitle').append(cvUtil.cvLocalize("chart.title.Worldwide_Average_Disk_Backup_Throughput"));
        				    $('#summaryPieChartContainer1Title').append(cvUtil.cvLocalize("chart.title.Worldwide_Average_Tape_Backup_Throughput"));
        				    $('#summaryPieChartContainer6Title').append(cvUtil.cvLocalize("chart.title.Worldwide_Average_Cloud_Library_Throughput"));
        			     }else{
        					$('#summaryBarChartContainerTitle').append(cvUtil.cvLocalize("chart.title.Average_Disk_Backup_Throughput"));
        					$('#summaryPieChartContainer1Title').append(cvUtil.cvLocalize("chart.title.Average_Tape_Backup_Throughput"));
        					$('#summaryPieChartContainer6Title').append(cvUtil.cvLocalize("chart.title.Average_Cloud_Library_Throughput"));
        			     }
        				dataAvailable(false, "summaryBarTop", "summaryBarChartContainer", cvUtil.cvLocalize("No_Data_Available"));
        				dataAvailable(false, "summaryPieTop1", "summaryPieChartContainer1", cvUtil.cvLocalize("No_Data_Available"));
        				dataAvailable(false, "summaryPieTop6", "summaryPieChartContainer6", cvUtil.cvLocalize("No_Data_Available"));
        			}else if(surveyId == 106){
        				$("#barTitle").html(cvUtil.cvLocalize("chart.title.Client_Version_History"));
        				dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        			}else if(surveyId == 4){
        				if(!$("#barTop").hasClass("chartError")){
        					if(commUniId>0){
        						$("#barTitle").html(cvUtil.cvLocalize("chart.title.Subclient_Count_By_Agent_Type"));
        					}else{
        						$("#barTitle").html(cvUtil.cvLocalize("chart.title.Subclient_Count_By_Agent_Group"));
        					}
        				dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        				}
        			}else if(surveyId == 51 && cvUtil.getParameter('repType')){
        				var sd = moment(cvUtil.getParameter("startDate")).format('MMM DD, YYYY').toString();
        				$('#barTitle').append(cvUtil.cvLocalize("chart.title.Hourly_Backup_Jobs_on", sd));
        				dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        				$("#tableWrapper").hide();
        			}else if(surveyId == 137 && cvUtil.getParameter('repType')){
        				if(cvUtil.getParameter('repType') == 'monthly'){
	        				var sd = moment(cvUtil.getParameter("startDate")).format('MMMM YYYY').toString();
	        				$('#barTitle').append(cvUtil.cvLocalize("chart.title.Daily_Backup_Jobs_on", sd));
	        				dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
	        				$("#tableWrapper").hide();
        				}
        			}
					/*
					 * if(surveyId != 1) { if(surveyId != 5) { $("#chartTitle").append("Worldwide
					 * "+selectedSurvey); } else { $("#barTitle").append("Worldwide Non English " +
					 * selectedSurvey + " - CommCell Count"); $("#chartTitle").append("Worldwide Non English " +
					 * selectedSurvey + " - Login Count"); } }
					 */
        		 }
				if ( isTable ) {
					if(surveyId == 137 && cvUtil.getParameter("jobStatus")!=""){
						if(cvUtil.getParameter('repType') != 'monthly'){
							showJobsDetailsSummary();
						}
						tableHeading = cvUtil.cvLocalize("table.title.Job_Details");
					}

					if (actionTitle == "GetHealthCardSummary") {
						$("#noDataNotificationPanel").html(cvUtil.cvLocalize("No_Data_Available"));
						$("#noDataNotificationPanel").show();
					} else {
						if(window[tableDiv+'_initialized']==true){
							$("#" + tableDiv).empty();
						}

						$('#'+ tableDiv).attr('comp', tableDiv).attr('data-component-type', 'METRICS_CHART').addClass('chartholder').append("<div class='chartTitleStyle'>"+ tableHeading +"</div>");
						dataAvailable(false, tableDiv, tableDiv, cvUtil.cvLocalize("No_Data_Available"));
						$('#'+ tableDiv ).parent(".tableClass").css('margin','0px');
						$('#'+tableDiv).show();
						$("#statusRow").hide();
					}
				}
			}
        	 if(window.addTableLegend){
					addTableLegend();
				}
        	 $("#"+tableDiv+" .rptTblBtnEncDiv").append($("#"+tableDiv+"_table_length"));
        	 scroll(surveyId);
	});
}

function scroll(surveyId){
	 /*
		 * if ( surveyId == 12 && (cvUtil.getParameter("fromDashboardSLA")=="")) { var top =
		 * $('#commCellDetails').offset().top; top -= (top - $('#summaryDetails').offset().top); top += 70;
		 * $('html, body').animate({ scrollTop: top }, 500); }
		 */
}

function generateTableOnDemand(surveyId,commcellId, title, div, pagerdiv, extraUrlParams)
{
	if(exportRequest)
	{
		generateTable(surveyId,'GetSurvey',false,true,div,pagerdiv,title,commcellId,'IndCommCell',false, false, true, extraUrlParams);
		return;
	}
	var view = {};
	view.title = title;
	view.filters = true;
	view.collapsible = true;
	view.exportExcel = true;
	view.alarm = true;
	$('#tableWrapper').append(SurveyTemplates.makeReportTable(div, view));
	window[div+'_initialized']=true;
	$("#"+div).show();
	$("#"+div + " .arrowPlaceholder").parent().siblings("div").hide();
	$("#"+div + " .arrowPlaceholder").removeClass("expand").addClass("collapse");
	var loaded=false;
	$("#"+div + ".reportTable").find(".arrowPlaceholder").click(function (event) {
		//$("#commCellDetails").detach();
		if(!loaded){
			report.mask("");
			$("#"+div + ".reportTable table").hide();		//handler in reportsbase also triggers and toggles it
			generateTable(surveyId,'GetSurvey',false,true,div,pagerdiv,title,commcellId,'IndCommCell',false, false, true, extraUrlParams);

			//$("#commCellDetails .arrowPlaceholder").parent().siblings("div").slideToggle("fast");
			loaded=true;
		}
	});
}

/*
 * This method will prepare the data and generate the chart for all the survey other than capacity License
 * Usage
 */
function genearateChartFromResult(newData,surveyId,tableDiv, extraUrlParams)
{
	if(surveyId != 1)
	{
		if(surveyId == 5) {
			if(commUniId <= 0){
				$("#chartTitle").append(cvUtil.cvLocalize("chart.title.Worldwide_Non_English_GUI_Login_Languages_Login_Count"));
				$("#barTitle").append(cvUtil.cvLocalize("chart.title.Worldwide_Non_English_GUI_Login_Languages_CommCell_Count"));
			}
			createBars(newData, 'barchartcontainer', 2, 0, surveyId);
		}
		else if ( surveyId == 134) {
			createBars2(newData, 'barchartcontainer', 1, 0, surveyId);
			$("#barTitle").append("Mailbox Quota Usage");
		}else if ( surveyId == 34) {
			/*
			 * $("#chartTitle").html("Worldwide Client Count by Job Priority"); $("#barTitle").html("Worldwide
			 * CommCell Count by Job Priority");
			 */
			createBars(newData, 'barchartcontainer', 2, 0, surveyId);
		}else if(surveyId == 106){
			createClientVersion(newData);
		}else if(surveyId == 3){
			summaryPieChartDataConvert(newData, extraUrlParams);
		}else if(surveyId == 12 && commUniId <=0){
			createCommCellVersionsBarCharts(newData);
		}else if(surveyId == 4){
			createSnapEngineUsageCharts(newData,tableDiv);
		}else if(surveyId == 55){
			summaryThroughputBarChart(newData);
		}else if(surveyId == 51 || surveyId == 137){
			createBackupBarChart(newData, surveyId == 137);
		}else if(surveyId == 67){
			summaryClientsTrendingChart(newData);
		}else if(surveyId == 96 || surveyId == 196){
			summaryLibraryGrowthTrendingChart(newData);
		}
		/*
		 * else { $("#chartTitle").append("Worldwide "+selectedSurvey); }
		 */

		if($.inArray(surveyId, [5,8]) != -1) {
			if(surveyId == 8){
				if(commUniId <= 0){
					$("#chartTitle").append(cvUtil.cvLocalize("chart.title.Worldwide_Client_Statistics"));
				}else{
					$("#chartTitle").append("Client Statistics");
				}
			}
			createPieChart(newData,'piechartcontainer',1,0,surveyId);
		}
	}

}


function createCommCellVersionsBarCharts(currentData){
	var labels11 = new Array();
	var values11 = new Array();
	var isLTS;
	var dataColumn = 2, labelColumn=0;
	var version11Str = '11.';
	var v11color = '#ec6600' , LTScolor= '#287010';

	var arr = jQuery.makeArray(currentData.coldata.rows);
	var cnt11=0, missedCnt=0;

	LTSobj={};
	for (var i=0; i< arr.length ; i++){
			var dataObj = arr[i];
			var vals = dataObj['cell'];
			if(vals[labelColumn].indexOf(version11Str) == 0){
				labels11[cnt11] = vals[labelColumn].replace(version11Str, "");
				isLTS = vals[3] //to get the IsLTS data
				LTSobj[ version11Str + labels11[cnt11].trim()]=isLTS;
				cnt11++;
			}
	}
	var arr11 = extractVersionsToDisplay(labels11,8,100);	//Showing Feature Releases in between 11.8 and 11.100 only ,as advised by Parag

	//get max 25 of v11 release
	var labels = new Array();
	var values = new Array();
	var colors = new Array();
	var popupLabels = new Array();
	var MAX = 25;
	var ctr=0;

	index =  arr11.length > MAX ? arr11.length -MAX : 0;
	for (var bars=0; index< arr11.length && bars< MAX; index++, bars++) {
		labels[ctr] = version11Str + arr11[index];//.replace("SP","");
		values[ctr] = getValueofVersion(arr, version11Str + arr11[index], dataColumn);
		popupLabels[ctr] = labels[ctr]+": "+values[ctr];
		if(LTSobj[labels[ctr]]==1){
			colors.push(LTScolor);
		}
		else{
			colors.push(v11color);
		}
		ctr++;
	}
	var seriesLabels = [cvUtil.cvLocalize("seriesLabel.LTS")];
	var seriesColors = [LTScolor];

	var name = selectedSurvey;
	if(name == null || name == ""){
		name = cvUtil.cvLocalize("chart.title.CommCell_Version");
	}
	$("#barTitle").append("Worldwide "+name);

	values = $.grep(values, function(n, i){
        return (typeof n != 'undefined' && $.isNumeric(n));
	});
	if(values.length <= 0){
		dataAvailable(false, "barTop", "barTop", cvUtil.cvLocalize("No_chartable_data_available"));
		return;
	}

	var width = values.length * 35;
	if (width < 200){width=200;
//var stackedValues =  [values];
//var stackedSeriesLabels = [seriesLabels];
	}

	var chart = drawCommCellVersionsChart(seriesLabels,values, colors,  seriesColors, width);
	chart.label(labels, true);

	for(var i=0;i<chart.bars.length;i++){
		var cbar = chart.bars[i];
		var val = (cbar.value || "0");
		var xlab = labels[i];
		var version = cvUtil.cvLocalize("seriesLabel.v11");
		val = "<div style='font-weight: bold; text-align: center'>"+version+"</div>"+xlab+" : "+val;
		cbar.popupLabel=val;
	 }
}
function drawCommCellVersionsChart(labels, vals, colors,  seriesColors, width)
{
	var commcellGroupId = cvUtil.getParameterByName("ccGroupId");
	var companyId = cvUtil.getParameterByName("companyId");
	var frameId = 'barchartcontainer';
	$("#" + frameId).empty();
	var raphaelWidth = 900;
	if(vals.length > 20){raphaelWidth =1110;}
	var r = Raphael(frameId, raphaelWidth,400);

    var maxY = Math.ceil(Math.max.apply(Math, vals));

    var tempLabel = r.text(0,0, yAxisTitle).attr({fill: '#333', stroke: "none",font:"11px Lucida Grande,Lucida Sans Unicode,Verdana,Arial","text-anchor": 'start',"font-weight": "normal"});
	var padding = tempLabel.getBBox().width + 40;
    if (exportRequest != ""){padding +=10;}
	tempLabel.remove();

	if(vals.length > 20){padding =10;}
	var barWidth = 15, barGap = 20;
	if(vals.length <= 15){
		barWidth = 20;
		//barGap = 20;
	}

	var xAxisTitle= cvUtil.cvLocalize("chart.axis.title.v11Service_Packs") , yAxisTitle = cvUtil.cvLocalize("chart.axis.title.CommCell_Count"), legendAnchor = "bottom";

    var chart = r.barchart( padding,50, width || 550,250, vals,
    		{
    			stacked:false,
    			smooth: true,
    			axis: "0 0 1 1",
    			actualMaxY: maxY,
    			serieslabels:labels,
    			seriesColors: seriesColors,
    			colors:colors,
    			legendAnchor:legendAnchor,
    			xAxisTitle:xAxisTitle,
    			yAxisTitle:yAxisTitle,
    			barActualWidth:barWidth,
    			barGap:barGap,
    			showGrid: true,
    			showpopup:true
    		});

    chart.centerChart(frameId);
    return chart;
}
function getValueofVersion(arr, version, dataColumn) {
	for (var i=0; i< arr.length ; i++)
	{
		if (arr[i].id==version) {
			return  arr[i]['cell'][dataColumn];
		}
	}
}

function extractVersionsToDisplay(labels, versionMin, versionMax) {
	var labs = new Array();

	var index=0;
	for (var i=0; i< labels.length; i++) {
		var ver2 = labels[i].trim();
		if (parseInt(ver2) >= versionMin && parseInt(ver2) <= versionMax) {
			labs[index]=ver2;
			index++;
		}
	}
	if (labs.length ==0) {
		labs= labels;
	}
	labs.sort(sortVersions);
	return labs;

}

function sortVersions(a, b) {
		var regex=/[a-zA-Z]*/;
		var label1 = a.replace(regex,"");
		var label2 = b.replace(regex,"");
		var val1 =  parseInt(label1);
		var val2 =  parseInt(label2);

		if (val1 == val2) {
			var m1 = label1.match(/[a-z]\b/);
			var m2=  label2.match(/[a-z]\b/);
			var sub1="";
			var sub2="";
			if (m1 !=null){sub1 = m1[0];}
			if (m2!=null){sub2= m2[0];}

			return compareTo(sub1, sub2);
		} else {
			return compareTo(val1, val2);
		}
}

function compareTo(a, b) {
		if (a==b) {
			return 0;
		} else if (a<b) {
			return -1;
		} else {
			return 1;
		}
}


function createSnapEngineUsageCharts(currentData,tableDiv){
	if(tableDiv=='summaryDetails'){
		var snapCol = 0, appCol = 1, dataColSubclient = 3;
		var arr = jQuery.makeArray(currentData.coldata.rows);
		var snapLabels=[];
		var appLabels=[];
		var appArrays=[];
		var j=0;


		//Bar chart data process
		for (var i=0; i< arr.length ; i++)
		{
			var dataObj = arr[i];
			var vals = dataObj['cell'];
			var snapStr = vals[snapCol];
			var appStr = vals[appCol];
			var scCnt = parseInt(vals[dataColSubclient]);
			var snapIndex = $.inArray(snapStr, snapLabels);
			var appIndex = $.inArray(appStr, appLabels);

			if(snapIndex == -1) {
				//new snap push into array
				snapIndex = j;
				snapLabels[j++]=snapStr;
			}
			if(appIndex == -1){
				//new app push into array
				appLabels[appLabels.length] = appStr;
				var appValues = [];
				appArrays[appArrays.length] = appValues;
				appValues[snapIndex] = scCnt;
			}else{
				//update existing app
				var appValues = appArrays[appIndex];
				var cnt=0;
				if(appValues[snapIndex]){
					cnt = appValues[snapIndex];
				}

				appValues[snapIndex] = cnt + scCnt;
			}

		}

		//Filling empty sc cnt values in app arrays
		for(var i=0;i<appArrays.length;i++){
			var appValues = appArrays[i];
			for(var j=0;j<snapLabels.length;j++){
				var val = appValues[j];
				if(val == undefined || isNaN(val)){
					appValues[j] = 0;
				}
			}
		}
		  //Start - top9 & others
			var showItemsCount = 10;
			if(snapLabels.length > showItemsCount){
				var otehrsIndex=showItemsCount-1;
				snapLabels[otehrsIndex] = 'Others';

				for(var j=0;j<appArrays.length;j++){
					var appArray = appArrays[j];
					for(var k=otehrsIndex+1;k<appArray.length;k++){
						appArray[otehrsIndex] = appArray[otehrsIndex] + appArray[k];
					}
				}
				//removing exceeding items from array
				snapLabels.splice(showItemsCount, snapLabels.length-showItemsCount);

				for(var j=0;j<appArrays.length;j++){
					var appArray = appArrays[j];
					appArray.splice(showItemsCount, appArray.length-showItemsCount);
				}
			}


			//End - top9 & others

			var yMax = 0;
			for(var i=0;i<snapLabels.length;i++){
				var total=0;
				for(var j=0;j<appArrays.length;j++){
					var cnt = appArrays[j][i];
					total = total+cnt;
				}
				if(yMax < total){
					yMax = total;
				}
			}

			var stackLegLabels = appLabels;
			var stackedValues = appArrays;

			dataAvailable(true, "barTop", "barchartcontainer");
			var valuesArray = jQuery.makeArray(stackedValues);

			var width = 600;
			var height = 100;
			var guitter= 100;

			for(var i=0;i<snapLabels.length;i++){
				if(height<300){
					height = height +50;
				}
				if(guitter > 20){
					guitter= guitter - 10;
				}

			}
			guitter = guitter+'%';

			var xpos_label = width+320;
			if(xpos_label < 300){
				xpos_label = 300;
			}
			var x = 50;
			var y = 20;
			var div = "barchartcontainer";
			var r = Raphael(div, 1100,600);
			//yMax = getYmax(yMax);

			var chart = r.hbarchart(x,y, width,height,valuesArray,
					{
				stacked: true,
				axis: "0 0 1 1",
				smooth: true,
				actualMaxY:yMax,
				serieslabels:stackLegLabels,
				pointlabels: snapLabels,
				xAxisTitle: cvUtil.cvLocalize("chart.axis.title.Snap_Engines"),
				yAxisTitle: cvUtil.cvLocalize("chart.axis.title.Subclient_Count"),
				showGrid: true,
				showpopup: true,
				isBottom:true
					}
			);
			chart.label(snapLabels);
			chart.heightAdjustment(div);
			var divHeight = $("#"+div).height();
			$("#barTop").css("height", divHeight+50);
			chart.centerChart(div);
			updatBarChartPopups(chart, stackLegLabels, snapLabels);

			$(".chartContainer").css("text-align","left");
			if(commUniId>0){
				$('#barTitle').html(cvUtil.cvLocalize("chart.title.Subclient_Count_By_Agent_Type"));
				$('#chartTitle').html(cvUtil.cvLocalize("chart.title.Snap_Engine_Usage"));
			}else{
				$('#barTitle').html(cvUtil.cvLocalize("chart.title.Subclient_Count_By_Agent_Group"));
				$('#chartTitle').html(cvUtil.cvLocalize("chart.title.Worldwide_Snap_Engine_Usage"));
			}


	}else{
		var snapColName = 0,snapCount = 1;
		var arr = jQuery.makeArray(currentData.coldata.rows);
	//Pie chart data processs
	var pieValues = [];
	var pieLabels=[];
	var pj=0;
	for (var i=0; i< arr.length ; i++)
	{
		var dataObj = arr[i];
		var vals = dataObj['cell'];
		var snapStr = vals[snapColName];
		var val = vals[snapCount];
		var index = $.inArray(snapStr, pieLabels);
		if(index != -1) {
			pieValues[index]=pieValues[index]+parseInt(val);
		}else{
			pieLabels[pj]=snapStr;
			pieValues[pj++]=parseInt(val);
		}
	}
	for(var i=0;i<pieLabels.length;i++){
		pieLabels[i] = pieLabels[i] + " - (" + pieValues[i] +")";
	}
	//Pie chart
	var pieDataArray = restrictToMax(pieLabels,pieValues,"");
	createPieChart12('piechartcontainer','pieTop',pieDataArray[0],pieDataArray[1]);
	}
}

function createPieChart12(div,topDiv,labels,values)
{
	if(values.length > 0)
	{
		dataAvailable(true, topDiv, div);
		//createRaphaelPieChart(div,labels,values);
		$("#"+div).empty();
		Raphael(div, 650, 350).pieChart(180, 170, 140, values, labels,365,30, "#fff",null,null,false);
	}
	else
	{
		dataAvailable(false, topDiv, div, cvUtil.cvLocalize("No_Data_Available"));
	}
}
function summaryPieChartDataConvert(currentData, extraUrlParams)
{
		currentData.labels = currentData.colNames;
		currentData.values = currentData.coldata.rows;
		if (extraUrlParams && extraUrlParams.bAggregate == 1){drawUsageCharts(currentData,true,'AGENT_TYPE');} else {drawUsageCharts(currentData,true, 'LICENSE_TYPE');}

}
function createBars2(currentData, divId, dataColumn, labelColumn, surveyId) {
	$("#"+divId).empty();
	var labels = new Array();
	var values = new Array();
	var colors = new Array();
	var arr = jQuery.makeArray(currentData.coldata.rows);
	var xAxisLables = new Array();
	for (var i=0; i< arr.length ; i++)
	{
			var dataObj = arr[i];
			var vals = dataObj['cell'];
			values[i] = vals[dataColumn];
			xAxisLables[i] = vals[labelColumn];
			colors.push("#1363da");
			labels[i] = vals[labelColumn];
	}


	var arr = [labels, values];
	//var colors=[];
	//for(var i=0;i<arr[0].length;i++)
	//	colors.push("#1363da");
	//var seriesLabels = ["Number of Users"];
	//var seriesColors = ["#1363da"];
	if(arr[0].length && arr[1].length) {
		var chart = createBarchart(divId,null,arr[1], colors, null, null, null, null, currentData.colNames[0], currentData.colNames[1], 35,true);
		chart.label(arr[0], true);
	} else {
		dataAvailable(false, "barTop", "barTop", cvUtil.cvLocalize("error.msg.GUI_Login_Languages"));
	}
}
function createBars(currentData, divId, dataColumn, labelColumn, surveyId) {
		$("#"+divId).empty();
			var labels = new Array();
			var values = new Array();
			var colors = new Array();
			var arr = jQuery.makeArray(currentData.coldata.rows);
			var xAxisLables = new Array();

			for (var i=0; i< arr.length ; i++)
			{
					var dataObj = arr[i];
					var vals = dataObj['cell'];
					values[i] = vals[dataColumn];
					xAxisLables[i] = vals[labelColumn];
					colors.push("#264A80");
					labels[i] = vals[labelColumn] + " - (" + vals[dataColumn] +")";
			}

			if(surveyId == 5)
			{
				var english_index = 0;
				$.each(labels,function(i,val){
					if(val.indexOf("English-UnitedStates") != -1){english_index=i;}
				});
				labels.splice(english_index,1);
				values.splice(english_index,1);
			}


		var arr = restrictToMax(labels,values,"");
		if(arr[0].length && arr[1].length) {
			var chart = createBarchartNew(divId,arr[0],arr[1], null, null, null, null, null, cvUtil.cvLocalize("chart.axis.title.Languages"), cvUtil.cvLocalize("chart.axis.title.CommCell_Count"), arr[0]);

			var pointLables = new Array();
			$.each(arr[0], function(i,val){
				if(val.indexOf('- (') != -1){
					val = val.substr(0, val.indexOf('- (')-1);
					pointLables[i] = val.trim();
				}
			});

			updatBarChartPopups(chart, pointLables);
		} else {
			dataAvailable(false, "barTop", "barTop", cvUtil.cvLocalize("error.msg.GUI_Login_Languages"));
		}


}

function createClientVersion(data){

	$("#barTitle").html(cvUtil.cvLocalize("chart.title.Client_Version_History"));
	var coldata = data.coldata;
	var rows = coldata.rows;
	//loop through the entire rows and pickup version and split rows into two groups - 9.0 and 10.
	var months =[];
	var  monthName=[];

	var  v11Monthly = [] ,v9Monthly=[], v10Monthly=[];
	for(var i=0,j=rows.length-1; i<rows.length; i++) {
		months[i]=rows[j-i].cell[0];
		v11Monthly[i]=rows[j-i].cell[1] >= 0? rows[j-i].cell[1] : 0;
		v10Monthly[i]= rows[j-i].cell[2] >=0? rows[j-i].cell[2] : 0;
		v9Monthly[i]= rows[j-i].cell[3] >=0? rows[j-i].cell[3] : 0;
		}


	//---------------------------------------------
	for(var i=0; i<rows.length; i++) {
		monthName[i]= getDate(months[i], 'MMM');//moment(months[i]).format('MMM');
	}

	var div = "barchartcontainer";
	var r = Raphael(div, 1000,450);

	var v9Max = Math.max.apply(Math, v9Monthly);
	var v10Max = Math.max.apply(Math, v10Monthly);
	var v11Max = Math.max.apply(Math, v11Monthly);

	var ymax = Math.max.apply(Math, [v9Max, v10Max, v11Max]);


	var valuesArray = [v9Monthly,v10Monthly, v11Monthly];
	var seriesLabels = [cvUtil.cvLocalize("chart.series.label.Version_9"),cvUtil.cvLocalize("chart.series.label.Version_10"), cvUtil.cvLocalize("chart.series.label.Version_11")];


	var labels = $.map( monthName, function(val, index){
		return (val);

	});
	var xAxistitle =getDate(months[0], 'MMMM YYYY')+" - "+getDate(months[rows.length-1], 'MMMM YYYY');
	var yAxistitle = cvUtil.cvLocalize("chart.axis.title.Clients_Count");
	var width =780;
	var height = 300;
	var x = 10;
	var y = 20;
	var barWidth = 45;
	width = ( 10 + barWidth ) * v11Monthly.length;
	var xpos = width + 150;

		r.txtattr = {font:"15px Fontin-Sans, Arial, sans-serif", fill:"#000", "font-weight": "normal"};
		var chart = r.barchart(x,y,width,height,valuesArray,
	{
			  nostroke: false,
    		  axis: "0 0 1 1",
    		  smooth: true,
    		  actualMaxY:ymax,
    		  serieslabels:seriesLabels,
			  xAxisTitle:xAxistitle,
			  yAxisTitle:yAxistitle,
    		  showGrid: true,
    		  showpopup: true,
    		  isBottom:true
    		}
    	);

		chart.label = function(labels, isBottom){
			labels = labels || [];
	        this.labels = r.set();
	        var L, l = -Infinity;
	        var len = valuesArray.length,
	        	multi = len,
	        	row = 0;
	        for (var i = valuesArray.length; i--;) {
	        	if( valuesArray[i].length > len){
	        		row = i;
	        		len = valuesArray[i].length;
	        	}
            }
	        var total = Math.max.apply(Math, valuesArray);
	    	for (var i = 0; i < chart.bars[row].length; i++) {
	    		var index = (multi || 1) % 2;
	  		  	if (multi ==1){
	  		  		index =0;
	  		  	}
	  		  	var label =  r.raphael.g.labelise(labels[i], multi ? valuesArray[0][i] : valuesArray[i], total);
	  		  	var y = chart.bars[row][i].y + chart.bars[row][i].h,
	  		  		x = chart.bars[row][i].x;
	  		  	L = r.text(x , isBottom ? (y+10) : y - 10, label).attr({"text-anchor" : "middle"}).insertBefore(chart.covers[i * (multi || 1) + index]);
	  		  	var bb = L.getBBox();
	  		  	L.attr({"x": (x - ((bb.width/2)+2))});
	  		  	if (bb.x - 7 < l) {
	  		  		L.remove();
	  		  	} else {
	  		  		this.labels.push(L);
	  		  		l = bb.x + bb.width;
	  		  	}
	    	}
	};
	chart.label(labels, true);
	chart.centerChart(div);

	//Popup labels
	updatBarChartPopups(chart, seriesLabels, labels);

	dataAvailable(true, "barTop",  "barTop");

}

function onDemandCommCellDetails(surveyId,commcellId)
{
	var view = {};
	view.title = (surveyId ==1  && commcellId == "") ? localMsg.worldwideAgentData : cvUtil.cvLocalize("CommCell_Details");
	view.filters = true;
	view.collapsible = true;
	view.exportExcel = true;
	view.alarm = true;
	$('#tableWrapper').append(SurveyTemplates.makeReportTable('commCellDetails', view));
	window['commCellDetails_initialized']=true;
	$("#commCellDetails").show();
	$("#commCellDetails .arrowPlaceholder").parent().siblings("div").hide();
	$("#commCellDetails .arrowPlaceholder").removeClass("expand").addClass("collapse");
	var loaded=false;
	$("#commCellDetails.reportTable").find(".arrowPlaceholder").click(function (event) {
		//$("#commCellDetails").detach();
		if(!loaded){
			report.mask("");
			$("#commCellDetails.reportTable table").hide();		//handler in reportsbase also triggers and toggles it
			generateTable(surveyId,'GetSurvey',false,true,'commCellDetails','commCellDetailsPager',cvUtil.cvLocalize("CommCell_Details"),commcellId,'CommCell',true, false, true);

			//$("#commCellDetails .arrowPlaceholder").parent().siblings("div").slideToggle("fast");
			loaded=true;
		}
	});

}

function createBarchartNew(frameId, labels, vals, colors,  seriesColors, width, legendAnchor,yMax, xAxisTitle, yAxisTitle, popupLabels)
{
	$("#" + frameId).empty();
	var raphaelWidth = 900;
	if(vals.length > 20){raphaelWidth =1100;}
	var r = Raphael(frameId, raphaelWidth,400);

    var maxY = yMax || Math.ceil(Math.max.apply(Math, vals));
    //maxY = getYmax(maxY);

    //get the width of the y axis label

    //var tempLabel = r.text(0,0, yAxisTitle).attr({fill: '#333', stroke: "none",font:"11px Lucida Grande,Lucida Sans Unicode,Verdana,Arial","text-anchor": 'start',"font-weight": "normal"});
	var padding = 20;//tempLabel.getBBox().width;
    if (exportRequest != ""){padding +=10;
//tempLabel.remove();
}

	if(vals.length > 20){padding =10;}
	var barWidth = 15, barGap = 15;
	if(vals.length <= 15){
		barWidth = 20;
		//barGap = 20;
	}
    var chart = r.barchart( padding,50, width || 550,250, vals,
    		{
    			stacked:false,
    			//nostroke: false,
    			smooth: true,
    			axis: "0 0 1 1",
    			actualMaxY: maxY,
    			//axisystep:getYStepCount(maxY),
    			labelxposGap: 70,
    			serieslabels:labels,
    			seriesColors: seriesColors,
    			colors:colors,
    			legendAnchor:legendAnchor,
    			xAxisTitle:xAxisTitle,
    			yAxisTitle:yAxisTitle,
    			barActualWidth:barWidth,
    			barGap:barGap,
    			showGrid: true,
    			showpopup:true
    		}, popupLabels);//, vals.slice(0)); //data["popupLabels"]

    chart.centerChart(frameId);
    return chart;
}

function createBarchart(frameId, labels, vals, colors,  seriesColors, width, legendAnchor,yMax, xAxisTitle, yAxisTitle, popupLabels)
{
	$("#" + frameId).empty();
	var r = Raphael(frameId, 1180,400);

    var maxY = yMax || Math.ceil(Math.max.apply(Math, vals));
    //maxY = getYmax(maxY);

    //get the width of the y axis label
    var tempLabel = r.text(0,0, maxY).attr({fill: '#333', stroke: "none",font:"11px Lucida Grande,Lucida Sans Unicode,Verdana,Arial","text-anchor": 'start',"font-weight": "normal"});
	var padding = tempLabel.getBBox().width + tempLabel.getBBox().height + 5;
	if (exportRequest != ""){padding +=10;}
	tempLabel.remove();

    var chart = r.barchart( padding,50, width || 550,250, vals,
    		{
    			stacked:false,
    			axis: "0 0 1 1",
    			actualMaxY: maxY,
    			//axisystep:getYStepCount(maxY),
    			serieslabels:labels,
    			seriesColors: seriesColors,
    			colors:colors,
    			legendAnchor:legendAnchor,
    			xAxisTitle:xAxisTitle,
    			yAxisTitle:yAxisTitle,
    			showGrid: true,
    			showpopup:true
    		}, popupLabels);//, vals.slice(0)); //data["popupLabels"]

    chart.centerChart(frameId);

    return chart;
}

function createHeaders(chart, vals, r){
	for(var i=0;i < vals.length;i++)
	{
		var name = convert(chart.bars[i].value);
		var y = chart.bars[i].y || 280;
		r.text(chart.bars[i].x-10, y - 10,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
	}
}

function createHeaders2(chart, vals, r){
	for(var i=0;i < vals.length-1;i++)
	{
		var name = convert(chart.bars[i].value);
		var y = chart.bars[i].y || 280;
		r.text(chart.bars[i].x-10, y - 10,name).attr({fill: '#333', stroke: "none", "font-size": 10,"text-anchor": 'start',"font-weight": 400});
	}
}

function getNoOfTicks(yMax){
	var yMin = 0;
	var noOfDigits = (yMax ==0) ? 1 : parseInt((Math.log(yMax)/Math.log(10)) + 1);
	var range = yMax-yMin;
	var noOfTicks  = 10;
	var tickRange = Math.ceil(Math.abs(range/Math.pow(noOfTicks,noOfDigits))*10);
	return  tickRange;
}
/*
 * function getYmax(yMax){ //yMax = Math.ceil(yMax); var toNearest = 100; var done = false; if(yMax < 1){ yMax =
 * 1; done = true; }else if(yMax < 2){ yMax = 2; done = true; }else if(yMax <= 5){ yMax++; done = true; }else
 * if (yMax < 10){ toNearest = 1; } else if (yMax < 100) toNearest = 10; else if (yMax < 500) toNearest = 50;
 * else if (yMax < 1000) toNearest = 100; else if (yMax < 5000) toNearest = 500; else if (yMax < 10000)
 * toNearest = 1000; else if (yMax < 50000) toNearest = 5000; else if (yMax < 100000) toNearest = 10000; yMax =
 * Math.ceil(yMax); if(done == false){ var rest = yMax % toNearest; yMax = (yMax - rest) + (toNearest == 1 ? 0 :
 * toNearest); while(yMax % 5 != 0) { yMax++; } } return yMax; }
 */

/*
 * function getYStepCount(yMax) { var count = 5; if(yMax <= 1) { return count; }else if(yMax <= 2) { return
 * count-1; }else if(yMax <=5){ return yMax; } var unit = (yMax <= 10)?2:5; for (; count > 0; count--) { if (
 * Math.floor(yMax / count) % unit == 0 ) { return count; } } return 1; }
 */

function roundNumber(num, dec) {
	var result = Math.round(num*Math.pow(10,dec))/Math.pow(10,dec);
	return result;
}



/* This method will the table for all the survey's other than capacity License Usage */
function genearateTableFromResult(newData,surveyId,actionTitle,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal)
{
	// for daily or hourly back job reports, depending on the parameter skipped jobs, the newData variable has to be changed.
	// if the skipped job parameter is not true, then the skipped job row has to be removed, which is handled by the below code
	if((surveyId == 137 &&  (getUrlParameter("repType") != "hourly" && getUrlParameter("repType") != "daily" )) || surveyId == 51 ) {
		if(getUrlParameter('skippedJobs') != "true") {
			var indextoSplice = -1;
			var columnsLength = newData.colNames.length;
			if(newData.colNames[columnsLength -1].match(/skipped/i)) {
				indextoSplice = columnsLength - 1;
			} else {
				// if the skipped job row is not found at the last index of the array, then find the proper index by looping through each element
				for(var i=0; i<columnsLength; i++) {
					if(newData.colNames[i].match(/skipped/i)) {
						indextoSplice = i;
						break;
					}
				}
			}

			if(indextoSplice != -1) {
				newData.colNames.splice(indextoSplice,1);
				for(var i = 0; i < newData.coldata.rows.length; i++) {newData.coldata.rows[i].cell.splice(indextoSplice,1);}
			}
		}
	}


	var diagNUsagePage = window.location.href.indexOf("CommCellSurvey.jsp?surveyId=12") > -1 ? true:false;
	var value = convertFromJQToDT(newData);
	if(newData.dbQuery!=undefined){
		value.dbQuery=newData.dbQuery;
	}
	var view = {};
	view.title = tableHeading;
	view.filters = !(surveyId==92&&type=='Summary');
	view.collapsible = true;
	view.alarm = true;
	if(surveyId == 2 && diagNUsagePage) {
		view.colChooser = false;
	} else {
		view.exportExcel = true;
	}
	if(cvUtil.getParameter('createGroup',null) !=null){
		view.exportExcel = false;
		view.alarm = false;
	}
	if(surveyId == 67 && cvUtil.getParameter("entity")){
		view.title  = decodeURIComponent(cvUtil.getParameter("entity"));

	}else if(surveyId == 137){
		if(cvUtil.getParameter("repType") == 'monthly'){
			view.title = cvUtil.cvLocalize("table.title.Daily_Backup_Jobs");
			showJobsSummaryOptions();
		}else if(cvUtil.getParameter("repType") == 'daily' || cvUtil.getParameter("repType") == 'hourly'){
			showJobsDetailsSummary();
			view.title = cvUtil.cvLocalize("table.title.Job_Details");
		}
	}else if(surveyId == 51 && cvUtil.getParameter("repType")!=""){
		view.title = cvUtil.cvLocalize("table.title.Hourly_Backup_Jobs");
		showJobsSummaryOptions();
	}else if(surveyId == 25 && tableDiv == "FullStrikeTable" && commcellId >0){
		view.urls = [];
		var baseLink = docBaseURL.substr(0,docBaseURL.lastIndexOf("/"));
		helpLink = baseLink+"/article?p=error_codes/error_codes.htm";
		view.urls.push({
			"name" : cvUtil.cvLocalize("Error_Code"),
			"url" :
				(SurveyGlobals.Version && SurveyGlobals.Version.substring(0, 1) == '9' ? "http://documentation.commvault.com/commvault/release_9_0_0/books_online_1/english_us/error_codes/error_codes.htm": helpLink),
			"target" : "_blank"
		});
	}else if(surveyId==67 || surveyId==117){
		value.iDisplayLength=10;
	}else if(surveyId == 144){
		if(commcellId){
			if(cvUtil.getParameter("database") ) {
				var database = cvUtil.getParameter("database");
				view.title  = cvUtil.cvLocalize("Database")+" - "+database;
			}else{
				view.title  = cvUtil.cvLocalize("Databases");
			}
		}

	}else if(surveyId==55 && type=='Summary'){
		view.title = cvUtil.cvLocalize("throughput.Backup_Throughput_by_Media");
	}
	if(surveyId==96){
		view.trend = true;
	}
	if(typeof SurveyTemplates !== 'undefined') {
		if(!(window['commCellDetails_initialized']==true && tableDiv=="commCellDetails") && !window[tableDiv+'_initialized']){$('#tableWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));}
		if(exportRequest){
			value.iDisplayLength=-1;
		}
		Reports.configureClientSideTableWithPaging(tableDiv, view.title, value);
		if(surveyId == 25 && tableDiv == 'commCellDetails'){
			addTableLinksAtTop(tableDiv, view);
		}
		if(surveyId == 2) {
			if(diagNUsagePage) {
				var dataTable = $('#'+tableDiv+CVTable.table).dataTable();
                dataTable.fnSetColumnVis( 0, false);
			}
		}
		/*
		 * if(newData.totalRows > newData.maxRows){ var title = 'This table is showing only
		 * '+newData.maxRows+' of ' + newData.totalRows + ' entries. Filters and Sorting will work on loaded
		 * data only. To view full data, please use CSV export.'; var note = "<span
		 * id='"+tableDiv+"_rows_note' class='tableRowsNote' title='"+title+"'>This table is showing partial
		 * data.</span>"; $("#"+tableDiv+" .dataTables_info").append(note); $("#"+tableDiv).attr('sqlid',
		 * newData.sqlExportKey); }
		 */
	} else {
		genearateGrid(newData,surveyId,tableDiv,pagerDiv,actionTitle,tableHeading,commcellId,type,isGlobal);
	}

	collapseTable(surveyId);


}

function collapseTable(surveyId){
	/*
	 * if(!exportRequest){ if((!exportRequest) && surveyId == 12 &&
	 * cvUtil.getParameter("fromDashboardSLA")==""){ var key = "summaryDetails"; var arrow =
	 * $("#"+key+".reportTable").find(".arrowPlaceholder"); if(arrow.hasClass("expand")){
	 * $("#"+key+".rptTblBtnEncDiv").hide(); arrow.removeClass("expand").addClass("collapse");
	 * arrow.parent().siblings().slideToggle("fast"); } } }
	 */
}

function genearateScaleReportTables(newData,surveyId,actionTitle,tableDiv,pagerDiv,tableHeading,commcellId,type,isGlobal)
{
	if(newData == undefined || newData == null) {
		alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
	}else {
		if(newData && typeof newData === 'object') {
			var colWidthMap = {};
			colWidthMap["Parameter"] = 300;
			colWidthMap["Status<SCALE_STATUS>"] = 200;

			$.each(newData, function(key, data){
				if(typeof data == 'object') {
					tableDiv = key.replace(/ /g, '_')+'_'+surveyId;

					var value = convertFromJQToDT(data, colWidthMap);
					var view = {};
					view.title = key;
					view.collapsible = true;

					var param = cvUtil.getParameter('param');
					if(param != undefined && param.length > 0){
						view.filters = true;
						view.exportExcel = true;
						view.colChooser = true;
					}
					if(surveyId==7){
						view.filters = true;
					}
					if(typeof SurveyTemplates !== 'undefined') {
						$('#tableWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));
						if(exportRequest){
							value.iDisplayLength=-1;
						}
						if(param != undefined && param.length > 0){
							Reports.configureClientSideTableWithPaging(tableDiv, view.title, value);
							$("#"+tableDiv+" .rptTblBtnEncDiv").append($("#"+tableDiv+"_table_length"));
						}else{
							Reports.configureClientSideTable(tableDiv, view.title, value);
						}
					}
				}
			});
		}/*
			 * else if(data && typeof data === 'string') { // not expecting string for data, could be error..
			 * $("#noDataNotificationPanel").html(data); $("#ContentWrapper").hide();
			 * $("#noDataNotificationPanel").show(); } $('#ContentWrapper').append("<div
			 * class='clearFloat'/>");
			 */
	}
}

function addTableLinksAtTop(tableDiv, view) {
	var ulMarkup = $('#' + tableDiv + "_links").html();
	var topLinkMarkup = "<div class='tableLinks' id='"+tableDiv+"_toplinks'>" + ulMarkup + "</div>";
	$('#' + tableDiv + "_table_wrapper").prepend(topLinkMarkup);
}

function getSortColumnIndex(col, colNames){
	col = col + '<SORTCOLUMN>';
	for(var i=0; i<colNames.length;i++) {
		if(col == colNames[i]){
			return i;
		}
	}
	return -1;
}

function convertFromJQToDT(data, colWidthMap) {
	var retval = {};
	var diagNUsagePage = window.location.href.indexOf("CommCellSurvey.jsp?surveyId=12") > -1 ? true:false;
	if(data) {
		var aoColumns = [];
		var aaData = [];
		if(data.colNames) {
			for(var i=0; i<data.colNames.length;i++) {
				var col = {};
				col.bVisible = !data.colModel[i].hidden;
				col.sOriginalName = data.colNames[i];
				col.sqlType = data.colModel[i].sqlType;
				col.doNotShow = data.colModel[i].doNotShow;

				if (data.colNames[i].indexOf("<HIDDEN>") !== -1) {
					var re = /<HIDDEN>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.bVisible = false;
				}

				if(data.colNames[i].indexOf("<ALTSORT>") != -1){
					var re = /<ALTSORT>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');

					var columnName = data.colNames[i];
					if(columnName.indexOf("<") != -1 && columnName.indexOf(">") != -1){
						columnName = columnName.substr(0, columnName.indexOf('<'));
					}
					var sort_index = getSortColumnIndex(columnName, data.colNames);
					if(sort_index > -1){
						col.iDataSort = sort_index;
					}
				}

				if (data.colNames[i].indexOf("<DONOTSHOW>") !== -1
						|| data.colNames[i].indexOf("<SORTCOLUMN>") !== -1) {
					if(data.colNames[i].indexOf("<SORTCOLUMN>") !== -1){
						var re = /<SORTCOLUMN>/gi;
						data.colNames[i] = data.colNames[i].replace(re, '_SORTCOLUMN');
					}else{
						var re = /<DONOTSHOW>/gi;
						data.colNames[i] = data.colNames[i].replace(re, '');
					}
					col.doNotShow = true;
					col.bVisible = false;
				}

				if(data.colModel[i].sorttype != undefined && data.colModel[i].sorttype == 'numeric'){
					col.sType = data.colModel[i].sorttype;
				}

				//set custom width
				if (colWidthMap && colWidthMap[data.colNames[i]]) {
					col.sWidth = colWidthMap[data.colNames[i]];
				}

				//Renderers.....
				col.bFilterRendered = true;
				if(data.colNames[i].indexOf("<SIZEMB>") != -1) {
					var re = /<SIZEMB>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = getRenderer(data.colNames[i], { 'sortype' : data.colModel[i].sorttype, 'size': 'sizeMB' });
				} else if(data.colNames[i].indexOf("<SIZEMB_NEG>") != -1) {
					var re = /<SIZEMB_NEG>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = getRenderer(data.colNames[i], { 'sortype' : data.colModel[i].sorttype, 'size': 'sizeMB_Neg' });
				} else if(data.colNames[i].indexOf("<DATETIME>") != -1) {
					var re = /<DATETIME>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "dateTimeRenderer";
				} else if (data.colNames[i].indexOf("<MMMYYYY>") != -1) {
					var re = /<MMMYYYY>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "MMMYYYY";
				} else if (data.colNames[i].indexOf("<NumberNA>") != -1) {
					var re = /<NumberNA>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "NumberNA";
				} else if (data.colNames[i].indexOf("<NumberUnlimitedNA>") != -1) {
					var re = /<NumberUnlimitedNA>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "NumberUnlimitedNA";
				} else if (data.colNames[i].indexOf("<DISKLIBDATE>") != -1) {
					var re = /<DISKLIBDATE>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "DISKLIBDATE";
				} else if (data.colNames[i].indexOf("<MMMDDYYYY>") != -1) {
					var re = /<MMMDDYYYY>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "MMMDDYYYY";
				} else if (data.colNames[i].indexOf("<DWDDMMM>") != -1) {
					var re = /<DWDDMMM>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "DWDDMMM";
				} else if (data.colNames[i].indexOf("<MMMDDYYYYHrMinAM>") != -1) {
					var re = /<MMMDDYYYYHrMinAM>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "MMMDDYYYYHrMinAM";
				} else if (data.colNames[i].indexOf("Quarter") != -1) {
					col.rendererType = "Quarter";
				} else if (data.colNames[i].indexOf("<SP_NAME_LINK>") !== -1) {
					var re = /<SP_NAME_LINK>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					if(cvUtil.getParameter("commUniId")) {
						col.rendererType = "spNameLinkRenderer";
					}
				} else if (data.colNames[i].indexOf("<CATEGORY_LINK>") !== -1) {
					var re = /<CATEGORY_LINK>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "CATEGORY_LINK";
				} else if (data.colNames[i].indexOf("<BOOLEAN>") !== -1) {
					var re = /<BOOLEAN>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "booleanRenderer";
					col.bFilterRendered = false;
				}  else if (data.colNames[i].indexOf("<HEALTH_STATUS>") !== -1) {
					var re = /<HEALTH_STATUS>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "HEALTH_STATUS";
				} else if (data.colNames[i].indexOf("<DAYS>") !== -1) {
					var re = /<DAYS>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "DAYS";
				} /*
					 * else if (data.colNames[i].indexOf("<") !== -1 && data.colNames[i].indexOf(">") !== -1) {
					 * var re = /<.*?>/gi; var token = data.colNames[i].match(re); token = token.toString();
					 * var renderer = token.substr(1, token.length-2); data.colNames[i] =
					 * data.colNames[i].replace(re, ''); col.rendererType = renderer; }
					 */else if (data.colNames[i].indexOf("<SCALE_STATUS>") !== -1) {
					var re = /<SCALE_STATUS>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "SCALE_STATUS";
				}else if (data.colNames[i].indexOf("<SCALE_REMARKS_LINK>") !== -1) {
					var re = /<SCALE_REMARKS_LINK>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "SCALE_REMARKS_LINK";
				} else if (data.colNames[i].indexOf("<HOURS>") !== -1) {
					var re = /<HOURS>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "HOURS";
				}else if (data.colNames[i].indexOf("<COMMCELL_STATUS>") !== -1) {
					var re = /<COMMCELL_STATUS>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "CommcellStatusRenderer";
					col.bFilterRendered = false;
				}else if (data.colNames[i].indexOf("<FORMATNUMBERNA>") !== -1) {
					var re = /<FORMATNUMBERNA>/gi;
					data.colNames[i] = data.colNames[i].replace(re, '');
					col.rendererType = "FORMATNUMBERNA";
					col.bFilterRendered = false;
				}else if (
					data.colNames[i].indexOf("<AssociateToCommCellGroup>") !== -1) {
                    var re = /<AssociateToCommCellGroup>/gi;
                    data.colNames[i] = data.colNames[i].replace(re, '');
                    col.rendererType = "AssociateToCommCellGroup";
				}else if(data.colNames[i].indexOf("<CC_DRILLDOWN>") !== -1){
					var re = /<CC_DRILLDOWN>/gi;
                    data.colNames[i] = data.colNames[i].replace(re, '');
                    col.rendererType = "CC_DRILLDOWN";
                    col.bFilterRendered = false;
				} else if (data.colNames[i].indexOf("<DOT_STATUS>") !== -1) {
                    /// Pass on render types which require a status dot icon
                    var re = /<DOT_STATUS>/gi;
                    data.colNames[i] = data.colNames[i].replace(re, '');
                    col.rendererType = "DOT_STATUS";
                    col.bFilterRendered = false;
				}else {
					var re = /<(.*)>$/i;
					if(re.test(data.colNames[i])) {
						col.rendererType = re.exec(data.colNames[i])[1];
						data.colNames[i] = data.colNames[i].replace(re, '');
					} else {
						col.rendererType = getRenderer(data.colNames[i], { 'sortype' : data.colModel[i].sorttype });
					}
				}
				col.sTitle = data.colNames[i];
				col.mDataProp = data.colNames[i].replace(";", "_").replace(".", "");
				col.bUseRendered = false;
				aoColumns.push(col);
			}
			setFilterRendered(aoColumns);
		}
		if(data.coldata) {
			if(data.coldata.rows) {
				for(var j=0; j<data.coldata.rows.length; j++) {
					var cell = data.coldata.rows[j].cell;
					var dtcell = {};
					for(var k=0;k<cell.length;k++) {
						dtcell[aoColumns[k].mDataProp] = cell[k];
					}
					aaData.push(dtcell);
				}
			}

			retval.iDisplayLength = defaultIDisplayLength;
			retval.iTotalRecords = data.coldata.total;
			retval.iTotalDisplayRecords = data.coldata.records;
		}
		retval.aoColumns = aoColumns;
		retval.aaData = aaData;
		retval.query = data.query;
		retval.dataURL = data.dataURL;
	}

	return retval;

}

function getRenderer(colname, opts) {
	if(opts.size === 'sizeMB') {
		return "capacityMB";
	} else if (opts.size === 'sizeMB_Neg') {
		return "capacityMB_Neg";
	} else if (colname === "CommCell Name") {
		return "commcellName";
	} else if (colname === "Strike Count") {
		return "strikeCount";
	} else if (colname === "Last Job Failure Reason") {
		return "failureReason";
	}else if (colname === "GroupName") {
		return "CommCellGroup";
	}
	return "";
}

function genearateGrid(newData,survey,div,pagerDiv,actionTitle,tableHeading,commcellId,type,isGlobal)
{
	var colnames = newData.colNames;
	var stri = survey+'_'+div+'=';
	console.log(stri);
	$.each(colnames,function(i,val){
	stri = stri + val+":string,";
	});
	console.log(stri);
	var colmodel = newData.colModel;
	var coldata = newData.coldata;
	var shrinFit=true;
	var isHealth = window.location.href.indexOf("CommCellSurvey.jsp?surveyId=12") > -1 ? true:false;
	if(survey == 1 || (survey == 3 && type != "Summary")){shrinFit=false;}

			jQuery("#"+div).jqGrid({
				datatype:"jsonstring",
				colNames:colnames,
				colModel:colmodel,
				rowNum:100,
				rowList:[50,100,200,500],
				pager:pagerDiv,
				sortName:'id',
				datastr:coldata,
				toppager : true,
				cloneToTop : true,
				viewrecords:true,
				sortorder:"asc",
				viewrecords: true,
				ignoreCase: true,
				loadonce:true,
				datastr: coldata,
				altRows:true,
				sortorder: "desc",
				caption:tableHeading,
				width:$("#content").width(),
				shrinkToFit:shrinFit,
				height: '100%',
				onCellSelect:function(rowid, iCol, cellcontent)
				{

					try {
						var clientName = $("#"+div).jqGrid ('getCell', rowid, 4);
						var commCellId = $("#"+div).jqGrid ('getCell', rowid, 1);
						commCellId=$(commCellId).text();
						var commIpAddr = $("#"+div).jqGrid ('getCell', rowid, 2);
						var CommGuiId = $("#"+div).jqGrid ('getCell', rowid, 3);
						var commUniId = $("#"+div).jqGrid ('getCell', rowid, 0);


						if(type == 'CommCell' && iCol == 1 && isHealth){document.location.href='commcellmonitoring.jsp?commUniId='+commUniId;}else if(type == 'CommCell' && iCol == 1) {
						populateIndCommCellDetails(rowid);
						//populateIndDashboard(rowid);
					}
					}
                catch(error) {

					}
				},loadComplete:function(){
					//$("tr.jqgrow:even").addClass('evenRow');
					//$("tr.jqgrow:odd").addClass('oddRow');
				},
				gridComplete : function(){
					if(isHealth) {
						$("#"+div).hideCol("index14");
						$("#"+div).setGridParam({'autowidth':true});
						$('#'+div).setGridWidth(1100, true);
					}
					$('.ui-jqgrid tr.jqgrow:nth-child(odd)').addClass("oddColor");
					$('.ui-jqgrid tr.jqgrow:nth-child(odd)').css('background-image', 'none');
					$('.ui-jqgrid tr.jqgrow:nth-child(even)').addClass("evenColor");
					$('.ui-jqgrid tr.jqgrow:nth-child(even)').css('background-image' , 'none');
					$('td').removeAttr('title');
				}
			});
		var grid = $("#"+div);
   		grid.jqGrid('filterToolbar',{stringResult: true,searchOnEnter : false,defaultSearch : "cn",
		beforeSearch:function(){
			var ofilter = $("#"+div).getGridParam("postData").filters; // this methis is overidden to get the filtered list when exporting by Jagadeesh.
			ofilter = cvUtil.parseJSON(ofilter);
			if(gridSearchResult == null){gridSearchResult = {};}
			gridSearchResult[div] = 'empty';
			if(ofilter.rules[0] != undefined)
			{
				isSearch = true;
				currentSearchGrid = div;
			}
		}});
   		grid.jqGrid('navGrid', '#'+div+'_toppager_right', {del:false,add:false,edit:false,search:true,cloneToTop : true,beforeRefresh: function(){
            gridSearchResult = {}; // when clicked on reload icon , refresh the search results to all
			gridSearchResult[div] = 'empty'; // when clicked on reload icon , refresh the search results to all by Jagadeesh.
		}});
		grid.jqGrid('navButtonAdd', '#'+div+'_toppager_left',{caption:"Export to Excel",buttonicon:"ui-icon-disk",view:true, del:false, add:false, edit:false, excel:true,onClickButton: function(){ exportExcel($(this),isGlobal,commcellId);}});
		var topPagerDiv = $('#'+div+'_toppager')[0];
		//$("#" + grid[0].id + "_toppager_center", topPagerDiv).remove();
		//$("#" + grid[0].id + "_toppager_right", topPagerDiv).empty();
		grid.jqGrid('navButtonAdd', '#'+div+'_toppager_left', {// "#list_toppager_left"
			caption : "Columns",
			buttonicon : 'ui-icon-wrench',
			onClickButton : function() {
				grid.jqGrid('columnChooser', {
							msel_opts: {
                            autoOpen: true
                            },
					done : function(perm) {
						if(!perm) {
							return false;
						}
						this.jqGrid('remapColumns', perm, true);
						if($('#'+div).getGridParam('shrinkToFit') == true){$('#'+div).setGridWidth(1100, true);}
					}

				});
			}
		});


	}
//	var oldFrom = $.jgrid.from;
//		var lastSelected;
//		$.jgrid.from = function (source, initalQuery) {
//		var result = oldFrom.call(this, source, initalQuery),
//		old_select = result.select;
//		result.select = function (f) {
//			lastSelected = old_select.call(this, f);
//			if(isSearch){
//				isSearch = false;
//				gridSearchResult[currentSearchGrid] = lastSelected;
//			}
//			return lastSelected;
//		};
//		return result;
//		}
	/* this Method wil add the hex value for the commcell ID if the formatter is defined in the col model */
	$.extend($.fn.fmatter , {
		hexIdFormatter : function(cellvalue, options, rowdata) {
		return decimalToHex(cellvalue,2).toUpperCase();
		}
	});
	function summaryBarChart(data,isGlobal,commcellId)
	{
		var colnames = data.labels;
		var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
		var commUniId = cvUtil.getParameter('commUniId', -1);
		var companyId = cvUtil.getParameter("companyId", 0);
		if(isGlobal && ccGroupId > 0) {
			$('#summaryBarChartContainerTitle').append("Group Usage");
		}else if(isGlobal){
			$('#summaryBarChartContainerTitle').append(localMsg.worldwideLicenseUsage);
		} else {
			$('#summaryBarChartContainerTitle').append(localMsg.licenseUsage);
		}

		if(!(isPrivateMetrics == 'false' && parseInt(ccGroupId) <= 0 && parseInt(companyId) <= 0 && parseInt(commUniId) <= 0)){//no link for public worldwide level
			var url = "", params = [], paramStr = "";
			if (parseInt(ccGroupId) > 0) {
				params.push("ccGroupId=" + ccGroupId);
			}
			if (parseInt(companyId) > 0) {
				params.push("companyId=" + companyId);
			}
			if (parseInt(commUniId) > 0) {
				params.push("commUniId=" + commUniId);
			}
			if (params.length > 0) {
				paramStr = "?";
			}
			paramStr += params.join("&");
			var url = cvUtil.getContextPath() + "/survey/reports/capacitygrowth.jsp" + url + paramStr;
			$('#headerLinks ul').append('<li class="nobar rightMenu"><a id="peakCapacityUrl" href="'+url+'">Peak Capacity Usage Growth</a></li>');
		}


		if( data.error == undefined )
		{
			var tempLabels=colnames.slice(1,colnames.length);
			var labels=new Array();
			var colmodel = data.values;
			var val = colmodel[0]['cell'];
			var labels = new Array();
			var totalValues = new Array();
			var freeValues = new Array();
			var usedValues = new Array();
			var percent = new Array();
			var colors = new Array();
			var ys = new Array();
			var unit = 'TB';
			if(commcellId == undefined){unit='PB';}
			if(isGlobal){
				$("#collectionCount").append("Number of CommCells with License: <span class='commcell'> "+ colmodel[0]['cell'][0]+"<\span>");
			}
			j=0; //changed the logic to reverse the order of the bar
			for (var i=0;i<colmodel.length;i++)
			{

				var val = colmodel[i]['cell'];
					labels[j] =  val[1];
					if(commcellId == undefined && $.inArray(val[1], countEntities)==-1){   // this for the world wide
						totalValues[j] = roundNumber(parseFloat(val[2])/1024,2);
						freeValues[j]= roundNumber(parseFloat(val[2])/1024,2)-roundNumber(parseFloat(val[3])/1024,2);
						usedValues[j] = roundNumber(parseFloat(val[3])/1024,2);
						percent[j] = roundNumber(parseFloat(val[4]), 2);
					}else
					{                        // this for the individual commcell id
						totalValues[j] = roundNumber(parseFloat(val[2]), 2);
						freeValues[j]= roundNumber(parseFloat(val[2]),2)-roundNumber(parseFloat(val[3]),2);
						usedValues[j] = roundNumber(parseFloat(val[3]), 2);
						percent[j] = roundNumber(parseFloat(val[4]), 2);
					}
					if(totalValues[j]==0 && usedValues[j]>0){
						percent[j]=100;
					}
					ys[j]=percent[j];
					if (totalValues[j] == 0){colors.push("#FFCC00");}else if(ys[j]>100||(totalValues[j]==0 && usedValues[j]>0)){
						ys[j]=100;
						 colors.push('#ff0000'); //red
					} else {colors.push("#508cf5");}
				j++;
			}
			var stackedValues = [ys];
			var yMax = 99;

			var note=cvUtil.cvLocalize("capacity_Usage", unit);
			var serLabels =[cvUtil.cvLocalize("chart.series.label.Data_Size_in", unit) ,cvUtil.cvLocalize("chart.series.label.License_Type")];
			//labs.sort(sortLabelsArray);
			//vals.sort(int_arr);
			dataAvailable(true, "summaryBarTop", "summaryBarChartContainer");
			$('#summaryBarTop').addClass('fullWidth');
			$("#licenseNote").addClass("show");

			createCapacityUsageDials(data);
		}
		else
		{
			dataAvailable(false, "summaryBarTop", "summaryBarChartContainer", cvUtil.cvLocalize("error.msg.Capacity_License_may_not_be_used"));
		}

		 if (exportRequest) {
			 $("#summaryPieTop2").addClass("pageBreak");
			 $("#summaryPieTop3").addClass("pageBreak");
			 $("#summaryPieTop4").addClass("pageBreak");
			 $("#summaryPieTop5").addClass("pageBreak");
			 $("#summaryPieTop1").addClass("pageBreak");
			 $("#summaryPieTop6").addClass("pageBreak");
		 }
	}


	function showLicenseUsageNote(versionInfo){
		if(surveyId == 1 && versionInfo != undefined && (commUniId > 0)){
			var regex=/\d+/gi;
			var verArr = versionInfo.match(regex);
			var show = true;
			if(verArr.length > 1){
				var version = parseInt(verArr[0].trim());
				var sp = parseInt(verArr[1].trim());
				if(version >= 11){
					show = false;
				}else if(version == 10 && sp >= 11){
					show = false;
				}
			}else if(verArr.length == 1){
				var version = parseInt(verArr[0].trim());
				if(version >= 11){
					show = false;
				}
			}
			if(show){
				$("#summaryBarTopNote").append(cvUtil.cvLocalize("error.msg.Purchased_quantities"));
			}
		}
	}

	function summaryThroughputBarChart(data)
	{
		 var month = [];
		 var diskThoughput = [];
		 var tapeThroughput = [];
		 var cloudThroughput = [];

		 var diskData = [];
		 var tapeData = [];
		 var cloudData = [];
		 var allChartsData = [];
		 var chartOptions = {}

		 var diskChartJson = {};
		 diskChartJson.title = cvUtil.cvLocalize("chart.title.Average_Disk_Backup_Throughput");
		 diskChartJson.type = 'Disk';
		 allChartsData.push(diskChartJson);

		 var tapeChartJson = {};
		 tapeChartJson.title = cvUtil.cvLocalize("chart.title.Average_Tape_Backup_Throughput");
		 tapeChartJson.type = 'Tape';
		 allChartsData.push(tapeChartJson);

		 var cloudChartJson = {};
		 cloudChartJson.title = cvUtil.cvLocalize("chart.title.Average_Cloud_Library_Throughput");
		 cloudChartJson.type = 'Cloud';
		 allChartsData.push(cloudChartJson);

		 if( data.error == undefined ){
			 var coldata = data.coldata;
			 var rows = coldata.rows;
			 var xAxisLabels = jQuery.extend(true, [], data.colNames);// Deep copy
			 xAxisLabels.pop();
			 xAxisLabels.splice(0, 1);
			 for (var i=0;i<rows.length;i++){
				if(rows[i].cell[0].toLowerCase() == 'disk'){
					for(var j=1; j<=8; j++){
						diskThoughput[j-1] = parseFloat(rows[i].cell[j]) >=0? parseFloat(rows[i].cell[j]) : 0;
					}
				}else if(rows[i].cell[0].toLowerCase() == 'tape'){
					for(var j=1; j<=8; j++){
						tapeThroughput[j-1] = parseFloat(rows[i].cell[j]) >=0? parseFloat(rows[i].cell[j]) : 0;
					}
				}else if(rows[i].cell[0].toLowerCase() == 'cloud'){
					for(var j=1; j<=8; j++){
						cloudThroughput[j-1] = parseFloat(rows[i].cell[j]) >=0? parseFloat(rows[i].cell[j]) : 0;
					}
				}
			}

			var xAxis = {};
			xAxis.title = {};
			xAxis.gridLineWidth = 1;
			xAxis.gridLineColor = '#eee';
			xAxis.tickInterval = 1;
			xAxis.labels= {
			        formatter: function() {
			            return xAxisLabels[this.value];
			        }
			    };
			var yAxis = {};
			yAxis.title = {};
			yAxis.min = 0;
			yAxis.title.text = 'GB/HR';
			yAxis.gridLineColor = '#eee';
			yAxis.gridLineWidth = 1;
			var tooltip = {
			        formatter: function () {
			            return xAxisLabels[this.x] +' : <b>' + this.y + ' GB/HR</b>';
			        }
			    };
			chartOptions.xAxis = xAxis;
			chartOptions.yAxis = yAxis;
			chartOptions.tooltip = tooltip;

			var drawDiskChart = false ;
			var drawTapeChart = false;
			var drawCloudChart = false;

			for(var i=0;i<diskThoughput.length;i++){
				if((!drawDiskChart)&&diskThoughput[i]>0){
					drawDiskChart=true;
				}
				if((!drawTapeChart)&&tapeThroughput[i]>0){
					drawTapeChart=true;
				}
				if((!drawCloudChart)&&cloudThroughput[i]>0){
					drawCloudChart=true;
				}
			}

			if(drawDiskChart){
				diskChartJson.series = [];
				var series = {};
				series.name ='Disk';
				series.color =  '#B45F04';
				series.data = diskThoughput;//diskData;
				diskChartJson.series.push(series);
			}

			if(drawTapeChart){
				tapeChartJson.series = [];
				var series = {};
				series.name='Tape';
				series.color =  '#21610B';
				series.data = tapeThroughput;//tapeData;
				tapeChartJson.series.push(series);
			}

			if(drawCloudChart){
				cloudChartJson.series = [];
				var series = {};
				series.name='Cloud';
				series.color =  '#0489B1';
				series.data = cloudThroughput;//cloudData;
				cloudChartJson.series.push(series);
			}
		}
		drawThroughputLinechart(allChartsData, chartOptions);
	}

	function drawThroughputLinechart(allChartsData, chartOptions){
		$.each(allChartsData, function(i, chartData){
			var chartMarkup = '<li class="col-md-4 col-sm-6 col-xs-12"><div comp="throughputChart_' + i + '" data-component-type="METRICS_CHART" class="chartholder throughput-box"><div class="chartTitleStyle"><span>'+chartData.title+'</span></div>';
			var chartNodata = 'no-data_'+chartData.type;
			chartMarkup += '<div id="'+chartNodata+'" class="chart-no-data hide"></div>';
			var chartId = 'chart_'+chartData.type;
			chartMarkup += '<div id="'+chartId+'" class="chart-container"></div></div></li>';
			$('#throughputChartsDiv ul').append(chartMarkup);

			if(!chartData.series){
				$('#'+chartNodata).removeClass('hide');
				$('#'+chartNodata).text(cvUtil.cvLocalize("No_Data_Available"));
				return;
			}

			$("#"+chartId).highcharts({
				chart : {
					height : 290,
					marginRight: 30
					//width : 530
				},
				title : {
					text : ''
				},
				legend: {
					enabled: false
				},
				xAxis : chartOptions.xAxis,
				yAxis : chartOptions.yAxis,
			    tooltip: chartOptions.tooltip,
				series : chartData.series,
				plotOptions: {
				        series: {
				            marker: {
				                radius: 3
				            }
				        }
				    },
				credits : {
					enabled : false
				}
			});
		});
	}

	function createThroughputLinechart(frameId, cdata)
	{
		$("#" + frameId).empty();
		var r = Raphael(frameId, 545,340);
		var txtattr = { font: "12px 'Fontin Sans', Fontin-Sans, sans-serif" };

		var width = 7*65;

		if(width>600)
		{
			width = 600;
		}else if(width<150){
			width = 150;
		}

		cvcharts.createRaphaelLinechart(r, cdata, {
			axis : "0 1 1 1",
			chartWidth : width,
			chartHeight : 280,
			topMargin : 20,
			leftMargin : 50,
			maxSteps : 7,
			showPartialLine : true,
			shade : false,
			//width : 1,
			showLegend : false,
			smooth : true,
			radius : 2,
			formatLabels : false
		});
	}

	function summaryLibraryGrowthTrendingChart(resp){
		$('#barTitle').append(surveyId == 196?cvUtil.cvLocalize("chart.title.cloud_library_growth_trending"):cvUtil.cvLocalize("chart.title.disk_library_growth_trending"));
		var chartOptions = {}
		var month = [];
		var diskThoughput = [];
		var seriesData = [];
		var cdata;
		var maxSeries = 0;
		if( resp.data != undefined && resp.data.cData != undefined ){
			cdata = resp.data.cData;
			 for (var i=0;i<cdata.seriesList.length;i++){
				 var tseries = cdata.seriesList[i];
				 if(tseries){
					 var series = {};
					 series.name = tseries.seriesName;
					 series.connectNulls = true;
					 series.color = cvcharts.colors[5][i];
					 series.data = [];
					 for(var p=0; p < tseries.points.length; p++){
						 var point = tseries.points[p];
						 point.y = (point.y >=0)? point.y : null;
						 series.data.push(point);
					 }
					 seriesData.push(series);
					 if(series.name.length > maxSeries){
						 maxSeries = series.name.length;
					 }
				 }
			}
		}else{
			dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
			return;
		}

		var xAxis = {};
		xAxis.title = {};
		xAxis.title.text = cdata.xAxisTitle;
		xAxis.gridLineWidth = 1;
		xAxis.gridLineColor = '#eee';
		xAxis.tickInterval = 1;
		xAxis.labels= {
		        formatter: function() {
		            return cdata.xAxis.labels[this.value];
		        }
		    };

		var yAxis = {};
		yAxis.title = {};
		yAxis.min = 0;
		//yAxis.max = yMax;//cdata.yAxis.maxValue;
		yAxis.tickAmount = cdata.yAxis.numSteps;
		yAxis.title.text = cdata.yAxisTitle;;
		yAxis.gridLineColor = '#eee';
		yAxis.gridLineWidth = 1;
		var tooltip = {
		        formatter: function () {
		        	if(this.point.popupLabel){
		        		return this.series.name +' : <b>' + this.point.popupLabel + '</b>';
		        	}
		        }
		    };
		chartOptions.xAxis = xAxis;
		chartOptions.yAxis = yAxis;
		chartOptions.tooltip = tooltip;

		$("#barchartcontainer").highcharts({
			chart : {
				height : 350,
				width : 1000
			},
			title : {
				text : ''
			},
			xAxis : chartOptions.xAxis,
			yAxis : chartOptions.yAxis,
			legend: {
				enabled: true,
		        layout: 'vertical',
		        align: 'right',
		        verticalAlign: 'middle',
		        itemWidth: (maxSeries > 30?250:undefined)
			},
		    tooltip: chartOptions.tooltip,
			series : seriesData,
			plotOptions: {
			        series: {
			            marker: {
			                radius: 3,
			                symbol: 'circle'
			            }
			        }
			    },
			credits : {
				enabled : false
			}
		});
	}

	function summaryClientsTrendingChart(data){
		$('#barTitle').append(cvUtil.cvLocalize("chart.title.Clients_Count_Trending"));

		 var month = [];
		 var addedClients = [];
		 var removedClients = [];
		 var totalClients = [];

		if( data.error == undefined )
		{
			var coldata = data.coldata;
			var rows = coldata.rows;

			var addedPoints = [], removedPoints = [], totalPoints = [];

			var maxY=0;
			for (var i=0;i<rows.length;i++)
			{
				month[i] = getDate(rows[i].cell[0], 'MMM YYYY');
				addedClients[i] = parseFloat(rows[i].cell[1]) >=0? parseFloat(rows[i].cell[1]) : 0;
				removedClients[i] = parseFloat(rows[i].cell[2]) >=0? parseFloat(rows[i].cell[2]) : 0;
				totalClients[i] = parseFloat(rows[i].cell[3]) >=0? parseFloat(rows[i].cell[3]) : 0;

				var monthStr = month[i].substr(0, 3)+' '+month[i].substr(month[i].length-4);
				var aPoint={};
				aPoint.x=i;
				aPoint.y=addedClients[i];
				var plabel = cvUtil.cvLocalize('chart.series.label.Clients_Added')+' : '+addedClients[i];
				plabel = "<div style='font-weight: bold; text-align: center'>"+monthStr+"</div>"+plabel;
				aPoint.popupLabel= plabel;
				addedPoints.push(aPoint);
				if(addedClients[i] > maxY){
					maxY = addedClients[i];
				}

				var rPoint={};
				rPoint.x=i;
				rPoint.y=removedClients[i];
				var plabel = cvUtil.cvLocalize('chart.series.label.Clients_Removed')+' : '+removedClients[i];
				plabel = "<div style='font-weight: bold; text-align: center'>"+monthStr+"</div>"+plabel;
				rPoint.popupLabel=plabel;
				removedPoints.push(rPoint);
				if(removedClients[i] > maxY){
					maxY = removedClients[i];
				}

				var tPoint={};
				tPoint.x=i;
				tPoint.y=totalClients[i];
				plabel = cvUtil.cvLocalize('chart.series.label.Total_Clients')+' : '+totalClients[i];
				plabel = "<div style='font-weight: bold; text-align: center'>"+monthStr+"</div>"+plabel;
				tPoint.popupLabel=plabel;
				totalPoints.push(tPoint);
				if(totalClients[i] > maxY){
					maxY = totalClients[i];
				}
			}
			if(maxY <= 0){
				dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_chartable_data_available"));
				return;
			}
			var addedSeries={};
			addedSeries.seriesName=cvUtil.cvLocalize('chart.series.label.Clients_Added');
			addedSeries.points=addedPoints;


			var removedSeries={};
			removedSeries.seriesName=cvUtil.cvLocalize('chart.series.label.Clients_Removed');
			removedSeries.points=removedPoints;


			var totalSeries={};
			totalSeries.seriesName=cvUtil.cvLocalize('chart.series.label.Total_Clients');
			totalSeries.points=totalPoints;

			var seriesList = [];
			seriesList.push(totalSeries);
			seriesList.push(addedSeries);
			seriesList.push(removedSeries);
			var cdata={};
			cdata.seriesList=seriesList;
			cdata.isShowLegend=false;

			var xAxisTitle=month[0] + " - " + month[month.length-1];
			var yAxisTitle = cvUtil.cvLocalize('chart.axis.title.Clients_Count');

			var xAxisLabels = $.map(month, function(val, index){
				return month[index].substr(0, 3);
			});
			var xAxis={};
			xAxis.labels = xAxisLabels;
			xAxis.minValue=-1;
			xAxis.maxValue=12;
			cdata.xAxisTitle=xAxisTitle;
			cdata.xAxis=xAxis;

			var yAxis={};
			yAxis.labels = [];
			yAxis.minValue=0;
			yAxis.numSteps=5;
			cdata.yAxisTitle=yAxisTitle;
			cdata.yAxis=yAxis;

			yAxis.maxValue=reportsUtil.getYmax(maxY);
			yAxis.maxValue = yAxis.maxValue < 5 ? 5 : yAxis.maxValue;
			dataAvailable(true, "barTop", "barchartcontainer");
			var frameId="barchartcontainer";
			$("#" + frameId).empty();
			var r = Raphael(frameId, 1000,370);
			cvcharts.createRaphaelLinechart(r, cdata, {
					axis : "0 1 1 1",
					chartWidth : 700,
					chartHeight : 270,
					//topMargin : 20,
					//leftMargin : 50,
					maxSteps : 12,
					//showPartialLine : true,
					shade : false,
					//width : 1,
					legend:2,
					showLegend : true,
					smooth : true,
					radius : 2,
					formatLabels : false
			});
		}
		else
		{
			dataAvailable(false, "barTop", "barchartcontainer", cvUtil.cvLocalize("No_Data_Available"));
		}
	}

	function createThroughputBarchart(frameId, labels, vals)
	{
		$("#" + frameId).empty();
		var r = Raphael(frameId, 545,340);
		var txtattr = { font: "12px 'Fontin Sans', Fontin-Sans, sans-serif" };

	    var maxY = Math.ceil(Math.max.apply(Math, vals));
	    var len = vals.length * 40;
	    if (len < 200){len = 200;}
		var barWidth = 40;

		var width = (vals.length - 1)*65;

		if(width>400)
			{
			width = 400;
			}else if(width<150){
			width = 150;
			}

		var xAxisTitle= moment.unix(labels[0] + (new Date().getTimezoneOffset()*60)).format("MMMM D") + " - "
							+ moment.unix(labels[labels.length-1] + (new Date().getTimezoneOffset()*60)).format("MMMM D");
		var xpos = width + 100;
		var color = $.map(vals, function(val, index){
			return "#5CADFF" ;
		});
		var yAxisTitle = "GB/HR";
		var daysOfWeek = $.map(labels, function(val, index){
			return	moment.unix(labels[index] + (new Date().getTimezoneOffset()*60)).format("ddd");
			//(labels[index]).match('[A-Z][a-z][a-z]');
		});

		var popupLabels = $.map(labels, function(val, index){
			return	moment.unix(labels[index] + (new Date().getTimezoneOffset()*60)).format("ddd, MMM D");
			//(labels[index]).match('[A-Z][a-z][a-z]');
		});

		    r.txtattr = {font:"15px Fontin-Sans, Arial, sans-serif", fill:"#000", "font-weight": "normal"};
		    //maxY = getYmax(maxY);
	       var chart = r.barchart(80,50, width,240, vals,
	    	{
	    	nostroke: false,
	    	stacked: true,
	    	axis: "0 0 1 1",
	    	smooth: true,
	    	actualMaxY: maxY,
	    	axisxstep:1,
	    	colors:color,
	    	//axisystep:  getYStepCount(maxY),
	    	totalpoints:1,
	    	barWidth: barWidth,
	    	xAxisTitle:xAxisTitle,
	    	yAxisTitle: yAxisTitle,
	    	showlegend: false,
	    	labelxpos:xpos,
	    	minfactor:1024,
	    	showGrid:true,
  		  	showpopup:true,
	    	stretch: true

	    	});


	       //createHeaders(chart,vals.slice(0, vals.length - 1),r);
		   chart.label(daysOfWeek, true);
		   updatBarChartPopups(chart, daysOfWeek, popupLabels, yAxisTitle);

	}

	function findYmax(convValues)
	{
		var yMax=0;
		for(var i =0;i<convValues.length;i++)
		{
			var arr = conValues[i];
			var max = Math.max.apply(Math,arr); // 306
			if(yMax < max){yMax = max;}
		}
		return yMax;
	}
	function addChartTitle(div,title)
	{
		$('#'+div).empty();
		$('#'+div).append(title);
	}

	function drawUsageCharts(data,isGlobal, groupBy) {
		var leftPieBox = "summaryPieChartContainer2",
			rightPieBox = "summaryPieChartContainer3",
			leftPieOuterBox = "summaryPieTop2",
			rightPieOuterBox= "summaryPieTop3",
			leftPieTitleEle = "#summaryPieChartContainer2Title",
			rightPieTitleEle = "#summaryPieChartContainer3Title";

		if (groupBy == 'AGENT_TYPE') {
			leftPieBox = "summaryPieChartContainer4";
			rightPieBox = "summaryPieChartContainer5";
			leftPieOuterBox= "summaryPieTop4";
			rightPieOuterBox= "summaryPieTop5";
			leftPieTitleEle = "#summaryPieChartContainer4Title";
			rightPieTitleEle = "#summaryPieChartContainer5Title";
		}

		if ( data.error == undefined ) {
			var colnames = data.labels,
				tempLabels=colnames.slice(1,colnames.length),
				labels=new Array(),
				colmodel = data.values,
				dpEnterpriseChartLabels=new Array(),
				dpEnterpriseChartValues=new Array(),
				dpIndex=0,
				archiveEnterpriseLabels=new Array(),
				archiveEnterpriseValues=new Array(),
				archiveIndex=0,
				backupSizeIndex=5;
				archiveSizeIndex=6,
				tempValues = $.map(colmodel, function(node){
					return node["cell"];
				});


			if (groupBy == 'AGENT_TYPE') {
				backupSizeIndex=2;
				archiveSizeIndex=3;
			}

			for (var i=0;i<colmodel.length;i++)
			{
				var tempArray = colmodel[i]['cell'];
				var valueArray = new Array();
				if(tempArray[backupSizeIndex] != 0)
				{
					dpEnterpriseChartValues[dpIndex]=tempArray[backupSizeIndex];
					dpEnterpriseChartLabels[dpIndex]=tempArray[0]+" - (" + tempArray[backupSizeIndex] + ")";
					dpIndex++;
				}
				if(tempArray[archiveSizeIndex] != 0)
				{
					archiveEnterpriseValues[archiveIndex]=tempArray[archiveSizeIndex];
					archiveEnterpriseLabels[archiveIndex]=tempArray[0]+" - " + tempArray[archiveSizeIndex];
					archiveIndex++;
				}
			}


			var dpEnterpriseArr = sortLabelsPerValues(dpEnterpriseChartLabels,dpEnterpriseChartValues);
			var convDPEnterpriseArray= convertTONearest(dpEnterpriseArr[1]);
			var dpLabels =createLegends(dpEnterpriseArr[0],convDPEnterpriseArray[0]);
			var archiveEnterpriseArr = sortLabelsPerValues(archiveEnterpriseLabels,archiveEnterpriseValues);
			var convArchiveEnterpriseArray= convertTONearest(archiveEnterpriseArr[1]);
			var archiveLabels =createLegends(archiveEnterpriseArr[0],convArchiveEnterpriseArray[0]);
			createSumPieChart(leftPieBox, leftPieOuterBox, dpLabels,convDPEnterpriseArray[1],"TB", true);
			createSumPieChart(rightPieBox, rightPieOuterBox ,archiveLabels,convArchiveEnterpriseArray[1],"TB", true);


		}
		else {
			dataAvailable(false, leftPieOuterBox, leftPieBox, cvUtil.cvLocalize("error.msg.There_may_not_be_any_successful_Data_Protection_Jobs"));
			dataAvailable(false, rightPieOuterBox, rightPieOuterBox, cvUtil.cvLocalize("error.msg.There_may_not_be_any_successful_Data_Protection_Jobs"));
		}
		var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
		if (groupBy == 'AGENT_TYPE') {
			if(isGlobal && ccGroupId > 0) {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Group_Backup_Usage_by_Agent_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Group_Archive_Usage_by_Agent_Type"));
			}else if(isGlobal) {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Worldwide_Backup_Usage_by_Agent_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Worldwide_Archive_Usage_by_Agent_Type"));
			}
			else {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Backup_Usage_by_Agent_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Archive_Usage_by_Agent_Type"));
			}
		} else {
			if(isGlobal && ccGroupId > 0) {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Group_Backup_Usage_by_License_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Group_Archive_Usage_by_License_Type"));
			}else if(isGlobal) {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Worldwide_Backup_Usage_by_License_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Worldwide_Archive_Usage_by_License_Type"));
			}
			else {
				$(leftPieTitleEle).append(cvUtil.cvLocalize("chart.title.Backup_Usage_by_License_Type"));
				$(rightPieTitleEle).append(cvUtil.cvLocalize("chart.title.Archive_Usage_by_License_Type"));
			}
		}
	}


	function drawAgentUsagePieChart(data,isGlobal) {

		if ( data.error == undefined ) {
			var colnames = data.labels;
			var tempLabels=colnames.slice(1,colnames.length);
			var labels=new Array();
			var colmodel = data.values;
			var tempValues = $.map(colmodel, function(node){
				return node["cell"];
			});
			var licenseChartLabels=new Array();
			var licenseChartValues=new Array();
			var licCount=0;
			for (var i=0;i<colmodel.length;i++)
			{
				var tempArray = colmodel[i]['cell'];
				var valueArray = new Array();
				var total = tempArray[1];
				if(total != 0)
				{
					licenseChartValues[licCount]=total;
					licenseChartLabels[licCount]=tempArray[0]+" - (" + total + ")";
					licCount++;
				}
			}

			var licenseArr = sortLabelsPerValues(licenseChartLabels,licenseChartValues);
			createSumPieChart('summaryPieChartContainer1','summaryPieTop1',licenseArr[0],licenseArr[1],"", true);

		}
		else {
			dataAvailable(false, "summaryPieTop1", "summaryPieChartContainer1", cvUtil.cvLocalize("error.msg.There_may_not_be_any_successful_Data_Protection_Jobs"));
		}
		var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
		if(isGlobal && ccGroupId > 0) {
			$('#summaryPieChartContainer1Title').append(cvUtil.cvLocalize("chart.title.Group_License_Usage"));
		}else if(isGlobal) {
			$('#summaryPieChartContainer1Title').append(cvUtil.cvLocalize("chart.title.Worldwide_License_Usage"));

		}
		else {
			$('#summaryPieChartContainer1Title').append(cvUtil.cvLocalize("chart.title.License_Usage"));

		}

		$("#summaryPieTop1").addClass("fullWidth");
	}

	function restrictToMax(labels,values,unit, valuesAndLabelsSorted)
	{
		if (!valuesAndLabelsSorted) {
			labels.sort(sortLabelsArray);
			values.sort(int_arr);
		}

		var arr = new Array();
		var labs = new Array();
		var vals = new Array();
		var MAX_SLICE = 9;
		var ex = "Others";
		var exVal = 0;
		var includeOthers = false;

		if ( labels.length > MAX_SLICE + 1 ) {
			includeOthers = true;
		}
		for(var i=0;i<labels.length;i++)
		{
			if(i >= MAX_SLICE && includeOthers )
			{
				exVal = exVal+(parseFloat(values[i]));
			}
			else
			{
				labs[i]=labels[i];
				vals[i]=values[i];
			}
		}
		if(labs.length == 9)
		{
			if(unit != ""){
				labs[9]= ex + " - (" + exVal.toFixed(2)+ " " + $.trim(labels[0].split("-")[1]).split(" ")[1];//+")";
				vals[9]=exVal.toFixed(2);
			}else{
				labs[9]= ex + " - (" + exVal+")";
				vals[9]=exVal;
			}
		}


		arr.push(labs);

		arr.push(vals);
		return arr;
	}

	function int_arr(a, b) {
	  return parseInt(b) - parseInt(a);
	}

	function sortLabelsArray(a, b) {
	  return parseInt(b.substring(b.lastIndexOf("(")+1,b.lastIndexOf(")"))) - parseInt(a.substring(a.lastIndexOf("(")+1,a.lastIndexOf(")")));
	}
	function createSumPieChart(div,topDiv,labels,values,unit, valuesAndLabelsSorted)
	{
		if(values.length > 0)
		{
			dataAvailable(true, topDiv, div);
			var arr = restrictToMax(labels,values,unit, valuesAndLabelsSorted);
			createRaphaelPieChart(div,arr[0],arr[1] );
		}
		else
		{
			dataAvailable(false, topDiv, div, cvUtil.cvLocalize("error.msg.There_may_not_be_any_successful_Data_Protection_Jobs"));
		}
	}
	function createLegends(sortedLabels,convLabels)
	{
		var arr = new Array();
		for(var i=0;i<sortedLabels.length;i++)
		{
			arr[i] = $.trim(sortedLabels[i].split("-")[0])+' - ('+ convLabels[i]+')';
		}
		return arr;
	}
	function convertTONearest(values)
	{
		var arr= new Array();
		var high = Math.max.apply(Math, values); // 306
		var unit = getUnitFor(high);
		arr.push(convertToMaxSizeLabels(values,unit));
		arr.push(convertToMaxSizeValues(values,unit));
		return arr;
	}
	function sortLabelsPerValues(labels,values)
	{
		var arr = new Array(),
			val1=0,
			val2=0,
			temp1,
			temp2;

		var sortedValues= values.sort(function(a,b){return parseFloat(b)-parseFloat(a);});
		var sortedLabels= labels.sort(function(a,b){
//			return parseInt($.trim(b.split("-")[1]))-parseInt($.trim(a.split("-")[1]));
			temp1 = b.split("-");
			temp2 = a.split("-");
			val1 =$.trim(temp1[temp1.length-1]).replace(/(\(|\))/g,'');
			val2 =$.trim(temp2[temp2.length-1]).replace(/(\(|\))/g,'');
			return parseFloat(val1) - parseFloat(val2);
		});
		arr.push(sortedLabels);
		arr.push(sortedValues);
		return arr;
	}

	function createRaphaelPieChart(divId,labels,values)
	{
		$("#"+divId).empty();
		var colors= [];
		var series = [];
		var chartData = {};
		chartData.series = series;
		chartData.width = 570;
		if(divId, labels, values){
			colors=[];
			for (var i=0; i<labels.length; i++){
				series.push({name: labels[i], y : parseFloat(values[i])})
			}
			reportsUtil.createPieChart(divId, chartData);
		}
	}


	function getSurveyData(survey,commcellId, async, extraUrlParams)
	{
		var isGlobal=true;
		var URL="survey.do?action=GetSurveySummary&isChart=true&surveyId="+survey;
		if(surveyId==117){
			var controllerId = $("#controllerId").val();
			URL = URL+"&onController=" + controllerId;
		}
		if(commcellId)
		{
			isGlobal=false;
			URL = URL+"&ccId="+commcellId;
		}
		var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
		if(ccGroupId > 0) {
			URL += "&ccGroupId="+ccGroupId;
		}
		var tenant = encodeURIComponent(cvUtil.getParameter('tenant', ''));
		if (tenant && tenant != '') {
			URL = URL + '&tenant=' + tenant;
		}
		var companyId = cvUtil.getParameter('companyId', 0);
		if(companyId > 0) {
			URL += "&companyId="+companyId;
		}
		async = async || false;
		cvUtil.loadPageWithPOST(URL, extraUrlParams, function(output) {
        	var newData = output;//jQuery.parseJSON(output);
         	if (survey == 1)
    		{
    			summaryBarChart(newData,isGlobal,commcellId);
    		}
    		else if (survey == 3)
    		{		//for commcell level check fro commcell id and use drawusagecharts
    			if (commcellId !=null) {
    				if (extraUrlParams && extraUrlParams.bAggregate ==2){drawAgentUsagePieChart(newData,isGlobal);}else if (extraUrlParams && extraUrlParams.bAggregate ==3){drawUsageCharts(newData, isGlobal, 'LICENSE_TYPE');} else {drawUsageCharts(newData, isGlobal, 'AGENT_TYPE'); //bAggregate ==1
}
    			}else {
    				drawAgentUsagePieChart(newData,isGlobal);
    			}
    		}else if(surveyId==27 && commUniId > 0){
				dataAvailable(true, "barTop", "barchartcontainer");
				surveyCommon.drawSLATrendChart(newData);
			}else if (survey == 117)
    		{
    			if(newData.noDataNotificationPanel != undefined &&
    					(newData.noDataNotificationPanel.value != "" && newData.noDataNotificationPanel.value != undefined))
    			{
    				$("#noDataNotificationPanel").show().html(newData.noDataNotificationPanel.value);
    				$("#chartContentWrapper").hide();
    				return;
    			} else {
    			createPieChartsForSurvey117(newData,controllerId);
    			tableOnDemand();
    			}
    		}
    		else
    		{
    			if($.inArray(surveyId, [5,8]) != -1) {
    				createIndPieChart(newData, 'pieTop','piechartcontainer',1,0);
    			}
    		}
		 }
		);
	}

	function exportExcel($id,isGlobal,commcellId)
	{
	var file;
	if(isGlobal){file="WorldWide_"+selectedSurvey.replace(/ /gi, "_");} else {file=selectedSurvey.replace(/ /gi, "_")+"_For_Commcell_"+commcellId;}
	var keys=[], ii=0, rows="";
	var colModel  = $id.jqGrid('getGridParam', 'colModel');
	var colNames = $id[0].p.colNames;
		 for(var i=0;i<colNames.length;i++) {
			if ( colModel[i].hidden == false) {
				var colName = colNames[i];
				if(colName.indexOf("\"") != -1) {
					colName = colName.replace(/\"/gi, "\"\"");
				}
				colName = "\"" + colName + "\"";

				rows=rows+ colName + ",";     // output each Column as tab delimited
			}
		  }
	  rows=rows+"\n";   // Output header with end of line
	 var rowData = null;
	 //if there is any filtered data , then it is tored in the gridSearchResult map with the key as grid div id
	 if( gridSearchResult != null && (gridSearchResult[$id.attr('id')] != undefined && gridSearchResult[$id.attr('id')] != 'empty')){rowData = gridSearchResult[$id.attr('id')]; // all the filtered results.
} else {rowData = $id.jqGrid('getGridParam','data');}

	  for(var i=0;i<rowData.length;i++) {
	  var row=rowData[i];
			var ind =0;
			for(var j=0;j<colNames.length;j++)
			{
				var value = row["index"+ind];
				if ( value == undefined ) {
					value = row[colNames[j]];
					if ( colNames[j]=='Status') {
						value = value.split('_')[1];
					}
				}
				if (value == undefined || value == null) {
					value = " ";
				}
				if(value.match(/^(\d*.\d*) (Bytes|KB|MB|GB|TB|PB)/gi)) {
					var tokens = value.split(' ');
					value = convertToBytes(tokens[0], tokens[1]);
				} else {
					if ( value.indexOf("</span>") != -1 ) {
						value = $("<span/>").html(value).text();
					}
					if(value.indexOf("</a>") != -1) {
						var re = /<a(.*?)<\/a>/gi;
						value = value.replace(re, '');
					}
					if(value.indexOf("</li>") != -1) {
						var re = /<\/li>/gi;
						value = value.replace(re, '; ');
						value = value.replace(/<li(.*?)>/gi, '');
						value = value.replace(/<ul(.*?)>/gi, '');
						value = value.replace(/<\/ul>/gi, '');
						value = value.replace(/; ; /gi, '');
						if (value.charAt(value.length-2) == ';') {
							value = value.substr(0, value.length-2);
						}
					}

				}

				if ( colModel[j].hidden == false) {
					if(typeof value === "string" ) {
						if(value.indexOf("\"") != -1) {
							value = value.replace(/\"/gi, "\"\"");
						}
					}
					value = "\""+ value + "\"";
					rows=rows+ value+","; // output each Row as tab delimited
				}
				ind=ind+1;
			}
		rows=rows+"\n";  // output each row with end of line
	  }

	  rows=rows+"\n";  // end of line at the end
	  var rows = $("<div/>").html(rows).text();
				document.exportform.csvBuffer.value=rows;
				document.exportform.fileName.value=file;
				document.exportform.method='post';
				document.exportform.action='survey.do';  // send it to server which will open this contents in excel file
				document.exportform.target='_self';
				$("form[name='exportform']").submit();
	}


	function showHideComponents(surveyId, supportedIds) {
		surveyId = parseInt(surveyId);
		if(!showSummary(surveyId, supportedIds)) {
			// summary/charts not supported..
			$('#chartContentWrapper, #summaryDetails').hide();
		} else {
			// summary/charts supported
			$('#summaryDetails').show();

			if(surveyId == 1) {
				$('#licenseUsageDiv').show();
				$('#summaryPieTop1').show();
				$('#summaryPieTop2').show();
				$('#summaryPieTop3').show();
			} else if(surveyId == 5) {
				if(commUniId<=0){
					$('#barTop').show();
				}
				$('#pieTop').show();
			} else if(surveyId == 7) {
				//$('#scaleLatestTop1').show();
				//$('#scaleHistTop1').show();
				//$('#scaleHistTop2').show();
				//$('#summaryDetails').hide();
			} else if(surveyId == 38) {
				$("#chartContentWrapper").css("display","none"); //Removing Quarterly Adoption Rate chart
			} else if(surveyId == 106) {
				$('#barTop').show();
			} else if(surveyId == 41) {
				$('#pieTop').hide();
			} else if(surveyId == 35) {
				$('#pieTop').hide();
			} else if(surveyId == 48) {
				$('#pieTop').hide();
			}else if(surveyId == 55) {
				$('#throughputChartsDiv').removeClass('hide');
			} else if(surveyId == 25) {
				$('#pieTop').hide();
			} else if(surveyId == 26) {
				$('#chartContentWrapper').hide();
			} else if(surveyId == 31) {
				$('#chartContentWrapper').hide();
			} else if(surveyId == 92) {
				$('#chartContentWrapper').hide();
				$('#content').addClass('survey92');
			}  else if(surveyId == 12) {
				if(commUniId<=0){
					$('#pieTop').hide();
					$('#barTop').show();
				}
			} else if(surveyId == 4) {
				$('#barTop').show();
				if(commUniId <= 0){
					$('#pieTop').show();
				}
			}else if(surveyId == 134) {
				$('#pieTop').hide();
				$('#barTop').show();
				$('#summaryDetails').hide();
			} else if(surveyId == 117) {
				$('#barTop').show();
				/*
				 * $('#summaryBarTop').show(); $('#summaryPieTop1').show(); $('#summaryPieTop2').show();
				 * $('#summaryPieTop3').show();
				 */
			}
			else if(surveyId == 104){
				$('#chartContentWrapper').hide();
			} else if(surveyId == 51) {
				$('#pieTop').hide();
				$('#barTop').show();
			} else if(surveyId == 137) {
				var rep = cvUtil.getParameter('repType');
				if(rep != undefined && rep == 'monthly'){
					$('#pieTop').hide();
					$('#barTop').show();
				}
			} else if(surveyId === 27 && commUniId>0) {
				$('#barTop').show();
			} else if(surveyId === 67 ){
				if(!cvUtil.getParameter("entity")){
					$('#barTop').show();
				}
			}else if(surveyId === 200 || surveyId === 201) {
				$('#chartContentWrapper').hide();
			}else if(surveyId === 96 || surveyId === 196){
				$('#barTop').show();
				$('#pieTop').hide();
				$('#summaryDetails').hide();
			}  else {
				$('#pieTop').show();
			}

		}
	}

	function hideAllComponents() {
		$('#chartContentWrapper').hide();
		$("#tableWrapper").hide();
	}


	function dataAvailable(isDataAvailable, topId, containerId, errorMsg){
		if ( isDataAvailable ) {
			if ( topId != null ) {
				$('#'+topId).addClass('chartContainer');
				$('#'+topId).removeClass('chartError');
			}
		}
		else {
			$('#'+topId).removeClass('chartContainer');
			$('#'+topId).addClass('chartError');

			errorMsg = errorMsg || "";
			$('#' + containerId ).append('<div class="chartErrorMessage">'+ errorMsg +'</div>');
		}
	}

	function populateSurveyList(callback, app)
	{
		app = app || 'none';
		var unicID=cvUtil.getParameter('commUniId', 0);
		var URL = 'survey.do';
		cvUtil.loadPageWithPOST(URL, {action: 'GetSurveyList', app: app , commUniId:unicID}, function(output) {
        	    $("#surveyList").append(output);
        	    if(typeof surveyId =='undefined'){surveyId="-1";}
				$("#surveyList").val(surveyId);
				selectedSurvey=$('#surveyList option[value=' + surveyId + ']').text();
				$("#surveyName").append(selectedSurvey);
				if(callback && typeof callback === 'function') {
					callback();
				}
		});
	}

	function getCommCellDetailsOfUid(uid, sid, callback) {
		var URL="survey.do?action=CommCellDetailsUid&commUniId="+uid;
		if(sid){
			URL = URL + "&survey="+sid;
		}
		var ccGroupId=cvUtil.getParameter('ccGroupId', -1);
		if(ccGroupId > 0){
			URL = URL + "&ccGroupId="+ccGroupId;
		}
		var companyId=cvUtil.getParameter('companyId', 0);
		if(companyId > 0){
			URL = URL + "&companyId="+companyId;
		}

		cvUtil.loadPageWithPOST(URL, null, function(output) {
	    	   var data = output;//jQuery.parseJSON(output);
	    	   if (typeof SurveyGlobals == 'undefined') {
	    		   SurveyGlobals = {};
	    	   }
	    	   if(data.CommCellID != undefined){
	    	   commCellId = data.CommCellHexID;
	    	   SurveyGlobals.commCellId = commCellId;
	    	   }else{
	    	   commCellId =" ";
	    	   SurveyGlobals.commCellId = commCellId;
	    	   }
	    	   if(data.IP != undefined){
	    	   commIpAddr = data.IP;
	    	   SurveyGlobals.commIpAddr = commIpAddr;
	    	   }
	    	   else{
	    	   commIpAddr =" ";
	    	   SurveyGlobals.commIpAddr = commIpAddr;
	    	   }
	    	   if(data.GUID != undefined){
	    	   CommGuiId = data.GUID;
	    	   SurveyGlobals.CommGuiId = CommGuiId;
	    	   }
	    	   else{
	    	   CommGuiId =" ";
	    	   SurveyGlobals.CommGuiId = CommGuiId;
	    	   }
	    	   if(data.Customer != undefined){
	    	   clientName = data.Customer;
	    	   SurveyGlobals.clientName = clientName;
	    	   }
	    	   else{
	    	   clientName =" ";
	    	   SurveyGlobals.clientName = clientName;
	    	   }
	    	   if(data.Version != undefined){
	    	   Version = data.Version;
	    	   SurveyGlobals.Version = Version;
	    	   }
	    	   else{
	    	   Version =" ";
	    	   SurveyGlobals.Version = Version;
	    	   }
	    	   if ( data.MonitoredGroup != undefined ) {
	    	   MonitoredGroup =data.MonitoredGroup;
	    	   SurveyGlobals.MonitoredGroup = MonitoredGroup;
	    	   }
	    	   else{
	    	   MonitoredGroup =" ";
	    	   SurveyGlobals.MonitoredGroup = MonitoredGroup;
	    	   }
	    	   if ( data.time != undefined ) {
	    	   collectiontime = data.time;
	    	   SurveyGlobals.collectiontime = collectiontime;
	    	   }
	    	   else{
	    	   collectiontime =" ";
	    	   SurveyGlobals.collectiontime = collectiontime;
	    	   }
	    	   if ( data.TimeZone != undefined ) {
		    	   tZ = data.TimeZone;
		    	   SurveyGlobals.tZ = tZ;
	    	   }
		       else{
		    	   tZ =" ";
		    	   SurveyGlobals.tZ = tZ;
		       }

	    	   var GroupName;
	    	   if(data.GroupName){
	    		   GroupName = data.GroupName;
	    	   }
	    	   SurveyGlobals.GroupName = GroupName;

	    	   CommCellCount = 0;
	    	   if(data.CommCellCount){
	    		   CommCellCount = data.CommCellCount;
	    	   }
	    	   SurveyGlobals.CommCellCount = CommCellCount;

	    	   callback(data);
	    });
	}

	function getPostUpgradeReportOfUid(uid, callback) {
		var URL="getupgradedate.do?ccId="+uid;

		cvUtil.loadPageWithPOST(URL, null, function(output) {
	    	   var data = output;//jQuery.parseJSON(output);
	    	   callback(data);
	    });
	}

	function getCommCellDetails(survey)
	{
		var URL="survey.do?action=GetSurvey&surveyId="+survey+"&isCommCellClick=true";
		cvUtil.loadPageWithPOST(URL, null, function(output) {
				var data = output;//jQuery.parseJSON(output);
				genearateGrid(newData,survey,'commCellDetails','commCellDetailsPager','GetSurvey');
		});
	}

	function getTotalComcell()
	{
	      var URL="survey.do?action=GetTotalCommCells";
	      var ccGroupId=cvUtil.getParameter('ccGroupId', -1);
	      var surveyId = cvUtil.getParameter('surveyId', -1);
	      var companyId = cvUtil.getParameter("companyId", 0);
	      var tenant = encodeURIComponent(cvUtil.getParameter('tenant', ''));
	      var currentURL = window.location.pathname;
			if(ccGroupId > 0){
				URL = URL + "&ccGroupId="+ccGroupId;
			}
			if(companyId > 0){
				URL = URL + "&companyId="+companyId;
			}
			if(surveyId > 0){
				URL = URL + "&surveyId="+surveyId;
			}
			if(currentURL.indexOf("health.jsp")>-1){
				URL = URL +"&reportype=2";
			}
			if (tenant && tenant != '') {
		  		URL = URL + '&tenant=' + tenant;
		  	}
			cvUtil.loadPageWithPOST(URL, null, function(output) {
	                  $('#metaTotalCCs').append('Participating CommCells: <span class="commcell">' + output + '</span>');
	      });
	}

	function getSurveyDataForDashBoard(survey,commcellId, latest, isTable)
	{
		var isGlobal=true;
		var URL="survey.do?action=GetSurveySummary&surveyId="+survey;
		if ( isTable ) {
			URL = URL + "&isChart=false";
		} else {
			URL = URL + "&isChart=true";
		}
		if(commcellId != undefined)
		{
			isGlobal=false;
			URL = URL+"&ccId="+commcellId;
		}
		if (latest != undefined) {
			URL = URL + "&latest="+latest;
		}
		else {
			latest = 0;
		}
		cvUtil.loadPageWithPOST(URL, null, function(output) {
        	var newData = output; //jQuery.parseJSON(output);
			var error = newData.error;
        	if(error == undefined)
			{
        		if ( survey == 7 ) {
    				var chartsData = [];
    				if ( latest ) {
    					chartsData = processData(newData);
    					for ( var i = 0; i < chartsData.length; i++ ) {
    						dataAvailable(true, 'scaleLatestTop' + chartsData[i]["group"], 'scaleLatestContainer'+ chartsData[i]["group"]);
    						createChart('Job Status', chartsData[i], 'scaleLatest');
    					}
    				} else {
    					chartsData = processDataForLineChart(newData);
    					for( var i = 0; i < chartsData.length; i++ ) {
    						dataAvailable(true, 'scaleHistTop' + chartsData[i]["group"], 'scaleHistContainer'+ chartsData[i]["group"]);
    						var title = cvUtil.cvLocalize("Job_Status");
							var width = 400;
							var height = 300;
    						if ( chartsData[i]["group"] == 2) {
    							title = cvUtil.cvLocalize("chart.title.Advanced_Job_Status");
								width=700;
    						}
    						createRaphaelLinechart(title, chartsData[i]["data"], "scaleHist", chartsData[i]["group"],width,height);
    					}
    				}
    			}
    			else if ( survey == 12 ) {
    				genearateTableFromResult(newData, survey, '', 'updateInfoTable', 'updateInfoPager', "Updates", commcellId, '', false);
    			}
    			else
    			{
    				$('#chartTitle').append(cvUtil.cvLocalize("chart.title.GUI_Login_Languages"));
    				$('#pieTop').addClass('chartContainer');
    				dataAvailable(true, 'pieTop', 'piechartcontainer');
    				createIndPieChart(newData, 'pieTop', 'piechartcontainer',1,0);
    			}
			}
        	else {
        		if (survey == 1)
    			{
    				if(latest) {
    					dataAvailable(false, "claLatestTop", "claLatestContainer", cvUtil.cvLocalize("No_Data_Available"));
    					$('#claLatestTitle').append(cvUtil.cvLocalize("chart.title.Capacity_Usage_Latest"));
    				}
    				else {
    					dataAvailable(false, "claHistTop", "claHistContainer", cvUtil.cvLocalize("No_Data_Available"));
    					$('#claHistTitle').append(cvUtil.cvLocalize("chart.title.Capacity_Usage_History"));
    				}

    			}
        		else if ( survey == 7 ) {
        			if ( latest ) {

        				dataAvailable(false, "scaleLatestTop1", "scaleLatestContainer1", cvUtil.cvLocalize("No_Data_Available"));
        				dataAvailable(false, "scaleLatestTop2", "scaleLatestContainer2", cvUtil.cvLocalize("No_Data_Available"));

        				$('#scaleLatestTitle1').append(cvUtil.cvLocalize("chart.title.Job_Status"));
        				$('#scaleLatestTitle2').append(cvUtil.cvLocalize("chart.title.Job_Status"));
        			}
        			else {

        				dataAvailable(false, "scaleHistTop1", "scaleHistContainer1", cvUtil.cvLocalize("No_Data_Available"));
        				dataAvailable(false, "scaleHistTop2", "scaleHistContainer2", cvUtil.cvLocalize("No_Data_Available"));

        				$('#scaleHistTitle1').append(cvUtil.cvLocalize("chart.title.Job_Status"));
        				$('#scaleHistTitle2').append(cvUtil.cvLocalize("chart.title.Advanced_Job_Status"));
        			}
        		}
        		else if ( survey == 12 ) {
        			$('#tableTop').append("<div class='chartTitleStyle'><fmt:message key=\"chart.title.Updates\" /></div>");
        			dataAvailable(false, "tableTop", "tableTop", cvUtil.cvLocalize("No_Data_Available"));
        		}
        		else {
        			$('#chartTitle').append(cvUtil.cvLocalize("chart.title.GUI_Login_Languages"));
        			dataAvailable(false, "pieTop", "piechartcontainer", cvUtil.cvLocalize("No_Data_Available"));
        		}
			}


		 }
		);
	}

	function processData(data) {
		var colModel= data.values;
		var labels = data.labels;
		var chartsData = [];

		for( var i = 0; i < colModel.length; i++ ) {
			var cell = colModel[i]['cell'];
			var name = cell[1];
			var val = cell[2];
			var valType = cell[3];
			var grp = cell[4];
			var cType = cell[5];
			var date = cell[6];

			var groupFound = false;
			for ( var jj = 0; jj < chartsData.length; jj++ ) {
				if ( chartsData[jj]["group"] == grp ) {
					chartsData[jj]["labels"].push(name);
					chartsData[jj]["vals"].push(val);
					groupFound = true;
				}
			}
			if ( !groupFound ) {
				var dobj = { "group" : grp, "chart" : cType, "labels" : [name], "vals" : [val], "date" : date };
				chartsData.push(dobj);
			}
		}

		return chartsData;
	}

	function processDataForLineChart(data) {
		var colModel= data.values;
		var labels = data.labels;
		var chartsData = [];

		for( var i = 0; i < colModel.length; i++ ) {
			var cell = colModel[i]['cell'];
			var name = cell[1];
			var x = cell[2];
			var xType = cell[3];
			var y = cell[4];
			var yType = cell[5];
			var popup = cell[6];
			var grp = cell[7];

			var groupFound = false;
			for( var cdi = 0; cdi < chartsData.length; cdi++ ) {
				if(!chartsData[cdi].group) {
					chartsData[cdi]["group"] = grp;
					var dobj = { "name" : name, "xVals" : [x], "yVals" : [y], "popups" : [popup], "xTypes" : [xType], "yTypes" : [yType] };
					chartsData[cdi]["data"] = [];
					chartsData[cdi]["data"].push(dobj);
					groupFound = true;
				}
				else {
					if(chartsData[cdi].group == grp) {
						var gdata = chartsData[cdi].data;
						var nameFound = false;
						for( var di = 0; di < gdata.length; di++ ) {
							if( gdata[di].name == name) {
								gdata[di].xVals.push(x);
								gdata[di].yVals.push(y);
								gdata[di].popups.push(popup);
								gdata[di].xTypes.push(xType);
								gdata[di].yTypes.push(yType);
								nameFound = true;
							}
						}
						if ( !nameFound ) {
							var dobj = { "name" : name, "xVals" : [x], "yVals" : [y], "popups" : [popup], "xTypes" : [xType], "yTypes" : [yType] };
							gdata.push(dobj);
						}
						groupFound = true;
					}
				}
			}
			if ( !groupFound ) {
				dobj =  { "name" : name, "xVals" : [x], "yVals" : [y], "popups" : [popup], "xTypes" : [xType], "yTypes" : [yType] };
				var data = [];
				data.push(dobj);
				gobj = { "group" : grp, "data" : data };
				chartsData.push(gobj);
			}
		}

		return chartsData;
	}

	function createChart(title, chartData, frameIdPrefix) {

		var grp = chartData["group"];
		if( !grp ) {
			grp = '';
		}
		$("#" + frameIdPrefix + "Title" + grp).append(title + ' as on ' + chartData["date"]);

		if ( chartData["chart"] == 1 ) {
			if( grp == 1) {
				createBarchart(frameIdPrefix + "Container" + grp, chartData["labels"], chartData["vals"]);
			}
		} else {
			var labels = [];
			for( var li = 0; li < chartData["labels"].length;  li++ ) {
				labels.push(chartData["labels"][li] + ' - (' + parseInt(chartData["vals"][li])+')');
			}
			createRaphaelPieChart(frameIdPrefix + "Container" + grp, labels, chartData["vals"]);
		}
	}

	function createRaphaelLinechart(title, chartData, frameIdPrefix, grp,width,height)
	{
		var data = {};

		if( !grp ) {
			grp = '';
		}

		$("#" + frameIdPrefix + "Container" + grp).empty();
		var r = Raphael(frameIdPrefix + "Container" + grp);
		var txtattr = {fill: "#fff", stroke: '#333', 'stroke-width': 1, "font-weight":100, font: "12px  Fontin-Sans, sans-serif"};

		var temp=[];
		var temp2=[];
		var popupLabels=[];
		var pointData = [];
		var seriesLabels = [];
		var yPos = 50;
		var xLabels = [];
		var xStepInterval = 0;
		var minDate = '';
		var maxDate = '';
		var maxY = 0;
	    for ( var i = 0 ; i < chartData.length; i++ )
	    {
	    	var s = chartData[i];
	    	temp[i] = [];
	    	for(var xv = 0; xv < s["xVals"].length; xv++) {
	    		temp[i].push(xv);
	    	}
	    	temp2[i]= s["yVals"];
	    	// yAxisStep = s["yVals"].length - 1;

	    	// if ( yAxisStep == 0 ) {
	    	// 	yAxisStep = 1;
	    	// }

	    	for( var mi = 0; mi < temp2[i].length; mi++ ) {
	    		if( temp2[i][mi] > maxY ) {
	    			maxY = Math.ceil(temp2[i][mi]);
	    		}
	    	}

	    	popupLabels[i] = s["popups"];
	    	pointData[i] = []; //s["pointData"];
	    	seriesLabels[i] = s["name"];
	    	yPos +=20;

	    	if(xLabels.length < s["xVals"].length) {
	    		xLabels = s["xVals"];
	    		minDate = xLabels[0];
	    		maxDate = xLabels[xLabels.length - 1];
	    	}
	    }

	    $("#" + frameIdPrefix + "Title" + grp).append(title + ' from ' + minDate + ' to ' + maxDate );

	    var delta = 0;
	    data["unitStr"] = ' ';
	    if (data["unitStr"]){delta = data["unitStr"].length * 10;}


	    var isClickable = false;
	    //10 - 50 20 + delta
	    var axisStep = 5;
	    if ( xLabels.length < 5 ) {
	    	if ( xLabels.length > 1 ) {
	    		axisStep = xLabels.length - 1;
	    	}
	    	else {
	    		axisStep = 1;
	    	}
	    }
	    var lines = r.linechart(80, 20,width,height,temp,temp2,  { nostroke: false, axis: "0 0 1 1", smooth: true, axisxstep: axisStep, maxy: maxY, axisystep:5 ,/* miny:-1, */
	    	"serieslabels" : seriesLabels,labelxpos:780 + delta, labelypos:85,  unitstr:data["unitStr"], clickable:isClickable}, popupLabels, pointData);

	    xStepInterval = Math.floor( xLabels.length /(lines.axis[0].text.items.length) );
	    for(var x=0; x < lines.axis[0].text.items.length; x++) {
	    	var txt = xLabels[ ( x + x*xStepInterval ) ];
	    	if(!txt) {
	    		txt = xLabels[ xLabels.length - 1 ];
	    	}
	    	lines.axis[0].text.items[x].attr({'text': txt}); //*xStepInterval
	    }


	    lines.hover(function () {
    	this.tags = r.set();

    				if (this.pointIndex ==0){this.tags.push(r.popup(this.x, this.y, this.popupLabel, "right", 10).attr(txtattr));} else {this.tags.push(r.popup(this.x, this.y, this.popupLabel, "up", 10).attr(txtattr));}
    	    }, function () {
    	        this.tags && this.tags.remove();
      });

		lines.symbols.attr({ r: 4 });
		 r.raphael.g.txtattr = txtattr;

	}

	function commcellsForSearch(callback, opts) {
		var url = "survey.do?action=CommCellsForSearch";
		var params = "";
		if(opts && typeof opts === 'object') {
			$.each(opts, function(key, value){
				params = params + "&" + key + "=" + value;
			});
		}
		url = url + params;
		if(cvUtil.getParameter('ccGroupId') != null){
			url +='&ccGroupId='+cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('companyId') != null){
			url +='&companyId='+cvUtil.getParameter('companyId');
		}
		cvUtil.loadPageWithPOST(url, '', function(data1) {
			if(callback && typeof callback === 'function') {
				callback(data1);
			}
		});
	}

	function metricsReporting(callback) {
		var url = "survey.do?action=metricsReporting";
		if(cvUtil.getParameter('fromDashboardSLA') != null){
			url +='&fromDashboardSLA='+cvUtil.getParameter('fromDashboardSLA');
		}
		if(cvUtil.getParameter('ccGroups') != null){
			url +='&ccGroups='+cvUtil.getParameter('ccGroups');
		}
		if(cvUtil.getParameter('ccGroupId') != null){
			url +='&ccGroupId='+cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('createGroup') !=null){
			url +='&createGroup='+cvUtil.getParameter('createGroup');
		}
		if(cvUtil.getParameter('companies') != null){
			url +='&companies='+cvUtil.getParameter('companies');
		}
		if(cvUtil.getParameter('companyId') != null){
			url +='&companyId='+cvUtil.getParameter('companyId');
		}
		cvUtil.loadPageWithPOST(url, '', function(data1) {
			if(callback && typeof callback === 'function') {
				callback(data1);
			}
		});
	}

	function getHealthParamsLevels(callback) {
		var url = "survey.do?action=getHealthParamsLevels";
		cvUtil.loadPageWithPOST(url, '', function(data1) {
			if(callback && typeof callback === 'function') {
				callback(data1);
			}
		});

	}
	function hideHeaderLinks(surveyId,enableDropDown,enableWorldWideHeader){
		worldWide = true;
		metricsReports=true;
		if(!(enableWorldWideHeader)||(!enableDropDown)){
			worldWide=false;
		}
		if(!worldWide){
			$("#commcellUrl").hide();
		}
		if(!metricsReports){
			$("#diagUrl").hide();

		}


	}

	function surveyListAndMeta(callback) {
		var url = "survey.do?action=surveyListAndMeta";
		url = url + "&pathname=" + window.location.pathname;
		var tempSurveyId = cvUtil.getParameter('surveyId');
		if(tempSurveyId) {
			url = url + "&surveyId=" + tempSurveyId;
		}
		if(cvUtil.getParameter('commUniId')) {
			url = url + "&commUniId=" + cvUtil.getParameter('commUniId');
		}
		if(cvUtil.getParameter('ccGroupId', -1) > 0) {
			url = url + "&ccGroupId=" + cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('companyId', 0) > 0) {
			url = url + "&companyId=" + cvUtil.getParameter('companyId');
		}
		if(tempSurveyId && tempSurveyId == 27){
			var fromCCDashboardSLA = cvUtil.getParameter("fromCCDashboardSLA");
			if(fromCCDashboardSLA != undefined && fromCCDashboardSLA == 'true'){
				url +='&fromCCDashboardSLA='+fromCCDashboardSLA;
			}
		}
		cvUtil.loadPageWithPOST(url, '', function(data1) {
			if(callback && typeof callback === 'function') {
				callback(data1);
				report.logReportLoadEvent();
			}
		});
	}

	function showSummary(surveyId, summarySupported){
		var dispSummary=false;
		if($.inArray(surveyId, summarySupported) != -1) {
			dispSummary=true;
			var fromSLA = cvUtil.getParameter("fromDashboardSLA");
			var showSLATrend = cvUtil.getParameter("showSLATrend");
			if((fromSLA != undefined && fromSLA == 'true') || (showSLATrend != undefined && showSLATrend == 'true')){
				dispSummary=false;
			}else if(surveyId == 104 && cvUtil.getParameter("entity")!=""){
				dispSummary=false;
			}else if(surveyId == 137){
				var rep = cvUtil.getParameter('repType');
				if(rep != undefined && rep != 'monthly'){
					dispSummary=false;
				}
			}
		}
		return dispSummary;
	}

	function showDetails(surveyId){
		if(surveyId == 104 && cvUtil.getParameter("entity")==""){
			return false;
		}else if(surveyId == 51 && cvUtil.getParameter("repType")!=""){
			return false;
		}else if(surveyId == 137){
			var rep = cvUtil.getParameter('repType');
			if(rep != undefined && rep == 'monthly'){
				return false;
			}
		}else if(surveyId == 55 && commUniId > 0){
			return false;
		}
		return true;
	}


	function updatBarChartPopups(chart, legendLabels, pointLabels, units, format){
		if(pointLabels){
			for(var i=0;i<chart.bars.length;i++){
				if (chart.bars[i].length != undefined) {
				for(var j=0;j<chart.bars[i].length;j++){
					var cbar = chart.bars[i][j];
					var val = (cbar.value || "0");
					var xLabel = pointLabels[j];
					if (format){val = parseFloat(val).toFixed(2);}
					val = legendLabels[i]+" : "+val;
						val = "<div style='font-weight: bold; text-align: center'>"+xLabel+"</div>"+val;
						if(units){
							val = val + " "+units;
						}
						cbar.popupLabel=val;
					}
				} else {
					var cbar = chart.bars[i];
					var val = (cbar.value || "0");
					var xLabel = pointLabels[i];
					if (format){val = parseFloat(val).toFixed(2);}
					val = "<div style='font-weight: bold; text-align: center'>"+xLabel+"</div>"+val;
					if(units){
						val = val + " "+units;
					}
					cbar.popupLabel=val;
				}
			}
		}else{
			for(var i=0;i<chart.bars.length;i++){
				var cbar = chart.bars[i];
				var val = (cbar.value || "0");
				if (format){val = parseFloat(val).toFixed(2);}
				val = legendLabels[i]+" : "+val;
				if(units){
					val = val + " "+units;
				}
				cbar.popupLabel=val;
			}
		}

	}

	function setFilterRendered(aoColumns) {
		var renderersResultingURLs = [
		                              "JobsAffected",
		                              "commcellId",
		                              "CustomerName",
		                              "CommCellName",
		                              "commcellName",
		                              "commceServ",
		                              "strikeCount",
		                              "throughput",
		                              "spNameLinkRenderer",
		                              "CATEGORY_LINK",
		                              "HEALTH_STATUS",
		                              "booleanRenderer",
		                              "SCALE_STATUS",
		                              "SCALE_REMARKS_LINK"
		                              ];
		for(var i=0; i<aoColumns.length; i++) {
			var renderer = aoColumns[i].rendererType;
			if(typeof renderer != 'undefined'){
				if($.inArray(renderer, renderersResultingURLs) > -1) {
					aoColumns[i].bFilterRendered = false;
				}
			}
		}
	}
	function showJobsSummaryOptions(){
		if(exportRequest){
			var excludeTranscationLogs = cvUtil.getParameter("excludeTranscationLogs", 0);
			var excludeVal = excludeTranscationLogs  == '1'? 'Yes':'No';
			var summary = "<table id=\"reportSummary\">";
			summary += "<tr><td>"+cvUtil.cvLocalize("Exclude_SQL_Transaction_Logs")+"</td><td>: "+excludeVal+"</td></tr>";
			summary += "</table>";
			$("#reportSummaryDiv").append(summary);
			$("#reportSummaryDiv").show();
		}
	}
	function showJobsDetailsSummary(){
		var stat = parseInt(cvUtil.getParameter("jobStatus"));
		var JOB_STATUS={
				0: cvUtil.cvLocalize("chart.series.label.All"),
				1: cvUtil.cvLocalize("chart.series.label.Completed"),
				2: cvUtil.cvLocalize("chart.series.label.Failed"),
				3: cvUtil.cvLocalize("chart.series.label.Completed_with_Errors_or_Warnings"),
				4: cvUtil.cvLocalize("chart.series.label.Killed"),
				5: cvUtil.cvLocalize("chart.series.label.Skipped"),
				6: cvUtil.cvLocalize("chart.series.label.Committed")
		};
		var type = cvUtil.getParameter('repType');
		var dateFormat = 'MMM DD, YYYY';
		if(type != undefined && type == 'hourly'){
			dateFormat = 'MMM DD, YYYY hh:mm A';
		}
		var sd = moment(cvUtil.getParameter("startDate"), "YYYY-MM-DD hh:mm:ss").format(dateFormat).toString();
		var excludeTranscationLogs = cvUtil.getParameter("excludeTranscationLogs", 0);
		var excludeVal = excludeTranscationLogs  == '1'? 'Yes':'No';

		//var ed = moment(cvUtil.getParameter("endDate")).format('MMM DD, YYYY').toString();
		var summary = "<table id=\"reportSummary\">";
		summary += "<tr><td>"+cvUtil.cvLocalize("chart.title.Job_Status")+"</td><td>: "+JOB_STATUS[stat]+"</td></tr>";
		summary += "<tr><td>"+cvUtil.cvLocalize("Date")+"</td><td>: "+sd+"</td></tr>";
		summary += "<tr><td>"+cvUtil.cvLocalize("Exclude_SQL_Transaction_Logs")+"</td><td>: "+excludeVal+"</td></tr>";
		summary += "</table>";
		$("#reportSummaryDiv").append(summary);
		$("#reportSummaryDiv").show();
	}

	function createBackupBarChart(data, isDaily){

		var coldata = data.coldata;
		var rows = coldata.rows;
		if(rows.length <= 0){
			dataAvailable(false, div, div, cvUtil.cvLocalize("No_Data_Available"));
			return
		}
		var labels=new Array();
		var success=new Array();
		var failure=new Array();
		var warning=new Array();
		var killed=new Array();
		var committed=new Array();
		var skipped=new Array();
		var maxValue=0;
		var asof=new Array();
		var popupLabels=new Array();
		var skippedJobsParam = getUrlParameter('skippedJobs');

		for(var i=0;i<rows.length;i++){
			var colInx = 0;
			if(isDaily){
				var date = ((parseInt(rows[i].cell[colInx])));
				asof.push(date);
				labels.push(getDate(date, "DD"));
				popupLabels.push(getDate(date, "ddd, MMM D"));
			}else{
				colInx++;
				var hh = ((parseInt(rows[i].cell[colInx])))/60;
				asof.push(hh);
				var aa = hh >= 12 ? "PM" : "AM";
				hh = (hh > 12) ? hh-12 : (hh == 0) ? 12 : hh;
				labels.push(hh+":00 "+aa);
			}

			colInx++;
			//asof.push(rows[i].cell[1]);
			if(rows[i].cell[colInx] == ""){
				success.push(parseInt(0));
			}else{
				success.push(parseInt(rows[i].cell[colInx]));
			}
			colInx++;
			if(rows[i].cell[colInx] == ""){
				warning.push(parseInt(0));
			}else{
				warning.push(parseInt(rows[i].cell[colInx]));
			}
			colInx++;
			if(rows[i].cell[colInx] == ""){
				failure.push(parseInt(0));
			}else{
				failure.push(parseInt(rows[i].cell[colInx]));
			}
			colInx++;
			if(rows[i].cell[colInx] == "" || rows[i].cell[colInx] == "null" || rows[i].cell[colInx] == "-1"){
				killed.push(parseInt(0));
			}else{
				killed.push(parseInt(rows[i].cell[colInx]));
			}
			colInx++;
			if(skippedJobsParam == "true") {
				if(rows[i].cell[colInx] == ""){
					skipped.push(parseInt(0));
				}else{
					skipped.push(parseInt(rows[i].cell[colInx]));
				}
			}
			colInx++;
			if(rows[i].cell[colInx] == "" || rows[i].cell[colInx] == "null" || rows[i].cell[colInx] == "-1"){
				committed.push(parseInt(0));
			}else{
				committed.push(parseInt(rows[i].cell[colInx]));
			}
			var total = success[i]+failure[i]+warning[i]+killed[i]+committed[i];
			if(skippedJobsParam == "true") {
				total = total + skipped[i];
			}
			if(total > maxValue){
				maxValue = total;
			}

	   }
		var stackedValues = [success,warning, failure, killed];
		if(skippedJobsParam == "true"){stackedValues.push(skipped);}
		stackedValues.push(committed);
		//--------------------
		var params;
		var drillHandler;
		if(data.enableDrilldown){
			//var cdates = getDates(labels, isMonthly);

			var JOB_STATUS={
					0: 1,
					1: 3,
					2: 2,
					3: 4,
					4: 6
			};
			if(skippedJobsParam == "true") {
				JOB_STATUS={
						0: 1,
						1: 3,
						2: 2,
						3: 4,
						4: 5,
						5: 6
				};
			}
			params = [];

			var sd = moment(cvUtil.getParameter("startDate")).format('YYYY-MM-DD').toString();
			for(var stack=0; stack < stackedValues.length; stack++){
				var temp = [];
				for(var series=0; series<stackedValues[stack].length; series++){
					var entity = {};
					entity.startDate = isDaily? asof[series] : sd+" "+asof[series];
					entity.jobStatus = JOB_STATUS[stack];
					entity.isDaily = isDaily;
					temp[series] = entity;
				}
				params[stack] = temp;
			}


			drillHandler = function(){
				var entity = this.bar.clickParams;
				showHourlyJobResults(entity);
			};

			//--------------------
			var xLabelDrilldownURLs;
			var enableXLabelDrilldown = true;
			if(enableXLabelDrilldown){

				xLabelDrilldownURLs = [];
				for(var series=0; series<stackedValues[0].length; series++){
					var startDate = isDaily? asof[series] : sd+" "+asof[series];
					xLabelDrilldownURLs[series] = getJobResultsURL(startDate, isDaily, 0);
				}
			}
		}
		//--------------------
		var stackLegLabels = ["Completed","Completed with Errors or Warnings","Failed", "Killed"];
		var colorCodes = [COLORCODES["SUCCESS"],COLORCODES["PARTIALSUCCESS"],COLORCODES["FAILURE"],COLORCODES["KILLED"]];
		if(skippedJobsParam == "true"){
			stackLegLabels.push("Skipped");
			colorCodes.push(COLORCODES["SKIPPED"]);
		}
		stackLegLabels.push("Committed");
		colorCodes.push(COLORCODES["COMMITTED"]);

		var yMax = Math.ceil(maxValue);
		var yAxistitle="Job Count";
		var xAxistitle = isDaily? "Days" : "Hours";
		var div = "barchartcontainer";
		var r = Raphael(div, 1050,380);
		var valuesArray = jQuery.makeArray(stackedValues);

		var width =500, height=300;
		var x= 50,y=10;

		r.txtattr = {font:"12px Arial, sans-serif, Fontin-Sans", fill:"#000", "font-weight": "bold"};
		var chart = r.barchart(x, y, width, height,valuesArray,
    		{
			  stacked: true,
    		  axis: "0 0 1 1",
    		  actualMaxY:yMax,
    		  serieslabels:stackLegLabels,
    		  pointlabels: labels,
    		  //labelxpos:xpos,
    		  //labelypos:60,
			  colors: colorCodes,
			  legendAnchor: "bottom",
			  axisxstep:2,
			  xAxisTitle:xAxistitle,
			  yAxisTitle:yAxistitle,
			  clickParams: params,
			  clickHandler: drillHandler,
			  xLabelDrilldownURLs: xLabelDrilldownURLs,
			  //barGap: 5,
			  barPointLabelWidth: 24,
			  barActualWidth: 12,
    		  totalpoints:2,
    		  showGrid:true,
    		  showpopup:true,
    		  isBottom:true
    		}
    	);

		chart.label(labels, true);
		updatBarChartPopups(chart, stackLegLabels, isDaily?popupLabels : labels);

		//centerChart
		chart.centerChart(div);
		if(isDaily){
			var sd = moment(cvUtil.getParameter("startDate")).format('MMMM YYYY').toString();
			$('#barTitle').append("Daily Backup Jobs on "+sd);
		}else{
			var sd = moment(cvUtil.getParameter("startDate")).format('MMM DD, YYYY').toString();
			$('#barTitle').append("Hourly Backup Jobs on "+sd);
		}

	}

	function hideSearchCommCell(){
		$("#search").css("display", "none");
	}

	function showWorldwideLink(){
		var surveyId = parseInt(cvUtil.getParameter('surveyId'));
		if(surveyId != undefined){
			var worldwideNotSupported = [7, 100, 101, 106, 121,157, 161, 171, 250];
			if(surveyId == 51 && cvUtil.getParameter('repType')){
				return false;
			}else if(surveyId == 137){
				return false;
			}else if($.inArray(surveyId, worldwideNotSupported) > -1){
				return false;
			}
		}
		return true;
	}

	function updateOptions(){
		var surveyId = parseInt(cvUtil.getParameter('surveyId'));
		if(surveyId != undefined){
			if(surveyId == 51 || surveyId == 137) {
				if(cvUtil.getParameter('repType') || cvUtil.getParameter('jobStatus')){
					hideSearchCommCell();
				}
			}/*
				 * else if(surveyId == 106 && cvUtil.getParameter("commUniId")){ hideSearchCommCell(); }
				 */
		}
	}

	function showHourlyJobResults(params){
		window.location.href=getJobResultsURL(params.startDate, params.isDaily, params.jobStatus);
	}

	function getJobResultsURL(startDate, isDaily, jobStatus){
		var sd,ed, type="hourly";
		var url = '';
		var str = "?";
		var commUniId = cvUtil.getParameter("commUniId");
		var excludeTranscationLogs = cvUtil.getParameter("excludeTranscationLogs", 0);
		var tenant = encodeURIComponent(cvUtil.getParameter("tenant", ''));

		if(isDaily){
			sd = getDate(startDate, 'YYYY-MM-DD');
			var mm = moment(sd);
			edate = mm.endOf("day").unix();
			ed = moment.unix((parseFloat(edate))).format('YYYY-MM-DD');
			sd += " 00:00:00";
			ed += " 23:59:59";
			type="daily";
		}else{
			sd = startDate+":00:00";
			ed = startDate+":59:59";
		}

		if(commUniId) {
			url = cvUtil.getContextPath() + '/survey/reports/indcommcellsurvey.jsp';
			str += "commUniId="+commUniId+"&";
		} else {
			url = cvUtil.getContextPath() + '/survey/reports/CommCellSurvey.jsp';
		}
		str += "surveyId=137&jobStatus="+jobStatus+"&startDate="+sd+"&endDate="+ed+"&repType="+type+"&excludeTranscationLogs="+excludeTranscationLogs;
		if(tenant != ''){
			str += "&tenant="+tenant;
		}
		if(cvUtil.getParameter('ccGroupId', -1) > 0){
			str = str + "&ccGroupId=" + cvUtil.getParameter('ccGroupId');
		}
		if(cvUtil.getParameter('companyId', 0) > 0){
			str = str + "&companyId=" + cvUtil.getParameter('companyId');
		}
		url += str;
		return url;
	}

	function deleteHandler() {
		$(document).on("click", ".deleteIcon", function(e){

			var deleteCommCell = $(this).data("uniqid");
			var deleteCommCellName = $(this).data("cname");
			var deleteCSguid = $(this).data("guid");

			e.preventDefault();
			$( "#dialog" ).dialog({
				resizable: false,
				modal: true,
				title: "Confirm Deletion",
				width: 480,
				height: 180
			});


			$(".deleteCommCellName").html(cvUtil.cvLocalize("Delete_Commserve_Data", deleteCommCellName));
			$(".confirmText").html(cvUtil.cvLocalize("Confirm_Action", "Confirm"));

			$(".confirm").val("");

			$(".deleteButton").off("click");
			$(".deleteButton").on("click",function(e){
				e.preventDefault();
				var confirm = $(".confirm").val().toLowerCase();
				if(confirm == "confirm"){

					$("#dialog").dialog("close");
					$("#content").mask("");
				    var URL = cvUtil.getContextPath() + '/server/survey.do?action=deleteCommcell&deleteCommCell='+deleteCommCell + '&deleteCSguid=' +deleteCSguid+ '&commcellName=' +deleteCommCellName ;
				    cvUtil.loadPageWithPOST(URL, null, function(output) {
						 	var outputData = output;//jQuery.parseJSON(output);
						 	if(outputData && outputData.error){
						 		cvUtil.errorToast(outputData.error,null,null,true);
						 	}else{
								cvUtil.toast(cvUtil.cvLocalize("Successfully_Deleted"),null,null,true);
						 	}

							setTimeout(function(e){
								location.reload();
							},1000);
					});

				} else {
					$("#dialog .error").css("visibility","visible");
				}
			});

			$(".cancel").click(function(e){
				e.preventDefault();
				$(".confirm").val("");
				$("#dialog").dialog("destroy");
			});

		});
	}

	function createCapacityUsageDials(data) {
		var dials = [],
			dial,
			licenseData,
			NAME_INDEX=1,
			TOTAL_INDEX=2,
			USED_INDEX=3,
			LOAN_INDEX=6,
			dialId,
			wrapperId,
			valueUsed,
			valueTotal,
			formattedValueUsed,
			formattedValueTotal,
			unitStrUsed,
			unitStrTotal,
			li,
			chartDiv,
			noteDiv,
			mark,
			completeUsage=0;
		var hasCommvaultCompleteLic = false;
		$.each(data.values, function(index, val) {
			licenseData = val.cell;
			dial = {};
			dial.name = licenseData[NAME_INDEX];
			valueUsed=licenseData[USED_INDEX];
			valueTotal=licenseData[TOTAL_INDEX];
			unitStrUsed="TB";
			unitStrTotal="TB";
			mark="";
			if (dial.name === 'Commvault Complete'){
				if(valueTotal > 0){
					hasCommvaultCompleteLic = true;
				}
			}

			if(dial.name === 'CI Objects'){
				return true;
			}
			if (hasCommvaultCompleteLic){
				if(parseInt(commUniId) > 0 ){
					if(dial.name === 'Backup' || dial.name === 'Archive') {
						return true;
					}
				}else{//worldwide/group level

				}
			}

			if (isCountLicense(dial.name)) {
				var usedObj = reportsUtil.autoConvertCount(valueUsed);
				formattedValueUsed = usedObj.value;
				unitStrUsed = usedObj.unit?usedObj.unit:"";

				var totalObj = reportsUtil.autoConvertCount(valueTotal);
				formattedValueTotal = totalObj.value;
				unitStrTotal = totalObj.unit?totalObj.unit:"";
			} else {
				var usedObj = reportsUtil.autoConvertFromTB(valueUsed);
				formattedValueUsed = usedObj.value;
				unitStrUsed = usedObj.units;

				var totalObj = reportsUtil.autoConvertFromTB(valueTotal);
				formattedValueTotal = totalObj.value;
				unitStrTotal = totalObj.units;
			}

			if (licenseData[LOAN_INDEX] > 0) {
				dial.loanedCapacity = licenseData[LOAN_INDEX];
				var loanObj = reportsUtil.autoConvertFromTB(licenseData[LOAN_INDEX]);
				dial.loanNote = cvUtil.cvLocalize("info.msg.Including_loaner_of", loanObj.value, loanObj.units);
				mark = "*";
			} else {
				dial.loanedCapacity = 0;
			}


			dial.used = {value: licenseData[USED_INDEX], formattedValue: formattedValueUsed, unit: unitStrUsed};
			dial.total= {value: licenseData[TOTAL_INDEX], formattedValue: formattedValueTotal, unit: unitStrTotal + mark};


//			for debugging
//			dial.used= {value: licenseData[USED_INDEX] ==0 ? 3 : licenseData[USED_INDEX], formattedValue: licenseData[USED_INDEX] ==0 ? 3 : licenseData[USED_INDEX], unit: "TB"}; //test
//			if (dial.name === 'Protected VMs' || dial.name==='Archived MailBoxes') {
//				dial.total= {value: -1, formattedValue: -1, unit: "TB"};
//			}  else if (dial.name.indexOf('Snapshot') != -1) {
//				dial.used= {value: 15, formattedValue: 15, unit: "TB"};  //test
//				dial.total= {value: 10, formattedValue:10, unit: "TB"};
//			}
//			  else if (dial.name.indexOf('Replication') != -1 || dial.name == 'CI Objects') {
//			dial.used= {value: 4, formattedValue: 4, unit: "TB"};  //test
//			dial.total= {value: 10, formattedValue:10, unit: "TB"};
//			}
			dials.push(dial);
		});

		$.each(dials, function(index,val) {
			wrapperId = getDivId(val.name);
			dialId= "dial_" + index;
			li = $("<li class='dialContent'></li>");
			$("#" + wrapperId).append(li);
			chartDiv = $("<div></div>", {
						id:dialId
						});
			li.append(chartDiv);
			noteDiv = $("<div class='noteDiv'></div>");
			li.append(noteDiv);
			if (val.loanedCapacity > 0) {
				noteDiv.html(val.loanNote);
			}
			//$("#" + wrapperId).append("<li id='" + dialId + "' class='licUsageDial'></li>");
			surveyCommon.drawCapacityDials(dialId, val);
		});

		$("#summaryPieTop1").addClass("licUsage");
		$("#summaryPieTop2").addClass("licUsage");
		$("#summaryPieTop3").addClass("licUsage");
		$("#summaryPieTop4").addClass("licUsage");
		$("#summaryPieTop5").addClass("licUsage");
		$("#summaryPieTop4").show();
		$("#summaryPieTop5").show();
		$(".sectionBreak").addClass("licUsageSectionBreak");

	}


	function getDivId(licName) {
		if (licName === 'CI Objects' || licName == 'Archived MailBoxes' || licName == 'Archive' || licName === 'Archive Enterprise' || licName === 'Mailbox Archive Solution') {
			return "archiveLicenses";
		}else if(licName ==='VM Sockets' || licName ==='Protected VMs' || licName === 'Application Class Virtual') {
			return "vmLicenses";
		}else if (licName === 'Users' || licName === 'Sharing Users' || licName === 'eDiscovery Users' || licName ==='Devices') {
			return "usersLicenses";
		} else if (licName === 'Commvault Complete') {
			return "completeLicense";
		} else {
			return "backupLicenses";
		}
	}

	function isCountLicense(licName) {
		return ($.inArray(licName, countEntities)!=-1);
	}

	function processCapacityWidgetData(dial) {
		var chartData = [], usageLabel, total =  dial.total.formattedValue, usageDialVal=0, loanDialVal=0, totalDialVal;

		var total = dial.total.value -  dial.loanedCapacity ;
		if (total < 0) {
			total = 0;
		}

		//calculate pie slices, total capacity (including loan) is 100%
		if (dial.used.value == 0 && dial.total.value == -1) { //unlimited
			usageDialVal = 0;
			totalDialVal=1;
		} else if (dial.total.value > 0) {
			usageDialVal = (dial.used.value / dial.total.value) * 100;
			loanDialVal = (dial.loanedCapacity / dial.total.value) * 100;
			totalDialVal = dial.total.value - dial.used.value;
			if (totalDialVal <0) {
				totalDialVal =0;
			} else {
				totalDialVal = (totalDialVal/dial.total.value) * 100;
			}
		} else {
			usageDialVal= dial.used.value ;
		}

		chartData.push({
			name : 'Usage',
			y : usageDialVal
		});
		chartData.push({
			name : 'Total',
			y :totalDialVal

		});
		chartData.push({
			name : 'Loaned Capacity',
			y : loanDialVal
		});

		if (!isCountLicense(dial.name)) {
			dial.used.formattedValue = parseFloat(dial.used.formattedValue).toFixed(2);
	    }

		usageLabel = "<ul class= 'dialCenterLabelWrapper'><li class='dialLabel1 dialCenterLabel'>" + cvUtil.cvLocalize("chart.title.Using")  + "</li>";
		usageLabel = usageLabel +  "<li class='dialLabel2 dialCenterLabel'>" +   dial.used.formattedValue +" "+ dial.used.unit  + "</li>";

    	if (dial.total.value == -1) {
    		usageLabel = usageLabel +  "<li class='dialLabel1 dialCenterLabel'>" + cvUtil.cvLocalize("chart.title.Unlimited") + "</li>";
    	} else if (dial.total.value > 0) {
    		usageLabel = usageLabel +  "<li class='dialLabel1 dialCenterLabel'>" + "of " +  dial.total.formattedValue +" "+ dial.total.unit  + "</li>";
    	}

    	usageLabel = usageLabel + "</ul>";

		dial.usageLabel = usageLabel;

		var COLORCODES = {
			"WITHIN_CAPACITY" : "#03C04A",
			"OVER_CAPACITY" : "#F1453D",
			"WARNING" : "#F2631A",
			"LICENSE_NOT_APPLIED" : "#868686", //"#EB8787"
			"INFO" : "#337ab7"
		};

		var usagePercent = Math.round((100 * dial.used.value) / dial.total.value * 100) / 100; //actual usage in percent

		var usageColor = COLORCODES["OVER_CAPACITY"];
		if (dial.total.value == 0) { //New licenses. These are consumption levels only.  Not licensed entities.
			usageColor = COLORCODES["LICENSE_NOT_APPLIED"];
		} else if (dial.total.value == -2) {
			amount2 = 110;
			usageColor = COLORCODES["INFO"]; // Complete Usage
		} else if (dial.total.value < 0) {
			amount2 = 110;
			usageColor = COLORCODES["WITHIN_CAPACITY"]; // Unlimited
		} else if (usagePercent < 90) {
			usageColor = COLORCODES["WITHIN_CAPACITY"];
		} else if (usagePercent >= 90 && usagePercent <= 100) {
			usageColor = COLORCODES["WARNING"];
		}

		var totalColor = '#ededed';
		var loanedColor = dial.loanedCapacity > 0 ? "#85adad" : "#ededed";

		var dialColors = [];
		dialColors.push(usageColor);
		dialColors.push(totalColor);
		dialColors.push(loanedColor);

		dial.chartData = chartData;
		dial.dialColors = dialColors;
	}

	surveyCommon.drawCapacityDials = function(divId, dial) {
		processCapacityWidgetData (dial);
		var chart = new Highcharts.Chart({
			chart : {
				renderTo : divId,
				type : 'pie',
				width : 220,
				height : 170,
				margin: [25,0,0,0],
				animation: false
			},
			title : {
				text : dial.name,
				style : {
					"color" : "#777",
					"font-family" : "Helvetica,Arial,sans-serif",
					"font-size": "12px",
					"white-space": "nowrap"
				}
			},
			subtitle : {
				text : dial.usageLabel,
				x: 0,
				y: 75,
				floating: true,
				useHTML: true,
				style : {
					"color" : "#777",
					"font-family" : "Helvetica,Arial,sans-serif",
					"font-size": "12px",
					"white-space": "nowrap",
				}
			},
			colors : dial.dialColors,
			exporting : {
				enabled : false
			},
			credits : {
				enabled : false
			},
			tooltip : {
				enabled : true,
				headerFormat : '',
				useHTML : true,
				pointFormat : '{point.name}'
			},
			plotOptions : {
				pie : {
					animation: false,
					startAngle : -150,
					endAngle: 150,
					dataLabels : {
						enabled : false
					},
					states: {
						hover: {
							enabled: false
						}
					}
				}
			},
			legend : {
				enabled : false,
			},
			series :  [ {
				colorByPoint : true,
				innerSize : '73%',
				data : dial.chartData
			} ]
		});
	}

	surveyCommon.buildLicenseUsageDial = function(divId,color,dial, prediction, i, fromLicUsage, loanNote, dialWidth) {
		var used = dial.used.formattedValue;
		var total = dial.total.formattedValue;
		var name = dial.name;
		var usedunits = dial.used.unit;
		var totalunits = dial.total.unit;
		var actualUsed = dial.used.value;
		var actualTotal = fromLicUsage ? dial.total.value - dial.loanedCapacity : dial.total.value ;  //in license usage server is sending in total field both purchase and loan
		var loanTotal = dial.loanedCapacity;
		var totalCapacity = actualTotal + dial.loanedCapacity;
	    var amount = 110;  //110 is the circular length of the dial
	    var amount2 = Math.round((110 * actualUsed)/totalCapacity * 100) / 100 ; //translate actual used to dial units, this is for drawing purposes
	    var usagePercent =  Math.round((100 * actualUsed)/actualTotal * 100) / 100 ; //actual usage in percent
		var actualTotalDialAmount = Math.round((110 * actualTotal)/totalCapacity * 100) / 100;

	    if (actualTotal ==0) { //New licenses. These are consumption levels only.  Not licensed entities.
	    	color = COLORCODES["LICENSE_NOT_APPLIED"];
	    } else if (actualTotal <0) {
    			amount2=110;
    			color = COLORCODES["WITHIN_CAPACITY"]; // Unlimited
	    } else if(usagePercent < 90) {
	    		color = COLORCODES["WITHIN_CAPACITY"];
	    } else if (usagePercent >=90 && usagePercent <=100) {
	    	color = COLORCODES["WARNING"];
	    } else {
	    	color = COLORCODES["OVER_CAPACITY"];
	    }

	    if(amount2 > 110) {
	    	amount2 = 110;
	    }
	    if (!isCountLicense(name)) {
	    	used = parseFloat(used).toFixed(2);
	    }
	    var width = dialWidth || 185;
	    var archtype = Raphael(divId, width, 140);
	    archtype.customAttributes.arc = function (xloc, yloc, value, total, R) {
	        var alpha = 360 / total * value,
	            a = (90 - alpha) * Math.PI / 180,
	            x = xloc + R * Math.cos(a),
	            y = yloc - R * Math.sin(a),
	            path;
	        if (total == value) {
	            path = [
	                ["M", xloc, yloc - R],
	                ["A", R, R, 0, 1, 1, xloc - 0.01, yloc - R]
	            ];
	        } else {
	            path = [
	                ["M", xloc, yloc - R],
	                ["A", R, R, 0, +(alpha > 180), 1, x, y]
	            ];
	        }
	        return {
	            path: path
	        };
	    };



	    //paint entire dial

	    var dialColor = loanTotal > 0 ? COLORCODES["LOANED_CAPACITY"] : "#ededed" ;

	    var my_arc = archtype.path().attr({
	        "stroke": dialColor,
	        "stroke-width": 14,
	        arc: [15, 50, 0, 135, 55]
	    });


	    if (loanTotal > 0){addPopupLabel(my_arc, cvUtil.cvLocalize("chart.title.Loaned_Capacity"))
}


	    my_arc.animate({
	        arc: [15, 50, amount, 135, 55]
	    });
	    my_arc.transform("t-30,83r-145t-95,0");


	    //paint total
	    var totalArc = archtype.path().attr({
	        "stroke": "#ededed",
	        "stroke-width": 14,
	        arc: [15, 50, 0, 135, 55]
	    });

	    totalArc.animate({
	        arc: [15, 50, actualTotalDialAmount, 135, 55]//actualTotalDialAmount
	    });

	    //my_arc.rotate(-145,50,60);
	    totalArc.transform("t-30,83r-145t-95,0");






	    //paint usage
	    var my_arc2 = archtype.path().attr({
	        "stroke": color,
	        "stroke-width": 14,
	        arc: [15, 50, 0, 135, 55]
	    });

	    addPopupLabel(my_arc2, cvUtil.cvLocalize("chart.title.Usage"))

	    my_arc2.animate({
	        arc: [15, 50, amount2, 135, 55]
	    });

	    //my_arc2.rotate(-145,50,60);
	    my_arc2.transform("t-30,83r-145t-95,0");


	    //total = total/1024;
	    if (!isCountLicense(name)) {
	    	total = convert(total);
		    if(used.length>6){
		    	used = parseFloat(used).toFixed(1);
		    }
	    }
	    archtype.text(95, 10, name).attr({ font: "16px Helvetica",fill: '#666'});
    	archtype.text(95, 65, cvUtil.cvLocalize("chart.title.Using")).attr({ font: "13px Helvetica",fill: '#888' });
    	archtype.text(95, 85, used+" "+usedunits).attr({ font: "15px Helvetica",fill: '#444' });

    	if (actualTotal == -1) {
    		archtype.text(95, 105, cvUtil.cvLocalize("chart.title.Unlimited")).attr({ font: "13px Helvetica",fill: '#888' });
	    } else if (totalCapacity > 0) {
	    	if (!fromLicUsage) {
	    		total =  dial.dialTotal.formattedValue;
	    		totalunits =  dial.dialTotal.unit;
	    	}
	    	archtype.text(95, 105, "of "+total+" "+totalunits).attr({ font: "13px Helvetica",fill: '#888' });
	    }

	    if(prediction) {
	    	//prediction = "You will run out of licensed capacity in Jan 2015.You will run out of licensed capacity in Jan 2015.You will run out of licensed capacity in Jan 2015"
	    	if(i!=1){
	    		$(".dataprotection").attr('title', prediction);
	    		if(prediction.length > 85){
	    			prediction = prediction.substr(0, 80)+'...';
	    		}
	    		$(".dataprotection").html(prediction);
	    	} else {
	    		$(".dataarchive").attr('title', prediction);
	    		if(prediction.length > 85){
	    			prediction = prediction.substr(0, 80)+'...';
	    		}
	    		$(".dataarchive").html(prediction);
	    	}
	    }else{
	    	$('.capacity .charts').css('margin-top','18px');

	    }

	    if(loanNote){$("#loanNote_" + i).html(loanNote);} else {$("#loanNote_" + i).hide();}

	    if (!fromLicUsage) {
	    	 //console.log(archtype.path());
		    my_arc["0"].setAttribute("style","cursor:pointer");
		    my_arc2["0"].setAttribute("style","cursor:pointer");

	    	 $("#pie3,#pie4").click(function(e){
	 	    	/// Redirect to appropriate page
	    		var ccVersion = null;
	    		if(typeof Version !== 'undefined'){	//When vieweing commcell dashboard
	    				ccVersion = Version
	    		}
	 	    	window.location.href = getCapacityUsageUrl(ccVersion);
	 	    });
	    }

	};


	function addPopupLabel(dial, text) {
		dial.mouseover(function(e) {
			$(tip).css("left", e.pageX+20).css("top", e.pageY+15);
			 $(tip).html(text);
			 $(tip).stop(true, true).fadeIn(500).stop(true, true);//.fadeOut(3500);
			 over = true;
			e.stopPropagation();

		});

		dial.mouseout(function() {
			$(tip).stop(true, true).fadeOut();
        	 over = false;
		});
	}




surveyCommon.initComponents = function(selectedSurvey, ccId, ccGroupId, companyId, donotTruncateName){

		$('#surveyName').attr('title', selectedSurvey);
		if((ccId && ccId>0)|| (ccGroupId && ccGroupId>0)){
			$("#commcellUrl").attr("href", window.location.pathname);
			if(donotTruncateName){
				$("#surveyName").text(selectedSurvey);
			}else{
				$("#surveyName").text(reportsUtil.getTruncatedName(selectedSurvey));
			}
		}
		else{
			$("#surveyName").text(selectedSurvey);
			$("#commcellUrl").hide();
		}
		if(!ccId||ccId<1){
			getTotalComcell();
		}
		if(ccGroupId > 0 && ccId <=0) {
			getCommCellDetailsOfUid(ccId, null, function(data){
				if(data.error) {
					$(".cvApps").hide();
					$("#noDataNotificationPanel").html(data.error);
					$("#noDataNotificationPanel").show();
				}else{
					if(data.GroupName){
						var cgName = reportsUtil.getTruncatedName(data.GroupName);
						$("#custName").html(cgName + " -&nbsp;");
						$('#custName').attr('title', data.GroupName);
						$('.reportsLink').text(data.GroupName+' (Reports)');
					}
				}
			});
		}else {
		surveyListAndMeta(function(data1) {
			var output = data1; //$.parseJSON(data1);

			if(output !== null && typeof output === 'object') {
				if(output.error) {

				} else {
					var customer=output.customer;
					if(output.commCellId) {
						$("#metaCCId").html('<span>'+cvUtil.cvLocalize("commcell.info.label.CommCell_ID")+': ' + output.commCellId + '</span>');
					}
					if(output.CommServeGUID) {
						output.CommServeGUID = registrationCode(output.CommServeGUID);
						$("#GUID").html('<span>'+cvUtil.cvLocalize("commcell.info.label.Registration_Code")+': ' + output.CommServeGUID + '</span>');
					}
					if(output.time) {
						$("#metaAsOf").html('<span>'+cvUtil.cvLocalize("commcell.info.label.As_of")+': ' + output.time + '</span>');
					}
					if(output.timeZone) {
						$("#timeZone").html('<span>'+cvUtil.cvLocalize("commcell.info.label.Time_zone")+': ' + output.timeZone + '</span>');
					}

					if(output.version) {
						var baseLink = docBaseURL.substr(0,docBaseURL.lastIndexOf("/"));
						var helpLink10 = baseLink+"/article?p=error_codes/error_codes.htm";
						if (output.version.substring(0, 1) == '9') {
							$('#errorCodeUrl')
									.attr(
											'href',
											'http://documentation.commvault.com/commvault/release_9_0_0/books_online_1/english_us/error_codes/error_codes.htm');
						} else {
							$('#errorCodeUrl')
									.attr(
											'href', helpLink10);
						}
					}

					$(document).attr("title",  selectedSurvey);

					if(customer) {
						customer = $.trim(customer);
						if (customer.length != 0) {
							$('.reportsLink').text(customer+' ('+cvUtil.cvLocalize("Reports")+')');
							$("#custName").html(customer + " -&nbsp;");
							//$("#surveyListHolder").width($("#uniform-surveyList span").width() + $("#custName").width() + 10 );
							$(document).attr("title",  customer + " - " + selectedSurvey);
							cvUtil.GUIAuditReportLog(selectedSurvey,customer);
						}
					}
					if(output.GroupName != null){
						$('.commcellsLink').text(output.GroupName+' ('+cvUtil.cvLocalize("CommCells")+')');
					}
				}
			}
		});
		}
	};

	surveyCommon.addDetailsLink=function(){
		if(surveyId == 8){
			var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
			var detailsUrl = cvUtil.getContextPath();
			if(commUniId > 0){
				detailsUrl = detailsUrl + '/survey/reports/indcommcellsurvey.jsp?surveyId=67'+'&commUniId='+commUniId;
			}else{
				detailsUrl = detailsUrl + '/survey/reports/CommCellSurvey.jsp?surveyId=67';
			}
			if(ccGroupId > 0){
				detailsUrl = detailsUrl + '&ccGroupId='+ccGroupId;
			}
			var detailsLink = '<a class="details-link hideOnExportFriendly" href="'+detailsUrl+'">'+cvUtil.cvLocalize("Details")+'</a>';
			$("#pieTop .chartTitleStyle").append(detailsLink);
		}
	};

	surveyCommon.drawSLATrendChart=function(cData){
		var topId="barTop", divId="barchartcontainer";
		$("#barTitle").html(cvUtil.cvLocalize("chart.title.Last_12_Months_SLA_Trend"));
		if(!cData || !cData.seriesList || cData.seriesList.length <= 0){
			dataAvailable(false, topId, divId, cvUtil.cvLocalize("No_Data_Available"));
			return;
		}
		var cw = 650, ch=300;
		var r = Raphael(divId, 700, 400);
		cvcharts.createRaphaelLinechart(r,cData,
				{axis:"0 1 1 1",
				legend:-1,
				chartWidth:cw,
				chartHeight:ch,
				topMargin:10,
				leftMargin:50,
				labelxpos: 50,
				maxSteps:12,
				showPartialLine: true,
				shade:false,
				width:1,
				showLegendMultiLines:true,
				smooth:false,
				radius:2,
				formatLabels:false}

		, null, true);
	};

	function getUrlParameter(sParam) {
	    var sPageURL = decodeURIComponent(window.location.search.substring(1)),
	        sURLVariables = sPageURL.split('&'),
	        sParameterName,
	        i;

	    for (i = 0; i < sURLVariables.length; i++) {
	        sParameterName = sURLVariables[i].split('=');

	        if (sParameterName[0] === sParam) {
	            return sParameterName[1] === undefined ? true : sParameterName[1];
	        }
	    }
	};


	cvUtil.getAdditionalParams = function() {
		var isMetadataCall = cvUtil.getParameter('isReportMetadataCall', ''),
		params = [];

		if (isMetadataCall ==="true"){params.push({key:"isReportMetadataCall", value: true});}else if (isMetadataCall === "false")
		{
			params.push({key:"isReportMetadataCall", value: false});
			params.push({key:"isContentSearch", value: true});
		}


		return params;
	};

	//Minimum Required Feature Release for Custom License Summary Report is 11.15. Function to check whether this condition is met.
	function isMinRequiredFRForNewCapacityReport(currentFR) {
		var isRequiredFeatureRelease = currentFR && currentFR.length > 2 && parseInt(currentFR.substring(0,2) ) >= 11;	//Check whether the CC version is 11
		if(isRequiredFeatureRelease){
			//Check whether the CommCell FR is greater than 15. Handling cases of version input as "11 SP15" and "11.15".
			isRequiredFeatureRelease = (currentFR.indexOf("SP") != -1) ? parseInt( currentFR.substring(currentFR.indexOf("SP")+2) ) >= 15 : parseInt( currentFR.substring(currentFR.indexOf(".")+1) ) >= 15;
		}
		return isRequiredFeatureRelease;
	}