function CreateEditCommCellGroup() {

	this.report = new Reports.initReport({
		type : 'commCellGroup',
		reportTitle : 'Reports',
		scaleReport : true

	});

	this.requestString = report.requestString;

	const ASSOCIATE_TO_COMMCELL_GROUP = "Associate to CommCell Group";
	const COMMCELL_NAME = "CommCell Name";
	const COMMCELL_ID = "CommCell ID";
	const DISPLAY_NAME = "Display Name";
	const COMMCELL_GUID = "CommCell Guid";
	var commCellGroupController = {};
	commCellGroupController.name = "";
	commCellGroupController.groupdescription = "";
	commCellGroupController.ccGroupId = -1;
	commCellGroupController.commcellHolder = {};

	commCellGroupController.checkLength = function(o, min, max, idName) {
		if (o.val().length > max) {
			var msg = "";
			msg = cvUtil.cvLocalize('CommCell_group_length_check_error_message', idName, max);
			$('#validateTips').text(msg);
			o.addClass("ui-state-error");
			setTimeout(function() {
				o.removeClass("ui-state-error", 3500);
			}, 500);
			return false;
		} else if (o.val().length < min) {
			$('#validateTips').text(cvUtil.cvLocalize('Please_Enter_CommCell_group_name'));
			o.addClass("ui-state-error");
			setTimeout(function() {
				o.removeClass("ui-state-error", 3500);
			}, 500);
			return false;
		} else {
			return true;
		}
	};

	commCellGroupController.deleteGroup = function(ccGroupId, groupName) {

	}

	commCellGroupController.createEditGroup = function(ccGroupId, name, groupdescription) {
		var params = [];
		params.push("ccGroupId=" + ccGroupId);
		params.push("groupdescription=" + window.encodeURIComponent(groupdescription));
		params.push("name=" + window.encodeURIComponent(name));
		params.push("createGroup=" + true);
		var target = cvUtil.createUrlWithParams("commCellGroupHandling.jsp", params);
		window.location.href = target;
	};

	commCellGroupController.loadData = function() {
		console.log("load data");
		let ccGroupId = cvUtil.getParameter("ccGroupId");
		let title = cvUtil.cvLocalize('Commcell_group_Create_dialog_title');
		let name = window.decodeURIComponent(cvUtil.getParameter("name"));
		let tableData = {
			iDisplayLength : 100,
			aoColumns : getColumnDefs(),
			aaData : [],
			iTotalDisplayRecords : 0,
			iTotalRecords : 0
		}
		cvUtil.loadPageWithPOST(cvUtil.getContextPath() +
				"/survey.do?action=CommCellsForSearch&searchType=1&companyId=" + ccGroupId, null, function(data) {
			if (data) {
				tableData.iTotalDisplayRecords = data.length;
				tableData.iTotalRecords = data.length;
			}

			let tableRows = [];
			$.each(data, function(i, rowData) {
				let row = {};
				//				row[ASSOCIATE_TO_COMMCELL_GROUP] = 1;
				row[COMMCELL_NAME] = rowData.ccName;
				//				row[COMMCELL_ID] = rowData.ccId;
				//				row[COMMCELL_GUID] = rowData.ccGuid;
				row[DISPLAY_NAME] = rowData.label;
				tableRows.push(row);
			});

			tableData.aaData = tableRows;

			Reports.configureClientSideTableWithPaging("commCellGroup", "", tableData);
			//			Reports.configureClientSideTable('commCellGroup', "", tableData);

		}, function(e) {
			cvUtil.errorToast(localMsg.commcellListError);
		});

	}

	function createColumn(colName, rendererType, sqlType, visible, donotShow) {
		return {
			bFilterRendered : true,
			bUseRendered : false,
			bVisible : visible,
			doNotShow : donotShow,
			mDataProp : colName,
			rendererType : rendererType,
			sOriginalName : colName,
			sTitle : colName,
			dataType : sqlType
		}
	}

	function getColumnDefs() {
		let cols = [];

		//		cols.push(createColumn(ASSOCIATE_TO_COMMCELL_GROUP, "AssociateToCommCellGroup", "Integer", true, false));
		cols.push(createColumn(DISPLAY_NAME, "", "String", true, false));
		cols.push(createColumn(COMMCELL_NAME, "", "String", false, true));
		//		cols.push(createColumn(COMMCELL_ID, "", "String", true, false));
		//		cols.push(createColumn(COMMCELL_GUID, "", "String", false, true));

		return cols;
	}

	function init() {
		$("#groupDetails").focus();
		commCellGroupController.loadData();
	}

	//	init();
	//	$(document).ready(function() {
	//		console.log("ready");
	//		CreateEditCommCellGroup();
	//
	//		$("#groupDetails").focus();
	//		commCellGroupController.loadData();
	//
	//		$(document).on("click", "#cancelButton", function() {
	//			var params = [ "ccGroups=true" ];
	//			window.location.href = cvUtil.createUrlWithParams("monitoringform.jsp", params);
	//		});
	//
	//	});

	commCellGroupController.loadData();

};

$(document).ready(function() {
	CreateEditCommCellGroup();

});
