var growth = growth || {};
growth.chartData = {};
growth.tableData = {};
growth.cachedCommcells = {};
$(document).ready(function() {

	var chartTitle = growth.request.entityDisplayType;
	var groupBy = cvUtil.getParameter('groupBy', "");
	if (window.isDedupe == "true") {
		if ((window.entityType == "CommCell" && groupBy && groupBy != "CommCell") ||
				(window.entityType == "Agent Type" && groupBy && groupBy != "Agent Type")) {
			chartTitle = chartTitle + " by " + groupBy;
		}
	}

	$('#chartTitle').text(chartTitle);

	growth.chartType = 'line';
	$('.linechartMini').click(function(e) {
		growth.changeChartType('line');
		e.preventDefault();
		growth.updateHash();
	});
	$('.vbarchartMini').click(function(e) {
		growth.changeChartType('bar');
		e.preventDefault();
		growth.updateHash();
	});

	$('.tableMini').click(function(e) {
		growth.changeChartType('table');
		e.preventDefault();
		growth.updateHash();
	});

	$('#yAxisSelection').on('click', 'li', function() {
		$('#yAxisSelection li.on').removeClass('on');
		$(this).addClass('on');
		if ($(this).attr("data-isdedupe") != undefined) {
			growth.request.isFullBackup = $(this).attr('id').substring(0, 1);
		} else {
			growth.request.growthType = $(this).attr('id').substring(0, 1);
		}
		growth.drawGrowthChart();
		growth.drawTable();
		growth.updateHash();
	});
	$('#aggregateSelection').on('click', 'li', function(e) {
		$('#aggregateSelection li.on').removeClass('on');
		$(this).addClass('on');
		var aggregate = $(this).attr('id').substring(0, 1);
		growth.toggleChartMode(aggregate);
		growth.updateHash();
		e.preventDefault();
		e.stopPropagation();
	});

	$(".dedupeIntervalTypes").on("change", function() {
		var intervalType = $(this).val();
		var id = $(this).closest('.viewBox').attr('id');
		growth.request.intervalType = intervalType;
		if (intervalType == 3) {
			growth.request.numOfInterval = 13;
		} else {
			growth.request.numOfInterval = 12;
		}

		growth.drawGrowthChart();
		growth.drawTable();
		growth.updateHash(null, null, true);

	});

	$("#dedupeGroupBy").on("change", function() {
		var groupBy = $(this).val();
		var id = $(this).closest('.viewBox').attr('id');
		growth.request.groupBy = groupBy;
		delete growth.selectedEntities;
		delete report.requestString.entityNames;

		$('#chartTitle').text(growth.request.entityDisplayType + " by " + groupBy);

		growth.drawGrowthChart();
		growth.drawTable();
		growth.updateHash(null, null, true);

	});

	$("#chartContainer").addClass("tableView");

});
growth.initChartComponentsFromUrl = function() {
	if (growth.request.aggregate || growth.request.aggregate == 0) {
		$('#aggregateSelection li.on').removeClass('on');
		$('#aggregateSelection li#' + growth.request.aggregate + '_aggregate').addClass('on');
	}
	$('#yAxisSelection li.on').removeClass('on');
	if (growth.request.growthType == 5) {
		$('#yAxisSelection li#' + growth.request.isFullBackup + '_growthType').addClass('on');
		$('.dedupeIntervalTypes').val(growth.request.intervalType);
		$('#dedupeGroupBy').val(growth.request.groupBy);
	} else {
		$('#yAxisSelection li#' + growth.request.growthType + '_growthType').addClass('on');
	}

	$('.entitySelection').toggleClass('disabledActions', growth.request.aggregate != 0);
	if (growth.request.aggregate != 0) {
		$('.entitySelection').attr('title', cvUtil.cvLocalize("chargeback.trends.entity.title"));
	} else {
		$('.entitySelection').attr('title', '');
	}

};
growth.changeChartType = function(chartType) { //line or bar
	var ele = '#chartContainer';
	if (chartType) {
		growth.chartType = chartType;
	}
	var viewBox = $(ele).closest('.viewBox');
	if (viewBox.hasClass('errorBox') || viewBox.hasClass('nodata')) {
		return;
	}
	viewBox.find('.boxedChart').empty();
	growth.rePaint();
};
growth.drawChartInSelectedMode = function(entityNames) {
	growth.request.entityNames = entityNames;
	growth.toggleChartMode(0);
};
growth.drawChartInAggregateMode = function() {
	growth.toggleChartMode(1);
};
growth.toggleChartMode = function(aggregate) {
	growth.request.aggregate = aggregate;
	delete growth.chartData;
	$('.entitySelection').toggleClass('disabledActions', growth.request.aggregate != 0);

	if (aggregate == 0 && (!growth.selectedEntities || growth.selectedEntities.length == 0)) {
		growth.handleNoChartableData('#chartContainer', cvUtil.cvLocalize("growth.Select_entities_from_table"));
	} else {
		if (aggregate == 0) {
			growth.request.entityNames = growth.selectedEntities;
		} else {
			delete growth.request.entityNames;
		}
		growth.drawGrowthChart();
	}
	if (growth.request.aggregate != 0) {
		$('.entitySelection').attr('title', cvUtil.cvLocalize("growth.selected_entities_enable"));
	} else {
		$('.entitySelection').attr('title', '');
	}
};
growth.addEntityToChart = function(entityName, selectedEntities) {
	growth.request.entityNames = selectedEntities;
	growth.drawGrowthChart();
};

growth.removeEntityFromChart = function(entityName) {
	var entityList = growth.selectedEntities;
	var newEntityList = [];
	for (var i = 0; i < entityList.length; i++) {
		if (entityList[i] != entityName) {
			newEntityList.push(entityList[i]);
		}
	}

	growth.request.entityNames = newEntityList;
	growth.selectedEntities = newEntityList;
	if (newEntityList.length == 0) {
		growth.handleNoChartableData('#chartContainer', cvUtil.cvLocalize('Growth_Trend_Entity_Selection_Msg'));
		return;
	}
	growth.drawGrowthChart();
};

growth.drawGrowthChart = function(append) {
	var boxSelector = '#chartContainer';
	if ($('div.loadmask').length <= 0) {
		cvUtil.mask(boxSelector);
	}
	$('.entitySelection').addClass('disabledActions');
	cvUtil.loadPageWithPOST('entityGrowthChart.do', growth.request, function(resp) {
		cvUtil.unmask(boxSelector);
		$('.entitySelection').toggleClass('disabledActions', growth.request.aggregate != 0);
		if (!append || !growth.chartData || !growth.chartData.seriesList) {
			if (!resp || !resp.data) {
				return handleError(boxSelector);
			}
			if (resp.data.isError) {
				return handleError(boxSelector, resp.data.errorMessage);
			}
			var cData = resp.data.cData;
			if (!cData) {
				return growth.handleNoChartableData(boxSelector);
			}

			if (cData.seriesList.length <= 0) {
				return growth.handleNoData(boxSelector);
			}
		} else {
			if (!resp || !resp.data) {
				return alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
			}
			if (resp.data.isError) {
				return alert(resp.data.errorMessage);
			}
			var cData = resp.data.cData;
			if (!cData) {
				return alert(cvUtil.cvLocalize("No_data_selected_entity"));
			}
			if (cData.seriesList.length <= 0) {
				return alert(cvUtil.cvLocalize("No_data_selected_entity"));
			}
		}
		var cData = resp.data.cData;
		if (growth.request.application) {
			for (var i = 0; i < cData.seriesList.length; i++) {
				cData.seriesList[i].seriesName = growth.getCommcellNameFromUniqId(cData.seriesList[i].seriesName);
			}
		}
		if (append && growth.chartData && growth.chartData.seriesList) {
			growth.chartData.seriesList.push(cData.seriesList[0]);
		} else {
			growth.chartData = cData;
			if (growth.request.growthType == 5) { //dedupe sends one model since  Y is not auto converted
				growth.tableData = cData;
			} else if (growth.request.growthType === 6) { //clients count sends one model since  Y is not auto converted
				growth.tableData = cData;
			} else {
				growth.tableData = resp.data.tData;
			}

		}
		growth.rePaint();
	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.unmask(boxSelector);
		growth.handleError(boxSelector, cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
	});
};
growth.getCommcellNameFromUniqId = function(id) {
	if (!growth.cachedCommcells || !growth.cachedCommcells[id]) {
		return id;
	}
	return growth.cachedCommcells[id];
};
growth.rePaint = function() {
	$('#chart').empty();
	$('#summaryTableWrapper').empty();
	$('#chartContainer').removeClass('nodata');
	if (growth.chartType == 'bar') {
		growth.drawBarGrowthChart('chart', growth.chartData);
	} else if (growth.chartType == 'line') {
		growth.drawLineGrowthChart('chart', growth.chartData);
	} else if (growth.chartType == 'table') {
		growth.drawChartTable(growth.chartData);
	}
};
growth.drawLineGrowthChart = function(chartDiv, cData) {
	$('#chart').show();
	$('#summaryTableWrapper').hide();
	if (!cData) {
		console.log('drawLineGrowthChart - cData is null...returning without doing anything.');
		return;
	}
	var cw = 835, ch = 280;
	var r = Raphael(chartDiv);
	var numPoints = cData.seriesList[0].points.length;
	cData.yAxis.minValue = 0;
	cvcharts.createRaphaelLinechartNew(r, cData, {
		axis : "0 1 1 1",
		chartWidth : cw,
		chartHeight : ch,
		leftMargin : 53,
		topMargin : 30,
		shade : false,
		radius : 2,
		showPartialLine : true,
		showLegend : false,
		legend : 1,
		legendX : cw + 15,
		legendY : 35,
		maxSteps : numPoints,
		maxLegendLen : 50,
		thresholdLabel : cData["yAxis"]['thresholdLabel'],
		thresholdProperties : {
			thresholdStroke : {
				"stroke" : "#008000",
				"stroke-width" : 1.5
			}
		},
		colors : cvcharts.colors[5]
	});
};

growth.drawBarGrowthChart = function(frameid, chartData) {
	$('#chart').show();
	$('#summaryTableWrapper').hide();
	if (!chartData) {
		console.log('drawBarGrowthChart - chartdata is null...returning without doing anything.');
		return;
	}
	chartData.isStack = true;
	chartData.isShowLegend = true;

	var r = Raphael(frameid);
	var minYAxisValue = chartData["yAxis"]["minValue"];
	var smooth = true;
	var temp = [];
	var temp2 = [];
	var popupLabels = [];
	var pointData = [];
	var seriesLabels = [];
	var colors = [];

	var myColor = cvcharts.colors[5];

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var ctr = 0;
		for (var i = 0; i < chartData.seriesList.length; i++) {
			var s = chartData.seriesList[i];
			if (chartData.isStack == true) {
				if (chartData.colorSet != null && chartData.colorSet != undefined) {
					if (chartData.colorSet[s["seriesName"]] != null && chartData.colorSet[s["seriesName"]] != undefined) {
						s.color = chartData.colorSet[s["seriesName"]];
					} else {
						s.color = myColor[ctr++];
					}
				} else {
					s.color = myColor[i];
				}
			} else {
				s.color = myColor[0];
			}
		}
	}

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[chartData.seriesList.length - i - 1];
		var points = s.points;
		temp[i] = [];
		temp2[i] = [];
		popupLabels[i] = [];
		pointData[i] = [];
		xLabels = [];
		colors[i] = s["color"];
		for (var j = 0; j < points.length; j++) {
			temp[i][j] = points[j]["x"];
			xLabels[j] = points[j]["name"];
			temp2[i][j] = points[j]["y"] >= 0 ? points[j]["y"] : 0;
			if (points[j]["y"] <= minYAxisValue && j + 1 < points.length) {
				if (points[j + 1]["y"] <= minYAxisValue) {
					smooth = false; //don't smooth if more than 1 cnsecutive values are 0 in which case it will go below the axis line
				}
			}
			popupLabels[i][j] = points[j]["popupLabel"];
			pointData[i][j] = s["pointData"];
		}
		seriesLabels[i] = s["seriesName"];
	}

	var xAxisLabels = chartData["xAxis"]["labels"];
	if (typeof xAxisLabels == 'undefined' || !xAxisLabels.length || xAxisLabels.length < 1) {
		xAxisLabels = xLabels;
	}
	xAxisLabels = modifyLabels(xAxisLabels);

	var totalPoints = xAxisLabels.length;
	var width = 800;
	var chart;

	//format labels
	//	seriesLabels = cvcharts.formatChartLabels(seriesLabels, 50,24);
	var height = 300;
	chart = r.barchart(20, 20, width, height, temp2, {
		stacked : true,
		nostroke : false,
		axis : "0 0 1 1",
		symbol : "circle",
		smooth : true,
		//maxy:chartData["yAxis"]["maxValue"],
		actualMaxY : chartData["stackedYAxis"]["maxValue"],
		axisxstep : totalPoints,
		//axisystep:chartData["yAxis"]["numSteps"] || 3,
		serieslabels : seriesLabels,
		colors : colors,
		//xaxiswidth:width,
		maxLegendLen : 50,
		labelypos : 50,
		showlegend : chartData["isShowLegend"],
		xAxisTitle : chartData["xAxisTitle"],
		yAxisTitle : chartData["yAxisTitle"],
		pointlabels : xAxisLabels,
		//    	 		topBottomDisplay:topBottomDisplay,
		showpopup : true,
		//    	 		chartDataType:chartData.chartDataType,
		showGrid : true,
		//    	 		legendAnchor:'bottom',
		barGap : 24,
		barActualWidth : 18,
		threshold : {
			value : chartData["yAxis"]['thresholdValue'],
			color : '#008000',
			label : chartData["yAxis"]['thresholdLabel']
		}
	//barActualHeight:20
	}, popupLabels);
	chart.heightAdjustment(frameid);

	chart.label(xAxisLabels, true);

	//	chart.label(labels, true);
	//    cvcharts.createBarChart( cData,chartDiv,cx,25, 'vbarchart', cw, ch,0, -1,null,20, true);
	//    cvcharts.createRaphaelBarchart(r, cData, {axis:"0 1 1 1",chartWidth:cw,chartHeight:ch,topMargin:0,shade:false,radius:0,showLegend:false, legend:1,legendX:cw+10,legendY:10, maxSteps:numPoints,maxLegendLen:10});
};

growth.drawChartTable = function(chartData) {
	var view = {}, tableData = growth.tableData, tableModel = {}, row, dataTable = $("#summaryTable_table").dataTable();

	$('#chart').hide();
	$('#summaryTableWrapper').show();

	$("#summaryTable").empty();

	view.title = tableData.yAxisTitle;
	view.filters = true;
	view.collapsible = false;
	view.alarm = false;
	view.exportExcel = true;
	view.colChooser = true;

	//create table data
	tableModel.iTotalRecords = chartData.seriesList.length;
	tableModel.iTotalDisplayRecords = chartData.seriesList.length;
	tableModel.iDisplayLength = 100;
	tableModel.aaData = [];
	tableModel.aoColumns = [];
	tableModel.dataURL = chartData.dataURL;

	//define columns. First column is the chart legend, rest of columns are the x axis labels
	//To avoid mismatch between X-axis labels and point names ,data is taken directly from series point names
	tableModel.aoColumns.push(getColumnDefinition("Name", 'String', ""));
	$.each(tableData.seriesList[0].points, function(i, point) {
		tableModel.aoColumns.push(getColumnDefinition(point.name, 'Long', i));
	});

	//define the table data
	$.each(tableData.seriesList, function(i, series) {
		row = {};
		row["Name_"] = series.seriesName;
		$.each(series.points, function(j, point) {
			row[point.name + "_" + j] = point.y;
		});
		tableModel.aaData.push(row);
	});

	$('#summaryTableWrapper').append(SurveyTemplates.makeReportTable('summaryTable', view));
	Reports.configureClientSideTable('summaryTable', '', tableModel);
};

function getColumnDefinition(name, type, prefix) { //prefix to make column names unique
	var propName = name + "_" + prefix;
	var column = {
		sName : propName,
		sTitle : name,
		mDataProp : propName,
		sqlType : type,
		bHidden : false,
		bSortable : true,
		bVisible : true,
		originalColName : propName
	};

	if (type == 'Long') {
		column.bUseRendered = false;
		if (growth.request.growthType == 4 || growth.request.growthType == 5 || growth.request.growthType == 6) {
			column.rendererType = 'NumberNA';
		} else {
			column.rendererType = 'capacityMB';
		}

	} else if (type == 'String') {
		column.sWidth = "180px";
	}

	return column;
}

growth.handleNoData = function(viewBoxId) {
	$(viewBoxId).addClass('nodata');
	$('#summaryTableWrapper').hide();
};
growth.handleNoChartableData = function(viewBoxId, msg) {
	$(viewBoxId).addClass('nodata');
	$(viewBoxId).find('.noDataSpan').text(msg || cvUtil.cvLocalize("No_Data_Available"));
	$('#summaryTableWrapper').hide();
	$('#chart').hide();
};
growth.handleError = function(viewBoxId, errorText) {
	$(viewBoxId).addClass('errorBox');
	var msg = errorText || cvUtil.cvLocalize("Something_went_wrong_please_try_again");
	$(viewBoxId).find('.errorSpan').text(msg);
};
cvcharts.formatChartLabels = function(seriesLabels) {
	return seriesLabels;
};