function HealthReport() {
	var customerName, commId;
	var paramsTable = "";
	var exportRequest = cvUtil.getParameter('exportType', "");

	var commUniId = cvUtil.getParameter('commUniId', 0);

	if (commUniId == 0) {
		window.alert(cvUtil.cvLocalize("CommCell_Association_Required"));
		window.location.href = 'monitoringform.jsp';
	}

	this.report = new Reports.initReport({
		type : "health",
		idtomask : "ContentWrapper",
		directPrint : true
	});

	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId) {
			report.requestString.commUniId = commUniId;
		}
		var isAlarm = (cvUtil.getParameter("isAlarm", "") == "true" ? true : false);
		if (isAlarm) {
			var paramName = cvUtil.getParameter("paramName", "");
			var paramId = cvUtil.getParameter("paramId", "");
			var paramValue = cvUtil.getParameter("paramValue", "-1");
			var paramStatus = cvUtil.getParameter("paramStatus", "");
			var op = cvUtil.getParameter("op", "-1");

			report.requestString.paramName = paramName;
			report.requestString.paramId = paramId;
			report.requestString.paramValue = paramValue;
			report.requestString.paramStatus = paramStatus;
			report.requestString.op = op;
			report.requestString.exportType = exportRequest;
		}
	};

	report.initComponents = function() {
		reportsUtil.setWorldwideLink(!isPublicMetrics);
	};

	report.initComponentState = function() {

	};

	report.beforeLoadReport = function() {

	};

	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=health&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	report.onLoadReport = function(data) {
		var atleastATableHasData = false;
		if (!data) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else {
			if (typeof data === 'string') {
				$("#noDataNotificationPanel").html(data);
				$("#noDataNotificationPanel").show();
			}
			if (typeof data === 'object') {
				if (data.errorMsg == true) {
					$("#noDataNotificationPanel").html(data.noDataNotificationPanel.value);
					$("#noDataNotificationPanel").show();
					$('#welcomeMsg').html(cvUtil.cvLocalize("Health_Report_title", data.Customer.value));
					customerName = data.Customer.value;
					$(document).attr("title", cvUtil.cvLocalize("Health_Report_title", customerName));
					$('.reportsLink').text(customerName + ' (' + cvUtil.cvLocalize("Reports") + ')');
					cvUtil.GUIAuditReportLog("Health Report", customerName);
				} else {
					$.each(data,
							function(key, value) {
								if (typeof value == 'object') {
									if (value.viewType == 'literal') {
										if (key == 'Customer') {
											var clientName = value.value;
											if (clientName != null && clientName != " " &&
													$.trim(clientName).length != 0) {
												$('#welcomeMsg').html(cvUtil.cvLocalize("Health_Report_title",
														clientName));
												$(document).attr("title",
														cvUtil.cvLocalize("Health_Report_title", clientName));
												customerName = clientName;
												commId = this.commCellId;
												$('.reportsLink').text(customerName + ' (' +
														cvUtil.cvLocalize("Reports") + ')');
												cvUtil.GUIAuditReportLog("Health Report", customerName);

											} else {
												$('#welcomeMsg').html(cvUtil.cvLocalize("Health_Report"));
												$(document).attr("title", cvUtil.cvLocalize("Health_Report"));
											}
										}
										if (key == 'CommCellID') {
											var commCellId = value.value;
											if (commCellId != undefined && $.trim(commCellId).length != 0) {
												//$('#metaAsOf').html('As Of: <span>'+collectiontime+ '</span>');
												//return commCellId + ' (' +  decimalToHex(commCellId,2).toUpperCase() + ')';
												$("#metaCCId").html('<span>' +
														cvUtil.cvLocalize("commcell.info.label.CommCell_ID") + ': ' +
														decimalToHex(commCellId, 2).toUpperCase() + '</span>');
											}

										}
										if (key == 'time') {
											var collectiontime = value.value;
											if (collectiontime != undefined && $.trim(collectiontime).length != 0) {
												$('#metaAsOf').html('<span>' +
														cvUtil.cvLocalize("commcell.info.label.As_of") + ': ' +
														collectiontime + '</span>');
											}

										}
										if (key == 'CommServeGUID') {
											var GUID = value.value;
											if (GUID != undefined && $.trim(GUID).length != 0) {
												GUID = registrationCode(GUID);
												$('#GUID').html('<span>' +
														cvUtil.cvLocalize("commcell.info.label.Registration_Code") +
														': ' + GUID + '</span>');
											}

										}
										if (key == "MonitoredGroup") {
											var monitoredGroup = value.value;
											if (monitoredGroup != undefined && $.trim(monitoredGroup).length != 0) {
												$('#metaClientGrp').html('<span>' +
														cvUtil.cvLocalize("audit.label.Client_Group") + ': ' +
														monitoredGroup + '</span>');
											}
										}
										if (key == 'enableDoc') {
											var enableDoc = value.value;
											if (enableDoc) {
												$('#exportWord').show();
												$('#exportPpt').show();
											}
										}
										if (key == 'GroupName') {
											var groupName = value.value;
											if (groupName) {
												$('.commcellsLink').text(groupName + ' (' +
														cvUtil.cvLocalize("CommCells") + ')');
											}
										}
									} else if (value.viewType == 'clientTable') {
										$('#tableWrapper').append(SurveyTemplates.makeReportTable(key, value));
										if (!value.value.aaData || value.value.aaData.length != 0) {
											atleastATableHasData = true;
										}
										Reports.configureClientSideTable(key, value.title, value.value);
										addActionEvents();
										if (value.title === 'DeDuplication') {
											$("#" + key).css("page-break-before", "always");
										}
									} else if (value.viewType == undefined) {
										if (key == 'paramsTable') {
											paramsTable = value;
										}
									}
								}
							});
					$("td").removeAttr("title");
					if (atleastATableHasData) {
						$("#noDataNotificationPanel").hide();
						report.afterLoadReport();
					} else {
						$("#noDataNotificationPanel").html(data.noDataNotificationPanel.value);
						$("#noDataNotificationPanel").show();
						$("#tableWrapper").hide();
					}

				}
			}

		}
	};

	report.init();

	report.tableDrawCallBack = function(oSettings) {
		var dataTable = $('#' + oSettings.sInstance).dataTable();
		/*
		 * $.each(dataTable.fnGetNodes(), function(index, value) {
		 * 
		 * var aData = dataTable.fnGetData( this );
		 * 
		 * });
		 */

	};

	report.getExportFilePrefix = function() {
		var filePre = "HealthCheck";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}
		return filePre;
	};

	$("#exportPpt").mouseover(function() {
		$("#_exportppt").show();
	});

	$("#exportPpt").mouseout(function() {
		$("#_exportppt").hide();
	});

	report.exportX = function(exportType) {
		var arrayOfParam = [];
		if (exportType == "valassessppt") {
			exportingModule(arrayOfParam, exportType);
		} else {
			$("#dialog-Health-form fieldset input").live("focus", function() {
				$(this).css("background-color", "#cccccc");
			});
			$(function() {
				$("[name^='field_']").focus(function() {
					$(":focus").addClass("ui-state-highlight");
				});
				$("#location,#name,#fromdate,#todate").blur(function() {
					$("#location,#name,#fromdate,#todate").removeClass("ui-state-highlight");
				});
				var location = $("#location"), name = $("#name"), fromdate = $("#fromdate"), todate = $("#todate"), allFields = $([])
						.add(location).add(name).add(fromdate).add(todate), tips = $(".validateTips");

				function updateTips(t) {
					tips.removeClass("location");
					tips.text(t).addClass("ui-state-highlight");
					setTimeout(function() {
						tips.removeClass("ui-state-highlight", 4500);
					}, 500);
					setTimeout(function() {
						tips.text("All fields are required.", 1000);
					}, 4500);

				}

				function checkLength(o, n, min, max) {
					if (o.val().length > max || o.val().length < min) {
						o.addClass("ui-state-error");
						updateTips(n + " field must not be blank " + ".");
						setTimeout(function() {
							o.removeClass("ui-state-error", 3500);
						}, 500);
						return false;
					} else {
						return true;
					}
				}

				function checkRegexp(o, regexp, n) {
					if (!(regexp.test(o.val()))) {
						o.addClass("ui-state-error");
						updateTips(n);
						setTimeout(function() {
							o.removeClass("ui-state-error", 3500);
						}, 500);
						return false;
					} else {
						return true;
					}
				}

				$("#dialog-Health-form").show().dialog({
					autoOpen : false,
					height : 370,
					width : 360,
					modal : true,
					buttons : {
						"Proceed" : function() {
							var bValid = true;
							allFields.removeClass("ui-state-error");
							bValid = bValid && checkLength(name, "name", 1, 50);

							bValid = bValid && checkLength(location, "location", 1, 50);
							//     bValid = bValid && checkRegexp( location, /^([A-Za-z])+$/,"Location can contain only characters");
							if (bValid) {
								arrayOfParam = 'name=' + escape(window.encodeURIComponent(name.val())) + '&' +
										'location=' + escape(location.val());
								// 			 'fromdate='+fromdate.val()+'&'+
								// 			 'todate='+todate.val()

								$(this).dialog("close");
								exportingModule(arrayOfParam, exportType);

							}
						},
						Cancel : function() {
							$(this).dialog("close");

						}
					},
					close : function() {
						allFields.val("").removeClass("ui-state-error");

					}
				});

				$("#dialog-Health-form").dialog("open");
			});
		}
	};

	// ------------ Private Supporting functions --------------------

	function exportingModule(arrayOfParam, exportTypeParam) {
		var commUniId = cvUtil.getParameter('commUniId', -1);
		var url = document.URL;
		var paramString = exportTypeParam;
		if (arrayOfParam.length > 0) {
			paramString += '&' + arrayOfParam;
		}

		var params = 'exportType=' + paramString + '&commUniId=' + commUniId;
		var link = 'commUniId=' + commUniId + '&directDownload=false&exportType=' + paramString +
				'&module=health&reportName=' + customerName + ' - HealthCheck';

		if (window.cvCustomMask) {
			$("#content").mask(cvUtil.cvLocalize('WaitMsg'), 0, function() {
				report.exportajaxRequest.abort('userAborted');
			});
		} else {
			report.mask(report.idtomask, true, "Exporting...");
		}

		var positionToInsert = url.lastIndexOf("?") + 1;
		if (positionToInsert < 1) {
			url = url + '?' + params;
		} else {
			url = [ url.slice(0, positionToInsert), params + '&', url.slice(positionToInsert) ].join('');
		} //we can't just append at the end because of IE9

		var URL = cvUtil.getContextPath() + '/reports/exp.do?' + link;
		report.exportajaxRequest = cvUtil.loadPageWithGET(URL, "", function(data1) {
			if (!data1 || data1 == "" || data1 == 'null') {
				alert(cvUtil.cvLocalize('ExportError'));
			} else {
				$("#fileNameToDownload").val(window.encodeURIComponent(data1));
				$("#exportForm").submit();
			}
			report.unmask(this.idtomask);
		}, function(xhr, ajaxOptions, thrownError) {
			if (thrownError != 'userAborted') {
				cvUtil.handleError(xhr, ajaxOptions, thrownError);
			}
		});
		requestString.invisible.exportType = undefined;
		isExport = false;
		requestString.invisible.exportAll = false;
		requestString.invisible.chartsSVGs = null;

	}

	function addActionEvents() {
		$(".dataTable tbody tr").each(function() {
			var row = $(this);
			var rEvents = row.data("events");
			if (!rEvents || !rEvents.mouseover || !rEvents.mouseover.length) {
				row.mouseenter(function(event) {
					$(this).find(".health-actions").css("visibility", "visible");
					//$(this).addClass("");   // more styling if necessary
				});
				row.mouseleave(function(event) {
					$(this).find(".health-actions").css("visibility", "hidden");
					//$(this).removeClass("");
				});

			}
		});
		$(".health-actions span").each(function() {
			var btn = $(this);
			var evt = btn.data("events");
			if (!evt || !evt.click || !evt.click.length) {
				btn.click(function(event) {
					var paramName = $(this).data("paramname");
					var paramId = $(this).data("paramid");
					var alarmType = $(this).data("alarmtype");
					var bId = btn.attr("id");
					if (bId == 'cAlarm') {
						Reports.configureAlarm({
							"paramId" : paramId,
							"paramName" : paramName,
							"type" : alarmType,
							"paramsTable" : paramsTable,
							"manageLink" : true
						});
					} else if (bId == 'vAlarms') {
						//viewAlarms(paramName);
					}
				});
			}
		});

	}

	/* This method will be used in the formatter to return the hex value of a commcell id. */
	function decimalToHex(d, padding) {
		var hex = Number(d).toString(16);
		if (hex == -1) {
			return "FFFFFFFF";
		}
		padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;
		while (hex.length < padding) {
			hex = "0" + hex;
		}
		return hex.toUpperCase();
	}
}

/// Handle worldwide and group level health card reports
function HealthCardSummary() {
	/// Flag to tell reports renderer to provide drilldown links to CommCell
	/// health reports instead of dashboards
	Reports.isHealthCard = true;

	/// CommCell group ID
	var ccGroupId = cvUtil.getParameter("ccGroupId", -1),

	/// True if at worldwide (not group) level
	isWorldwide = ccGroupId <= 0,

	/// Title of survey for header and document title
	surveyName = "Health Card",

	/// Prefix to header and title
	prefix = "Worldwide";

	var isAlarm = (cvUtil.getParameter("isAlarm", "") == "true" ? true : false);
	if (isAlarm) {
		$("#container").addClass("healthAlert");
	}

	/// If at group level, prepend the group name; otherwise, prepend
	/// "Worldwide" to title and header
	getCommCellDetailsOfUid(0, null, function(data) {
		if (data.error) {
			$(".cvApps").hide();
			$("#noDataNotificationPanel").html(data.error);
			$("#noDataNotificationPanel").show();
		} else {
			if (typeof data.GroupName !== "undefined") {
				prefix = data.GroupName;
				$(".reportsLink").text(data.GroupName + " (Reports)");
			}
		}

		surveyCommon.initComponents(prefix + " - " + surveyName, 0, ccGroupId);

		/// Disble Worldwide link on public metrics
		reportsUtil.setWorldwideLink(!isPublicMetrics);
	});

	/// This makes the call to survey.do and produces a table for the
	/// results; I'm commenting these parameters heavily for the sake of
	/// anyone that else has to use	this method (or me from the future).
	generateTable(0, /// survey ID
	"GetHealthCardSummary", /// name of action to invoke in survey.do
	false, /// whether or not the result should be a chart
	true, /// whether or not the result should be a table
	"healthCardSummary", /// table div ID
	"healthCardSummaryPager", /// table pager div ID
	"Health Card", /// table title
	0, /// CommCell ID
	"Summary", /// type of report
	true, /// whether or not it is worldwide
	false, /// whether or not to use only the latest result
	true, /// whether or not to use asynchronous call
	{ /// extra URL parameters
		ccGroupId : ccGroupId
	});
}

$(document)
		.ready(function() {
			/// Depending on whether the report is requested for a specific CommCell or
			/// for group/Worldwide level, invoke the appropriate constructor
			$(".collapsible-page-tabs").addClass("hideToggle");
			$("#headerSearchCC").addClass("healthResponsive");
			var commUniId = cvUtil.getParameter("commUniId", 0), ccGroupId = cvUtil.getParameter("ccGroupId", -1), companyId = cvUtil
					.getParameter('companyId', 0);

			if (commUniId > 0) {
				/// CommCell level report
				var url = cvUtil.getContextPath() + "/health/health.jsp" + window.location.search;
				window.location.href = url;
			} else if ((ccGroupId <= 0 && companyId <= 0) && isPublicMetrics) {
				window.location.href = "../../reports";
			} else {
				/// Worldwide or group level report
				HealthCardSummary();
			}
		});
