function HealthParams() {
	var lastSaved = {};
	var CRIT_PREFIX = "crit_";
	var WARN_PREFIX = "warn_";
	var CRIT = "crit";
	var WARN = "warn";
	var paramIds = {};
	var paramIndex = 0;
	var hash = window.location.hash;

	this.report = new Reports.initReport({
		type: "healthparams",
		idtomask: "ContentWrapper",
		directPrint : true
	});

	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		Reports.Renderers["healthThresholdRenderer"] = function(o, val, id) {
			var warn = o.aData["Warning"];
			var crit = o.aData["Critical"];
			var criticalText = o.aData["CriticalText"];
			var warnText = o.aData["WarnText"];
			var goodText = o.aData["GoodText"];
			var tmin = o.aData["tmin"];
			var tmax = o.aData["tmax"];
			var paramName = o.aData["Parameter"];
			var paramId = o.aData["Id"];
			if(!paramIds[paramId]) {
				paramIds[paramId] = {};
			}
			paramIds[paramId][paramName] = paramIndex++;
			paramId = getId(paramId, paramName);
			var warn_dvar_name = WARN_PREFIX + paramId;
			var crit_dvar_name = CRIT_PREFIX + paramId;
			var save_button_id = "save_b_" + paramId;
			var cancel_button_id = "cancel_b_" + paramId;
			var buttons_class = "buttons_" + paramId;

			//Good
			var goodSpan = "<span class='good'>"+cvUtil.cvLocalize("GoodStatus")+": </span>" + goodText;
			var goodArr = goodText.split('$MULTICRIT$');
			if(goodArr.length > 1){
				goodSpan='';
				$.each(goodArr, function(i, val){
					goodSpan += "<span class='good'>"+cvUtil.cvLocalize("GoodStatus")+": </span>" + val + "<BR>";
				});
			}

			//Warning
			var warningSpan = "<span class='warn'>"+cvUtil.cvLocalize("WarningStatus")+": </span>" + warnText;
			var warningArr = warnText.split('$MULTICRIT$');
			if(warningArr.length > 1){
				warningSpan='';
				$.each(warningArr, function(i, val){
					warningSpan += "<span class='warn'>"+cvUtil.cvLocalize("WarningStatus")+": </span>" + val + "<BR>";
				});
			}

			//Critical
			var criticalSpan = "<span class='critical'>"+cvUtil.cvLocalize("CriticalStatus")+": </span>" + criticalText;
			var criticalArr = criticalText.split('$MULTICRIT$');
			if(criticalArr.length > 1){
				criticalSpan='';
				$.each(criticalArr, function(i, val){
					criticalSpan += "<span class='critical'>"+cvUtil.cvLocalize("CriticalStatus")+": </span>" + val + "<BR>";
				});
			}

			var v = "";
			if(val !== 'Information' && val !== 'Warning') {
				v += "<div class='hparam'>" + val + "</div><table id='table_" + paramId + "' class='items hparam-list'>" +
				"<tr><td>"+goodSpan+"</td>" +
				"<td class='items'>"+ warningSpan + "</td>" +
				"<td class='items'>"+ criticalSpan + "</td></tr></table>" +
						"<span class='buttons " + buttons_class + "'>" +
						"<span id='" + save_button_id + "'><span class='sprite icon-save' alt=''></span></span>" +
						"<span id='" + cancel_button_id + "'><span class='sprite icon-cancel' alt=''></span></span>" +
						"</span>";
				v = v.replace(/#1/g, warn)
				.replace(/#2/g, crit);
			}
			else {
				v = "<div class='hparam'>" + val + "</div>";
			}
			return v;
		};

	};

	report.initComponents = function() {

	};

	report.initComponentState = function(){


	};

	report.beforeLoadReport = function() {

	};

	report.getRequestUrl = function() {
		// TODO - Update action will have some extra parameter in the URL?
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=healthparams&json='+window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	report.onLoadReport = function(data) {
		if(data && typeof data ===  'object' && !data.error) {
			$.each(data, function(index, value) {
				var view = {};
				view.title = value.tableTitle;
				view.filters = false;
				view.collapsible = true;
				view.colChooser = false;
				$('#tableWrapper').append(SurveyTemplates.makeReportTable("table"+index, view));
				Reports.configureClientSideTable("table"+index, view.title, value);
			});

			$("td").attr("title", "");

			// forcing viewport
			if(hash) {
				window.location.href = hash;
			}
		}
		else {
			alert(data.error);
		}
	};

	report.init();

	report.tableDrawCallBack = function(oSettings) {
		var dataTable = $('#'+oSettings.sInstance).dataTable();

		$.each(dataTable.fnGetNodes(), function(index, value) {
			var aData = dataTable.fnGetData( this );
			var warn = roundNumber(parseFloat(aData["Warning"], 10), 0);
			var crit = roundNumber(parseFloat(aData["Critical"], 10), 0);
			var paramId = aData["Id"];

			var paramName = aData["Parameter"];
			paramId = getId(paramId, paramName);
			var warn_dvar_name = WARN_PREFIX + paramId;
			var crit_dvar_name = CRIT_PREFIX + paramId;
			var tmin = roundNumber(parseFloat(aData["tmin"], 10), 2);
			var tmax = roundNumber(parseFloat(aData["tmax"], 10), 2);

			$(value).attr("id", getRealId(paramId));
		});

	};

	// ------------ Private Supporting functions --------------------

	function getId(paramId, paramName) {
		if(paramIds[paramId] && paramIds[paramId][paramName] != undefined) {
			return paramId + "_" + paramIds[paramId][paramName];
		}
		return paramId;
	}

	function getRealId(paramId) {
		return paramId.split("_")[0];
	}

}

$(document).ready(function() {
	HealthParams();
	cvUtil.GUIAuditReportLog("Health Report Parameters","CommCell");

});
