function ManageBillings() {

	var commcellsList, billingTagsList, agentsList;
	var tagsTableId = 'billingTags';
	var subclientLevelbillingAssociationsID = 'subclientLevelbillingAssociations';
	var storagePolicyCopyAssociationsID = "storagePolicyCopyAssociations";
	var agentLevelAssociationsID = "agentLevelbillingAssociations";
	var commUniId = cvUtil.getParameter('commUniId', 0);
	var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
	var companyId = cvUtil.getParameter('companyId', 0);
	var tagId = cvUtil.getParameter('tagId', 0);
	var exportRequest = cvUtil.getParameter('exportType', '');
	var tagEditing, associationEditing;
	var searchOpen = null; //When any search result is opened, this is changed to true

	var SHOW_TAG_NAME_SIZE = 50;
	var SHOW_ENTITY_NAME_SIZE = 31;

	this.report = new Reports.initReport({
		type : 'managebilling',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		requestString['tagId'] = tagId;
	};

	report.initComponents = function() {

	};

	report.initComponentState = function() {
		$("#surveyName").html('Manage Billing Tags');
		var link = 'chargebackmonthly.jsp';
		var div = 'reportLinks';
		if (commUniId && commUniId > 0) {
			link += '?commUniId=' + commUniId;
			div = 'commCellLevelReportLinks';
		}
		if (ccGroupId > 0) {
			link += (link.indexOf('?') > 0 ? '&' : '?') + 'ccGroupId=' + ccGroupId;
		}
		if (companyId > 0) {
			link += (link.indexOf('?') > 0 ? '&' : '?') + 'companyId=' + companyId;
		}
		$(".dynamicBreadcrumb").remove();
		var template = '<li class="smartlinkMain withSeparatorMain"><a id="{2}" class="smartLinkMain" href="{0}">{1}</a></li>';
		$("#breadcrumbMain").append(template.replace('{0}', link).replace('{1}', cvUtil.cvLocalize("Chargeback"))
				.replace('{2}', "chargeBackLink"));

		// linkTag = '<div class="monthly_link" ><a href="'+link+'">Chargeback</a></div>';
		//$('#'+div).prepend(linkTag);
	};
	report.beforeLoadReport = function() {
		report.mask("");
	};

	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=managebilling&action=managebilling&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	report.getExportFilePrefix = function() {
		var filePre = "ManageBilling";
		return filePre;
	};

	report.onLoadReport = function(data) {
		processResponse(data, true);
		report.attachTableActions();
		report.afterLoadReport();
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------
	function addActionIcons(tableId) {

		$('#' + tableId + ' tbody tr').each(function() {
			var row = $(this);
			var rEvents = row.data("events");
			if (!rEvents || !rEvents.mouseover || !rEvents.mouseover.length) {
				row.mouseenter(function(event) {
					$(this).find(".actionLinks").css("visibility", "visible");
					//$(this).addClass("");   // more styling if necessary
				});
				row.mouseleave(function(event) {
					$(this).find(".actionLinks").css("visibility", "hidden");
					//$(this).removeClass("");
				});

			}
		});
	}
	function processResponse(data, initialLoad) {
		if (data == undefined || data == null) {
			alert("Something went wrong, Please try again.");
		} else if (data && typeof data === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel").html(data);
			$("#noDataNotificationPanel").show();
		} else {
			if (data && typeof data === 'object') {
				//var hasRights = false;
				$.each(data, function(key, value) {
					if (typeof value == 'object') {
						if (value.viewType == 'clientTableWithPaging' || value.viewType == 'clientTable') {
							var wrapperId = 'tableWrapper';

							$('#' + wrapperId).append(SurveyTemplates.makeReportTable(key, value));
							var tdata = value.value;
							var configTable = true;
							if ((!tdata.aoColumns || tdata.aoColumns.length == 0) &&
									(!tdata.aoColumnDefs || tdata.aoColumnDefs.length == 0)) {
								configTable = false;
							}
							if (configTable) {
								if (value.viewType == 'clientTable') {
									Reports.configureClientSideTable(key, value.title, tdata);
								} else {
									Reports.configureClientSideTableWithPaging(key, value.title, tdata, null, {
										sDom : "lfrtip"
									});
								}
							}
							$("#" + key + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
							var pageLengthDiv = $("#" + key + "_table_wrapper .dataTables_length").detach();
							pageLengthDiv.appendTo($("#" + key + " .rptTblBtnEncDiv"));
							$("#" + key + "_holder").hide();
						} else if (value.viewType == 'custom') {
							customRender(key, value);
						}/*
							 * else if(value.viewType=='literal'){ hasRights = value.value; }
							 */

						$("#" + key + "_nodata").hide();
						$("#" + key).show();
					} else if (key == 'dataAvailable') {
						var dataAvailable = value;
						if (!dataAvailable) {
							//$("#filterDiv").hide();
							$("#ContentWrapper").hide();
							//$("#meta").hide();
							$("#noDataNotificationPanel1").html(data.errorMsg.value);
							$("#noDataNotificationPanel1").show();

						}
					}
				});
				/*
				 * if(hasRights){ addBillingTagButtons(); }
				 */
				addBillingTagButtons();
				//addStorageCopyBillingAssociationsButtons();
				addBillingAssociationsButtons(subclientLevelbillingAssociationsID);
				addBillingAssociationsButtons(storagePolicyCopyAssociationsID);
				addBillingAssociationsButtons(agentLevelAssociationsID);

				if (exportRequest) {
					var summary = "<table id=\"reportSummary\">";
					summary += "<tr><td>" + cvUtil.cvLocalize("chargeback.billing.Billing_Associations_For_Tag") +
							"</td><td> " + $('#tagsList option:selected').text() + "</td></tr>";
					summary += "</table>";
					$("#reportSummaryDiv").append(summary);
					$("#reportSummaryDiv").show();
				}
			} else if (typeof data === 'string') {

				$("#noDataNotificationPanel").html(data);
				$("#noDataNotificationPanel").show();
			}
		}
	}

	function customRender(key, model) {
		if (key == 'customerInfo') {
			customerName = model.value.Customer;
			collectiontime = model.value.time;
			GUID = model.value.CommServeGUID;

			if (customerName != null && customerName != " " && $.trim(customerName).length != 0) {
				$('#custName').html(customerName + ' -&nbsp;');
			} else {
				//$('#welcomeMsg').html('Capacity and Chargeback');
			}

			if (commUniId > 0 && (collectiontime != '') && GUID != undefined) {
				$("#metaAsOf").html('<span>' + cvUtil.cvLocalize("commcell.info.label.As_of") + ': ' + collectiontime +
						'</span>');
				$("#metaCCId").html('<span>' + cvUtil.cvLocalize("commcell.info.label.CommCell_ID") + ': ' +
						model.value.CommCellHexID + '</span>');
				$("#GUID").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Registration_Code") + ': ' +
						GUID.slice(-10) + '</span>');
			}
		} else if (key == 'globalParamInfo') {
			costDetails.fet = model.value.fet;
			costDetails.datawritten = model.value.datawritten;
			costDetails.adminclient = model.value.adminclient;
			costDetails.adminsubclient = model.value.adminsubclient;
			setCostDetailsToUI();
		} else if (key == 'billingTagsList') {
			billingTagsList = convertMapToList(model.value);
		} else if (key == 'commcells') {
			commcellsList = convertMapToList(model.value);
		} else if (key == 'agentsList') {
			agentsList = convertMapToList(model.value);
		}
	}
	function addBillingTagButtons() {
		$("#billingTags_title")
				.append("<input type ='button' id='add_button' class='actionButtons clearfix hideOnExportFriendly' value='" +
						cvUtil.cvLocalize("New") +
						"' title='" +
						cvUtil.cvLocalize("chargeback.billing.Create_New_Billing_Tag") + "'/>");
		$("#add_button").button();

		var tagTableId = tagsTableId + CVTable.table;
		var tagTable = $('#' + tagTableId).dataTable();
		$("#add_button").click(function(e) {
			e.preventDefault();
			if (tagEditing != null) {
				return;
			}
			var newData = {};
			newData["Tag ID"] = 0;
			newData["Tag Name"] = "";
			newData["Size Type"] = 0;
			newData["Price (/TB)"] = -2; //Less than 0 and not -1 would return price tag as blank
			newData["Additional Price Level"] = "-1";
			newData["Additional Price"] = -1;
			newData["Discount Level"] = "-1"
			newData["Discount Size (TB)"] = 0;
			newData["Discount (%)"] = 0;
			newData["Description"] = "";

			tagTable.fnSettings().aaSorting = [ [ 0, "asc" ] ];

			var aiNew = tagTable.fnAddData([ newData ]);
			var nRow = tagTable.fnGetNodes(aiNew[0]);
			editTagRow(tagTable, nRow);
			tagEditing = nRow;

			disableButton("add_button", true);

		});

		$('#' + tagTableId + ' span.edit').live('click', function(e) {
			e.preventDefault();
			var nRow = $(this).parents('tr')[0];
			if (nRow.length <= 0 || tagEditing != null) {
				return;
			}
			editTagRow(tagTable, nRow);
			tagEditing = nRow;
			disableButton("add_button", true);
			removeSelection(nRow);
		});

		$('#' + tagTableId + ' span.delete').live('click',
				function(e) {
					e.preventDefault();

					var nRow = $(this).parents('tr')[0];
					if (nRow.length <= 0 || tagEditing != null) {
						return;
					}
					var aData = tagTable.fnGetData(nRow);
					var result = confirm('Do you want to delete Billing Tag "' + aData['Tag Name'] + '"?');
					if (result == false) {
						return;
					}
					var request = {};
					request["tagName"] = aData['Tag Name'];
					request["tagId"] = aData['Tag ID'];
					request["sizeType"] = getSizeTypeFromStr(aData["Size Type"]);

					var configURL = cvUtil.getContextPath() +
							'/server/cloudsurvey.do?type=managebilling&action=deleteTag&json=' +
							window.encodeURIComponent(JSON.stringify(request));

					report.mask("billingTags");
					cvUtil.loadPageWithPOST(configURL,
							"",
							function(data) {
								report.unmask();
								if (data.result == 'true') {
									tagTable.fnDeleteRow(nRow);
									updateBillingTags(aData['Tag ID'], null, true);
									updatAssociationTagList();
									if (billingTagsList.length > 0) {
										var stagId = parseInt($("#tagsList").val());
										$("#" + storagePolicyCopyAssociationsID + " #tagsList").val(stagId);
										$("#" + subclientLevelbillingAssociationsID + " #tagsList").val(stagId);
										$("#" + agentLevelAssociationsID + " #tagsList").val(stagId);
										loadAssociations(stagId, subclientLevelbillingAssociationsID);
										enableAddAssociation(subclientLevelbillingAssociationsID);
										loadAssociations(stagId, storagePolicyCopyAssociationsID);
										enableAddAssociation(storagePolicyCopyAssociationsID);
										loadAssociations(stagId, agentLevelAssociationsID);
										enableAddAssociation(agentLevelAssociationsID);
									}
									showMessage(cvUtil.cvLocalize("chargeback.billing.Successfully_deleted_Tag",
											aData['Tag Name']), false);
								} else {
									showMessage(cvUtil.cvLocalize("chargeback.billing.Unable_to_delete_Tag",
											aData['Tag Name']), true);
								}
							});
				});

		$('#' + tagTableId + ' span.save').live('click', function(e) {
			e.preventDefault();
			var nRow = $(this).parents('tr')[0];
			var aData = tagTable.fnGetData(nRow);
			checkValidTagName(aData['Tag Name']);
			checkValidDesc();
			checkValidPrice('price');
			checkValidPrice('basePrice');
			checkValidDiscount('discountSize', false);
			checkValidDiscount('discount', true);
			var errors = $('.errorField', nRow);
			if (errors != undefined && errors.length > 0) {
				showMessage(cvUtil.cvLocalize("chargeback.billing.check.Please_resolve_errors"), true);
				return;
			}

			/* Get the row as a parent of the link that was clicked on */

			if (tagEditing !== null && tagEditing != nRow) {
				/* Currently editing - but not this row - restore the old before continuing to edit mode */
				restoreRow(tagTable, tagEditing);
				editTagRow(tagTable, nRow);
				tagEditing = nRow;
			} else if (tagEditing == nRow/* && this.innerHTML == "Save" */) {
				/* Editing this row and want to save it */
				saveBillingTag(tagTable, tagEditing);
				tagEditing = null;
			} else {
				/* No edit in progress - let's start one */
				editTagRow(tagTable, nRow);
				tagEditing = nRow;
			}
		});

		$('#' + tagTableId + ' span.cancel').live('click', function(e) {
			e.preventDefault();

			/* Get the row as a parent of the link that was clicked on */
			var nRow = $(this).parents('tr')[0];

			var aData = tagTable.fnGetData(nRow);
			//tagTable.fnSetColumnVis(4, false);
			if (aData['Tag ID'] != '0') {
				var idx = 1;
				tagTable.fnUpdate(aData['Tag Name'], nRow, idx++, false);
				tagTable.fnUpdate(getSizeTypeFromStr(aData['Size Type']), nRow, idx++, false);
				tagTable.fnUpdate(getNumber(aData['Price (/TB)']), nRow, idx++, false);
				tagTable.fnUpdate(getEntity(aData['Additional Price Level']), nRow, idx++, false);
				tagTable.fnUpdate(getNumber(aData['Additional Price']), nRow, idx++, false);
				tagTable.fnUpdate(getEntity(aData['Discount Level']), nRow, idx++, false);
				tagTable.fnUpdate(getNumber(aData['Discount Size (TB)']), nRow, idx++, false);
				tagTable.fnUpdate(getNumber(aData['Discount (%)']), nRow, idx++, false);
				tagTable.fnUpdate(aData['Description'], nRow, idx++, false);
				//tagTable.fnUpdate( aData['Contact'], nRow, 4, false );
				tagTable.fnDraw();
			} else {
				tagTable.fnDeleteRow(nRow);
			}
			tagEditing = null;
			disableButton("add_button", false);

		});

	}

	//To limit the length of label shown without losing functionality
	function renderDropdown(ul, item) {
		var labelToDisplay = (item.label.length > SHOW_ENTITY_NAME_SIZE) ? item.label.substring(0,SHOW_ENTITY_NAME_SIZE)+"..." : item.label;
		return $("<li>")
			.data("item.autocomplete", item)
			.append("<a title='"+item.label+"'>" + labelToDisplay+ "</a>")
			.appendTo(ul);
	}

	function getNumber(val, edit) {
		if (val == '' || val == 'N/A') {
			if (edit == true) {
				val = '';
			} else {
				val = -1;
			}

		}
		return val;
	}

	function getEntity(val) {
		if (val == 'Client') {
			val = 1;
		} else if (val == 'SubClient') {
			val = 0;
		} else {
			val = -1;
		}
		return val;
	}

	function updatAssociationTagList() {
		var options = [];
		options.push("<option value='0'>" + cvUtil.cvLocalize("chargeback.billing.All") + "</option>");
		if (billingTagsList) {
			$.each(billingTagsList, function(index, tag) {
				var tName = tag.name;
				if (tName.length > SHOW_TAG_NAME_SIZE) {
					tName = tName.substr(0, SHOW_TAG_NAME_SIZE) + '...';
				}
				options.push("<option value='" + tag.id + "' title='" + tag.name + "'>" + tName + "</option>");
			});
		}
		$('#' + subclientLevelbillingAssociationsID + ' #tagsList').html(options.join(''));
		$('#' + storagePolicyCopyAssociationsID + ' #tagsList').html(options.join(''));
		$('#' + agentLevelAssociationsID + ' #tagsList').html(options.join(''));
	}

	function addRowSelectionActions(tableId, isTagsTable) {
		$("#" + tableId + " tbody").on("click", "tr", function(event) {
			if ($(this).hasClass('row_selected')) {
				$(this).toggleClass('row_selected');
				$(event.target.parentNode).find('td').css('background-color', '');
			} else {
				var oTable = $('#' + tableId).dataTable();
				if (oTable.fnSettings()) {
					$(oTable.fnSettings().aoData).each(function() {
						$(this.nTr).removeClass('row_selected');
						$(this.nTr).find('td').css('background-color', '');
					});
				}
				$(this).toggleClass('row_selected');
				$(event.target.parentNode).find('td').css('background-color', '#B0BED9');
			}
		});
	}

	function removeSelection(nRow) {
		$(nRow).find('td').css('background-color', '');
	}

	function disableButton(id, disable) {
		$("#" + id).prop('disabled', disable);
		if (disable) {
			$("#" + id).css('background-color', '#B0BED9');
		} else {
			$("#" + id).css('background-color', '');
		}
	}
	/* Get the rows which are currently selected */
	function fnGetSelected(oTable) {
		var nRow = oTable.$('tr.row_selected');
		return nRow;
	}

	function editTagRow(oTable, nRow) {
		var aData = oTable.fnGetData(nRow);
		var jqTds = $('>td', nRow);
		var idx = 0;
		jqTds[idx++].innerHTML = '<input id="tagName" type="text" class="tagsInputs enterAction" value="' +
				aData['Tag Name'] + '"/>';
		var sizeType = getNumber(aData["Size Type"], true);
		var sizeTypeStr = '';
		sizeTypeStr += '<option value="0">' + cvUtil.cvLocalize("chargeback.billing.Any") + '</option>';
		sizeTypeStr += '<option value="1">' + cvUtil.cvLocalize("chargeback.billing.Frontend_Backup") + '</option>';
		sizeTypeStr += '<option value="2">' + cvUtil.cvLocalize("chargeback.billing.Frontend_Archive") + '</option>';
		sizeTypeStr += '<option value="3">' + cvUtil.cvLocalize("chargeback.billing.Application") + '</option>';
		sizeTypeStr += '<option value="4">' + cvUtil.cvLocalize("chargeback.billing.Media") + '</option>';
		jqTds[idx++].innerHTML = '<select id="sizeType" class="tagsInputs enterAction">' + sizeTypeStr + '</select>';

		var price = aData['Price (/TB)'];
		if (price === 'Global Price') {
			//price = '-1';
		} else if (price === 'N/A') {
			price = '';
		}
		jqTds[idx++].innerHTML = '<div class="select-editable"><input id="price" type="text" class="tagsInputs enterAction" onkeypress="return isValideNumber(event);" value="' +
				price + '"/>';
		$("#price").autocomplete({
			source : [ "Global Price" ],
			minLength : 0
		});
		$("#price").click(function(e) {
			$("#price").autocomplete("search", "");
		});
		var baseLevel = aData["Additional Price Level"];
		var levelStr = '<option value="-1">' + cvUtil.cvLocalize("Not_Applicable") + '</option>';
		levelStr += '<option value="1">' + cvUtil.cvLocalize("Client") + '</option>';
		levelStr += '<option value="0">' + cvUtil.cvLocalize("SubClient") + '</option>';

		jqTds[idx++].innerHTML = '<select id="baseLevel" class="tagsInputs enterAction">' + levelStr + '</select>';
		var basePrice = getNumber(aData["Additional Price"], true);
		jqTds[idx++].innerHTML = '<input id="basePrice" type="text" class="tagsInputs enterAction" onkeypress="return isValideNumber(event);" value="' +
				basePrice + '"/>';
		var discountLevel = aData["Discount Level"];
		jqTds[idx++].innerHTML = '<select id="discountLevel" class="tagsInputs enterAction">' + levelStr + '</select>';
		var discountSize = getNumber(aData["Discount Size (TB)"], true);
		jqTds[idx++].innerHTML = '<input id="discountSize" type="text" class="tagsInputs enterAction" onkeypress="return isValideNumber(event);" value="' +
				discountSize + '"/>';
		var discount = getNumber(aData["Discount (%)"], true);
		jqTds[idx++].innerHTML = '<input id="discount" type="text" class="tagsInputs enterAction" onkeypress="return isValideNumber(event);" value="' +
				discount + '"/>';
		jqTds[idx++].innerHTML = '<textarea  rows="1" cols="10" id="desc" class="tagsInputsLast enterAction">' +
				aData['Description'] + '</textarea>' + '<span class="tagEditSpan">' +
				'<span class="save sprite icon-save" title="Save"></span>' +
				'<span class="cancel sprite icon-delete" title="Cancel"></span>' + '</span>';
		$("#baseLevel option[value='" + getEntity(baseLevel) + "']").prop('selected', 'selected');
		$("#discountLevel option[value='" + getEntity(discountLevel) + "']").prop('selected', 'selected');
		$("#sizeType option[value='" + getSizeTypeFromStr(sizeType) + "']").prop('selected', 'selected');

		$('#tagName').focusout(function() {
			checkValidTagName(aData['Tag Name']);
		});

		$('#price').focusout(function() {
			checkValidPrice('price');
		});
		$('#baseLevel').change(function() {
			enablePrice('baseLevel');
		});
		$('#basePrice').focusout(function() {
			checkValidPrice('basePrice');
		});
		$('#discountLevel').change(function() {
			enablePrice('discountLevel');
		});
		$('#discountSize').focusout(function() {
			checkValidDiscount('discountSize', false);
		});
		$('#discount').focusout(function() {
			checkValidDiscount('discount', true);
		});

		$('#desc').focusout(function() {
			checkValidDesc();
		});

		//		$('#tag-price-select').on('change', function(e) {
		//			this.nextElementSibling.value = $('#tag-price-select').val();
		//		});

		enablePrice('baseLevel');
		enablePrice('discountLevel');

		$('#tagName').focus();
	}

	function getSizeTypeFromStr(sizeType) {
		if (sizeType === 'Frontend Backup') {
			return 1;
		} else if (sizeType === 'Frontend Archive') {
			return 2;
		} else if (sizeType === 'Application') {
			return 3;
		} else if (sizeType === 'Media') {
			return 4;
		} else {
			return 0;
		}
	}

	function checkValidTagName(currentTag) {
		var val = $('#tagName').val();
		var errTxt;
		if (val == undefined || val.trim() == '') {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Tag_name_should_not_be_empty");
		} else if (val.length > 250) {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Tag_name_should_not_exceed_250_characters");
		} else if ($("<p>").html(val).text() != val) {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Tag_name_should_not_contain_HTML");
		} else {
			if (billingTagsList) {
				$.each(billingTagsList, function(index, existingTag) {
					if (val == existingTag.name && currentTag != existingTag.name) {
						errTxt = cvUtil.cvLocalize("chargeback.billing.check.Tag_name_already_exists");
						return;
					}
				});
			}
		}
		updateError('tagName', errTxt);
	}

	function checkValidDesc() {
		var val = $('#desc').val();
		var errTxt;
		if (val == undefined || val.trim() == '') {

		} else if (val.length > 500) {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Description_should_not_exceed_500_characters");
		} else if ($("<p>").html(val).text() != val) {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Description_should_not_contain_HTML");
		}
		updateError('desc', errTxt);
	}

	function checkValidPrice(id) {
		var errTxt = validCost(id);
		updateError(id, errTxt);
	}
	function checkValidDiscount(id, percent) {
		var errTxt = validDiscount(id, percent);
		updateError(id, errTxt);
	}

	function updateError(id, error) {
		var field = $('#' + id);
		if (error) {
			field.addClass('errorField');
			field.attr('title', error);
		} else {
			field.removeClass('errorField');
			field.attr('title', '');
		}
	}

	function enablePrice(id) {
		var val = $('#' + id).val() || -1;
		if (val == -1) {
			if (id == 'baseLevel') {
				$('#basePrice').prop('disabled', true);
			} else {
				$('#discountSize').prop('disabled', true);
				$('#discount').prop('disabled', true);
			}
		} else {
			if (id == 'baseLevel') {
				$('#basePrice').prop('disabled', false);
			} else {
				$('#discountSize').prop('disabled', false);
				$('#discount').prop('disabled', false);
			}
		}
	}

	function isValidPrice(id) {

	}

	function saveBillingTag(oTable, nRow) {
		var jqInputs = $('input', nRow);
		var aData = oTable.fnGetData(nRow);
		var request = {};
		request["tagId"] = aData['Tag ID'] || 0;
		request["tagName"] = jqInputs[0].value;

		var sizeType = $('#sizeType').val() || 0;
		request["sizeType"] = sizeType;

		var tagPrice = jqInputs[1].value || -1;
		tagPrice = (tagPrice == 'Global Price') ? -1 : tagPrice;
		request["price"] = tagPrice;
		var bpl = $('#baseLevel').val() || -1;
		request["baseLevel"] = bpl;
		if (bpl == -1) {
			request["basePrice"] = -1;
		} else {
			request["basePrice"] = jqInputs[2].value || -1;
		}
		var dl = $('#discountLevel').val() || -1;
		request["discountLevel"] = dl;
		if (dl == -1) {
			request["discountSize"] = -1;
			request["discount"] = -1;
		} else {
			request["discountSize"] = jqInputs[3].value || -1;
			request["discount"] = jqInputs[4].value || -1;
		}

		var description = $("#desc").val();
		request["description"] = description;

		var edit = request["tagId"] != '0';

		var configURL = cvUtil.getContextPath() + '/server/cloudsurvey.do?type=managebilling&action=addEditTag&json=' +
				window.encodeURIComponent(JSON.stringify(request));

		report.mask("");
		cvUtil.loadPageWithPOST(configURL,
				"",
				function(data) {
					report.unmask();
					if (data.error == undefined) {
						var tagName = jqInputs[0].value;
						if (tagName.length > SHOW_TAG_NAME_SIZE) {
							tagName = tagName.substr(0, SHOW_TAG_NAME_SIZE) + '...';
						}
						var tagId = 0;
						if (!edit) {
							oTable.fnUpdate(data.tagId, nRow, 0, false);
							tagId = data.tagId;
							var temp = {};
							temp.id = tagId;
							temp.name = tagName;
							if (billingTagsList == undefined) {
								billingTagsList = [];
							}
							billingTagsList.push(temp);
							updatAssociationTagList();
							$("#" + storagePolicyCopyAssociationsID + " #addAssociation_button").attr('title',
									'Create New Billing Association');
							$("#" + subclientLevelbillingAssociationsID + " #addAssociation_button").attr('title',
									'Create New Billing Association');
							$("#" + agentLevelAssociationsID + " #addAssociation_button").attr('title',
									'Create New Billing Association');
						} else {
							tagId = aData['Tag ID'];
							updateBillingTags(tagId, tagName);
							tagId = parseInt($("#tagsList").val());
						}

						var price = jqInputs[1].value;
						if (price == '') {
							price = -1;
						} else if (price == 'Global Price') {
							price = -1;
						}
						var idx = 1;
						oTable.fnUpdate(jqInputs[0].value, nRow, idx++, false);
						oTable.fnUpdate(request["sizeType"], nRow, idx++, false);
						oTable.fnUpdate(price, nRow, idx++, false);
						oTable.fnUpdate(request["baseLevel"], nRow, idx++, false);
						oTable.fnUpdate(request["basePrice"], nRow, idx++, false);
						oTable.fnUpdate(request["discountLevel"], nRow, idx++, false);
						oTable.fnUpdate(request["discountSize"], nRow, idx++, false);
						oTable.fnUpdate(request["discount"], nRow, idx++, false);
						oTable.fnUpdate(description, nRow, idx++, false);
						//oTable.fnUpdate( jqInputs[3].value, nRow, 4, false );
						//oTable.fnSetColumnVis(4, false);
						oTable.fnDraw();

						updatAssociationTagList();

						$("#" + storagePolicyCopyAssociationsID + " #tagsList").val(tagId);
						$("#" + subclientLevelbillingAssociationsID + " #tagsList").val(tagId);
						if (edit) {
							showMessage(cvUtil.cvLocalize("chargeback.billing.Updated_billing_tag", jqInputs[0].value),
									false);
						} else {
							$("#" + storagePolicyCopyAssociationsID + " #tagsList").val(tagId);
							$("#" + subclientLevelbillingAssociationsID + " #tagsList").val(tagId);
							$("#" + agentLevelAssociationsID + " #tagsList").val(tagId);
							loadAssociations(tagId, subclientLevelbillingAssociationsID);
							loadAssociations(tagId, storagePolicyCopyAssociationsID);
							loadAssociations(tagId, agentLevelAssociationsID);
							showMessage(cvUtil
									.cvLocalize("chargeback.billing.Added_new_billing_tag", jqInputs[0].value), false);
						}
						disableButton("add_button", false);
						enableAddAssociation(storagePolicyCopyAssociationsID);
						enableAddAssociation(subclientLevelbillingAssociationsID);
						enableAddAssociation(agentLevelAssociationsID);

					} else {
						showMessage(cvUtil.cvLocalize("chargeback.billing.Unable_to_add_update_billing_tag",
								jqInputs[0].value), true);
					}
				});
	}
	function addBillingAssociationsButtons(associationsTableId) {
		var titleId = '#' + associationsTableId + '_title_holder';
		$(titleId).append('<span id="associationSpan" class="hideOnExportFriendly"/>');
		var associationSpan = '#associationSpan';

		var billingtags = '<select id="tagsList">';

		var options = [];
		options.push("<option value='0'>" + cvUtil.cvLocalize("chargeback.billing.All") + "</option>");
		if (billingTagsList) {
			$.each(billingTagsList, function(index, tag) {
				var tName = tag.name;
				if (tName.length > SHOW_TAG_NAME_SIZE) {
					tName = tName.substr(0, SHOW_TAG_NAME_SIZE) + '...';
				}
				options.push("<option value='" + tag.id + "' title='" + tag.name + "'>" + tName + "</option>");
			});
		}
		billingtags += options.join('');
		billingtags += '</select>';
		$(titleId + ' ' + associationSpan).append(billingtags);

		$("#tagsList option[value='" + report.requestString.tagId + "']").prop('selected', 'selected');

		$(titleId + ' ' + associationSpan)
				.append("<input type ='button' id='addAssociation_button' class='actionButtons clearfix hideOnExportFriendly' value='" +
						cvUtil.cvLocalize("New") +
						"' title='" +
						cvUtil.cvLocalize("chargeback.billing.Create_New_Billing_Association") + "'/>");
		$("#" + associationsTableId + " #addAssociation_button").button();
		enableAddAssociation(associationsTableId);
		//associationsTableId = associationsTableId+CVTable.table;

		$('#' + associationsTableId + " #addAssociation_button").click(function(e) {
			e.preventDefault();
			var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
			var associationsTable = $('#' + currentassociationsTableId + CVTable.table).dataTable();
			if (associationEditing != null) {
				return;
			}

			var newData = {};
			newData = populateTagAssociationRow(currentassociationsTableId);
			associationsTable.fnSettings().aaSorting = [ [ 0, "asc" ] ];

			var aiNew = associationsTable.fnAddData([ newData ]);
			var nRow = associationsTable.fnGetNodes(aiNew[0]);
			editAssociationRow(currentassociationsTableId, associationsTable, nRow);
			associationEditing = nRow;

			disableButton(currentassociationsTableId + " #addAssociation_button", true);

		});

		$('#' + associationsTableId + ' span.delete')
				.live('click',
						function(e) {
							e.preventDefault();
							//var nRow = fnGetSelected(associationsTable);
							var nRow = $(this).parents('tr')[0];
							if (nRow.length <= 0 || associationEditing != null) {
								return;
							}
							//var row=associationsTable.fnGetPosition(nRow.find('td')[0])[0];
							var result = confirm(cvUtil
									.cvLocalize("chargeback.billing.Do_you_want_to_delete_this_Billing_Association"));
							if (result == false) {
								return;
							}
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var associationsTable = $('#' + currentassociationsTableId + CVTable.table).dataTable();
							var aData = associationsTable.fnGetData(nRow);
							var request = {};
							request = populateDeleteRequest(currentassociationsTableId, aData);
							var configURL = cvUtil.getContextPath(currentassociationsTableId) +
									'/server/cloudsurvey.do?type=managebilling&action=updateAssociation&billingAssocitaionType=' +
									currentassociationsTableId + '&json=' +
									window.encodeURIComponent(JSON.stringify(request));

							report.mask("");
							cvUtil.loadPageWithPOST(configURL, "", function(data) {
								report.unmask();
								if (data.result == true) {
									associationsTable.fnDeleteRow(nRow);
									showMessage(cvUtil
											.cvLocalize("chargeback.billing.Successfully_deleted_billing_association"),
											false);
								} else {
									showMessage(cvUtil
											.cvLocalize("chargeback.billing.Unable_to_delete_billing_association"),
											true);
								}
								associationEditing = null;
							});
						});

		$('#' + associationsTableId + " #tagsList").change(function(el) {
			associationEditing = null;
			var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
			disableButton(currentassociationsTableId + " #addAssociation_button", false);

			var tagId = parseInt($('#' + currentassociationsTableId + " #tagsList").val());
			if (tagId <= 0) {
				disableButton(currentassociationsTableId + " #addAssociation_button", true);
			}
			$('#' + storagePolicyCopyAssociationsID + " #tagsList").val(tagId);
			$('#' + subclientLevelbillingAssociationsID + " #tagsList").val(tagId);
			$('#' + agentLevelAssociationsID + " #tagsList").val(tagId);

			loadAssociations(tagId, storagePolicyCopyAssociationsID);
			loadAssociations(tagId, subclientLevelbillingAssociationsID);
			loadAssociations(tagId, agentLevelAssociationsID);
			enableAddAssociation(storagePolicyCopyAssociationsID);
			enableAddAssociation(subclientLevelbillingAssociationsID);
			enableAddAssociation(agentLevelAssociationsID);
		});

		$('#' + associationsTableId + ' span.save').live('click', function(e) {
			e.preventDefault();

			/* Get the row as a parent of the link that was clicked on */
			checkValidCommCell(associationsTableId);
			var nRow = $(this).parents('tr')[0];
			var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
			var associationsTable = $('#' + currentassociationsTableId + CVTable.table).dataTable();
			if (currentassociationsTableId === storagePolicyCopyAssociationsID) {
				checkValidInputFiels();
			}
			var errors = $('.errorField', nRow);
			if (errors != undefined && errors.length > 0) {
				showMessage(cvUtil.cvLocalize("chargeback.billing.check.Please_resolve_errors"), true);
				return;
			}

			if (associationEditing !== null && associationEditing != nRow) {
				/* Currently editing - but not this row - restore the old before continuing to edit mode */
				restoreRow(associationsTable, associationEditing);
				editAssociationRow(currentassociationsTableId, associationsTable, nRow);
				associationEditing = nRow;
			} else if (associationEditing == nRow /* && this.innerHTML == "Save" */) {
				/* Editing this row and want to save it */
				saveAssociationRow(currentassociationsTableId, associationsTable, associationEditing);

			} else {
				/* No edit in progress - let's start one */
				editAssociationRow(currentassociationsTableId, associationsTable, nRow);
				associationEditing = nRow;
			}
		});

		$('#' + associationsTableId + ' span.cancel').live('click', function(e) {
			e.preventDefault();

			/* Get the row as a parent of the link that was clicked on */
			var associationsTable = $('#' + associationsTableId + CVTable.table).dataTable();
			var nRow = $(this).parents('tr')[0];
			associationsTable.fnDeleteRow(nRow);
			disableButton(associationsTableId + " #addAssociation_button", false);
			associationEditing = null;
		});
	}

	function editAssociationRow(currentassociationsTableId, oTable, nRow) {
		//data-searchid created to recognise corresponding searchbox id
		var commcells = '<div id="commcellsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="commcells" class="tagsInputs enterAction"><span data-searchid="commcells" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="commcells" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
		if (commcellsList) {
			var options = [];
			$.each(commcellsList, function(index, cc) {
				var ccName = cc.name;
				options.push({
					label : ccName,
					value : cc.id
				});
			});
		}
		editAssociationRowValue(nRow, commcells, currentassociationsTableId);

		$("#commcells").autocomplete({
			source : options,
			minLength : 0,
			position : {
                my : "left top",
				at : "left bottom",
				of : "#commcellsSearchBox",
				collision: "none"
			},
			open : function(event, ui) {
				$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
				if (searchOpen && searchOpen.length > 0) {
					return false;
				}
				searchOpen = "commcells";
			},
			close : function(event, ui) {
				searchOpen = null;
			},
			select : function(event, ui) {
				$("#commcells").val(ui.item.label);
				$("#commcells").data("labelId", ui.item.value);
				var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
				if (currentassociationsTableId === agentLevelAssociationsID) {
					return false;
				}
				var commcell = parseInt(ui.item.value);
				if (commcell == 0) {
					return;
				}
				if (currentassociationsTableId == subclientLevelbillingAssociationsID) {
					resetEntities([
							'clientgroups',
							'clients',
							'agents',
							'instances',
							'backupsets',
							'subclients',
							'archiveEnabled',
							'onePassEnabled' ]);
					loadEntities('clientgroups', currentassociationsTableId);

				} else if (currentassociationsTableId = storagePolicyCopyAssociationsID) {
					resetEntities([ 'storagePolicy', 'copyName' ]);
					loadEntities('storagePolicy', currentassociationsTableId);
				}
				return false;
			}
		}).data("autocomplete")._renderItem = renderDropdown;
		$('#commcells').focus();

		$('#commcells').focusout(function() {
			checkValidCommCell(currentassociationsTableId);
		});
		//When user click search button, explicitly giving search command
		$('#' + currentassociationsTableId + ' .searchBox .searchBoxIcon').click(function(e) {
			var searchBarId = $(this).data("searchid");
			$('#' + currentassociationsTableId + ' .searchBox #' + searchBarId).autocomplete("search",
					$("#" + searchBarId).val());
		});
		//When user clicks on search box, opens up the options available
		$('#' + currentassociationsTableId + ' .searchBox').click(function(e) {
			if (e.target.id != "" && $('#' + e.target.id).val() == "") {
				$('#' + e.target.id).autocomplete("search", "");
			}
		});
		//When user clicks clear button, clear text area
		$('#' + currentassociationsTableId + ' .searchBox .clearIcon').click(function(e) {
			var searchBarId = $(this).data("searchid");
			$('#' + currentassociationsTableId + ' .searchBox #' + searchBarId).val("");
			$('#' + currentassociationsTableId + ' .searchBox #' + searchBarId).data("labelId", null);
			$('#' + currentassociationsTableId + ' .searchBox #' + searchBarId).autocomplete("search", "");
			if (searchBarId == "commcells") {
				if (currentassociationsTableId == subclientLevelbillingAssociationsID) {
					resetEntities([
							'clientgroups',
							'clients',
							'agents',
							'instances',
							'backupsets',
							'subclients',
							'archiveEnabled',
							'onePassEnabled' ]);
				} else if (currentassociationsTableId = storagePolicyCopyAssociationsID) {
					resetEntities([ 'storagePolicy', 'copyName' ]);
				}
			} else {
				resetEntity(searchBarId);
			}
		});
		$('#commcells').focus();
	}

	function checkValidCommCell(currentassociationsTableId) {
		if (currentassociationsTableId === agentLevelAssociationsID) {
			return;
		}
		var val = $('#' + currentassociationsTableId + ' #commcells').data("labelId");
		var errTxt;
		if (val == undefined || val.trim() == '' || val.trim() == '0') {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.CommCell_should_not_be_empty");
		}
		updateError('commcells', errTxt);
	}

	function checkValidInputFiels() {
		var storagePolicyVal = $('#storagePolicy').val();
		var copyNameVal = $('#copyName').val();
		var errTxt;
		if (storagePolicyVal == undefined || storagePolicyVal.trim() == '' || storagePolicyVal.trim() == '0') {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Storage_Policy_should_not_be_empty");
			updateError('storagePolicy', errTxt);
			return;
		} else {
			updateError('storagePolicy', errTxt);
		}

		if (copyNameVal == undefined || copyNameVal.trim() == '' || copyNameVal.trim() == '0') {
			errTxt = cvUtil.cvLocalize("chargeback.billing.check.Copy_Name_should_not_be_empty");
			updateError('copyName', errTxt);
			return;
		} else {
			updateError('copyName', errTxt);
		}
	}

	function loadEntities(entityId, currentassociationsTableId) {
		var request = {};
		request = populateloadloadEntitiesRequest(currentassociationsTableId);

		var configURL = cvUtil.getContextPath() +
				'/server/cloudsurvey.do?type=managebilling&action=entities&billingAssocitaionType=' +
				currentassociationsTableId + '&json=' + window.encodeURIComponent(JSON.stringify(request));

		//report.mask(entityId, false);
		cvUtil.loadPageWithPOST(configURL, "", function(data) {
			//report.unmask();
			if (data.entitiesList != undefined && data.entitiesList.entities) {
				var options = [];
				var list = convertMapToList(data.entitiesList.entities);
				$.each(list, function(index, entity) {
					var entityName = entity.name;
					options.push({
						label : entityName,
						value : entity.id
					});
				});
				if (entityId == "clientgroups") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#clientgroupsSearchBox",
							collision: "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "clientgroups";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#clientgroups").val(ui.item.label);
							$("#clientgroups").data("labelId", ui.item.value);
							resetEntity("clientgroups");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var group = parseInt($("#clientgroups").data("labelId"));
							if (group == 0) {
								return;
							}

							loadEntities('clients', currentassociationsTableId);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "clients") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#clientsSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "clients";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#clients").val(ui.item.label);
							$("#clients").data("labelId", ui.item.value);
							resetEntity("clients");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var client = parseInt($("#clients").data("labelId"));
							if (client == 0) {
								return;
							}
							loadEntities('agents', currentassociationsTableId);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "agents") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#agentsSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "agents";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#agents").val(ui.item.label);
							$("#agents").data("labelId", ui.item.value);
							resetEntity("agents");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var agent = parseInt($("#agents").data("labelId"));
							if (agent == 0) {
								return;
							}
							if (currentassociationsTableId === agentLevelAssociationsID) {
								loadEntities('commcells', currentassociationsTableId);
							} else {
								loadEntities('instances', currentassociationsTableId);
							}
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "instances") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#instancesSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "instances";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#instances").val(ui.item.label);
							$("#instances").data("labelId", ui.item.value);
							resetEntity("instances");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var instance = parseInt($("#instances").data("labelId"));
							if (instance == 0) {
								return;
							}
							loadEntities('backupsets', currentassociationsTableId);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "backupsets") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#backupsetsSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "backupsets";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#backupsets").val(ui.item.label);
							$("#backupsets").data("labelId", ui.item.value);
							resetEntity("backupsets");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var backupset = parseInt($("#backupsets").data("labelId"));
							if (backupset == 0) {
								return;
							}
							loadEntities('subclients', currentassociationsTableId);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "subclients") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#subclientsSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "subclients";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#subclients").val(ui.item.label);
							$("#subclients").data("labelId", ui.item.value);
							resetEntity("subclients");
							var currentassociationsTableId = $(this).closest(".reportTable").attr("id");
							var subclient = parseInt($("#subclients").data("labelId"));
							if (subclient == 0) {
								return;
							}
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else if (entityId == "storagePolicy") {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#storagePolicySearchBox",
							collision: "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "storagePolicy";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$("#storagePolicy").val(ui.item.label);
							$("#storagePolicy").data("labelId", ui.item.value);
							resetEntity("storagePolicy");
							var group = parseInt($("#storagePolicy").data("labelId"));
							if (group == 0) {
								return;
							}

							loadEntities('copyName', currentassociationsTableId);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				} else {
					$('#' + entityId).autocomplete({
						source : options,
						minLength : 0,
						position : {
                            my : "left top",
							at : "left bottom",
							of : "#copyNameSearchBox",
							collision : "none"
						},
						open : function(event, ui) {
							$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
							if (searchOpen && searchOpen.length > 0) {
								return false;
							}
							searchOpen = "storagePolicy";
						},
						close : function(event, ui) {
							searchOpen = null;
						},
						select : function(event, ui) {
							$('#' + entityId).val(ui.item.label);
							$('#' + entityId).data("labelId", ui.item.value);
							return false;
						}
					}).data("autocomplete")._renderItem = renderDropdown;
				}
			}
		});
	}

	function resetEntity(Entity) { //Uses 'search box id' passed as parameter to clear all the trailing searchboxes
		if (Entity == "clientgroups") {
			resetEntities([
					'clients',
					'agents',
					'instances',
					'backupsets',
					'subclients',
					'archiveEnabled',
					'onePassEnabled' ]);
		} else if (Entity == "clients") {
			resetEntities([ 'agents', 'instances', 'backupsets', 'subclients', 'archiveEnabled', 'onePassEnabled' ]);
		} else if (Entity == "agents") {
			resetEntities([ 'instances', 'backupsets', 'subclients', 'archiveEnabled', 'onePassEnabled' ]);
		} else if (Entity == "instances") {
			resetEntities([ 'backupsets', 'subclients', 'archiveEnabled', 'onePassEnabled' ]);
		} else if (Entity == "backupsets") {
			resetEntities([ 'subclients', 'archiveEnabled', 'onePassEnabled' ]);
		} else if (Entity == "subclients") {
			resetEntities([ 'archiveEnabled', 'onePassEnabled' ]);
		} else if (Entity == "storagePolicy") {
			resetEntities([ 'copyName' ]);
		}
	}

	function resetEntities(list) {
		for (var i = 0; i < list.length; i++) {
			$('#' + list[i]).empty();
			$('#' + list[i]).val("");
			$('#' + list[i]).data("labelId", "");
		}
	}

	function loadAssociations(tagId, currentassociationsTableId) {
		var request = {};
		request["tagId"] = tagId;
		requestString['tagId'] = tagId;

		var configURL = cvUtil.getContextPath() +
				'/server/cloudsurvey.do?type=managebilling&action=getAssociations&billingAssocitaionType=' +
				currentassociationsTableId + '&json=' + window.encodeURIComponent(JSON.stringify(requestString));
		report.mask("");
		var filterOn = $("#billingAssociations_FilterButton").hasClass("filterOn");
		if (filterOn) {
			$("#billingAssociations_FilterButton").click();
		}

		cvUtil.loadPageWithPOST(configURL, "", function(data) {
			report.unmask();
			if (data) {
				Reports.configureClientSideTableWithPaging(currentassociationsTableId,
						data.associations.value.title,
						data.associations.value);
				report.afterLoadReport();
				$("#" + currentassociationsTableId + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
				var pageLengthDiv = $("#" + currentassociationsTableId + "_table_wrapper .dataTables_length").detach();
				pageLengthDiv.appendTo($("#" + currentassociationsTableId + " .rptTblBtnEncDiv"));
				$("#" + currentassociationsTableId + "_holder").hide();
				report.unmask();
			}
		});
	}
	function populateloadloadEntitiesRequest(currentassociationsTableId) {
		var request = {};
		if (currentassociationsTableId === subclientLevelbillingAssociationsID) {
			var commcell = parseInt($("#commcells").data("labelId") || 0);
			var group = parseInt($("#clientgroups").data("labelId") || 0);
			var client = parseInt($("#clients").data("labelId") || 0);
			var agent = parseInt($("#agents").data("labelId") || 0);
			var instance = parseInt($("#instances").data("labelId") || 0);
			var backupset = parseInt($("#backupsets").data("labelId") || 0);
			request["commcell"] = commcell;
			request["clientgroup"] = group;
			request["client"] = client;
			request["agent"] = agent;
			request["instance"] = instance;
			request["backupset"] = backupset;
		} else if (currentassociationsTableId === storagePolicyCopyAssociationsID) {
			var commcell = parseInt($("#commcells").data("labelId") || 0);
			var storagePolicyID = parseInt($("#storagePolicy").data("labelId") || 0);
			var copyID = parseInt($("#copyName").data("labelId") || 0);
			var request = {};
			request["commcell"] = commcell;
			request["storagePolicyID"] = storagePolicyID;
			request["copyID"] = copyID;
		} else if (currentassociationsTableId === agentLevelAssociationsID) {
			request["agent"] = parseInt($("#agents").data("labelId") || 0);
		}
		return request;

	}
	function populateTagAssociationRow(currentSelection) {
		if (currentSelection === subclientLevelbillingAssociationsID) {
			return {
				"CommServ UniqueId" : "0",
				"CommCell Name" : "",
				"Client Group ID" : "0",
				"Client Group" : "",
				"Client ID" : "0",
				"Client" : "",
				"Agent Type ID" : "0",
				"Agent" : "",
				"InstanceId ID" : "0",
				"Instance" : "",
				"Backupset ID" : "0",
				"Backupset" : "",
				"App ID" : "0",
				"Subclient" : "",
				"Archive Enabled" : "",
				"OnePass Enabled" : "",
			}
		} else if (currentSelection === storagePolicyCopyAssociationsID) {
			return {
				"CommServ UniqueId" : "0",
				"CommCell Name" : "",
				"Storage Policy" : "",
				"Copy ID" : "0",
				"Copy Name" : "",
				"Is Primary Copy" : "",
				"Is Snap Copy" : "",
				"Is Dedup Copy" : "",
				"Library Name" : ""
			}
		} else if (currentSelection === agentLevelAssociationsID) {
			return {
				"Agent Type ID" : "0",
				"Agent" : "",
				"CommServ UniqueId" : "0",
				"CommCell Name" : "",
			}
		}
	}

	function populateDeleteRequest(currentSelection, aData) {
		var request = {};
		if (currentSelection === subclientLevelbillingAssociationsID) {
			request["commcell"] = aData['CommServ UniqueId'] || 0;
			request["clientgroup"] = aData['Client Group ID'] || 0;
			request["client"] = aData['Client ID'] || 0;
			request["agent"] = aData['Agent Type ID'] || 0;
			request["instance"] = aData['InstanceId ID'] || 0;
			request["backupset"] = aData['Backupset ID'] || 0;
			request["subclient"] = aData['App ID'] || 0;
			var tId = $('#tagsList').val();
			if (tId <= 0) {
				tId = aData['Tag ID'] || 0;
			}
			request["tagId"] = tId;
			request["addDelete"] = 0;
			;
		} else if (currentSelection === storagePolicyCopyAssociationsID) {
			var tId = $('#tagsList').val();
			if (tId <= 0) {
				tId = aData['Tag ID'] || 0;
			}

			request["commcell"] = aData['CommServ UniqueId'] || 0;
			request["copyID"] = aData['Copy ID'] || 0;
			request["tagId"] = tId;
			request["addDelete"] = 0;
		} else if (currentSelection === agentLevelAssociationsID) {
			var tId = $('#tagsList').val();
			if (tId <= 0) {
				tId = aData['Tag ID'] || 0;
			}
			request["agent"] = aData['Agent Type ID'] || 0;
			request["commcell"] = aData['CommServ UniqueId'] || 0;
			request["tagId"] = tId;
			request["addDelete"] = 0;
		}
		return request;
	}

	function editAssociationRowValue(nRow, commcells, currentassociationsTableId) {
		var jqTds = $('>td', nRow);
		if (currentassociationsTableId === subclientLevelbillingAssociationsID) {
			var clientgroups = '<div id="clientgroupsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="clientgroups" class="tagsInputs enterAction"><span data-searchid="clientgroups" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="clientgroups" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var clients = '<div id="clientsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="clients" class="tagsInputs enterAction"><span data-searchid="clients" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="clients" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var agents = '<div id="agentsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="agents" class="tagsInputs enterAction"><span data-searchid="agents" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="agents" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var instances = '<div id="instancesSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="instances" class="tagsInputs enterAction"><span data-searchid="instances" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="instances" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var backupsets = '<div id="backupsetsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="backupsets" class="tagsInputs enterAction"><span data-searchid="backupsets" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="backupsets" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var subclients = '<div id="subclientsSearchBox" class="searchBox tagsAssocInputsLast"><span class="ui-widget"><input type ="text" id="subclients" class="tagsInputs enterAction "><span data-searchid="subclients" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="subclients" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			subclients += '<span class="tagEditSpan">';
			subclients += '<span class="save sprite icon-save" title="Save"></span>';
			subclients += '<span class="cancel sprite icon-delete" title="Cancel"></span>';

			jqTds[0].innerHTML = commcells;
			jqTds[1].innerHTML = clientgroups;
			jqTds[2].innerHTML = clients;
			jqTds[3].innerHTML = agents;
			jqTds[4].innerHTML = instances;
			jqTds[5].innerHTML = backupsets;
			jqTds[6].innerHTML = subclients;

		} else if (currentassociationsTableId === storagePolicyCopyAssociationsID) {
			var storagePolicy = '<div id="storagePolicySearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="storagePolicy" class="tagsInputs enterAction"><span data-searchid="storagePolicy" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="storagePolicy" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			var copyName = '<div id="copyNameSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="copyName" class="tagsInputs enterAction"><span data-searchid="copyName" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="copyName" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			copyName += '<span class="tagEditSpan">';
			copyName += '<span class="save sprite icon-save" title="Save"></span>';
			copyName += '<span class="cancel sprite icon-delete" title="Cancel"></span>';

			jqTds[0].innerHTML = commcells;
			jqTds[1].innerHTML = storagePolicy;
			jqTds[2].innerHTML = copyName;
		} else if (currentassociationsTableId === agentLevelAssociationsID) {
			var agents = '<div id="agentsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="agents" class="tagsInputs enterAction"><span data-searchid="clientgroups" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="agents" class="clearIcon sprite icon-tagging-delete"></span></span></div>';

			if (agentsList) {
				var options = [];
				$.each(agentsList, function(index, agent) {
					var agentName = agent.name;
					/*
					 * if(agentName.length > SHOW_ENTITY_NAME_SIZE){ agentName = agentName.substr(0,
					 * SHOW_ENTITY_NAME_SIZE)+'...'; }
					 */
					options.push({
						label : agentName,
						value : agent.id
					});
				});
			}
			commcells = '<div id="commcellsSearchBox" class="searchBox"><span class="ui-widget"><input type ="text" id="commcells" class="tagsInputs enterAction"><span data-searchid="commcells" class="searchBoxIcon sprite icon-search_icon"></span><span data-searchid="commcells" class="clearIcon sprite icon-tagging-delete"></span></span></div>';
			commcells += '<span class="tagEditSpan">';
			commcells += '<span class="save sprite icon-save" title="Save"></span>';
			commcells += '<span class="cancel sprite icon-delete" title="Cancel"></span>';
			commcells += '</span>';

			jqTds[0].innerHTML = agents;
			jqTds[1].innerHTML = commcells;
			$("#agents").autocomplete({
				source : options,
				minLength : 0,
				position : {
                    my : "left top",
					at : "left bottom",
					of : "#agentsSearchBox",
					collision : "none"
				},
				open : function(event, ui) {
					$(this).autocomplete("widget").css("width", $(".searchBox").width() * 1.1);
					if (searchOpen && searchOpen.length > 0) {
						return false;
					}
					searchOpen = "agents";
				},
				close : function(event, ui) {
					searchOpen = null;
				},
				select : function(event, ui) {
					$("#agents").val(ui.item.label);
					$("#agents").data("labelId", ui.item.value);
					return false;
				}
			}).data("autocomplete")._renderItem = renderDropdown;
		}
		return;
	}
	function saveAssociationRowRequest(currentassociationsTableId, jqInputs) {
		var request = {};
		if (currentassociationsTableId == subclientLevelbillingAssociationsID) {
			request["commcell"] = $(jqInputs[0]).data("labelId") || 0;
			request["clientgroup"] = $(jqInputs[1]).data("labelId") || 0;
			request["client"] = $(jqInputs[2]).data("labelId") || 0;
			request["agent"] = $(jqInputs[3]).data("labelId") || 0;
			request["instance"] = $(jqInputs[4]).data("labelId") || 0;
			request["backupset"] = $(jqInputs[5]).data("labelId") || 0;
			request["subclient"] = $(jqInputs[6]).data("labelId") || 0;
			request["tagId"] = $('#tagsList').val() || 0;
			request["addDelete"] = 1;
		} else if (currentassociationsTableId == storagePolicyCopyAssociationsID) {
			request["commcell"] = $(jqInputs[0]).data("labelId") || 0;
			request["storagePolicyID"] = $(jqInputs[1]).data("labelId") || 0;
			request["copyID"] = $(jqInputs[2]).data("labelId") || 0;
			request["tagId"] = $('#tagsList').val() || 0;
			request["addDelete"] = 1;

		} else if (currentassociationsTableId === agentLevelAssociationsID) {
			request["agent"] = $(jqInputs[0]).data("labelId") || 0;
			request["commcell"] = $(jqInputs[1]).data("labelId") || 0;
			request["tagId"] = $('#tagsList').val() || 0;
			request["addDelete"] = 1;
			request["clientgroup"] = 0;
			request["client"] = 0;
			request["instance"] = 0;
			request["backupset"] = 0;
			request["subclient"] = 0;

		}
		return request;
	}
	function populateAssociationRowFromResp(currentassociationsTableId, oTable, nRow, dataSet) {
		var jqInputs = $('input', nRow);
		var aData = oTable.fnGetData(nRow);
		if (currentassociationsTableId === subclientLevelbillingAssociationsID) {
			aData['CommServ UniqueId'] = $(jqInputs[0]).data("labelId") || 0;
			aData['Client Group ID'] = $(jqInputs[1]).data("labelId") || 0;
			aData['Client ID'] = $(jqInputs[2]).data("labelId") || 0;
			aData['Agent Type ID'] = $(jqInputs[3]).data("labelId") || 0;
			aData['InstanceId ID'] = $(jqInputs[4]).data("labelId") || 0;
			aData['Backupset ID'] = $(jqInputs[5]).data("labelId") || 0;
			aData['App ID'] = $(jqInputs[6]).data("labelId") || 0;

			oTable.fnUpdate($("#commcells")[0].value, nRow, 1, false);
			oTable.fnUpdate($("#clientgroups")[0].value, nRow, 3, false);
			oTable.fnUpdate($("#clients")[0].value, nRow, 5, false);
			oTable.fnUpdate($("#agents")[0].value, nRow, 7, false);
			oTable.fnUpdate($("#instances")[0].value, nRow, 9, false);
			oTable.fnUpdate($("#backupsets")[0].value, nRow, 11, false);
			oTable.fnUpdate($("#subclients")[0].value, nRow, 13, false);
			if (dataSet.aaData[0]['Archive Enabled']) {
				oTable.fnUpdate(dataSet.aaData[0]['Archive Enabled'], nRow, 14, false);
			}
			if (dataSet.aaData[0]['OnePass Enabled']) {
				oTable.fnUpdate(dataSet.aaData[0]['OnePass Enabled'], nRow, 15, false);
			}
		} else if (currentassociationsTableId == storagePolicyCopyAssociationsID) {
			aData['CommServ UniqueId'] = $(jqInputs[0]).data("labelId") || 0;
			aData['Copy ID'] = $(jqInputs[2]).data("labelId") || 0;

			oTable.fnUpdate($("#commcells")[0].value, nRow, 1, false);
			oTable.fnUpdate($("#storagePolicy")[0].value, nRow, 2, false);
			oTable.fnUpdate($("#copyName")[0].value, nRow, 4, false);
			oTable.fnUpdate(dataSet.aaData[0]['Is Primary Copy'], nRow, 5, false);
			oTable.fnUpdate(dataSet.aaData[0]['Is Snap Copy'], nRow, 6, false);
			oTable.fnUpdate(dataSet.aaData[0]['Is Dedup Copy'], nRow, 7, false);
			oTable.fnUpdate(dataSet.aaData[0]['Library Name'], nRow, 8, false);
		} else if (currentassociationsTableId === agentLevelAssociationsID) {
			aData['Agent Type ID'] = $(jqInputs[0]).data("labelId") || 0;
			aData['CommServ UniqueId'] = $(jqInputs[1]).data("labelId") || 0;

			oTable.fnUpdate($("#agents")[0].value, nRow, 1, false);
			oTable.fnUpdate($("#commcells")[0].value, nRow, 3, false);

		}
		oTable.fnDraw();

	}
	function saveAssociationRow(currentassociationsTableId, oTable, nRow) {
		var request = {};
		var jqInputs = $('input', nRow);
		request = saveAssociationRowRequest(currentassociationsTableId, jqInputs);

		var configURL = cvUtil.getContextPath() +
				'/server/cloudsurvey.do?type=managebilling&action=updateAssociation&billingAssocitaionType=' +
				currentassociationsTableId + '&json=' + window.encodeURIComponent(JSON.stringify(request));

		report.mask(currentassociationsTableId);
		cvUtil.loadPageWithPOST(configURL,
				"",
				function(data) {
					report.unmask();
					if (data.tagName != undefined) {
						showMessage(cvUtil
								.cvLocalize("chargeback.billing.Tag_association_already_exists", data.tagName), true);
					} else if (data.result == true) {
						if (currentassociationsTableId == subclientLevelbillingAssociationsID &&
								data.subclientLevelbillingAssociations != undefined) {
							populateAssociationRowFromResp(currentassociationsTableId,
									oTable,
									nRow,
									data.subclientLevelbillingAssociations);
						} else if (currentassociationsTableId == storagePolicyCopyAssociationsID &&
								data.storagePolicyCopyAssociations != undefined) {
							populateAssociationRowFromResp(currentassociationsTableId,
									oTable,
									nRow,
									data.storagePolicyCopyAssociations);
						} else if (currentassociationsTableId == agentLevelAssociationsID &&
								data.agentLevelbillingAssociations != undefined) {
							populateAssociationRowFromResp(currentassociationsTableId,
									oTable,
									nRow,
									data.agentLevelbillingAssociations);
						}
						showMessage(cvUtil.cvLocalize("chargeback.billing.Added_new_billing_association"), false);
						associationEditing = null;
						disableButton(currentassociationsTableId + " #addAssociation_button", false);
					} else if (data.error != undefined && data.error != '') {
						showMessage(data.error, true);
					} else {
						showMessage(cvUtil.cvLocalize("chargeback.billing.Unable_to_add_billing_association"), true);
					}
				});
	}

	function restoreRow(oTable, nRow) {
		var aData = oTable.fnGetData(nRow);
		var jqTds = $('>td', nRow);

		for (var i = 0, iLen = jqTds.length; i < iLen; i++) {
			oTable.fnUpdate(aData[i], nRow, i, false);
		}

		oTable.fnDraw();
	}

	function validDiscount(id, percent) {
		var val = $("#" + id).val();
		if ($('#discountLevel').val() == -1) {
			return null;
		}
		if (val <= 0) {
			return cvUtil.cvLocalize("chargeback.billing.check.Value_should_be_greater_than_zero");
		}
		if (percent) {
			if (parseFloat(val) > 100) {
				return cvUtil.cvLocalize("chargeback.billing.check.Percentage_cannot_exceed_100");
			}
		} else {
			if (parseFloat(val) > 99999) {
				return cvUtil.cvLocalize("chargeback.billing.check.Value_cannot_exceed_99999");
			}
		}
		return null;
	}

	function validCost(id) {
		var cost = $("#" + id).val();
		if (id === 'price') {
			if (cost === 'Global Price') {
				return null;
			}
			if (cost === '' || (parseFloat(cost) != -1 && parseFloat(cost) < 0)) {
				return cvUtil.cvLocalize("chargeback.billing.check.Invalid_price");
			}
		}
		if (id == 'basePrice') {
			if ($('#baseLevel').val() == -1) {
				return null;
			}
			if (cost == 0) {
				return cvUtil.cvLocalize("chargeback.billing.check.Value_should_be_greater_than_zero");
			}
		}
		if (parseFloat(cost) < -2 || isNaN(cost)) {
			//$('#priceError').html('Invalid price.');
			return cvUtil.cvLocalize("chargeback.billing.check.Invalid_price");
		}
		var values = cost.split('.');

		if (values[1] != undefined && values[1].length > 3) {
			//$('#priceError').html("Price can only have 3 decimal places.");
			return cvUtil.cvLocalize("chargeback.billing.check.Price_can_only_have_3_decimal_places");
		} else if (parseFloat(cost) > 99999.999) {
			//$('#priceError').html("Price cannot exceed 99999.999");
			return cvUtil.cvLocalize("chargeback.billing.check.Price_cannot_exceed_99999_999");
		}

		return null;
	}

	function sortTagNames() {
		sortList(billingTagsList);
	}

	function updateBillingTags(id, val, deleteTag) {
		var deleteIndex = -1;
		for (var t = 0; t < billingTagsList.length; t++) {
			var tag = billingTagsList[t];
			if (id == tag.id) {
				if (deleteTag) {
					deleteIndex = t;
				} else {
					billingTagsList[t].name = val;
				}
				break;
			}
		}
		if (deleteIndex > -1) {
			billingTagsList.splice(deleteIndex, 1);
		}

		sortTagNames();

		enableAddAssociation(storagePolicyCopyAssociationsID);
		enableAddAssociation(subclientLevelbillingAssociationsID);
	}

	function convertMapToList(map) {
		var list = [];
		if (map) {
			$.each(map, function(key, val) {
				var temp = {};
				temp.id = key;
				temp.name = val;
				list.push(temp);
			});
			sortList(list);
		}
		return list;
	}

	function sortList(list) {
		if (list) {
			list.sort(function(a, b) {
				var nameA = a.name.toLowerCase();
				var nameB = b.name.toLowerCase();
				return (nameA < nameB) ? -1 : (nameA > nameB) ? 1 : 0;
			});
		}
	}

	function enableAddAssociation(sectionId) {
		var enable = false;
		if (billingTagsList && billingTagsList.length > 0) {
			enable = true;
			var tId = $("#" + sectionId + ' #tagsList').val();
			if (tId <= 0) {
				enable = false;
				$("#" + sectionId + " #addAssociation_button").attr('title',
						cvUtil.cvLocalize("chargeback.billing.Select_Billing_Tag_from_the_dropdown"));
			} else {
				$("#" + sectionId + " #addAssociation_button").attr('title',
						cvUtil.cvLocalize("chargeback.billing.Create_New_Billing_Association"));
			}

		} else {
			enable = false;
			$("#" + sectionId + " #addAssociation_button").attr('title',
					cvUtil.cvLocalize("chargeback.billing.Requires_at_least_one_Billing_Tag"));
		}

		if (enable == true) {
			disableButton(sectionId + " #addAssociation_button", false);
		} else {
			disableButton(sectionId + " #addAssociation_button", true);
		}
	}

	// $("body").on("keyup", "#billingTags .enterAction", function(e) {
	// 	if (tagEditing == undefined) {
	// 		return;
	// 	}

	// 	if (e.keyCode == 27) {//esc for cancel
	// 		$('#billingTags_table a.cancel').click();
	// 	} else if (e.keyCode == 13) {//enter for save
	// 		if (e.shiftKey) {
	// 			return false;
	// 		}
	// 		$('#billingTags_table a.save').click();
	// 	}
	// });

	// $("body").on("keyup", "#subclientLevelbillingAssociations .enterAction", function(e) {
	// 	if (associationEditing == undefined) {
	// 		return;
	// 	}

	// 	if (e.keyCode == 27) {//esc for cancel
	// 		$('#subclientLevelbillingAssociations_table a.cancel').click();
	// 	} else if (e.keyCode == 13) {//enter for save
	// 		$('#subclientLevelbillingAssociations_table a.save').click();
	// 	}
	// });

	// $("body").on("keyup", "#storagePolicyCopyAssociations .enterAction", function(e) {
	// 	if (associationEditing == undefined) {
	// 		return;
	// 	}

	// 	if (e.keyCode == 27) {//esc for cancel
	// 		$('#storagePolicyCopyAssociations_table a.cancel').click();
	// 	} else if (e.keyCode == 13) {//enter for save
	// 		$('#storagePolicyCopyAssociations_table a.save').click();
	// 	}
	// });

	// $("body").on("keyup", "#agentLevelbillingAssociations .enterAction", function(e) {
	// 	if (associationEditing == undefined) {
	// 		return;
	// 	}

	// 	if (e.keyCode == 27) {//esc for cancel
	// 		$('#agentLevelbillingAssociations_table a.cancel').click();
	// 	} else if (e.keyCode == 13) {//enter for save
	// 		$('#agentLevelbillingAssociations_table a.save').click();
	// 	}
	// });

	$("body")
			.on("click",
					function(e) {
						if (searchOpen &&
								searchOpen.length &&
								!($(e.target).hasClass("tagsInputs") ||
										$(e.target).closest(".ui-autocomplete").length > 0 || $(e.target)
										.data("searchid") == searchOpen)) {
							$(".tagsInputs").autocomplete("close"); //Close the opened autocomplete if we are clicking on anything other than the dropdown,serach bar or its search icon
						}

					})
}

function isValideNumber(evt) {
	var keyCode = (evt.which) ? evt.which : evt.keyCode;
	key = String.fromCharCode(keyCode);
	var regex = /[0-9]|\./;
	if (!regex.test(key) &&
	// Backspace and Del
	!(keyCode == 8 || keyCode == 46
	//left and right
	|| keyCode == 37 || keyCode == 39
	//Home and End
	|| keyCode == 35 || keyCode == 36
	//Tab and Shift+Tab
	|| keyCode == 9 || (evt.shiftKey && keyCode == 9))) {
		evt.returnValue = false;
		if (evt.preventDefault) {
			evt.preventDefault();
		}
	}
}

function showMessage(message, isError) {
	if (isError) {
		cvUtil.errorToast(message, null, null, true);
	} else {
		cvUtil.toast(message, null, null, true);
	}
}

$(document).ready(function() {
	ManageBillings();
});