var quarterlyBusinessDoc = {};

var supportAccountManager;
var technicalAccountManager;
var fromMonth;
var toMonth;

quarterlyBusinessDoc.fillDropdowns = function(last12monthsDropdown) {
	var monthName = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];
	var month = new Date().getMonth() - 1;
	var year = new Date().getFullYear();
	for (var i = 0; i < 12; i++) {
		if (month < 0) {
			month = 11;
			year--;
		}
		last12monthsDropdown.append("<option value=\"" + (i + 1) + "\">" + monthName[month] + " " + year + "</option>");
		month--;
	}
	$('#time-frame-inputs #from-time').val(12); // To make the default selection of from-time to the last option.
};
quarterlyBusinessDoc.initializeAndValidateInputs = function() {

	supportAccountManager = $("#support-account-manager").val();
	technicalAccountManager = $("#technical-account-manager").val();
	fromMonth = parseInt($("#from-time option:selected").val());
	toMonth = parseInt($("#to-time option:selected").val());

	if (supportAccountManager.length <= 0 || technicalAccountManager.length <= 0) {

		$('#validateTips').text(cvUtil.cvLocalize('error.input_cannot_be_blank'));
		$('#validateTips').addClass("validation-error");

		if (supportAccountManager.length <= 0) {
			quarterlyBusinessDoc.raiseErrorForComponent($("#support-account-manager"));
		}

		if (technicalAccountManager.length <= 0) {
			quarterlyBusinessDoc.raiseErrorForComponent($("#technical-account-manager"));
		}
		return false;
	}

	if (fromMonth < toMonth) {
		$('#validateTips').text(cvUtil.cvLocalize('From_Time_Greater_Than_To_Time'));
		$('#validateTips').addClass("validation-error");
		quarterlyBusinessDoc.raiseErrorForComponent($(".timeframeinput"));
		return false;
	}

	return true;
};

quarterlyBusinessDoc.exportDoc = function() {

	var EMEA_QBR_DOC_GUID = 'be6cde23-94ca-4670-94f6-00bf8b290289';
	var EXPORT_TYPE = 'customdoc';
	var FILE_PREFIX = 'EMEA QBR'; // for push service
	var subscriptionId = window.sessionStorage.getItem("export_subscriptionID"); // Push service subscription Id

	var link = "directDownload=false&commUniId=" + parent.cvUtil.getParameter('commUniId', "0") + "&ccGroupId=" +
			parent.cvUtil.getParameter('ccGroupId', "-1") + "&exportType=" + EXPORT_TYPE + "&documentGUID=" +
			EMEA_QBR_DOC_GUID + "&subscriptionID=" + subscriptionId + "&filePrefix=" + FILE_PREFIX;
	link = link + "&sam=" + supportAccountManager + "&tam=" + technicalAccountManager + "&fromMonth=" + fromMonth +
			"&toMonth=" + toMonth + "&companyId=" + parent.cvUtil.getParameter('companyId', 0);
	var csExportURL = parent.cvUtil.getContextPath() + '/reports/exp.do?' + link;

	cvUtil.getTopWindow().cvUtil.loadPageWithGET(csExportURL, ""); // Success and error handling done in push service

};

quarterlyBusinessDoc.raiseErrorForComponent = function(component) {

	component.addClass("ui-state-error");
	component.on('focus', function() {
		component.removeClass("ui-state-error");
	});
};

$(document).ready(function() {
	quarterlyBusinessDoc.fillDropdowns($(".last12months"));
	$(".qbrButtons").on('click', "#qbrSubmitButton", function(e) {
		if (quarterlyBusinessDoc.initializeAndValidateInputs()) {
			quarterlyBusinessDoc.exportDoc();
			cvUtil.closeModal();
		}
	});
	$(".qbrButtons").on('click', "#qbrCancelButton", function(e) {
		cvUtil.closeModal();
	});
	$("exportForm").bind("keypress", function(e) {
		if (e.keyCode == 13) {
			return false;
		}
	});
});