var quarterlyBusinessPpt = {};

var supportAccountManager;
var technicalAccountManager;
var fromMonth;
var toMonth;
var businessPeriod = "Quarterly";

quarterlyBusinessPpt.fillDropdowns = function(last12monthsDropdown) {
	var monthName = [];
	if (businessPeriod == "Quarterly") {
		monthName = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];
	} else {
		monthName = [
				"January",
				"February",
				"March",
				"April",
				"May",
				"June",
				"July",
				"August",
				"September",
				"October",
				"November",
				"December" ];
	}

	var month = new Date().getMonth() - 1;
	var year = new Date().getFullYear();
	last12monthsDropdown.empty();
	for (var i = 0; i < 12; i++) {
		if (month < 0) {
			month = 11;
			year--;
		}
		last12monthsDropdown.append("<option value=\"" + (i + 1) + "\">" + monthName[month] + " " + year + "</option>");
		month--;
	}
	$('#time-frame-inputs #from-time').val(12); // To make the default selection of from-time to the last option.
};
quarterlyBusinessPpt.initializeAndValidateInputs = function() {

	supportAccountManager = $("#support-account-manager").val();
	technicalAccountManager = $("#technical-account-manager").val();
	fromMonth = parseInt($("#from-time option:selected").val());
	toMonth = parseInt($("#to-time option:selected").val());

	if (supportAccountManager.length <= 0 || (technicalAccountManager.length <= 0 && businessPeriod != "Monthly")) {

		$('#validateTips').text(cvUtil.cvLocalize('error.input_cannot_be_blank'));
		$('#validateTips').addClass("validation-error");

		if (supportAccountManager.length <= 0) {
			quarterlyBusinessPpt.raiseErrorForComponent($("#support-account-manager"));
		}

		if (technicalAccountManager.length <= 0) {
			quarterlyBusinessPpt.raiseErrorForComponent($("#technical-account-manager"));
		}
		return false;
	}

	if (fromMonth < toMonth && businessPeriod == "Quarterly") {
		$('#validateTips').text(cvUtil.cvLocalize('From_Time_Greater_Than_To_Time'));
		$('#validateTips').addClass("validation-error");
		quarterlyBusinessPpt.raiseErrorForComponent($(".timeframeinput"));
		return false;
	}

	return true;
};
quarterlyBusinessPpt.exportPpt = function() {

	var APAC_QBR_DOC_GUID;
	var FILE_PREFIX;
	if (businessPeriod == "Quarterly") {
		APAC_QBR_DOC_GUID = '8c88f021-3665-4f4c-ac57-790a8cfd8fba';
		FILE_PREFIX = 'QBR PPT';
	} else {
		fromMonth = toMonth;
		APAC_QBR_DOC_GUID = '5d2e3f41-05d0-43b6-bc87-306f6f315976';
		FILE_PREFIX = 'ESP Monthly PPT';
	}
	var EXPORT_TYPE = 'customppt';

	var subscriptionId = window.sessionStorage.getItem("export_subscriptionID"); // Push service subscription Id

	var link = "directDownload=false&commUniId=" + parent.cvUtil.getParameter('commUniId', "0") + "&ccGroupId=" +
			parent.cvUtil.getParameter('ccGroupId', "-1") + "&exportType=" + EXPORT_TYPE + "&documentGUID=" +
			APAC_QBR_DOC_GUID + "&subscriptionID=" + subscriptionId + "&filePrefix=" + FILE_PREFIX;
	link = link + "&sam=" + supportAccountManager + "&tam=" + technicalAccountManager + "&fromMonth=" + fromMonth +
			"&toMonth=" + toMonth + "&companyId=" + parent.cvUtil.getParameter('companyId', 0) + "&businessPeriod=" +
			businessPeriod;
	var csExportURL = parent.cvUtil.getContextPath() + '/reports/exp.do?' + link;

	cvUtil.getTopWindow().cvUtil.loadPageWithGET(csExportURL, ""); // Success and error handling done in push service

};
quarterlyBusinessPpt.raiseErrorForComponent = function(component) {

	component.addClass("ui-state-error");
	component.on('focus', function() {
		component.removeClass("ui-state-error");
	});
};

$(document).ready(function() {
	quarterlyBusinessPpt.fillDropdowns($(".last12months"));
	$(".qbrButtons").on('click', "#qbrSubmitButton", function(e) {
		if (quarterlyBusinessPpt.initializeAndValidateInputs()) {
			quarterlyBusinessPpt.exportPpt();
			cvUtil.closeModal();
		}
	});
	$(".qbrButtons").on('click', "#qbrCancelButton", function(e) {
		cvUtil.closeModal();
	});
	$("exportForm").bind("keypress", function(e) {
		if (e.keyCode == 13) {
			return false;
		}
	});
	$('#report-type-inputs input[type=radio]').change(function() {
		if ($(this).val() == "Monthly") {
			businessPeriod = "Monthly";
			$('#technical-account-manager').hide();
			$('#tam').hide();
			$('#from-time').hide();
			$('#to-label').hide();
		} else {
			businessPeriod = "Quarterly";
			$('#technical-account-manager').show();
			$('#tam').show();
			$('#from-time').show();
			$('#to-label').show();
		}
		quarterlyBusinessPpt.fillDropdowns($(".last12months"));
	});
});