var reportSetting = (function() {
	var configureReport = {
		ACTION_GET_LIST : 0,
		ACTION_UPDATE : 1
	};
	var reportActions = {
		RETENTION_ENABLED : 1,
		STATUS_ENABLED : 2,
		DATEUNIT_Monthly : 4
	}
	function init() {
		this.report = new Reports.initReport({
			type : "survey",
			directPrint : true
		});
	}
	var parmaObj = {};
	function getListRequestUrl() {
		return cvUtil.getContextPath() + '/server/configureReportSettings.do?action=GET_LIST';
	}
	;

	function getUpdateURL() {
		return cvUtil.getContextPath() + '/server/configureReportSettings.do?action=UPDATE';
	}
	;

	function submitRequest(paramObj, callback) {
		var url = paramObj.URL;
		var action = paramObj.action;
		var tableIdSecletor = paramObj.tableIdSecletor;
		parmaObj = paramObj;

		var reportName = paramObj.reportName
		var span = document.createElement('span');
		span.innerHTML = paramObj.reportName;
		reportName = span.innerText;
		if (paramObj.status == "Enabled") {
			reportName = '<a target="_blank" href=' + window.location.origin + cvUtil.CONTEXT_PATH +
					paramObj.hyperlink + '>' + reportName + '</a>'
		}

		cvUtil.loadPageWithSessionCheck(url, paramObj, function(data1) {
			if (parmaObj.action == "UPDATE") {
				var logMessage = "Report Name=[" + parmaObj.reportName + "] Retention=[" + parmaObj.retention +
						"] Status=[" + parmaObj.status + "]";
				var toastMessage = cvUtil.cvLocalize("report_is_updated_successfully", reportName);
				cvUtil.toast(toastMessage);
				cvUtil.logUserAction("Metrics Reports Configuration", parmaObj.action, null, logMessage, "INFO");
			}
			if (!!callback && typeof callback == 'function') {
				callback(data1, tableIdSecletor);
			}
		}, function(xhr, ajaxOptions, thrownError, action) {
			if (parmaObj.action == "UPDATE") {
				cvUtil.logUserAction("Metrics Reports Configuration", parmaObj.action, null, "Report Name=[" +
						parmaObj.reportName + "] Message=[Update Failed]", "INFO");
			}
			var message = null; //decide based on action
			errFun(xhr, ajaxOptions, thrownError, message);
		}

		);
	}

	function errFun(xhr, ajaxOptions, thrownError, message) {
		if (xhr.status == 0 && xhr.statusText != "userAborted") {
			cvUtil.errorToast(cvUtil.cvLocalize("validate_Tomcat_services"), "");
		} else {
			cvUtil.errorToast(message + " " + thrownError);
		}
	}
	;

	configureReport.loadMetricsReports = function() {
		var paramObj = {};
		paramObj.URL = getListRequestUrl();
		init();
		submitRequest(paramObj, createMetricsReportsTable);
	};

	function createMetricsReportsTable(data) {
		var tableObj = getTableObj("reportdiv");
		createReportTable(data.DataTable, tableObj.div, tableObj.title);
	}

	function getTableObj(reportDiv) {
		var tableObj = {};
		if (reportDiv === "reportdiv") {
			tableObj.div = "reportdiv";
			tableObj.title = "Reports";
			tableObj.reportType = -1;
		}
		return tableObj;
	}
	function attachTableTagActions(tableIdSecletor) {
		$(tableIdSecletor + ' tbody tr').each(function() {
			var row = $(this);
			var rEvents = row.data("events");
			if (!rEvents || !rEvents.mouseover || !rEvents.mouseover.length) {
				row.mouseenter(function(event) {
					if (!$(".tagEditSpan").is(':visible')) {
						$(this).find(".tagActionIcons").css("display", "block")
					}
				});
				row.mouseleave(function(event) {
					$(this).find(".tagActionIcons").css("display", "none");
				});

			}
		});

		$(tableIdSecletor + ' span.edit').live('click', function(e) {
			e.preventDefault();
			e.stopImmediatePropagation();
			var nRow = $(this).parents('tr')[0];
			if (nRow.length <= 0) {
				return;
			}
			editTagRow(tableIdSecletor, nRow);
			tagEditing = nRow;
		});

		$(tableIdSecletor + ' span.save').live('click', function(e) {
			e.preventDefault();
			e.stopImmediatePropagation();
			var nRow = $(this).parents('tr')[0];
			var aData = $(tableIdSecletor).dataTable().fnGetData(nRow);
			validateRetention("#retention", aData['Flags<DONOTSHOW>']);
			var errors = $('.errorField', nRow);
			if (errors != undefined && errors.length > 0) {
				return;
			}
			if ($("#reportdiv_table_wrapper").hasClass("masked")) {
				return;
			}
			cvUtil.mask("#reportdiv_table_wrapper");
			// get report Id retention and status and post
			var jqTds = $('>td', nRow);
			var paramobj = {};
			var status = $(jqTds[3]).children("select").val();
			if (!status) {
				status = $(jqTds[3]).text();
			}
			paramobj.retention = $(jqTds[2]).children("input").val();
			paramobj.status = status.trim();
			paramobj.URL = getUpdateURL();
			paramobj.reportId = aData['ReportId<DONOTSHOW>'];
			paramobj.reportName = aData['Report Name<reportConfigurationActions>'];
			paramobj.hyperlink = aData['Hyperlink<DONOTSHOW>'];
			paramobj.tableIdSecletor = tableIdSecletor;
			paramobj.action = "UPDATE"
			submitRequest(paramobj, configureReport.loadMetricsReports);
		});

		$(tableIdSecletor + ' span.cancel').live('click', function(e) {
			e.preventDefault();
			e.stopImmediatePropagation();
			var nRow = $(this).parents('tr')[0];
			var oTable = $(tableIdSecletor).dataTable();
			var aData = oTable.fnGetData(nRow);
			var arrRtention = aData['Retention<DATEUNIT>'].split(" ");
			oTable.fnUpdate(arrRtention[0], nRow, 4, false);
			oTable.fnUpdate(aData['Status'], nRow, 6, false);
			oTable.fnDraw();
		});
		$(tableIdSecletor + ' input#retention').live('keypress', function(e) {
			if (e.keyCode == 13) {
				e.preventDefault();
				e.stopImmediatePropagation();
				$(tableIdSecletor + ' span.save').trigger("click");
			}
		});

	}

	function attachTableAction(div) {
		$("body").on("click", "#" + div + "_Filter .tableFilter", function(event) {
			event.stopImmediatePropagation();
			var gridId = $(this).attr('id');
			gridId = gridId.substring(0, gridId.lastIndexOf("_"));
			if ($("#" + gridId + "_FilterSelected").length > 0 && $("#" + gridId + "_filterText-0").is(":visible")) {
				$("#" + gridId + "_FilterSelected").val(true);
			}
			Reports.filterClick(gridId, 'toggle');
		});
	}

	function editTagRow(tableIdSecletor, nRow) {
		var oTable = $(tableIdSecletor).dataTable();
		var aData = oTable.fnGetData(nRow);
		$(".tagActionIcons").hide();
		var jqTds = $('>td', nRow);
		//check flags first
		var flag = aData['Flags<DONOTSHOW>'];
		if (flag & reportActions.RETENTION_ENABLED) {
			var arrRtention = aData['Retention<DATEUNIT>'].split(" ");
			jqTds[2].innerHTML = $("#retentionEditTemplate").html().trim();
			$(jqTds[2]).children('input').val(arrRtention[0]);//populate data
			$(jqTds[2]).children('span').text(arrRtention[1]);
		} else {
			$(jqTds[2]).attr("title", aData['RetentionText<DONOTSHOW>'])
		}

		if (flag & reportActions.STATUS_ENABLED) {
			jqTds[3].innerHTML = $("#statusEditTemplate").html().trim();
			$(jqTds[3]).children('select').val(aData['Status']);//populate data
		} else {
			$(jqTds[3]).attr("title", aData['StatusText<DONOTSHOW>'])
		}
		$(jqTds[3]).append($("#saveCancelEditOp").html().trim());

		$('#retention').focusout(function() {
			// validate retention
			validateRetention("#retention", flag);
		});

		$('#retention').focus();
	}

	function validateRetention(id, flag) {
		var retention = $(id).val();
		var regexPattern = /^\d+$/;
		if (!regexPattern.test(retention)) {
			markField(id, cvUtil.cvLocalize("Positive_Numeric_Value_Required"));//errorField
		} else if (retention > 2555 && ((flag & reportActions.DATEUNIT_Monthly) == 0)) {
			markField(id, cvUtil.cvLocalize("Retention_Period_Check"));//errorField
		} else if (retention > 85 && ((flag & reportActions.DATEUNIT_Monthly) != 0)) {
			markField(id, cvUtil.cvLocalize("Retention_Period_Check_Months"));//errorField
		} else if (retention < 1) {
			markField(id, cvUtil.cvLocalize("Retention_Period_Check_min"));
		} else {
			clearHighlight(id);
		}
	}

	function markField(fieldId, errorMessage) {
		$(fieldId).addClass("errorField");
		$(fieldId).attr('title', errorMessage);
		if (!$(fieldId).is(":focus")) {
			$(fieldId).focus();
		}
	}

	function clearHighlight(fieldId) {
		$(fieldId).removeClass("errorField");
		$(fieldId).attr('title', '');
	}
	function createReportTable(data, div, title) {
		var key = div;
		var elem = $('#' + key);
		var view = {};
		view.title = title;
		view.filters = true;
		$(elem).empty()

		if (data.iTotalDisplayRecords == 0) {
			return;
		}
		data.iDisplayLength = 50;
		$(elem).append(SurveyTemplates.makeReportTable(key, view));
		$("#" + key + "_table_length").remove();
		configureClientSideTableWithPaging(key, title, data, "");
		$(elem).find(".dynamicDropDown").hide();
		$("#" + key + " .rptTblBtnEncDiv").append($("#" + key + "_table_length"));
	}

	function configureClientSideTableWithPaging(gridid, title, data, nodata, opt) {

		nodata = nodata || cvUtil.cvLocalize("No_Data_Available");
		var options = opt || {};
		options.oColReorder = options.oColReorder || {};
		options.oColReorder.allowReorder = false;
		if ((!data.aoColumns || data.aoColumns.length == 0) && (!data.aoColumnDefs || data.aoColumnDefs.length == 0)) {
			console.error('No columns defined for the table, skipping datatables initialization');
			return;
		}
		$.each(data.aoColumns, function(intIndex, objValue) {
			objValue.fnRender = Reports.Renderers[objValue["rendererType"]];
		});

		updateMandatoryList(gridid, data.aoColumns);

		if ($('#' + gridid + CVTable.table).hasClass('initialized')) {
			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			dataTable.fnUpdate(data.aaData);
		} else {
			var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
			if (dataTabl) {
				$('#' + gridid + CVTable.table).removeClass('initialized');
				$('#' + gridid + CVTable.table).dataTable().fnClearTable();
				$('#' + gridid + CVTable.table).dataTable().fnDestroy();
				$('#' + gridid + CVTable.table).empty();

			}
			var ps = parseInt(cvUtil.getParameter("pageSize", 0));
			var lengthMenu = [ [ 10, 50, 100, 200, 500, -1 ], [ 10, 50, 100, 200, 500, "All" ] ];
			if (ps != 0) {
				if (lengthMenu[0].indexOf(ps) == -1) {
					lengthMenu[0].push(ps);
					lengthMenu[1].push(ps);
				}
			} else {
				ps = data.iDisplayLength;
			}
			var originalColumns = data.aoColumns;
			data.aoColumns[4].iDataSort = 9;
			$('#' + gridid + CVTable.table).addClass('initialized').dataTable({
				"aaData" : data.aaData,
				"aoColumns" : data.aoColumns,
				"aoColumnDefs" : data.aoColumnDefs,
				"iTotalRecords" : data.iTotalRecords,
				"iDisplayLength" : ps,
				"bUseRendered" : false,
				"bRetrieve" : true,
				"bServerSide" : false,
				"bDeferRender" : true,
				"bFilter" : true,
				"bAutoWidth" : false,
				"sDom" : options.sDom || "Rlfrtip",
				"bLengthChange" : true,
				"aLengthMenu" : lengthMenu,
				"bInfo" : true,
				"sPaginationType" : "input",
				"aaSorting" : data.aaSorting,
				"oColReorder" : options.oColReorder || {},
				"oLanguage" : {
					"oPaginate" : {
						"sFirst" : '&nbsp;',
						"sNext" : '&nbsp;',
						"sPrevious" : '&nbsp;',
						"sLast" : '&nbsp;'
					},
					"sLengthMenu" : "Show _MENU_"
				},
				"fnDrawCallback" : function(oSettings) {
					$('.dataTable tbody td').each(function(index) {
						$this = $(this);
						var titleVal = $this.text();
						if (titleVal != '') {
							$this.attr('title', titleVal);
						}
					});
					$('#' + gridid + CVTable.table).addClass('drawn');
					attachTableTagActions("#" + gridid + "_table");
				}
			});

			attachTableAction(gridid);
			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			if (!!dataTable.fnSettings()) {
				dataTable.fnSettings().originalColumns = originalColumns;
				dataTable.fnSettings().query = data.query;
			}
			$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
				$(value).attr('title', $(value).text());
			});

			$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
				$(value).attr('data-label',
						$('#' + gridid + CVTable.table + ' thead th')[index %
								($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
			});

			$.each(dataTable.fnGetNodes(), function(index, value) {
				$.each($('td', $(this)), function(childIndex, childValue) {

					if (data.aoColumns[childIndex]["rendererType"] != undefined) {
						var frRender = data.aoColumns[childIndex]["rendererType"];
						if (frRender.indexOf("editable") == 0) {
							var input = $(this).find('input');
							$(this).find('input').bind('keyup blur', function(event) {
								if (!event.keyCode || event.keyCode == 13) {
									var growth = input.val();
									$.each(capacity.units, function(index, unit) {
										if (endsWith(growth, index)) {
											if (!isNaN(growth.substr(0, growth.length - index.length))) //convert only if it is a number
											{
												growth = parseFloat(growth) * unit;
											}
											return false;
										}
									});
									if (isNaN(growth)) {
										return;
									} else {
										growth = Math.round(parseFloat(growth) * 100) / 100;
									}
								}
							});
						}
					}

				});
			});
		}
		$("#" + gridid + '_table_length').addClass('hideOnExportFriendly');
		$("#" + gridid).show();
	}

	function disableReportSearch() {
		saveAnalyticsEngine(-1);
	}
	function updateAnalyticsEngine() {
		var engineId = $('.analyticsEngine').val();
		if (engineId <= 0) {
			return;
		}
		saveAnalyticsEngine(engineId);
	}
	function saveAnalyticsEngine(engineId) {
		if (engineId === 0 || engineId < -1) {
			return;
		}
		var data = {};
		data.engineId = engineId;
		showProcessingMessage('.analyticsEngSetting');
		cvUtil.loadPageWithSessionCheck(cvUtil.getContextPath() + "/reports/saveAnalyticsEngine.do", data, function(
				resp) {
			hideProcessingMessage('.analyticsEngSetting');
			if (resp.errorMessage) {
				cvUtil.errorToast(resp.errorMessage);
			} else {
				if (engineId === -1) {
					$('.analyticsEngine').val(-1);
					$('.disable-reports-search').addClass('disabled');
					cvUtil.toast(cvUtil.cvLocalize('Successfully_disabled_reports_content_search'));
				} else {
					$('.disable-reports-search').removeClass('disabled');
					cvUtil.toast(cvUtil.cvLocalize('Successfully_updated_analytics_engine'));
				}
			}
		}, function(xhr, ajaxOptions, thrownError) {
			hideProcessingMessage('.analyticsEngSetting');
			cvUtil.errorToast($.trim(xhr.responseText), 30000);
		});
	}

	function getAnalyticsEngines() {
		var data = {};
		cvUtil.loadPageWithSessionCheck(cvUtil.getContextPath() + "/reports/getAnalyticsEngines.do", data, function(
				resp) {
			if (resp.searchServer) {
				var options = '';
				var selected = false;
				$.each(resp.searchServer, function(i, engine) {
					if (engine.isSelected) {
						selected = true;
					}
					options = options + '<option value="' + engine.client.clientId + '" ' +
							(engine.isSelected ? 'selected' : '') + '>' + engine.client.clientName + '</option>';
				});
				$('.analyticsEngine').empty();
				$('.analyticsEngine').append(options);
				if (!selected) {
					$('.analyticsEngine').val(-1);
					$('.disable-reports-search').addClass('disabled');
				} else {
					$('.disable-reports-search').removeClass('disabled');
				}
			} else {
				$('.disable-reports-search').addClass('disabled');
				console.log('Unable to get analytics engines');
			}
		}, function(xhr, ajaxOptions, thrownError) {
			cvUtil.errorToast($.trim(xhr.responseText), 30000);
		});
	}

	function showProcessingMessage(entityId) {
		$(entityId + ' span.processing-msg').removeClass('hide');
		$(entityId + ' span.icon-save').addClass("disabled");
	}

	function hideProcessingMessage(entityId) {
		$(entityId + ' span.processing-msg').addClass('hide');
		$(entityId + ' span.icon-save').removeClass("disabled");
	}

	function initComponents() {
		$('#saveAnalyticsEngine').on('click', function() {
			updateAnalyticsEngine();
		});
		$('.disable-reports-search').on('click', function() {
			disableReportSearch();
		});
	}
	configureReport.initComponents = initComponents;
	configureReport.getAnalyticsEngines = getAnalyticsEngines;
	return configureReport;

}).call(this);

$(document).ready(function() {
	reportSetting.initComponents();
	reportSetting.getAnalyticsEngines();
	if (surveyEnabled === 'true') {
		reportSetting.loadMetricsReports();
	}

});