if (typeof SurveyGlobals === 'undefined') {
	var SurveyGlobals = {};
}
//var unsupportedReports = [2, 6, 7, 9, 10, 13, 14, 38];
var surveyId = cvUtil.getParameter('surveyId');
var commUniId = cvUtil.getParameter('commUniId', 0);
var isTable = true;
var isChart = true;
var exportType = cvUtil.getParameter('exportType', "");
var paramId = "";
function Survey(callback) {

	this.report = new Reports.initReport({
		type : 'survey',
		idtomask : "content",
		directPrint : true
	});

	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		var surveyPages = [ "CommCellSurvey", "indcommcellsurvey" ];
		if (!surveyId) {
			for (var j = 0; j < surveyPages.length; j++) {
				if (window.location.href.indexOf(surveyPages[j]) != -1) {
					surveyId = 12;
					break;
				}
			}
		}
		this.requestString.surveyId = surveyId;
		if (commUniId != 0) {
			this.requestString.commUniId = commUniId;
		}

		// survey #60 will have an extra parameter to show the drill down client list for a Storage policy.
		if (surveyId && surveyId == 60) {
			var spName = cvUtil.getParameter("spName");
			if (spName) {
				this.requestString.spName = spName;
			}
		}

		// survey #104 will have an extra parameter to show the drill down client list for a Category.
		if (surveyId && surveyId == 104) {
			var entity = cvUtil.getParameter("entity");
			if (entity) {
				this.requestString.entity = entity;
			}
		}
		var dd = cvUtil.getParameter("dd");
		if (dd) {
			this.requestString.dd = dd;
		}
	};

	report.initComponents = function() {
		this.requestString.surveyId = surveyId;
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				Reports.exportToExcelPrefix = ($('#custName').text() ? $('#custName').text().replace(/\s-\s/g, "")
						.replace(/\s-&nbsp;/g, "").replace(/[\s\\\/:\\"*?<>|]+/g, "_") +
						"_" : "") +
						$.trim($('#surveyList option:selected').text()).replace(/\s/g, "_") || $("#welcomeMsg").text();
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				$(".chartTitleStyle").show();
				report.unmask();
			}, 100);
			report.unmask();
		});
		initEditCCName();
	};

	report.initComponentState = function() {

	};

	report.beforeLoadReport = function() {
		if (window.tempCvIdtoMask) {
			//			report.idtomask=window.tempCvIdtoMask;
			//			report.mask(report.idtomask, false);
		} else {
			report.mask("");
		}
	};

	report.getRequestUrl = function() {
		return "";
	};

	report.onLoadReport = function(data) {
	};

	report.updateRequestString = function() {
	};

	report.getExportFilePrefix = function() {
		return getExportFilePrefix();
	};

	report.tableDrawCallBack = function(oSettings) {
		var dataTable = $('#' + oSettings.sInstance).dataTable();
		$('.icon-check-circle-bulb', dataTable).each(function(index, ele) {
			$(this).closest('td').attr('title', decodeURIComponent($(this).data('healthdesc')));
		});
	};

	report.init();
	if (callback && typeof callback === 'function') {
		callback();
	}

	function getExportFilePrefix() {
		var surveyName = "";
		surveyName = $("#surveyName").text();

		var filePre = surveyName;//.replace(/ /g,"_");
		var unicID = cvUtil.getParameter('commUniId', 0);
		var customerName = "";
		//customerName = ($('#custName').text() ? $.trim($('#custName').text()).replace(/[ ]*-$/g, "") : "");
		var cname = $('ul.nav .nav-customer-title').attr('title');
		customerName = (cname ? $.trim(cname).replace(/[ ]*-$/g, "") : "");

		if (customerName != '') {
			filePre = customerName + ' - ' + filePre;
		} else {
			filePre = 'Worldwide - ' + filePre;
		}
		return filePre;
	}
	;
	// other functions --

	/*
	 * $(document).ajaxStart(function() { report.mask("content", false, "Loading..."); }).ajaxStop(function() {
	 * report.unmask("content"); });
	 */

	function initEditCCName() {
		$(document).on("click", ".dataTable .edit-ccname", function() {
			if ($('#ccTableWrapper_table input.new-cc-name:visible').length > 0) {
				return;
			}
			var elem = $(this);
			var tr = $(elem.closest('tr'));
			var tf = tr.find(".new-cc-name");
			var cancel = tr.find(".cancel-cc-name");
			var save = tr.find(".save-cc-name");
			var content = tr.find(".cc-name-content");
			elem.hide();

			content.hide();
			tf.select().show().focus();
			cancel.show();
			save.show();

		});

		$(document).on("click", ".dataTable .save-cc-name", function() {
			var elem = $(this);
			var tr = $(elem.closest('tr'));
			var editInput = tr.find(".new-cc-name");
			return saveCommcellName($(editInput));
		});

		$(document).on("click", ".dataTable .cancel-cc-name", function() {
			var elem = $(this);
			resetCommCellEditing(elem);
		});

		$(document).on("keypress", ".dataTable .new-cc-name", function(e) {
			if (e.keyCode === 13) {
				var elem = $(this);
				return saveCommcellName(elem);
			}
		});
	}

	function resetCommCellEditing(elem) {
		var tr = $(elem.closest('tr'));
		var editInput = tr.find(".new-cc-name");
		var content = tr.find(".cc-name-content");

		var oTable = elem.closest("table.dataTable").dataTable();
		var aData = oTable.fnGetData(tr[0]);
		var pos = oTable.fnGetPosition(tr[0]);
		oTable.fnUpdate(aData, pos, undefined, false);

		content.show();
		editInput.hide();
	}

	function saveCommcellName(elem) {
		//var elem = $(this);
		var displayName = $.trim(elem.val());
		var uniqueId = elem.data("uniqid");
		var name = elem.data('name');
		var oTable = elem.closest("table.dataTable").dataTable();
		var tr = elem.closest("tr");
		var content = tr.find(".cc-name-content");
		var aData = oTable.fnGetData(tr[0]);
		if (name != displayName) {

			// check for any html content in the input.
			if ($("<p>").html(displayName).text() != displayName) {
				return markField(elem, cvUtil.cvLocalize('CommCell_Name') + " " +
						cvUtil.cvLocalize('commCellNameChange.validation.html'));
			}

			var params = [];
			params.push({
				name : 'name-change-uniqid',
				value : uniqueId
			});
			params.push({
				name : 'name-change-displayname',
				value : displayName
			});
			var url = cvUtil.getContextPath() + '/server/commCellNameChange.do';
			cvUtil.loadPage(url, params, function(data) {
				if (data.errorMessage) {
					cvUtil.errorToast(data.errorMessage);
				} else {
					if (displayName.length > 0 && data.changedName !== displayName) {
						cvUtil.errorToast(cvUtil.cvLocalize('commCellNameChange.error'));
					} else {
						// update in the dom
						aData["CommCell Name"] = data.changedName;
						//aData["Status"] = "disabled";
						var pos = oTable.fnGetPosition(tr[0]);
						oTable.fnUpdate(aData, pos, undefined, false);

						// also update the search field.
						search({
							page : "commcellmonitoring.jsp"
						});

						cvUtil.toast(cvUtil.cvLocalize('commCellNameChange.success', name, data.changedName));
						elem.hide();
						content.show();
					}
				}

			}, function(xhr, ajaxOptions, thrownError) {
				cvUtil.handleError(xhr, ajaxOptions, thrownError);
				elem.hide();
				content.show();
			});
		} else {
			resetCommCellEditing(elem);
		}
		return true;
	}

	function markField(fieldId, errorMessage) {
		if (!errorMessage || errorMessage == '') {
			clearHighlight(fieldId);
			return true;
		}
		highlightField(fieldId, errorMessage);
		return false;
	}

	function clearHighlight(fieldId) {
		$(fieldId).removeClass("errorField");
		$(fieldId).attr('title', '');
	}

	function highlightField(fieldSelector, errorMessage) {
		$(fieldSelector).addClass("errorField");
		$(fieldSelector).attr('title', errorMessage);
		if (!$(fieldSelector).is(":focus")) {
			$(fieldSelector).focus();
		}
	}
}

$(document).ready(function() {
	$(".chartTitleStyle").hide();
	if (typeof loadData !== 'undefined') {
		Survey(loadData);
	} else {
		Survey();
	}

	$("body").on("click", ".moveToInternalLink", function(e) { //Handle Internal Anchor Links
		e.preventDefault();
		var moveToLocation = $(this).attr('href'); //Contains '#' as starting eg: #Client_Scale_Parameters_7
		$('html, body').animate({
			scrollTop : $(moveToLocation).offset().top
		}, 500);
	});

	var queryId = cvUtil.getParameterByName("surveyId");
	var commcellGroupId = cvUtil.getParameterByName("ccGroupId");
	var companyId = cvUtil.getParameterByName("companyId");
	var isReportMetaDataCall = cvUtil.getParameterByName("isReportMetadataCall");
	if ((isReportMetaDataCall == "" || isReportMetaDataCall == undefined) &&
			( (queryId == 12 && commUniId != 0 ) || queryId == 64 || queryId == 65 || queryId == 66 || queryId == 70 || queryId == 156 ||
					queryId == 96 || queryId == 39 || queryId == 105 || queryId == 161 || queryId == 181 ||
					queryId == 200 || queryId == 201 || queryId == 206 || queryId == 213 ||
					(queryId == 144 && !cvUtil.getParameter("database")) || queryId == 209)) {
		cvUtil.loadPageWithGET(cvUtil.getContextPath() + "/server/statusRow.do?queryId=" + queryId + "&commUniId=" +
				commUniId, null, function(data) {
			paramID = data.paramId;
			var good = data.GoodText.replace(/#1/g, data.Warning).replace(/#2/g, data.Critical);
			var warn = data.WarnText.replace(/#1/g, data.Warning).replace(/#2/g, data.Critical);
			var critical = data.CriticalText.replace(/#1/g, data.Warning).replace(/#2/g, data.Critical);
			if (data.Threshold != "") {
				$("#threshold").html(data.Threshold);
				$('#threshold').prop('title', data.Threshold);
			} else {
				$("#threshold").parent("td").remove();
			}

			var goodSpan = "", warnSpan = "", criticalSpan = "";

			var goodArr = good.split("$MULTICRIT$");
			if (goodArr.length > 1) {
				$.each(goodArr, function(i, val) {
					val = val.trim();
					goodSpan = "<span class='goodLabel'>" + cvUtil.cvLocalize("Good") +
							"</span><span class='goodVal' title='" + val + "'>" + val + "</span><BR>";
					$(".good").append($(goodSpan));

				});
			} else {
				goodSpan = "<span class='goodLabel'>" + cvUtil.cvLocalize("Good") +
						"</span><span class='goodVal' title='" + good + "'>" + good + "</span>";
				$(".good").append($(goodSpan));
			}

			var warnArr = warn.split("$MULTICRIT$");
			if (warnArr.length > 1) {
				$.each(warnArr, function(i, val) {
					val = val.trim();
					warnSpan = "<span class='warnLabel'>" + cvUtil.cvLocalize("Warning") +
							"</span><span class='warnVal' title='" + val + "'>" + val + "</span><BR>";
					$(".warn").append($(warnSpan));

				});
			} else {
				warnSpan = "<span class='warnLabel'>" + cvUtil.cvLocalize("Warning") +
						"</span><span class='warnVal' title='" + warn + "'>" + warn + "</span>";
				$(".warn").append($(warnSpan));
			}

			var criticalArr = critical.split("$MULTICRIT$");
			if (criticalArr.length > 1) {
				$.each(criticalArr, function(i, val) {
					val = val.trim();
					criticalSpan = "<span class='criticalLabel'>" + cvUtil.cvLocalize("Critical") +
							"</span><span class='criticalVal' title='" + val + "'>" + val + "</span><BR>";
					$(".critical").append($(criticalSpan));

				});
			} else {
				criticalSpan = "<span class='criticalLabel'>" + cvUtil.cvLocalize("Critical") +
						"</span><span class='criticalVal' title='" + critical + "'>" + critical + "</span>";
				$(".critical").append($(criticalSpan));
			}

			$("#statusRow").show();

		}, function() {
			console.log("status row data retreive failure");
		});
		$("body").on("click", ".healthStatus", function(e) {
			var url = $(this).find(".disableOnEmbedded").attr("href");
			url = url + paramID;
			$(this).find(".disableOnEmbedded").attr("href", url);
		});
	} else {
		$("#statusRow").remove();
	}
	if (queryId == 67 || queryId == 137) {
		report.scaleReport = true;
	}
});
