// ============================================================================
//  Copyright (c) CommVault Systems,
//  All Rights Reserved
//
//  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF CommVault Systems
//  The copyright notice above does not evidence any
//  actual or intended publication of such source code.
//
//  File name: survey_templates.js
//  Author: Hari Ravula
// ============================================================================
var SurveyTemplates = {
		getElement : function(key) {
			var elem = $('#'+key);
			return (elem.length !== 0) ? elem : undefined;
		},
		makeReportTable : function(key, view) {
			var tableMarkup = "";
			var elem = SurveyTemplates.getElement(key);
			if(view.sqlExportKey){
				Reports.reportTableMap[key]={};
				Reports.reportTableMap[key].gridid=key;
				Reports.reportTableMap[key].queryId=key;
				Reports.reportTableMap[key].title=view.title;
			}
			if(elem) {
				$(elem).addClass('clearFloat reportTable reportView '+ key +'_table').attr("comp", key).attr("data-component-type", "METRICS_TABLE");
			} else {
				tableMarkup = tableMarkup
				+ "<div id='{{id}}' comp='{{id}}' data-component-type='METRICS_TABLE' class='clearFloat reportTable reportView {{id}}_table'>";
			}
			if(view.title) {
				tableMarkup = tableMarkup
					+ "<h1 id='{{id}}_title_holder'>";
				if(view.collapsible) {
					tableMarkup = tableMarkup
					+ "<div class='arrowPlaceholder expand'></div>";
				}
				tableMarkup = tableMarkup
					+ "<span id='{{id}}_title' class='reportstabletitle'>{{title}}</span></h1>";
			}

			tableMarkup = tableMarkup + "<div class='rptTblBtnEncDiv'>";

			if(view.filters) {
				if(typeof view.colChooser === 'undefined' || view.colChooser == true) {
					tableMarkup = tableMarkup
					+ "<div id='{{id}}_holder' class='columnEditor dynamicDropDown hideOnExportFriendly'>";
					tableMarkup = tableMarkup
					+	"<input id='{{id}}_Button' class='AddorRemoveCols' type='button' value='' title='"+cvUtil.cvLocalize("Add_or_remove_columns")+"' />";
					tableMarkup = tableMarkup
					+	"<ul id='{{id}}_Colums' class='reportColums_container' ></ul>";
					tableMarkup = tableMarkup
					+ "</div>";
				}
				tableMarkup = tableMarkup
					+ "<div id='{{id}}_Filter' class='reports_Filter  hideOnExportFriendly'>";
				tableMarkup = tableMarkup
						+ "<input id='{{id}}_FilterButton' class='tableFilter hideOnExportFriendly' type='button' value='' title='"+cvUtil.cvLocalize("Filter_columns")+"' />";
				tableMarkup = tableMarkup
						+ "<input id='{{id}}_FilterSelected' type='hidden' />";
				tableMarkup = tableMarkup
					+ "</div>";
			}

			//column chooser should be allowed to be set without the filters
			if (view.colChooser && !  view.filters) {
				tableMarkup = tableMarkup
				+ "<div id='{{id}}_holder' class='columnEditor dynamicDropDown hideOnExportFriendly'>";
				tableMarkup = tableMarkup
				+	"<input id='{{id}}_Button' class='AddorRemoveCols' type='button' value='' title='"+cvUtil.cvLocalize("Add_or_remove_columns")+"' />";
				tableMarkup = tableMarkup
				+	"<ul id='{{id}}_Colums' class='reportColums_container' ></ul>";
				tableMarkup = tableMarkup
				+ "</div>";
			}

			if(view.exportExcel) {
				tableMarkup = tableMarkup
					+ "<div id='{{id}}_ExportExcel' class='reports_ExportExcel hideOnExportFriendly'>";
				tableMarkup = tableMarkup
					+ "<input id='{{id}}_ExportExcelButton' class='tableExportExcel' type='button' value='' title='"+cvUtil.cvLocalize("Export_to_CSV")+"' />";
				tableMarkup = tableMarkup
					+ "</div>";
			}
			if(view.alarm) {
				tableMarkup = tableMarkup
					+ "<div id='{{id}}_Alarm' class='reports_Alarm hideOnExportFriendly'>";
				tableMarkup = tableMarkup
					+ "<input id='{{id}}_AlarmButton' class='tableAlarm ' type='button' value='' title='"+cvUtil.cvLocalize("Add_Alert")+"' />";
				tableMarkup = tableMarkup
					+ "</div>";
			}

			if(view.exportExcel) {
				tableMarkup = tableMarkup
				+ "<div id='{{id}}_api' class='reports_api hideOnExportFriendly'>";
				tableMarkup = tableMarkup
				+ "<input id='{{id}}_apiButton' class='tableApi' type='button' value='' title='"+cvUtil.cvLocalize("DataSet.Preview.RESTAPI")+"' />";
				tableMarkup = tableMarkup
				+ "</div>";
			}

			var showTrend = false;//Disabled trend for v10.
			if(showTrend && view.trend && commUniId>0) {
				tableMarkup = tableMarkup
					+ "<div id='{{id}}_trend' class='reports_trend hideOnExportFriendly'>";
				tableMarkup = tableMarkup
					+ "<input id='{{id}}_TrendButton' class='tableTrend' type='button' value='' title='"+cvUtil.cvLocalize("Trend")+"' />";
				tableMarkup = tableMarkup
					+ "</div>";
			}


			tableMarkup = tableMarkup
				+ "</div><table id='{{id}}_table'></table>";

			if(view.urls && view.urls.length > 0) {
				var liString = "";
				$.each(view.urls, function(index, value){
					if((value.url !== "#" || value.url !== "javascript:void()")&& value.url.indexOf("http") == -1) {
						var curl = window.location.href;
						var url = "operations.jsp";
						if(value.url.indexOf("<ind>") != -1){
							url = "indcommcellsurvey.jsp";
							value.url = value.url.replace("<ind>","");
						} else if(value.url.indexOf("<wor>") != -1){
							url = "CommCellSurvey.jsp";
							value.url = value.url.replace("<wor>","");
						}
						if(curl.indexOf('operations.jsp') != -1) {
							if($.trim(window.location.search).length == 0) {
								curl = url + "?" + value.url;
						// } else if (window.location.search.indexOf("tenantName=") > -1) {
						// 	var URLParam = window.location.search;
						// 	tenantstart = URLParam.indexOf("tenantName=") + 9; //URLParam.indexOf("tenantName=") + "tenantName=".length
						// 	tenantend = URLParam.indexOf("&", tenantstart);
						// 	tenantend = tenantend > tenantstart ? tenantend : URLParam.length;
						// 	var tId = URLParam.substring(tenantstart, tenantend); //Extracted tenantName
						// 	if (tId > -1) {
						// 		var cId = tId.substring(0, tId.indexOf("_")); //Extracted commcellId
						// 		curl = url + window.location.search + "&" + "commUniId=" + cId + "&" +
						// 				value.url;
						// 	} else {
						// 		curl = url + window.location.search + "&" + value.url;
						// 	}
						// } 
							} else {
								curl = url + window.location.search + "&" + value.url;
							}
						}else {
							if($.trim(window.location.search).length == 0) {
								curl = curl + "?" + value.url;
							} else {
								curl = curl + "&" + value.url;
							}
						}
						value.css="followForExport";
						value.url = curl;
					}
					if(value.name == "Error Code"){
						//update help link
						var helpLink = docBaseURL.substr(0,docBaseURL.lastIndexOf("/"));
						var helplinkSubstring = helpLink.indexOf("release_9_0_0")!=-1?"/english_us/error_codes/error_codes.htm":"/article?p=error_codes/error_codes.htm";
						helpLink +=helplinkSubstring ;
						value.url=helpLink;
						value.target = "_blank";
						value.css="";
					}
					liString = liString + "<li><a href='"+ value.url +"' "
						+ (value.target ? "target='"+ value.target + "' " : "")
						+ (value.id ? "id = '" + value.id + "'" : "" ) + " class='"+value.css+"'>"+ value.name +"</a></li>";
				});
				tableMarkup = tableMarkup
						+ "<div id='{{id}}_links' class='{{id}}_links tableLinks'><ul>"+ liString +"</ul></div>";
			}

			if(view.buttons && view.buttons.length > 0) {
				var liString = "";
				$.each(view.buttons, function(index, value){
					liString = liString + "<li><button "
						+ (value.id ? "id = '" + value.id + "'" : "" ) + ">"+ value.text +"</a></li>";
				});
				tableMarkup = tableMarkup
						+ "<div id='{{id}}_links' class='{{id}}_links tableLinks'><ul>"+ liString +"</ul></div>";
			}

			tableMarkup = tableMarkup
				+ "<div class='clearFloat'></div>";

			if(!elem) {
				tableMarkup = tableMarkup
					+ "</div>";
			}
			var html = Mustache.render(tableMarkup, {"id": key, "title" : view.title});

			var exportType = cvUtil.getParameter("exportType", "");
			if (exportType.toLowerCase() === 'email_body') {
				addTableMetaDataForExport();
			}

			if(elem) {
				$("#" + key).append(html);
				return "";
			} else {
				return html;
			}

			function addTableMetaDataForExport() {
				window.reportMetaData = window.reportMetaData || {};

				if (!window.reportMetaData.tableMetaData) {
					window.reportMetaData.tableMetaData = {};
				}
				window.reportMetaData.tableMetaData[key] = {
						"tableWrapperDivID": key + "_table_wrapper",
						"rowSelector" : "tbody tr",
						"class" :{
								"odd" : "odd",
							    "even": "even",
							    "generic": ""
						}
				};
			}
		},

		makeChart : function(key, view) {

           var chartMarkup = "";
			var elem = SurveyTemplates.getElement(key);
			if(elem) {
				$(elem).addClass('clearFloat reportChart reportView '+ key +'_chart');
			} else {
				chartMarkup = chartMarkup
				+ "<div id='{{id}}' comp='{{id}}' data-component-type='METRICS_CHART' class='clearFloat chartholder reportChart reportView {{id}}_chart'>";
			}

			if(view.title) {
				chartMarkup = chartMarkup
					+ "<h1>";
				if(view.collapsible) {
					chartMarkup = chartMarkup
					+ "<div class='arrowPlaceholder expand'></div>";
				}
				chartMarkup = chartMarkup
					+ "<span id='{{id}}_title' class='reportstabletitle reportscharttitle'>{{title}}</span></h1>";
			}
			chartMarkup = chartMarkup
				+ "<div id='{{id}}_container' class='chartbody' style='vertical-align:middle'></div>";





			if(view.urls && view.urls.length > 0) {
				var liString = "";
				$.each(view.urls, function(index, value){
					if(value.url.indexOf("http") == -1) {
						var curl = window.location.href;
						if(curl.indexOf('operations.jsp') != -1) {
							if($.trim(window.location.search).length == 0) {
								curl = "operations.jsp" + "?" + value.url;
							} else {
								curl = "operations.jsp" + window.location.search + "&" + value.url;
							}
						} else {
							if($.trim(window.location.search).length == 0) {
								curl = curl + "?" + value.url;
							} else {
								curl = curl + "&" + value.url;
							}
						}
						value.url = curl;
						value.css="followForExport";
					}
					if(value.name == "Error Code"){
						var helpLink = docBaseURL.substr(0,docBaseURL.lastIndexOf("/"));
						var helplinkSubstring = helpLink.indexOf("release_9_0_0")!=-1?"/english_us/error_codes/error_codes.htm":"/article?p=error_codes/error_codes.htm";
						helpLink += helplinkSubstring;
						value.url=helpLink;
						value.target = "_blank";
						value.css="";
					}
					liString = liString + "<li><a href='" + value.url + "' "
						+ (value.target ? "target='"+ value.target + "' " : "")
						+ (value.id ? "id = '" + value.id + "'" : "" ) + " class='"+value.css+"'>"+ value.name +"</a></li>";
				});
				chartMarkup = chartMarkup
						+ "<div id='{{id}}_links' class='{{id}}_links tableLinks'><ul>"+ liString +"</ul></div>";
				chartMarkup = chartMarkup
					+ "<div class='clearFloat'></div>";

			}
			if(!elem) {
				chartMarkup = chartMarkup
					+ "</div>";
			}
			var html = Mustache.render(chartMarkup, {"id" : key, "title": view.title});

			if(elem) {
				$(elem).append(html);
				return "";
			} else {
				return html;
			}


		},

		makeComplexView : function(key, view) {
			var tmplt = "";
			var elem = SurveyTemplates.getElement(key);
			if(elem) {
				$(elem).addClass('clearFloat reportCView reportView '+ key +'_cview');
			} else {
				tmplt = tmplt
					+ "<div id='{{id}}' class='clearFloat reportCView reportView {{id}}_cview'>";
			}

			if(view.title) {
				tmplt = tmplt
					+ "<h1>";
				if(view.collapsible) {
					tmplt = tmplt
						+ "<div class='arrowPlaceholder expand'></div>";
				}
				tmplt = tmplt
					+ "<span id='{{id}}_title' class='reportscviewtitle' comp='{{id}}_title' data-component-type='EB_HTML'>{{title}}</span></h1>";
			}
			if(!elem) {
				tmplt = tmplt
					+ "</div>";
			}

			var html = Mustache.render(tmplt, {"id" : key, "title": view.title});

			if(elem) {
				$(elem).append(html);
				return "";
			} else {
				return html;
			}
		},

		makeSurveyList : function(key, groups, opts) {
			var html = "";
			var sArray;
			var sobj;
			var href = "#";
			var page;

			for( grp in groups ) {
				sArray = groups[grp];
				html = html + "<li class='survey-category' >" + grp + "</li>";
				for(var i=0; i<sArray.length; i++) {
					sobj = sArray[i];

					if(sobj.type === 'ID') {
						var curl = window.location.href;

						var params = '?';
                        var commUniId = cvUtil.getParameter("commUniId", -1);
                        if(commUniId!=-1)
                        	params='?commUniId='+commUniId + '&';
//                        if(params.indexOf("type=") !== -1) {
//                              params = params.replace(/type=\d*/, '');
//                        }
                        if( grp === 'Activity') {
                              // page should be operations.jsp
                              page = "operations.jsp"  + params;
                        } else {
                              // same otherwise.
                              if(curl.indexOf("commUniId") !== -1) {
                                    page = "indcommcellsurvey.jsp" + params;
                              } else {
                                    page = "CommCellSurvey.jsp" + params;
                              }
                        }
						href = page + 'surveyId='+sobj.value;
						html = html + "<li class='survey-list-item' ><a href='" + href + "' >" + sobj.name + "</a></li>";
					}
					else if(sobj.type === 'URL') {
						html = html + "<li class='survey-list-item'><a href='" + sobj.value + "'>" + sobj.name + "</a></li>";
					}
					else if(sobj.type === 'PARAMS') {
						if(opts) {
							if(opts.page) {
								if(sobj.value.indexOf("?") === 0) {
									href = opts.page + sobj.value;
								} else {
									href = opts.page + "?" + sobj.value;
								}
							}
						}
						html = html + "<li class='survey-list-item' ><a href='" + href + "' >" + sobj.name + "</a></li>";
					}
				}
			}

			return html;
		},

		makeAlarmConditionRow : function(obj, opts) {
			var html = "";
			var conditionArray = [];
		var operatorsHtml = '<select id="gen-opSelect" class="opSelect gen-opSelect margin-left-10 input-control"></select>';
			if(obj.fromManage && !obj.editCriteriaSet) {
				var alarmURL = obj.alarmURL;
				var oper = " is ";
				if(!!alarmURL) {
					var reqObj = {};
					var searchPart = alarmURL.substring(alarmURL.indexOf("?") +1);
					urlToRequest(searchPart, reqObj);
					if(obj.type == Alarms.TYPE_HEALTH ) {
						var paramId = reqObj.paramId;
						var paramValue = reqObj.paramValue;
						var paramStatus = reqObj.paramStatus;
						var paramName = reqObj.paramName;
						var operator = reqObj.op;
						var template = "";
						if(!paramStatus) {
							template = obj.description;
							if(operator == -1) {
								oper = " is ";
							} else if(operator == 0) {
								oper = " less than ";
							} else if(operator == 1) {
								oper = " more than ";
							} else if(operator == 2) {
								oper = " equal to ";
							} else if(operator == 3) {
								oper = " contains ";
							} else if(operator == 4) {
								oper = " within last ";
							} else if(operator == 5) {
								oper = " beyond last ";
							} else if(operator == 6) {
								oper = " within next ";
							} else if(operator == 7) {
								oper = " beyond next ";
							}else if(operator == 8) {
								oper = " Not Equal To ";
							}else if(operator == 9) {
								oper = " Is Empty ";
							}else if(operator == 10 ) {
								oper = " Not Empty ";
							}else if(operator == 11 ) {
								oper = " Not Contains ";
							}
							conditionArray.push({"template":template, "oper" : oper, "paramValue": paramValue, "paramStatus":""});
						} else {
							conditionArray.push({"paramName":paramName, "oper": oper, "paramStatus":paramStatus});
						}

						return JSON.stringify(conditionArray);
					} else if(obj.type == Alarms.TYPE_GENERAL) {
						var filteredTable = reqObj.filteredTable[0];
						var filterClause = reqObj[filteredTable].filterClause;
						reqObj.isOr = (reqObj.isOr == "true" ? true : false);
						var andOr = "";
						if(reqObj.isOr) {
							// add or
							andOr = " or ";
						} else {
							// add and
							andOr = " and ";
						}

						filterClause = filterClause.slice(0, -1);	// removing the last semi-colon.

						var filters = "";
						filters = filterClause.split(/;?([^;-]+)-(LIKE)-/).slice(1); 		// removing the empty sting that is matched
						var i = 0;

						var criteriaCols = [];
						for(i=0; i<filters.length; i+=3) {
							var filteredColumn = filters[i];
							//var operator = filters[i+1];
							var search = filters[i+2].toLowerCase();
							search=$.trim(search);
							if(search.length == 0) {
								continue;
							}
							var tokens = [];
							if(search.indexOf(" or ") > -1) {
								tokens = search.split(' or ');
							} else if(search.indexOf(" || ") > -1) {
								tokens = search.split(' || ');
							} else if(search.indexOf(" and ") > -1) {
								tokens = search.split(' and ');
							} else if(search.indexOf(" && ") > -1) {
								tokens = search.split(' && ');
							} else {
								tokens.push(search);
							}
							for(var ti=0; ti<tokens.length; ti++) {
								var condition = tokens[ti];
								var operator = "";
								search = $.trim(condition);

								if(search != "") {
									if(search.indexOf('>=')==0||search.indexOf('<=')==0 || search.indexOf('<>')==0) {
										operator=search.substring(0, 2);
										search=$.trim(search.substring(2));
									}
									else if(search.indexOf('>')==0||search.indexOf('<')==0||search.indexOf('=')==0) {
										operator=search.substring(0, 1);
										search=$.trim(search.substring(1));
									} else if(search.indexOf('inlast')==0||search.indexOf('innext')==0) {
										operator=search.substring(0, 6);
										search=$.trim(search.substring(6));
									} else if(search.indexOf('beyondlast')==0||search.indexOf('beyondnext')==0) {
										operator=search.substring(0, 10);
										search=$.trim(search.substring(10));
									}else if(search.indexOf('isempty')==0 || search.indexOf('notlike')==0) {
										operator=search.substring(0, 7);
										search=$.trim(search.substring(7));
									}else if(search.indexOf('notempty')==0) {
										operator=search.substring(0, 8);
										search=$.trim(search.substring(8));
									}

									if(operator=='') {
										oper = " contains ";
									}
									else if(operator == "<") {
										oper = " less than ";
									} else if(operator == ">") {
										oper = " more than ";
									} else if(operator == "=") {
										oper = " equal to ";
									} else if(operator == "inlast") {
										oper = " in last ";
									} else if(operator == "beyondlast") {
										oper = " beyond last ";
									} else if(operator == "innext") {
										oper = " in next ";
									} else if(operator == "beyondnext") {
										oper = " beyond next ";
									}else if(operator == "<>") {
										oper = " Not Equal To ";
									}else if(operator == "isempty") {
										oper = " Is Empty ";
										search ="";
									}else if(operator == "notempty") {
										oper = " Not Empty ";
										search ="";
									}else if(operator == "notlike") {
										oper = " Not Contains ";
									}

									/*
									if((tokens.length > 1 && (ti != tokens.length - 1))
											|| (ti == tokens.length - 1) && (i != filters.length - 4)) {
										if(reqObj.isOr) {
											// add or
											andOr = " or ";
										} else {
											// add and
											andOr = " and ";
										}
									}
									*/
									if(opts && opts.forDescription) {
										 var col = $.grep(opts.oSettings.aoColumns, function(e, ndx) {
											return e.mDataProp == filteredColumn;
										});
										 filteredColumn = col[0].sTitle;
									}
									conditionArray.push({"filteredColumn" : filteredColumn, "oper" : oper, "search" : search, "join" : andOr});
 								}
							}
						}
					}
				}
			return JSON.stringify(conditionArray);
		} else {
			if (obj.type == Alarms.TYPE_HEALTH) {
				var healthParamObj = Alarms.getHealthParams(obj);
				return SurveyTemplates.constructConditionHTML(healthParamObj.DescriptionText);
			} else if (obj.type == Alarms.TYPE_GENERAL) {
				var ocNdx = 0;
				for (; ocNdx < obj.originalColumns.length; ocNdx++) {
					var oCol = obj.originalColumns[ocNdx];
					oCol.index = ocNdx;
					oCol.visible = function() {
						var dataTable = $('#' + obj.gridId + CVTable.table).dataTable();
						var oSettings = dataTable.fnSettings();
						for (var i = 0; i < oSettings.aoColumns.length; i++) {
							if (this.sTitle == "Dashboard") {
								this.bVisible = false;
								return false;
							}
							if (this.sTitle == "" && this.rendererType == "selectionRenderer") {
								this.bVisible = false;
								return false;
							}

							if (this.sTitle == oSettings.aoColumns[i].sTitle) {
								this.bVisible = oSettings.aoColumns[i].bVisible;
								return oSettings.aoColumns[i].bVisible;
							}
						}
						return true;
					};
				}

				var colOptList = "{{#originalColumns}}{{#visible}}<option data-title='{{sTitle}}' data-renderer='{{rendererType}}' "
						+ " data-index='{{index}}' data-sqltype='{{sqlType}}' data-stype='{{sType}}'>{{{sTitle}}}</option>{{/visible}}{{/originalColumns}}";

				html = '<li class="editable-alarm gen-alarm-row"><div id="paramsDiv"><select class="gen-columnSelect input-control" >' +
						colOptList +
						'</select>'
						//+ operatorsHtml + '<input class="gen-thresholdValue" type="text" /></li>';
						+
						operatorsHtml +
						'<input class="gen-thresholdValue input-control padding-bottom-10 margin-left-10 input-control" type="text" /></div><div id="removeConditionDiv"> <div id="removeCondition"> <span>&times;</span> </div> </div></li>';
				//						'<li><button class="addNewCondition" title="Add New Condition">Add Condition</button></li>';
				html = Mustache.render(html, obj);
			}
		}

		return html;
	},
	constructConditionHTML : function(tmplt, id) {
		var eleId = "";
		var criteriaId = 0;
		if (id != undefined) {
			eleId = "_" + id;
			criteriaId = id;
		}
		var opStr = '<select id="opSelect" class="health-opSelect" disabled="disabled">'
				+ '<option value="0" selected>Less Than</option>'
				+ '<option value="1">More Than</option><option value="2">Equal To</option>'
				+ '<option value="8">Not Equal To</option></select>';
		html = '<input type="radio" name="configureBy" id="byValue' + eleId + '" value="byValue' + eleId +
				'" data-criteria-id=' + criteriaId + '  />';

		html = html + "<label for='byValue" + eleId + "'>";
		if (tmplt.indexOf("##op##") > -1) {
			tmplt = tmplt.replace("##op##", "</label>" + opStr);
			tmplt = tmplt.replace("##val##",
					'<input id="thresholdValue" class="input-control" type="text" disabled="disabled"/>');
		} else {
			tmplt = tmplt.replace("##val##",
					'</label><input id="thresholdValue" class="input-control" type="text" disabled="disabled"/>');
		}
		html = html + tmplt;
		return html;
	}

};
