function resetCharts() {
	$.each($("div[id$=Container]"), function() {
		$(this).show();
		$(this).siblings('canvas').hide();
	});
}

function buildCanvas() {
	$("#chartPanel > .showifnodata").hide();
	$("#chartPanel > .hideifnodata").hide();
	$("#ContentWrapper").mask(" ");
	$("#JobSummary").mask(" ");
	$('#indent-1').mask();
	$("#searchdiv").hide();
	var filePre = "PostUpgradeCheckReport";
	var unicID = cvUtil.getParameter('ccId', 0);
	if (unicID > 0) {
		filePre = unicID + '_' + filePre;
	}
	var customename = clientname;
	if (customename != '') {
		filePre = customename + '_' + filePre;
	}
	buildChartOnCanvas();
	var element = document.getElementById("hc-content");
	element = document.body;
	h2cSelector = [ element ];
	setTimeout(function() {
		$(h2cSelector).html2canvas(
				{
					flashcanvas : "../js/flashcanvas.min.js",
					logging : false,
					profile : false,
					useCORS : false,
					onrendered : function(canvas) {
						var $canvas = $(canvas);
						// test if canvas is read-able
						try {
							dataURL = $canvas[0].toDataURL();
							var exportUrl = '';
							if (document.URL.toString().indexOf("?") == -1) {
								exportUrl = document.URL + "?isExport=true";

							} else {
								exportUrl = document.URL + "&isExport=true";
							}

							cvUtil.loadPageWithGET(cvUtil.getContextPath()
									+ '/server/exp.do?directDownload=false&filePrefix=' + filePre
									+ '&pageSize=-1&exportType=pdf', {
								url : exportUrl
							}, function(data1) {

								if (!data1 || data1 == "" || data1 == 'null')
									alert('Something went wrong while exporting the report.'); //localize
								else {
									$("#fileNameToDownload").val(window.encodeURIComponent(data1));
									$("#exportPDFForm").submit();
								}

								$("#ContentWrapper").unmask();
								$("#JobSummary").unmask();
								$("#chartPanel > .showifnodata").hide();
								$("#chartPanel > .hideifnodata").show();
								$('#indent-1').unmask();
								$("#searchdiv").show();
							});

							resetCharts();
						} catch (e) {
							if ($canvas[0].nodeName.toLowerCase() === "canvas") {
								// TODO, maybe add a bit less offensive way to present this, but still something that can easily be noticed
								alert("Export failed. IE version < 9.0 is not supported.");
							}
						}
					}
				});
	}, 100);

}

function buildChartOnCanvas() {
	$.each($("div[id$=Container]"), function() {
		var svg = $(this).html();
		if ($.browser.msie) {
			svg = svg.replace("xmlns=\"http://www.w3.org/2000/svg\"", "");
			svg = svg.toString();
		}
		if ($(this).siblings('canvas')[0]) {
			$(this).hide();
			$(this).siblings('canvas').show();
			canvg($(this).siblings('canvas')[0], $.trim(svg));
		}
	});
}

var eventsAdded = false;
function addExpandablePanels() {
	var isExport = cvUtil.getParameter("isExport", false);

	if (!isExport && !eventsAdded) {
		$("#hc-content")
				.addClass("ui-accordion ui-accordion-icons ui-widget ui-helper-reset")
				.find("h3")
				.addClass("ui-accordion-header ui-helper-reset ui-state-default ui-corner-top ui-corner-bottom")
				.hover(function() {
					$(this).toggleClass("ui-state-hover");
				})
				.prepend('<span class="ui-icon ui-icon-triangle-1-e"></span>')
				.click(
						function() {
							$(this)
									.toggleClass(
											"ui-state-default ui-accordion-header-active ui-state-active ui-state-default ui-corner-bottom")
									.find("> .ui-icon").toggleClass("ui-icon-triangle-1-e ui-icon-triangle-1-s").end()
									.next().slideToggle().toggleClass("ui-accordion-content-active");
							return false;
						}).next().addClass("ui-accordion-content  ui-helper-reset ui-widget-content ui-corner-bottom");
		//.hide();
		//$("#hc-content h3").click();
		$("#hc-content").addClass("ui-accordion ui-accordion-icons ui-widget ui-helper-reset").find("h3").toggleClass(
				"ui-state-default ui-accordion-header-active ui-state-active ui-state-default ui-corner-bottom").find(
				"> .ui-icon").toggleClass("ui-icon-triangle-1-e ui-icon-triangle-1-s").end().next().slideToggle()
				.toggleClass("ui-accordion-content-active");
		eventsAdded = true;
	} else {
		$("#hc-content").addClass("ui-accordion ui-accordion-icons ui-widget ui-helper-reset").find("h3").css(
				"color",
				"#333333 !important");
	}
}

function UpgradeCheckReport() {
	colorFailed = "#FF3030"; //Red
	colorFailed3d = "#B22222";
	colorCompleted = "#71C42B"; //Green
	colorCompleted3d = "#4E891E";

	colors = [ colorFailed, colorCompleted ]; //colorCompletedError, colorCompletedWarning,colorActive,colorDelayed, colorKilled, colorNoRun];
	colors3d = [ colorFailed3d, colorCompleted3d ]; //colorCompletedError3d, colorCompletedWarning3d,colorActive3d,colorDelayed3d, colorKilled3d, colorNoRun3d];

	$.ajax({
		url : 'upgradechck.do',
		data : {
			days : $.trim($('#lastN').val()),
			ccId : cvUtil.getParameter('ccId', "")
		},
		type : 'GET',
		dataType : 'json',
		beforeSend : function() {
			$("#chartPanel > .showifnodata").hide();
			$("#chartPanel > .hideifnodata").hide();
			$("#ContentWrapper").mask(" ");
			$("#JobSummary").mask(" ");
		},
		error : function(data) {
			$("#ContentWrapper").unmask();
			$("#JobSummary").unmask();
			$("#chartPanel > .showifnodata").show();
			$("#chartPanel > .hideifnodata").hide();
			alert(data.error);
		},
		success : function(data) {

			if (data.error) {
				$("#ContentWrapper").unmask();
				$("#JobSummary").unmask();
				$("#chartPanel > .showifnodata").show();
				$("#chartPanel > .hideifnodata").hide();
				$("#noDataNotificationPanel").html(data.error).show();
				return;
			}
			$("#noDataNotificationPanel").hide();
			$("#ContentWrapper").unmask();
			$("#upgradedate").text(data.UpgradeDate);

			if (data == 'null' || data == null) {
				$("#chartPanel > .showifnodata").show();
				$("#chartPanel > .hideifnodata").hide();
				return;
			}

			chartData_pre = data["prechart"]["points"];
			var rows = 0;
			var rowsTotal = 0;
			while (rows < chartData_pre.length) {
				rowsTotal += chartData_pre[rows].y;
				rows++;
			}

			if (rowsTotal <= 0) {
				$("#chartPanel > .showifnodata").show();
				$("#chartPanel > .hideifnodata").hide();
			} else {
				$("#chartPanel > .showifnodata").hide();
				$("#chartPanel > .hideifnodata").show();
				createRaphaelchart(chartData_pre, "piechartcontainer_pre");
			}

			$("#chartTitle_pre").html("<p style=\"font-weight:normal;\">Pre Upgrade </p>" + data.prechart.chartTitle);
			//$("#timeRangeLabel_pre").html(data1.timeRange);

			chartData_post = data["postchart"]["points"];
			var rows = 0;
			var rowsTotal = 0;
			while (rows < chartData_post.length) {
				rowsTotal += chartData_post[rows].y;
				rows++;
			}

			if (rowsTotal <= 0) {
				$("#chartPanel > .showifnodata").show();
				$("#chartPanel > .hideifnodata").hide();
			} else {
				$("#chartPanel > .showifnodata").hide();
				$("#chartPanel > .hideifnodata").show();
				createRaphaelchart(chartData_post, "piechartcontainer_post");
			}

			$("#chartTitle").html("<p style=\"font-weight:normal;\">Post Upgrade </p>" + data.postchart.chartTitle);
			$("#JobSummary").unmask();

			for ( var i in data.JobSummary.coldata.rows) {
				var jobstatus = data.JobSummary.coldata.rows[i].cell[0];
				var hreflist = window.location.href.split("/");
				var hash = hreflist[hreflist.length - 1];
				data.JobSummary.coldata.rows[i].cell[0] = "<a href='" + hash + "&jobstatus=" + jobstatus + "'>"
						+ jobstatus + "</a>";
			}
			$("#JobSummary").unmask();
			$("#JobSummaryDetails").jqGrid('GridUnload');
			jQuery("#JobSummaryDetails").jqGrid({
				datatype : "jsonstring",
				colNames : data.JobSummary.colNames,
				colModel : data.JobSummary.colModel,
				rowNum : 100,
				datastr : data.JobSummary.coldata,
				loadonce : true,
				viewrecords : true,
				width : $("#content").width(),
				shrinkToFit : true,
				height : '100%',
				gridComplete : function() {
					$("td:not(:first-child)").addClass("notfirstchild");
					$("tr.jqgrow td").addClass("paddingtdrow");
					$('table').addClass("borderspacing");
					$('table').removeClass("ui-jqgrid-htable");
					$('#gview_JobSummaryDetails').addClass("gviewborder");
				}
			});
		}
	});

	function createRaphaelchart(currentData, id) {
		$("#" + id).empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});
		currentData.values = values;
		var labels = $.map(currentData, function(node) {
			return node["name"] + " - " + node["y"];
		});

		var events = {};
		events.clickFtn = [];
		var xpos = 450;
		var ypos = 5;
		//		if (id == "piechartcontainer_pre"){
		//			 xpos = -1;
		//			 ypos = -1;
		//			 labels = $.map(currentData, function(node){ 
		//			        return ""; 
		//			  });
		//		}

		var paper = Raphael(id, 560, 300);
		paper.pieChart(250, 150, 150, currentData, labels, xpos, ypos, "#fff", events, null, colors, colors3d);
	}

}

function UpgradeCheckSummary() {

	var sortgrid = true;

	$(".topPanelTitle").hide();
	$("#chartPanel").hide();
	$("#ContentWrapper").css("height", "auto");
	$(".SummaryTitle").hide();
	$("#topPanel").mask();
	$("#JobSummary").mask(" ");
	$('#indent-1').mask();
	$("#searchdiv").hide();
	$(".daystocmp").hide();

	$
			.ajax({
				url : 'upgradechck.do',
				data : {
					days : $.trim($('#lastN').val()),
					ccId : cvUtil.getParameter('ccId', ""),
					jobstatus : cvUtil.getParameter('jobstatus', ""),
					showlatest : (($('#showlatest').val() == "Pre Upgrade & Post Upgrade") ? 1 : 0)
				},
				type : 'GET',
				dataType : 'json',
				beforeSend : function() {
					$(".summarylegends").hide();
					$("#JobSummary").mask(" ");
				},
				error : function(data) {
					alert(data.error);
				},
				success : function(data) {
					
					if(data.isValidCCID == false){
		        		window.location = $('#diagUrl').attr('href');
		        		return;
		        	}
					
					$("#JobSummaryDetails").jqGrid('GridUnload');
					$("#IndexCacheDetails").jqGrid('GridUnload');
					if (data.error) {
						$("#topPanel").unmask();
						$("#JobSummary").css("height", "100%");
						$("#JobSummary").unmask();
						$("#noDataNotificationPanel").html(data.error).show();
						$('#hc-content').hide();
						$('#topPanel').hide();
						return;
					}
					$("#noDataNotificationPanel").hide();
					if (data.AsOfDate != undefined && $.trim(data.AsOfDate).length != 0) {
						$('#metaAsOf').html('As of: <span>' + data.AsOfDate + '</span>');
					}

					if (data.JobSummaryError) {
						$('#JobSummaryDetails').text(data.JobSummaryError);
					}

					if (data.IndexCacheError) {
						$('#IndexCacheDetails').text(data.IndexCacheError);
					}

					$(".daystocmp").show();
					$(".summarylegends").show();

					jsonData = data;

					$(".btn").css("background-image", "none");
					$("#btn" + cvUtil.getParameter('jobstatus', "").toLowerCase()).css("background-image", "");
					$("#upgradedate").text(data.UpgradeDate);
					$("#topPanel").unmask();
					$("#JobSummary").css("height", "100%");
					$("#JobSummary").unmask();

					var customsort = function(cell, rowdata) {
						var postval;
						var post = cell.split('<br/>');

						if (isNaN(parseFloat(post[1]))) {
							postval = post[1].split(' ')[1];
							postval = parseFloat(postval);
						} else {
							postval = parseFloat(post[1]);
						}

						return postval;
					};

					for ( var i in data.JobSummary_pre.colModel) {
						if (data.JobSummary_pre.colModel[i].sorttype == 'customsort') {
							data.JobSummary_pre.colModel[i].sorttype = customsort;
						}

						if (parseInt(i) in {
							0 : 1,
							1 : 1,
							2 : 1
						}) {
							data.JobSummary_pre.colModel[i].width = 180;
						} else if (parseInt(i) == 3) {
							data.JobSummary_pre.colModel[i].width = 190;
						} else if (parseInt(i) == 4) {
							data.JobSummary_pre.colModel[i].width = 200;
						} else {
							data.JobSummary_pre.colModel[i].width = 174;
						}

					}

					setsummarydata(data.JobSummary_pre, data.JobSummary_post, 1);
					data.JobSummary_pre.colNames[1] = "<img class=\"jobsummaryicons\" src=\"../images/Completed.png\" />&nbsp&nbsp"
							+ data.JobSummary_pre.colNames[1];
					data.JobSummary_pre.colNames[2] = "<img class=\"jobsummaryicons\" src=\"../images/CompletedwithError.png\" />&nbsp&nbsp"
							+ data.JobSummary_pre.colNames[2];
					data.JobSummary_pre.colNames[3] = "<img class=\"jobsummaryicons\" src=\"../images/ThroughputTime.png\" />&nbsp&nbsp"
							+ data.JobSummary_pre.colNames[3];
					data.JobSummary_pre.colNames[4] = "<img class=\"jobsummaryicons\" src=\"../images/AverageTime.png\" />&nbsp&nbsp"
							+ data.JobSummary_pre.colNames[4];
					data.JobSummary_pre.colNames[5] = "<img class=\"jobsummaryicons_attmps\" src=\"../images/AverageAttempts.png\" />&nbsp&nbsp"
							+ data.JobSummary_pre.colNames[5];
					jQuery("#JobSummaryDetails").jqGrid({
						datatype : "jsonstring",
						colNames : data.JobSummary_pre.colNames,
						colModel : data.JobSummary_pre.colModel,
						rowNum : 100,
						datastr : data.JobSummary_pre.coldata,
						loadonce : true,
						viewrecords : true,
						width : $("#content").width(),
						shrinkToFit : true,
						height : '100%',
						sortorder : 'desc',
						loadComplete : function() {
							if (sortgrid) {
								setTimeout('sortingGrid()', 30);
								sortgrid = false;
							}
							$("#gview_JobSummaryDetails").width($("#gview_JobSummaryDetails").width() + 2);

						}
					});
					$(".jqgriddiv").css("width", $("#content").width() + 4);
					//$('.jqgfirstrow').hide();
					$("#JobSummaryDetails td:not(:first-child)").removeClass("notfirstchild");
					$("#JobSummaryDetails tr.jqgrow td").removeClass("paddingtdrow");

					//if ($.browser.mozilla) {
					//	$("#first_li").css("margin-top", "3px");
					//}

					$("#searchdiv").show();
					$('#indent-1').unmask();

					//setindexcachedata(data.IndexCache_Pre,data.IndexCache_Post);
					setsummarydata(data.IndexCache_Pre, data.IndexCache_Post, 2);
					jQuery("#IndexCacheDetails").jqGrid({
						datatype : "jsonstring",
						colNames : data.IndexCache_Pre.colNames,
						colModel : data.IndexCache_Pre.colModel,
						rowNum : 100,
						datastr : data.IndexCache_Pre.coldata,
						loadonce : true,
						viewrecords : true,
						width : $("#content").width(),
						shrinkToFit : true,
						height : '100%',
						sortorder : 'desc',
						loadComplete : function() {
							$("#gview_IndexCacheDetails").width($("#gview_IndexCacheDetails").width() + 2);
						}
					});
				}
			});
}

function sortingGrid() {
	$("#JobSummaryDetails").sortGrid('index0', false);
}
function setsummarydata(data1, data2, type) {
	var deletearr = new Array();
	for ( var i in data1.coldata.rows) {

		var check;
		if (type == 1) {
			check = (data1.coldata.rows[i].cell[1] == "0") && (data1.coldata.rows[i].cell[2] == "0");
		} else if (type == 2) {
			check = false;//(parseFloat(data1.coldata.rows[i].cell[1]).toFixed(2) == "0.00");
		}

		if (check) {

		} else {
			deletearr.push(data1.coldata.rows[i]);
			getbardata(data1.coldata.rows[i], data2.rows, type);
		}
	}

	if (type == 2) {
		getprepostindexcachedata(data2.rows);
		var count = data1.coldata.rows.length;
		for ( var i in data2.rows) {
			data2.rows[i].id = count.toString();
			deletearr.push(data2.rows[i]);
			count++;
		}
	}

	data1.coldata.total = deletearr.length;
	data1.coldata.records = deletearr.length;
	data1.coldata.rows = deletearr;

}

function getbardata(data2, data, type) {
	var data1 = data2.cell;
	var isrowfound = false;
	var iszerodata = false;
	for ( var i in data) {
		if (data[i].cell[0] == data1[0]) {
			isrowfound = true;

			var statuscolor;//= "Good";
			var statuscolor2 = "Critical";
			var statuscolor1 = "moderate";

			var prestr1 = '<div style="width:';
			var prestr3;
			var poststr2 = 'px;" class="postupgrade progress">';
			var prestr2 = 'px;" class="preupgrade progress">';
			var linebr = '<br/>';
			var charspace = '&nbsp&nbsp ';
			var poststr1 = '<div style="width:';
			var poststr3;
			var commonstr = '</div>';

			for ( var j in data1) {
				if (j == 0) {
					data1[j] = '<div class="progressmaindiv">' + data1[j] + '</div>';
					continue;
				}

				var statuscolor = "Good";
				predata = parseFloat(data1[j]);
				postdata = parseFloat(data[i].cell[j]);

				if (type == 1) {
					if ((predata.toFixed(2) == "0.00") || (postdata.toFixed(2) == "0.00")) {

					} else {
						var diff = 0;
						if ((j == 5) || (j == 4) || (j == 2)) {
							if (predata < postdata) {
								diff = parseInt(((postdata - predata) / postdata) * 100);
								if (diff >= 15) {
									statuscolor = statuscolor2;
								} else if (diff < 15) {
									statuscolor = statuscolor1;
								}
							}
						} else {
							if (predata > postdata) {
								diff = parseInt(((predata - postdata) / predata) * 100);
								if (diff >= 15) {
									statuscolor = statuscolor2;
								} else if (diff < 15) {
									statuscolor = statuscolor1;
								}
							}
						}
					}
				} else if (type == 2) {
					var diff = 0;
					if (predata < postdata) {
						diff = parseInt(((postdata - predata) / postdata) * 100);
						if (diff >= 15) {
							statuscolor = statuscolor2;
						} else if (diff >= 10) {
							statuscolor = statuscolor1;
						}
					}
				}

				if ((predata.toFixed(2) != "0.00") && (postdata.toFixed(2) == "0.00") && j != 2 && (type == 1)) {
					statuscolor = statuscolor2;
				}

				if ((predata.toFixed(2) == "0.00") && (postdata.toFixed(2) != "0.00") && j == 2 && (type == 1)) {
					statuscolor = statuscolor2;
				}

				var maindiv = '<div class="progressmaindiv ' + statuscolor + '">';

				var poststr3_px;
				var prestr3_px;
				if (type == 1) {
					if ((j == 3) || (j == 4)) {
						prestr3 = parseFloat(data1[j]).toFixed(2);
						poststr3 = parseFloat(data[i].cell[j]).toFixed(2);

					} else {
						prestr3 = data1[j];
						poststr3 = data[i].cell[j];
					}
				} else if (type == 2) {
					if (j == 1) {
						prestr3 = data1[j];
						poststr3 = data[i].cell[j];
					} else {
						prestr3 = parseFloat(data1[j]).toFixed(2);
						poststr3 = parseFloat(data[i].cell[j]).toFixed(2);
					}
				}

				if (parseFloat(prestr3) > parseFloat(poststr3)) {
					prestr3_px = 130;
					poststr3_px = parseInt((parseFloat(poststr3) / parseFloat(prestr3)) * 130);
				} else {
					poststr3_px = 130;
					prestr3_px = parseInt((parseFloat(prestr3) / parseFloat(poststr3)) * 130);
				}

				if (prestr3_px < 10) {
					prestr3_px = 10;
				}

				if (poststr3_px < 10) {
					poststr3_px = 10;
				}

				if (parseFloat(prestr3).toFixed(2) == "0.00") {
					prestr3_px = 0;
				}
				if (parseFloat(poststr3).toFixed(2) == "0.00") {
					poststr3_px = 0;
				}

				if ((prestr3 + "").length > (poststr3 + "").length) {
					var count = ((prestr3 + "").length - (poststr3 + "").length);
					if (count > 1) {
						count = (count * 2);
					}
					var addstr = "";
					for ( var p = 0; p < count; p++) {
						addstr += "&nbsp";
					}
					poststr3 = addstr + " " + poststr3;
				} else if ((prestr3 + "").length < (poststr3 + "").length) {
					var count = ((poststr3 + "").length - (prestr3 + "").length);
					if (count > 1) {
						count = (count * 2);
					}
					var addstr = "";
					for ( var p = 0; p < count; p++) {
						addstr += "&nbsp";
					}
					prestr3 = addstr + " " + prestr3;
				}

				data1[j] = maindiv + prestr3 + charspace + prestr1 + prestr3_px.toString() + prestr2 + commonstr
						+ linebr + poststr3 + charspace + poststr1 + poststr3_px.toString() + poststr2 + commonstr
						+ commonstr;
			}

			delete data[i];
		}
	}
	if (!isrowfound) {
		var prestr1 = '<div style="width:';
		var prestr3;
		var statuscolor = "Critical";
		var statuscolor1 = "Good";

		var linebr = '<br/>';
		var charspace = '&nbsp&nbsp ';
		var prestr2 = 'px;" class="preupgrade progress">';
		var poststr1 = '<div style="width:';
		var poststr2 = 'px;" class="postupgrade progress">';
		var poststr3;
		var commonstr = '</div>';

		for ( var j in data1) {
			if (j == 0) {
				data1[j] = '<div class="progressmaindiv">' + data1[j] + '</div>';
				continue;
			}
			var statuscolor = "Critical";

			var prestr3_px;

			if (type == 1) {
				if ((j == 3) || (j == 4)) {
					prestr3 = parseFloat(data1[j]).toFixed(2);
				} else {
					prestr3 = data1[j];
				}
			} else if (type == 2) {
				if (j == 1) {
					prestr3 = data1[j];
				} else {
					prestr3 = parseFloat(data1[j]).toFixed(2);
				}
			}

			if (parseFloat(prestr3).toFixed(2) == "0.00") {
				statuscolor = statuscolor1;
			}

			var maindiv = '<div class="progressmaindiv ' + statuscolor + '">';
			poststr3 = 0;

			if (parseFloat(prestr3) > parseFloat(poststr3)) {
				prestr3_px = 130;
			} else {
				prestr3_px = parseInt((parseFloat(prestr3) / parseFloat(poststr3)) * 130);
			}

			if (prestr3_px < 10) {
				prestr3_px = 10;
			}

			if (parseFloat(prestr3).toFixed(2) == "0.00") {
				prestr3_px = 0;
			}

			if ((prestr3 + "").length < (poststr3 + "").length) {
				var count = ((poststr3 + "").length - (prestr3 + "").length);
				if (count > 1) {
					count = (count * 2);
				}
				var addstr = "";
				for ( var p = 0; p < count; p++) {
					addstr += "&nbsp";
				}
				prestr3 = addstr + " " + prestr3;
			}

			data1[j] = maindiv + prestr3 + charspace + prestr1 + prestr3_px.toString() + prestr2 + commonstr + linebr
					+ poststr3.toString() + poststr1 + poststr3.toString() + poststr2 + commonstr + commonstr;
		}
	}
}

function getprepostindexcachedata(data2) {

	var prestr1 = '<div style="width:';
	var prestr3;
	var statuscolor = "Critical";
	var statuscolor1 = "Good";

	var linebr = '<br/>';
	var charspace = '&nbsp&nbsp ';
	var prestr2 = 'px;" class="preupgrade progress">';
	var poststr1 = '<div style="width:';
	var poststr2 = 'px;" class="postupgrade progress">';
	var poststr3;
	var commonstr = '</div>';

	for ( var l in data2) {

		for ( var j in data2[l].cell) {
			if (j == 0) {
				data2[l].cell[j] = '<div class="progressmaindiv">' + data2[l].cell[j] + '</div>';
				continue;
			}
			var statuscolor = "Critical";

			var poststr3_px = 130;

			if (j == 1) {
				poststr3 = data2[l].cell[j];
			} else {
				poststr3 = parseFloat(data2[l].cell[j]).toFixed(2);
			}

			prestr3 = 0;
			prestr3_px = 0;

			if (poststr3 == prestr3) {
				var maindiv = '<div class="progressmaindiv ' + statuscolor1 + '">';
			} else {
				var maindiv = '<div class="progressmaindiv ' + statuscolor + '">';
			}

			if (parseFloat(poststr3).toFixed(2) == "0.00") {
				statuscolor = statuscolor1;
				poststr3_px = 0;
			}

			data2[l].cell[j] = maindiv + prestr3 + charspace + prestr1 + prestr3_px.toString() + prestr2 + commonstr
					+ linebr + poststr3 + charspace + poststr1 + poststr3_px.toString() + poststr2 + commonstr
					+ commonstr;
		}

	}
}

var clientname;
function getreportready() {

	$("#searchdiv").hide();

	var ccId = cvUtil.getParameter('commUniId', "");
	if (ccId == "") {
		ccId = cvUtil.getParameter('ccId', "");
	}

	getCommCellDetailsOfUid(ccId, null, function() {
		if (clientName != null && clientName != " " && $.trim(clientName).length != 0) {
			$('#welcomeMsg').html(clientName + " - " + 'Post Upgrade Check Report');
			$(document).attr("title", clientName + " - " + 'Post Upgrade Check Report');
			clientname = clientName;
			$('.reportsLink').text(clientName+' (Reports)');
		} else {
			$('#welcomeMsg').html('Post Upgrade Check Report');
			$(document).attr("title", 'Post Upgrade Check Report');
		}
	});

	var days = cvUtil.getParameter('days', "3");
	$('#lastN').val($.trim(days));

	var showlatest = cvUtil.getParameter('showlatest', 1);
	$('#showlatest').val(((showlatest == 1) ? "Pre Upgrade & Post Upgrade" : "Pre Upgrade & Latest data"));

	params = {
		days : $.trim(days),
		ccId : ccId,
		showlatest : showlatest
	};

	var jobstatus = cvUtil.getParameter('jobstatus', "Completed");

	if (jobstatus != "") {
		params["jobstatus"] = jobstatus;
	}

	var url = cvUtil.requestToUrl(params);
	History.replaceState(null, document.title, "?" + url);

	if (jobstatus != "") {
		$(".btn").show();
		UpgradeCheckSummary();
	} else {
		UpgradeCheckReport();
	}
}

$(document).ready(function() {

	getreportready();
	addExpandablePanels();
	$("#btngenerate").click(function() {
		getreportready();
	});

	$('#exportPdf').click(function() {
		buildCanvas();
	});

	$('#showlatest').change(function() {

		var days = $('#lastN').val();
		params = {
			days : $.trim(days)
		};

		var ccId = cvUtil.getParameter('ccId', "10028");
		//var ccId = "10028";//"11761";//"10028";
		params["ccId"] = ccId;

		var showlatest = (($('#showlatest').val() == "Pre Upgrade & Post Upgrade") ? 1 : 0);
		params["showlatest"] = showlatest;

		var jobstatus = cvUtil.getParameter('jobstatus', "Completed");
		if (jobstatus != "") {
			params["jobstatus"] = jobstatus;
		}

		var url = cvUtil.requestToUrl(params);
		History.replaceState(null, document.title, "?" + url);

		if (jobstatus != "") {
			UpgradeCheckSummary();
		} else {
			UpgradeCheckReport();
		}
	});

	$("#lastN").change(function() {

		var days = $('#lastN').val();
		params = {
			days : $.trim(days)
		};

		var ccId = cvUtil.getParameter('ccId', "10028");
		//var ccId = "10028";//"11761";//"10028";
		params["ccId"] = ccId;

		var showlatest = (($('#showlatest').val() == "Pre Upgrade & Post Upgrade") ? 1 : 0);
		params["showlatest"] = showlatest;

		var jobstatus = cvUtil.getParameter('jobstatus', "Completed");
		if (jobstatus != "") {
			params["jobstatus"] = jobstatus;
		}

		var url = cvUtil.requestToUrl(params);
		History.replaceState(null, document.title, "?" + url);

		if (jobstatus != "") {
			UpgradeCheckSummary();
		} else {
			UpgradeCheckReport();
		}
	});

});
