function PreUpgradeReadinessReport() {

	var commUniId = cvUtil.getParameter('commUniId', 0);
	var customerName = "";

	this.report = new Reports.initReport({
		type : 'preupgradereadiness',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			requestString["commUniId"] = commUniId;
		}
	};

	report.initComponents = function() {
		$("#exportcsv").hide();

		$("#surveyName").html('Pre Upgrade Readiness');

	};

	report.initComponentState = function() {

	};
	report.beforeLoadReport = function() {
		report.mask("");
	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/upgradereadiness.do?commUniId=' + commUniId;
	};
	report.getExportFilePrefix = function() {
		var filePre = "PreUpgradeReadinessReport";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}

		return filePre;
	};
	report.onLoadReport = function(data) {
		processResponse(data);
		report.attachTableActions();
		report.afterLoadReport();
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(data) {
		if (data == undefined || data == null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else if (data && typeof data === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel").html(data);
			$("#noDataNotificationPanel").show();
		} else {
			if (data && typeof data === 'object') {
				$.each(data, function(key, value) {
					if (typeof value == 'object') {
						if (value.viewType == 'clientTable') {
							var tdata = value.value.CommServ.value;
							var tableDiv = 'entityTable';
							var wrapperId = 'ContentWrapper';
							$('#' + wrapperId).append(SurveyTemplates.makeReportTable(tableDiv, value));
							var configTable = true;
							if ((!tdata.aoColumns || tdata.aoColumns.length == 0) &&
									(!tdata.aoColumnDefs || tdata.aoColumnDefs.length == 0)) {
								configTable = false;
							}

							if (configTable) {
								Reports.configureClientSideTable(tableDiv, "CommServ", tdata);
								//set allcheckspassed banner 
								if (value.value.CommServ_allcheckspassed.value == true) {
									$(".allcheckspassed").show();
								} else {
									$(".failedreportclass").show();
								}

								//set metaAsOf Date
								$("#metaAsOf").html('As of: <span>' + value.value.CommServ_AsOfDate.value + '</span>');
							}
							$("#" + tableDiv + "_title").html(value.title);
						} else if (key == 'customerInfo') {
							customRender(key, value);
						} else if (key == 'errorMsg') {
							$("#ContentWrapper").hide();
							$("#noDataNotificationPanel").html(data.errorMsg.value);
							$("#noDataNotificationPanel").show();
						}
					}
				});
			}
		}
	}

	function customRender(key, model) {
		if (key == 'customerInfo') {
			customerName = model.value.Customer;
			collectiontime = model.value.time;
			GUID = model.value.CommServeGUID;

			if (customerName != null && customerName != " " && $.trim(customerName).length != 0) {
				$('#custName').html(customerName + ' -&nbsp;');
				$('.reportsLink').text(customerName + ' (Reports)');
				$(document).attr("title", customerName + " - " + $(document).attr("title"));
				cvUtil.GUIAuditReportLog($("#surveyName").text().trim(), customerName);
			}

			if (commUniId > 0 && (collectiontime != '') && GUID != undefined) {
				GUID = registrationCode(GUID);
				$("#timeZone").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Time_zone") + ': ' +
						model.value.TimeZone + '</span>');
				/*
				 * $("#metaAsOf").html('<span>' + cvUtil.cvLocalize("commcell.info.label.As_of") + ': ' +
				 * collectiontime + '</span>');
				 */
				$("#metaCCId").html('<span>' + cvUtil.cvLocalize("commcell.info.label.CommCell_ID") + ': ' +
						model.value.CommCellHexID + '</span>');
				$("#GUID").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Registration_Code") + ': ' + GUID +
						'</span>');
			}
		}
	}

}

$(document).ready(function() {
	PreUpgradeReadinessReport();
	report.scaleReport = true;
});