var userGroups = {}, entity;
var COMMCELL_SECURITY_API = 'saveCommCellSecurity.do';
var COMMCELL_GROUP_SECURITY_API = 'saveCommCellGroupSecurity.do';

userGroups.updateUIwithModel = function(data) {

};

userGroups.submit = function() {
	if (!userGroups.isValidData()) {
		return;
	}
	// Prepare data parameter object:
	var request = {};
	request.entityId = entity.entityId;
	request.entityName = entity.displayName != undefined ? entity.displayName : entity.entityName;
	request.ccGuid = entity.ccGuid;
	var userusergroups = userGroups.getSelectedUserUserGroups();
	request.users = userusergroups.users;
	request.userGroups = userusergroups.groups;
	var action = "modifySecurity";
	var message = "";
	var configURL = cvUtil.getContextPath() + '/reports/';
	var entityTypeStr = 'CommCell Group';
	if (entity.entityType == 1) {
		configURL += COMMCELL_SECURITY_API;
		entityTypeStr = 'CommCell';
	} else {
		configURL += COMMCELL_GROUP_SECURITY_API;
	}
	var data = {
		'json' : JSON.stringify(request)
	};
	message = userGroups.modifySecurity(configURL, data, entityTypeStr);
	cvUtil.logUserAction(entityTypeStr, action, null, entityTypeStr + "=[" + entity.entityName + "] Message=[" +
			message + "]", "INFO");
	userGroups.exitDialog();
};

userGroups.modifySecurity = function(configURL, data, entityTypeStr) {
	// Send request:
	var isError = false;
	var message;
	cvUtil.mask();
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug(resp);
	});
	cvUtil.unmask();
	if (result.isError) {
		message = cvUtil.cvLocalize("userGroups.security.fail", entityTypeStr);
		//console.debug(message);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		message = cvUtil.cvLocalize("userGroups.security.success", entityTypeStr);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

userGroups.isValidData = function() {
	return true;
};

userGroups.clearAll = function() {
	$("#availableUserList").empty();
	$("#selectedUserList").empty();
};

userGroups.getSelectedUserUserGroups = function() {
	var groupsList = [];
	var usersList = [];
	$("#selectedUserList li").each(function(i) {
		if ($(this).data('usertype') == 1) {
			var user = {};
			user.name = $(this).data('user');
			user.id = $(this).data('userid');
			usersList.push(user);
		} else {
			var groupObj = {};
			groupObj.name = $(this).data('user');
			groupObj.id = $(this).data('userid');
			groupObj.type = $(this).data('usertype');
			groupObj.umdsProviderId = $(this).data('umdsproviderid');
			groupsList.push(groupObj);
		}
	});
	return {
		'groups' : groupsList,
		'users' : usersList
	};
};

userGroups.populateColumns = function populateColumns(data, selectedUserGroups) {
	userGroups.clearAll();
	var userList = [];
	/*
	 * data.sort(function(a,b){ return a.login - b.login; if(a.type > 1 && b.type > 1){ return a.login -
	 * b.login; } return a.type < b.type; });
	 */

	$.each(data, function(i, group) {
		userList.push(group.name);
		var typ = (group.type > 1) ? 2 : 1;
		var sourceLi = $("<li></li>", {
			text : group.name,
			title : (group.email !== '') ? group.name + ' (' + group.email + ')' : group.name,
			class : "selectableuser",
			id : "selectable" + typ + group.id,
			"data-user" : group.name,
			"data-userType" : group.type,
			"data-umdsProviderId" : group.umdsProviderId,
			"data-userId" : group.id,
			"data-email" : group.email
		});
		if (group.type == 2 || group.type == 3) {
			sourceLi.addClass('selectableUserGroup');
		}
		$("#availableUserList").append(sourceLi);
	});

	$('#cr-security-search-user').keyup(function(event) {
		var search_text = $('#cr-security-search-user').val();
		var rg = new RegExp(search_text, 'i');
		$("#availableUserList li").each(function(i) {
			if ($.trim($(this).html()).search(rg) == -1) {
				$(this).css('display', 'none');
			} else {
				$(this).css('display', '');
			}
		});
	});

	if (selectedUserGroups.length) {
		for (var i = 0; i < selectedUserGroups.length; i++) {
			userGroups.addToSelectedList(selectedUserGroups[i]);
		}
	}
	$(".selectableuser").click(function() {
		if ($(this).hasClass('selectedUser')) {
			$(this).removeClass('selectedUser');
		} else {
			$(this).addClass('selectedUser');
		}
	});
};
userGroups.addEvents = function() {
	$("#moveRight").click(function() {
		$("#availableUserList .selectedUser").each(function() {
			$(this).removeClass("selectedUser");
			$(this).appendTo("#selectedUserList");
			$("#cr-security-search-user").val("");
			userGroups.showAllAvailableUsers();
		});
	});
	$("#moveLeft").click(function() {
		$("#selectedUserList .selectedUser").each(function() {
			$(this).removeClass("selectedUser");
			$(this).appendTo("#availableUserList");
		});
	});
	$("#availableUserList").on('dblclick', '.selectableuser', function(event) {
		$(this).removeClass("selectedUser");
		$(this).appendTo("#selectedUserList");
		$("#cr-security-search-user").val("");
		userGroups.showAllAvailableUsers();
	});
	$("#selectedUserList").on('dblclick', '.selectableuser', function(event) {
		$(this).removeClass("selectedUser");
		$(this).appendTo("#availableUserList");
	});
}

userGroups.addToSelectedList = function(group) {
	var typ = (group.type > 1) ? 2 : 1;
	var userid = typ + '' + group.id;
	var element = userGroups.removeFromSelectedList("#selectable" + userid);
	//element.removeClass('selectableuser');
	if (element.hasClass('selectedUser')) {
		element.removeClass('selectedUser');
	}
	if (group.inherited) {
		var cls = group.type > 1 ? 'inheritedUser inheritedGroup' : 'inheritedUser';
		element.removeClass('selectableUserGroup');
		element.removeClass('selectableuser');
		element.addClass(cls);
	}
	$("#selectedUserList").append(element[0]);
};

userGroups.removeFromSelectedList = function(id) {
	return $("#availableUserList").find(id).remove();
};

userGroups.showAllAvailableUsers = function() {
	$("#availableUserList li").each(function() {
		$(this).css('display', '');
	});
};

userGroups.fetchData = function() {
	var request = {};
	request.entityType = entity.entityType;
	request.entityId = entity.entityId;
	request.entityName = entity.entityName;
	request.ccGuid = entity.ccGuid;
	console.debug("Posting ajax request to fetch user groups information");
	var configURL = cvUtil.getContextPath() + '/reports/getUserGroups.do';
	cvUtil.mask();
	var isError = false;
	cvUtil.loadPageWithPOST(configURL, request, function(resp) {
		if (resp) {
			userGroups.populateColumns(resp.availableGroups, resp.selectedGroups);
		}
		cvUtil.unmask();
	}, function(resp) {
		cvUtil.unmask();
		cvUtil.errorToast(resp.responseText.trim(), null, null, true);
	});

};

userGroups.exitDialog = function(forceReload) {
	cvUtil.closeModal();
};

function getData() {
	return window.returnData;
}

$(document).ready(function() {
	entity = cvUtil.getInitModalData();
	userGroups.addEvents();
	userGroups.fetchData();

	$("#okButton").click(function(e) {
		userGroups.submit();
	});
	$("#cancelButton").click(function(e) {
		window.returnData = {
			'isError' : false,
			'cancel' : true
		};
		cvUtil.closeModal();
	});
	$("#closeButton").click(function() {
		window.returnData = {
			'isError' : false,
			'cancel' : true
		};
		userGroups.exitDialog();
	});

});
