(function(umExports) {
	'use strict';

	var commUniId = cvUtil.getParameter('commUniId', 0);
	var ccGroupId = cvUtil.getParameter('ccGroupId', 0);
	var companyId = cvUtil.getParameter('companyId', 0);
	var respType = {
		UNKNOWN_RESP : 0,
		EMPTY_RESP : 1,
		GENERIC_RESP : 2,
		WORKFLOW_RESP : 3
	};
	var entity = {}, usersList = [];
	var showActions = false;

	function init() {
		$('#viewUsersLink').on('click', function() {
			entity.ccGroupId = ccGroupId;
			entity.companyId = companyId;
			entity.CommGuiId = CommGuiId;
			entity.commCellId = commCellId;

			showViewUsersDialog();
		});
		$('#addNewUserLink').on('click', function() {
			if (companyId > 0 && commUniId <= 0) {//If new user event triggered from company level, we need one of the commcell details
				var params = {};
				params.companyId = companyId;
				params.includeCommCellDetails = true;
				var configURL = cvUtil.getContextPath() + '/reports/getCommCellInfoForCompany.do';
				cvUtil.loadPageWithGET(configURL, params, function(resp) {
					if (resp) {
						CommGuiId = resp.data.details.CommServeGUID;
						commCellId = resp.data.details.CommCellHexID;
						entity.commIpAddr = resp.data.details.IP;
						entity.CommGuiId = resp.data.details.CommServeGUID;
						entity.commCellId = resp.data.details.CommCellHexID;
					}
				});
			} else {
				entity.CommGuiId = CommGuiId;
				entity.commCellId = commCellId;
			}

			entity.ccGroupId = ccGroupId;
			entity.companyId = companyId;

			showNewUserDialog();

		});
	}

	function showViewUsersDialog(data) {
		showActions = false;
		$(".actions-col-th").hide();
		if (surveySingleCommcellUser || (companyId > 0 && commUniId == 0)) {
			$(".actions-col-th").show();
			showActions = true;
		}

		var dlgTitle = cvUtil.cvLocalize("Users");
		if (data) {
			dlgTitle = data.entityName + ' - ' + dlgTitle;
		}
		$('.users-table-body').empty();
		$("#usersDialogWrapper").removeClass('hide');
		$("#err_msg").hide();
		$("#um-users-dialog").dialog({
			title : dlgTitle,
			width : 600,
			height : 380,
			modal : true,
			resizable : false,
			buttons : [ {
				text : cvUtil.cvLocalize("Close"),
				class : "ui-close-button",
				click : function() {
					$('#users-content').empty();
					$(this).dialog("close");
				}
			}, {
				text : cvUtil.cvLocalize("um.save_csv"),
				class : "add-user-btn ui-close-button ui-save-csv-button",
				click : function() {
					saveAsCSV(data);
				}
			} ]
		});

		getUsersInfo(data);
	}

	function saveAsCSV(data) {
		var title = $('ul.nav .nav-customer-title').attr('title') + ' - ' + cvUtil.cvLocalize('Users');
		if (data) {
			title = data.entityName + ' - ' + cvUtil.cvLocalize('Users');
		}
		var content = title + '\n\n';
		content += cvUtil.cvLocalize('Name') + ',' + cvUtil.cvLocalize('Email') + ',' +
				cvUtil.cvLocalize('user.company');
		content += ',' + cvUtil.cvLocalize('Admin');
		content += '\n';

		if (usersList && usersList.length > 0) {
			$.each(usersList, function(key, user) {
				content += user.userName + ',' + user.email + ',' + user.companyName;
				content += ',' + user.isAdmin;
				content += '\n';
			});
		} else {
			content += cvUtil.cvLocalize('No_Data_Available');
		}

		document.exportform.csvBuffer.value = content;
		var now = new Date();
		var month = now.getMonth() + 1;
		if (month < 10) {
			month = "0" + month;
		}
		document.exportform.fileName.value = title + "_" + month + "_" + now.getDate() + "_" + now.getFullYear() + "_" +
				now.getHours() + "" + now.getMinutes() + "" + now.getSeconds();
		document.exportform.reportName.value = title;
		$("form[name='exportform']").submit();
	}

	function showNewUserDialog(data) {
		var dlgTitle = cvUtil.cvLocalize("Add_User");
		if (data) {
			dlgTitle = data.entityName + ' - ' + dlgTitle;
		}
		$("#newUserDialogWrapper").removeClass('hide');
		$("#err_msg").hide();
		$("#new-user-dialog").dialog({
			title : dlgTitle,
			width : 350,
			height : 230,
			modal : true,
			resizable : false,
			buttons : [ {
				text : cvUtil.cvLocalize("Close"),
				class : "ui-close-button",
				click : function() {
					resetUser();
					$(this).dialog("close");
				}
			}, {
				text : cvUtil.cvLocalize("user.add"),
				class : "ui-ok-button",
				click : function() {
					if (!validateNewUser()) {
						return;
					}
					addUser();
					$(this).dialog("close");
				}
			} ]
		});
	}

	function addUser() {
		var email = $.trim($("#email").val());
		var userName = $.trim($("#userName").val());

		let params = {
				companyName : dashboardCommon.userGroupName,
				commcells:  [],
				users : [{
					name: userName,
					email: email,
					isCreator: 0,
					operation: 1
				}],
				isEdit : 1,
				companyId: entity.companyId
		}



		cvUtil.loadPageWithPOST(cvUtil.getContextPath() + "/createUpdateCompany.do", {
			params : JSON.stringify(params)
		}, function(data) {
			if (data && data.data && data.data.errorCode > 0) {
				cvUtil.errorToast(data.data.message);
				resetUser();
			} else {
				var message = cvUtil.cvLocalize("um.info.emil_notif_msg");
				cvUtil.toast(message);
				message = userName + "' added to the CommCell Group";
				cvUtil.logUserAction("User Management", "Add User", null, "Customer Name=[" + clientName +
						"] Message=[" + message + "] ", "INFO");
				resetUser();
			}
			cvUtil.unmask();
		}, function(e) {
			cvUtil.unmask();
			cvUtil.errorToast(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
			resetUser();
		});

	}

	function validateNewUser() {
		$("#new-user-dialog .textbox").not("#exusername, #expwd").each(function() {
			validateField($(this));
		});
		if ($('#new-user-dialog .errorField').length > 0) {
			return false;
		}
		return true;
	}
	function validateField(tx) {
		var re = new RegExp(tx.data("validation"));
		var val = tx.val();
		var txId = tx.attr("id");
		var fn = tx.data("validationfn");
		var msg = '';
		if (fn !== undefined) {
			eval(fn);
			return;
		}
		if (re.test(val) === false) {
			msg = tx.data("msg");
		}
		markField('#' + txId, msg);
	}
	function matchPwds() {
		var msg = '';
		var pwd = $("#pwd").val();
		var confPwd = $("#confirmPassword").val();
		if (pwd !== confPwd) {
			msg = $("#confirmPassword").data("msg");
		}
		markField('#pwd', msg);
		markField('#confirmPassword', msg);
	}

	function resetUser() {
		$("#new-user-dialog .textbox").not("#exusername, #expwd").each(function() {
			var $tx = $(this);
			$tx.val('');
			markField('#' + $tx.attr("id"), '');
		});
	}

	function deleteInheritedUser(user) {
		if (user.inherited) {
			$("#um-inherited-user-remove-dialog-wrapper").removeClass('hide');
			$(".userGroupName").html(cvUtil.cvLocalize('User_Access_Other_CommCells', user.username, user.groupname));
			$("#um-inherited-user-remove-dialog").dialog({
				width : 440,
				height : 200,
				modal : true,
				resizable : true,
				buttons : [ {
					text : cvUtil.cvLocalize("No"),
					class : "ui-close-button",
					click : function() {
						$(this).dialog("close");
					}
				}, {
					text : cvUtil.cvLocalize("Yes"),
					class : "ui-ok-button",
					click : function() {
						deleteUser(user);
						$(this).dialog("close");
					}
				} ]
			});
		}
	}

	function deleteUser(user) {
		var params = {};
		params.userId = user.userid;
		params.userEmail = user.useremail;
		params.userGroupId = user.groupid;
		params.ccGroupId = entity.ccGroupId;
		params.companyId = entity.companyId;
		params.ccGuid = entity.CommGuiId;
		params.commcellId = entity.commCellId;
		params.userGroup = user.groupname;

		cvUtil.mask("#um-users-dialog");
		var configURL = cvUtil.getContextPath() + '/reports/deleteUserFromGroup.do';
		cvUtil.loadPageWithPOST(configURL, params, function(resp) {
			cvUtil.unmask("#um-users-dialog");
			if (resp) {

				if (resp.respType === respType.EMPTY_RESP) {
					cvUtil.errorToast(resp.errorMessage);
				} else if (resp.respType === respType.GENERIC_RESP) {
					if (resp.errorCode !== 0) {
						cvUtil.errorToast(resp.errorMessage);
					} else {
						cvUtil.toast(cvUtil.cvLocalize("um.user.remove.ok"));
						var message = "User '" + user.username + "' removed from customer group";
						cvUtil.logUserAction("User Management", "Remove User", null, "Customer Name=[" + clientName +
								"] Message=[" + message + "] ", "INFO");
						getUsersInfo();
					}

				} else if (resp.respType === respType.WORKFLOW_RESP) {
					//cvUtil.errorToast(resp.errorMessage);
					if (resp.status === 4) {
						cvUtil.toast(cvUtil.cvLocalize("um.user.remove.ok"));
						var message = "User '" + user.username + "' removed from customer group";
						cvUtil.logUserAction("User Management", "Remove User", null, "Customer Name=[" + clientName +
								"] Message=[" + message + "] ", "INFO");
						getUsersInfo();
					} else {
						cvUtil.errorToast(resp.errorMessage);
					}
				} else if (resp.respType === respType.UNKNOWN_RESP) {
					resp = jQuery.parseJSON(resp);
					cvUtil.errorToast(resp.resp);
				}
			}
		}, function(err) {
			cvUtil.unmask("#um-users-dialog");
			cvUtil.errorToast(err.responseText);
		});

	}

	function updateUserInfo(user) {
		var params = {};
		params.userId = user.userid;
		params.userName = user.username;
		params.userGroupId = user.groupid;
		params.userOp = user.isadmin ? 'NON_ADMIN' : 'ADMIN';
		params.ccGroupId = entity.ccGroupId;
		params.ccGuid = entity.CommGuiId;
		params.commcellId = entity.commCellId;
		params.companyId = entity.companyId;

		cvUtil.mask("#um-users-dialog");
		var configURL = cvUtil.getContextPath() + '/reports/updateCustomerCloudUser.do';
		cvUtil.loadPageWithPOST(configURL, params, function(resp) {
			cvUtil.unmask("#um-users-dialog");
			if (resp) {
				if (resp.errorCode) {
					cvUtil.errorToast(resp.errorMessage);
				} else {
					var msg = cvUtil.cvLocalize("um.user.change.admin", user.username);
					if (user.isadmin) {
						msg = cvUtil.cvLocalize("um.user.change.non_admin", user.username);
					}
					cvUtil.toast(msg);
					cvUtil.logUserAction("User Management", "Update User", null, "Customer Name=[" + clientName +
							"] Message=[" + msg + "] ", "INFO");
					getUsersInfo();
				}
			}
		}, function(err) {
			cvUtil.unmask("#um-users-dialog");
			cvUtil.errorToast(err.responseText);
		});

	}

	function getUsersInfo(data) {
		if (data) {
			entity.companyId = data.companyId;
			if (data.entityType === 2) {
				entity.ccGroupId = data.ccGroupId;
				//params.ccGuid = CommGuiId;
				//params.commcellId = commCellId;
			} else {
				entity.ccGroupId = data.ccGroupId;
				entity.CommGuiId = data.CommGuiId;
				entity.commCellId = data.commCellId;
			}
		}
		var params = {};
		params.ccGroupId = entity.ccGroupId;
		params.companyId = entity.companyId;
		params.ccGuid = entity.CommGuiId;
		params.commcellId = entity.commCellId;

		console.debug("Posting ajax request to fetch users information");
		var configURL = cvUtil.getContextPath() + '/reports/getCustomerUsers.do';
		cvUtil.mask("#um-users-dialog");
		cvUtil.loadPageWithPOST(configURL, params, function(resp) {
			usersList = [];
			if (resp) {
				var rows = '';
				if(resp.data.isSingleCCcompany){
					$(".actions-col-th").show();
					showActions = true;
				}
				if (resp.data.ccusers) {
					$.each(resp.data.ccusers, function(i, groupInfo) {
						var userGroup = groupInfo.userGroup.associatedUserOrUserGroup;
						if (groupInfo.users) {
							$.each(groupInfo.users, function(j, user) {
								if (user.associatedUserOrUserGroup.userName &&
										user.associatedUserOrUserGroup.userName.length > 0) {
									var inputId = 'admin_' + j;
									var deleteSpan = '<span class="sprite icon-trash um-user-delete" title="' +
											cvUtil.cvLocalize("um.remove.user.title") + '"></span>';
									var isAdmin = (user.description === '1') ? true : false;
									var checked = isAdmin ? 'checked' : 'unchecked';
									//var adminCol = '<input id="'+inputId+'" type="checkbox" class="cvToggle um-user-admin" '+checked+'><label for="'+inputId+'" style="margin-top: -15px;"></label>';
									var adminCol = '<span class="custom-cb um-user-admin ' + checked +
											'" data-state="' + checked + '"></span>';
									if (resp.data.login_user_id === user.associatedUserOrUserGroup.userId) {
										deleteSpan = '';
										if (isAdmin) {
											adminCol = '<span class="sprite icon-check" title="' +
													cvUtil.cvLocalize("um.admin.user.title") + '"></span>';
										} else {
											adminCol = '';
										}
									} else if (!resp.data.isCloudAdminUser || commUniId > 0) {
										deleteSpan = '';
										if (isAdmin) {
											adminCol = '<span class="sprite icon-check" title="' +
													cvUtil.cvLocalize("um.admin.user.title") + '"></span>';
										} else {
											adminCol = '';
										}
									}
									var data = "data-username='" + user.associatedUserOrUserGroup.userName +
											"' data-userid='" + user.associatedUserOrUserGroup.userId +
											"' data-groupid='" + userGroup.userGroupId + "' data-groupname='" +
											userGroup.userGroupName + "' data-inherited='" + groupInfo.inherited +
											"' data-useremail='" + user.email + "'";
									if (isAdmin) {
										data = data + "data-isadmin=true";
									} else {
										data = data + "data-isadmin=false";
									}
									rows += "<TR class='user-row'><TD class='um-user-label'>" +
											user.associatedUserOrUserGroup.userName +
											"</TD><TD class='um-user-label'>" + user.email +
											"</TD><TD class='um-user-company-col' " + data + ">" +
											userGroup.userGroupName + "</TD>";

									if (showActions) {
										rows += "<TD class='um-user-admin-col' " + data + ">" + adminCol +
												"</TD><TD class='um-user-remove-col' " + data + ">" + deleteSpan +
												"</TD>";
									}else{
										rows += "<TD class='um-user-admin-col' " + data + ">" + adminCol +
										"</TD>";
									}
									rows += "</TR>";

									var userInfo = {};
									userInfo.userName = user.associatedUserOrUserGroup.userName;
									userInfo.email = user.email;
									userInfo.isAdmin = isAdmin ? 'Yes' : 'No';
									userInfo.companyName = userGroup.userGroupName;
									usersList.push(userInfo);
								}
							});
						}
					});
				}
				$('.users-table-body').empty();
				if (rows.length <= 0) {
					rows += "<TR class='user-row'><TD COLSPAN='2'>" + cvUtil.cvLocalize("No_Data_Available") +
							"</TD></TR>";
				}
				$('.users-table-body').append(rows);

			}
			$('.um-user-admin').off('click');
			$('.um-user-admin').on('click', function() {
				var user = $(this).parent().data();

				updateUserInfo(user);

			});
			$('.um-user-delete').off('click');
			$('.um-user-delete').on('click', function() {
				var user = $(this).parent().data();
				if (user.inherited) {
					deleteInheritedUser(user);
				} else {
					$("#um-user-remove-dialog-wrapper").removeClass('hide');
					$(".removeUser").html(cvUtil.cvLocalize('Remove_The_User', user.username));
					$("#err_msg").hide();
					$("#um-user-remove-dialog").dialog({
						width : 440,
						height : 120,
						modal : true,
						resizable : false,
						buttons : [ {
							text : cvUtil.cvLocalize("Cancel"),
							class : "ui-close-button",
							click : function() {
								$(this).dialog("close");
							}
						}, {
							text : cvUtil.cvLocalize("Remove"),
							class : "ui-ok-button",
							click : function() {
								deleteUser(user);
								$(this).dialog("close");
							}
						} ]
					});
				}
			});
			cvUtil.unmask("#um-users-dialog");
		}, function(resp) {
			cvUtil.unmask("#um-users-dialog");
			cvUtil.errorToast(resp.responseText.trim(), null, null, true);
		});
	}

	umExports.usermanagement = {
		matchPwds : matchPwds,
		showViewUsersDialog : showViewUsersDialog,
		showNewUserDialog : showNewUserDialog
	};

	init();

})(window);