var customer = {}, customerInfo = {}, previousCustomerInfo = {}, customerId = 0, companyId = 0;

customer.showCustomerContacts = function(isCustContacts) {
	customer.showContacts(true);
};

customer.submit = function() {
	if (!customer.isValidData()) {
		return;
	}
	// Prepare data parameter object:
	var request = {};
	request.customerId = customerId;
	request.companyId = companyId;
	request.custName = $("#name").val();
	request.paidAccount = $("#paidAccount").is(':checked');
	request.address = $("#address").val();
	request.environment = $("#environment").val();
	request.overview = $("#overview").val();

	// Send request:
	console.debug("Posting ajax request to update customer information");
	var message, action;
	var configURL = cvUtil.getContextPath() + '/reports/handleCustomerInfo.do';
	var data = {
		'json' : JSON.stringify(request)
	};
	if (customerId > 0 || companyId > 0) {
		action = 'modifyCustomer';
		message = customer.modifyCustomer(configURL, data);
	} else {
		action = 'addCustomer';
		message = customer.addCustomer(configURL, data);
	}

	var oldData = {
		'ESPAccount' : (previousCustomerInfo['Paid Account<AccountType>'] == 1),
		'Address' : previousCustomerInfo['Address'],
		'Environment' : previousCustomerInfo['Environment'],
		'Overview' : previousCustomerInfo['Overview']
	};
	var newData = {
		'ESPAccount' : request.paidAccount,
		'Address' : request.address,
		'Environment' : request.environment,
		'Overview' : request.overview
	};
	var changes = JSON.stringify({
		'OldData' : oldData,
		'NewData' : newData
	});
	cvUtil.logUserAction("Profile Customer Information", action, null, "Customer Name=[" + request.custName +
			"] Message=[" + message + "] Changes=[" + changes + "]", "INFO");
	cvUtil.closeModal();
};

customer.modifyCustomer = function(configURL, data) {
	var message;
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug("resp = " + resp);
	});
	if (result.isError) {
		message = cvUtil.cvLocalize('cust.failed_update', result.message);
		showMessage(message, true);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		message = cvUtil.cvLocalize('cust.success_update');
		showMessage(message, false);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

customer.addCustomer = function(configURL, data) {
	var message;
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {

	});
	if (result.isError) {
		message = "Add customer failed : " + result.message;
		showMessage(message, true);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		message = "Customer information added successfully";
		showMessage(message, false);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

customer.isValidData = function() {
	/*
	 * if(!reportsUtil.checkValidateEmail('#email', false)){ return false; }
	 */

	var msg = '';
	var address = $('#address').val();
	if (address != undefined && address.trim().length > 255) {
		msg = cvUtil.cvLocalize("cust.check.address");
	}
	markField('#address', msg);

	if ($('.errorField').length > 0) {
		return false;
	}
	return true;
};

customer.fetchData = function() {
	var model = cvUtil.getInitModalData();
	customerInfo = model;
	previousCustomerInfo = jQuery.extend(true, {}, customerInfo);// Deep copy
	customer.updateUIfromModel(model);
};
customer.updateUIfromModel = function(model) {
	customerId = model['CustomerInfoId<DONOTSHOW>'];
	companyId = model['companyId<DONOTSHOW>'];
	$("#name").val(model['Customer Name<ProfileCustName>']);
	$("#address").val(model['Address']);
	$("#environment").val(model['Environment']);
	$("#overview").val(model['Overview']);
	$('#paidAccount').prop('checked', model['Paid Account<AccountType>'] == 1);
};

function getData() {
	return window.returnData;
}

function showMessage(message, isError) {
	if (isError) {
		cvUtil.errorToast(message, null, null, true);
	} else {
		cvUtil.toast(message, null, null, true);
	}
}
$(document).ready(function() {
	$("#name").prop('disabled', true);
	$("#custInfoForm").bind("keypress", function(e) {
		/*
		 * if (e.keyCode == 13) { return false; }
		 */
	});
	/*
	 * $("#tamdate").datepicker({ dateFormat: "mm/dd/yy", onClose: function(selectedDate){ } });
	 * $("#tamdate").datepicker( "option", "minDate", new Date() ); $("#tamdate").datepicker( "setDate", new
	 * Date() );
	 * 
	 * $("#engdate").datepicker({ dateFormat: "mm/dd/yy", onClose: function(selectedDate){ } });
	 * $("#engdate").datepicker( "option", "minDate", new Date() ); $("#engdate").datepicker( "setDate", new
	 * Date() );
	 */
	$("#name").focus();
	$("#okButton").click(function(e) {
		customer.submit();
	});
	$("#cancelButton").click(function(e) {
		cvUtil.closeModal();
	});
	customer.fetchData();
});
