var custTouch = {}, ccGroupId = 0, companyId = 0, touchId = 0, isCommvaultUser = true, loggedInUser = {};

custTouch.submit = function() {
	if (!custTouch.isValidData()) {
		return;
	}
	// Prepare data parameter object:
	var request = {};
	request.touchId = touchId;
	request.customerId = (ccGroupId > 0) ? ccGroupId : 0;
	request.companyId = companyId;
	request.customerName = $('#customer').val();
	request.custUrl = parent.window.location.href;
	request.custstatus = isCommvaultUser ? -1 : $('#custStatusSldr').slider('value');
	request.cvstatus = isCommvaultUser ? $('#cvInfluSldr').slider('value') : -1;
	request.notes = $('#notes').val();
	if (isCommvaultUser) {
		request.location = $("#tamLocation").val();
		request.daysspent = $('#tamdays').val();
		request.startDate = $("#startDate").val();
		request.endDate = $("#endDate").val();
	} else {
		request.userName = loggedInUser['name'];
		request.userEmail = loggedInUser['email'];
		request.userPhone = loggedInUser['phone'];
		request.userTitle = loggedInUser['title'];
	}
	var action = "";
	var message = "";
	cvUtil.mask();
	var configURL = cvUtil.getContextPath() + '/reports/handleCustomerTouch.do';
	var data = request;//{'json' : JSON.stringify(request)};
	if (touchId > 0) {
		mesage = custTouch.modifyTouch(configURL, data);
		action = "modifyTouch";
	} else {
		message = custTouch.addTouch(configURL, data);
		action = "addTouch";
	}
	cvUtil.logUserAction("Touch", action, null, "CustomId=[" + request.customerId + "] Message=[" + message + "]");
	cvUtil.unmask();
	cvUtil.closeModal();
};

custTouch.addTouch = function(configURL, data) {
	var touchInfo = 'Customer Satisfaction';
	if (isCommvaultUser) {
		touchInfo = 'Customer Touch';
	}
	// Send request:
	console.debug("Posting ajax request to save " + touchInfo + " information");
	var message;
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug("resp = " + resp);
	});
	if (result.isError) {
		if (isCommvaultUser) {
			message = cvUtil.cvLocalize('touch.error.add_touch_fail', result.message);
		} else {
			message = cvUtil.cvLocalize('touch.error.add_cs_fail', result.message);
		}
		console.debug(message);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		if (isCommvaultUser) {
			message = cvUtil.cvLocalize('touch.error.add_touch_success');
		} else {
			message = cvUtil.cvLocalize('touch.error.add_cs_success');
		}
		console.debug(message);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

custTouch.modifyTouch = function(configURL, data) {
	// Send request:
	console.debug("Posting ajax request to save customer touch information");
	var message;
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug(resp);
	});
	if (result.isError) {
		message = "Modify touch failed : " + result.message;
		console.debug(message);
		//showMessage(message, true);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		console.debug("Modify touch result: " + result.isError);
		message = "Touch updated";
		//showMessage(message, false);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

custTouch.isValidData = function() {
	var notes = $('#notes').val();
	var msg = '';
	if (notes === undefined || notes.trim() === '') {
		msg = cvUtil.cvLocalize('touch.error.notes');
	}
	markField('#notes', msg);

	msg = '';
	var daysspent = $('#tamdays').val();
	if (isNaN(daysspent) || daysspent === '') {
		msg = cvUtil.cvLocalize('touch.error.no_days');
	} else if (daysspent <= 0) {
		msg = cvUtil.cvLocalize('touch.error.days_less');
	} else if (daysspent > 180) {
		msg = cvUtil.cvLocalize('touch.error.days_high');
	}
	markField('#tamdays', msg);
	if (isCommvaultUser) {
		msg = '';
		var tsd = $("#startDate").val();
		var ted = $("#endDate").val();
		if (tsd === "" && ted === "") {
			msg = cvUtil.cvLocalize('touch.error.touch_period');
			markField('#startDate', msg);
			markField('#endDate', msg);
		} else if (tsd !== "") {
			if (ted === "") {
				msg = cvUtil.cvLocalize('touch.error.touch_end');
				markField('#startDate', "");
				markField('#endDate', msg);
			}
		} else if (ted !== "") {
			if (tsd === "") {
				msg = cvUtil.cvLocalize('touch.error.touch_start');
				markField('#startDate', msg);
				markField('#endDate', "");
			}
		}
		if (msg === "") {
			if (tsd !== "" && !ValidateDateFormat(tsd)) {
				msg = cvUtil.cvLocalize('touch.error.touch_date_format');
			} else {
				var mToday = moment(new Date());
				var mStart = moment(tsd);
				var diffDays = mToday.diff(mStart, 'days');
				if (diffDays > 180) {
					msg = cvUtil.cvLocalize('touch.error.touch_start');
					markField('#startDate', msg);
				}
			}
			markField('#startDate', msg);
		}

		if (msg === "") {
			if (ted !== "" && !ValidateDateFormat(ted)) {
				msg = cvUtil.cvLocalize('touch.error.touch_date_format');
			}
			markField('#endDate', msg);
		}
	}
	if ($('.errorField').length > 0) {
		return false;
	}
	return true;
};
function ValidateDateFormat(dtValue) {
	//validates MM/DD/YYYY format
	var dtRegex = new RegExp(/\b\d{1,2}[\/]\d{1,2}[\/]\d{4}\b/);
	return dtRegex.test(dtValue);
}
custTouch.fetchData = function() {
	var model = cvUtil.getInitModalData();
	ccGroupId = model['ccGroupId<DONOTSHOW>'];
	companyId = model['companyId<DONOTSHOW>'];
	touchId = model['CustomerTouchId<DONOTSHOW>'];
	isCommvaultUser = model['isCommmvaultUser'];
	loggedInUser = model['loggedInUser'];
	if (ccGroupId > 0 || companyId > 0) {
		var custName = model['Customer Name<ProfileCustName>'];
		$('#customer').val(custName);
		$("#customer").prop('disabled', true);
	}
	custTouch.updateUIfromModel(model);
};

custTouch.updateUIfromModel = function(model) {
	if (touchId > 0) {
		$('#custStatusSldr').slider('value', model['Customer Satisfaction']);
		$('#cvInfluSldr').slider('value', model['Commvault Influence']);
		$('#notes').val(model['Notes']);
		var tamlocation = model['TAM Location<TAMLocation>'];
		$("#tamLocation").find("option[value='" + tamlocation + "']").attr("selected", "selected");
		$('#tamdays').val(model['Days Spent']);
	}

};

function getData() {
	return window.returnData;
}

function initSlider(id, val) {
	$(id).slider({
		min : 1,
		max : 10,
		step : 1,
		value : val
	}).slider("pips", {
		rest : "label"
	}).slider("float");
}

$(document).ready(function() {

	initSlider("#custStatusSldr", 5);
	initSlider("#cvInfluSldr", 5);

	$("#touchForm").bind("keypress", function(e) {
		if (e.keyCode === 13) {
			return false;
		}
	});

	if ($("#startDate").length > 0) {
		$("#startDate").datepicker({
			onClose : function(selectedDate) {
				$("#endDate").datepicker("option", "minDate", selectedDate);
				var mStart = moment(selectedDate);
				var mEnd = moment($("#endDate").val());
				var diffDays = mEnd.diff(mStart, 'days') + 1;
				if (diffDays > 0) {
					$('#tamdays').val(diffDays);
				}
			}
		});
		$("#endDate").datepicker({
			onClose : function(selectedDate) {
				$("#startDate").datepicker("option", "maxDate", selectedDate);

				var mEnd = moment(selectedDate);
				var mStart = moment($("#startDate").val());
				var diffDays = mEnd.diff(mStart, 'days') + 1;
				if (diffDays > 0) {
					$('#tamdays').val(diffDays);
				}
			}
		});
		var today = new Date();
		var todayStr = today.format('MM/dd/yyyy');
		$("#startDate").val(todayStr);
		$("#endDate").val(todayStr);

		today.setDate(today.getDate() - 179);
		$("#startDate").datepicker("option", "minDate", today.format('MM/dd/yyyy'));
		$("#startDate").datepicker("option", "maxDate", todayStr);
		$("#endDate").datepicker("option", "maxDate", todayStr);
	}

	$("#customer").focus();
	$("#okButton").click(function() {
		custTouch.submit();
	});
	$("#cancelButton").click(function() {
		cvUtil.closeModal();
	});

	custTouch.fetchData();
});
