var custContact = {}, actualModel, previousContacts, previousContractDates, customerInfo, currentModel = [], contactId = -1, isCustContacts = false, actualDates = [];
var groupIdMap = {
	0 : '',
	1 : 'Management',
	2 : 'Project Managers',
	3 : 'Operations',
	4 : 'Commvault'
};
var groupNameMap = {
	'' : 0,
	'Management' : 1,
	'Project Managers' : 2,
	'Operations' : 3,
	'Commvault' : 4
};

custContact.init = function() {
	
	$('.resetContact').click(function(e){
		custContact.resetContact();
	});
	
	$('.addUpdateContact').click(function(e){
		custContact.addUpdateContact();
	});
	$('#userTitleSelect').change(function(e){
		this.nextElementSibling.value=this.value;
	});
	

	$("input:radio[name=contactType]").click(function(e) {
		isCustContacts = ($(this).val() == 2);

		if (isCustContacts) {
			$('#name').show();
			$('#title').show();
			$("#category").prop('disabled', false);
			$("#emails").prop('disabled', false);
			var options = "<option value='1'>Management</option>";
			options += "<option value='2'>Project Managers</option>";
			options += "<option value='3'>Operations</option>";
			$("#category").html(options);
			$('#userContact').hide();
			//$('#userTitle').hide();
			//$('#userTitleSelect').hide();
			$('.select-editable').hide();
		} else {
			$('#userContact').show();
			//$('#userTitle').show();
			//$('#userTitleSelect').show();
			$('.select-editable').show();
			$("#category").html("<option value='4'>Commvault</option>");
			$("#category").val(4);
			$("#category").prop('disabled', true);
			$("#emails").prop('disabled', true);
			$('#name').hide();
			$('#title').hide();

		}
		if (!customerInfo.isCommmvaultUser && !isCustContacts) {
			$('#emails').hide();
			$('#emailsLabel').hide();
			$('#custContactsForm').addClass('disabled');
			$('.contactOpts').addClass('disabled');
		} else {
			$('#emails').show();
			$('#emailsLabel').show();
			$('#custContactsForm').removeClass('disabled');
			$('.contactOpts').removeClass('disabled');

		}
		custContact.resetContact();
		custContact.refreshContacts();
		if (!customerInfo.isCommmvaultUser) {
			$('#contractDates').addClass('disabled');
		}
	});

};

custContact.updateUIfromModel = function(contact) {
	$('#custContactsForm input').removeClass('errorField');
	$('#custContactsForm select').removeClass('errorField');
	if (!contact) {
		contact = {};
		contact['primaryContact'] = false;
		contact['userId'] = 0;
		contact['contactId'] = 0;
		$("#contactsList tr").removeClass("selected");
		$("#contactMask").removeClass("editOn").addClass("addOn");
		$(".addUpdateContact").text('Add');
		if (!isCustContacts) {
			contact['group'] = 4;
		}
	} else {
		$("#contactMask").removeClass("addOn").addClass("editOn");
		$(".addUpdateContact").text('Update');
	}
	if (isCustContacts) {
		$("#name").attr('data-userid', contact['userId']);
		$("#name").attr('data-contactid', contact['contactId']);
		$("#name").val(contact['name']);
		$("#title").val(contact['title']);
		$("#emails").prop('disabled', contact['userId'] > 0);
		$("#name").prop('disabled', contact['userId'] > 0);
	} else {
		$("#userContact").val(contact['userId']);
		$("#userContact").attr('data-contactid', contact['contactId']);
		$("#userTitle").val(contact['title']);
	}

	$('#primaryContact').prop('checked', contact['primaryContact']);
	$("#emails").val(contact['email']);
	$("#phone").val(contact['phone']);

	$("#category").val(contact['group']);
};

custContact.resetContact = function() {
	contactId = -1;
	custContact.updateUIfromModel();
};

custContact.addUpdateContact = function() {
	if (!custContact.isValidData()) {
		return false;
	}
	var contact = {};
	if (contactId > -1) {
		contact.id = contactId;
		custContact.deleteContact(contactId);
	} else {
		var maxId = 0;
		for (var i = 0; i < actualModel.length; i++) {
			if (actualModel[i]['id'] > maxId) {
				maxId = actualModel[i]['id'];
			}
		}
		contact.id = maxId + 1;
	}
	//console.log("contact id = " + contact.id);
	if (isCustContacts) {
		contact.userId = $("#name").attr('data-userid');//$("#name").data('userid');
		contact.contactId = $("#name").attr('data-contactid');//$("#name").data('contactid');
		contact.name = $("#name").val();
		contact.title = $("#title").val();
	} else {
		contact.userId = $("#userContact").val();
		contact.contactId = $("#userContact").attr('data-contactid');//$("#userContact").data('contactid');
		contact.name = $("#userContact option:selected").text();
		contact.title = $("#userTitle").val();
	}

	contact.phone = $("#phone").val();
	contact.email = $("#emails").val();
	contact.primaryContact = $("#primaryContact").is(':checked');

	contact.group = $("#category").val();
	contact.status = 0;
	contact.actionEdit = 1;
	contact.actionDelete = contact.userId > 0 ? 0 : 1;

	actualModel.push(contact);
	custContact.refreshContacts();
	custContact.resetContact();
};

custContact.deleteContact = function(id) {
	var index = -1;
	for (var i = 0; i < actualModel.length; i++) {
		if (actualModel[i]['id'] == id) {
			index = i;
			break;
		}
	}
	if (index > -1) {
		actualModel.splice(index, 1);
		custContact.refreshContacts();
	}

};

custContact.getContractDates = function() {
	var contractDates = [], index = -1, tam, eng;
	$.each(actualDates, function(i, contract) {
		if (contract['contractType<ContractType>'] == 1) {
			tam = contract;
		} else if (contract['contractType<ContractType>'] == 2) {
			eng = contract;
		}
	});
	var tamContractId = 0;
	if (tam) {
		tamContractId = tam['contractId'];
	}
	var tsd = $("#tamStartDate").val();
	if (tsd) {
		var ted = $("#tamEndDate").val();
		var add = true;
		if (tamContractId > 0) {
			if (tam['Start Date<MMMDDYYYY>'] == tsd && tam['End Date<MMMDDYYYY>'] == ted) {
				add = false;
			}
		}
		if (add) {
			index++;
			var contract = {};
			contract.contractType = 1;
			contract.contractId = tamContractId;
			contract.startDate = tsd;
			contract.endDate = ted;
			contractDates[index] = contract;
		}
	}

	var engContractId = 0;
	if (eng) {
		engContractId = eng['contractId'];
	}
	var esd = $("#engStartDate").val();
	if (esd) {
		var eed = $("#engEndDate").val();
		var add = true;
		if (engContractId > 0) {
			if (eng['Start Date<MMMDDYYYY>'] == esd && eng['End Date<MMMDDYYYY>'] == eed) {
				add = false;
			}
		}
		if (add) {
			index++;
			var contract = {};
			contract.contractType = 2;
			contract.contractId = engContractId;
			contract.startDate = esd;
			contract.endDate = eed;
			contractDates[index] = contract;
		}
	}
	return contractDates;

};

custContact.enableContractDates = function() {
	var enableTam = false, enableEngineer = false;
	for (var i = 0; i < actualModel.length; i++) {
		if (actualModel[i]['title'].toUpperCase() == 'TAM') {
			enableTam = true;
		} else if (actualModel[i]['title'].toUpperCase() == 'ENGINEER') {
			enableEngineer = true;
		}
	}

	$("#tamStartDate").prop('disabled', !enableTam);
	$("#tamEndDate").prop('disabled', !enableTam);
	if (!enableTam) {
		$("#tamStartDate").val("");
		$("#tamEndDate").val("");
	}

	$("#engStartDate").prop('disabled', !enableEngineer);
	$("#engEndDate").prop('disabled', !enableEngineer);

	if (!enableEngineer) {
		$("#engStartDate").val("");
		$("#engEndDate").val("");
	}
};
custContact.updateActualModelForSubmit = function() {
	//This is for external commvault users check.
	//Will submit these contacts only if property(primary contact, phone, title or team) get changed.
	$.each(previousContacts,
			function(i, pContact) {
				var idx = -1;
				var deleted = true;
				for (var j = 0; j < actualModel.length; j++) {
					if (actualModel[j]['userId'] == pContact['userId'] &&
							actualModel[j]['contactId'] == pContact['contactId']) {
						deleted = false;
						if (actualModel[j]['group'] == pContact['group'] &&
								actualModel[j]['phone'] == pContact['phone'] &&
								actualModel[j]['title'] == pContact['title'] &&
								actualModel[j]['primaryContact'] == pContact['primaryContact']) {
							idx = j;
							break;
						}

					}
				}
				if (idx > -1) {//remove unmodified contact from model
					actualModel.splice(idx, 1);
				}
				if (deleted == true) {
					pContact.status = 1;//delete
					actualModel.push(pContact);
				}
			});
}

custContact.submit = function() {
	if (!custContact.isValidContractDates()) {
		return false;
	}
	// Prepare data parameter object:
	custContact.updateActualModelForSubmit();
	var request = {};
	request.customerId = customerInfo['CustomerInfoId<DONOTSHOW>'];
	request.companyId = customerInfo['CompanyId<DONOTSHOW>'];
	request.contacts = actualModel;
	request.contractDates = custContact.getContractDates();

	// Send request:
	console.debug("Posting ajax request to update customer contacts information");
	var configURL = cvUtil.getContextPath() + '/reports/saveCustomerContacts.do';
	var message, action = 'Update Contacts';
	var data = {
		'json' : JSON.stringify(request)
	};
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug("resp = " + resp);
	});
	if (result.isError) {
		message = cvUtil.cvLocalize('contact.error.update', result.message);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		message = cvUtil.cvLocalize('contact.error.success');
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	var changes = JSON.stringify({
		'OldContacts' : custContact.getContactListForLog(previousContacts),
		'ModifiedContacts' : custContact.getContactListForLog(actualModel),
		'OldContractDates' : previousContractDates,
		'NewContractDates' : request.contractDates
	});
	cvUtil.logUserAction("Profile Contacts", action, null, "Customer Name=[" + request.custName + "] Message=[" +
			message + "] Changes=[" + changes + "]", "INFO");
	cvUtil.closeModal();
};

custContact.getContactListForLog = function(contacts) {
	var resp = [];
	var i = 0;
	$.each(contacts, function(i, obj) {
		resp[i++] = {
			'Name' : obj.name,
			'Phone' : obj.phone,
			'Email' : obj.email,
			'PrimaryContact' : obj.primaryContact,
			'Title' : obj.title,
			'Team' : groupIdMap[parseInt(obj.group)],
			'Status' : obj.status
		};
	});
	return resp;
};

custContact.isValidContractDates = function() {
	var msg = '';

	var tsd = $("#tamStartDate").val();
	var ted = $("#tamEndDate").val();
	if (tsd != "") {
		if (ted == "") {
			msg = cvUtil.cvLocalize('contact.error.tam_end_date');
			markField('#tamStartDate', "");
			markField('#tamEndDate', msg);
		}
	} else if (ted != "") {
		if (tsd == "") {
			msg = cvUtil.cvLocalize('contact.error.tam_start_date');
			markField('#tamStartDate', msg);
			markField('#tamEndDate', "");
		}
	}
	if (msg == "") {
		if (tsd != "" && !ValidateDateFormat(tsd)) {
			msg = cvUtil.cvLocalize('contact.error.date_format');
		}
		markField('#tamStartDate', msg);
	}

	if (msg == "") {
		if (ted != "" && !ValidateDateFormat(ted)) {
			msg = cvUtil.cvLocalize('contact.error.date_format');
		}
		markField('#tamEndDate', msg);
	}

	msg = "";
	var esd = $("#engStartDate").val();
	var eed = $("#engEndDate").val();
	if (esd != "") {
		if (eed == "") {
			msg = cvUtil.cvLocalize('contact.error.eng_end_date');
			markField('#engStartDate', "");
			markField('#engEndDate', msg);
		}
	} else if (eed != "") {
		if (esd == "") {
			msg = cvUtil.cvLocalize('contact.error.eng_start_date');
			markField('#engStartDate', msg);
			markField('#engEndDate', "");
		}
	}
	if (msg == "") {
		if (esd != "" && !ValidateDateFormat(esd)) {
			msg = cvUtil.cvLocalize('contact.error.date_format');
		}
		markField('#engStartDate', msg);
	}
	if (msg == "") {
		if (eed != "" && !ValidateDateFormat(eed)) {
			msg = cvUtil.cvLocalize('contact.error.date_format');
		}
		markField('#engEndDate', msg);
	}

	if ($('#contractDates .errorField').length > 0) {
		return false;
	}
	return true;
};

function ValidateDateFormat(dtValue) {
	//validates MM/DD/YYYY format
	var dtRegex = new RegExp(/\b\d{1,2}[\/]\d{1,2}[\/]\d{4}\b/);
	return dtRegex.test(dtValue);
}

custContact.isValidData = function() {
	var msg = '';
	if (isCustContacts) {
		var name = $('#name').val();
		if (name == undefined || name.trim() == '') {
			msg = cvUtil.cvLocalize('contact.error.no_name');
		} else {
			if (name.length > 126) {
				msg = cvUtil.cvLocalize('contact.error.name_length');
			}
		}
		markField('#name', msg);
		validateEmail(false);
		if ($('#custContactsForm #emails .errorField').length <= 0) {
			var emails = $("#emails").val();
			emails = emails.replace(/[\s,;]+/g, ';'); //replace all whitespaces, comma and semicolons with a single semicolon
			var emailList = emails.split(';');
			if (emailList == null) { //defensive
				emailList = emails;
			}
			var emailError = false;
			$.each(emailList, function(index, value) {
				if (value) {
					value = $.trim(value);
					if (value.toLowerCase().indexOf('@commvault.com') > 0) {
						emailError = true;
					}
				}
			});
			if (emailError) {
				msg = cvUtil.cvLocalize('contact.error.cv_email');
				markField('#emails', msg);
			}
		}
		msg = '';
		var title = $('#title').val();
		if (title == undefined || title.trim() == '') {
			msg = cvUtil.cvLocalize('contact.error.title');
		}
		markField('#title', msg);

		msg = '';
		var team = $("#category").val();
		if (team == undefined || parseInt(team) <= 0) {
			msg = cvUtil.cvLocalize('contact.error.team');
		}
		markField('#category', msg);
	} else {
		var userContact = $('#userContact').val();
		if (userContact == undefined || userContact <= 0) {
			msg = cvUtil.cvLocalize('contact.error.name_select');
		}
		markField('#userContact', msg);

		msg = '';
		var title = $('#userTitle').val();
		if (title == undefined || title.trim() == '') {
			msg = cvUtil.cvLocalize('contact.error.title');
		}
		markField('#userTitleSelect', msg);
	}
	reportsUtil.checkValidPhoneNumber('#phone', false);
	if ($('#custContactsForm .errorField').length > 0) {
		return false;
	}
	return true;
};

custContact.loadData = function() {
	customerInfo = cvUtil.getInitModalData();

	var actualModelTemp = jQuery.extend(true, {}, customerInfo['Contacts']);// Deep copy
	actualModel = [];
	if (actualModelTemp !== undefined) {
		$.each(actualModelTemp, function(i, contact) {
			actualModel.push(contact);
		});
	}
	previousContacts = jQuery.extend(true, {}, customerInfo['Contacts']);// Deep copy
	isCustContacts = customerInfo['isCustContacts'];

	//if(!isCustContacts){
	var request = {};
	request.ccGroupId = customerInfo['CustomerInfoId<DONOTSHOW>'];
	request.companyId = customerInfo['companyId<DONOTSHOW>'];
	console.debug("Posting ajax request to fetch contacts information");
	var configURL = cvUtil.getContextPath() + '/reports/getContactsInfo.do';
	//cvUtil.mask();
	var isError = false;
	cvUtil.loadPageWithPOST(configURL, request, function(resp) {
		if (resp) {
			var options = "<option value=0></option>";
			$.each(resp.cvUsers, function(i, user) {
				options += "<option value=" + user.id + " data-email=" + user.email + ">" + user.name + "</option>";
			});
			$("#userContact").html(options);
			$("#userContact").change(function(e) {
				var email = $('option:selected', this).attr('data-email');
				$('#emails').val(email);
				//console.log(email);
			});

			if (resp.dates) {
				$.each(resp.dates, function(i, contract) {
					var valid = false;
					var d = parseInt(contract['End Date<MMMDDYYYY>']) * 1000;
					if (d) {
						var end = moment(d).format("MM/DD/YYYY");
						var today = moment(new Date()).format("MM/DD/YYYY");
						var mToday = moment(today);
						var mEnd = moment(end);
						var diff = mToday.diff(mEnd, 'days');
						if (diff <= 0) {
							valid = true;
						}
						resp.dates[i]['End Date<MMMDDYYYY>'] = moment(d).format("MM/DD/YYYY");
					}
					d = parseInt(contract['Start Date<MMMDDYYYY>']) * 1000;
					if (d) {
						resp.dates[i]['Start Date<MMMDDYYYY>'] = moment(d).format("MM/DD/YYYY");
					}
					if (valid === true) {
						actualDates[actualDates.length] = resp.dates[i];
						previousContractDates = jQuery.extend(true, {}, resp.dates[i]);// Deep copy
					}
				});

			}
			custContact.updateDatesUI();
			custContact.enableContractDates();
		}
	});
	//}
	//custContact.updateUIfromModel();
	//custContact.initTable(actualModel);
	custContact.init();
	if (!customerInfo.isCommmvaultUser) {
		$("#customer").attr("checked", true).trigger('click');
	} else {
		$("#commvault").attr('checked', isCustContacts).trigger('click');
	}

};

custContact.updateDatesUI = function() {
	if (actualDates) {
		$.each(actualDates, function(i, contract) {
			if (contract['contractType<ContractType>'] == 1) {
				$("#tamStartDate").val(contract['Start Date<MMMDDYYYY>']);
				$("#tamEndDate").val(contract['End Date<MMMDDYYYY>']);
			} else if (contract['contractType<ContractType>'] == 2) {
				$("#engStartDate").val(contract['Start Date<MMMDDYYYY>']);
				$("#engEndDate").val(contract['End Date<MMMDDYYYY>']);
			}
		});
	}
};

custContact.updateModels = function() {
	currentModel.length = 0;
	for (var i = 0; i < actualModel.length; i++) {
		if (isCustContacts) {
			if (actualModel[i]['group'] != 4) {
				currentModel.push(actualModel[i]);
			}
		} else {
			if (actualModel[i]['group'] == 4) {
				currentModel.push(actualModel[i]);
			}
		}
	}
};

custContact.refreshContacts = function() {
	custContact.updateModels();
	custContact.initTable(currentModel);
	custContact.enableContractDates();
};

function getData() {
	return window.returnData;
}

/*
 * function showMessage(message, isError){ if(isError) cvUtil.errorToast(message, null, null, true); else
 * cvUtil.toast(message, null, null, true); }
 */

custContact.initTable = function(model) {
	var data = {};
	data.aaData = model;
	data.iDisplayLength = -1;
	var config = {
		"aoColumns" : [ {
			"sTitle" : cvUtil.cvLocalize('contact.name'),
			"mDataProp" : "name"
		}, {
			"sTitle" : cvUtil.cvLocalize('contact.title'),
			"mDataProp" : "title"
		}, {
			"sTitle" : cvUtil.cvLocalize('contact.team'),
			"mDataProp" : "group",
			"fnRender" : function(o, val) {
				val = parseInt(val);
				return groupIdMap[val];
			}
		}, {
			"sTitle" : '',
			"sClass" : "editTd",
			"mDataProp" : "actionEdit",
			"sDefaultValue" : "1",
			"fnRender" : function(o, val) {
				if (!customerInfo.isCommmvaultUser && !isCustContacts) {
					return '';
				}
				return '<img src="../../vmprovisioning/img/edit.png" width="17px" height="17px"/>';
			}
		}, {
			"sTitle" : '',
			"sClass" : "deleteTd",
			"mDataProp" : "actionDelete",
			"sDefaultValue" : "1",
			"fnRender" : function(o, val) {
				if (!customerInfo.isCommmvaultUser && !isCustContacts) {
					return '';
				}
				val = parseInt(val);
				if (isCustContacts && val == 0) {
					return '';
				}
				return '<img src="../../vmprovisioning/img/delete.png" width="17px" height="17px"/>';
			}
		} ],
		"sDom" : ""
	};
	oTable = Table.configureTable('contactsList', "Contacts", data, cvUtil.cvLocalize('No_Data_Available'), config);

	$("#contactsList").off("click", "tbody td:not(.deleteTd)");
	$("#contactsList").on("click", "tbody td:not(.deleteTd)", function() {
		var tr = $(this).closest('tr');
		$(".selected").removeClass("selected");
		$(tr).addClass("selected");
		var tc = oTable.fnGetData(tr[0]);
		if (tc != null) {
			if (!customerInfo.isCommmvaultUser && !isCustContacts) {
				return;
			}
			var tempContact = jQuery.extend(true, {}, tc);// Deep copy
			contactId = tc.id;
			tempContact.group = groupNameMap[tc.group];
			custContact.updateUIfromModel(tempContact);
		}
	});
	$("#contactsList").off("click", "tbody td.deleteTd");
	$("#contactsList").on("click", "tbody td.deleteTd", function() {
		var tempContact = oTable.fnGetData($(this).closest('tr')[0]);
		if (tempContact != null) {
			if (isCustContacts && tempContact.userId > 0) {
				return;
			}
			custContact.deleteContact(tempContact.id);
		}
	});
	if (data.aaData && data.aaData.length <= 0) {
		$("#contactsList_table .dataTables_empty").text(cvUtil.cvLocalize('No_Data_Available'));
	}

};

$(document).ready(function() {

	$("#tamStartDate").datepicker({
		onClose : function(selectedDate) {
			$("#tamEndDate").datepicker("option", "minDate", selectedDate);
		}
	});
	$("#tamEndDate").datepicker({
		onClose : function(selectedDate) {
			$("#tamStartDate").datepicker("option", "maxDate", selectedDate);
		}
	});
	$("#engStartDate").datepicker({
		onClose : function(selectedDate) {
			$("#engEndDate").datepicker("option", "minDate", selectedDate);
		}
	});
	$("#engEndDate").datepicker({
		onClose : function(selectedDate) {
			$("#engStartDate").datepicker("option", "maxDate", selectedDate);
		}
	});

	$("#name").focus();
	$("#okButton").click(function(e) {
		custContact.submit();
	});
	$("#cancelButton").click(function(e) {
		window.returnData = {
			'cancel' : true
		};
		cvUtil.closeModal();
	});
	custContact.loadData();

});