var commUniId = cvUtil.getParameter('commUniId', 0);
var ccGroupId = cvUtil.getParameter('ccGroupId', 0);
var companyId = cvUtil.getParameter('companyId', 0);

function ProfileFeedbackDetails() {
	var customerName = "";

	this.report = new Reports.initReport({
		type : 'profilefeedbackdetails',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			requestString["commUniId"] = commUniId;
		}
		if (ccGroupId > 0) {
			requestString["ccGroupId"] = ccGroupId;
		}
		if (companyId > 0) {
			requestString["companyId"] = companyId;
		}
	};

	report.initComponents = function() {
		if ((ccGroupId > 0 || companyId > 0)&& $('#breadcrumbMain .profileDashboardLi').length == 0) {
			var params = '?';
			if (ccGroupId > 0) {
				params += '&ccGroupId=' + ccGroupId;
			}
			if (commUniId > 0) {
				params += '&commUniId=' + commUniId;
			}
			if (companyId > 0) {
				params += '&companyId=' + companyId;
			}
			params = params.replace('?&', '');
			var profileURL = cvUtil.getContextPath() + '/survey/profile/profilecustdashboard.jsp?' + params;
			var a = '<a class="smartLinkMain commcellsLink" href="' + profileURL + '">' +
					cvUtil.cvLocalize("profile.Profile_Dashboard") + '</a>';
			$('#breadcrumbMain')
					.append('<li class="secTitleClickable smartlinkMain withSeparatorMain profileDashboardLi">' + a +
							'</li>');
		}
		$("#surveyName").html(localMsg_Customer_Satisfaction);
	};

	report.initComponentState = function() {
		$("#exportcsv").hide();
		$("#commcellUrl").hide();
		updateFilters();
	};
	report.beforeLoadReport = function() {
		report.mask("");
	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/reports/fetchFeedbackDetails.do?ccGroupId=' + ccGroupId + '&companyId=' +
				companyId;
	};
	report.getExportFilePrefix = function() {
		var filePre = "ProfileCustomerSatisfaction";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}

		return filePre;
	};
	report.onLoadReport = function(data) {
		processResponse(data);
		report.attachTableActions();
		report.afterLoadReport();
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(resp) {
		if (resp == undefined || resp == null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else if (resp && typeof resp === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel").html(data);
			$("#noDataNotificationPanel").show();
		} else {
			if (resp && typeof resp === 'object') {
				if (resp.data.custFeedbackList) {
					processTable('custFeedbackTable', localMsg_Customer_Satisfaction, resp.data.custFeedbackList);
				}
				if (resp.data.cvFeedbackList) {
					processTable('cvFeedbackTable', localMsg_Commvault_Influence, resp.data.cvFeedbackList);
				}
			}

		}
	}

	function processTable(tableDiv, title, data) {
		var view = {};
		view.members = data;
		view.collapsible = true;
		view.filters = true;
		view.exportExcel = true;
		view.alarm = true;
		view.title = title;

		var wrapperId = 'ContentWrapper';
		$('#' + wrapperId).append(SurveyTemplates.makeReportTable(tableDiv, view));

		var tdata = view.members;
		tdata.iDisplayLength = 100;
		setFilterRendered(tdata.aoColumns);
		var configTable = true;
		if ((!tdata.aoColumns || tdata.aoColumns.length == 0) &&
				(!tdata.aoColumnDefs || tdata.aoColumnDefs.length == 0)) {
			configTable = false;
		}
		if (configTable) {
			Reports.configureClientSideTableWithPaging(tableDiv, view.title, tdata);
		}
		$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
		var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
		pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
	}

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}
}

function setFilterRendered(aoColumns) {
	var renderersResultingURLs = [ "TAMLocation", "MMMDDYYYY" ];
	for (var i = 0; i < aoColumns.length; i++) {
		var renderer = aoColumns[i].rendererType;
		if (typeof renderer != 'undefined') {
			if ($.inArray(renderer, renderersResultingURLs) > -1) {
				aoColumns[i].bFilterRendered = false;
			}
		}
	}
}

function showProfileErrorMsg(msg) {
	$("#ContentWrapper").hide();
	$("#profileErrorMsg").text(msg);
	$("#noDataNotificationPanel").show();
}

$(document).ready(function() {
	$("#surveyName").html(localMsg_Customer_Satisfaction);
	window.reportEnum = "Survey";
	if (ccGroupId <= 0 && companyId <= 0) {
		showProfileErrorMsg(localMsg_Invalid_CommCell_Group_Id);
		return;
	}

	if (ccGroupId > 0) {
		var configURL = "survey.do?action=CommCellDetailsUid&ccGroupId=" + ccGroupId + "&companyId=" + companyId;
		cvUtil.loadPageWithPOST(configURL, null, function(output) {
			var data = output;//jQuery.parseJSON(output);
			if (data.error) {
				showProfileErrorMsg(data.error);
			} else {
				var cgName = reportsUtil.getTruncatedName(data.GroupName);
				customerName = data.GroupName;
				$('#custName').html(cgName + " - ");
				$('#custName').attr('title', data.GroupName);
				$('.reportsLink').text(data.GroupName + ' (' + localMsg_Reports + ')');
				$(document).attr("title", data.GroupName + " - " + localMsg_Customer_Satisfaction);
				cvUtil.GUIAuditReportLog("Profile Customer Satisfation Details", data.GroupName);
			}
		}, function(err) {
			cvUtil.errorToast(err.responseText.trim(), null, null, true);
		});
	} else if (companyId > 0) {
		var configURL = "getCompanyInfo.do?companyId=" + companyId;
		cvUtil.loadPageWithGET(configURL, null, function(output) {
			if (output.data && output.data.company) {
				var company = output.data.company;
				var cgName = reportsUtil.getTruncatedName(company.company.userGroupName);
				customerName = company.company.userGroupName;
				$('#custName').html(cgName + " - ");
				$('#custName').attr('title', customerName);
				$('.reportsLink').text(customerName + ' (' + localMsg_Reports + ')');
				$(document).attr("title", customerName + " - " + localMsg_Customer_Satisfaction);
				cvUtil.GUIAuditReportLog("Profile Customer Satisfation Details", customerName);
			}
		}, function(err) {
			cvUtil.errorToast(err.responseText.trim(), null, null, true);
		});
	}
	if (showProfileDashboard) {
		if (companyId > 0) {
			ProfileFeedbackDetails();
		} else {
			var request = {};
			request.ccGroupId = ccGroupId;
			request.companyId = companyId;
			var configURL = cvUtil.getContextPath() + '/reports/getProfileEnabledForGroup.do';
			cvUtil.loadPageWithPOST(configURL, request, function(resp) {
				if (resp) {
					if (resp.enabledProfile == undefined || resp.enabledProfile == false) {
						showProfileErrorMsg(localMsg_Profile_disabled);
					} else {
						ProfileFeedbackDetails();
					}
				}
			}, function(err) {
				showProfileErrorMsg(err.responseText.trim());
			});
		}
	} else {
		showProfileErrorMsg(localMsg_Profile_not_configured);
	}
});
