var notification = {}, notificationId = 0, ccGroupId = 0, companyId = 0, ccGroupName;

notification.initUI = function() {
	$("input[name=freqType]:radio").change(function(ele) {
		if ($("input[name='freqType']:checked").val() == '1') {
			$('#daysSpinner').prop('disabled', false);
			$('#daysToRunList input[type="checkbox"]').prop('disabled', true);
		} else {
			$('#daysToRunList input[type="checkbox"]').prop('disabled', false);
			$('#daysSpinner').prop('disabled', true);
		}
	});
	$("input[name=enableNotif]:checkbox").change(function(ele) {
		if ($("input[name='enableNotif']:checked").val() == '1') {
			notification.enableDisableComp([
					'input[name="freqType"]',
					'#daysToRunList input[type="checkbox"]',
					'#daysSpinner',
					'#dueDaysSpinner' ], true);
		} else {
			notification.enableDisableComp([
					'input[name="freqType"]',
					'#daysToRunList input[type="checkbox"]',
					'#daysSpinner',
					'#dueDaysSpinner' ], false);
		}
	});
	$("input[name='freqType'][value='2']").click();
	notification.fetchData();
};

notification.enableDisableComp = function(components, enable) {
	$.each(components, function(i, comp) {
		$(comp).prop('disabled', !enable);
	});
};

notification.updateUIwithModel = function(data) {
	//$("input[name='freqType'][value="+data.notifyType+"]").prop("checked", true);
	if (data.notifyType == '0') {//disabled notifications
		$("input[name='enableNotif']").click();
	} else {
		if (data.notifyType == '1') {
			$('#daysSpinner').val(data.repeatNdays);
		} else {
			if (data.weekdays) {
				var daysArr = data.weekdays.split(';');
				$.each(daysArr, function(i, val) {
					var name = 'day' + val;
					$("input[name=" + name + "]").prop("checked", true);
				});
			}
		}
		$('#dueDaysSpinner').val(data.nDaysPriorDueDate);
		$("input[name='freqType'][value=" + data.notifyType + "]").click();
	}
};

notification.submit = function() {
	if (!notification.isValidData()) {
		return;
	}
	// Prepare data parameter object:
	var request = {};
	request.ccGroupId = ccGroupId;
	request.companyId = companyId;
	request.ccGroupName = ccGroupName;
	request.operationType = 'MODIFY';
	/*
	 * var freqType = $("input[name='freqType']:checked").val(); request.freqType=freqType; if(freqType ==
	 * '1'){//daily request.nDays = $("#daysSpinner").val(); }else{//weekdays } request.nDueDays =
	 * $("#dueDaysSpinner").val();
	 */
	var formFields = $('form').serializeArray();
	jQuery.each(formFields, function(i, field) {
		request[field.name] = field.value;
	});

	var configURL = cvUtil.getContextPath() + '/reports/handleProfileNotification.do';
	var data = request;//{'json' : JSON.stringify(request)};
	var mesage = notification.modifyNotification(configURL, data);
	var action = "modifyNotification";
	cvUtil.logUserAction("ProfileNotification", action, null, '');
	notification.exitTaskDialog();
};

notification.modifyNotification = function(configURL, data) {
	// Send request:
	console.debug("Posting ajax request to update Notification information");
	var isError = false;
	var message = '';
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		console.debug(resp);
	});
	if (result.isError) {
		message = cvUtil.cvLocalize('notification.error.modify_failed', result.message);
		console.debug(message);
		//showMessage(message, true);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		console.debug("Modify Notification result: " + result.isError);
		message = cvUtil.cvLocalize('notification.error.modify_success');
		//showMessage(message, false);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

notification.isValidData = function() {
	var msg = '';

	var freqType = $("input[name='freqType']:checked").val();
	if (freqType == '1') {//daily
		var nDays = $("#daysSpinner").val();
	} else {//weekdays
		if ($('#daysToRunList input[type="checkbox"]:checked').length <= 0) {

		}
	}
	var nDueDays = $("#dueDaysSpinner").val();

	/*
	 * markField('#duedate', msg);
	 * 
	 * msg = ''; var summary = $('#summary').val(); if(summary == undefined || summary.trim() == ''){ msg =
	 * 'Enter task name'; } markField('#summary', msg);
	 */

	if ($('.errorField').length > 0) {
		return false;
	}
	return true;
};

notification.fetchData = function() {
	var modal = cvUtil.getInitModalData();
	ccGroupId = modal['CustomerInfoId<DONOTSHOW>'];
	ccGroupName = modal['Customer Name<ProfileCustName>'];
	companyId = modal['companyId<DONOTSHOW>'];

	var request = {};
	request.customerId = ccGroupId;
	request.companyId = companyId;

	console.debug("Posting ajax request to fetch notification information");
	var configURL = cvUtil.getContextPath() + '/reports/fetchNotificationsById.do';
	cvUtil.mask();
	var isError = false;
	cvUtil.loadPageWithPOST(configURL, request, function(resp) {
		if (resp && resp.notifInfo) {
			if (resp.notifInfo.length > 0) {
				var tempList = resp.notifInfo;
				var notifInfo = {};
				$.each(tempList, function(key, val) {
					notifInfo[val.attrName] = val.attrVal;
				});
				notification.updateUIwithModel(notifInfo);
			} else {
				$("input[name='enableNotif']").click();//disabled notifications
			}
		}
		cvUtil.unmask();
	});

};

notification.exitTaskDialog = function(forceReload) {
	cvUtil.closeModal();
};

function getData() {
	return window.returnData;
}

$(document).ready(function() {
	notification.initUI();

	$("#okButton").click(function(e) {
		notification.submit();
	});
	$("#cancelButton").click(function(e) {
		cvUtil.closeModal();
	});
	$("#closeButton").click(function() {
		window.returnData = {
			'isError' : false,
			'cancel' : true
		};
		notification.exitTaskDialog();
	});

});