var feedback = {}, ccGroupId = 0, companyId = 0, ccGroupName, contactsList, isConfiguredQuarterly, totalContacts = 0;

feedback.initUI = function() {

	var modal = cvUtil.getInitModalData();
	ccGroupId = modal['ccGroupId'];
	companyId = modal['companyId'];
	ccGroupName = modal['CustomerName'];
	contactsList = modal['contacts'];

	if (contactsList) {
		var tableBody = '';
		var listBody = '';
		var groupIdMap = {
			'0' : '',
			'1' : 'Management',
			'2' : 'Project Managers',
			'3' : 'Operations',
			'4' : 'Commvault'
		};
		for (var i = 0; i < contactsList.length; i++) {
			if (contactsList[i]['group'] != 4 && contactsList[i]['email'].length > 0) {
				var primary = contactsList[i]['primaryContact'] ? 'Yes' : 'No';
				var data = "data-name='" + contactsList[i]['name'] + "' data-email='" + contactsList[i]['email'] +
						"' data-userid='" + contactsList[i]['userId'] + "' data-contactid='" +
						contactsList[i]['contactId'] + "'";
				var id = contactsList[i]['userId'] + '_' + contactsList[i]['contactId'];
				tableBody += '<TR>';
				tableBody += '<TD><input type="checkbox" name="contactschks" class="contactChk" id=' + id + ' ' + data +
						'/></TD>';
				tableBody += '<TD>' + contactsList[i]['name'] + '</TD>';
				tableBody += '<TD>' + contactsList[i]['title'] + '</TD>';
				tableBody += '<TD>' + groupIdMap[contactsList[i]['group']] + '</TD>';
				tableBody += '<TD>' + primary + '</TD>';
				tableBody += '</TR>';
				totalContacts++;
			}
		}
		$('#contactsTableBody').html(tableBody);
	}
	$('#includeAllContacts').click(function() {
		$('.contactChk').prop('checked', $('#includeAllContacts').is(':checked'));
	});
	$('.contactChk').click(function() {
		$('#includeAllContacts').prop('checked',
				($('#rfContactsList').find('input[name="contactschks"]:checked').length == totalContacts));
	});
	$('#includeAllContacts').click();
	feedback.fetchData();
};

feedback.updateUIwithModel = function(data) {
	if (data.feedbackQuarterly == '1') {
		isConfiguredQuarterly = true;
	}

	$('#quarterly').prop("checked", data.feedbackQuarterly ? data.feedbackQuarterly == '1' : false);
	$('#sendNow').prop("checked", data.feedbackSendNow ? data.feedbackSendNow == '1' : false);
	if (data.feedbackNotifyAllContacts != '1') {
		$('#includeAllContacts').click();
	}
	//$('#rfContactsList').prop('disabled', $('#includeAllContacts').is(':checked'));
	if (data.feedbackNotifyAllContacts === undefined || data.feedbackNotifyAllContacts === '0') {
		if (data.feedbackNotifyContacts) {
			var contactsArr = data.feedbackNotifyContacts.split(';');
			$.each(contactsArr, function(i, contact) {
				contact = contact.trim();
				if (contact.length > 0) {
					$('#' + contact).prop("checked", true);
				}
			});
		}
	}
	if ($('#includeAllContacts').is(':checked')) {
		$('.contactChk').prop('checked', $('#includeAllContacts').is(':checked'));
	}
};

feedback.submit = function() {
	if (!feedback.isValidData()) {
		return;
	}
	// Prepare data parameter object:
	var request = {};
	request.ccGroupId = ccGroupId;
	request.companyId = companyId;
	request.ccGroupName = ccGroupName;
	request.quarterly = $('#quarterly').is(':checked');
	request.sendNow = $('#sendNow').is(':checked');
	request.includeAllContacts = $('#includeAllContacts').is(':checked');

	if (!request.includeAllContacts) {
		var clist = [];
		var selectedList = $('table input:checkbox:checked');
		$.each(selectedList, function(i, chk) {
			var contact = {};
			contact.name = $(this).data('name');
			contact.userId = $(this).data('userid');
			contact.contactId = $(this).data('contactid');
			contact.email = $(this).data('email');
			clist.push(contact);
		});
		request.contacts = clist;
	}

	var configURL = cvUtil.getContextPath() + '/reports/handleProfileRequestFeedback.do';
	var data = {
		'json' : JSON.stringify(request)
	};
	var mesage = feedback.modifyFeedback(configURL, data);
	var action = "modifyRequestFeedback";
	cvUtil.logUserAction("ProfileRequestFeedback", action, null, '');
	cvUtil.closeModal();
};

feedback.modifyFeedback = function(configURL, data) {
	// Send request:
	console.debug("Posting ajax request to update Request Feedback information");
	var message = '';
	cvUtil.mask();
	var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
		cvUtil.unmask();
		console.debug(resp);
	}, function(err) {
		cvUtil.unmask();
		cvUtil.errorToast(err.responseText.trim(), null, null, true);
	});
	if (result.isError) {
		message = result.message;
		console.debug(message);
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	} else {
		message = cvUtil.cvLocalize('requestFeedback.request_feedback');
		window.returnData = {
			'isError' : result.isError,
			'message' : message
		};
	}
	return message;
};

feedback.isValidData = function() {
	var msg = '';

	var allcontacts = $('#includeAllContacts').is(':checked');
	if (!allcontacts) {
		var clist = $('table input:checkbox:checked');
		var selectedContacts = clist.length > 0;
		if (!selectedContacts) {
			msg = cvUtil.cvLocalize('requestFeedback.error.contact');
			$('.feedbackContacts').addClass('notifTypeDivError');
		} else {
			$('.feedbackContacts').removeClass('notifTypeDivError');
		}
		markField('#rfContactsList', msg);
	} else {
		markField('#rfContactsList', msg);
		$('.feedbackContacts').removeClass('notifTypeDivError');
	}

	if (!isConfiguredQuarterly) {
		msg = '';
		if ($('.notifType input[type="checkbox"]:checked').length <= 0) {
			msg = cvUtil.cvLocalize('requestFeedback.error.time');
			$('.notifTypeDiv').addClass('notifTypeDivError');
		} else {
			$('.notifTypeDiv').removeClass('notifTypeDivError');
		}
		markField('.notifTypeDiv', msg);
	}

	if ($('.errorField').length > 0) {
		return false;
	}
	return true;
};

feedback.fetchData = function() {

	var request = {};
	request.customerId = ccGroupId;
	request.companyId = companyId;
	console.debug("Posting ajax request to fetch Request Feedback information");
	var configURL = cvUtil.getContextPath() + '/reports/fetchRequestFeedbackById.do';
	cvUtil.mask();
	var isError = false;
	cvUtil.loadPageWithPOST(configURL, request, function(resp) {
		if (resp && resp.feedback) {
			if (resp.feedback.length > 0) {
				var tempList = resp.feedback;
				var info = {};
				$.each(tempList, function(key, val) {
					info[val.attrName] = val.attrVal;
				});
				feedback.updateUIwithModel(info);
			}
		}
		//$('.contactChk').prop('disabled', $('#includeAllContacts').is(':checked'));
		cvUtil.unmask();
	}, function(err) {
		cvUtil.unmask();
		if (err.responseText) {
			cvUtil.errorToast(err.responseText.trim(), null, null, true);
		}
	});

};

function getData() {
	return window.returnData;
}

$(document).ready(function() {
	feedback.initUI();

	$("#okButton").click(function(e) {
		feedback.submit();
	});
	$("#cancelButton").click(function(e) {
		cvUtil.closeModal();
	});
	$("#closeButton").click(function() {
		window.returnData = {
			'isError' : false,
			'cancel' : true
		};
		cvUtil.closeModal();
	});

});
