var commUniId = cvUtil.getParameter('commUniId', 0);
var ccGroupId = cvUtil.getParameter('ccGroupId', 0);
var companyId = cvUtil.getParameter('companyId', 0);
var taskId = cvUtil.getParameter('taskId', 0);
var tasksList = null, customerName = "";

function ProfileTasks() {
	this.report = new Reports.initReport({
		type : 'profiletasks',
		idtomask : 'ContentWrapper',
		directPrint : true
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		if (commUniId > 0) {
			requestString["commUniId"] = commUniId;
		}
		if (ccGroupId > 0) {
			requestString["ccGroupId"] = ccGroupId;
		}
		if (companyId > 0) {
			requestString["companyId"] = companyId;
		}
	};

	report.initComponents = function() {
		$('body').on('click', '.addTask', function(event) {
			var params = '?';
			if (ccGroupId > 0) {
				params += '&ccGroupId=' + ccGroupId;
			}
			if (commUniId > 0) {
				params += '&commUniId=' + commUniId;
			}
			if (companyId > 0) {
				params += '&companyId=' + companyId;
			}
			params = params.replace('?&', '');
			window.location.href = cvUtil.getContextPath() + '/survey/profileTask.do?' + params;
		});

		$('body').on('click', ".worldwideTasks", function(event) {
			window.location.href = cvUtil.getContextPath() + '/survey/profile/profiletasks.jsp';
		});

		var fromProfile = cvUtil.getParameter('fromProfile', false);
		if ((ccGroupId > 0 || companyId > 0) && $('#breadcrumbMain .profileDashboardLi').length == 0) {
			var params = '?';
			if (ccGroupId > 0) {
				params += '&ccGroupId=' + ccGroupId;
			}
			if (commUniId > 0) {
				params += '&commUniId=' + commUniId;
			}
			if (companyId > 0) {
				params += '&companyId=' + companyId;
			}
			params = params.replace('?&', '');
			var profileURL = cvUtil.getContextPath() + '/survey/profile/profilecustdashboard.jsp?' + params;
			var a = '<a class="smartLinkMain commcellsLink" href="' + profileURL + '">' + localMsg_Profile_Dashboard +
					'</a>';
			$('#breadcrumbMain')
					.append('<li class="secTitleClickable smartlinkMain withSeparatorMain profileDashboardLi">' + a +
							'</li>');
		}

		if (ccGroupId <= 0 && companyId <= 0) {
			$('.tasksToolbar').addClass('hide');
			$('#statusPie').removeClass('tasksStatusPie');
			$('#breadcrumbMain li.repDropdown').remove();
			var cca = '<a class="smartLinkMain" href="' + cvUtil.getContextPath() +
					'/survey/reports/viewReport.jsp?reportId=RegisteredCompanies">' + cvUtil.cvLocalize('companies') +
					'</a>';
			$('#breadcrumbMain').append('<li class="secTitleClickable smartlinkMain withSeparatorMain">' + cca +
					'</li>');
		}

	};

	report.initComponentState = function() {
		$("#exportcsv").hide();
		$("#commcellUrl").hide();
		updateFilters();
	};
	report.beforeLoadReport = function() {
		reportsUtil.setWorldwideLink();
		report.mask("");
	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/reports/fetchTasksList.do?customerId=' + ccGroupId + '&companyId=' +
				companyId;
	};
	report.getExportFilePrefix = function() {
		var filePre = "ProfileTasks";

		if (customerName) {
			filePre = customerName + ' - ' + filePre;
		}

		return filePre;
	};
	report.onLoadReport = function(data) {
		processResponse(data);
		report.attachTableActions();
		report.afterLoadReport();
		if (taskId > 0) {
			showTaskDialog(taskId);
			var params = "?ccGroupId=" + ccGroupId;
			if (commUniId > 0) {
				params += "&commUniId=" + commUniId;
			}
			if (companyId > 0) {
				params += "&companyId=" + companyId;
			}
			taskId = 0;
			History.replaceState(null, document.title, params);
		}
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(data) {
		var initialLoad = ($('#tasksTable').length == 0);
		if (data == undefined || data == null) {
			alert(cvUtil.cvLocalize("Something_went_wrong_please_try_again"));
		} else if (data && typeof data === 'string') {
			$("#ContentWrapper").hide();
			$("#meta").hide();
			$("#noDataNotificationPanel").html(data);
			$("#noDataNotificationPanel").show();
		} else {
			if (data && typeof data === 'object') {
				tasksList = data.tasksList.aaData;
				drawPieChart();
				var view = {};
				view.members = data.tasksList;
				view.collapsible = false;
				view.filters = true;
				view.exportExcel = true;
				view.alarm = true;
				view.title = '';

				var tableDiv = 'tasksTable';
				if (initialLoad) {
					var wrapperId = 'ContentWrapper';
					$('#' + wrapperId).append(SurveyTemplates.makeReportTable(tableDiv, view));
				} else {
					$("input[id*='_FilterSelected']").val('');
				}
				var tdata = view.members;
				tdata.iDisplayLength = 100;
				setFilterRendered(tdata.aoColumns);
				var configTable = true;
				if ((!tdata.aoColumns || tdata.aoColumns.length == 0) &&
						(!tdata.aoColumnDefs || tdata.aoColumnDefs.length == 0)) {
					configTable = false;
				}
				if (configTable) {
					Reports.configureClientSideTableWithPaging(tableDiv, view.title, tdata);
				}
				$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
				var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
				pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
			}

		}
	}

	function showTaskDialog(tid) {
		for (var i = 0; i < tasksList.length; i++) {
			if (tid == tasksList[i]['Task Id']) {
				var task = tasksList[i];
				task.isCommmvaultUser = isCommvaultUser;
				reportsUtil.showTaskDialog(tid, task, function() {
					console.debug('Reloading tasks...');
					window.location.reload();
				});
				return;
			}
		}
	}

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}
}

function setFilterRendered(aoColumns) {
	var renderersResultingURLs = [ "Task", "TaskStatus", "URL", "MMMDDYYYY", "booleanRenderer" ];
	for (var i = 0; i < aoColumns.length; i++) {
		var renderer = aoColumns[i].rendererType;
		if (typeof renderer != 'undefined') {
			if ($.inArray(renderer, renderersResultingURLs) > -1) {
				aoColumns[i].bFilterRendered = false;
			}
			if (renderer === 'Task' || renderer === 'URL' || renderer === 'booleanRenderer') {
				aoColumns[i].bUseRendered = false;
			}
		}
	}
}

function drawPieChart() {
	var chartDiv = 'piechartcontainer';
	if (tasksList === undefined || tasksList.length <= 0) {
		$('#statusPie').removeClass('chartContainer');
		$('#statusPie').addClass('chartError');
		$('#' + chartDiv).append('<div class="chartErrorMessage">' + localMsg_NoDataAvailable + '</div>');
		return;
	}

	var statusMap = {
		1 : 0,
		2 : 0,
		3 : 0,
		4 : 0
	};
	var openCnt = 0, fixedCnt = 0, closedCnt = 0, killedCnt = 0;
	for (var i = 0; i < tasksList.length; i++) {
		var stat = parseInt(tasksList[i]['Status<TaskStatus>']);
		var cnt = statusMap[stat];
		if (cnt) {
			statusMap[stat] = parseInt(cnt) + 1;
		} else {
			statusMap[stat] = 1;
		}
	}
	var labels = new Array();
	var values = new Array();
	for ( var prop in statusMap) {
		values.push(statusMap[prop]);
		labels.push(reportsUtil.getTaskStatus(prop) + ' - (' + statusMap[prop] + ')');
	}

	$('#' + chartDiv).empty();
	$('#' + chartDiv).css('height', '360px');

	Raphael(chartDiv, 660, 360).pieChart(320, 170, 140, values, labels, 520, 130);
}

function showProfileErrorMsg(msg) {
	$("#ContentWrapper").hide();
	$("#profileTasksMsg").text(msg);
	$("#noDataNotificationPanel").show();
}

function getCustomerEdgeDriveInfo() {
	var request = {};
	request.customerId = ccGroupId;
	request.companyId = companyId;
	request.name = customerName;
	console.debug("Posting ajax request to init customer edge drive folder information");
	var configURL = cvUtil.getContextPath() + '/reports/getCustomerEdgeFolderInfo.do';
	cvUtil.loadPageWithPOST(configURL, request, function(resp) {
		if (resp) {

		}

	}, function(resp) {
		cvUtil.errorToast(resp.responseText.trim(), null, null, true);
	});
}

function initProfileTasks() {
	ProfileTasks();
	getCustomerEdgeDriveInfo();
}

$(document).ready(function() {
	$("#surveyName").html(localMsg_Profile_Tasks);
	window.reportEnum = "Survey";
	if (!isCommvaultUser && ccGroupId <= 0 && companyId <= 0) {
		showProfileErrorMsg(localMsg_Invalid_CommCell_Group_Id);
		return;
	}
	if (ccGroupId > 0) {
		var configURL = "survey.do?action=CommCellDetailsUid&ccGroupId=" + ccGroupId;
		cvUtil.loadPageWithPOST(configURL, null, function(output) {
			var data = output;//jQuery.parseJSON(output);
			if (data.error) {
				showProfileErrorMsg(data.error);
			} else {
				var cgName = reportsUtil.getTruncatedName(data.GroupName);
				customerName = data.GroupName;
				$('#custName').html(cgName + " - ");
				$('#custName').attr('title', data.GroupName);
				$('.reportsLink').text(data.GroupName + ' (' + localMsg_Reports + ')');
				$(document).attr("title", data.GroupName + " - " + localMsg_Profile_Tasks);
				cvUtil.GUIAuditReportLog(localMsg_Profile_Tasks, data.GroupName);
			}
		}, function(err) {
			cvUtil.errorToast(err.responseText.trim(), null, null, true);
		});
	} else if (companyId > 0) {
		var configURL = "getCompanyInfo.do?companyId=" + companyId;
		cvUtil.loadPageWithGET(configURL, null, function(output) {
			if (output.data && output.data.company) {
				var company = output.data.company;
				var cgName = reportsUtil.getTruncatedName(company.company.userGroupName);
				customerName = company.company.userGroupName;
				$('#custName').html(cgName + " - ");
				$('#custName').attr('title', customerName);
				$('.reportsLink').text(customerName + ' (' + localMsg_Reports + ')');
				$(document).attr("title", customerName + " - " + localMsg_Profile_Tasks);
				cvUtil.GUIAuditReportLog(localMsg_Profile_Tasks, customerName);
			}
		}, function(err) {
			cvUtil.errorToast(err.responseText.trim(), null, null, true);
		});
	}

	if (showProfileDashboard) {
		if ((isCommvaultUser && ccGroupId <= 0) || (!isCommvaultUser && companyId > 0)) {
			initProfileTasks();
		} else {
			var request = {};
			request.ccGroupId = ccGroupId;
			var configURL = cvUtil.getContextPath() + '/reports/getProfileEnabledForGroup.do';
			cvUtil.loadPageWithPOST(configURL, request, function(resp) {
				if (resp) {
					if (resp.enabledProfile == undefined || resp.enabledProfile == false) {
						showProfileErrorMsg(localMsg_Profile_disabled);
					} else {
						initProfileTasks();
					}
				}
			}, function(err) {
				showProfileErrorMsg(err.responseText.trim());
			});
		}
	} else {
		showProfileErrorMsg(localMsg_Profile_not_configured);
	}
});
