(function(taskExports) {
	'use restrict';

	var currentUserId = 0, commUniId = 0, oldTaskData = {}, tempSelectedUser = {}, docShareId = 0, loadAttachments = true, loadHistory = true;
	var ccGroupId = cvUtil.getParameter('ccGroupId', 0);
	var companyId = cvUtil.getParameter('companyId', 0);
	var commUniId = cvUtil.getParameter('commUniId', 0);
	var taskId = cvUtil.getParameter('taskId', 0);
	var from = cvUtil.getParameter('from', false);
	var returnLink, profileUsersList = [], emailTo = '';
	var uploadAction = false;
	var edgeInfo = {};

	function init() {
		$('#breadcrumbMain li.repDropdown').remove();
		if ($('#breadcrumbMain .profileDashboardLi').length === 0) {
			var params = '?';
			if (ccGroupId > 0) {
				params += '&ccGroupId=' + ccGroupId;
			}
			if (commUniId > 0) {
				params += '&commUniId=' + commUniId;
			}
			if (companyId > 0) {
				params += '&companyId=' + companyId;
			}
			params = params.replace('?&', '');
			returnLink = cvUtil.getContextPath() + '/survey/profile/profilecustdashboard.jsp?' + params;
			var a = '<a class="smartLinkMain commcellsLink" href="' + returnLink + '">' + localMsg_Profile_Dashboard +
					'</a>';
			$('#breadcrumbMain')
					.append('<li class="secTitleClickable smartlinkMain withSeparatorMain profileDashboardLi">' + a +
							'</li>');
		}
		if (from !== 'dashboard') {
			if ($('#breadcrumbMain .profileTasksLi').length === 0) {
				var params = '?';
				if (ccGroupId > 0) {
					params += '&ccGroupId=' + ccGroupId;
				}
				if (commUniId > 0) {
					params += '&commUniId=' + commUniId;
				}
				if (companyId > 0) {
					params += '&companyId=' + companyId;
				}
				params = params.replace('?&', '');
				returnLink = cvUtil.getContextPath() + '/survey/profile/profiletasks.jsp?' + params;
				var a = '<a class="smartLinkMain commcellsLink" href="' + returnLink + '">' + localMsg_Profile_Tasks +
						'</a>';
				$('#breadcrumbMain')
						.append('<li class="secTitleClickable smartlinkMain withSeparatorMain profileTasksLi">' + a +
								'</li>');
			}
		}
		setTaskTitle(1);
		$("#cancelButton").click(function() {
			closeTaskPage(true);
		});
		if (ccGroupId <= 0 && companyId <= 0 && taskId <= 0) {
			showProfileErrorMsg(cvUtil.cvLocalize('profiledashbaord.error.unable_profile'));
			return;
		}
		if (ccGroupId > 0) {
			var configURL = "survey.do?action=CommCellDetailsUid&ccGroupId=" + ccGroupId;
			cvUtil.loadPageWithPOST(configURL, null, function(output) {
				var data = output;//jQuery.parseJSON(output);
				if (data.error) {
					showProfileErrorMsg(data.error);
				} else {
					var cgName = reportsUtil.getTruncatedName(data.GroupName);
					customerName = data.GroupName;
					$('#custName').html(cgName + " - ");
					$('#custName').attr('title', data.GroupName);
					//$('.reportsLink').text(data.GroupName + ' (' + localMsg_Reports + ')');
					$(document).attr("title", data.GroupName + " - " + localMsg_Profile_Tasks);
					cvUtil.GUIAuditReportLog(localMsg_Profile_Tasks, data.GroupName);
					$('li.profileDashboardLi a').text(customerName + ' (' + $('li.profileDashboardLi a').text() + ')');
					if (!(!isCommvaultUser && ccGroupId > 0)) {
						getCustomerEdgeDriveInfo();
					}
				}
			}, function(err) {
				cvUtil.errorToast(err.responseText.trim(), null, null, true);
			});

		} else if (companyId > 0) {
			var configURL = "getCompanyInfo.do?companyId=" + companyId;
			cvUtil.loadPageWithGET(configURL, null, function(output) {
				if (output.data && output.data.company) {
					var company = output.data.company;
					var cgName = reportsUtil.getTruncatedName(company.company.userGroupName);
					customerName = company.company.userGroupName;
					$('#custName').html(cgName + " - ");
					$('#custName').attr('title', customerName);
					$(document).attr("title", customerName + " - " + localMsg_Profile_Tasks);
					cvUtil.GUIAuditReportLog(localMsg_Profile_Tasks, customerName);
					$('li.profileDashboardLi a').text(customerName + ' (' + $('li.profileDashboardLi a').text() + ')');
					if (!(!isCommvaultUser && ccGroupId > 0)) {
						getCustomerEdgeDriveInfo();
					}
				}
			}, function(err) {
				cvUtil.errorToast(err.responseText.trim(), null, null, true);
			});
		}
		if (showProfileDashboard) {
			if (companyId > 0) {
				initComponents();
			} else {
				var request = {};
				request.ccGroupId = ccGroupId;
				request.companyId = companyId;
				var configURL = cvUtil.getContextPath() + '/reports/getProfileEnabledForGroup.do';
				cvUtil.loadPageWithPOST(configURL, request, function(resp) {
					if (resp) {
						if (resp.enabledProfile == undefined || resp.enabledProfile == false) {
							showProfileErrorMsg(localMsg_Profile_disabled);
							return;
						} else {
							initComponents();
						}
					}
				}, function(err) {
					showProfileErrorMsg(err.responseText.trim());
				});
			}

		} else {
			showProfileErrorMsg(localMsg_Profile_not_configured);
			return;
		}

	}

	function showProfileErrorMsg(msg) {
		$("#ContentWrapper").hide();
		$("#profileTasksMsg").text(msg);
		$("#noDataNotificationPanel").show();
	}
	function initComponents() {
		$('#task-tabs').tabs({
			select : function(event, ui) {
				if (ui.panel.id === 'task-attachments' && $("#attachments").length > 0) {
					if (taskId > 0 && loadAttachments) {
						getAttachments();
						loadAttachments = false;
					} else if ($("#attachments").length > 0) {

					}
				} else if (ui.panel.id === 'task-history' && $("#task-history-div").length > 0) {
					if (taskId > 0 && loadHistory) {
						getTaskHistory();
						loadHistory = false;
					} else if ($("#attachments").length > 0) {

					}
				}

			}
		});

		getTaskInfo();
		$("#duedate").datepicker({
			dateFormat : "mm/dd/yy",
			onClose : function(selectedDate) {
				if (taskId > 0) {
					if (moment(oldTaskData['Target Date<MMMDDYYYY>'] * 1000).format("MM/DD/YYYY") !== selectedDate) {
						$('.duedate-reason').removeClass('hide-change-reason');
						$('.row.hide-change-reason').removeClass('hide-change-reason');
						if ($('.hide-change-reason').length !== 0) {
							$('label.duedate-reason').addClass('col-sm-offset-6');
						} else {
							$('label.duedate-reason').removeClass('col-sm-offset-6');
						}
					} else {
						if ($('.hide-change-reason').length !== 0) {
							$(this).closest('.row.duedate-reason').addClass('hide-change-reason');
						}
						$('.duedate-reason').addClass('hide-change-reason');
						$('label.duedate-reason').removeClass('col-sm-offset-6');
					}
				}
			}
		});
		$("#startdate").datepicker({
			dateFormat : "mm/dd/yy",
			onClose : function(selectedDate) {

			}
		});
		if (taskId > 0) {
			$("#status").on('change', function(e) {
				if (oldTaskData['Status<TaskStatus>'] != this.value) {
					$('.status-reason').removeClass('hide-change-reason');
					$('.row.hide-change-reason').removeClass('hide-change-reason');
					if ($('.hide-change-reason').length === 0) {
						$('label.duedate-reason').removeClass('col-sm-offset-6');
					}
				} else {
					if ($('.hide-change-reason').length !== 0) {
						$(this).closest('.row.status-reason').addClass('hide-change-reason');
					}
					$('.status-reason').addClass('hide-change-reason');
					if ($('.hide-change-reason').length !== 0) {
						$('label.duedate-reason').addClass('col-sm-offset-6');
					}
				}
			});
		}
		var today = new Date();
		$("#duedate").datepicker("option", "minDate", today);
		$("#startdate").datepicker("option", "minDate", today);
		var maxDate = new Date();
		maxDate.setDate(today.getDate() + 365);
		$("#duedate").datepicker("option", "maxDate", maxDate);
		$("#startdate").datepicker("option", "maxDate", maxDate);
		var due = new Date();
		due.setDate(today.getDate() + 14);
		$("#duedate").datepicker("setDate", due);
		$("#createddate").val(today.format('MM/dd/yyyy'));
		$("#startdate").val(today.format('MM/dd/yyyy'));
		$("#createdBy").prop('disabled', true);
		$("input[name='task-type']").change(function() {
			var type = $('input:radio[name="task-type"]:checked').val();
			setTaskTitle(type);
		});

		$("#summary").focus();
		$("#okButton").click(function() {
			submit();
		});

		if (taskId > 0) {
			$('#emailModal').on('show.bs.modal', function(e) {
				initEmailTaskDialog();
			});

			$('#emailModal').on('hidden.bs.modal', function(e) {
				cleanupEmailDialog();
			});

			$('#sendButton').click(function() {
				sendTakMail();
			});
		}
		$("#progressContainer").remove();
	}
	function setTaskTitle(type) {
		if (taskId > 0) {
			$('#surveyName').html(cvUtil.cvLocalize('task.page.title.modify', cvUtil.cvLocalize('task.type.task')));
		} else {
			$('#surveyName').html(cvUtil.cvLocalize('task.page.title.new', cvUtil.cvLocalize('task.type.task')));
		}
	}

	function initUsersComponents(usersList) {
		if (taskId <= 0) {
			$("#task-upload-btn").hide();
		}
		$("#autoUsersList").autocomplete({
			source : function(request, response) {
				var results = $.ui.autocomplete.filter(usersList, request.term);
				response(results);
			},
			minLength : 0,
			select : function(event, ui) {
				$('#autoUsersList').val(ui.item.label);
				tempSelectedUser = ui.item;
				return false;
			},
			focus : function(event, ui) {
				$('#autoUsersList').val(ui.item.label);
				event.preventDefault(); // Prevent the default focus behavior.
			},
			delay : 1,
			appendTo : "#autocompletediv"
		});
		jQuery.ui.autocomplete.prototype._resizeMenu = function() {
			var ul = this.menu.element;
			ul.outerWidth(this.element.outerWidth());
		};
		$("#autoUsersList").on("blur", function() {
			$(this).val(tempSelectedUser.label || "");
		});
		$("#task-upload-btn").click(function() {
			if (taskId <= 0) {
				return;
			}
			var files = $('#task-files-input').prop('files');
			if (files === undefined || files.length <= 0) {
				cvUtil.toast(cvUtil.cvLocalize('task.error.select_files'));
				return;
			}
			cvUtil.mask("#task-attachments");
			uploadAction = true;
			uploadDocuments(taskId);
		});

	}
	function updateUIwithModel(data) {
		$('#summary').val(data['Name<Task>']);
		$('#url').val(data['URL<URL><HIDDEN>']);
		$('#desc').val(data['Description'] ? data['Description'] : '');
		$('#notes').val(data['Notes<HIDDEN>'] ? data['Notes<HIDDEN>'] : '');
		$('#createdBy').val(data['Created By']);
		$("#status option[value='" + data['Status<TaskStatus>'] + "']").attr('selected', 'selected');
		$('input:radio[name="task-type"][value=' + data["Type<TaskType>"] + ']').prop('checked', 'checked');
		if (taskId > 0) {
			$("#createddate").val(moment(data['Creation Date<MMMDDYYYY><HIDDEN>'] * 1000).format("MM/DD/YYYY"));
			var dt = data["Target Date<MMMDDYYYY>"] * 1000;

			var today = moment(moment(new Date()).format("MM/DD/YYYY"));
			var due = moment(dt);
			var days = due.diff(today, 'days');
			if (days < 0) {
				$("#duedate").datepicker("option", "minDate", moment(dt).format("MM/DD/YYYY"));
			}

			$("#duedate").datepicker("setDate", moment(dt).format("MM/DD/YYYY"));

			$('#autoUsersList').val(tempSelectedUser.label);
			$("#startdate").val(moment(data['Start Date<MMMDDYYYY>'] * 1000).format("MM/DD/YYYY"));
			$('#modifiedBy').val(data['Last Modified By<HIDDEN>']);
			$("#modifiedDate").val(moment(data['Last Modified Date<MMMDDYYYY><HIDDEN>'] * 1000).format("MM/DD/YYYY"));
		}

		if ($("#internal").length > 0) {
			setChecked($("#internal"), (data['Internal<booleanRenderer>'] === 'Yes'));
		}
		setTaskTitle(data['Type<TaskType>']);
	}

	function submit() {
		if (!isValidData()) {
			return;
		}
		$('.form-error-msg').val('');
		toggleButtons(true);
		if (taskId > 0 && !isDataChanged()) {
			cvUtil.mask();
			uploadDocuments(taskId);
			return;
		}
		// Prepare data parameter object:
		var request = {};
		request.customerId = ccGroupId;
		request.commUniId = commUniId;
		request.ccGroupId = ccGroupId;
		request.companyId = companyId;
		request.taskid = taskId;
		request.tasksummary = $('#summary').val();
		request.url = $('#url').val();
		request.taskdesc = $('#desc').val();
		request.notes = $('#notes').val();
		request.taskcreatedby = currentUserId;
		request.taskassignedto = tempSelectedUser.value;
		request.status = $('#status').val();
		request.taskduedate = $('#duedate').datepicker('getDate').getTime() / 1000;
		request.taskstartdate = $('#startdate').datepicker('getDate').getTime() / 1000;
		request.internalTask = isInternalTask();
		request.statusReason = $('#status-reason').val();
		request.duedateReason = $('#duedate-reason').val();
		request.taskType = $('input:radio[name="task-type"]:checked').val();
		var action = "";
		var message = "";
		var configURL = cvUtil.getContextPath() + '/reports/handleTaskInfo.do';
		var data = request;//{'json' : JSON.stringify(request)};

		if (taskId > 0) {
			mesage = modifyTask(configURL, data);
			action = "modifyTask";
		} else {
			message = addTask(configURL, data);
			action = "addNewTask";
		}
		toggleButtons(false);
		cvUtil.unmask('#ContentWrapper');
		var oldData = {};
		if (taskId > 0) {
			oldData = {
				'TaskName' : oldTaskData['Name<Task>'],
				'TaskId' : oldTaskData['Task Id'],
				'TaskType' : oldTaskData['Type<TaskType>'],
				'Description' : oldTaskData['Description'],
				'AssignedTo' : oldTaskData['AssignedId<DONOTSHOW>'],
				'DueDate' : oldTaskData['Target Date<MMMDDYYYY>'],
				'StartDate' : oldTaskData['Start Date<MMMDDYYYY>'],
				'Status' : reportsUtil.getTaskStatus(oldTaskData['Status<TaskStatus>']),
				'RelatedLink' : oldTaskData['URL<URL><HIDDEN>'],
				'Notes' : oldTaskData['Notes<HIDDEN>'],
				'InternalTask' : oldTaskData['Internal<booleanRenderer>']
			};
		}
		var newData = {
			'TaskName' : request.tasksummary,
			'TaskId' : request.taskid,
			'TaskType' : request.taskType,
			'Description' : request.taskdesc,
			'AssignedTo' : request.taskassignedto,
			'DueDate' : request.taskduedate,
			'StartDate' : request.taskstartdate,
			'Status' : reportsUtil.getTaskStatus(request.status),
			'RelatedLink' : request.url,
			'Notes' : request.notes,
			'InternalTask' : request.internalTask
		};
		var changes = JSON.stringify({
			'TaskId' : taskId,
			'CommCellGroupId' : ccGroupId,
			'OldData' : oldData,
			'NewData' : newData
		});
		cvUtil.logUserAction("Profile Task", action, null, "TaskName=[" + request.tasksummary + "] Message=[" +
				message + "] Changes=[" + changes + "]", "INFO");
	}

	function toggleButtons(savingMode) {
		if (savingMode) {
			$('#okButton').addClass('disabled');
			$('#cancelButton').addClass('disabled');
			$('#okButton').text('Saving Task...');
		} else {
			$('#okButton').removeClass('disabled');
			$('#cancelButton').removeClass('disabled');
			$('#okButton').text(cvUtil.cvLocalize('Save'));
		}
	}

	function isInternalTask() {
		var internalTask = false;
		if ($("#internal").length > 0 && isChecked($("#internal"))) {
			internalTask = true;
		}
		return internalTask;
	}

	function addTask(configURL, data) {
		// Send request:
		console.debug("Posting ajax request to add new task information");
		var message;
		cvUtil.mask('#ContentWrapper');
		var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
			console.debug("resp = " + resp);
		});
		if (result.isError) {
			toggleButtons(false);
			cvUtil.unmask();
			message = cvUtil.cvLocalize('task.error.new_failed', result.message);
			cvUtil.errorToast(message, null, null, true);
			console.debug(message);
		} else {
			taskId = result.taskId;
			message = cvUtil.cvLocalize('task.error.new_success');
			cvUtil.toast(message, null, null, true);
			uploadDocuments(taskId);
		}
		return message;
	}

	function modifyTask(configURL, data) {
		// Send request:
		console.debug("Posting ajax request to update task information");
		var message;
		cvUtil.mask('#ContentWrapper');
		var result = cvUtil.loadSynchronously(configURL, data, function(resp) {
			console.debug(resp);
		});

		if (result.isError) {
			toggleButtons(false);
			cvUtil.unmask('#ContentWrapper');
			message = cvUtil.cvLocalize('task.error.modify_failed', result.message);
			cvUtil.errorToast(message, null, null, true);
		} else {
			message = cvUtil.cvLocalize('task.error.modify_success');
			cvUtil.toast(message, null, null, true);
			uploadDocuments(taskId);
		}
		return message;
	}

	function isDataChanged() {
		var oldData = {
			'TaskName' : oldTaskData['Name<Task>'],
			'TaskId' : oldTaskData['Task Id'],
			'Description' : oldTaskData['Description'],
			'AssignedTo' : oldTaskData['AssignedId<DONOTSHOW>'],
			'DueDate' : oldTaskData['Target Date<MMMDDYYYY>'],
			'StartDate' : oldTaskData['Start Date<MMMDDYYYY>'],
			'Status' : oldTaskData['Status<TaskStatus>'],
			'RelatedLink' : oldTaskData['URL<URL><HIDDEN>'],
			'Notes' : oldTaskData['Notes<HIDDEN>'],
			'InternalTask' : oldTaskData['Internal<booleanRenderer>'],
			'TaskType' : oldTaskData['Type<TaskType>'],
		};

		if (oldData.TaskName !== $('#summary').val()) {
			return true;
		} else if (oldData.Description !== $('#desc').val()) {
			return true;
		} else if (oldData.AssignedTo !== tempSelectedUser.value) {
			return true;
		} else if (oldData.DueDate !== $('#duedate').datepicker('getDate') / 1000) {
			return true;
		} else if (oldData.Status !== parseInt($('#status').val())) {
			return true;
		} else if (oldData.RelatedLink !== $('#url').val()) {
			return true;
		} else if (oldData.Notes !== $('#notes').val()) {
			return true;
		} else if ((oldData.InternalTask === 'Yes') !== isInternalTask()) {
			return true;
		} else if (oldData.StartDate !== $('#startdate').datepicker('getDate') / 1000) {
			return true;
		} else if (oldData.TaskType !== parseInt($('input:radio[name="task-type"]:checked').val())) {
			return true;
		}

		return false;
	}

	function isValidData() {
		var msg = '';
		var assignTo = tempSelectedUser.value;
		if (assignTo === undefined || assignTo === 0) {
			msg = cvUtil.cvLocalize('task.error.resource');
		}
		markField('#autoUsersList', msg);
		msg = '';

		var desc = $('#desc').val();
		if (desc === undefined || desc.trim() === '') {
			msg = cvUtil.cvLocalize('task.error.desc');
		}
		markField('#desc', msg);

		msg = '';
		var duedate = $('#duedate').val();
		var status = parseInt($('#status').val());
		if (duedate === undefined || duedate.trim() === '') {
			msg = cvUtil.cvLocalize('task.error.duedate');
		} else {
			duedate = $.trim(duedate);
			var datePattern = /^([0-9]{2})\/([0-9]{2})\/([0-9]{4})$/;
			if (!duedate.match(datePattern)) {
				msg = cvUtil.cvLocalize('task.error.date_format');
			}
			if (msg === '' && status <= 2) {//due date check for Open/Fixed tasks only
				var today = moment(moment(new Date()).format("MM/DD/YYYY"));
				var due = moment(duedate);
				var days = due.diff(today, 'days');
				if (days < 0) {
					msg = cvUtil.cvLocalize('task.error.date_check');
				}
			}
		}
		markField('#duedate', msg);
		msg = '';
		if (taskId > 0) {
			if (moment(oldTaskData['Target Date<MMMDDYYYY>'] * 1000).format("MM/DD/YYYY") !== duedate) {
				var duedate_reason = $('#duedate-reason').val();
				if (duedate_reason === undefined || $.trim(duedate_reason) === '') {
					msg = cvUtil.cvLocalize('task.error.duedate.change');
				}
			}
			markField('#duedate-reason', msg);
			msg = '';
			if (oldTaskData['Status<TaskStatus>'] !== status) {
				var status_reason = $('#status-reason').val();
				if (status_reason === undefined || $.trim(status_reason) === '') {
					msg = cvUtil.cvLocalize('task.error.status.change');
				}
			}
			markField('#status-reason', msg);
			msg = '';
		}
		var summary = $('#summary').val();
		if (summary === undefined || summary.trim() === '') {
			msg = cvUtil.cvLocalize('task.error.name');
		}
		markField('#summary', msg);

		msg = '';
		if (isInternalTask()) {
			if (!tempSelectedUser.cvuser) {
				msg = cvUtil.cvLocalize('task.error.cv_resource');
			}
			markField('#autoUsersList', msg);
		}
		msg = '';

		var createddate = new Date($('#createddate').val());
		var startdate = new Date($('#startdate').val());
		var duedatedt = new Date(duedate);
		if (startdate.getTime() < createddate.getTime() || startdate.getTime() > duedatedt.getTime()) {
			msg = cvUtil.cvLocalize('task.error.start_date');
		}
		markField('#startdate', msg);

		msg = '';
		if ($('.has-error').length > 0) {
			return false;
		}
		return true;
	}

	function markField(fieldId, errorMessage) {
		if (!errorMessage || errorMessage == '') {
			clearHighlight(fieldId);
			return true;
		}
		highlightField(fieldId, errorMessage);
		return false;
	}

	function clearHighlight(fieldId) {
		$(fieldId).parent('.form-group').removeClass("has-error");
		$(fieldId).attr('title', '');
	}
	function highlightField(fieldSelector, errorMessage) {
		$(fieldSelector).parent('.form-group').addClass("has-error");
		$(fieldSelector).attr('title', errorMessage);
		if (!$(fieldSelector).is(":focus")) {
			$(fieldSelector).focus();
		}
	}
	function getTaskInfo() {
		var model = {};

		var request = {};
		request.ccGroupId = ccGroupId;
		request.companyId = companyId;
		request.taskId = taskId;
		request.includeUsers = true;
		if (taskId <= 0) {
			request.includeTaskInfo = false;
		}

		console.debug("Posting ajax request to get task information");
		var configURL = cvUtil.getContextPath() + '/survey/getProfileTaskInfo.do';

		cvUtil.mask();
		cvUtil.loadPageWithGET(configURL, request, function(resp) {
			if (resp && resp.data) {

				if (resp.data.taskInfo && resp.data.taskInfo.aaData.length > 0) {
					model = resp.data.taskInfo.aaData[0];
					oldTaskData = jQuery.extend(true, {}, model);// Deep copy
				}
				var taskUsers = resp.data.taskUsers;
				var usersList = [];
				if (taskId <= 0) {
					currentUserId = taskUsers.current_user_id;
					model['Created By'] = taskUsers.current_user_name;
					$("#status option[value='3']").remove();
					$("#status option[value='4']").remove();
					$("#status option[value='5']").remove();
				} else {
					currentUserId = model['CreatedId<DONOTSHOW>'];
					tempSelectedUser = {
						'label' : model['Assigned To'],
						'value' : model['AssignedId<DONOTSHOW>'],
						'cvuser' : false
					};
				}
				$.each(taskUsers.users, function(i, user) {
					usersList.push({
						'label' : user.name,
						'value' : user.id,
						'cvuser' : true,
						'email' : user.email
					});

					if (taskId > 0) {
						profileUsersList.push({
							'label' : user.name,
							'value' : user.email
						});

						if (model['CreatedId<DONOTSHOW>'] == user.id || model['AssignedId<DONOTSHOW>'] == user.id ||
								model['ModifiedId<DONOTSHOW>'] == user.id) {
							emailTo = emailTo + user.email + ';';
						}
					}

					if (tempSelectedUser.value && tempSelectedUser.value == user.id) {
						tempSelectedUser.cvuser = true;
					}
				});
				if (taskUsers.customerContactsInfo) {
					$.each(taskUsers.customerContactsInfo,
							function(i, contact) {
								if (parseInt(contact['Group']) !== 4 && contact['Email']) {
									if (parseInt(contact['ContactUserId<DONOTSHOW>']) > 0) {
										var puser = {
											'label' : contact['Contact Name'],
											'value' : contact['ContactUserId<DONOTSHOW>'],
											'cvuser' : false,
											'email' : contact['Email']
										};
										usersList.push(puser);
									}
									if (taskId > 0) {
										profileUsersList.push({
											'label' : contact['Contact Name'],
											'value' : contact['Email']
										});
										var custUserId = contact['ContactUserId<DONOTSHOW>'];
										if (model['CreatedId<DONOTSHOW>'] == custUserId ||
												model['AssignedId<DONOTSHOW>'] == custUserId ||
												model['ModifiedId<DONOTSHOW>'] == custUserId) {
											emailTo = emailTo + contact['Email'] + ';';
										}
									}
									if (tempSelectedUser.value &&
											tempSelectedUser.value == contact['ContactUserId<DONOTSHOW>']) {
										tempSelectedUser.cvuser = false;
									}
								}
							});
				}
				initUsersComponents(usersList);
				updateUIwithModel(model);

			}
			cvUtil.unmask();
		});

	}

	function uploadDocuments(taskId) {
		if (taskId <= 0) {
			return;
		}
		var files = $('#task-files-input').prop('files');
		if (files !== undefined && files.length > 0) {
			try {
				tasksUtil.uploadDocuments(ccGroupId, companyId, taskId, files);
			} catch (err) {
				cvUtil.errorToast(err.errorMessage, null, null, true);
			} finally {

			}
		} else {
			closeTaskPage();
		}
	}

	function getAttachments() {
		var request = {};
		request.shareFolderId = 0;
		request.taskId = taskId;

		console.debug("Posting ajax request to fetch documents list");
		var params = [];
		//params.push(cvUtil.createParamString("shareFolderId", 0));
		params.push(cvUtil.createParamString("taskId", taskId));
		params.push(cvUtil.createParamString("ccGroupId", ccGroupId));
		params.push(cvUtil.createParamString("companyId", companyId));

		var redirectURL = cvUtil.getContextPath() + "/server/getTaskAttachments.do?";
		cvUtil.mask("#task-attachments");
		$('#tasksDocsTablebody').empty();
		cvUtil.loadPageWithPOST(redirectURL,
				cvUtil.createParamsString(params),
				function(resp) {
					cvUtil.unmask("#task-attachments");
					if (resp.isClientResp && resp.data.files) {
						var tableBody = '';
						var data = resp.data.files;
						var cnt = 0;
						docShareId = resp.data.shareFolderId;
						for (i = 0; i < data.length; i++) {
							if (data[i]["directory"]) {//Folder

							} else {//File
								var itemAttrsEncoded = {
									"displayName" : data[i]["name"],
									"modifiedTime" : data[i]["modifiedTime"] + "",
									"actualPath" : data[i]["path"],
									"parentGuid" : data[i]["parentGuid"],
									"unformattedModifiedTime" : data[i]["modifiedTime"] + "",
									"unformattedSize" : data[i]["sizeinBytes"] + "",
									"isDirectory" : !data[i]["file"] + "",
									"displayPath" : data[i]["displayPath"],
									"path" : data[i]["GUID"],
									"stubGuid" : data[i]["versionGUID"],
									"commCellNumber" : 0 + "",
									"subclientId" : 0 + "",
									"offset" : 0 + "",
									"isStub" : "false",
									"backupTime" : data[i]["modifiedTime"] + "",
									"archiveFileId" : 0 + "",
									"shareFolderId" : data[i]["shareFolderId"],
									"isSyncFolder" : "true"
								};
								itemAttrsEncoded = window.encodeURIComponent(JSON.stringify(itemAttrsEncoded));
								var fileData = ' data-guid="' + data[i]["GUID"] + '" data-name="' + data[i]["name"] +
										'"';
								var download = '<a id="downloadLink" class="taskDocActions" title="' +
										cvUtil.cvLocalize('task.Download') +
										'" ><span class="sprite reports-actions-store task-file-download" ' + fileData +
										' itemAttrsEncoded=' + itemAttrsEncoded + '></span></a>';
								var deleteFile = '';
								if(edgeInfo.permissions === 2){
									deleteFile = '<a id="deleteLink" class="taskDocActions" title="' +
											cvUtil.cvLocalize('task.Delete') +
											'" ><span class="sprite icon-trash task-file-delete" ' + fileData +
											'></span></a>';
								}
								var size = autoConvert(data[i]["sizeinBytes"]);
								tableBody += '<TR><TD>' + (++cnt) + '</TD><TD title="' + data[i]["name"] + '">' +
										data[i]["name"] + '</TD><TD title="' + size + '">' + size + '</TD><TD>' +
										deleteFile + download + '</TD></TR>';
							}
						}
						if (cnt > 0) {
							//tableBody += '<TR><TD colspan="3">No attachments available</TD></TR>';
							$('#tasksDocsTablebody').html(tableBody);

							$(".task-file-delete").off("click");
							$(".task-file-delete").on("click", function() {
								var file = $(this).data();
								deleteAttachment(file);
							});

							$(".task-file-download").off("click");
							$(".task-file-download").on("click", function() {
								var fdata = $(this).attr('itemAttrsEncoded');
								var file = $(this).data();
								downloadAttachment(file);
							});
						} else {
							tableBody += '<TR><TD colspan="3">' + cvUtil.cvLocalize('task.error.no_attachments') +
									'</TD></TR>';
							$('#tasksDocsTablebody').html(tableBody);
						}
					} else {
						if (resp.isClientResp && resp.data.errorCode > 0) {
							cvUtil.errorToast(resp.data.errorMessage, null, null, true);
						}
						$('#tasksDocsTablebody').html('<TR><TD colspan="3">' +
								cvUtil.cvLocalize('task.error.no_attachments') + '</TD></TR>');
					}

				},
				function(resp) {
					$('#tasksDocsTablebody').html('<TR><TD colspan="3">' +
							cvUtil.cvLocalize('task.error.no_attachments') + '</TD></TR>');
					cvUtil.unmask("#task-attachments");
					if (resp.responseText) {
						//cvUtil.errorToast(resp.responseText.trim(), null, null, true);
					}

				});
	}

	function deleteAttachment(file) {
		var request = {};
		request.shareFolderId = 0;
		request.taskId = taskId;

		console.debug("Posting ajax request to delete an attachment");
		var params = [];
		params.push(cvUtil.createParamString("fileGuidId", file.guid));
		params.push(cvUtil.createParamString("taskId", taskId));
		params.push(cvUtil.createParamString("ccGroupId", ccGroupId));
		params.push(cvUtil.createParamString("companyId", companyId));

		var redirectURL = cvUtil.getContextPath() + "/server/deleteTaskAttachment.do?";
		cvUtil.mask("#task-attachments");
		cvUtil.loadPageWithPOST(redirectURL, cvUtil.createParamsString(params), function(resp) {
			if (resp.errorCode) {
				cvUtil.errorToast(resp.errorMessage, null, null, true);
			} else {
				cvUtil.toast(cvUtil.cvLocalize('task.error.file_delete'), null, null, true);
				getAttachments();
			}
			cvUtil.unmask("#task-attachments");
		}, function(resp) {
			cvUtil.unmask("#task-attachments");
			//dashboard.showDocumentsMessage(0, 'Unable to get the data from server');
			if (resp.responseText) {
				cvUtil.errorToast(resp.responseText.trim(), null, null, true);
			}

		});
	}

	function downloadAttachment(file) {
		console.debug("Posting ajax request to download attachment");
		var params = [];
		params.push(cvUtil.createParamString("fileGuidId", file.guid));
		params.push(cvUtil.createParamString("fileName", file.name));
		params.push(cvUtil.createParamString("taskId", taskId));
		params.push(cvUtil.createParamString("ccGroupId", ccGroupId));
		params.push(cvUtil.createParamString("companyId", companyId));

		var redirectURL = cvUtil.getContextPath() + "/server/downloadProfileAttachment.do?";
		cvUtil.mask("#task-attachments");
		cvUtil.loadPageWithPOST(redirectURL, cvUtil.createParamsString(params), function(resp) {
			if (resp.data.errorCode) {
				cvUtil.errorToast(resp.data.errorMessage, null, null, true);
			} else {
				$("#fileNameToDownload").val(window.encodeURIComponent(resp.data.fileName));
				$("#exportForm").submit();
				//cvUtil.toast("File downloaded successfully", null, null, true);
				//getAttachments();
			}
			cvUtil.unmask("#task-attachments");
		}, function(resp) {
			cvUtil.unmask("#task-attachments");
			//dashboard.showDocumentsMessage(0, 'Unable to get the data from server');
			if (resp.responseText) {
				cvUtil.errorToast(resp.responseText.trim(), null, null, true);
			}
		});
		cvUtil.toast(cvUtil.cvLocalize('profile.download.msg'));
	}

	function addTagsToAttachments() {
		var files = $('#task-files-input').prop('files');
		if (files === undefined || files.length <= 0) {
			closeTaskPage();
			return;
		}
		var filesList = '';
		$.each(files, function(i, file) {
			filesList += file.name + ';';
		});

		console.debug("Posting ajax request to tags to files");
		var params = [];
		params.push(cvUtil.createParamString("files", filesList));
		params.push(cvUtil.createParamString("taskId", taskId));
		params.push(cvUtil.createParamString("ccGroupId", ccGroupId));
		params.push(cvUtil.createParamString("companyId", companyId));

		var redirectURL = cvUtil.getContextPath() + "/server/addTagsToTaskAttachments.do?";
		cvUtil.mask("#task-attachments");
		cvUtil.loadPageWithPOST(redirectURL, cvUtil.createParamsString(params), function(resp) {
			if (resp && resp.data.errorCode > 0) {
				cvUtil.errorToast(resp.data.errorMessage, null, null, true);
			}
			cvUtil.unmask("#task-attachments");
			if (uploadAction === true) {
				uploadAction = false;
				document.getElementById("task-files-input").value = "";
				getAttachments();
			} else {
				closeTaskPage();
			}
		}, function(resp) {
			cvUtil.unmask("#task-attachments");
			//closeTaskPage();
			//dashboard.showDocumentsMessage(0, 'Unable to get the data from server');
			if (resp.responseText) {
				cvUtil.errorToast(resp.responseText.trim(), null, null, true);
			}

		});
	}

	function getTaskHistory() {
		var request = {};
		request.taskId = taskId;

		console.debug("Posting ajax request to fetch task history");

		var URL = cvUtil.getContextPath() + "/survey/getProfileTaskHistory.do?";
		cvUtil.mask("#task-history-div");
		$('#task-history-tablebody').empty();
		cvUtil.loadPageWithGET(URL, request, function(resp) {
			cvUtil.unmask("#task-history-div");
			if (resp && resp.data && resp.data.taskHistory) {
				var rows = '';
				$.each(resp.data.taskHistory.aaData, function(i, row) {
					rows += '<TR>';
					rows += '<TD>' + (i + 1) + '</TD>';
					rows += '<TD>' + row.userName + '</TD>';
					rows += '<TD>' + getDate(row.created, 'MM/DD/YYYY hh:mm a') + '</TD>';
					rows += '<TD>' + row.Field + '</TD>';
					rows += '<TD>' + row.NewVal + '</TD>';
					rows += '<TD>' + row.OldVal + '</TD>';
					rows += '</TR>';
				});
				$('#task-history-tablebody').append(rows);
			}
		}, function(resp) {
			cvUtil.unmask("#task-history-div");
			if (resp.responseText) {
				cvUtil.errorToast(resp.responseText.trim(), null, null, true);
			}
		});
	}

	function closeTaskPage(withoutDelay) {
		cvUtil.unmask('');
		if (returnLink) {
			if (withoutDelay) {
				window.location.href = returnLink;
			} else {
				setTimeout(function() {
					//redirect to profile dashboard/tasks page with delay 3sec
					window.location.href = returnLink;
				}, 3000);
			}
		}
	}
	function getCustomerEdgeDriveInfo() {
		var request = {};
		request.customerId = ccGroupId;
		request.companyId = companyId;

		console.debug("Posting ajax request to init customer edge drive folder information");
		cvUtil.mask("#custInfoGrid");
		var configURL = cvUtil.getContextPath() + '/reports/getCustomerEdgeFolderInfo.do';
		cvUtil.loadPageWithPOST(configURL, request, function(resp) {
			if (resp && resp.shareFolderId && resp.shareFolderGuid) {
				edgeInfo=resp;
				if(edgeInfo.permissions !== 2){
					$('.task-uploads').remove();
				}
			}

		}, function(resp) {
			cvUtil.errorToast(resp.responseText.trim(), null, null, true);
		});
	}

	function onUploadFileError(fileItem) {
		if (fileItem.error) {
			cvUtil.errorToast(cvUtil.cvLocalize('task.error.upload_file', fileItem.fileName, fileItem.error.message));
		}
	}
	function split(val) {
		return val.split(/;\s*/);
	}
	function extractLast(term) {
		return split(term).pop();
	}
	function initEmailTaskDialog() {
		$("#email-to, #email-cc")
		// don't navigate away from the field on tab when selecting an item
		.on("keydown", function(event) {
			if (event.keyCode === $.ui.keyCode.TAB && $(this).autocomplete("instance").menu.active) {
				event.preventDefault();
			}
		}).autocomplete({
			minLength : 0,
			source : function(request, response) {
				// delegate back to autocomplete, but extract the last term
				response($.ui.autocomplete.filter(profileUsersList, extractLast(request.term)));
			},
			focus : function() {
				// prevent value inserted on focus
				return false;
			},
			select : function(event, ui) {
				var terms = split(this.value);
				// remove the current input
				terms.pop();
				// add the selected item
				terms.push(ui.item.value);
				// add placeholder to get the comma-and-space at the end
				terms.push("");
				this.value = terms.join("; ");
				return false;
			}
		});

		$('#email-to').val(emailTo);
		$('#email-subject').val('Profile Task #' + taskId + ' - ' + $("#summary").val());
	}

	function sendTakMail() {
		if (!isValidEmailData()) {
			cvUtil.errorToast(cvUtil.cvLocalize('task.validation.errors'));
			return;
		}

		var request = {};
		request.taskId = taskId;
		request.ccGroupId = ccGroupId;
		request.companyId = companyId;
		request.emailTo = $('#email-to').val();
		request.emailCc = $('#email-cc').val();
		request.emailSubject = $('#email-subject').val();
		request.emailMessage = $('#email-msg').val();
		request.taskUrl = window.location.href;
		request.custName = customerName;
		console.debug("Posting ajax request to send task email");
		cvUtil.mask("#emailModal");
		var configURL = cvUtil.getContextPath() + '/reports/sendProfileTaskEmail.do';
		cvUtil.loadPageWithPOST(configURL, request, function(resp) {
			cvUtil.unmask("#emailModal");
			if (resp.data.success) {
				cvUtil.toast(cvUtil.cvLocalize('task.email.success'));
				$('#emailModal').modal('hide');
			} else {
				cvUtil.errorToast(cvUtil.cvLocalize('task.email.fail'));
			}
		}, function(resp) {
			cvUtil.unmask("#emailModal");
			cvUtil.errorToast(resp.responseText.trim(), null, null, true);
		});

	}

	function isValidEmailData() {
		var msg = '';
		var emailTo = $('#email-to').val();
		var emailCc = $('#email-cc').val();
		if ((emailTo === undefined || emailTo.trim() === '') && (emailCc === undefined || emailCc.trim() === '')) {
			msg = cvUtil.cvLocalize('task.email.error.address_count');
			markField('#email-to', msg);
			markField('#email-cc', msg);
		} else {
			if (emailTo.trim().length > 0 && !isValidEmail(emailTo)) {
				msg = cvUtil.cvLocalize('task.email.error.address');
			} else {
				msg = '';
			}
			markField('#email-to', msg);
			if (emailCc.trim().length > 0 && !isValidEmail(emailCc)) {
				msg = cvUtil.cvLocalize('task.email.error.address');
			} else {
				msg = '';
			}
			markField('#email-cc', msg);
		}
		msg = '';

		var emailSubject = $('#email-subject').val();
		if (emailSubject === undefined || emailSubject.trim() === '') {
			msg = cvUtil.cvLocalize('task.email.error.subject');
		}
		markField('#email-subject', msg);
		msg = '';

		if ($('.has-error').length > 0) {
			return false;
		}
		return true;
	}

	function isValidEmail(emails) {
		emails = emails.replace(/[\s,;]+/g, ';'); //replace all whitespaces, comma and semicolons with a single semicolon
		var emailList = emails.split(';');
		if (emailList == null) {
			emailList = emails;
		}
		var emailPattern = /^[^@;,\s]+@[^@;,\s]+\.[^@;,\s]+$/; //basic validation - restrict @, comma, semicolon and any white space
		var isValid = true;
		$.each(emailList, function(index, value) {
			if (value) {
				value = $.trim(value);
				if (!value.match(emailPattern)) {
					isValid = false;
					return;
				}
			}
		});
		return isValid;
	}

	function cleanupEmailDialog() {
		$('#email-to').val('');
		$('#email-cc').val('');
		$('#email-subject').val('');
		$('#email-msg').val('');
		$("#emailModal .form-group").removeClass("has-error");
	}

	init();
	taskExports.task = {
		addTagsToAttachments : addTagsToAttachments,
		onUploadFileError : onUploadFileError
	};

})(window);