<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>
<fmt:bundle basename="localization.SurveyMessages">

	<jsp:include page="../../common/header.jsp">
		<jsp:param value="true" name="includeMask" />
		<jsp:param value="true" name="includeSecHeader" />
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="" name="titleLocalized" />
		<jsp:param value="dialog" name="displayMode" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/profile.css" name="css" />
	</jsp:include>

	<style>
		#content {
		    background-color: white;
		    border: medium none;
		    box-shadow: none;
		    min-height: 1px;
		    padding: 0;
		}
	</style>
	<script nonce="${sessionScope.cspNonce}" >
	    var localMsg = localMsg || {};
		${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
	</script>
	<div>
		<div id="contactMask" class="addOn">
		<div>
			<div id="contactTypeDiv">
				<span><fmt:message key="contact.contactType"/></span>
				<input type="radio" name="contactType" id="commvault" value="1" class="formField" checked><fmt:message key="contact.commvault"/>
				<input type="radio" name="contactType" id="customer" value="2" class="formField"><fmt:message key="contact.customer"/>
			</div>
			<h3 class="contactTitle editMessage"><fmt:message key="contact.editContact.title.page"/></h3>
			<h3 class="contactTitle addMessage"><fmt:message key="contact.addContact.title.page"/></h3>
			<form id="custContactsForm" class="stdBorder">
				<table >
					<tbody>
						<tr>
							<td class="label custLeftLabel"><fmt:message key="contact.name"/></td><td class="value"><select id="userContact" class="field"></select><input type="text" name="name" id="name" class="field"></td>
							<td class="label primaryContact custRightLabel"></td><td class="value"><input id="primaryContact" type="checkbox"/><fmt:message key="contact.primaryContact"/></td>
						</tr>
						<tr>
							<td class="label custLeftLabel"><fmt:message key="contact.phone"/></td><td class="value"><input type="text" name="phone" id="phone" class="field"></td>
							<td class="label custRightLabel"><fmt:message key="contact.team"/></td><td class="value"><select id="category" class="selectField"></select></td>
						</tr>
						<tr>
							<td class="label custLeftLabel"><fmt:message key="contact.title"/></td><td class="value">
								<div class="select-editable">
								    <select id="userTitleSelect">
								        <option value=""></option>
								        <option value="Engineer">Engineer</option>
										<option value="SE">SE</option>
										<option value="SAM">SAM</option>
										<option value="TAM">TAM</option>
								    </select>
								    <input type="text" id="userTitle" name="format" value="" />
								</div>
								<input type="text" name="title" id="title" class="field"></td>
							<td class="label custRightLabel"><span id="emailsLabel"><fmt:message key="contact.email"/></span></td>
							<td class="value"><input type="email" name="emails" id="emails" class="field"></td>

						</tr>

					</tbody>
				</table>

			</form>
			<div class="contactOpts btns">
					<a class='cancelButton resetContact'><fmt:message key="contact.reset"/></a>
					<a class='okSaveButton addUpdateContact'><fmt:message key="contact.add"/></a>
			</div>
		</div>
		<h3 class="contactTitle existingContactTitle"><fmt:message key="contact.label.existing"/></h3>
			<div id="contactsList" class="stdBorder">
				<table id="contactsList_table" class="display"></table>
				<div class="clearFloat"></div>
			</div>

		<h3 class="contactTitle contractTitle"><fmt:message key="contact.contractTitle"/></h3>
			<div id="contractDates" class="stdBorder">
				<table >
					<tbody>
						<tr>
							<td class="label"><fmt:message key="contact.contract.tamStartDate"/></td>
							<td class="value"><input type="text" id="tamStartDate" placeholder="mm/dd/yyyy" /></td>
							<td class="rightLabel"><fmt:message key="contact.contract.endDate"/></td>
							<td class="value"><input type="text" id="tamEndDate" placeholder="mm/dd/yyyy" /></td>
						</tr>
						<tr>
							<td class="label"><fmt:message key="contact.contract.engineerStartDate"/></td>
							<td class="value"><input type="text" id="engStartDate" placeholder="mm/dd/yyyy" /></td>
							<td class="rightLabel"><fmt:message key="contact.contract.endDate"/></td>
							<td class="value"><input type="text" id="engEndDate" placeholder="mm/dd/yyyy" /></td>
						</tr>
					</tbody>
				</table>
				<div class="clearFloat"></div>
			</div>

		</div>
		<fmt:bundle basename="localization.messages">
			<div class="buttonsDiv btns rghtFloat" >
				<a href="#" id="cancelButton"><fmt:message key="Cancel" /></a>
				<a href="#" id="okButton" class="okSaveButton"><fmt:message key="Submit" /></a>
			</div>
		</fmt:bundle>

	</div>
</fmt:bundle>

<jsp:include page="../../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/reports/js/reportsUtil.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/tablebase.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/moment.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/profile/js/profilecustcontacts.js" name="js" />
</jsp:include>