<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<fmt:bundle basename="localization.SurveyMessages">
	<jsp:include page="../../common/header.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
			<jsp:param value="reports/reportsBase.jsp" name="jsp" />
			<jsp:param value="true" name="includeHistory"/>
			<jsp:param value="${pageContext.request.contextPath}/survey/css/uniform.default.css" name="css" />
			<jsp:param value="true" name="includeJqueryUI" />
			<jsp:param value="true" name="includeTableSupport" />
			<jsp:param value="Profile Tasks" name="titleLocalized" />
			<jsp:param value="" name="headerTitleLocalized" />
			<jsp:param value="" name="headerTitle" />
			<jsp:param value="true" name="includeCustomSelect"/>
			<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css"/>
			<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
			<jsp:param value="${pageContext.request.contextPath}/survey/css/operations.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
			<jsp:param value="true" name="bootstrapped" />
			<jsp:param value="true" name="reportsNav" />
			<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/survey/css/alarms.css" name="css" />
			<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
	</jsp:include>

	<fmt:message key="profile.Profile_Dashboard" var="Profile_Dashboard" />
	<fmt:message key="NoDataAvailable" var="NoDataAvailable" />
	<fmt:message key="tasks.Profile_Tasks" var="Profile_Tasks" />
	<fmt:message key="profile.Invalid_CommCell_Group_Id" var="Invalid_CommCell_Group_Id" />
	<fmt:message key="Reports" var="Reports" />
	<fmt:message key="profile.Profile_not_configured" var="Profile_not_configured" />
	<fmt:message key="profile.Profile_disabled" var="Profile_disabled" />

	<jsp:include page="../surveyBase.jsp">
		<jsp:param value="ProfileTasks" name="apptype"/>
		<jsp:param value="true" name="includeExportSupport"/>
	</jsp:include>

	<jsp:include page="../reports/surveyHeader.jsp">
		<jsp:param value="true" name="changePage" />
		<jsp:param value="../reports/dashboard.jsp" name="searchPage"/>
		<jsp:param name="welcomeMsg" value="" />
		<jsp:param name="searchCC" value="false" />

		<jsp:param name="exportPdf" value="true"/>
		<jsp:param name="exportCsv" value="true" />
		<jsp:param name="exportHtml" value="true" />
		<jsp:param name="printButton" value="true" />
		<jsp:param name="exportEnabled" value="true" />
		<jsp:param name="includeCROptionBeforeExport" value="true" />
		<jsp:param name="includeCROptionBeforeSearch" value="true" />
	</jsp:include>




	<script type="text/javascript" nonce="${sessionScope.cspNonce}" >
		var showProfileDashboard=false, isCommvaultUser=false;
		<c:if test="${applicationScope.showProfileDashboard == true }">
			showProfileDashboard=true;
		</c:if>
		<c:if test="${sessionScope.isCommvaultUser == true }">
			isCommvaultUser=true;
		</c:if>
		var localMsg_Profile_Dashboard = "${Profile_Dashboard}";
		var localMsg_NoDataAvailable = "${NoDataAvailable}";
		var localMsg_Profile_Tasks = "${Profile_Tasks}";
		var localMsg_Invalid_CommCell_Group_Id = "${Invalid_CommCell_Group_Id}";
		var localMsg_Reports = "${Reports}";
		var localMsg_Profile_not_configured = "${Profile_not_configured}";
		var localMsg_Profile_disabled = "${Profile_disabled}";

	</script>
	<div id="noDataNotificationPanel" class='noDataErrorMsg profileErrorMsg'>
		<span class='sprite icon-info'></span>
		<span id='profileTasksMsg'></span>
	</div>
	<div id="ContentWrapper">
		<div class="tasksToolbar hideOnExportFriendly">
			<span class='addTask task-button'><span class='new-task-icon sprite icon-plus'></span><span class='addTaskBtn'><fmt:message key="tasks.NewTask" /></span></span>
			<c:if test="${sessionScope.isCommvaultUser == true}">
				<span class='worldwideTasks task-button'><fmt:message key="tasks.Worldwide_Tasks" /></span>
			</c:if>
		</div>
		<div id="statusPie" class="tasksStatusPie">
			<div id="chartTitle" class="chartTitleStyle"><fmt:message key="tasks.Tasks_by_Status" /></div>
			<div id="piechartcontainer" ></div>
		</div>
	</div>

	<form id="exportForm" action="${pageContext.request.contextPath}/server/doDownload" method="get">
		<input id="downloadType" type='hidden' name='type' value='report' />
		<input id="fileNameToDownload" type='hidden' name='fileName' value='' />
	</form>

	<jsp:include page="../reports/alarmdialog.jsp"></jsp:include>

	<jsp:include page="../../common/footer.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/jquery.uniform.min.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-min.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/g.raphael.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/custom-pie.js" name="js" />
	  	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
	  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	  	<jsp:param value="${pageContext.request.contextPath}/common/js/moment.js" name="js" />
	  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/search.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/alarms.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/profile/js/profiletasks.js" name="js" />
		<jsp:param value="true" name="bootstrapped" />
	</jsp:include>
</fmt:bundle>
