<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>
<fmt:bundle basename="localization.SurveyMessages">

	<jsp:include page="../../common/header.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
		<jsp:param value="true" name="includeHistory"/>
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="Profile Tasks" name="titleLocalized" />
		<jsp:param value="" name="headerTitleLocalized" />
		<jsp:param value="" name="headerTitle" />
		<jsp:param value="true" name="includeCustomSelect"/>
		<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
		<jsp:param value="true" name="bootstrapped" />
		<jsp:param value="true" name="reportsNav" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/tasks.css" name="css" />
	</jsp:include>
	<jsp:include page="../surveyBase.jsp">
		<jsp:param value="ProfileTask" name="apptype"/>
	</jsp:include>

	<jsp:include page="../reports/surveyHeader.jsp">
		<jsp:param value="true" name="changePage" />
		<jsp:param name="welcomeMsg" value="" />
		<jsp:param name="searchCC" value="false" />

	</jsp:include>

	<fmt:bundle basename="localization.BackupBrowseMessages">
		<fmt:message key="backupBrowse.notification.downloadSubmitted" var="downloadSubmitted" />
	</fmt:bundle>
	<fmt:message key="profile.Profile_Dashboard" var="Profile_Dashboard" />
	<fmt:message key="NoDataAvailable" var="NoDataAvailable" />
	<fmt:message key="tasks.Profile_Tasks" var="Profile_Tasks" />
	<fmt:message key="profile.Invalid_CommCell_Group_Id" var="Invalid_CommCell_Group_Id" />
	<fmt:message key="Reports" var="Reports" />
	<fmt:message key="profile.Profile_not_configured" var="Profile_not_configured" />
	<fmt:message key="profile.Profile_disabled" var="Profile_disabled" />
	<script nonce="${sessionScope.cspNonce}" >
	    var localMsg = localMsg || {};
		${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};
		localMsg.downloadSubmitted="${downloadSubmitted}";
		var showProfileDashboard=false, isCommvaultUser=false;
		<c:if test="${applicationScope.showProfileDashboard == true }">
			showProfileDashboard=true;
		</c:if>
		<c:if test="${sessionScope.isCommvaultUser == true }">
			isCommvaultUser=true;
		</c:if>
		var localMsg_Profile_Dashboard = "${Profile_Dashboard}";
		var localMsg_NoDataAvailable = "${NoDataAvailable}";
		var localMsg_Profile_Tasks = "${Profile_Tasks}";
		var localMsg_Invalid_CommCell_Group_Id = "${Invalid_CommCell_Group_Id}";
		var localMsg_Reports = "${Reports}";
		var localMsg_Profile_not_configured = "${Profile_not_configured}";
		var localMsg_Profile_disabled = "${Profile_disabled}";
	</script>
	<div id="noDataNotificationPanel" class='noDataErrorMsg profileErrorMsg'>
		<span class='sprite icon-info'></span>
		<span id='profileTasksMsg'></span>
	</div>
	<div id="ContentWrapper" class="container">
		<div id="task-tabs">
			<ul>
				<li><a href="#task-general"><span class="task-tab-title"><fmt:message key="task.tab.general" /></span></a></li>
				<c:if test="${!(sessionScope.isCommvaultUser == false and param.ccGroupId > 0)}">
					<li id="task-attachments-li"><a href="#task-attachments"><span class="task-tab-title"><fmt:message key="task.tab.attachments" /></span></a></li>
				</c:if>
				<c:if test="${fn:escapeXml(param.taskId) != null && fn:escapeXml(param.taskId) > 0}">
					<li id="task-history-li"><a href="#task-history"><span class="task-tab-title"><fmt:message key="task.tab.history" /></span></a></li>
				</c:if>
			</ul>
			<div id="task-general">
				<form id="taskForm">
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="summary"><fmt:message key="task.name" /></label>
						<div class="form-group">
							<input type="text" name="summary" id="summary" class="col-sm-4 col-xs-12 task-input form-control">
						</div>
						<label class="col-sm-2 col-xs-12" for="task-type"><fmt:message key="task.task_type" /></label>
						<div class="col-sm-4 col-xs-12 form-group">
							<input type="radio" name="task-type" value="0" id="task-type-task" checked><label class="task-radio-label" for="task-type-task"><fmt:message key="task.type.task"/></label>
							<input type="radio" name="task-type" value="3" id="task-type-cv"><label class="task-radio-label" for="task-type-cv"><fmt:message key="task.type.cv"/></label>
							<input type="radio" name="task-type" value="4" id="task-type-customer"><label class="task-radio-label" for="task-type-customer"><fmt:message key="task.type.customer"/></label>
						</div>
					</div>
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="createdBy"><fmt:message key="task.createdby" /></label>
						<div class="form-group">
							<input type="text" name="createdBy" id="createdBy" class="col-sm-4 col-xs-12 task-input form-control" disabled>
						</div>
						<label class="col-sm-2 col-xs-12" for="createddate"><fmt:message key="task.createddate" /></label>
						<div class="form-group">
							<input type='text' id='createddate' name='createddate' class='col-sm-4 col-xs-12 task-input form-control' disabled/>
						</div>
					</div>
					<c:if test="${fn:escapeXml(param.taskId) != null && fn:escapeXml(param.taskId) > 0}">
						<div class="row">
							<label class="col-sm-2 col-xs-12" for="modifiedBy"><fmt:message key="task.modifiedBy" /></label>
							<div class="form-group">
								<input type="text" name="modifiedBy" id="modifiedBy" class="col-sm-4 col-xs-12 task-input form-control" disabled>
							</div>
							<label class="col-sm-2 col-xs-12" for="modifiedDate"><fmt:message key="task.modifiedDate" /></label>
							<div class="form-group">
								<input type='text' id='modifiedDate' name='modifiedDate' class='col-sm-4 col-xs-12 task-input form-control' disabled/>
							</div>
						</div>
					</c:if>
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="autoUsersList"><fmt:message key="task.assignedto" /></label>
						<div id="autocompletediv" class="autocompletediv form-group">
							<input name="autoUsersList" id="autoUsersList" class="col-sm-4 col-xs-12 task-input autoTaskUsers form-control" spellcheck="false" placeholder="Search User" />
						</div>

						<label class="col-sm-2 col-xs-12" for="startdate"><fmt:message key="task.startdate" /></label>
						<div class="form-group">
							<input type='text' id='startdate' name='startdate' class='col-sm-4 col-xs-12 task-input form-control' title='Enter Date in MM/DD/YYYY format.'/>
						</div>
					</div>
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="status"><fmt:message key="task.status" /></label>
						<div class="form-group">
							<select id="status" class="col-sm-4 col-xs-12 task-input form-control">
								<option value="1"><fmt:message key="task.status.Open" /></option>
								<option value="2"><fmt:message key="task.status.Fixed_Monitoring" /></option>
								<option value="3"><fmt:message key="task.status.Closed" /></option>
								<option value="4"><fmt:message key="task.status.Killed" /></option>
								<option value="5"><fmt:message key="task.status.OnHold" /></option>
							</select>
						</div>
						<label class="col-sm-2 col-xs-12" for="duedate"><fmt:message key="task.duedate" /></label>
						<div class="form-group">
							<input type='text' id='duedate' name='duedate' class='col-sm-4 col-xs-12 task-input form-control' title='Enter Date in MM/DD/YYYY format.' />
						</div>
					</div>
					<div class="row hide-change-reason">
						<label class="col-sm-2 col-xs-12 hide-change-reason status-reason" for="status-reason" ><fmt:message key="task.Status_Change_Reason" /></label>
						<div class="form-group">
							<textarea id="status-reason" name="status-reason" class="col-sm-4 col-xs-12 reason task-input form-control task-input-reason hide-change-reason status-reason"  placeholder="Enter reason for status change"></textarea>
						</div>

						<label class="col-sm-2 col-xs-12 hide-change-reason duedate-reason" for="duedate-reason" ><fmt:message key="task.Due_date_Change_Reason" /></label>
						<div class="form-group">
							<textarea id="duedate-reason" name="duedate-reason" class="col-sm-4 col-xs-12 reason task-input form-control task-input-reason hide-change-reason duedate-reason" placeholder="Enter reason for due date change"></textarea>
						</div>
					</div>
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="url"><fmt:message key="task.url" /></label>
						<div class="form-group">
							<input type="text" name="url" id="url" class="col-sm-4 col-xs-12 task-input form-control" />
						</div>

						<c:if test="${sessionScope.isCommvaultUser == true}">
							<div class="internal-task-div">
								<span  class="custom-cb task-input" id="internal" data-state="unchecked"></span>
								<label class="custom-cb-label internal-task-label" for="internal"><fmt:message key="task.internal" /></label>
							</div>
						</c:if>
					</div>
					<div class="row">
						<label class="col-sm-2 col-xs-12" for="desc"><fmt:message key="task.description" /></label>
						<div class="form-group">
							<textarea name="desc" id="desc" class="col-sm-4 col-xs-12 task-input task-input-area form-control"></textarea>
						</div>
						<label class="col-sm-2 col-xs-12" for="notes"><fmt:message key="task.notes" /></label>
						<div class="form-group">
							<textarea name="notes" id="notes" class="col-sm-4 col-xs-12 task-input task-input-area form-control"></textarea>
						</div>
					</div>
					<div class="row">
						<span class="form-error-msg"></span>
					</div>
				</form>
			</div>
			<c:if test="${!(sessionScope.isCommvaultUser == false and param.ccGroupId > 0)}">
				<div id="task-attachments">
					<div id="attachments">
						<table id="tasksDocsTable" class="table">
							<thead>
								<tr>
									<th>#</th>
									<th><fmt:message key="task.file.file_name" /></th>
									<th><fmt:message key="task.file.size" /></th>
									<th><fmt:message key="task.file.action" /></th>
								</tr>
							</thead>
							<tbody id="tasksDocsTablebody">
								<TR>
									<TD colspan="4"><fmt:message key="task.noattachments" /></TD>
								</TR>
							</tbody>
						</table>
						</div>
					<div>
						<div class="task-uploads">
							<div class="row task-upload-options">
								<input type="file" name="docs" id="task-files-input" class="col-sm-3" multiple>
								<input type="button" id="task-upload-btn" value="Upload" class="col-sm-1">
							</div>
						</div>
					</div>
				</div>
			</c:if>
			<c:if test="${fn:escapeXml(param.taskId) != null && fn:escapeXml(param.taskId) > 0}">
				<div id="task-history">
						<div id="task-history-div">
							<table id="task-history-table" class="table">
								<thead>
									<tr>
										<th>#</th>
										<th><fmt:message key="task.history.user" /></th>
										<th><fmt:message key="task.history.time" /></th>
										<th><fmt:message key="task.history.field_name" /></th>
										<th><fmt:message key="task.history.new_value" /></th>
										<th><fmt:message key="task.history.old_value" /></th>
									</tr>
								</thead>
								<tbody id="task-history-tablebody">
									<TR>
										<TD colspan="6"><fmt:message key="task.history.No_history_available"/></TD>
									</TR>
								</tbody>
							</table>
						</div>
				</div>
			</c:if>
		</div>

		<div class="btn-actions">
			<div class="btn-group">
				<button type="button" class="btn btn-primary" id="okButton"><fmt:message key="Save" /></button>
				<button type="button" class="btn btn-default" id="cancelButton"><fmt:message key="Cancel" /></button>
				<c:if test="${fn:escapeXml(param.taskId) != null && fn:escapeXml(param.taskId) > 0}">
					<button type="button" class="btn btn-default" id="emailButton" data-toggle="modal" data-target="#emailModal"><fmt:message key="task.email"/></button>
				</c:if>
			</div>
		</div>
	</div>
<%@include file="profile-templates.jsp" %>

</fmt:bundle>

<%@include file="tasksCommon.jsp" %>

<jsp:include page="../../common/footer.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/jquery.uniform.min.js" name="js" />
	  	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
	  	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	  	<jsp:param value="${pageContext.request.contextPath}/common/js/moment.js" name="js" />
	  	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/reports/js/reportsUtil.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/profile/js/task.js" name="js" />
		<jsp:param value="true" name="bootstrapped" />
</jsp:include>

