<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<fmt:bundle basename="localization.SurveyMessages">

<fmt:message key="DDBPerformance.Records" var="records"/>
<fmt:message key="DDBPerformance.DataSize" var="dataSize"/>
<fmt:message key="DDBPerformance.AverageQAndITime" var="qiTime"/>

<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	var localMsg = localMsg || {};
	localMsg.records="${records}";
	localMsg.dataSize="${dataSize}";
	localMsg.qiTime="${qiTime}";
</script>

<div id="trendingDiv">
	<h1>
		<div class="arrowPlaceholder collapse"></div>
		<span id="trendTitle"><fmt:message key="DDBPerformance.PerformTrending"/></span>
	</h1>
	<div id = "trendingWrapper">
		<div id="ddbTrendFilter"  class="hideOnExportFriendly">
			<div class="trendFilter">
				<h4><fmt:message key="DDBPerformance.Trending.Options"/></h4>
				<div id="freqDiv">
					<div>
					<label id="trendFrequencyLabel" for="trendFrequency"><fmt:message key="DDBPerformance.Frequency"/></label>
					<select id="trendFrequency">
						<option value=1 data-sublabel="<fmt:message key="DDBPerformance.days"/>"><fmt:message key="DDBPerformance.Daily"/></option>
						<option value =2 data-sublabel="<fmt:message key="DDBPerformance.weeks"/>"><fmt:message key="DDBPerformance.Weekly"/></option>
						<option value=3 data-sublabel="<fmt:message key="DDBPerformance.months"/>"><fmt:message key="DDBPerformance.Monthly"/></option>
					</select>
					</div>
					<div>
					<label id ="lastNDaysLabel"for="lastNDays"><fmt:message key="DDBPerformance.ForLast"/></label>
					<input id="lastNDays" value="7" type="number" min="2" max="30"/>
					<label id="nDaysText"><fmt:message key="DDBPerformance.days"/></label>
					</div>
					<input id="applyButton" type="button" value="<fmt:message key="DDBPerformance.Get.Trending.Data"/>">
				</div>
			</div>

			<div id="plotOptions" class="trendFilter">
				<h4><fmt:message key="DDBPerformance.PlotOptions"/></h4>
				<div id="ddbListDiv">
					<label><fmt:message key="DDBPerformance.SelectDDBToTrend"/><select id="ddbListBox">	</select></label>
				</div>
				<div id="records"  class="optionsDiv selected">
					<p><fmt:message key="DDBPerformance.ByRecords"/></p>
					<ul  class="verticalList">
							<li><div id="PRIMARY_RECORDS"   class="custom-cb checked plotEntity" data-state="checked"></div><span class="custom-cb-label"><fmt:message key="DDBPerformance.PrimaryRecords"/></span></li>
							<li><div id="SECONDARY_RECORDS"   class="custom-cb checked plotEntity" data-state="checked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.SecondaryRecords"/></span></li>
							<li ><div id="PRUNABLE_RECORDS"   class="custom-cb checked plotEntity" data-state="checked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.PrunableRecords"/></span></li>
					</ul>


				</div>

				<div id="dataSize" class="optionsDiv">
					<p><fmt:message key="DDBPerformance.ByDataSize"/></p>
					<ul class="horizontalList">
						<li class="col1"><div id="DEDUPED_DATA"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.DedupedData"/></span></li>
						<li><div id="TOTAL_DATA"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.TotalData"/></span></li>
						<li class="col1"><div id="FRONTEND_BACKUP"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.FrontendBackup"/></span></li>
						<li><div id="FRONTEND_ARCHIVE"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label"><fmt:message key="DDBPerformance.FrontendArchive"/></span></li>
						<li class="col1"><div id="DDB_SIZE"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label"><fmt:message key="DDBPerformance.SizeOfDDB"/></span></li>
					</ul>
				</div>

				<div id="QITime"  class="optionsDiv">
					<p><fmt:message key="DDBPerformance.ByQITime"/></p>
					<ul class="verticalList">
						<li ><div id="QI_TIME"   class="custom-cb unchecked plotEntity" data-state="unchecked"></div><span class="custom-cb-label" ><fmt:message key="DDBPerformance.AverageQAndITime"/></span></li>
					</ul>
				</div>
				<div class="clearFloat"></div>
			</div>
		</div>
		<div class="clearFloat"></div>
		 <div class="showOnExportFriendly" id="chartOptionDiv">
			<table id="chartOptionSummary">
				<tr><td><fmt:message key="DDBPerformance.Frequency"/>:</td><td id="freqVal"></td></tr>
				<tr><td><fmt:message key="DDBPerformance.ForLast"/>:</td><td id="forLastVal"> </td></tr>
				<tr><td><fmt:message key="DDBPerformance.DDB"/>:</td><td id="ddbVal"> </td></tr>
				<tr><td><fmt:message key="DDBPerformance.Entities"/>:</td><td id="entitiesVal"> </td></tr>
			</table>
		</div>
		<div>
		</div>
		<div id="chartDisplayArea">
			<p id="messageLabel"></p>
			<div id= "ddbTrendChartArea">
			</div>

		</div>
		</div>


	</div>
	</fmt:bundle>