<!-- Markup for all alert dialogs -->
<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>

<jsp:include page="../../reportsplus/alarms/alarmlocale.jsp"/>

<fmt:bundle basename="localization.ReportsPlusMessages">
<fmt:message key="monday" var="monday"/>
<fmt:message key="tuesday" var="tuesday"/>
<fmt:message key="wednesday" var="wednesday"/>
<fmt:message key="thursday" var="thursday"/>
<fmt:message key="friday" var="friday"/>
<fmt:message key="saturday" var="saturday"/>
<fmt:message key="sunday" var="sunday"/>


<div id="alarmsDialog" style="display:none">
	<div class="alarmsConfigurationDiv alert-section-container">
	  <div class="form-group row">
			<div class="col-sm-3">
				<label for="alarmName"><fmt:message key="AlertName"/></label>
			</div>
	        <div class="col-sm-9">
				<input type="text" id="alarmName" class="input-control full-width"/>
			</div>
	   </div>

	   <div class="form-group row">
			<div class="col-sm-12">
			   <p id="sendNotifSelection"><fmt:message key="SendNotificationWith"/>
					<span id="alertSeverity">
						<select id="alertSeveritySelect">
					  		<option value="INFORMATION" selected><fmt:message key="InfoStatus"/></option>
							<option value="WARNING"><fmt:message key="WarningStatus"/></option>
							<option value="CRITICAL"><fmt:message key="CriticalStatus"/></option>
						</select><fmt:message key="StatusText"/></span>
					<c:if test="${param.healthReport == null || param.healthReport != 'true'}">
						 <span id="allOrAnyDiv" class="alarmAllOrAnyDivOpacity">
						 	<select id="allOrAnySelect" disabled>
						   		<option value="false" selected>all</option>
						   		<option value="true">any</option>
							</select><fmt:message key="SendNotificationRestText"/>
						</span>
					</c:if>
			 	</p>
			</div>
	 	</div>

	 	<div class="form-group row margin-bottom-none">
		    <c:choose>
			<c:when test="${param.healthReport != null && param.healthReport == 'true'}">
		        <div id="health-opts-div" class="col-sm-12">
		            <div id="alarmReportName" class="alarmReportName"><fmt:message key="HealthAlert"/></div>
		            <ul id="alarmOpts" class="alarmOpts">
		                <li>
		                    <div class="opts-radios">
		                        <input type="radio" name="configureBy" id="byStatus" value="byStatus" checked/>
		                        <label for="byStatus">
		                        	<span class="paramName" id="paramName"></span>'s status is
		                        </label>
		                    </div>
		            	    <select id="statusSelect">
		            	       <option value="critical"><fmt:message key="CriticalStatus"/></option>
		            	       <option value="warning"><fmt:message key="WarningStatus"/></option>
		            	       <option value="good"><fmt:message key="GoodStatus"/></option>
		            	    </select>
		                </li>
		                <li id="byValLi">
		                    <div class="opts-radios">
		                    </div>
		                    <div class="clearFloat"></div>
		                </li>
		            </ul>
		            <button class="testCriteria" title="Test Criteria"><fmt:message key="Test_Criteria"/></button>
		        </div>
		       </c:when>
		          <c:otherwise>
		        <div id="general-opts-div">
		            <div id="gen-paramName" class="alarmReportName"></div>
		            <ul id="gen-alarmOpts">
		            </ul>
		            <div>
		                <button class="addNewCondition" title="Add New Condition"><fmt:message key="AddCondition"/></button>
		                <button class="testCriteria" title="Test Criteria"><fmt:message key="Test_Criteria"/></button>
		                <button id="editCriteria" class="editCriteria" title="<fmt:message key="Edit_Criteria_Title"/>" style="display:none"><fmt:message key="Edit_Criteria"/></button>
		            </div>
		        </div>
		      </c:otherwise>
		      </c:choose>
	      </div>

          <div id="alarmErr" class="alarmErr form-group row"><fmt:message key="ValidationText"/></div>
        <div class="clearFloat" ></div>
	  </div>
	<!-- ======================================================================================================================= -->

		<div class="alarm-accordion" id="notifications-accordion">
			<button class="alarm-accordion-title">
			 	<i class="glyphicon glyphicon-chevron-down"></i><i class="glyphicon glyphicon-chevron-right"></i>
			 	<span class="title-val"> <fmt:message key="label.accordion.notification"/> </span>
	 		</button>
	 		<div class="alarm-accordion-panel">
	 			<div class="alert-section-container">
				  	<c:choose>
						<c:when test="${applicationScope.isPublicMetricsCloud == null || applicationScope.isPublicMetricsCloud == 'false'}">
					       	<div class="notificationType">
					       		<div class="form-group row padding-bottom-15">
					       			<div class="col-sm-12">
						               <ul class="notes">
											<li><div id='emailAlertCB' class="custom-cb notesCB otherNotifications" data-state="unchecked" data-value="EMAIL"></div><span class="custom-cb-label" ><fmt:message key="Email"/></span></li>
											<li><div id='consoleAlertCB' class="custom-cb notesCB otherNotifications" data-state="unchecked" data-value="LIVEFEEDS"></div><span class="custom-cb-label" ><fmt:message key="ConsoleAlerts"/></span></li>
											<li><div id='eventViewerCB' class="custom-cb notesCB otherNotifications" data-state="unchecked" data-value="APPLOG"></div><span class="custom-cb-label" ><fmt:message key="WindowsEventViewer"/></span></li>
											<li><div id='snmpCB' class="custom-cb notesCB otherNotifications" data-state="unchecked" data-value="SNMP"></div><span class="custom-cb-label" ><fmt:message key="SNMPTraps"/></span></li>
											<li><div id='scomCB' class="custom-cb notesCB otherNotifications" data-state="unchecked" data-value="SCOM"></div><span class="custom-cb-label" ><fmt:message key="SCOMAlert"/></span></li>
									    </ul>
								  </div>
								</div>
								<div id="emailDetails" class="full-width" style="display:none">
									<div class="form-group row padding-bottom-15">
										<div class="col-sm-3">
											<label for="emailTo"><fmt:message key="Recipients"/> </label>
										</div>
										<div class="col-sm-9">
											<span class="email_suggestion full-width" data-margin-left="0" data-suggestion-width="100%">
												<input type="text" id="emailTo" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space"/>
											</span>
										</div>
									</div>

									<div class="form-group row padding-bottom-15">
										<div class="col-sm-3">
											<label for="emailCc"><fmt:message key="CcRecipients"/> </label>
										</div>
										<div class="col-sm-9">
											<span class="email_suggestion full-width" data-margin-left="0" data-max-suggestion="6"  data-suggestion-width="100%" >
												<input type="text" id="emailCc" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space"  />
											</span>
										</div>
									</div>

									<div class="form-group row padding-bottom-15">
										<div class="col-sm-3">
											<label for="emailBcc"><fmt:message key="BccRecipients"/> </label>
										</div>
										<div class="col-sm-9">
											<span class="email_suggestion full-width" data-margin-left="0" data-max-suggestion="5"  data-suggestion-width="100%">
												<input type="text" id="emailBcc" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space" />
											</span>
										</div>
									</div>

								</div>
								<div id="customiseEmail" style="display:none">
									<div class="form-group row">
										<div class="col-sm-3">
											<label for="emailBody"><fmt:message key="Content_Label"/></label>
										</div>
										<div class="col-sm-9">
											<textarea id="emailBody" class="gen-Custom-SNMP-template input-control full-width" ROWS=2></textarea>
										</div>
									</div>
								</div>
								<div id="customiseSNMPTrap" style="display:none">
									<div class="form-group row">
										<div class="col-sm-3">
											<label for="customSNMPTrap"><fmt:message key="DescriptionColon"/></label>
										</div>
										<div class="col-sm-9">
											<textarea id="customSNMPTrap" class="gen-Custom-SNMP-template input-control full-width" ROWS=4></textarea>
										</div>
										<div class="col-sm-9 col-sm-offset-3">
											<span><fmt:message key="Alarms_SNMP_Note"/></span>
										</div>
									</div>
								</div>
					           </div>
						</c:when>
						<c:otherwise>
					             <div id="emailDetails" class="full-width">
					             	<div class="form-group row padding-bottom-15">
						             	<div class="col-sm-3">
											<label for="emailTo"><fmt:message key="Recipients"/> </label>
										</div>
										<div class="col-sm-9">
											<input type="text" id="emailTo" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space"/>
										</div>
									</div>

									<div class="form-group row  padding-bottom-15">
										<div class="col-sm-3">
												<label for="emailCc"><fmt:message key="CcRecipients"/> </label>
										</div>
										<div class="col-sm-9">
												<input type="text" id="emailCc" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space"  />
										</div>
									</div>

									<div class="form-group row">
										<div class="col-sm-3">
												<label for="emailBcc"><fmt:message key="BccRecipients"/> </label>
										</div>
										<div class="col-sm-9">
												<input type="text" id="emailBcc" class="input-control full-width" placeholder="Separated by semi-colon, comma, or a space" />
										</div>
									</div>
								</div>
								<div id="customiseEmail" style="display:none">
										<div class="form-group row">
											<div class="col-sm-3">
												<label for="emailBody"><fmt:message key="Content_Label"/></label>
											</div>
											<div class="col-sm-9">
												<textarea id="emailBody" class="gen-Custom-SNMP-template input-control full-width" ROWS=2></textarea>
											</div>
										</div>
								</div>
						</c:otherwise>
					 </c:choose>
					 <div class="accordion-error form-group row"></div>
				</div>
			</div>
		</div>

		<div class="alarm-accordion" id="schedules-accordion">
			<button class="alarm-accordion-title">
			 	<i class="glyphicon glyphicon-chevron-down"></i><i class="glyphicon glyphicon-chevron-right"></i>
			 	<span class="title-val"> <fmt:message key="label.accordion.schedule"/> </span>
	 		</button>
	 		<div class="alarm-accordion-panel">
	 			<div class="alert-section-container">
	 				<div  id="loadingSchedule" style="display:none">
						<br><fmt:message key="Loading_Schedule_Details"/>
					</div>
					<div  id="noScheduleAvailable" style="display:none">
						<br><fmt:message key="ScheduleNotConfigured"/>
						<span><fmt:message key="Add_Schedule"/></span>
					</div>
					<div id="alarmSchedule" class="full-width">
						<div class="form-group row">
							<div class="col-sm-3">
								<label for="timeElement"> <fmt:message key="Time"/> </label>
							</div>
							<div class="col-sm-9">
								<div id="timeElement">
										<input type="hidden" id="timeValue" name="timeValue" value="28800" />
								</div>
							</div>
						</div>

						<div class="form-group row">
							<div class="col-sm-3">
								<label> <fmt:message key="timezone"/> </label>
							</div>
							<div class="col-sm-9">
								<select id="timezone" name="timezone" class="input-control full-width">
				                    <c:forEach items="${CommServTimeZones.timezones}" var="timezone" >
				                        <option value="${timezone.tzId}" title="${timezone.timezoneDisplayName}">${timezone.timezoneDisplayName}</option>
				                    </c:forEach>
				                </select>
							</div>
						</div>

						<div class="form-group row">
							<div class="col-sm-3">
								<label id="alarmFreqOption"><fmt:message key="Frequency"/></label>
							</div>
							<div class="col-sm-9">
								<select	id="alarmFreqOptionSelect" class="input-control full-width">
										<option value="DAILY"><fmt:message key="CustomReport.Daily"/></option>
										<option value="WEEKLY"><fmt:message key="CustomReport.Weekly"/></option>
										<option value="MONTHLY"><fmt:message key="CustomReport.Monthly"/></option>
								</select>
							</div>
						</div>

						<div class="form-group row">
							<div class="col-sm-12">
								<div id="freqDetails">
									<div id="weeklyElements" style="display:none">
										<ol id="daysToRunList" class="clearfix">
											<li><cv:cvCheckbox name="daysToRun0" styleClass="dayToRun" title="${monday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun1" styleClass="dayToRun" title="${tuesday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun2" styleClass="dayToRun" title="${wednesday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun3" styleClass="dayToRun" title="${thursday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun4" styleClass="dayToRun" title="${friday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun5" styleClass="dayToRun" title="${saturday}" checked="unchecked" /></li>
											<li><cv:cvCheckbox name="daysToRun6" styleClass="dayToRun" title="${sunday}" checked="unchecked" /></li>
										</ol>
									</div>
									<div id="monthlyElements" style="display:none">
										<div class="col-sm-3">
											<input type="radio" id="dateSelector" name="monthSelection" value="dateSelector">
											<label for="dateSelector"><fmt:message key="on_day"/></label>
										</div>
										<div class="col-sm-9">
											<input id="dateSpinner" class="input-control" name="dateValue" type="number" min="1" max="31">
										</div>
										<div class="col-sm-3">
											<input type="radio" id="daySelector" name="monthSelection" value="daySelector" checked>
											<label for="daySelector"><fmt:message key="on_the"/></label>
										</div>
										<div class="col-sm-9">
												<span id="daySelectorInput">
													<select name="weekOfMonth" id="weekOfMonth">
														<option value="First"><fmt:message key="First"/></option>
														<option value="Last"><fmt:message key="Last"/></option>
														<option value="Second"><fmt:message key="Second"/></option>
														<option value="Third"><fmt:message key="Third"/></option>
														<option value="Fourth"><fmt:message key="Fourth"/></option>
													</select>
													<select name="dayOfWeek" id="dayOfWeek">
														<option value="Weekday"><fmt:message key="Weekday"/></option>
														<option value="Weekend_Day"><fmt:message key="Weekend"/></option>
														<option value="Monday"><fmt:message key="monday"/></option>
														<option value="Tuesday"><fmt:message key="tuesday"/></option>
														<option value="Wednesday"><fmt:message key="wednesday"/></option>
														<option value="Thursday"><fmt:message key="thursday"/></option>
														<option value="Friday"><fmt:message key="friday"/></option>
														<option value="Saturday"><fmt:message key="saturday"/></option>
														<option value="Sunday"><fmt:message key="sunday"/></option>
													</select>
												</span>
										 </div>
									</div>
									<div id="repeatNHoursElements" class="repeatNHoursElements">
									    <div class="custom-cb unchecked repeatEveryNHours" data-state="unchecked" name="repeatEveryNHours"></div>
									    <label class="custom-cb-label"><fmt:message key="schedule.label.repeatEvery"/></label>
									    <span id="holdrepeatNHoursElementsData">
											<input id="everyNHoursSpinner" name="everyNHoursSpinner" class="input-control" type="number" value="8" min="0" max="24">
											<span><fmt:message key="schedule.label.hours"/></span>
											<input id="everyNMinsSpinner" name="everyNMinsSpinner" class="input-control" type="number" value="0" min="0" max="59">
											<span><fmt:message key="schedule.label.minutes"/></span>
											<span><fmt:message key="schedule.label.until"/></span>
											<div id="timeElementUntil">
												<input type="hidden" id="activeEndTime" name="activeEndTime" value="86100" />
											</div>
										</span>
									</div>
								</div>
							</div>
						</div>

					</div>
					<div class="accordion-error form-group row"></div>
				</div>
	 		</div>
	 	</div>

</div>
<div id="alarmDialogOperators" style="display:none">
		<select id="alarmOpSelect">
			<option value="0" class="numOnly lessThan" selected>Less Than</option>
			<option value="1" class="numOnly moreThan">More Than</option>
			<option value="2" class="notDate equals">Equal To</option>
			<option value="3" class="strOnly contains">Contains</option>
			<option value="4" class="dateOnly inLast">In Last</option>
			<option value="5" class="dateOnly beyondLast">Beyond Last</option>
			<option value="6" class="dateOnly inNext">In Next</option>
			<option value="7" class="dateOnly beyondNext">Beyond Next</option>
			<option value="8" class="notDate notequals">Not Equal To</option>
			<option value="9" class="notDate isEmpty">Is Empty</option>
			<option value="10" class="notDate notEmpty">Not Empty</option>
			<option value="11" class="strOnly notContains">Not Contains</option>
		</select>

</div>
<form name="testAlertCriteria" action="${pageContext.request.contextPath}/reports/testAlert.do" method="POST" target="_blank">
    <input type="hidden" name="testurl" />
     <input type="hidden" name="testCriteria" />
    <input type="hidden" name="gridId" />
    <input type="hidden" name="reportName" />
</form>
 </fmt:bundle>
 <link rel="stylesheet" href="${pageContext.request.contextPath}/common/css/cvTimepicker.css?${applicationScope.BUILD_TS}">
 <script nonce="${sessionScope.cspNonce}" src="${pageContext.request.contextPath}/common/js/cvTimepicker.js?${applicationScope.BUILD_TS}"></script>

 <script type="text/javascript" nonce="${sessionScope.cspNonce}" >
	var timeZoneList = "${CommServTimeZones}";
	var defaultTimeZoneId = "${commServTimeZone}";

	if(typeof defaultTimeZoneId == undefined ||!defaultTimeZoneId){
		defaultTimeZoneId = 1000;//default commserv timezone
	}
</script>