<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>

<fmt:bundle basename="localization.ReportsMessages">
	<fmt:message key="CommCellGrowth.CurrentCapacityUsage" var="CurrentCapacityUsage" />

<jsp:include page="../../common/header.jsp">

		<jsp:param value="CommCell Growth Statistics" name="headerTitleLocalized" />
		<jsp:param value="CommCell Growth Statistics" name="titleLocalized" />
		<jsp:param value="report" name="appName" />
		<jsp:param value="reports/reportsBase.jsp" name="jsp" />
		<jsp:param value="false" name="changeSurvey" />
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="true" name="includeHistory"/>
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="true" name="includeCustomSelect"/>
		<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
		<jsp:param value="true" name="bootstrapped" />
		<jsp:param value="true" name="reportsNav" />

		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/uniform.default.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.multiselect.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/operations.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/growth.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>

</jsp:include>

<jsp:include page="surveyHeader.jsp">
	<jsp:param name="changePage" value="true" />
	<jsp:param name="includeBreadcrumb" value="true" />
	<jsp:param name="searchCC" value="true" />
	<jsp:param value="true" name="exportPdf"/>
	<jsp:param value="true" name="exportCsv"/>
	<jsp:param value="true" name="exportHtml"/>
	<jsp:param value="true" name="printButton"/>
	<jsp:param value="true" name="includeCROptionBeforeSearch"/>
	<jsp:param value="true" name="exportEnabled"/>
	<jsp:param name="headerLinks" value="worldwideUrl" />
</jsp:include>


<%@ include file="../../reports/reportsBaseBody.jsp" %>
	<fmt:message key="CommCellGrowth.CommvaultComplete" var="CommvaultComplete" />
	<fmt:message key="CommCellGrowth.DataProtectionEnterpriseGrowth" var="DataProtectionEnterprise" />
	<fmt:message key="CommCellGrowth.DataProtectionCoreGrowth" var="DataProtectionCoreGrowth" />
	<fmt:message key="CommCellGrowth.DataArchiveEnterpriseGrowth" var="DataArchiveEnterpriseGrowth" />
	<fmt:message key="CommCellGrowth.DataArchiveCoreGrowth" var="DataArchiveCoreGrowth" />
	<fmt:message key="CommCellGrowth.Replication" var="Replication" />
	<fmt:message key="CommCellGrowth.Snapshot" var="Snapshot" />
	<fmt:message key="CommCellGrowth.Sockets" var="Sockets" />
	<fmt:message key="CommCellGrowth.ProtectedVMs" var="ProtectedVMs" />
	<fmt:message key="CommCellGrowth.Users" var="Users" />
	<fmt:message key="CommCellGrowth.ArchivedMailBoxes" var="ArchivedMailBoxes" />
	<fmt:message key="CommCellGrowth.CIObjects" var="CIObjects" />
	<fmt:message key="CommCellGrowth.MailboxArchiveSolution" var="ArchivedSolution" />

	<script nonce="${sessionScope.cspNonce}" >
		var docBaseURL="${applicationScope.DOCUMENTATION_LINK}",
			isPublicMetrics = ${applicationScope.isPublicMetricsCloud == "true" ? "true" : "false"};
	</script>


<div id="CapacityGrowthContentWrapper" class="horizontal-line-top">
	<div id="noDataNotificationPanel" style="text-align: center; display:none;"></div>
	<div id="GrowthContent_NoData">	</div>

<!-- 	<div id="GrowthChartsWrapper"> -->

	<c:choose>
		<c:when test="${param.exportType =='csv'}">
			<div id="reportTaskSummaryDiv"></div>
			<div id="GrowthTableDetails"></div>
		</c:when>
		<c:otherwise>
			<div id="peakChartOptions" class="hideOnExportFriendly">
				<ul class="sizeToggleButtons">
					<li class="sizeOptions" data-sizeUnit="TB" id="sizeTB" title='<fmt:message key="CommCellGrowth.CapacityTB"/>'> TB</li>
					<li class="sizeOptions" data-sizeUnit="GB" id="sizeGB" title='<fmt:message key="CommCellGrowth.CapacityGB"/>'> GB</li>
				</ul>

				<div id="show24MonthsDiv" class="hideOnExportFriendly">
					<div id="show24Months" class="custom-cb unchecked" data-state="unchecked"></div>
					<span>Show 24 Months</span>
				</div>
			</div>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="commvaultComplete" />
				<jsp:param name="title" value='${CommvaultComplete}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="protectionEnterprise" />
				<jsp:param name="title" value='${DataProtectionEnterprise}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="protectionCore" />
				<jsp:param name="title" value='${DataProtectionCoreGrowth}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>


			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="archiveEnterprise" />
				<jsp:param name="title" value='${DataArchiveEnterpriseGrowth}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>


			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="archiveCore" />
				<jsp:param name="title" value='${DataArchiveCoreGrowth}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="replication" />
				<jsp:param name="title" value='${Replication}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="snapshot" />
				<jsp:param name="title" value='${Snapshot}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>
			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="vmsockets" />
				<jsp:param name="title" value='${Sockets}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="protectedvms" />
				<jsp:param name="title" value='${ProtectedVMs }'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="users" />
				<jsp:param name="title" value='${Users}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="archived_mailboxes" />
				<jsp:param name="title" value='${ArchivedMailBoxes}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="ci_objects" />
				<jsp:param name="title" value='${CIObjects}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<jsp:include page="../../reports/growthReport_sub.jsp">
				<jsp:param name="id" value="archived_solution" />
				<jsp:param name="title" value='${ArchivedSolution}'/>
				<jsp:param name="image_path" value="${pageContext.request.contextPath}/reports/img" />
			</jsp:include>

			<div id="growthFooter">
					<h2> <a id="helpLink" href="#" target="_blank"><fmt:message key="CommCellGrowth.HowCapacityCalculated"/></a></h2>
					<div id="growthLegend" comp="growthLegend" data-component-type="EB_IMAGE">
					<ul>
						<li><fmt:message key="CommCellGrowth.UsageLevel"/></li>
						<li> <span class="sprite icon-line-green"></span> <fmt:message key="CommCellGrowth.LessThan80"/></li>
						<li> <span class="sprite icon-line-yellow"></span> <fmt:message key="CommCellGrowth.Between80And95"/></li>
						<li> <span class="sprite icon-line-red"></span> <fmt:message key="CommCellGrowth.Above95"/></li>
					</ul>

					</div>
				<!-- <span class="notes">* This bar shows the peak usage in this month. The usage shown on the dashboard is the current usage and it may not be equal to the number shown here.</span> -->
				<div style="margin-top: 10px;"></div>
			</div>
	<!-- 	</div> -->
		</c:otherwise>
	</c:choose>
</div>



</fmt:bundle>

<jsp:include page="../../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/jquery.uniform.min.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/growthRepCommon.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/survey/js/capacitygrowth.js" name="js"/>
  	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>

  		<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/search.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/highcharts/highcharts.js" name="js"/>
		<jsp:param value="true" name="bootstrapped" />
</jsp:include>
<%--
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
--%>