<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="../../WEB-INF/cvtaglib.tld" prefix="cv"%>
<c:set var="isAdminUser" value='false' scope="page" />
<cv:reportsTag name="adminRight" id="999">
	<c:set var="isAdminUser" value='true' scope="page" />
</cv:reportsTag>
<fmt:bundle basename="localization.ReportsMessages">
	<jsp:include page="../../common/header.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.multiselect.css" name="css" />
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/uniform.default.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/applicationstyles.css" name="css" />

		<jsp:param value="${pageContext.request.contextPath}/survey/css/commCellGroupHandling.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css"
			name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/operations.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/alarms.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/summary/css/summarystyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/cvdialog.css" name="css" />
		<jsp:param value="reports/reportsBase.jsp" name="jsp" />
		<jsp:param value="true" name="includeHistory" />
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="true" name="includeCustomSelect" />

		<jsp:param value="false" name="changeSurvey" />
		<jsp:param value="report" name="appName" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
		<jsp:param value="Create CommCell Group" name="titleLocalized" />
		<jsp:param value="Create CommCell Group" name="headerTitleLocalized" />
	</jsp:include>
	<jsp:include page="surveyHeader.jsp">
		<jsp:param value="true" name="changePage" />
		<jsp:param name="welcomeMsg" value="Reports" />
		<jsp:param name="includeBreadcrumb" value="false" />
		<jsp:param value="commcellUrl" name="headerLinks" />
		<jsp:param name="commcells" value="false" />
		<jsp:param value="false" name="includeCROptionBeforeSearch" />
		<jsp:param value="true" name="disbaleExport" />
	</jsp:include>

	<jsp:include page="../surveyBase.jsp">
		<jsp:param value="true" name="includeExportSupport" />
	</jsp:include>

	<div id="noDataNotificationPanel"
		style="text-align: center; display: none;"></div>
	<div id="ccTableWrapper">
		<div id="groupDetails">
			<fieldset class="commCellGroupDetails">
				<ul>
					<li><label for="name"><fmt:message key="GroupName" /></label>
						<input type="text" class="groupName ui-widget-content ui-corner-all" id="name"	name="field_name"></li>

					<li><label for="description"><fmt:message key="Description" /></label> <input name="field_description" id="description"
							class="groupDescription ui-widget-content ui-corner-all">
					</li>
				</ul>
			</fieldset>
			<div id="commCellGroupbuttons" class="btns hideOnExportFriendly">
				<a id="cancelButton" href="#"><fmt:message key="CancelButtonText" /></a> <a class="okSaveButton"
					id="submit_new_group_Details" href="#"><fmt:message key="Save" /></a>
			</div>
			<p id="validateTips" class="validateTips"></p>
			<c:if test="${applicationScope.showProfileDashboard == true}">
				<span class='enableProfile-info'><input type="checkbox" id="enableProfile"><fmt:message key="Enable_Profile" /></span>
			</c:if>
		</div>

	</div>
</fmt:bundle>
<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	$(document).ready(function() {
		var edgeDriveConfiguredForProfile = false;
		<c:if test="${applicationScope.EdgeDriveConfiguredForProfile != null and applicationScope.EdgeDriveConfiguredForProfile ==true}">
			edgeDriveConfiguredForProfile = true;
		</c:if>
		if(!edgeDriveConfiguredForProfile){
			$('#enableProfile').prop('disabled', !edgeDriveConfiguredForProfile);
			$('.enableProfile-info').prop('title', 'Edge drive folders are not configured for profile');
			$('.enableProfile-info').addClass('enableProfile-info-disable');
		}


	$("#groupDetails").focus();
	commCellGroupHandler.loadData();
	$(document).on(	"click","#submit_new_group_Details",function() {
		this.requestString = report.requestString;
		this.requestString.createGroup = true;
		var name = $("#name");
		var description = $("#description");
		var reportPageName = $("#welcomeMsg").text();
		var enableProfile = 0;
		if ($("#enableProfile").length) {
			enableProfile = $("#enableProfile").is(':checked') ? 1 : 0;
		}
		var ccGroupId = cvUtil.getParameter("ccGroupId");
		if (!commCellGroupHandler.checkLength(name, 1, 128, cvUtil.cvLocalize("Group_name"))
				|| !commCellGroupHandler.checkLength(description, 0, 300,cvUtil.cvLocalize("Group_description"))) {
			return;
		} else {
			commCellGroupHandler.enableProfile = enableProfile;
			commCellGroupHandler.name = name.val();
			commCellGroupHandler.groupdescription = description.val();
			commCellGroupHandler.ccGroupId = ccGroupId;
		}
		var URL = cvUtil.getContextPath()
				+ '/server/commCellGroupOp.do?type=commCellGroupOp&action=createEditGroup';
		//add group name in request
		if (commCellGroupHandler.name != null
				&& commCellGroupHandler.name.trim() != "") {
			this.requestString.groupName = commCellGroupHandler.name;
		}
		//add group description in request
		if (commCellGroupHandler.groupdescription != null
				&& commCellGroupHandler.groupdescription.trim() != "") {
			this.requestString.groupdescription = commCellGroupHandler.groupdescription;
		}

		if (commCellGroupHandler.ccGroupId != null
				&& parseInt(commCellGroupHandler.ccGroupId) > 0) {
			this.requestString.ccGroupId = parseInt(commCellGroupHandler.ccGroupId);
			//set operation type
			this.requestString.operation = 3;//Modify operation
		} else {
			this.requestString.ccGroupId = -1;
			//set operation type
			this.requestString.operation = 1;//ADD operation
		}

		if (commCellGroupHandler.enableProfile != null) {
			this.requestString.enableProfile = commCellGroupHandler.enableProfile;
		}

		////add code here to add commcell list associated with new group in request
		var commCellList = [];
		var ccAuditList = '';
		for(var guid in commCellGroupHandler.commcellHolder){
			commCellList.push(commCellGroupHandler.commcellHolder[guid]);
			ccAuditList = ccAuditList + commCellGroupHandler.commcellHolder[guid]['ActualCCName']+';';
		}
		this.requestString.commCellList = commCellList;
		report.mask();
		var param = {};
		param.json = (JSON.stringify(this.requestString));
		cvUtil.loadPageWithPOST(URL, param, function(output) {
			if (output.errorCode == undefined || output.errorCode == 0) {
				var params = [ "ccGroups=true" ];
				cvUtil.logUserAction(reportPageName, "createEditGroup", null,
						"CommCell Group=["+commCellGroupHandler.name+"] Message=["+output.success+"] CommCells=["+ccAuditList+"]", "INFO");
				var msg = 'Successfully created CommCell Group: ';
				if(requestString.operation === 3){
					msg = 'Successfully modified CommCell Group: ';
				}
				cvUtil.toast(msg+commCellGroupHandler.name);
				setTimeout(function(){
					//redirect to commcell group page with delay 3sec
					window.location.href = cvUtil.createUrlWithParams("monitoringform.jsp",params);
				}, 3000);

			} else {
				report.unmask();
				cvUtil.logUserAction(reportPageName, "createEditGroup", null, "Message=["+output.errorMsg+"]","INFO");
				cvUtil.errorToast(output.errorMsg);
			}
		});
	});
	$(document).on("click", "#cancelButton", function() {
		var params = [ "ccGroups=true" ];
		window.location.href = cvUtil.createUrlWithParams("monitoringform.jsp", params);
	});
});
</script>
<jsp:include page="../../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/commCellGroupHandling.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />

	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/mustache.js" name="js" />

	<jsp:param value="${pageContext.request.contextPath}/common/js/moment.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/commCellGroupHandling.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
</jsp:include>
