<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="../../WEB-INF/cvtaglib.tld" prefix="cv" %>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>

<jsp:include page="../../common/header.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/summary/css/summarystyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/applicationstyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/reports/css/reportsHome.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />

	<jsp:param value="CommCell Survey" name="titleLocalized" />
	<jsp:param value="reports/reportsBase.jsp" name="jsp" />
	<jsp:param value="true" name="includeHistory"/>
	<jsp:param value="true" name="bootstrapped" />
	<jsp:param value="true" name="reportsNav" />
</jsp:include>

<c:set var="isAdminUser" value='false' scope="page" />
<cv:reportsTag name="adminRight" id="999">
	<c:set var="isAdminUser" value='true' scope="page" />
</cv:reportsTag>
<c:set var="singleCommCellUser" value="false" />
<c:if test="${sessionScope.SurveySingleCommcellUser != null}">
	<c:set var="singleCommCellUser" value="true" />
</c:if>

<c:set var="groupLevelCR" value="false" />
<c:if test="${(param.companyId > 0 and (empty param.commUniId or param.commUniId <= 0)) and (sessionScope.CvUserDefaultDashboardGroupId != null and sessionScope.CvUserDefaultDashboardGroupId == param.companyId)}">
	<c:set var="groupLevelCR" value="true" />
</c:if>



<c:choose>
	<c:when test="${sessionScope.CR_VERSION == 'true'}">
		<c:url var="url" value="/customreports/viewReport.jsp"></c:url>
	</c:when>
	<c:when
		test="${sessionScope.CR_VERSION == null || sessionScope.CR_VERSION == 'false'}">
		<c:url var="customreportsURL" value="/reportsplus/reportViewer.jsp"></c:url>
	</c:when>
</c:choose>

<style>

#container {
	width:auto;
}

.app_details {
	top: 0;
	margin-top: 0px;
	left: 0;
	clear:left;
	display:none;
}
#custName {
 	max-width: 500px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    line-height: 1.1;
    font-size: 1.5em;
    padding: 10px 5px;
}
#headerSearchCC {
	margin-right:7px;
	margin-top: -40px;

}
.reportsSearch{
 margin-top: 8px;
}
#headerSearchCC > div {
   float: left;
}
#headerLinks {
	margin-top: 0px;
}
#headerLinks .rightMenu a {
	font-size: 13px;
}

.surveyHead {
    border-bottom:1px solid #eee;
    height: 0;
    margin-top: 0;
}

.sechead {
	 /*padding-bottom: 10px; */
	 padding-top: 0px;
	 border: none;
	 padding-top: 35px;
	 width: 60%;
}

.tagSections {
	font-size: 0.875em;
}

.breadcrumbMain {
    padding-bottom: 1px;
    display: table-row;
 }

.pageTabs {
/* 	margin-top: -34px; */
	margin-bottom:-3px;
	float:left;
	margin-left:0px !important;
}
#ContentWrapper{
	min-height: 150px;
}
.clear-both {
    padding: 5px 0 0;
}

#reportHomeOptions {
	display: inline-flex;
    float: right;
    margin-top: -53px;
}
#reportsHomeActions #newReportLink{
	padding-bottom: 0px;
}
#reportHomeLink.single-cc-user-report-links {
	margin: 13px 0px 0px 0px;
}
#reportHomeLink.single-cc-user-report-links ul{
	margin-bottom: 2px;
}
@media (max-width : 767px){
	.surveyHead{
	 	margin-top: -30px;
	}
	#reportHomeOptions {
		float: right;
    	margin-top: -20px;
	}
}
</style>
<fmt:bundle basename="localization.ReportsMessages">
<div class="sechead">
<div id="headerLinks" class="hideOnExportFriendly wait">
</div>
<ul id="breadcrumbMain" class="breadcrumbMain">
	<c:set var="ccUrlParams" value=""/>
	<c:if test="${(fn:escapeXml(param.commUniId) != null  and (singleCommCellUser eq false) and not empty fn:escapeXml(param.commUniId))|| (fn:escapeXml(param.ccId) != null
		and not empty fn:escapeXml(param.ccId)) || (param.ccGroupId > 0) || (param.companyId > 0)}">
		<li class="secTitleClickable smartlinkMain withSeparatorMain">
			<a class="smartLinkMain" href="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard"><fmt:message key="Worldwide_Dashboard" /></a>
		</li>
	</c:if>
	<c:if test="${param.ccGroupId != null and applicationScope.METRICS_INSTALLED eq 'true'}">
		<c:set var="ccUrlParams" value="?ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
		<li class="secTitleClickable smartlinkMain withSeparatorMain">
			<a class="smartLinkMain" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp?ccGroups=true"><fmt:message key="CommCell_Groups" /></a>
		</li>
	</c:if>
	<c:if test="${param.commUniId != null and applicationScope.METRICS_INSTALLED eq 'true'}">
		<li class="secTitleClickable smartlinkMain withSeparatorMain">
			<a class="smartLinkMain commcellsLink" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp${ccUrlParams}"><fmt:message key="CommCells" /></a>
		</li>
	</c:if>
</ul>
<div id="custName"></div>
<div class="app_details"></div>
<div class="clear-both"></div>
</div>
<div id="reportHomeOptions">
	<c:if test="${(sessionScope.SurveySingleCommcellUser != null) or (groupLevelCR == 'true')}">
		<div id="reportHomeLink" class="single-cc-user-report-links">
			<ul id="reportsHomeActions">
				<cv:reportsTag name="Reports.ManageReports" id="888">
					<li id="newReportLink"  title="<fmt:message key="Reports_Action_New"/>">
						<a href="${pageContext.request.contextPath}/reportsplus">
							<span class="sprite reports-actions-newreport"></span>
						</a>
					</li>

					 <c:if test="${applicationScope.showTileBuilder == 'true'}">
						<li id="newTileLink"  title="<fmt:message key="New_Tile"/>">
							<a href="${pageContext.request.contextPath}/reportsplus/?tile=true">
								<span class="sprite reports-actions-newtile"></span>
							</a>
						</li>
					</c:if>
					<li id="importReportButton"  data-sourcepage="report_home_page" title="<fmt:message key="ImportReport"/>"></li>
				</cv:reportsTag>
				<li id="customDashboard" title ="Custom Dashboard"></li>
			</ul>
			<cv:reportsTag name="Reports.ManageReports" id="888">
				<%@include file="../../reports/reportImportExport.jsp" %>
			</cv:reportsTag>
		</div>
	</c:if>
	<div class="reportsSearch searchDiv">
		<input type="text" placeholder="Search Reports" id="reportFilterSearch"></input>
	</div>
</div>

<jsp:include page="surveyHeader.jsp">
	<jsp:param name="searchCC" value="false" />
	<jsp:param name="includeBreadcrumb" value="false" />
	<jsp:param name="showTabs" value="true" />
	<jsp:param name="reports" value="true" />
	<jsp:param name="noTitleDropdown" value="true" />
	<jsp:param name="includeCROptionBeforeSearch" value="true" />
	<jsp:param value="true" name="disbaleExport" />
</jsp:include>

	<fmt:message key="Cancel" var="Cancel" />
	<fmt:message key="save" var="save" />
	<fmt:message key="invalidTag" var="invalidTagText"/>
	<fmt:message key="TagExists" var="TagExists"/>
<style>
 #noDataNotificationPanel {
 	text-align: center;
 	display:none;
 }
</style>

<script nonce="${sessionScope.cspNonce}" type="text/javascript">
var unsupportedReports = [2, 6, 7, 9, 10, 12, 13, 14, 38];
var commUniId = cvUtil.getParameter('commUniId', "' '");
var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
var companyId = cvUtil.getParameter('companyId', 0);
var commCellId = 0;
var commIpAddr = '';
var CommGuiId = '';
var clientName = '';
var app = 'none';
var collectTime = '';
var availableTags;
var customreportsURL = '${customreportsURL}';
var surveySingleCommcellUser=null;
<c:if test="${sessionScope.SurveySingleCommcellUser != null}">
	surveySingleCommcellUser=${sessionScope.SurveySingleCommcellUser};
</c:if>
window.tempCvIdtoMask = "ContentWrapper";
if (commUniId == 0) {
	window.alert(cvUtil.cvLocalize("CommCell_Association_Required"));
	window.location.href='monitoringform.jsp';
}

function loadData() {
	if((ccGroupId > 0 || companyId > 0) && commUniId==0) {
		getCommCellDetailsOfUid(commUniId, null, function(data){
			if(data.error) {
				$(".cvApps").hide();
				$("#noDataNotificationPanel").html(data.error);
				$("#noDataNotificationPanel").show();
			}else{
				var entityName = data.GroupName;
            	if(companyId > 0){
            		entityName = "${requestScope.CompanyNameFull}";
            	}
				var cgName = reportsUtil.getTruncatedName(entityName);
				$('#custName').html(cgName);
				$('#custName').attr('title', entityName);
				if(data.CommCellCount){
					$(".commcells").append('('+ data.CommCellCount +')');
				}
				$(".pageTabs").css("margin-left",$("#custName").width());
				if(entityName){
					$(document).attr("title", entityName + " - Reports");
				}
				cvUtil.GUIAuditReportLog("Reports Page" ,cgName);
			}
		});
	}else {
	getCommCellDetailsOfUid(commUniId, null, function(data){
		if(data.error) {
			$(".cvApps").hide();
			$("#noDataNotificationPanel").html(data.error);
			$("#noDataNotificationPanel").show();
		}
		if(commCellId ==  ' '){
			commCellId =" N/A";
		}
		if(collectiontime ==  ' '){
			collectiontime =" N/A";
		}
		if(MonitoredGroup ==  ' '){
			MonitoredGroup =" N/A";
		}
		if(clientName ==  ' '){
			clientName=" N/A";
		}
		$(".app_details").append('<span>CommCell ID: '+ commCellId +'</span><span>As of: '+ collectiontime +'</span><span>Client Group: '+ MonitoredGroup );
		if(clientName.indexOf("@") != -1)
			clientName=clientName.replace(/@/g,"&");

		if(clientName != null && clientName != " "  && clientName != " N/A" && $.trim(clientName).length != 0) {
			//clientName = clientName +" - "  + "Metrics Reporting";
			$(document).attr("title", clientName + " - Reports");
			var cName = reportsUtil.getTruncatedName(clientName);
			$('#custName').html(cName);
			$('#custName').attr('title', clientName);
			$(".pageTabs").css("margin-left",$("#custName").width());
			cvUtil.GUIAuditReportLog("Reports Page" ,clientName);
		} else {
			$(document).attr("title", "Metrics Reporting");
			$('#custName').html("Metrics Reporting");
			$(".pageTabs").css("margin-left",$("#custName").width());
			cvUtil.GUIAuditReportLog("Reports Page" ,"WorldWide");

		}
		if(data.GroupName){
			$('.commcellsLink').text(data.GroupName+' (CommCells)');
		}

		$(".pageTabs").css("margin-left",$("#custName").width());
		$('#detailsBusy').hide();

		if(Version.split(" ")[0] == "9.0"){
			//$('.upgradereadiness_app').show();
			$("#content").addClass("showPreUpgrade");
		}
	});
	}
	getPostUpgradeReportOfUid(commUniId, function(data){
		if(data == "0"){
			$('.upgrade_app').show();
			$("#content").addClass("showPostUpgrade");
		}
	});


	$(document).ready(function() {

		surveyListAndMeta(function(data1) {
			var output = data1;//$.parseJSON(data1);

			if(output !== null && typeof output === 'object') {
				if(!output.error) {
					getReportsTags(true);
					var surveyGroupList = output.surveys.surveyGroupList;
					var miscReports = output.surveys.miscReports;
					//Code to add Metrics Reports to CC page have been deleted with this GMR.
					if(miscReports!=undefined){

					for(var i=0; i<miscReports.length; i++){
						imgName = cvUtil.getContextPath()+"/reports/"+miscReports[i].customIcon.replace(/\s+/g, '');

							if(!(cvUtil.getParameterByName("commUniId") === "")){
								//var dataUnique = cvUtil.getContextPath()+"/reports/" +  miscReports[i].href;
								var link =  miscReports[i].href+"?commUniId="+cvUtil.getParameterByName("commUniId");
								var cgId = cvUtil.getParameterByName("ccGroupId");
								if(cgId != undefined && cgId > 0){
									link += "&ccGroupId="+cgId;
								}
								var cpId = cvUtil.getParameterByName("companyId");
								if(cpId != undefined && cpId > 0){
									link += (link.indexOf('?') > 0? "&" : "?") + "companyId="+cpId;
								}

								$("#reportItems").append(getReportTileHtml({
									imgName: imgName,
									uniqueId: 'metrics_' + miscReports[i].reportId,
									url: '${pageContext.request.contextPath}/reports/'+link,
									reportName:  miscReports[i].reportName,
									hasUpdate: false // metrics won't have updates
								}));
							}
						}

					}
					var isRequiredFeatureRelease = isMinRequiredFRForNewCapacityReport(Version);
					var isLicenseUsageReport,isPeakCapacityGrowthReport;
					for(group in surveyGroupList) {
						var surveyGroup = surveyGroupList[group];
						for(var i=0; i<surveyGroup.length; i++){
							if ( isRequiredFeatureRelease ){
								isLicenseUsageReport = (surveyGroup[i].type === "ID" && surveyGroup[i].value === 1);
								isPeakCapacityGrowthReport = (surveyGroup[i].type == 'URL' && surveyGroup[i].reportId === '2022');
								if(isLicenseUsageReport || isPeakCapacityGrowthReport){
									continue;
								}
							}
							if(!!surveyGroup[i].customIcon) {
								imgName = cvUtil.getContextPath()+"/reports/img/"+surveyGroup[i].customIcon;
							} else {
								imgName = cvUtil.getContextPath()+"/reports/img/defaultSurvey.png";
							}
							if(surveyGroup[i].type === "ID"){
								var sid = surveyGroup[i].value;
								var cgId = cvUtil.getParameterByName("ccGroupId");
								var ccId = cvUtil.getParameterByName("commUniId");
								var cpId = cvUtil.getParameterByName("companyId");
								var link= "indcommcellsurvey.jsp";
								var params='?surveyId='+surveyGroup[i].value;
								if(ccId != undefined && ccId > 0){
									params += "&commUniId="+ccId;
								}
								if(cgId != undefined && cgId > 0){
									params += "&ccGroupId="+cgId;
								}
								if(cpId != undefined && cpId > 0){
									params += "&companyId="+cpId;
								}
								if((sid == "23") || (sid=="25") || (sid=="44") || (sid=="30") || (sid=="103")){
									link= "operations.jsp";
								}
								else if(ccId == undefined || ccId <= 0){//CommCell Groups reports page
									link= "CommCellSurvey.jsp";
								}

								link += params;
								var reportSvgIcon = null;
								if (surveyGroup[i]['type'] == 'ID' ) {
									reportSvgIcon = reportsHome.getSVGIconForMetricsReport(surveyGroup[i]['value'], null);
								} else if (surveyGroup[i]['type'] == 'URL') {
									reportSvgIcon = reportsHome.getSVGIconForMetricsReport(null, surveyGroup[i]['value']);
								}

								$("#reportItems").append(getReportTileHtml({
									imgName: imgName,
									uniqueId: 'metrics_' + surveyGroup[i].value,
									url: link,
									reportName: surveyGroup[i].name,
									hasUpdate: false, // metrics won't have updates
									svgIcon: reportSvgIcon
								}));

								$("#reportItems img").on('error', function() {
									   $(this).attr("src",cvUtil.getContextPath()+"/reports/img/defaultSurvey.png");
									});
							}
							else {
								if(!(cvUtil.getParameterByName("commUniId") === "")){
									var dataUnique = surveyGroup[i].value.split('?');
								}
								else {
									var dataUnique = surveyGroup[i].value;
								}
								var hlink = surveyGroup[i].value;
								var cgId = cvUtil.getParameterByName("ccGroupId");
								var cpId = cvUtil.getParameterByName("companyId");
								if(cgId != undefined && cgId > 0){
									if(hlink.indexOf('?') > 0){
										hlink += "&";
									}else{
										hlink += "?";
									}
									hlink += "ccGroupId="+cgId;
								}
								if(cpId != undefined && cpId > 0){
									hlink += (hlink.indexOf('?') > 0? "&" : "?") + "companyId="+cpId;
								}
								if(isNaN(dataUnique[0])){
									dataUnique = surveyGroup[i].reportId;
								}else{
									dataUnique= dataUnique[0];
								}

								if ( surveyGroup[i].reportId === '2020' && (cvUtil.getParameter('commUniId', 0) > 0 || hlink.indexOf('health.jsp?commUniId') > -1)) {
									hlink = cvUtil.getContextPath() + "/health/" + hlink;
								}


								var reportSvgIcon = null;
								if (surveyGroup[i]['type'] == 'ID' ) {
									reportSvgIcon = reportsHome.getSVGIconForMetricsReport(surveyGroup[i]['value'], null);
								} else if (surveyGroup[i]['type'] == 'URL') {
									reportSvgIcon = reportsHome.getSVGIconForMetricsReport(null, surveyGroup[i]['value']);
								}

								$("#reportItems").append(getReportTileHtml({
									imgName: imgName,
									uniqueId: 'metrics_' + dataUnique,
									url: hlink,
									reportName: surveyGroup[i].name,
									hasUpdate: false, // metrics won't have updates
									svgIcon: reportSvgIcon
								}));

							}

						}
					}

					if((output.surveys.showCRList && output.surveys.CR_LIST) || (surveySingleCommcellUser != null && $.isNumeric(surveySingleCommcellUser))){
						var customReportList = output.surveys.CR_LIST;
						$.each(customReportList, function(key,value){
							if(!value.viewable){
								return;
							}
							var imgName = cvUtil.getContextPath()+"/reports/img/customIcon/"+value.icon;

							$("#reportItems").append(getReportTileHtml({
								imgName: imgName,
								uniqueId: 'custom_' + value.reportId,
								url: customreportsURL+"?reportId=" + value.reportId,
								reportName: value.reportName,
								hasUpdate: isReportUpdateAvailable(value),
								svgIcon: reportsHome.getSVGIcon(value)
							}));

						});
					}
					$('.reportItem[data-unique="UpgradeReadiness.jsp"]').addClass("preUpgradeCheck");
					$('.reportItem[data-unique="UpgradeCheck.jsp"]').addClass("postUpgradeCheck");
					if(!$("#content").hasClass("showPreUpgrade")){
						$(".preUpgradeCheck").remove();
					}
					if(!$("#content").hasClass("showPostUpgrade")){
						$(".postUpgradeCheck").remove();
					}
				}
				else{
					hideAllComponents();
					$("#noDataNotificationPanel").html(output.error);
					$("#noDataNotificationPanel").show();
				}
				$('.cvReports li').sort(function(a, b) {
				   		   return $(a).text().trim().toUpperCase().localeCompare($(b).text().trim().toUpperCase());
						 }).appendTo( '.cvReports ul');;

			}
			reportsHome.drawLiveSLAIcon();
		});
		$('#reportFilterSearch').focus();
	});

   	this.requestString.dashboard = true;
   	var commCellUID = this.requestString.commUniId;
   	delete this.requestString.surveyId;
   	this.requestString.commUniId = cvUtil.getParameter("commUniId", 0);
   	var tokens = [];
   	if (this.requestString.commUniId == 0) {
   		tokens.push(11);
   	}

   	for(var i=0; i< tokens.length; i++){
   			this.requestString.dToken = tokens[i];
   		    var URL = cvUtil.getContextPath() + '/server/cloudsurvey.do?type=operations&json='+window.encodeURIComponent(JSON.stringify(this.requestString));
   		 	cvUtil.loadPageWithGET(URL, null, function(output) {
   				reportsUtil.processHealthStatus(output);
   			});
   	}
 }
$("#reportFilterSearch").change( function () {
    var filter = $(this).val().trim();
    if(filter === ""){
    	$(".tagSections").show().find(".reportItem").show();
    	return;
    }
    if (filter) {
    	$(".tagSections").hide().find(".reportItem").hide();
    	var tagLists = $(".tagSections").find("li.reportItem>a:contains(" + filter + ")").parent("li").show().parents("ul").show();
    	$.each(tagLists,function(){
    		$(this).parents(".tagSections").show();
    		setSlideWidth("#"+$(this).attr("id"));
    	});
    }
}).keyup( function () {
    // fire the above change event after every letter
    $(this).change();
  });
if($('#reportButton ul li').length <= 0){//no menu options, remove 'File' menu
	$('#reportButton').remove();
}
</script>



<div>


	<div id="noDataNotificationPanel"></div>
	<a id="showAllTags" href="#"><fmt:message key="reports.tags.Show_All_Tags" /></a>
	 <div id="ContentWrapper">
		<div class="cvReports">
		<ul id="reportItems" class="slideBox">


		</ul>
		</div>
		<div id="reportSearchDiv"></div>
	</div>
	<div id="tagReportDialog">
			<!-- set these in js  -->
			<h3 class="reportTitle"></h3>
			<ul class="tagsList"></ul>
			<ul class="addTag">
				<li class="infoInTags"><fmt:message key="reports.tags.info" /></li>
				<li>
					<input id="newTag" type="text" placeholder='Add Tag'></input>
					<a href="#" id="addToTagList" class="add"><fmt:message key="reports.tags.Add" /></a>
				</li>
			</ul>
			<h4 class="invalidTag"><fmt:message key="reports.tags.invalid_tag" /></h4>
			<cv:reportsTag name="adminRight" id="999">
				<div id="adminOptDiv">
							<div id="applyTagToAllCB" class="custom-cb " data-state="unchecked">
							</div>
							<span id="applyTagToAllLabel" class="custom-cb-label"><fmt:message
								key="applyTagToAll" /></span>
				</div>
			</cv:reportsTag>
			<h4 class="noteInTags"><fmt:message key="reports.tags.note" /></h4>

		</div>


</div>
<div class="clrfloat"></div>
</fmt:bundle>
<jsp:include page="../../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/reportsHome.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/crUtil.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/js/asBuiltGuide.js" name="js" />
	<jsp:param value="true" name="bootstrapped" />
</jsp:include>
<script nonce="${sessionScope.cspNonce}" >
var metricsInstalled = ${applicationScope.METRICS_INSTALLED};
var localMsg = localMsg || {};
localMsg.cancel="${Cancel}";
localMsg.save="Save";
localMsg.invalidTagText="${invalidTagText}";
localMsg.TagExists="${TagExists}";

var isAdminUser = '${isAdminUser}';
var editIconLoc = "${pageContext.request.contextPath}/customreports/img/editreport.png";

</script>
