<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<fmt:bundle basename="localization.ReportsJSMessages">
	<div id="executive-summary-export-dialog">
			<fieldset class="executiveSummarySet">
				   	 <label for="name"><fmt:message key="headName" /></label>
			    	<input type="text" class="text" id="name" name="field_name">
			    	<br />	    	
			    	<label for="name"><fmt:message key="designation" /></label>
			    	<input type="text" class="text" id="designation" name="field_designation">
			    	<br/>
			    	<div id="ccglistHeader">
				    	<label for="ccglist"><fmt:message key="Commcell_Groups" /></label>
			    	</div>
			    	<div id="ccglist">
			    		<input type="hidden" id="ccgListFinal" name="ccgListFinal" value=""/> <!-- Used in Schedule -->
			    		<div>
		    				<input type="checkbox" id="SelectAllCCG"/><fmt:message key="Select_All" /><br />
		    			</div>
			    	</div>
			    	
			    	<label id="InActiveGrpMsg"><fmt:message key="No_Active_Commcell_groups_found" /></label>
			    	<br/>
			</fieldset>
			<Br>		
	 		<p id="validateTips" class="validateTips" ></p>	
	</div>
</fmt:bundle>
<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
		$(document).ready(function() {
	
			var executiveSummary = cvUtil.getTopWindow().excutiveSummary;
			var executiveSummaryDialog = $("#executive-summary-export-dialog");
			
			if(executiveSummary){
				if(cvUtil.getParameterByName("noAutofillExecSummary") != "true" ){ //Will be passed from Schedules Page
					executiveSummary.autofillInputFields(executiveSummaryDialog);
					executiveSummaryDialog = executiveSummaryDialog.find("#SelectAllCCG").prop('checked',true);
				}
				cvUtil.mask(".executiveSummarySet");
				var tgtUrl = cvUtil.getContextPath()+'/reports/getCommCellGrps.do';
				var params = "";
				var successFunc = function(data) {
		 			 cvUtil.unmask(".executiveSummarySet");
		 			 var arrayData = Object.keys(data);
		 			 arrayData.sort(function(a, b) {
		 				  var nameA = a.toUpperCase();
		 				  var nameB = b.toUpperCase();
		 				  if (nameA < nameB) {
		 				    return -1;
		 				  }
		 				  if (nameA > nameB) {
		 				    return 1;
		 				  }
		 				  return 0;
		 				});
		 			 for(var i=0; i<arrayData.length; i++)
			 		 	$("#ccglist").append(prepareCCGCheckBox(data[arrayData[i]], arrayData[i]));
			 		
			 		 // hides the ccglist and the buttons, if the commcell group is empty. 
		 			 var ccgListLength = Object.keys(data).length;
		 			 if(ccgListLength == 0 ) {
			 			 $("#execSummaryBtns").hide();
		 				 $("#ccglistHeader").hide();
		 				 $("#ccglist").hide();
		 				 $("#InActiveGrpMsg").show();
		 			 } else {
		 				$("#execSummaryBtns").show();
			 			$("#ccglistHeader").show();
			 			$("#ccglist").show();
			 			$("#InActiveGrpMsg").hide();			 				
		 			 }
		 			 
		 			 if(window.model){
		 				resetExecutiveSummarySection(window.model);
		 			 }
		 			 
			 		};
				var errorFunc = function(xhr, ajaxOptions, thrownError) {
					 alert(thrownError);
			 	};
				cvUtil.loadPageWithPOST(tgtUrl, params, successFunc, errorFunc);
			}
			
			
			$("#executive-summary-export-dialog").bind("keypress", function(e) {
				if (e.keyCode == 13) {
					return false;
				}
			});
			$("#executive-summary-export-dialog").focus();

				function prepareCCGCheckBox(value, text) {
					var texttoDisplay = text;
					if(text.length > 50)
						texttoDisplay = text.substring(0,50) + "...";
					var checkBox = "";
					checkBox += "<div title='" + text +"'>";
					//checkBox += "<div>";
					var checked = "";
					if(cvUtil.getParameterByName("noAutofillExecSummary") != "true" ){
						checked="checked";
					}
					checkBox += "<input type='checkbox' name='commcellgroup' value="+value+" id='commcellgroup"+value+"' class='commcellgroup' "+ checked +" title='" + text +"' />" +
							texttoDisplay + "<br />";
					checkBox += "</div>";
					
					return checkBox;
				}

				
				$("#SelectAllCCG").click(function(){
					if($(this).is(':checked'))
						selectAllCheckBoxes(true);
					else
						selectAllCheckBoxes(false);
				});
				
				function selectAllCheckBoxes(value) {
					$("input:checkbox[name=commcellgroup]").prop("checked", value);
				}
				
				$("input:checkbox[name=commcellgroup]").live("click", function(){
					var totalCount = $("input:checkbox[name=commcellgroup]").length;
					var selectedCount = $("input:checkbox[name=commcellgroup]:checked").length;
					if(totalCount == selectedCount)
						$("#SelectAllCCG").prop("checked", true);
					else
						$("#SelectAllCCG").prop("checked", false);
				});
			});
</script>