<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="../../WEB-INF/cvtaglib.tld" prefix="cv" %>

<c:set var="isActivity" value='false' scope="page" />
<c:set var="singleCommCellLevelActivity" value='false' scope="page" />
<c:set var="executiveSummary" value='false' scope="page" />
<c:if test="${param.commUniId == null || param.commUniId==''}">
	<c:if test="${param.surveyId == null || param.surveyId==''}">
		<c:set var="isActivity" value='true' scope="page" />
	</c:if>
</c:if>
<c:if test="${isActivity == 'true'}">
	<c:if test="${(param.ccGroupId == null || param.ccGroupId=='') && (param.companyId == null || param.companyId=='')}">
		<c:set var="executiveSummary" value='true' scope="page" />
	</c:if>
</c:if>
<c:if test="${(param.surveyId == null || param.surveyId=='') && executiveSummary == 'false'}">
	<c:set var="singleCommCellLevelActivity" value='true' scope="page" />
</c:if>
<c:set var="appName" value="operations"></c:set>

<fmt:bundle basename="localization.SurveyMessages">

	<!-- common headers -->
	<%-- 		<jsp:param value="true" name="exportOptions" /> --%>
	<jsp:include page="../../common/header.jsp">

		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
		<jsp:param value="reports/reportsBase.jsp" name="jsp" />
		<jsp:param value="true" name="includeHistory"/>
		<jsp:param value="${pageContext.request.contextPath}/common/css/ui.spinner.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/uniform.default.css" name="css" />
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="Activity" name="titleLocalized" />
		<jsp:param value="" name="headerTitleLocalized" />
		<jsp:param value="" name="headerTitle" />
		<jsp:param value="true" name="includeCustomSelect"/>
		<jsp:param value="true" name="bootstrapped" />
		<jsp:param value="true" name="reportsNav" />
		<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/css/bootstrap-multiselect.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/operations.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/alarms.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />

	</jsp:include>
	<%--
		<jsp:param value="true" name="includeSecHeader" />
	 --%>
<jsp:include page="../surveyBase.jsp">
	<jsp:param value="operations" name="apptype"/>
</jsp:include>
<jsp:include page="surveyHeader.jsp">
	<jsp:param name="changePage" value="true" />
	<jsp:param name="includeBreadcrumb" value="true" />
	<jsp:param name="searchCC" value="true" />
	<jsp:param name="welcomeMsg" value="" />
	<jsp:param name="headerLinks" value="worldwideUrl" />
	<jsp:param name="includeCROptionBeforeExport" value="true" />
	<jsp:param value="true" name="exportPdf"/>
	<jsp:param value="true" name="exportCsv"/>
	<jsp:param value="true" name="exportHtml"/>
	<jsp:param value="true" name="printButton"/>
	<jsp:param value="true" name="exportEnabled"/>
	<jsp:param value="true" name="includeCROptionBeforeSearch"/>
	<jsp:param value='${executiveSummary}' name="executiveSummary"/>
	<jsp:param value='${singleCommCellLevelActivity}' name="singleCommCellLevelActivity"/>
</jsp:include>



<script nonce="${sessionScope.cspNonce}" >
window.urlInitializationNotRequired=true;
window.isActivity='${isActivity}';
window.showPPT='${executiveSummary}';
window.showExecutivePPT='${singleCommCellLevelActivity}';
var metricsInstalled = ${applicationScope.METRICS_INSTALLED};
</script>

<form id="exportForm" action="${pageContext.request.contextPath}/server/doDownload" method="get">
	<input id="downloadType" type='hidden' name='type' value='report' />
	<input id="fileNameToDownload" type='hidden' name='fileName' value='' />
</form>

 <form name="exportform" action="survey.do" method="post" target="_self">
<input type="hidden" name="action" id="exportAction"
value="exportExcel" /> <input type="hidden" name="csvBuffer"
id="csvBuffer" /> <input type="hidden" name="fileName" id="fileName" />
<input type="hidden" name="reportName" id="reportName" />
</form>

<!-- BEGIN HTML -->
<c:set var="isPublicMetricsCloud" value="false" />
<c:if test="${applicationScope.isPublicMetricsCloud != null and applicationScope.isPublicMetricsCloud ==true}">
	<c:set var="isPublicMetricsCloud" value="true" />
</c:if>

<c:set var="isWorldWide" value="false" />
<c:if test="${!(param.commUniId >0 || param.ccGroupId > 0 || param.companyId > 0)}">
	<c:set var="isWorldWide" value="true" />
</c:if>
<c:choose>
	<c:when test="${param.surveyId == 25 and (isPublicMetricsCloud eq 'false' || (isPublicMetricsCloud eq 'true' and isWorldWide eq 'false'))}">
		<div id="reportFilters" class="hide hideOnExportFriendly">
			<span id="strikeAgentsDiv" class="strike-agents">
				<span class="input-label"><fmt:message key= "Agents"/></span>
				<select id="strikeAgents" multiple="multiple" class="input-val">
					<option value="1"><fmt:message key= "agent_filesystem"/></option>
					<option value="2"><fmt:message key= "agent_database"/></option>
					<option value="4"><fmt:message key= "agent_exchange"/></option>
					<option value="8"><fmt:message key= "agent_lotusnotes"/></option>
					<option value="16"><fmt:message key= "agent_sharepoint"/></option>
					<option value="32"><fmt:message key= "agent_vsa"/></option>
				</select>
			</span>
			<button id="apply-btn" class="btn btn-primary apply-btn hide"><fmt:message key= "apply"/></button>
		</div>
		<div class="export-summary hide">
			<c:choose>
				<c:when test="${param.surveyId == 25}">
					<div id="strikeAgentsList">
						<span><fmt:message key="Agents"/></span>: <span id="strikeAgentsListVal"></span>
					</div>
				</c:when>
			</c:choose>
		</div>
	</c:when>
</c:choose>

<div id="noDataNotificationPanel" style="display:none;">
</div>
	<div id="ContentWrapper">
		<!-- tables or charts should be included or excluded based on the surveyids and other parameters. -->
		<div id="options">
			<!-- contains the options specific to the page -->
		</div>


	</div> <!-- end ContentWrapper -->
<div id="mergeWeekend" style="display:none;">
		<div id="mergeWeekendDiv" class="hideOnExportFriendly" >
			<div id="mergeWeekendData" class="custom-cb" data-state=""></div>
			<span><fmt:message key= "Merge_Weekend"/></span>
		</div>
	</div>

	<div id="skippedJobs" style="display:none;">
		<div id="skippedJobsDiv" class="hideOnExportFriendly" >
			<div id="skippedJobsData" class="custom-cb" data-state=""></div>
			<span><fmt:message key= "Show_Skipped_Jobs"/></span>
		</div>
	</div>
<div id='tableWrapper'>
	<div id="FullStrikeTable" style="display:none"></div>
    <div id="IncrementalStrikeTable" style="display:none"></div>
</div>

<div id="activityNotificationPanel" style="display:none;"></div>
<jsp:include page="alarmdialog.jsp"></jsp:include>
<!-- END HTML -->

	<!-- common footers -->
	<jsp:include page="../../common/footer.jsp">
		<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-min.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/g.raphael.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-bar.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-line.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/js/bootstrap-multiselect.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>

		<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/common/js/moment.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/custom-pie.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/jquery.uniform.min.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/common/js/mustache.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
		<jsp:param value="${pageContext.request.contextPath}/survey/js/common.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/cloudsurvey.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/commcellsurvey.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/alarms.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/trend.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/trendChart.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/reports/js/cvcharts.js" name="js" />
		<jsp:param value="${pageContext.request.contextPath}/survey/js/executiveSummary.js" name="js" />
		<jsp:param value="true" name="bootstrapped" />
		</jsp:include>

</fmt:bundle>
