<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib uri="../../WEB-INF/cvtaglib.tld" prefix="cv" %>
<%@  taglib uri="../../WEB-INF/webenhance.tld" prefix="we" %>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>

<script nonce="${sessionScope.cspNonce}" src="${pageContext.request.contextPath}/survey/js/addtroubleshooturl.js?${applicationScope.BUILD_TS}"></script>
<%-- <script nonce="${sessionScope.cspNonce}" src="${pageContext.request.contextPath}/reports/responsive/js/bootstrap.js?${applicationScope.BUILD_TS}"></script> --%>
<link rel="stylesheet" href="${pageContext.request.contextPath}/reports/responsive/css/bootstrap-theme.css?${applicationScope.BUILD_TS}">
<link rel="stylesheet" href="${pageContext.request.contextPath}/reports/responsive/css/common.css?${applicationScope.BUILD_TS}">


<c:set var="isAdminUser" value='false' scope="page" />
<cv:reportsTag name="adminRight" id="999">
	<c:set var="isAdminUser" value='true' scope="page" />
</cv:reportsTag>

<c:set var="isCommcellAdmin" value='false' scope="page" />
<cv:reportsTag name="cellAdministrativeRight" id="999">
	<c:set var="isCommcellAdmin" value='true' scope="page" />
</cv:reportsTag>

<we:out escapeXml="false">
	<c:if test="${showUrl != null}">
		<script nonce="${sessionScope.cspNonce}" >
			window.history.replaceState(null,document.title,"${showUrl}");
		</script>
	</c:if>
</we:out>

<fmt:bundle basename="localization.ReportsMessages">
<cv:secureTag name="Survey" id="14">
	<c:set var="surveyEnabled" value="false" />
	<c:if test="${sessionScope.userHasReportsManagementCapabilities == true and applicationScope.METRICS_INSTALLED eq 'true'}">
		<c:set var="surveyEnabled" value="true" />
	</c:if>
</cv:secureTag>
<c:set var="singleCommCellUser" value="false" />
<c:if test="${sessionScope.SurveySingleCommcellUser != null}">
	<c:set var="singleCommCellUser" value="true" />
</c:if>
<c:set var ="CvUserDefaultDashboardGroupId" value="0" />
<c:if test="${sessionScope.CvUserDefaultDashboardGroupId != null and sessionScope.CvUserDefaultDashboardGroupId > 0}">
	<c:set var ="CvUserDefaultDashboardGroupId" value="${sessionScope.CvUserDefaultDashboardGroupId}" />
</c:if>

<script nonce="${sessionScope.cspNonce}" >
    window.urlInitializationNotRequired=true;

    var surveySingleCommcellUser = false;

    var localMsg = localMsg || {};
	${cv:jsLocalize("localMsg", "localization.SurveyMessages", null)};

	var user_domain = "${sessionScope.USER_DOMAIN}";
	var docBaseURL="${applicationScope.DOCUMENTATION_LINK}";
	<c:if test="${sessionScope.SurveySingleCommcellUser != null}">
		$("body").addClass('SurveySingleCommcellUser');
	</c:if>
	var isPublicMetricsCloud=false, isCommvaultUser=false, surveySingleCommcellUser;
	<c:if test="${applicationScope.isPublicMetricsCloud != null and applicationScope.isPublicMetricsCloud ==true}">
		isPublicMetricsCloud=true;
	</c:if>
	<c:if test="${sessionScope.isCommvaultUser == true}">
		isCommvaultUser=true;
	</c:if>
	<c:if test="${sessionScope.SurveySingleCommcellUser != null}">
		surveySingleCommcellUser = "${sessionScope.SurveySingleCommcellUser}";
	</c:if>
	var isReportsCloudAdminUser = "${sessionScope.isReportsCloudAdminUser}";
	var isAdminUser = '${isAdminUser}';
	var CvUserDefaultDashboardGroupId = 0;
	<c:if test="${sessionScope.CvUserDefaultDashboardGroupId != null and sessionScope.CvUserDefaultDashboardGroupId > 0}">
		CvUserDefaultDashboardGroupId=parseInt("${sessionScope.CvUserDefaultDashboardGroupId}");
	</c:if>

	var showNewCompany = false;
	<c:if test="${(sessionScope.isCommCellGroupAdminUser == 'true' or sessionScope.isReportsCloudAdminUser == 'true') and param.showNewCompany == 'true'}">
		showNewCompany = true;
	</c:if>
</script>

<div class="clear-both"></div>
<div class="surveyHead">
	<div>
		<!-- Top row for breadcrumb and links -->
		<div id="headerBreadcrumb">
			<c:if test="${param.includeBreadcrumb != null && param.includeBreadcrumb == 'true' }">

			</c:if>
		</div>
		<c:if test="${param.changePage != null && param.changePage != ''}">
			<ul id='breadcrumbMain' class='breadcrumbMain hideOnExportFriendly' >
				<%-- <li class="secTitleClickable smartlinkMain withSeparatorMain">
					<a class="smartLinkMain" href="${pageContext.request.contextPath}/survey/reports/dashboard.jsp">Reports</a>
				</li> --%>

				<c:choose>
					<c:when test="${(empty fn:escapeXml(param.commUniId) or fn:escapeXml(param.commUniId) <=0) && (empty fn:escapeXml(param.ccGroupId) or fn:escapeXml(param.ccGroupId)<=0) && (empty fn:escapeXml(param.companyId) or fn:escapeXml(param.companyId)<=0) && empty param.commcells && (empty fn:escapeXml(param.ccId) or fn:escapeXml(param.ccId)<=0) and param.isAlarm ne 'true'}">
						<c:if test="${empty param.isHealthReport and empty param.healthReport and empty param.dashboard and param.isAlarm ne 'true' && empty param.profiledashboard}">
							<c:if test="${surveyEnabled eq 'true'}">
								<li class="secTitleClickable smartlinkMain withSeparatorMain">
									<a class="smartLinkMain" href="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard"><fmt:message key="Worldwide_Dashboard" /></a>
								</li>
							</c:if>
							<li class='secTitleClickable smartlinkMain withSeparatorMain repDropdown repDropdownTitle '>
								<a class='smartLinkMain reportsLink'  href='${pageContext.request.contextPath}/reports'><fmt:message key="Reports" /></a>
								<img class="hideOnExportFriendly" src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png" alt="down" />
							</li>
							<li>
								<%@ include file="../../common/pageSelection.jsp" %>
							</li>
						</c:if>
					</c:when>
					<c:otherwise>
						<c:choose>
							<c:when test="${surveyEnabled eq 'true' and fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0 && (singleCommCellUser == false)}">
								<li class="secTitleClickable smartlinkMain withSeparatorMain">
									<a class="smartLinkMain" href="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard"><fmt:message key="Worldwide_Dashboard" /></a>
								</li>
								<c:set var="repUrlParams" value="ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
								<li class="secTitleClickable smartlinkMain withSeparatorMain">
									<a class="smartLinkMain" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp?ccGroups=true"><fmt:message key="CommCell_Groups" /></a>
								</li>
								<c:set var="reportLinkTitle" value="${requestScope.CommCellGroupNameFull}"/>
								<c:if test="${fn:escapeXml(param.commUniId) != null and not empty fn:escapeXml(param.commUniId)}">
									<c:set var="repUrlParams" value="ccGroupId=${fn:escapeXml(param.ccGroupId)}&commUniId=${fn:escapeXml(param.commUniId)}"/>
									<li class="secTitleClickable smartlinkMain withSeparatorMain">
										<a class="smartLinkMain commcellsLink" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp?ccGroupId=${fn:escapeXml(param.ccGroupId)}">${requestScope.CommCellGroupNameFull}&nbsp;(<fmt:message key="CommCells" />)</a>
									</li>
									<c:set var="reportLinkTitle" value="${requestScope.CommCellNameFull}"/>
								</c:if>
								<c:if test="${empty param.dashboard && empty param.commcells and param.isAlarm ne 'true' && empty param.profiledashboard}">
									<li class='secTitleClickable smartlinkMain withSeparatorMain repDropdown repDropdownTitle '>
										<a class='smartLinkMain reportsLink'  href='${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?${repUrlParams}'>${reportLinkTitle}&nbsp;(<fmt:message key="Reports" />)</a>
										<img class="hideOnExportFriendly" src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png" alt="down" />
									</li>
									<li>
										<%@ include file="../../common/pageSelection.jsp" %>
									</li>
								</c:if>
							</c:when>
							<c:when test="${surveyEnabled eq 'true' and applicationScope.isPublicMetricsCloud == true && fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0}">
								<li class="secTitleClickable smartlinkMain withSeparatorMain">
									<a class="smartLinkMain" href="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard"><fmt:message key="Worldwide_Dashboard" /></a>
								</li>
								<c:set var="repUrlParams" value="companyId=${fn:escapeXml(param.companyId)}"/>
								<li class="secTitleClickable smartlinkMain withSeparatorMain">
									<a class="smartLinkMain" href="${pageContext.request.contextPath}/survey/reports/viewReport.jsp?reportId=RegisteredCompanies"><fmt:message key="companies" /></a>
								</li>
								<c:set var="reportLinkTitle" value="${requestScope.CompanyNameFull}"/>
								<c:if test="${fn:escapeXml(param.commUniId) != null and not empty fn:escapeXml(param.commUniId)}">
									<c:set var="repUrlParams" value="companyId=${fn:escapeXml(param.companyId)}&commUniId=${fn:escapeXml(param.commUniId)}"/>
									<li class="secTitleClickable smartlinkMain withSeparatorMain">
										<a class="smartLinkMain commcellsLink" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp?companyId=${fn:escapeXml(param.companyId)}">${requestScope.CompanyNameFull}&nbsp;(<fmt:message key="CommCells" />)</a>
									</li>
									<c:set var="reportLinkTitle" value="${requestScope.CommCellNameFull}"/>
								</c:if>
								<c:if test="${empty param.dashboard && empty param.commcells and param.isAlarm ne 'true' && empty param.profiledashboard}">
									<li class='secTitleClickable smartlinkMain withSeparatorMain repDropdown repDropdownTitle '>
										<a class='smartLinkMain reportsLink'  href='${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?${repUrlParams}'>${reportLinkTitle}&nbsp;(<fmt:message key="Reports" />)</a>
										<img class="hideOnExportFriendly" src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png" alt="down" />
									</li>
									<li>
										<%@ include file="../../common/pageSelection.jsp" %>
									</li>
								</c:if>
							</c:when>
							<c:otherwise>
								<c:if test="${surveyEnabled eq 'true' and (fn:escapeXml(param.commUniId) != null  and (singleCommCellUser == false) and not empty fn:escapeXml(param.commUniId))|| (fn:escapeXml(param.ccId) != null and not empty fn:escapeXml(param.ccId))}">
									<li class="secTitleClickable smartlinkMain withSeparatorMain">
										<a class="smartLinkMain" href="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard"><fmt:message key="Worldwide_Dashboard" /></a>
									</li>
								</c:if>
								<c:if test="${surveyEnabled eq 'true' and (fn:escapeXml(param.commUniId) != null  and (singleCommCellUser == false) and not empty fn:escapeXml(param.commUniId))|| (fn:escapeXml(param.ccId) != null and not empty fn:escapeXml(param.ccId))}">
									<li class="secTitleClickable smartlinkMain withSeparatorMain">
										<a class="smartLinkMain commcellsLink" href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp"><fmt:message key="CommCells" /></a>
									</li>
								</c:if>
								<c:if test="${surveyEnabled eq 'true' and empty param.dashboard && empty param.commcells and param.isAlarm ne 'true' && empty param.profiledashboard}">
									<c:set var="reportLinkTitle" value="${requestScope.CommCellNameFull}"/>
									<li class='secTitleClickable smartlinkMain withSeparatorMain repDropdown repDropdownTitle '>
										<c:set var="cellId" value="${fn:escapeXml(param.commUniId)}" />
										<c:if test="${not empty fn:escapeXml(param.ccId)}">
											<c:set var="cellId" value="${fn:escapeXml(param.ccId)}" />
										</c:if>
										<a class='smartLinkMain reportsLink'  href='${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?commUniId=${cellId}'>${reportLinkTitle}&nbsp;(<fmt:message key="Reports" />)</a>
										<img class="hideOnExportFriendly" src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png" alt="down" />
									</li>
									<li>
										<%@ include file="../../common/pageSelection.jsp" %>
									</li>
								</c:if>
							</c:otherwise>
						</c:choose>
					</c:otherwise>
				</c:choose>
				<%-- <li>
					<%@ include file="../../common/pageSelection.jsp" %>
				</li> --%>
			</ul>
		</c:if>
		<div id="headerLinks" class="hideOnExportFriendly wait">
				<ul>
					<!-- The hrefs change in some cases dynamically, but the defaults are set -->
					<c:forEach items="${paramValues.headerLinks}" var="hLink" varStatus="loop">
						<c:choose>
							<c:when test="${!loop.last}">
								<c:set var="clsAttr" value="rightMenu" />
							</c:when>
							<c:otherwise>
								<c:set var="clsAttr" value="nobar rightMenu" />
							</c:otherwise>
						</c:choose>
						<c:if test="${hLink == 'worldwideUrl' }">
							<li class="${clsAttr}"><a id="commcellUrl" href="${pageContext.request.contextPath}/reports/index.jsp?page=Reports" ><fmt:message key="Worldwide" /></a></li>
						</c:if>
						<%-- ${!loop.last} --%>
					</c:forEach>
				</ul>
	    </div>

		<div id="headerUpgradeCC">
            <!-- CommCell upgrade -->
            <span class="sprite icon-info" id="infoeol"></span>
            <span class="msg" id="upgraderequestphase"></span>
            <a class="msg" id="upgraderequest"></a>
            <a class="msg" id="failedupgraderequestreport"><fmt:message key="Report" /> | </a>
            <a class="msg" id="failedupgraderequestreportnew"><fmt:message key="Report" /></a>
            <a class="msg" id="failedupgraderequestretry"><fmt:message key="Retry" /></a>
	     </div>

	</div>
		<div id="surveyHeaderRow">
		<!-- Second row for title and search -->
		<div class="clear-both"></div>
		<c:if test="${param.noTitleDropdown != true}">
		<jsp:include page="surveyTitleDropDown.jsp?${applicationScope.BUILD_TS}"></jsp:include>
		</c:if>

		<fmt:bundle basename="localization.SurveyMessages">
			<c:if test="${surveyEnabled != null && surveyEnabled == 'true'}">
				<c:if  test="${fn:escapeXml(param.commUniId) != 0 && fn:escapeXml(param.commUniId) != null && param.showLogTabs == true}">
					<ul id="gl-wrapper" class="hideOnExportFriendly nav navbar-nav ">
						<c:if test="${param.commcelllogs != null || param.proactive != null}">
							<c:set var="ccLogsLink" value="${pageContext.request.contextPath}/survey/reports/gatherlogsinfo.jsp?commUniId=${fn:escapeXml(param.commUniId)}"/>
							<c:set var="ccProactiveLink" value="${pageContext.request.contextPath}/survey/reports/proactivesupport.jsp?commUniId=${fn:escapeXml(param.commUniId)}"/>
							<c:choose>
								<c:when test="${param.commcelllogs != null && param.commcelllogs == true}">
									<li class="active"><a href="${ccLogsLink}"><fmt:message key="gatherlog.header.collectinfo"/></a></li>
								</c:when>
								<c:otherwise>
									<li><a href="${ccLogsLink}"><fmt:message key="gatherlog.header.collectinfo"/></a></li>
								</c:otherwise>
							</c:choose>
							<c:choose>
								<c:when test="${param.proactive != null && param.proactive == true}">
									<li class="active"><a href="${ccProactiveLink}"><fmt:message key="gatherlog.header.proactiveinfo"/></a></li>
								</c:when>
								<c:otherwise>
									<li><a href="${ccProactiveLink}"><fmt:message key="gatherlog.header.proactiveinfo"/></a></li>
								</c:otherwise>
							</c:choose>
					</c:if>
					</ul>
				</c:if>
			</c:if>
		</fmt:bundle>

		<div id="headerSearchCC" class="hideOnExportFriendly nav navbar-nav ">
			<c:if test="${param.includeCROptionBeforeSearch != null && param.includeCROptionBeforeSearch == true}">
				<c:set var="linkClass" value="reportLinks"/>
				<c:if test="${not empty fn:escapeXml(param.commUniId)}">
					<c:set var="linkClass" value="commCellLevelReportLinks"/>
				</c:if>
				<div id="${linkClass}"  >
					<c:if test="${param.dashboard != null && applicationScope.isPublicMetricsCloud != null && applicationScope.isPublicMetricsCloud ==true && sessionScope.isCommvaultUser == 'true' && not empty fn:escapeXml(param.commUniId)}">
						<div class="troubleShooting-wrapper">
							<a id="troubleShooting" href="${pageContext.request.contextPath}/survey/reports/gatherlogsinfo.jsp?commUniId=${fn:escapeXml(param.commUniId)}" title='<fmt:message key="dashboard.label.Troubleshooting" />'>
								<svg id="Layer_1" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" width="27" height="23" viewBox="0 0 34 34"><defs><style>.cls-1{fill:#2e4d66;}.cls-1,.cls-2{fill-rule:evenodd;}.cls-2{fill:#efb04c;}</style></defs><title>Troubleshooting</title><path class="cls-1" d="M5.7,30.4,9,27.2,5.3,23.6l-3,3.5a4.2,4.2,0,0,1,4.2-5.8,2.6,2.6,0,0,0,2.3-1c3.5-3.5,7-6.9,10.4-10.4a1.7,1.7,0,0,0,.6-1.6,4.4,4.4,0,0,1,5.6-4.7L22.1,6.7l3.7,3.6L28.9,7a4.3,4.3,0,0,1-4.5,5.7,2.4,2.4,0,0,0-2,.7L11.9,24a1.7,1.7,0,0,0-.6,1.6C11.6,28.9,9,31.1,5.7,30.4Z"/><path class="cls-2" d="M31.1,26.4l-6.9-7a1.4,1.4,0,0,0-1.1-.5.5.5,0,0,1-.6-.5l-.3-.7H22l-1,1.1-.3-.4-10-9.9A4.2,4.2,0,0,1,9.3,6c0-.1-.1-.3-.2-.3L6.4,4.1l-.9.8A15.5,15.5,0,0,1,6.7,7.1,1.5,1.5,0,0,0,8,8a2.5,2.5,0,0,1,1.4.8L19.9,19.3l.4.2-1.2,1.1c.3.2.4.4.6.4s.7.3.7.8a1.1,1.1,0,0,0,.3.8c2.4,2.4,4.9,4.8,7.3,7.3a2.3,2.3,0,0,0,2.4.5,2,2,0,0,0,1.5-1.7A2.1,2.1,0,0,0,31.1,26.4Zm-2.5,2.8c-.1.1-.2,0-.4-.1-2.2-2.3-4.5-4.5-6.8-6.8-.1-.1-.2-.3-.1-.4s.3.1.4.1c2.3,2.3,4.5,4.6,6.8,6.8C28.6,28.9,28.7,29.1,28.6,29.2Zm1.2-.8s-.1.1-.4-.2l-6.7-6.6c0-.1-.1-.2-.2-.3v-.2h.3l.2.2L29.7,28C30,28.3,29.8,28.4,29.8,28.4Zm.9-1.2h-.4l-6.8-6.9a.2.2,0,0,1-.1-.4l.4.2,6.8,6.8C30.7,26.9,30.8,27.1,30.7,27.2Z"/></svg>
							</a>
						</div>
					</c:if>
					<c:choose>
						<c:when test="${param.dashboard != null || (param.profiledashboard != null && param.profiledashboard == true)}">
							<c:if test="${isAdminUser == 'true' || (param.disbaleExport == null || param.disbaleExport == false) }">

								<div id="reportButton" class="reportActionButtons hideOnExportFriendly" >
									<svg id="Layer_1" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" width="28" height="28" viewBox="0 0 34 34" style="fill: #505050;"><path d="M34,8H0V6H34Zm0,18H0v2H34Zm0-10H0v2H34Z"/></svg>
									<div id="reportActionMenu" class="actionMenu hideOnExportFriendly">
										<ul id="reportMenu">
											<c:set var="showCloudDocs" value="false"></c:set>
											<c:set var="cloudDocsClass" value=""></c:set>
											<c:if test="${applicationScope.isPublicMetricsCloud != null and applicationScope.isPublicMetricsCloud ==true && param.showCloudDocs != null && param.showCloudDocs == 'true' && ((fn:escapeXml(param.ccGroupId) != null
												&& fn:escapeXml(param.ccGroupId) > 0) || (fn:escapeXml(param.companyId) != null
												&& fn:escapeXml(param.companyId) > 0) || (fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0))}">
												<c:set var="showCloudDocs" value="true"></c:set>
												<c:set var="cloudDocsClass" value="with-cloud-docs"></c:set>
											</c:if>
									 		<c:if test="${param.exportEnabled != null && param.exportEnabled == 'true'}">
												<li id="exportAsButton" class="actionMenuItem"><div class="actionMenuItemLabel"><div id="exportRightArrow"><span><fmt:message key="CustomReport.SaveAs" /></span></div></div>
													<ul id ="exportMenu" class="rightMenu ${cloudDocsClass}">
														<c:if test="${param.exportPdf != null && param.exportPdf == 'true' }">
															<li id="exportpdf"  class="actionMenuItem exportatserver "><span class="imageSpan sprite icon-export-pdf"></span><span class="textSpan">PDF</span></li>
														</c:if>
														<c:if test="${param.exportHtml != null && param.exportHtml == 'true' }">
															<li id="exporthtml"  class="actionMenuItem exportatserver"><div class=""><span class="imageSpan sprite icon-export-html"></span><span class="textSpan">HTML</span></div></li>
														</c:if>
														<c:if test="${(sessionScope.isCommvaultUser == true || sessionScope.isStorePremiumUser == true || isCommcellAdmin == 'true') && param.QuarterlyPPT != null && param.QuarterlyPPT == 'true' && ((fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0) || (fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0) || (fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0 && (CvUserDefaultDashboardGroupId > 0 && fn:escapeXml(param.companyId) != CvUserDefaultDashboardGroupId)))}">
                                                        	<li id="export-APAC-QBR" class="QBR-export-type"><div class=""><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan">ESP PPT</span></div></li>
                                                        </c:if>
                                                        							<c:if test="${sessionScope.isCommvaultUser == true && param.QuarterlyPPT != null && param.QuarterlyPPT == 'true' && (fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0)}">
                                                             								<li id="export-RMS-PPT" class="QBR-export-type"><div class=""><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan">RMS PPT</span></div></li>
                                                        							</c:if>
																					<c:set var="OSOSUsers" value="${cvConfig.getUsersPermittedToUseOSOS()}"></c:set>
																					<c:set var="CharterUsers" value="${cvConfig.getUsersPermittedToUseCharter()}"></c:set>
                                                        							<c:set var="loggedInUser" value="${loginContext.getUserInfo().getSmtpAddress()}"></c:set>
                                                        							<c:set var="commUniId" value="${fn:escapeXml(param.commUniId)}"></c:set>
                                                        							<c:set var="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}"></c:set>
                                                        							<c:set var="companyId" value="${fn:escapeXml(param.companyId)}"></c:set>
                                                        							<c:if test="${(sessionScope.isCommvaultUser == true) && (not empty loggedInUser) && (not empty param.QuarterlyPPT) && (param.QuarterlyPPT == 'true') && ((ccGroupId == null || ccGroupId <= 0) && (commUniId == null || commUniId <= 0) && (companyId == null || companyId <= 0))}">
                                                        								<c:if test="${(not empty OSOSUsers) && fn:contains(OSOSUsers, loggedInUser)}">
																					        <li id="export-OSOS-PPT" class="QBR-export-type"><div class=""><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan">OSOS PPT</span></div></li>
																					    </c:if>
																					    <c:if test="${(not empty CharterUsers) && fn:contains(CharterUsers, loggedInUser)}">
																					        <li id="export-Charter-Document" class="QBR-export-type"><div class=""><span class="imageSpan sprite icon-export-word"></span><span class="textSpan">Charter</span></div></li>
																					    </c:if>
																					</c:if>
                                                    							</ul>
                                                						</li>
                                            						</c:if>
											<!-- Print Option Deprecated -->
											<c:if test="${param.exportPdf != null && param.exportPdf == 'true' }">
												<li id="exportSchedule"  class="actionMenuItem exportSchedule"><div class="actionMenuItemLabel"><span><fmt:message key="CustomReport.Schedule" /></span></div></li>
												<li id="exportEmail"  class="actionMenuItem exportSchedule "><div class="actionMenuItemLabel"><span><fmt:message key="CustomReport.Email" /></span></div></li>
											</c:if>

						                     <c:if test="${param.enableReportAlert != null && param.enableReportAlert == 'true' }">
                                                <li id="reportAlert"  class="actionMenuItem"> <div class="actionMenuItemLabel"><span>Alert</span></div></li>
                                            </c:if>
											<fmt:bundle basename="localization.SurveyMessages">
												<c:if test="${showCloudDocs == 'true'}">
													<li id="cloudDocsLink"  class="actionMenuItem"><div class="actionMenuItemLabel hline"><span><fmt:message key="dashboard.cloud_documents" /></span></div></li>
												</c:if>
											</fmt:bundle>
											<c:if test="${applicationScope.isPublicMetricsCloud == 'true' && (param.usersManagement != null && param.usersManagement == true)}">
												<c:if test="${((fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0) || (fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0) || (fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0))}">
													<c:set var="hline" value="hline"></c:set>
													<c:if test="${sessionScope.isReportsCloudAdminUser == 'true'  && (sessionScope.isCommvaultUser == 'false' || sessionScope.isCommCellGroupAdminUser == 'true') && ((fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0 && singleCommCellUser == true) || ((fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0) && fn:escapeXml(param.commUniId) == null || fn:escapeXml(param.commUniId) <= 0))}">
														<li id="addNewUserLink"  class="actionMenuItem"><div class="actionMenuItemLabel ${hline}"><span><fmt:message key="Add_User" /></span></div></li>
														<c:set var="hline" value=""></c:set>
													</c:if>
													<li id="viewUsersLink"  class="actionMenuItem"><div class="actionMenuItemLabel ${hline}"><span><fmt:message key="View_Users" /></span></div></li>
													<c:set var="hline" value=""></c:set>
												</c:if>
												<c:if test="${fn:escapeXml(param.commUniId) != null && fn:escapeXml(param.commUniId) > 0 && (requestScope.commCellVersion != null && fn:startsWith(requestScope.commCellVersion, '11'))}">
													<li id="refreshCommcellSurveyLink"  class="actionMenuItem" value="Refresh"><span class="sprite icon-refresh imageSpan disabled ${hline}"></span><span class="textSpan disabled"><fmt:message key="Refresh" /></span></li>
													<c:set var="hline" value=""></c:set>
												</c:if>
											</c:if>
											<c:if test="${(param.profiledashboard != null && param.profiledashboard == true) && sessionScope.isCommvaultUser == true}">
												<li id="customerTouchLink"  class="actionMenuItem" ><div class="actionMenuItemLabel hline"><span class="customerTouch"><fmt:message key="Customer_Touch" /></span></div></li>
											</c:if>
										</ul>
									</div>
								</div>

								<div id="defaultAlertsContainer" class="reportActionButtons hideOnExportFriendly">
									<div id="open-default-alerts-dialog">
									<!-- ios-bell-outline.svg --><svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="28px" height="28px" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve"> <g> <path d="M381.7,225.9c0-97.6-52.5-130.8-101.6-138.2c0-0.5,0.1-1,0.1-1.6c0-12.3-10.9-22.1-24.2-22.1c-13.3,0-23.8,9.8-23.8,22.1 c0,0.6,0,1.1,0.1,1.6c-49.2,7.5-102,40.8-102,138.4c0,113.8-28.3,126-66.3,158h384C410.2,352,381.7,339.7,381.7,225.9z M107.2,368 c8.6-9,16.4-18.4,22.7-31.8c12-25.3,17.4-59.2,17.4-110.2c0-46.4,12.5-80.4,37.1-101.2c22.9-19.3,51.7-23.3,71.8-23.3 c20.1,0,48.9,4,71.6,23.3c24.5,20.7,37,54.5,37,100.9c0,83.8,14.9,117.3,40.3,142.3H107.2z"/> <path d="M256.2,448c26.8,0,48.8-19.9,51.7-43H204.5C207.3,428.1,229.4,448,256.2,448z"/> </g> </svg>
									</div>
									<div id="defaultAlertDialogBox">
										<div id="alert-data" class="defaultAlert-components">
											<div class="default-alarms-heading"><fmt:message key="AlertMe"/></div>

											<div id="loading-icon" class="defaultAlert-components">
												<img src="${pageContext.request.contextPath}/common/img/loader.gif"/>
											</div>
											<div id="default-alerts-list"></div>
											<div id="error-hold" class="defaultAlert-components">
												<hr>
												<span id="defaultAlert-error-location"></span>
											</div>

										</div>
									</div>
								</div>

							</c:if>
						</c:when>
						<c:otherwise>
						<c:choose>
							<c:when test="${isAdminUser == 'true' || (param.disbaleExport == null || param.disbaleExport == false) }">
								<div id="reportButton" class="reportActionButtons hideOnExportFriendly" >
									<svg id="Layer_1" data-name="Layer 1" xmlns="http://www.w3.org/2000/svg" width="24" height="24" style="fill: #505050;"><path stroke="null" id="svg_1" d="m27,6.6l-23,0l0,-1.6l23,0l0,1.6zm0,12.8l-23,0l0,1.6l23,0l0,-1.6zm0,-8l-23,0l0,1.6l23,0l0,-1.6z"/>
									<div id="reportActionMenu" class="actionMenu hideOnExportFriendly">
										<ul id="reportMenu">
									 		<c:if test="${param.createCommCellGroup != null && param.createCommCellGroup == 'true'}">
									 			<li id="createGroup"  class="actionMenuItem">
												<div id="createCommCellGroup" class="sprite icon-plus"></div>
												<div class="actionMenuItemLabel"><span ><fmt:message key="New_Group" /></span></div></li>
											</c:if>
									 		<c:if test="${param.exportEnabled != null && param.exportEnabled == 'true'}">
												<li id="exportAsButton" class="actionMenuItem"><div class="actionMenuItemLabel"><div id="exportRightArrow"><span><fmt:message key="CustomReport.SaveAs" /></span></div></div>
													<ul id ="exportMenu" class="rightMenu">
														<c:if test="${param.exportPdf != null && param.exportPdf == 'true' }">
															<li id="exportpdf"  class="actionMenuItem exportatserver "><span class="imageSpan sprite icon-export-pdf"></span><span class="textSpan">PDF</span></li>
														</c:if>
														<cv:secureTag name="WellnessReport" id="55">
															<c:set var="wellnessReportTag" scope = "session" value="wellnessTag"/>
														</cv:secureTag>
														<c:if test="${ (param.exportWord != null && param.exportWord == 'true') || (not empty wellnessReportTag && wellnessReportTag == 'wellnessTag' ) }">
															<li id="exportWord"  class="actionMenuItem exportatserver ${wellnessReportTag}" style="display:none"  ><span class="imageSpan sprite icon-export-word"></span><span class="textSpan">Word</span></li>
														</c:if>
														<c:if test="${param.exportPpt != null && param.exportPpt == 'true' }">
															<li id="exportPpt"  class="actionMenuItem exportSchedule" style="display:none" ><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan">PPT</span>
																	<ul id="_exportppt">
																		<li id="exportHealthPpt" class="exportatserver" ><fmt:message key="Health" /></li>
																		<li id="exportValAssessPpt" class="exportatserver" ><fmt:message key="Value_Assessment" /></li>
																	</ul>

															</li>
														</c:if>
														<c:if test="${param.exportCsv != null && param.exportCsv == 'true' }">
													<li id="exportCsv"  class="actionMenuItem exportatserver"><div class=""><span class="imageSpan sprite icon-export-csv"></span><span class="textSpan">CSV</span></div></li>
														</c:if>
														<c:if test="${param.exportHtml != null && param.exportHtml == 'true' }">
													<li id="exporthtml"  class="actionMenuItem exportatserver"><div class=""><span class="imageSpan sprite icon-export-html"></span><span class="textSpan">HTML</span></div></li>
														</c:if>
														<c:if test="${param.executiveSummary != null && param.executiveSummary == 'true' && (fn:escapeXml(param.tenant) == null || fn:escapeXml(param.tenant) == '')}">
															<li id="exportExecutiveSummary"  class="actionMenuItem" ><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan"><fmt:message key="executiveSummary"/></span></li>
														</c:if>
														<c:if test="${param.singleCommCellLevelActivity != null && param.singleCommCellLevelActivity == 'true'  && (fn:escapeXml(param.tenant) == null || fn:escapeXml(param.tenant) == '')}">
                                                            <li id="export-Executive-Summary" class="QBR-export-type"><div class=""><span class="imageSpan sprite icon-export-ppt-small"></span><span class="textSpan">Executive Summary</span></div></li>
                                                        </c:if>
													</ul>
												</li>
											</c:if>
											<!-- Print Option Deprecated -->
											<c:if test="${param.exportPdf != null && param.exportPdf == 'true' }">
												<li id="exportSchedule"  class="actionMenuItem exportSchedule"><div class="actionMenuItemLabel"><span><fmt:message key="CustomReport.Schedule" /></span></div></li>
												<li id="exportEmail"  class="actionMenuItem exportSchedule "><div class="actionMenuItemLabel"><span><fmt:message key="CustomReport.Email" /></span></div></li>
											</c:if>

											<c:if test="${param.enableReportAlert != null && param.enableReportAlert == 'true' }">
                                                <li id="reportAlert"  class="actionMenuItem"> <div class="actionMenuItemLabel"><span>Alert</span></div></li>
                                            </c:if>

											<%-- <c:if test="${sessionScope.isCommvaultUser == true}">
												<li id="createTask"  class="actionMenuItem taskAction" ><div class="actionMenuItemLabel"><span><fmt:message key="Task"/></span></div></li>
											</c:if> --%>


										</ul>
									</div>
								</div>

								</c:when>
								<c:when test="${param.fileDropDown != null && param.fileDropDown == 'true'  && param.ccGroups == 'true'}">
									<div id="reportButton" class="reportActionButtons hideOnExportFriendly" >
									<span class="reportActionButtonLabel"><fmt:message key="File" /></span> <img src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png">
									<div id="reportActionMenu" class="actionMenu hideOnExportFriendly">
									<ul id="reportMenu">
									<c:if test="${param.createCommCellGroup != null && param.createCommCellGroup == 'true'}">
										<li id="createGroup"  class="actionMenuItem">
											<div id="createCommCellGroup" class="sprite icon-plus"></div>
											<div class="actionMenuItemLabel"><span ><fmt:message key="New_Group" /></span></div>
										</li></c:if>
									</ul></div></div>
								</c:when>
								</c:choose>
						<!-- 	<div id="settingsLink" class="reportActionButtons" title="<fmt:message key="reportmanager"/>"> <span  class="reportActionButtonLabel"><fmt:message key="reportmanager"/></span></div>
							-->
						</c:otherwise>
					</c:choose>
			</div>
			</c:if>
			<!-- search -->
			<c:if test="${surveyEnabled eq 'true' and param.searchCC != null && param.searchCC == 'true' }">
				<jsp:include page="searchCommcell.jsp">
					<jsp:param value="${param.isHealthReport}" name="isHealthReport"/>
				</jsp:include>
			</c:if>
			<c:if test="${param.searchReport != null && param.searchReport == 'true' }">
				<div class="reportsSearch searchDiv">
					<input type="text" placeholder="Search Reports" id="reportFilterSearch"></input>
				</div>
			</c:if>

	</div>
	<div class="clear-both"></div>
	<div>
		<!--  last row for meta and export -->

		<div id="meta" comp="metricsInfo" data-component-type="EB_HTML">
			<ul>
				<li id="metaCCId" class="mItem"></li>
				<li id="GUID" class="mItem"></li>
				<li id="metaAsOf" class="mItem"></li>
				<li id="metaClientGrp" class="mItem"></li>
				<li id="timeZone" class="mItem"></li>
				<li id="metaTotalCCs" class="noComma mItem"></li>
				<li id="metaCCEdition" class="mItem"></li>
				<li id="metaCompanySelected" class="mItem"></li>
			</ul>
		</div>

	</div>
	</div>
</div>
<div class="clear-both">
</div>
<div id ="eolstatus" class="alert-danger hidden">
	<span class="msg alert-link" id="v9eol"></span>
	<a class="alert-link msg" id="v10eol"></a>
	<span id="remove-eolstatus" class="sprite icon-delete"></span>
</div>



<div class="clear-both">
</div>
</fmt:bundle>


