<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="func"%>

<div>
     <span id="welcomeMsg">
     <c:if test="${!param.ccGroups && param.ViewCommcellInfo == true && param.dashboard == null && func:escapeXml(param.commUniId) > 0}">
    	CommCell
	</c:if>
	<c:if test="${param.ccGroups && param.dashboard == null}">
		CommCell Groups
	</c:if>
    	<c:if test="${ !param.ccGroups && !param.companies && !(func:escapeXml(param.ccGroupId) > 0 || func:escapeXml(param.companyId) > 0 || func:escapeXml(param.commUniId) > 0) }">
			${func:escapeXml(param.welcomeMsg)}
		</c:if>
     </span>
     	<c:if test="${ ((param.dashboard != null || param.profiledashboard) && (func:escapeXml(param.ccGroupId) > 0 || func:escapeXml(param.companyId) > 0 || func:escapeXml(param.commUniId) > 0)) || (param.exportType != null) }">
	    	<div id="custName"></div>
	    </c:if>
    <div id="survey-list-holder" class="exportfriendly survey-list-holder">
    	<div id="cust-survey-div">
    	    <span id="surveyName"></span>
    	</div>
    	<div id="survey-drop-down" style="display:none">
    		<div id="tri-arrow" class="triborder" ><div class="triarea"></div></div>
        	<ul id='surveyList'></ul>
    	</div>
    </div>
    <fmt:bundle basename="localization.SurveyMessages">
		<div id="tenantChooserContainer">
			<div id="tenantChooserOverlay"></div>
			<input id="tenantChooser" type="text" placeholder="<fmt:message key='options.select_company' />" class="ui-autocomplete-input" autocomplete="off" role="textbox" aria-autocomplete="list" aria-haspopup="true">
			<span id="tenantDropButton" class="sprite icon-arrow-dropdown"></span>
			<span id="tenantClear" class="sprite icon-tagging-delete" title="<fmt:message key='options.clear_selection' />"></span>
			<div id="reportTaskSummary">
				<li>
					<label class="col1"><fmt:message key='options.company' />: </label>
					<span class="exportValue"></span>
				</li>
			</div>
		</div>
	</fmt:bundle>
</div>
<script nonce="${sessionScope.cspNonce}" >
if(typeof SurveyGlobals === 'undefined') {
	var SurveyGlobals = {};
}

	// MSPs list dropdown
	var nextPage;
	var surveyId = cvUtil.getParameter('surveyId', 0);
	var commUniId = cvUtil.getParameter('commUniId', -1);
	var ccGroupId = cvUtil.getParameter('ccGroupId',-1);
	var currentTenant = cvUtil.getParameter('tenant', "");
	var errorCode = cvUtil.getParameter('errorCode', -1);
	var repType = cvUtil.getParameter("repType", "");
	var MSPEnabledSurveys = surveyId == 23 || surveyId == 25 || surveyId == 27 || surveyId == 44 || surveyId == 67 || (surveyId == 51 && repType == "hourly") || (surveyId == 137 && (repType == "monthly" || repType == "hourly" || repType == "daily") );	//To show Tenants dropdown in a survey,add Survey Id here and change the parameters in corresponding SP calls
	var isActivityPage = (window.location.pathname == '/webconsole/survey/reports/operations.jsp' && surveyId == 0 && errorCode == -1); //Error code checked so as to not show this option in "Jobs Affected with Error Codes" view
	var dropdownOpen = false;
	var exportType = cvUtil.getParameter("exportType", "");
	if ( ( MSPEnabledSurveys || isActivityPage ) && (cv.isMspAdmin) ) {
		
		function removeTenantParamfromURL(url){
			var index = url.indexOf("tenant=");
			if(index == -1){
				return url;
			}
			var endIndex = url.indexOf("&",index);
			if( url.charAt(index-1) == "&" ){
				index--;
			}
			var createdURL = url.substring( 0,index );  
			createdURL += endIndex > -1 ? url.substring(endIndex) : '' ;
			return createdURL;
		}
		
		//Attaching JQueryUI autocomplete to create the dropdown
		$('#tenantChooser').autocomplete({
			select: function(event, ui) {	//Function that executes when a company is choosen
				nextPage = window.location.href.endsWith(window.location.pathname) ? (window.location.pathname + '?') : (removeTenantParamfromURL(window.location.href) + '&');
				nextPage += 'tenant=' + encodeURIComponent(ui.item.value);
				window.location = nextPage; //Redirecting to the new page with selected tenant info
				return false;
			},
			autoFocus: true,
			minLength: 0,
			position: { my: 'left top', at: 'left bottom', of: '#tenantChooserContainer' },
			//Function that executes when dropdown is opened
			open: function( event, ui ) {
				$('#tenantChooserOverlay').addClass("tenantChooserOpen");
				$(this).autocomplete("widget").css({
					"width" : ($("#tenantChooserContainer").width()+ 29 )		//Increasing the width of dropdown to match the conatiner
				});
				dropdownOpen=true;
				$('#tenantChooser').focus(); //When dropdown opened,focus is changed to input box so user can directly type in search keyword
			},
			//Function that executes when dropdown is closed
			close: function( event, ui ) {
				dropdownOpen=false;
			}
		}).autocomplete( "widget" ).addClass( "tenantChooserDropdown" ) ; // Adding class to Dropdown to apply css

		//To get the tenants viewable for the user
		var URL = cvUtil.getContextPath() + '/survey/reports/getCommcellsTenants.do?';
		URL += commUniId > -1 ? ("commUniId=" + commUniId + "&") : '' ;
		URL += ccGroupId > -1 ? ("ccGroupId=" + ccGroupId) : '' ;
		var tenantList = [];
		cvUtil.loadPageWithPOST(
			URL,
			'',
			function(data) {
				if( !data || !($.isArray(data)) || data.length == 0 ){	//If no response is returned, hide the drop down
				    $('#tenantChooserContainer').css('display', 'none');
				    return;
				}
				tenantList.push({ label: cvUtil.cvLocalize('options.all_companies') , value: '/All' }); //Selecting this would return info on all tenants in the commcell
				data.forEach(function(element) {
					label = element;
					value = element;
					option = { label: label, value: value };
					tenantList.push(option);
				});
				$('#tenantChooser').autocomplete('option', 'source', tenantList); //Attaching the created list to dropdown
				UrlTenant = cvUtil.getParameter('tenant', '');
				if (UrlTenant != '') {
					tenantList.forEach(function(tenant) {
						if (tenant['value'] == UrlTenant) {
							$("#tenantChooserContainer").attr('title', tenant['label']);
							$('#tenantChooser').attr('placeholder', tenant['label']);  //To replace the value shown in the dropdown search with the user selected Tenant name
							$('#reportTaskSummary li .exportValue').text(tenant['label']);	//Used in export to populate tenant name
						}
					});
				}
			},
			function() {
				$('#tenantChooserContainer').css('display', 'none');
			}
		);

		//When dropdown opened #tenantChooserOverlay will be added with class 'tenantChooserOpen' which covers the rest of the page using CSS.
		//Therefore any click outside will execute below function that will close the dropdown as well as remove tenantChooserOpen class.
		$('#tenantChooserOverlay').on('click',function(e){
			e.stopPropagation();
			if(dropdownOpen){
				$('#tenantChooser').autocomplete('close');
			}
			$('#tenantChooserOverlay').removeClass("tenantChooserOpen");
		});

		//Open dropdown when click is registered anywhere inside the div
		$('#tenantChooserContainer').on('click',function(e) {
			if(!dropdownOpen){
				$('#tenantChooser').autocomplete('search', $('#tenantChooser').val());
			}
		});

		//Creating a close button if a tenant is chosen
		if(currentTenant == ""){
			$('#tenantClear').css('display', 'none');
			$('#tenantChooser').css('width', '92%');
		}else{
			$('#tenantClear').on('click',function(event){
				mainPage=removeTenantParamfromURL(window.location.href);
				window.location=mainPage;
				event.stopPropagation();
			});
			exportType = exportType.toLowerCase();
			if( exportType === "csv" ){
				$("#reportTaskSummary").css("display","block")
			}else if(exportType == "html" || exportType == "pdf"){
				$('#tenantChooserContainer').css('display', 'none');
				if(currentTenant && currentTenant.length>0){
					if(currentTenant == '/All'){currentTenant = cvUtil.cvLocalize('options.all_companies');}
					//Wait for #metaCompanySelected to be created in DOM & then attach the selected company name 
					var companySelected = setInterval(
						function(){
							if($('#metaCompanySelected').length>0){
								clearInterval(companySelected);
								$('#metaCompanySelected').append(cvUtil.cvLocalize("options.company")+': <span>' + currentTenant + '</span>');
							}
						}
					,10);
				}
			}
		}

	} else {
		$('#tenantChooserContainer').css('display', 'none');
	}
	//MSP list dropdown end

SurveyGlobals.addDropDownEvents = function() {

	$('#survey-list-holder').click(function(e){
				if($("#survey-drop-down").is(":visible") === false) {
					var offset = $("#surveyName").offset();
					$("#survey-drop-down").show();
					$("#survey-drop-down").offset({ "top" : offset.top + 33, "left" : offset.left - 5});

				} else {
					$("#survey-drop-down").hide();
				}
				e.stopPropagation();
				});


	$(document).mouseup(function (e) {
	            var container = $("#survey-list-holder");
	            if (container.has(e.target).length === 0) {
	            	$("#survey-drop-down").hide();
	            }

	        });
};




</script>
